/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/lazy","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/core/position","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/workbench/api/worker/extensionHostWorker"],Ae=function(we){for(var e=[],y=0,T=we.length;y<T;y++)e[y]=Pe[we[y]];return e};define(Pe[66],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=void 0;function y(A){return($,E,d)=>{let I=null,D=null;if(typeof d.value=="function"?(I="value",D=d.value):typeof d.get=="function"&&(I="get",D=d.get),!D)throw new Error("not supported");d[I]=A(D,E)}}function T(A,$,E){let d=null,I=null;if(typeof E.value=="function"?(d="value",I=E.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(d="get",I=E.get),!I)throw new Error("not supported");const D=`$memoize$${$}`;E[d]=function(...l){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,l)}),this[D]}}e.$nh=T;function P(A,$,E){return y((d,I)=>{const D=`$debounce$${I}`,l=`$debounce$result$${I}`;return function(...b){this[l]||(this[l]=E?E():void 0),clearTimeout(this[D]),$&&(this[l]=$(this[l],...b),b=[this[l]]),this[D]=setTimeout(()=>{d.apply(this,b),this[l]=E?E():void 0},A)}})}e.$oh=P;function M(A,$,E){return y((d,I)=>{const D=`$throttle$timer$${I}`,l=`$throttle$result$${I}`,b=`$throttle$lastRun$${I}`,v=`$throttle$pending$${I}`;return function(...f){if(this[l]||(this[l]=E?E():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),$&&(this[l]=$(this[l],...f)),this[v])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),d.apply(this,[this[l]]),this[l]=E?E():void 0):(this[v]=!0,this[D]=setTimeout(()=>{this[v]=!1,this[b]=Date.now(),d.apply(this,[this[l]]),this[l]=E?E():void 0},t-Date.now()))}})}e.$ph=M}),define(Pe[89],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=void 0;class y{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$FM=y,e.$GM=new y("id#")}),define(Pe[119],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var T;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(n,s=!1){let a=0;const g=n.length;let p="",m=0,k=16,C=0;function u(R){let L=0,O=0;for(;L<R;){const Z=n.charCodeAt(a);if(Z>=48&&Z<=57)O=O*16+Z-48;else if(Z>=65&&Z<=70)O=O*16+Z-65+10;else if(Z>=97&&Z<=102)O=O*16+Z-97+10;else break;a++,L++}return L<R&&(O=-1),O}function w(R){a=R,p="",m=0,k=16,C=0}function S(){const R=a;if(n.charCodeAt(a)===48)a++;else for(a++;a<n.length&&d(n.charCodeAt(a));)a++;if(a<n.length&&n.charCodeAt(a)===46)if(a++,a<n.length&&d(n.charCodeAt(a)))for(a++;a<n.length&&d(n.charCodeAt(a));)a++;else return C=3,n.substring(R,a);let L=a;if(a<n.length&&(n.charCodeAt(a)===69||n.charCodeAt(a)===101))if(a++,(a<n.length&&n.charCodeAt(a)===43||n.charCodeAt(a)===45)&&a++,a<n.length&&d(n.charCodeAt(a))){for(a++;a<n.length&&d(n.charCodeAt(a));)a++;L=a}else C=3;return n.substring(R,L)}function F(){let R="",L=a;for(;;){if(a>=g){R+=n.substring(L,a),C=2;break}const O=n.charCodeAt(a);if(O===34){R+=n.substring(L,a),a++;break}if(O===92){if(R+=n.substring(L,a),a++,a>=g){C=2;break}switch(n.charCodeAt(a++)){case 34:R+='"';break;case 92:R+="\\";break;case 47:R+="/";break;case 98:R+="\b";break;case 102:R+="\f";break;case 110:R+=`
`;break;case 114:R+="\r";break;case 116:R+="	";break;case 117:{const he=u(4);he>=0?R+=String.fromCharCode(he):C=4;break}default:C=5}L=a;continue}if(O>=0&&O<=31)if(E(O)){R+=n.substring(L,a),C=2;break}else C=6;a++}return R}function V(){if(p="",C=0,m=a,a>=g)return m=g,k=17;let R=n.charCodeAt(a);if($(R)){do a++,p+=String.fromCharCode(R),R=n.charCodeAt(a);while($(R));return k=15}if(E(R))return a++,p+=String.fromCharCode(R),R===13&&n.charCodeAt(a)===10&&(a++,p+=`
`),k=14;switch(R){case 123:return a++,k=1;case 125:return a++,k=2;case 91:return a++,k=3;case 93:return a++,k=4;case 58:return a++,k=6;case 44:return a++,k=5;case 34:return a++,p=F(),k=10;case 47:{const L=a-1;if(n.charCodeAt(a+1)===47){for(a+=2;a<g&&!E(n.charCodeAt(a));)a++;return p=n.substring(L,a),k=12}if(n.charCodeAt(a+1)===42){a+=2;const O=g-1;let Z=!1;for(;a<O;){if(n.charCodeAt(a)===42&&n.charCodeAt(a+1)===47){a+=2,Z=!0;break}a++}return Z||(a++,C=1),p=n.substring(L,a),k=13}return p+=String.fromCharCode(R),a++,k=16}case 45:if(p+=String.fromCharCode(R),a++,a===g||!d(n.charCodeAt(a)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=S(),k=11;default:for(;a<g&&J(R);)a++,R=n.charCodeAt(a);if(m!==a){switch(p=n.substring(m,a),p){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return p+=String.fromCharCode(R),a++,k=16}}function J(R){if($(R)||E(R))return!1;switch(R){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let R;do R=V();while(R>=12&&R<=15);return R}return{setPosition:w,getPosition:()=>a,scan:s?N:V,getToken:()=>k,getTokenValue:()=>p,getTokenOffset:()=>m,getTokenLength:()=>a-m,getTokenError:()=>C}}e.$1m=A;function $(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function E(n){return n===10||n===13||n===8232||n===8233}function d(n){return n>=48&&n<=57}var I;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(I||(I={}));function D(n,s){const a=[],g=new Object;let p;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function C(u,w,S,F){m.value=u,m.offset=w,m.length=S,m.type=F,m.colonOffset=void 0,p=m}try{c(n,{onObjectBegin:(u,w)=>{if(s<=u)throw g;p=void 0,k=s>u,a.push("")},onObjectProperty:(u,w,S)=>{if(s<w||(C(u,w,S,"property"),a[a.length-1]=u,s<=w+S))throw g},onObjectEnd:(u,w)=>{if(s<=u)throw g;p=void 0,a.pop()},onArrayBegin:(u,w)=>{if(s<=u)throw g;p=void 0,a.push(0)},onArrayEnd:(u,w)=>{if(s<=u)throw g;p=void 0,a.pop()},onLiteralValue:(u,w,S)=>{if(s<w||(C(u,w,S,h(u)),s<=w+S))throw g},onSeparator:(u,w,S)=>{if(s<=w)throw g;if(u===":"&&p&&p.type==="property")p.colonOffset=w,k=!1,p=void 0;else if(u===","){const F=a[a.length-1];typeof F=="number"?a[a.length-1]=F+1:(k=!0,a[a.length-1]=""),p=void 0}}})}catch(u){if(u!==g)throw u}return{path:a,previousNode:p,isAtPropertyKey:k,matches:u=>{let w=0;for(let S=0;w<u.length&&S<a.length;S++)if(u[w]===a[S]||u[w]==="*")w++;else if(u[w]!=="**")return!1;return w===u.length}}}e.$2m=D;function l(n,s=[],a=M.DEFAULT){let g=null,p=[];const m=[];function k(u){Array.isArray(p)?p.push(u):g!==null&&(p[g]=u)}return c(n,{onObjectBegin:()=>{const u={};k(u),m.push(p),p=u,g=null},onObjectProperty:u=>{g=u},onObjectEnd:()=>{p=m.pop()},onArrayBegin:()=>{const u=[];k(u),m.push(p),p=u,g=null},onArrayEnd:()=>{p=m.pop()},onLiteralValue:k,onError:(u,w,S)=>{s.push({error:u,offset:w,length:S})}},a),p[0]}e.$3m=l;function b(n,s=[],a=M.DEFAULT){let g={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(u){g.type==="property"&&(g.length=u-g.offset,g=g.parent)}function m(u){return g.children.push(u),u}c(n,{onObjectBegin:u=>{g=m({type:"object",offset:u,length:-1,parent:g,children:[]})},onObjectProperty:(u,w,S)=>{g=m({type:"property",offset:w,length:-1,parent:g,children:[]}),g.children.push({type:"string",value:u,offset:w,length:S,parent:g})},onObjectEnd:(u,w)=>{g.length=u+w-g.offset,g=g.parent,p(u+w)},onArrayBegin:(u,w)=>{g=m({type:"array",offset:u,length:-1,parent:g,children:[]})},onArrayEnd:(u,w)=>{g.length=u+w-g.offset,g=g.parent,p(u+w)},onLiteralValue:(u,w,S)=>{m({type:h(u),offset:w,length:S,parent:g,value:u}),p(w+S)},onSeparator:(u,w,S)=>{g.type==="property"&&(u===":"?g.colonOffset=w:u===","&&p(w))},onError:(u,w,S)=>{s.push({error:u,offset:w,length:S})}},a);const C=g.children[0];return C&&delete C.parent,C}e.$4m=b;function v(n,s){if(!n)return;let a=n;for(const g of s)if(typeof g=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let p=!1;for(const m of a.children)if(Array.isArray(m.children)&&m.children[0].value===g){a=m.children[1],p=!0;break}if(!p)return}else{const p=g;if(a.type!=="array"||p<0||!Array.isArray(a.children)||p>=a.children.length)return;a=a.children[p]}return a}e.$5m=v;function f(n){if(!n.parent||!n.parent.children)return[];const s=f(n.parent);if(n.parent.type==="property"){const a=n.parent.children[0].value;s.push(a)}else if(n.parent.type==="array"){const a=n.parent.children.indexOf(n);a!==-1&&s.push(a)}return s}e.$6m=f;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const s=Object.create(null);for(const a of n.children){const g=a.children[1];g&&(s[a.children[0].value]=t(g))}return s}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$7m=t;function i(n,s,a=!1){return s>=n.offset&&s<n.offset+n.length||a&&s===n.offset+n.length}e.$8m=i;function r(n,s,a=!1){if(i(n,s,a)){const g=n.children;if(Array.isArray(g))for(let p=0;p<g.length&&g[p].offset<=s;p++){const m=r(g[p],s,a);if(m)return m}return n}}e.$9m=r;function c(n,s,a=M.DEFAULT){const g=A(n,!1);function p(te){return te?()=>te(g.getTokenOffset(),g.getTokenLength()):()=>!0}function m(te){return te?Re=>te(Re,g.getTokenOffset(),g.getTokenLength()):()=>!0}const k=p(s.onObjectBegin),C=m(s.onObjectProperty),u=p(s.onObjectEnd),w=p(s.onArrayBegin),S=p(s.onArrayEnd),F=m(s.onLiteralValue),V=m(s.onSeparator),J=p(s.onComment),N=m(s.onError),R=a&&a.disallowComments,L=a&&a.allowTrailingComma;function O(){for(;;){const te=g.scan();switch(g.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:R||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(te){case 12:case 13:R?Z(10):J();break;case 16:Z(1);break;case 15:case 14:break;default:return te}}}function Z(te,Re=[],se=[]){if(N(te),Re.length+se.length>0){let Y=g.getToken();for(;Y!==17;){if(Re.indexOf(Y)!==-1){O();break}else if(se.indexOf(Y)!==-1)break;Y=O()}}}function he(te){const Re=g.getTokenValue();return te?F(Re):C(Re),O(),!0}function $e(){switch(g.getToken()){case 11:{let te=0;try{te=JSON.parse(g.getTokenValue()),typeof te!="number"&&(Z(2),te=0)}catch{Z(2)}F(te);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return O(),!0}function De(){return g.getToken()!==10?(Z(3,[],[2,5]),!1):(he(!1),g.getToken()===6?(V(":"),O(),ve()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function ke(){k(),O();let te=!1;for(;g.getToken()!==2&&g.getToken()!==17;){if(g.getToken()===5){if(te||Z(4,[],[]),V(","),O(),g.getToken()===2&&L)break}else te&&Z(6,[],[]);De()||Z(4,[],[2,5]),te=!0}return u(),g.getToken()!==2?Z(7,[2],[]):O(),!0}function fe(){w(),O();let te=!1;for(;g.getToken()!==4&&g.getToken()!==17;){if(g.getToken()===5){if(te||Z(4,[],[]),V(","),O(),g.getToken()===4&&L)break}else te&&Z(6,[],[]);ve()||Z(4,[],[4,5]),te=!0}return S(),g.getToken()!==4?Z(8,[4],[]):O(),!0}function ve(){switch(g.getToken()){case 3:return fe();case 1:return ke();case 10:return he(!0);default:return $e()}}return O(),g.getToken()===17?a.allowEmptyContent?!0:(Z(4,[],[]),!1):ve()?(g.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}e.$0m=c;function o(n,s){const a=A(n),g=[];let p,m=0,k;do switch(k=a.getPosition(),p=a.scan(),p){case 12:case 13:case 17:m!==k&&g.push(n.substring(m,k)),s!==void 0&&g.push(a.getTokenValue().replace(/[^\r\n]/g,s)),m=a.getPosition();break}while(p!==17);return g.join("")}e.$$m=o;function h(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$_m=h}),function(we,e){typeof define=="function"&&define.amd?define(Pe[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(le,ce){for(var ye=0;ye<ce.length;ye++){var _=ce[ye];_.enumerable=_.enumerable||!1,_.configurable=!0,"value"in _&&(_.writable=!0),Object.defineProperty(le,_.key,_)}}function y(le,ce,ye){return ce&&e(le.prototype,ce),ye&&e(le,ye),Object.defineProperty(le,"prototype",{writable:!1}),le}function T(le,ce){if(le){if(typeof le=="string")return P(le,ce);var ye=Object.prototype.toString.call(le).slice(8,-1);if(ye==="Object"&&le.constructor&&(ye=le.constructor.name),ye==="Map"||ye==="Set")return Array.from(le);if(ye==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ye))return P(le,ce)}}function P(le,ce){(ce==null||ce>le.length)&&(ce=le.length);for(var ye=0,_=new Array(ce);ye<ce;ye++)_[ye]=le[ye];return _}function M(le,ce){var ye=typeof Symbol<"u"&&le[Symbol.iterator]||le["@@iterator"];if(ye)return(ye=ye.call(le)).next.bind(ye);if(Array.isArray(le)||(ye=T(le))||ce&&le&&typeof le.length=="number"){ye&&(le=ye);var _=0;return function(){return _>=le.length?{done:!0}:{done:!1,value:le[_++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}we.defaults=A();function $(le){we.defaults=le}var E=/[&<>"']/,d=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(ce){return l[ce]};function v(le,ce){if(ce){if(E.test(le))return le.replace(d,b)}else if(I.test(le))return le.replace(D,b);return le}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(le){return le.replace(f,function(ce,ye){return ye=ye.toLowerCase(),ye==="colon"?":":ye.charAt(0)==="#"?ye.charAt(1)==="x"?String.fromCharCode(parseInt(ye.substring(2),16)):String.fromCharCode(+ye.substring(1)):""})}var i=/(^|[^\[])\^/g;function r(le,ce){le=typeof le=="string"?le:le.source,ce=ce||"";var ye={replace:function(de,ie){return ie=ie.source||ie,ie=ie.replace(i,"$1"),le=le.replace(de,ie),ye},getRegex:function(){return new RegExp(le,ce)}};return ye}var c=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(le,ce,ye){if(le){var _;try{_=decodeURIComponent(t(ye)).replace(c,"").toLowerCase()}catch{return null}if(_.indexOf("javascript:")===0||_.indexOf("vbscript:")===0||_.indexOf("data:")===0)return null}ce&&!o.test(ye)&&(ye=p(ce,ye));try{ye=encodeURI(ye).replace(/%25/g,"%")}catch{return null}return ye}var n={},s=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,g=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(le,ce){n[" "+le]||(s.test(le)?n[" "+le]=le+"/":n[" "+le]=u(le,"/",!0)),le=n[" "+le];var ye=le.indexOf(":")===-1;return ce.substring(0,2)==="//"?ye?ce:le.replace(a,"$1")+ce:ce.charAt(0)==="/"?ye?ce:le.replace(g,"$1")+ce:le+ce}var m={exec:function(){}};function k(le){for(var ce=1,ye,_;ce<arguments.length;ce++){ye=arguments[ce];for(_ in ye)Object.prototype.hasOwnProperty.call(ye,_)&&(le[_]=ye[_])}return le}function C(le,ce){var ye=le.replace(/\|/g,function(ie,ae,me){for(var Ie=!1,z=ae;--z>=0&&me[z]==="\\";)Ie=!Ie;return Ie?"|":" |"}),_=ye.split(/ \|/),de=0;if(_[0].trim()||_.shift(),_.length>0&&!_[_.length-1].trim()&&_.pop(),_.length>ce)_.splice(ce);else for(;_.length<ce;)_.push("");for(;de<_.length;de++)_[de]=_[de].trim().replace(/\\\|/g,"|");return _}function u(le,ce,ye){var _=le.length;if(_===0)return"";for(var de=0;de<_;){var ie=le.charAt(_-de-1);if(ie===ce&&!ye)de++;else if(ie!==ce&&ye)de++;else break}return le.slice(0,_-de)}function w(le,ce){if(le.indexOf(ce[1])===-1)return-1;for(var ye=le.length,_=0,de=0;de<ye;de++)if(le[de]==="\\")de++;else if(le[de]===ce[0])_++;else if(le[de]===ce[1]&&(_--,_<0))return de;return-1}function S(le){le&&le.sanitize&&!le.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(le,ce){if(ce<1)return"";for(var ye="";ce>1;)ce&1&&(ye+=le),ce>>=1,le+=le;return ye+le}function V(le,ce,ye,_){var de=ce.href,ie=ce.title?v(ce.title):null,ae=le[1].replace(/\\([\[\]])/g,"$1");if(le[0].charAt(0)!=="!"){_.state.inLink=!0;var me={type:"link",raw:ye,href:de,title:ie,text:ae,tokens:_.inlineTokens(ae)};return _.state.inLink=!1,me}return{type:"image",raw:ye,href:de,title:ie,text:v(ae)}}function J(le,ce){var ye=le.match(/^(\s+)(?:```)/);if(ye===null)return ce;var _=ye[1];return ce.split(`
`).map(function(de){var ie=de.match(/^\s+/);if(ie===null)return de;var ae=ie[0];return ae.length>=_.length?de.slice(_.length):de}).join(`
`)}var N=function(){function le(ye){this.options=ye||we.defaults}var ce=le.prototype;return ce.space=function(_){var de=this.rules.block.newline.exec(_);if(de&&de[0].length>0)return{type:"space",raw:de[0]}},ce.code=function(_){var de=this.rules.block.code.exec(_);if(de){var ie=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:u(ie,`
`)}}},ce.fences=function(_){var de=this.rules.block.fences.exec(_);if(de){var ie=de[0],ae=J(ie,de[3]||"");return{type:"code",raw:ie,lang:de[2]?de[2].trim():de[2],text:ae}}},ce.heading=function(_){var de=this.rules.block.heading.exec(_);if(de){var ie=de[2].trim();if(/#$/.test(ie)){var ae=u(ie,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(ie=ae.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:ie,tokens:this.lexer.inline(ie)}}},ce.hr=function(_){var de=this.rules.block.hr.exec(_);if(de)return{type:"hr",raw:de[0]}},ce.blockquote=function(_){var de=this.rules.block.blockquote.exec(_);if(de){var ie=de[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:de[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},ce.list=function(_){var de=this.rules.block.list.exec(_);if(de){var ie,ae,me,Ie,z,W,H,G,q,x,ue,Oe,Ue=de[1].trim(),Ze=Ue.length>1,Je={type:"list",raw:"",ordered:Ze,start:Ze?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Ze?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Ze?Ue:"[*+-]");for(var tt=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");_&&(Oe=!1,!(!(de=tt.exec(_))||this.rules.block.hr.test(_)));){if(ie=de[0],_=_.substring(ie.length),G=de[2].split(`
`,1)[0],q=_.split(`
`,1)[0],this.options.pedantic?(Ie=2,ue=G.trimLeft()):(Ie=de[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ue=G.slice(Ie),Ie+=de[1].length),W=!1,!G&&/^ *$/.test(q)&&(ie+=q+`
`,_=_.substring(q.length+1),Oe=!0),!Oe)for(var _e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");_&&(x=_.split(`
`,1)[0],G=x,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(G)||nt.test(G)||_e.test(G)||et.test(_)));){if(G.search(/[^ ]/)>=Ie||!G.trim())ue+=`
`+G.slice(Ie);else if(!W)ue+=`
`+G;else break;!W&&!G.trim()&&(W=!0),ie+=x+`
`,_=_.substring(x.length+1)}Je.loose||(H?Je.loose=!0:/\n *\n *$/.test(ie)&&(H=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(ue),ae&&(me=ae[0]!=="[ ] ",ue=ue.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:ie,task:!!ae,checked:me,loose:!1,text:ue}),Je.raw+=ie}Je.items[Je.items.length-1].raw=ie.trimRight(),Je.items[Je.items.length-1].text=ue.trimRight(),Je.raw=Je.raw.trimRight();var ze=Je.items.length;for(z=0;z<ze;z++){this.lexer.state.top=!1,Je.items[z].tokens=this.lexer.blockTokens(Je.items[z].text,[]);var dt=Je.items[z].tokens.filter(function(Q){return Q.type==="space"}),X=dt.every(function(Q){for(var Ee=Q.raw.split(""),Be=0,He=M(Ee),Xe;!(Xe=He()).done;){var st=Xe.value;if(st===`
`&&(Be+=1),Be>1)return!0}return!1});!Je.loose&&dt.length&&X&&(Je.loose=!0,Je.items[z].loose=!0)}return Je}},ce.html=function(_){var de=this.rules.block.html.exec(_);if(de){var ie={type:"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:de[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(de[0]):v(de[0]);ie.type="paragraph",ie.text=ae,ie.tokens=this.lexer.inline(ae)}return ie}},ce.def=function(_){var de=this.rules.block.def.exec(_);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var ie=de[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:de[0],href:de[2],title:de[3]}}},ce.table=function(_){var de=this.rules.block.table.exec(_);if(de){var ie={type:"table",header:C(de[1]).map(function(H){return{text:H}}),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:de[3]&&de[3].trim()?de[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=de[0];var ae=ie.align.length,me,Ie,z,W;for(me=0;me<ae;me++)/^ *-+: *$/.test(ie.align[me])?ie.align[me]="right":/^ *:-+: *$/.test(ie.align[me])?ie.align[me]="center":/^ *:-+ *$/.test(ie.align[me])?ie.align[me]="left":ie.align[me]=null;for(ae=ie.rows.length,me=0;me<ae;me++)ie.rows[me]=C(ie.rows[me],ie.header.length).map(function(H){return{text:H}});for(ae=ie.header.length,Ie=0;Ie<ae;Ie++)ie.header[Ie].tokens=this.lexer.inline(ie.header[Ie].text);for(ae=ie.rows.length,Ie=0;Ie<ae;Ie++)for(W=ie.rows[Ie],z=0;z<W.length;z++)W[z].tokens=this.lexer.inline(W[z].text);return ie}}},ce.lheading=function(_){var de=this.rules.block.lheading.exec(_);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1],tokens:this.lexer.inline(de[1])}},ce.paragraph=function(_){var de=this.rules.block.paragraph.exec(_);if(de){var ie=de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1];return{type:"paragraph",raw:de[0],text:ie,tokens:this.lexer.inline(ie)}}},ce.text=function(_){var de=this.rules.block.text.exec(_);if(de)return{type:"text",raw:de[0],text:de[0],tokens:this.lexer.inline(de[0])}},ce.escape=function(_){var de=this.rules.inline.escape.exec(_);if(de)return{type:"escape",raw:de[0],text:v(de[1])}},ce.tag=function(_){var de=this.rules.inline.tag.exec(_);if(de)return!this.lexer.state.inLink&&/^<a /i.test(de[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(de[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(de[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(de[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:de[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):v(de[0]):de[0]}},ce.link=function(_){var de=this.rules.inline.link.exec(_);if(de){var ie=de[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ae=u(ie.slice(0,-1),"\\");if((ie.length-ae.length)%2===0)return}else{var me=w(de[2],"()");if(me>-1){var Ie=de[0].indexOf("!")===0?5:4,z=Ie+de[1].length+me;de[2]=de[2].substring(0,me),de[0]=de[0].substring(0,z).trim(),de[3]=""}}var W=de[2],H="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(W);G&&(W=G[1],H=G[3])}else H=de[3]?de[3].slice(1,-1):"";return W=W.trim(),/^</.test(W)&&(this.options.pedantic&&!/>$/.test(ie)?W=W.slice(1):W=W.slice(1,-1)),V(de,{href:W&&W.replace(this.rules.inline._escapes,"$1"),title:H&&H.replace(this.rules.inline._escapes,"$1")},de[0],this.lexer)}},ce.reflink=function(_,de){var ie;if((ie=this.rules.inline.reflink.exec(_))||(ie=this.rules.inline.nolink.exec(_))){var ae=(ie[2]||ie[1]).replace(/\s+/g," ");if(ae=de[ae.toLowerCase()],!ae||!ae.href){var me=ie[0].charAt(0);return{type:"text",raw:me,text:me}}return V(ie,ae,ie[0],this.lexer)}},ce.emStrong=function(_,de,ie){ie===void 0&&(ie="");var ae=this.rules.inline.emStrong.lDelim.exec(_);if(ae&&!(ae[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ae[1]||ae[2]||"";if(!me||me&&(ie===""||this.rules.inline.punctuation.exec(ie))){var Ie=ae[0].length-1,z,W,H=Ie,G=0,q=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,de=de.slice(-1*_.length+Ie);(ae=q.exec(de))!=null;)if(z=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!z){if(W=z.length,ae[3]||ae[4]){H+=W;continue}else if((ae[5]||ae[6])&&Ie%3&&!((Ie+W)%3)){G+=W;continue}if(H-=W,!(H>0)){if(W=Math.min(W,W+H+G),Math.min(Ie,W)%2){var x=_.slice(1,Ie+ae.index+W);return{type:"em",raw:_.slice(0,Ie+ae.index+W+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ue=_.slice(2,Ie+ae.index+W-1);return{type:"strong",raw:_.slice(0,Ie+ae.index+W+1),text:ue,tokens:this.lexer.inlineTokens(ue)}}}}}},ce.codespan=function(_){var de=this.rules.inline.code.exec(_);if(de){var ie=de[2].replace(/\n/g," "),ae=/[^ ]/.test(ie),me=/^ /.test(ie)&&/ $/.test(ie);return ae&&me&&(ie=ie.substring(1,ie.length-1)),ie=v(ie,!0),{type:"codespan",raw:de[0],text:ie}}},ce.br=function(_){var de=this.rules.inline.br.exec(_);if(de)return{type:"br",raw:de[0]}},ce.del=function(_){var de=this.rules.inline.del.exec(_);if(de)return{type:"del",raw:de[0],text:de[2],tokens:this.lexer.inlineTokens(de[2])}},ce.autolink=function(_,de){var ie=this.rules.inline.autolink.exec(_);if(ie){var ae,me;return ie[2]==="@"?(ae=v(this.options.mangle?de(ie[1]):ie[1]),me="mailto:"+ae):(ae=v(ie[1]),me=ae),{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.url=function(_,de){var ie;if(ie=this.rules.inline.url.exec(_)){var ae,me;if(ie[2]==="@")ae=v(this.options.mangle?de(ie[0]):ie[0]),me="mailto:"+ae;else{var Ie;do Ie=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(Ie!==ie[0]);ae=v(ie[0]),ie[1]==="www."?me="http://"+ae:me=ae}return{type:"link",raw:ie[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},ce.inlineText=function(_,de){var ie=this.rules.inline.text.exec(_);if(ie){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):v(ie[0]):ie[0]:ae=v(this.options.smartypants?de(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ae}}},le}(),R={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};R._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,R._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,R.def=r(R.def).replace("label",R._label).replace("title",R._title).getRegex(),R.bullet=/(?:[*+-]|\d{1,9}[.)])/,R.listItemStart=r(/^( *)(bull) */).replace("bull",R.bullet).getRegex(),R.list=r(R.list).replace(/bull/g,R.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+R.def.source+")").getRegex(),R._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",R._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,R.html=r(R.html,"i").replace("comment",R._comment).replace("tag",R._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),R.paragraph=r(R._paragraph).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.blockquote=r(R.blockquote).replace("paragraph",R.paragraph).getRegex(),R.normal=k({},R),R.gfm=k({},R.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),R.gfm.table=r(R.gfm.table).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.gfm.paragraph=r(R._paragraph).replace("hr",R.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",R.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",R._tag).getRegex(),R.pedantic=k({},R.normal,{html:r(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",R._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:r(R.normal._paragraph).replace("hr",R.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",R.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var L={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};L._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",L.punctuation=r(L.punctuation).replace(/punctuation/g,L._punctuation).getRegex(),L.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,L.escapedEmSt=/\\\*|\\_/g,L._comment=r(R._comment).replace("(?:-->|$)","-->").getRegex(),L.emStrong.lDelim=r(L.emStrong.lDelim).replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimAst=r(L.emStrong.rDelimAst,"g").replace(/punct/g,L._punctuation).getRegex(),L.emStrong.rDelimUnd=r(L.emStrong.rDelimUnd,"g").replace(/punct/g,L._punctuation).getRegex(),L._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,L._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,L._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,L.autolink=r(L.autolink).replace("scheme",L._scheme).replace("email",L._email).getRegex(),L._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,L.tag=r(L.tag).replace("comment",L._comment).replace("attribute",L._attribute).getRegex(),L._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,L._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,L._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,L.link=r(L.link).replace("label",L._label).replace("href",L._href).replace("title",L._title).getRegex(),L.reflink=r(L.reflink).replace("label",L._label).replace("ref",R._label).getRegex(),L.nolink=r(L.nolink).replace("ref",R._label).getRegex(),L.reflinkSearch=r(L.reflinkSearch,"g").replace("reflink",L.reflink).replace("nolink",L.nolink).getRegex(),L.normal=k({},L),L.pedantic=k({},L.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:r(/^!?\[(label)\]\((.*?)\)/).replace("label",L._label).getRegex(),reflink:r(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",L._label).getRegex()}),L.gfm=k({},L.normal,{escape:r(L.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),L.gfm.url=r(L.gfm.url,"i").replace("email",L.gfm._extended_email).getRegex(),L.breaks=k({},L.gfm,{br:r(L.br).replace("{2,}","*").getRegex(),text:r(L.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(le){return le.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Z(le){var ce="",ye,_,de=le.length;for(ye=0;ye<de;ye++)_=le.charCodeAt(ye),Math.random()>.5&&(_="x"+_.toString(16)),ce+="&#"+_+";";return ce}var he=function(){function le(ye){this.tokens=[],this.tokens.links=Object.create(null),this.options=ye||we.defaults,this.options.tokenizer=this.options.tokenizer||new N,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var _={block:R.normal,inline:L.normal};this.options.pedantic?(_.block=R.pedantic,_.inline=L.pedantic):this.options.gfm&&(_.block=R.gfm,this.options.breaks?_.inline=L.breaks:_.inline=L.gfm),this.tokenizer.rules=_}le.lex=function(_,de){var ie=new le(de);return ie.lex(_)},le.lexInline=function(_,de){var ie=new le(de);return ie.inlineTokens(_)};var ce=le.prototype;return ce.lex=function(_){_=_.replace(/\r\n|\r/g,`
`),this.blockTokens(_,this.tokens);for(var de;de=this.inlineQueue.shift();)this.inlineTokens(de.src,de.tokens);return this.tokens},ce.blockTokens=function(_,de){var ie=this;de===void 0&&(de=[]),this.options.pedantic?_=_.replace(/\t/g,"    ").replace(/^ +$/gm,""):_=_.replace(/^( *)(\t+)/gm,function(H,G,q){return G+"    ".repeat(q.length)});for(var ae,me,Ie,z;_;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(H){return(ae=H.call({lexer:ie},_,de))?(_=_.substring(ae.raw.length),de.push(ae),!0):!1}))){if(ae=this.tokenizer.space(_)){_=_.substring(ae.raw.length),ae.raw.length===1&&de.length>0?de[de.length-1].raw+=`
`:de.push(ae);continue}if(ae=this.tokenizer.code(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae);continue}if(ae=this.tokenizer.fences(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.heading(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.hr(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.blockquote(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.list(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.html(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.def(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.lheading(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(Ie=_,this.options.extensions&&this.options.extensions.startBlock&&function(){var H=1/0,G=_.slice(1),q=void 0;ie.options.extensions.startBlock.forEach(function(x){q=x.call({lexer:this},G),typeof q=="number"&&q>=0&&(H=Math.min(H,q))}),H<1/0&&H>=0&&(Ie=_.substring(0,H+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(Ie))){me=de[de.length-1],z&&me.type==="paragraph"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae),z=Ie.length!==_.length,_=_.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&me.type==="text"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):de.push(ae);continue}if(_){var W="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(W);break}else throw new Error(W)}}return this.state.top=!0,de},ce.inline=function(_,de){return de===void 0&&(de=[]),this.inlineQueue.push({src:_,tokens:de}),de},ce.inlineTokens=function(_,de){var ie=this;de===void 0&&(de=[]);var ae,me,Ie,z=_,W,H,G;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(W=this.tokenizer.rules.inline.reflinkSearch.exec(z))!=null;)q.includes(W[0].slice(W[0].lastIndexOf("[")+1,-1))&&(z=z.slice(0,W.index)+"["+F("a",W[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(W=this.tokenizer.rules.inline.blockSkip.exec(z))!=null;)z=z.slice(0,W.index)+"["+F("a",W[0].length-2)+"]"+z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(W=this.tokenizer.rules.inline.escapedEmSt.exec(z))!=null;)z=z.slice(0,W.index)+"++"+z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;_;)if(H||(G=""),H=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ue){return(ae=ue.call({lexer:ie},_,de))?(_=_.substring(ae.raw.length),de.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.tag(_)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.link(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.reflink(_,this.tokens.links)){_=_.substring(ae.raw.length),me=de[de.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(ae=this.tokenizer.emStrong(_,z,G)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.codespan(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.br(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.del(_)){_=_.substring(ae.raw.length),de.push(ae);continue}if(ae=this.tokenizer.autolink(_,Z)){_=_.substring(ae.raw.length),de.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(_,Z))){_=_.substring(ae.raw.length),de.push(ae);continue}if(Ie=_,this.options.extensions&&this.options.extensions.startInline&&function(){var ue=1/0,Oe=_.slice(1),Ue=void 0;ie.options.extensions.startInline.forEach(function(Ze){Ue=Ze.call({lexer:this},Oe),typeof Ue=="number"&&Ue>=0&&(ue=Math.min(ue,Ue))}),ue<1/0&&ue>=0&&(Ie=_.substring(0,ue+1))}(),ae=this.tokenizer.inlineText(Ie,O)){_=_.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(G=ae.raw.slice(-1)),H=!0,me=de[de.length-1],me&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):de.push(ae);continue}if(_){var x="Infinite loop on byte: "+_.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return de},y(le,null,[{key:"rules",get:function(){return{block:R,inline:L}}}]),le}(),$e=function(){function le(ye){this.options=ye||we.defaults}var ce=le.prototype;return ce.code=function(_,de,ie){var ae=(de||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(_,ae);me!=null&&me!==_&&(ie=!0,_=me)}return _=_.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+v(ae,!0)+'">'+(ie?_:v(_,!0))+`</code></pre>
`:"<pre><code>"+(ie?_:v(_,!0))+`</code></pre>
`},ce.blockquote=function(_){return`<blockquote>
`+_+`</blockquote>
`},ce.html=function(_){return _},ce.heading=function(_,de,ie,ae){if(this.options.headerIds){var me=this.options.headerPrefix+ae.slug(ie);return"<h"+de+' id="'+me+'">'+_+"</h"+de+`>
`}return"<h"+de+">"+_+"</h"+de+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(_,de,ie){var ae=de?"ol":"ul",me=de&&ie!==1?' start="'+ie+'"':"";return"<"+ae+me+`>
`+_+"</"+ae+`>
`},ce.listitem=function(_){return"<li>"+_+`</li>
`},ce.checkbox=function(_){return"<input "+(_?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(_){return"<p>"+_+`</p>
`},ce.table=function(_,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+_+`</thead>
`+de+`</table>
`},ce.tablerow=function(_){return`<tr>
`+_+`</tr>
`},ce.tablecell=function(_,de){var ie=de.header?"th":"td",ae=de.align?"<"+ie+' align="'+de.align+'">':"<"+ie+">";return ae+_+("</"+ie+`>
`)},ce.strong=function(_){return"<strong>"+_+"</strong>"},ce.em=function(_){return"<em>"+_+"</em>"},ce.codespan=function(_){return"<code>"+_+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(_){return"<del>"+_+"</del>"},ce.link=function(_,de,ie){if(_=h(this.options.sanitize,this.options.baseUrl,_),_===null)return ie;var ae='<a href="'+v(_)+'"';return de&&(ae+=' title="'+de+'"'),ae+=">"+ie+"</a>",ae},ce.image=function(_,de,ie){if(_=h(this.options.sanitize,this.options.baseUrl,_),_===null)return ie;var ae='<img src="'+_+'" alt="'+ie+'"';return de&&(ae+=' title="'+de+'"'),ae+=this.options.xhtml?"/>":">",ae},ce.text=function(_){return _},le}(),De=function(){function le(){}var ce=le.prototype;return ce.strong=function(_){return _},ce.em=function(_){return _},ce.codespan=function(_){return _},ce.del=function(_){return _},ce.html=function(_){return _},ce.text=function(_){return _},ce.link=function(_,de,ie){return""+ie},ce.image=function(_,de,ie){return""+ie},ce.br=function(){return""},le}(),ke=function(){function le(){this.seen={}}var ce=le.prototype;return ce.serialize=function(_){return _.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(_,de){var ie=_,ae=0;if(this.seen.hasOwnProperty(ie)){ae=this.seen[_];do ae++,ie=_+"-"+ae;while(this.seen.hasOwnProperty(ie))}return de||(this.seen[_]=ae,this.seen[ie]=0),ie},ce.slug=function(_,de){de===void 0&&(de={});var ie=this.serialize(_);return this.getNextSafeSlug(ie,de.dryrun)},le}(),fe=function(){function le(ye){this.options=ye||we.defaults,this.options.renderer=this.options.renderer||new $e,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new De,this.slugger=new ke}le.parse=function(_,de){var ie=new le(de);return ie.parse(_)},le.parseInline=function(_,de){var ie=new le(de);return ie.parseInline(_)};var ce=le.prototype;return ce.parse=function(_,de){de===void 0&&(de=!0);var ie="",ae,me,Ie,z,W,H,G,q,x,ue,Oe,Ue,Ze,Je,tt,_e,et,rt,nt,ze=_.length;for(ae=0;ae<ze;ae++){if(ue=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ue.type]&&(nt=this.options.extensions.renderers[ue.type].call({parser:this},ue),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ue.type))){ie+=nt||"";continue}switch(ue.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ue.tokens),ue.depth,t(this.parseInline(ue.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ue.text,ue.lang,ue.escaped);continue}case"table":{for(q="",G="",z=ue.header.length,me=0;me<z;me++)G+=this.renderer.tablecell(this.parseInline(ue.header[me].tokens),{header:!0,align:ue.align[me]});for(q+=this.renderer.tablerow(G),x="",z=ue.rows.length,me=0;me<z;me++){for(H=ue.rows[me],G="",W=H.length,Ie=0;Ie<W;Ie++)G+=this.renderer.tablecell(this.parseInline(H[Ie].tokens),{header:!1,align:ue.align[Ie]});x+=this.renderer.tablerow(G)}ie+=this.renderer.table(q,x);continue}case"blockquote":{x=this.parse(ue.tokens),ie+=this.renderer.blockquote(x);continue}case"list":{for(Oe=ue.ordered,Ue=ue.start,Ze=ue.loose,z=ue.items.length,x="",me=0;me<z;me++)tt=ue.items[me],_e=tt.checked,et=tt.task,Je="",tt.task&&(rt=this.renderer.checkbox(_e),Ze?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=rt+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=rt+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:rt}):Je+=rt),Je+=this.parse(tt.tokens,Ze),x+=this.renderer.listitem(Je,et,_e);ie+=this.renderer.list(x,Oe,Ue);continue}case"html":{ie+=this.renderer.html(ue.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ue.tokens));continue}case"text":{for(x=ue.tokens?this.parseInline(ue.tokens):ue.text;ae+1<ze&&_[ae+1].type==="text";)ue=_[++ae],x+=`
`+(ue.tokens?this.parseInline(ue.tokens):ue.text);ie+=de?this.renderer.paragraph(x):x;continue}default:{var dt='Token with "'+ue.type+'" type was not found.';if(this.options.silent){console.error(dt);return}else throw new Error(dt)}}}return ie},ce.parseInline=function(_,de){de=de||this.renderer;var ie="",ae,me,Ie,z=_.length;for(ae=0;ae<z;ae++){if(me=_[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(Ie=this.options.extensions.renderers[me.type].call({parser:this},me),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){ie+=Ie||"";continue}switch(me.type){case"escape":{ie+=de.text(me.text);break}case"html":{ie+=de.html(me.text);break}case"link":{ie+=de.link(me.href,me.title,this.parseInline(me.tokens,de));break}case"image":{ie+=de.image(me.href,me.title,me.text);break}case"strong":{ie+=de.strong(this.parseInline(me.tokens,de));break}case"em":{ie+=de.em(this.parseInline(me.tokens,de));break}case"codespan":{ie+=de.codespan(me.text);break}case"br":{ie+=de.br();break}case"del":{ie+=de.del(this.parseInline(me.tokens,de));break}case"text":{ie+=de.text(me.text);break}default:{var W='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error(W);return}else throw new Error(W)}}}return ie},le}();function ve(le,ce,ye){if(typeof le>"u"||le===null)throw new Error("marked(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");if(typeof ce=="function"&&(ye=ce,ce=null),ce=k({},ve.defaults,ce||{}),S(ce),ye){var _=ce.highlight,de;try{de=he.lex(le,ce)}catch(z){return ye(z)}var ie=function(W){var H;if(!W)try{ce.walkTokens&&ve.walkTokens(de,ce.walkTokens),H=fe.parse(de,ce)}catch(G){W=G}return ce.highlight=_,W?ye(W):ye(null,H)};if(!_||_.length<3||(delete ce.highlight,!de.length))return ie();var ae=0;ve.walkTokens(de,function(z){z.type==="code"&&(ae++,setTimeout(function(){_(z.text,z.lang,function(W,H){if(W)return ie(W);H!=null&&H!==z.text&&(z.text=H,z.escaped=!0),ae--,ae===0&&ie()})},0))}),ae===0&&ie();return}function me(z){if(z.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(z.message+"",!0)+"</pre>";throw z}try{var Ie=he.lex(le,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ve.walkTokens(Ie,ce.walkTokens)).then(function(){return fe.parse(Ie,ce)}).catch(me);ve.walkTokens(Ie,ce.walkTokens)}return fe.parse(Ie,ce)}catch(z){me(z)}}ve.options=ve.setOptions=function(le){return k(ve.defaults,le),$(ve.defaults),ve},ve.getDefaults=A,ve.defaults=we.defaults,ve.use=function(){for(var le=arguments.length,ce=new Array(le),ye=0;ye<le;ye++)ce[ye]=arguments[ye];var _=k.apply(void 0,[{}].concat(ce)),de=ve.defaults.extensions||{renderers:{},childTokens:{}},ie;ce.forEach(function(ae){if(ae.extensions&&(ie=!0,ae.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var z=de.renderers?de.renderers[Ie.name]:null;z?de.renderers[Ie.name]=function(){for(var W=arguments.length,H=new Array(W),G=0;G<W;G++)H[G]=arguments[G];var q=Ie.renderer.apply(this,H);return q===!1&&(q=z.apply(this,H)),q}:de.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");de[Ie.level]?de[Ie.level].unshift(Ie.tokenizer):de[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?de.startBlock?de.startBlock.push(Ie.start):de.startBlock=[Ie.start]:Ie.level==="inline"&&(de.startInline?de.startInline.push(Ie.start):de.startInline=[Ie.start]))}Ie.childTokens&&(de.childTokens[Ie.name]=Ie.childTokens)})),ae.renderer&&function(){var Ie=ve.defaults.renderer||new $e,z=function(G){var q=Ie[G];Ie[G]=function(){for(var x=arguments.length,ue=new Array(x),Oe=0;Oe<x;Oe++)ue[Oe]=arguments[Oe];var Ue=ae.renderer[G].apply(Ie,ue);return Ue===!1&&(Ue=q.apply(Ie,ue)),Ue}};for(var W in ae.renderer)z(W);_.renderer=Ie}(),ae.tokenizer&&function(){var Ie=ve.defaults.tokenizer||new N,z=function(G){var q=Ie[G];Ie[G]=function(){for(var x=arguments.length,ue=new Array(x),Oe=0;Oe<x;Oe++)ue[Oe]=arguments[Oe];var Ue=ae.tokenizer[G].apply(Ie,ue);return Ue===!1&&(Ue=q.apply(Ie,ue)),Ue}};for(var W in ae.tokenizer)z(W);_.tokenizer=Ie}(),ae.walkTokens){var me=ve.defaults.walkTokens;_.walkTokens=function(Ie){var z=[];return z.push(ae.walkTokens.call(this,Ie)),me&&(z=z.concat(me.call(this,Ie))),z}}ie&&(_.extensions=de),ve.setOptions(_)})},ve.walkTokens=function(le,ce){for(var ye=[],_=function(){var me=ie.value;switch(ye=ye.concat(ce.call(ve,me)),me.type){case"table":{for(var Ie=M(me.header),z;!(z=Ie()).done;){var W=z.value;ye=ye.concat(ve.walkTokens(W.tokens,ce))}for(var H=M(me.rows),G;!(G=H()).done;)for(var q=G.value,x=M(q),ue;!(ue=x()).done;){var Oe=ue.value;ye=ye.concat(ve.walkTokens(Oe.tokens,ce))}break}case"list":{ye=ye.concat(ve.walkTokens(me.items,ce));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[me.type]?ve.defaults.extensions.childTokens[me.type].forEach(function(Ue){ye=ye.concat(ve.walkTokens(me[Ue],ce))}):me.tokens&&(ye=ye.concat(ve.walkTokens(me.tokens,ce)))}},de=M(le),ie;!(ie=de()).done;)_();return ye},ve.parseInline=function(le,ce){if(typeof le>"u"||le===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof le!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(le)+", string expected");ce=k({},ve.defaults,ce||{}),S(ce);try{var ye=he.lexInline(le,ce);return ce.walkTokens&&ve.walkTokens(ye,ce.walkTokens),fe.parseInline(ye,ce)}catch(_){if(_.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(_.message+"",!0)+"</pre>";throw _}},ve.Parser=fe,ve.parser=fe.parse,ve.Renderer=$e,ve.TextRenderer=De,ve.Lexer=he,ve.lexer=he.lex,ve.Tokenizer=N,ve.Slugger=ke,ve.parse=ve;var te=ve.options,Re=ve.setOptions,se=ve.use,Y=ve.walkTokens,B=ve.parseInline,ne=ve,pe=fe.parse,re=he.lex;we.Lexer=he,we.Parser=fe,we.Renderer=$e,we.Slugger=ke,we.TextRenderer=De,we.Tokenizer=N,we.getDefaults=A,we.lexer=re,we.marked=ve,we.options=te,we.parse=ne,we.parseInline=B,we.parser=pe,we.setOptions=Re,we.use=se,we.walkTokens=Y,Object.defineProperty(we,"__esModule",{value:!0})}),define(Pe[121],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=e.$Wl=e.rot=e.$Ul=void 0;function y($,E,d){return Math.min(Math.max($,E),d)}e.$Ul=y;function T($,E){return(E+$%E)%E}e.rot=T;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Wl=P;class M{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Xl=M;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const d=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Yl=A}),function(){function we(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function A(E){M.push(E,Date.now())}function $(){const E=[];for(let d=0;d<M.length;d+=2)E.push({name:M[d],startTime:M[d+1]});return E}return{mark:A,getMarks:$}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(P+A.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return we(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function y(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=y(T))}(),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var T in y)(typeof exports=="object"?exports:we)[T]=y[T]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function y(T){if(e[T])return e[T].exports;var P=e[T]={i:T,l:!1,exports:{}};return we[T].call(P.exports,P,P.exports,y),P.l=!0,P.exports}return y.m=we,y.c=e,y.d=function(T,P,M){y.o(T,P)||Object.defineProperty(T,P,{enumerable:!0,get:M})},y.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},y.t=function(T,P){if(1&P&&(T=y(T)),8&P||4&P&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(y.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&P&&typeof T!="string")for(var A in T)y.d(M,A,function($){return T[$]}.bind(null,A));return M},y.n=function(T){var P=T&&T.__esModule?function(){return T.default}:function(){return T};return y.d(P,"a",P),P},y.o=function(T,P){return Object.prototype.hasOwnProperty.call(T,P)},y.p="",y(y.s=0)}([function(we,e,y){(function(T){var P;e=we.exports=se,P=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,$=e.re=[],E=e.src=[],d=0,I=d++;E[I]="0|[1-9]\\d*";var D=d++;E[D]="[0-9]+";var l=d++;E[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=d++;E[b]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var v=d++;E[v]="("+E[D]+")\\.("+E[D]+")\\.("+E[D]+")";var f=d++;E[f]="(?:"+E[I]+"|"+E[l]+")";var t=d++;E[t]="(?:"+E[D]+"|"+E[l]+")";var i=d++;E[i]="(?:-("+E[f]+"(?:\\."+E[f]+")*))";var r=d++;E[r]="(?:-?("+E[t]+"(?:\\."+E[t]+")*))";var c=d++;E[c]="[0-9A-Za-z-]+";var o=d++;E[o]="(?:\\+("+E[c]+"(?:\\."+E[c]+")*))";var h=d++,n="v?"+E[b]+E[i]+"?"+E[o]+"?";E[h]="^"+n+"$";var s="[v=\\s]*"+E[v]+E[r]+"?"+E[o]+"?",a=d++;E[a]="^"+s+"$";var g=d++;E[g]="((?:<|>)?=?)";var p=d++;E[p]=E[D]+"|x|X|\\*";var m=d++;E[m]=E[I]+"|x|X|\\*";var k=d++;E[k]="[v=\\s]*("+E[m]+")(?:\\.("+E[m]+")(?:\\.("+E[m]+")(?:"+E[i]+")?"+E[o]+"?)?)?";var C=d++;E[C]="[v=\\s]*("+E[p]+")(?:\\.("+E[p]+")(?:\\.("+E[p]+")(?:"+E[r]+")?"+E[o]+"?)?)?";var u=d++;E[u]="^"+E[g]+"\\s*"+E[k]+"$";var w=d++;E[w]="^"+E[g]+"\\s*"+E[C]+"$";var S=d++;E[S]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=d++;E[F]="(?:~>?)";var V=d++;E[V]="(\\s*)"+E[F]+"\\s+",$[V]=new RegExp(E[V],"g");var J=d++;E[J]="^"+E[F]+E[k]+"$";var N=d++;E[N]="^"+E[F]+E[C]+"$";var R=d++;E[R]="(?:\\^)";var L=d++;E[L]="(\\s*)"+E[R]+"\\s+",$[L]=new RegExp(E[L],"g");var O=d++;E[O]="^"+E[R]+E[k]+"$";var Z=d++;E[Z]="^"+E[R]+E[C]+"$";var he=d++;E[he]="^"+E[g]+"\\s*("+s+")$|^$";var $e=d++;E[$e]="^"+E[g]+"\\s*("+n+")$|^$";var De=d++;E[De]="(\\s*)"+E[g]+"\\s*("+s+"|"+E[k]+")",$[De]=new RegExp(E[De],"g");var ke=d++;E[ke]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var fe=d++;E[fe]="^\\s*("+E[C]+")\\s+-\\s+("+E[C]+")\\s*$";var ve=d++;E[ve]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)P(te,E[te]),$[te]||($[te]=new RegExp(E[te]));function Re(q,x){if(q instanceof se)return q;if(typeof q!="string"||q.length>M||!(x?$[a]:$[h]).test(q))return null;try{return new se(q,x)}catch{return null}}function se(q,x){if(q instanceof se){if(q.loose===x)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof se))return new se(q,x);P("SemVer",q,x),this.loose=x;var ue=q.trim().match(x?$[a]:$[h]);if(!ue)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Ue=+Oe;if(Ue>=0&&Ue<A)return Ue}return Oe}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=Re,e.valid=function(q,x){var ue=Re(q,x);return ue?ue.version:null},e.clean=function(q,x){var ue=Re(q.trim().replace(/^[=v]+/,""),x);return ue?ue.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(q){return P("SemVer.compare",this.version,this.loose,q),q instanceof se||(q=new se(q,this.loose)),this.compareMain(q)||this.comparePre(q)},se.prototype.compareMain=function(q){return q instanceof se||(q=new se(q,this.loose)),B(this.major,q.major)||B(this.minor,q.minor)||B(this.patch,q.patch)},se.prototype.comparePre=function(q){if(q instanceof se||(q=new se(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var x=0;do{var ue=this.prerelease[x],Oe=q.prerelease[x];if(P("prerelease compare",x,ue,Oe),ue===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(ue===void 0)return-1;if(ue!==Oe)return B(ue,Oe)}while(++x)},se.prototype.inc=function(q,x){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,x,ue,Oe){typeof ue=="string"&&(Oe=ue,ue=void 0);try{return new se(q,ue).inc(x,Oe).version}catch{return null}},e.diff=function(q,x){if(le(q,x))return null;var ue=Re(q),Oe=Re(x);if(ue.prerelease.length||Oe.prerelease.length){for(var Ue in ue)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ue[Ue]!==Oe[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ue)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ue[Ue]!==Oe[Ue])return Ue},e.compareIdentifiers=B;var Y=/^[0-9]+$/;function B(q,x){var ue=Y.test(q),Oe=Y.test(x);return ue&&Oe&&(q=+q,x=+x),ue&&!Oe?-1:Oe&&!ue?1:q<x?-1:q>x?1:0}function ne(q,x,ue){return new se(q,ue).compare(new se(x,ue))}function pe(q,x,ue){return ne(q,x,ue)>0}function re(q,x,ue){return ne(q,x,ue)<0}function le(q,x,ue){return ne(q,x,ue)===0}function ce(q,x,ue){return ne(q,x,ue)!==0}function ye(q,x,ue){return ne(q,x,ue)>=0}function _(q,x,ue){return ne(q,x,ue)<=0}function de(q,x,ue,Oe){var Ue;switch(x){case"===":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Ue=q===ue;break;case"!==":typeof q=="object"&&(q=q.version),typeof ue=="object"&&(ue=ue.version),Ue=q!==ue;break;case"":case"=":case"==":Ue=le(q,ue,Oe);break;case"!=":Ue=ce(q,ue,Oe);break;case">":Ue=pe(q,ue,Oe);break;case">=":Ue=ye(q,ue,Oe);break;case"<":Ue=re(q,ue,Oe);break;case"<=":Ue=_(q,ue,Oe);break;default:throw new TypeError("Invalid operator: "+x)}return Ue}function ie(q,x){if(q instanceof ie){if(q.loose===x)return q;q=q.value}if(!(this instanceof ie))return new ie(q,x);P("comparator",q,x),this.loose=x,this.parse(q),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(q,x){return B(x,q)},e.major=function(q,x){return new se(q,x).major},e.minor=function(q,x){return new se(q,x).minor},e.patch=function(q,x){return new se(q,x).patch},e.compare=ne,e.compareLoose=function(q,x){return ne(q,x,!0)},e.rcompare=function(q,x,ue){return ne(x,q,ue)},e.sort=function(q,x){return q.sort(function(ue,Oe){return e.compare(ue,Oe,x)})},e.rsort=function(q,x){return q.sort(function(ue,Oe){return e.rcompare(ue,Oe,x)})},e.gt=pe,e.lt=re,e.eq=le,e.neq=ce,e.gte=ye,e.lte=_,e.cmp=de,e.Comparator=ie;var ae={};function me(q,x){if(q instanceof me)return q.loose===x?q:new me(q.raw,x);if(q instanceof ie)return new me(q.value,x);if(!(this instanceof me))return new me(q,x);if(this.loose=x,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function Ie(q){return!q||q.toLowerCase()==="x"||q==="*"}function z(q,x,ue,Oe,Ue,Ze,Je,tt,_e,et,rt,nt,ze){return((x=Ie(ue)?"":Ie(Oe)?">="+ue+".0.0":Ie(Ue)?">="+ue+"."+Oe+".0":">="+x)+" "+(tt=Ie(_e)?"":Ie(et)?"<"+(+_e+1)+".0.0":Ie(rt)?"<"+_e+"."+(+et+1)+".0":nt?"<="+_e+"."+et+"."+rt+"-"+nt:"<="+tt)).trim()}function W(q,x){for(var ue=0;ue<q.length;ue++)if(!q[ue].test(x))return!1;if(x.prerelease.length){for(ue=0;ue<q.length;ue++)if(P(q[ue].semver),q[ue].semver!==ae&&q[ue].semver.prerelease.length>0){var Oe=q[ue].semver;if(Oe.major===x.major&&Oe.minor===x.minor&&Oe.patch===x.patch)return!0}return!1}return!0}function H(q,x,ue){try{x=new me(x,ue)}catch{return!1}return x.test(q)}function G(q,x,ue,Oe){var Ue,Ze,Je,tt,_e;switch(q=new se(q,Oe),x=new me(x,Oe),ue){case">":Ue=pe,Ze=_,Je=re,tt=">",_e=">=";break;case"<":Ue=re,Ze=ye,Je=pe,tt="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(H(q,x,Oe))return!1;for(var et=0;et<x.set.length;++et){var rt=x.set[et],nt=null,ze=null;if(rt.forEach(function(dt){dt.semver===ae&&(dt=new ie(">=0.0.0")),nt=nt||dt,ze=ze||dt,Ue(dt.semver,nt.semver,Oe)?nt=dt:Je(dt.semver,ze.semver,Oe)&&(ze=dt)}),nt.operator===tt||nt.operator===_e||(!ze.operator||ze.operator===tt)&&Ze(q,ze.semver)||ze.operator===_e&&Je(q,ze.semver))return!1}return!0}ie.prototype.parse=function(q){var x=this.loose?$[he]:$[$e],ue=q.match(x);if(!ue)throw new TypeError("Invalid comparator: "+q);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new se(ue[2],this.loose):this.semver=ae},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(q){return P("Comparator.test",q,this.loose),this.semver===ae||(typeof q=="string"&&(q=new se(q,this.loose)),de(q,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(q,x){if(!(q instanceof ie))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new me(q.value,x),H(this.value,ue,x);if(q.operator==="")return ue=new me(this.value,x),H(q.semver,ue,x);var Oe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ze=this.semver.version===q.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),tt=de(this.semver,"<",q.semver,x)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),_e=de(this.semver,">",q.semver,x)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Oe||Ue||Ze&&Je||tt||_e},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(q){var x=this.loose;q=q.trim(),P("range",q,x);var ue=x?$[fe]:$[ke];q=q.replace(ue,z),P("hyphen replace",q),q=q.replace($[De],"$1$2$3"),P("comparator trim",q,$[De]),q=(q=(q=q.replace($[V],"$1~")).replace($[L],"$1^")).split(/\s+/).join(" ");var Oe=x?$[he]:$[$e],Ue=q.split(" ").map(function(Ze){return function(Je,tt){return P("comp",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){P("caret",nt,ze);var dt=ze?$[Z]:$[O];return nt.replace(dt,function(X,Q,Ee,Be,He){var Xe;return P("caret",nt,X,Q,Ee,Be,He),Ie(Q)?Xe="":Ie(Ee)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Xe=Q==="0"?">="+Q+"."+Ee+".0 <"+Q+"."+(+Ee+1)+".0":">="+Q+"."+Ee+".0 <"+(+Q+1)+".0.0":He?(P("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=Q==="0"?Ee==="0"?">="+Q+"."+Ee+"."+Be+He+" <"+Q+"."+Ee+"."+(+Be+1):">="+Q+"."+Ee+"."+Be+He+" <"+Q+"."+(+Ee+1)+".0":">="+Q+"."+Ee+"."+Be+He+" <"+(+Q+1)+".0.0"):(P("no pr"),Xe=Q==="0"?Ee==="0"?">="+Q+"."+Ee+"."+Be+" <"+Q+"."+Ee+"."+(+Be+1):">="+Q+"."+Ee+"."+Be+" <"+Q+"."+(+Ee+1)+".0":">="+Q+"."+Ee+"."+Be+" <"+(+Q+1)+".0.0"),P("caret return",Xe),Xe})}(rt,et)}).join(" ")}(Je,tt),P("caret",Je),Je=function(_e,et){return _e.trim().split(/\s+/).map(function(rt){return function(nt,ze){var dt=ze?$[N]:$[J];return nt.replace(dt,function(X,Q,Ee,Be,He){var Xe;return P("tilde",nt,X,Q,Ee,Be,He),Ie(Q)?Xe="":Ie(Ee)?Xe=">="+Q+".0.0 <"+(+Q+1)+".0.0":Ie(Be)?Xe=">="+Q+"."+Ee+".0 <"+Q+"."+(+Ee+1)+".0":He?(P("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Xe=">="+Q+"."+Ee+"."+Be+He+" <"+Q+"."+(+Ee+1)+".0"):Xe=">="+Q+"."+Ee+"."+Be+" <"+Q+"."+(+Ee+1)+".0",P("tilde return",Xe),Xe})}(rt,et)}).join(" ")}(Je,tt),P("tildes",Je),Je=function(_e,et){return P("replaceXRanges",_e,et),_e.split(/\s+/).map(function(rt){return function(nt,ze){nt=nt.trim();var dt=ze?$[w]:$[u];return nt.replace(dt,function(X,Q,Ee,Be,He,Xe){P("xRange",nt,X,Q,Ee,Be,He,Xe);var st=Ie(Ee),vt=st||Ie(Be),Dt=vt||Ie(He);return Q==="="&&Dt&&(Q=""),st?X=Q===">"||Q==="<"?"<0.0.0":"*":Q&&Dt?(vt&&(Be=0),Dt&&(He=0),Q===">"?(Q=">=",vt?(Ee=+Ee+1,Be=0,He=0):Dt&&(Be=+Be+1,He=0)):Q==="<="&&(Q="<",vt?Ee=+Ee+1:Be=+Be+1),X=Q+Ee+"."+Be+"."+He):vt?X=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Dt&&(X=">="+Ee+"."+Be+".0 <"+Ee+"."+(+Be+1)+".0"),P("xRange return",X),X})}(rt,et)}).join(" ")}(Je,tt),P("xrange",Je),Je=function(_e,et){return P("replaceStars",_e,et),_e.trim().replace($[ve],"")}(Je,tt),P("stars",Je),Je}(Ze,x)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Ze){return!!Ze.match(Oe)})),Ue=Ue.map(function(Ze){return new ie(Ze,x)})},me.prototype.intersects=function(q,x){if(!(q instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(Oe){return q.set.some(function(Ue){return Ue.every(function(Ze){return Oe.intersects(Ze,x)})})})})},e.toComparators=function(q,x){return new me(q,x).set.map(function(ue){return ue.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new se(q,this.loose));for(var x=0;x<this.set.length;x++)if(W(this.set[x],q))return!0;return!1},e.satisfies=H,e.maxSatisfying=function(q,x,ue){var Oe=null,Ue=null;try{var Ze=new me(x,ue)}catch{return null}return q.forEach(function(Je){Ze.test(Je)&&(Oe&&Ue.compare(Je)!==-1||(Ue=new se(Oe=Je,ue)))}),Oe},e.minSatisfying=function(q,x,ue){var Oe=null,Ue=null;try{var Ze=new me(x,ue)}catch{return null}return q.forEach(function(Je){Ze.test(Je)&&(Oe&&Ue.compare(Je)!==1||(Ue=new se(Oe=Je,ue)))}),Oe},e.validRange=function(q,x){try{return new me(q,x).range||"*"}catch{return null}},e.ltr=function(q,x,ue){return G(q,x,"<",ue)},e.gtr=function(q,x,ue){return G(q,x,">",ue)},e.outside=G,e.prerelease=function(q,x){var ue=Re(q,x);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(q,x,ue){return q=new me(q,ue),x=new me(x,ue),q.intersects(x)},e.coerce=function(q){if(q instanceof se)return q;if(typeof q!="string")return null;var x=q.match($[S]);return x==null?null:Re((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,y(1))},function(we,e){var y,T,P=we.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function $(t){if(y===setTimeout)return setTimeout(t,0);if((y===M||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:M}catch{y=M}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var E,d=[],I=!1,D=-1;function l(){I&&E&&(I=!1,E.length?d=E.concat(d):D=-1,d.length&&b())}function b(){if(!I){var t=$(l);I=!0;for(var i=d.length;i;){for(E=d,d=[];++D<i;)E&&E[D].run();D=-1,i=d.length}E=null,I=!1,function(r){if(T===clearTimeout)return clearTimeout(r);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(r);try{T(r)}catch{try{return T.call(null,r)}catch{return T.call(this,r)}}}(t)}}function v(t,i){this.fun=t,this.array=i}function f(){}P.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)i[r-1]=arguments[r];d.push(new v(t,i)),d.length!==1||I||$(b)},v.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=f,P.addListener=f,P.once=f,P.off=f,P.removeListener=f,P.removeAllListeners=f,P.emit=f,P.prependListener=f,P.prependOnceListener=f,P.listeners=function(t){return[]},P.binding=function(t){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(t){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Pe[122],Ae([1,0,11,6]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function P(o){const h=o;return h?typeof h.read=="function":!1}e.$3d=P;function M(o){const h=o;return h?[h.on,h.pause,h.resume,h.destroy].every(n=>typeof n=="function"):!1}e.$4d=M;function A(o){const h=o;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$5d=A;function $(o,h){return new E(o,h)}e.$6d=$;class E{constructor(h,n){this.e=h,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(n=>n(h))}h(h){this.c.error.length===0?(0,y.$Z)(h):this.c.error.slice(0).forEach(n=>n(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,n){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(h,n){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const a=s.indexOf(n);a>=0&&s.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(o,h){const n=[];let s;for(;(s=o.read())!==null;)n.push(s);return h(n)}e.$7d=d;function I(o,h,n){const s=[];let a;for(;(a=o.read())!==null&&s.length<n;)s.push(a);return a===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof a<"u"){const g=a;return a=void 0,g}return o.read()}}}e.$8d=I;function D(o,h){return new Promise((n,s)=>{const a=[];l(o,{onData:g=>{h&&a.push(g)},onError:g=>{h?s(g):n(void 0)},onEnd:()=>{n(h?h(a):void 0)}})})}e.$9d=D;function l(o,h,n){o.on("error",s=>{n?.isCancellationRequested||h.onError(s)}),o.on("end",()=>{n?.isCancellationRequested||h.onEnd()}),o.on("data",s=>{n?.isCancellationRequested||h.onData(s)})}e.$0d=l;function b(o,h){return new Promise((n,s)=>{const a=new T.$Qc,g=[],p=C=>{if(g.push(C),g.length>h)return a.dispose(),o.pause(),n({stream:o,buffer:g,ended:!1})},m=C=>(a.dispose(),s(C)),k=()=>(a.dispose(),n({stream:o,buffer:g,ended:!0}));a.add((0,T.$Pc)(()=>o.removeListener("error",m))),o.on("error",m),a.add((0,T.$Pc)(()=>o.removeListener("end",k))),o.on("end",k),a.add((0,T.$Pc)(()=>o.removeListener("data",p))),o.on("data",p)})}e.$$d=b;function v(o,h){const n=$(h);return n.end(o),n}e.$_d=v;function f(){const o=$(()=>{throw new Error("not supported")});return o.end(),o}e.$ae=f;function t(o){let h=!1;return{read:()=>h?null:(h=!0,o)}}e.$be=t;function i(o,h,n){const s=$(n);return l(o,{onData:a=>s.write(h.data(a)),onError:a=>s.error(h.error?h.error(a):a),onEnd:()=>s.end()}),s}e.$ce=i;function r(o,h,n){let s=!1;return{read:()=>{const a=h.read();return s?a:(s=!0,a!==null?n([o,a]):o)}}}e.$de=r;function c(o,h,n){let s=!1;const a=$(n);return l(h,{onData:g=>s?a.write(g):(s=!0,a.write(n([o,g]))),onError:g=>a.error(g),onEnd:()=>{s||(s=!0,a.write(o)),a.end()}}),a}e.$ee=c}),define(Pe[24],Ae([1,0,44,122]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const P=typeof Buffer<"u",M=new y.$U(()=>new Uint8Array(256));let A,$;class E{static alloc(S){return P?new E(Buffer.allocUnsafe(S)):new E(new Uint8Array(S))}static wrap(S){return P&&!Buffer.isBuffer(S)&&(S=Buffer.from(S.buffer,S.byteOffset,S.byteLength)),new E(S)}static fromString(S,F){return!(F?.dontUseNodeBuffer||!1)&&P?new E(Buffer.from(S)):(A||(A=new TextEncoder),new E(A.encode(S)))}static fromByteArray(S){const F=E.alloc(S.length);for(let V=0,J=S.length;V<J;V++)F.buffer[V]=S[V];return F}static concat(S,F){if(typeof F>"u"){F=0;for(let N=0,R=S.length;N<R;N++)F+=S[N].byteLength}const V=E.alloc(F);let J=0;for(let N=0,R=S.length;N<R;N++){const L=S[N];V.set(L,J),J+=L.byteLength}return V}constructor(S){this.buffer=S,this.byteLength=this.buffer.byteLength}clone(){const S=E.alloc(this.byteLength);return S.set(this),S}toString(){return P?this.buffer.toString():($||($=new TextDecoder),$.decode(this.buffer))}slice(S,F){return new E(this.buffer.subarray(S,F))}set(S,F){if(S instanceof E)this.buffer.set(S.buffer,F);else if(S instanceof Uint8Array)this.buffer.set(S,F);else if(S instanceof ArrayBuffer)this.buffer.set(new Uint8Array(S),F);else if(ArrayBuffer.isView(S))this.buffer.set(new Uint8Array(S.buffer,S.byteOffset,S.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(S){return l(this.buffer,S)}writeUInt32BE(S,F){b(this.buffer,S,F)}readUInt32LE(S){return v(this.buffer,S)}writeUInt32LE(S,F){f(this.buffer,S,F)}readUInt8(S){return t(this.buffer,S)}writeUInt8(S,F){i(this.buffer,S,F)}indexOf(S,F=0){return d(this.buffer,S instanceof E?S.buffer:S,F)}}e.$fe=E;function d(w,S,F=0){const V=S.byteLength,J=w.byteLength;if(V===0)return 0;if(V===1)return w.indexOf(S[0]);if(V>J-F)return-1;const N=M.value;N.fill(S.length);for(let Z=0;Z<S.length;Z++)N[S[Z]]=S.length-Z-1;let R=F+S.length-1,L=R,O=-1;for(;R<J;)if(w[R]===S[L]){if(L===0){O=R;break}R--,L--}else R+=Math.max(S.length-L,N[w[R]]),L=S.length-1;return O}e.$ge=d;function I(w,S){return w[S+0]<<0>>>0|w[S+1]<<8>>>0}e.$he=I;function D(w,S,F){w[F+0]=S&255,S=S>>>8,w[F+1]=S&255}e.$ie=D;function l(w,S){return w[S]*2**24+w[S+1]*2**16+w[S+2]*2**8+w[S+3]}e.$je=l;function b(w,S,F){w[F+3]=S,S=S>>>8,w[F+2]=S,S=S>>>8,w[F+1]=S,S=S>>>8,w[F]=S}e.$ke=b;function v(w,S){return w[S+0]<<0>>>0|w[S+1]<<8>>>0|w[S+2]<<16>>>0|w[S+3]<<24>>>0}e.$le=v;function f(w,S,F){w[F+0]=S&255,S=S>>>8,w[F+1]=S&255,S=S>>>8,w[F+2]=S&255,S=S>>>8,w[F+3]=S&255}e.$me=f;function t(w,S){return w[S]}e.$ne=t;function i(w,S,F){w[F]=S}e.$oe=i;function r(w){return T.$7d(w,S=>E.concat(S))}e.$pe=r;function c(w){return T.$be(w)}e.$qe=c;function o(w){return T.$9d(w,S=>E.concat(S))}e.$re=o;async function h(w){return w.ended?E.concat(w.buffer):E.concat([...w.buffer,await o(w.stream)])}e.$se=h;function n(w){return T.$_d(w,S=>E.concat(S))}e.$te=n;function s(w){return T.$ce(w,{data:S=>typeof S=="string"?E.fromString(S):E.wrap(S)},S=>E.concat(S))}e.$ue=s;function a(w){return T.$6d(S=>E.concat(S),w)}e.$ve=a;function g(w,S){return T.$de(w,S,F=>E.concat(F))}e.$we=g;function p(w,S){return T.$ee(w,S,F=>E.concat(F))}e.$xe=p;function m(w){let S=0,F=0,V=0;const J=new Uint8Array(Math.floor(w.length/4*3)),N=L=>{switch(F){case 3:J[V++]=S|L,F=0;break;case 2:J[V++]=S|L>>>2,S=L<<6,F=3;break;case 1:J[V++]=S|L>>>4,S=L<<4,F=2;break;default:S=L<<2,F=1}};for(let L=0;L<w.length;L++){const O=w.charCodeAt(L);if(O>=65&&O<=90)N(O-65);else if(O>=97&&O<=122)N(O-97+26);else if(O>=48&&O<=57)N(O-48+52);else if(O===43||O===45)N(62);else if(O===47||O===95)N(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${w[L]}`)}}const R=V;for(;F>0;)N(0);return E.wrap(J).slice(0,R)}e.$ye=m;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:w},S=!0,F=!1){const V=F?C:k;let J="";const N=w.byteLength%3;let R=0;for(;R<w.byteLength-N;R+=3){const L=w[R+0],O=w[R+1],Z=w[R+2];J+=V[L>>>2],J+=V[(L<<4|O>>>4)&63],J+=V[(O<<2|Z>>>6)&63],J+=V[Z&63]}if(N===1){const L=w[R+0];J+=V[L>>>2],J+=V[L<<4&63],S&&(J+="==")}else if(N===2){const L=w[R+0],O=w[R+1];J+=V[L>>>2],J+=V[(L<<4|O>>>4)&63],J+=V[O<<2&63],S&&(J+="=")}return J}e.$ze=u}),define(Pe[123],Ae([1,0,28,12]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FuzzyScore=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.or=void 0;function P(...ie){return function(ae,me){for(let Ie=0,z=ie.length;Ie<z;Ie++){const W=ie[Ie](ae,me);if(W)return W}return null}}e.or=P,e.$Ij=M.bind(void 0,!1),e.$Jj=M.bind(void 0,!0);function M(ie,ae,me){if(!me||me.length<ae.length)return null;let Ie;return ie?Ie=T.$7e(me,ae):Ie=me.indexOf(ae)===0,Ie?ae.length>0?[{start:0,end:ae.length}]:[]:null}function A(ie,ae){const me=ae.toLowerCase().indexOf(ie.toLowerCase());return me===-1?null:[{start:me,end:me+ie.length}]}e.$Kj=A;function $(ie,ae){return E(ie.toLowerCase(),ae.toLowerCase(),0,0)}e.$Lj=$;function E(ie,ae,me,Ie){if(me===ie.length)return[];if(Ie===ae.length)return null;if(ie[me]===ae[Ie]){let z=null;return(z=E(ie,ae,me+1,Ie+1))?i({start:Ie,end:Ie+1},z):null}return E(ie,ae,me,Ie+1)}function d(ie){return 97<=ie&&ie<=122}function I(ie){return 65<=ie&&ie<=90}e.$Mj=I;function D(ie){return 48<=ie&&ie<=57}function l(ie){return ie===32||ie===9||ie===10||ie===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>b.add(ie.charCodeAt(0)));function v(ie){return l(ie)||b.has(ie)}function f(ie,ae){return ie===ae||v(ie)&&v(ae)}function t(ie){return d(ie)||I(ie)||D(ie)}function i(ie,ae){return ae.length===0?ae=[ie]:ie.end===ae[0].start?ae[0].start=ie.start:ae.unshift(ie),ae}function r(ie,ae){for(let me=ae;me<ie.length;me++){const Ie=ie.charCodeAt(me);if(I(Ie)||D(Ie)||me>0&&!t(ie.charCodeAt(me-1)))return me}return ie.length}function c(ie,ae,me,Ie){if(me===ie.length)return[];if(Ie===ae.length)return null;if(ie[me]!==ae[Ie].toLowerCase())return null;{let z=null,W=Ie+1;for(z=c(ie,ae,me+1,Ie+1);!z&&(W=r(ae,W))<ae.length;)z=c(ie,ae,me+1,W),W++;return z===null?null:i({start:Ie,end:Ie+1},z)}}function o(ie){let ae=0,me=0,Ie=0,z=0,W=0;for(let ue=0;ue<ie.length;ue++)W=ie.charCodeAt(ue),I(W)&&ae++,d(W)&&me++,t(W)&&Ie++,D(W)&&z++;const H=ae/ie.length,G=me/ie.length,q=Ie/ie.length,x=z/ie.length;return{upperPercent:H,lowerPercent:G,alphaPercent:q,numericPercent:x}}function h(ie){const{upperPercent:ae,lowerPercent:me}=ie;return me===0&&ae>.6}function n(ie){const{upperPercent:ae,lowerPercent:me,alphaPercent:Ie,numericPercent:z}=ie;return me>.2&&ae<.8&&Ie>.6&&z<.2}function s(ie){let ae=0,me=0,Ie=0,z=0;for(let W=0;W<ie.length;W++)Ie=ie.charCodeAt(W),I(Ie)&&ae++,d(Ie)&&me++,l(Ie)&&z++;return(ae===0||me===0)&&z===0?ie.length<=30:ae<=5}function a(ie,ae){if(!ae||(ae=ae.trim(),ae.length===0)||!s(ie)||ae.length>60)return null;const me=o(ae);if(!n(me)){if(!h(me))return null;ae=ae.toLowerCase()}let Ie=null,z=0;for(ie=ie.toLowerCase();z<ae.length&&(Ie=c(ie,ae,0,z))===null;)z=r(ae,z+1);return Ie}e.$Nj=a;function g(ie,ae,me=!1){if(!ae||ae.length===0)return null;let Ie=null,z=0;for(ie=ie.toLowerCase(),ae=ae.toLowerCase();z<ae.length&&(Ie=p(ie,ae,0,z,me))===null;)z=m(ae,z+1);return Ie}e.$Oj=g;function p(ie,ae,me,Ie,z){if(me===ie.length)return[];if(Ie===ae.length)return null;if(f(ie.charCodeAt(me),ae.charCodeAt(Ie))){let W=null,H=Ie+1;if(W=p(ie,ae,me+1,Ie+1,z),!z)for(;!W&&(H=m(ae,H))<ae.length;)W=p(ie,ae,me+1,H,z),H++;return W?ie.charCodeAt(me)!==ae.charCodeAt(Ie)?W:i({start:Ie,end:Ie+1},W):null}else return null}function m(ie,ae){for(let me=ae;me<ie.length;me++)if(v(ie.charCodeAt(me))||me>0&&v(ie.charCodeAt(me-1)))return me;return ie.length}const k=P(e.$Jj,a,A),C=P(e.$Jj,a,$),u=new y.$Cc(1e4);function w(ie,ae,me=!1){if(typeof ie!="string"||typeof ae!="string")return null;let Ie=u.get(ie);Ie||(Ie=new RegExp(T.$Pe(ie),"i"),u.set(ie,Ie));const z=Ie.exec(ae);return z?[{start:z.index,end:z.index+z[0].length}]:me?C(ie,ae):k(ie,ae)}e.$Pj=w;function S(ie,ae){const me=pe(ie,ie.toLowerCase(),0,ae,ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return me?V(me):null}e.$Qj=S;function F(ie,ae,me,Ie,z,W){const H=Math.min(13,ie.length);for(;me<H;me++){const G=pe(ie,ae,me,Ie,z,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,W]}e.$Rj=F;function V(ie){if(typeof ie>"u")return[];const ae=[],me=ie[1];for(let Ie=ie.length-1;Ie>1;Ie--){const z=ie[Ie]+me,W=ae[ae.length-1];W&&W.end===z?W.end=z+1:ae.push({start:z,end:z+1})}return ae}e.$Sj=V;const J=128;function N(){const ie=[],ae=[];for(let me=0;me<=J;me++)ae[me]=0;for(let me=0;me<=J;me++)ie.push(ae.slice(0));return ie}function R(ie){const ae=[];for(let me=0;me<=ie;me++)ae[me]=0;return ae}const L=R(2*J),O=R(2*J),Z=N(),he=N(),$e=N(),De=!1;function ke(ie,ae,me,Ie,z){function W(G,q,x=" "){for(;G.length<q;)G=x+G;return G}let H=` |   |${Ie.split("").map(G=>W(G,3)).join("|")}
`;for(let G=0;G<=me;G++)G===0?H+=" |":H+=`${ae[G-1]}|`,H+=ie[G].slice(0,z+1).map(q=>W(q.toString(),3)).join("|")+`
`;return H}function fe(ie,ae,me,Ie){ie=ie.substr(ae),me=me.substr(Ie),console.log(ke(he,ie,ie.length,me,me.length)),console.log(ke($e,ie,ie.length,me,me.length)),console.log(ke(Z,ie,ie.length,me,me.length))}function ve(ie,ae){if(ae<0||ae>=ie.length)return!1;const me=ie.codePointAt(ae);switch(me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$mf(me)}}function te(ie,ae){if(ae<0||ae>=ie.length)return!1;switch(ie.charCodeAt(ae)){case 32:case 9:return!0;default:return!1}}function Re(ie,ae,me){return ae[ie]!==me[ie]}function se(ie,ae,me,Ie,z,W,H=!1){for(;ae<me&&z<W;)ie[ae]===Ie[z]&&(H&&(L[ae]=z),ae+=1),z+=1;return ae===me}e.$Tj=se;var Y;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(Y||(Y={}));var B;(function(ie){ie.Default=[-100,0];function ae(me){return!me||me.length===2&&me[0]===-100&&me[1]===0}ie.isDefault=ae})(B||(e.FuzzyScore=B={}));class ne{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ae,me){this.firstMatchCanBeWeak=ae,this.boostFullMatch=me}}e.$Uj=ne;function pe(ie,ae,me,Ie,z,W,H=ne.default){const G=ie.length>J?J:ie.length,q=Ie.length>J?J:Ie.length;if(me>=G||W>=q||G-me>q-W||!se(ae,me,G,z,W,q,!0))return;re(G,q,me,W,ae,z);let x=1,ue=1,Oe=me,Ue=W;const Ze=[!1];for(x=1,Oe=me;Oe<G;x++,Oe++){const rt=L[Oe],nt=O[Oe],ze=Oe+1<G?O[Oe+1]:q;for(ue=rt-W+1,Ue=rt;Ue<ze;ue++,Ue++){let dt=Number.MIN_SAFE_INTEGER,X=!1;Ue<=nt&&(dt=le(ie,ae,Oe,me,Ie,z,Ue,q,W,Z[x-1][ue-1]===0,Ze));let Q=0;dt!==Number.MAX_SAFE_INTEGER&&(X=!0,Q=dt+he[x-1][ue-1]);const Ee=Ue>rt,Be=Ee?he[x][ue-1]+(Z[x][ue-1]>0?-5:0):0,He=Ue>rt+1&&Z[x][ue-1]>0,Xe=He?he[x][ue-2]+(Z[x][ue-2]>0?-5:0):0;if(He&&(!Ee||Xe>=Be)&&(!X||Xe>=Q))he[x][ue]=Xe,$e[x][ue]=3,Z[x][ue]=0;else if(Ee&&(!X||Be>=Q))he[x][ue]=Be,$e[x][ue]=2,Z[x][ue]=0;else if(X)he[x][ue]=Q,$e[x][ue]=1,Z[x][ue]=Z[x-1][ue-1]+1;else throw new Error("not possible")}}if(De&&fe(ie,me,Ie,W),!Ze[0]&&!H.firstMatchCanBeWeak)return;x--,ue--;const Je=[he[x][ue],W];let tt=0,_e=0;for(;x>=1;){let rt=ue;do{const nt=$e[x][rt];if(nt===3)rt=rt-2;else if(nt===2)rt=rt-1;else break}while(rt>=1);tt>1&&ae[me+x-1]===z[W+ue-1]&&!Re(rt+W-1,Ie,z)&&tt+1>Z[x][rt]&&(rt=ue),rt===ue?tt++:tt=1,_e||(_e=rt),x--,ue=rt-1,Je.push(ue)}q===G&&H.boostFullMatch&&(Je[0]+=2);const et=_e-G;return Je[0]-=et,Je}e.$Vj=pe;function re(ie,ae,me,Ie,z,W){let H=ie-1,G=ae-1;for(;H>=me&&G>=Ie;)z[H]===W[G]&&(O[H]=G,H--),G--}function le(ie,ae,me,Ie,z,W,H,G,q,x,ue){if(ae[me]!==W[H])return Number.MIN_SAFE_INTEGER;let Oe=1,Ue=!1;return H===me-Ie?Oe=ie[me]===z[H]?7:5:Re(H,z,W)&&(H===0||!Re(H-1,z,W))?(Oe=ie[me]===z[H]?7:5,Ue=!0):ve(W,H)&&(H===0||!ve(W,H-1))?Oe=5:(ve(W,H-1)||te(W,H-1))&&(Oe=5,Ue=!0),Oe>1&&me===Ie&&(ue[0]=!0),Ue||(Ue=Re(H,z,W)||ve(W,H-1)||te(W,H-1)),me===Ie?H>q&&(Oe-=Ue?3:5):x?Oe+=Ue?2:0:Oe+=Ue?0:1,H+1===G&&(Oe-=Ue?3:5),Oe}function ce(ie,ae,me,Ie,z,W,H){return _(ie,ae,me,Ie,z,W,!0,H)}e.$Wj=ce;function ye(ie,ae,me,Ie,z,W,H){return _(ie,ae,me,Ie,z,W,!1,H)}e.$Xj=ye;function _(ie,ae,me,Ie,z,W,H,G){let q=pe(ie,ae,me,Ie,z,W,G);if(q&&!H)return q;if(ie.length>=3){const x=Math.min(7,ie.length-1);for(let ue=me+1;ue<x;ue++){const Oe=de(ie,ue);if(Oe){const Ue=pe(Oe,Oe.toLowerCase(),me,Ie,z,W,G);Ue&&(Ue[0]-=3,(!q||Ue[0]>q[0])&&(q=Ue))}}}return q}function de(ie,ae){if(ae+1>=ie.length)return;const me=ie[ae],Ie=ie[ae+1];if(me!==Ie)return ie.slice(0,ae)+Ie+me+ie.slice(ae+2)}}),define(Pe[31],Ae([1,0,12]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(T||(T={})),function(P){const M="error",A="warning",$="warn",E="info",d="ignore";function I(l){return l?y.$6e(M,l)?P.Error:y.$6e(A,l)||y.$6e($,l)?P.Warning:y.$6e(E,l)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function D(l){switch(l){case P.Error:return M;case P.Warning:return A;case P.Info:return E;default:return d}}P.toString=D}(T||(T={})),e.default=T}),define(Pe[124],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(Pe[50],Ae([1,0,18,12]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=void 0;class P{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const v=b.charCodeAt(0),f=this.b.charCodeAt(this.c);return v-f}value(){return this.b[this.c]}}e.$Xh=P;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,T.$Ze)(b,this.b,0,b.length,this.c,this.d):(0,T.$2e)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Yh=M;class A{constructor(b=!0,v=!0){this.f=b,this.g=v}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let v=b.length-1;v>=0;v--,this.c--){const f=this.b.charCodeAt(v);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,T.$Ze)(b,this.b,0,b.length,this.d,this.e):(0,T.$2e)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Zh=A;var $;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})($||($={}));class E{constructor(b,v){this.f=b,this.g=v,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,T.$1e)(b,this.c.scheme);if(this.d[this.e]===2)return(0,T.$1e)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,T.$Ye)(b,this.c.query);if(this.d[this.e]===5)return(0,T.$Ye)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$1h=E;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var I;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(I||(I={}));class D{static forUris(b=()=>!1,v=()=>!1){return new D(new E(b,v))}static forPaths(b=!1){return new D(new A(void 0,!b))}static forStrings(){return new D(new P)}static forConfigKeys(){return new D(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,v){if(v){const f=v.slice(0);(0,y.$Wb)(f);for(const t of f)this.set(t,b)}else{const f=b.slice(0);(0,y.$Wb)(f);for(const t of f)this.set(t[0],t[1])}}set(b,v){const f=this.b.reset(b);let t;this.c||(this.c=new d,this.c.segment=f.value());const i=[];for(t=this.c;;){const c=f.cmp(t.segment);if(c>0)t.left||(t.left=new d,t.left.segment=f.value()),i.push([-1,t]),t=t.left;else if(c<0)t.right||(t.right=new d,t.right.segment=f.value()),i.push([1,t]),t=t.right;else if(f.hasNext())f.next(),t.mid||(t.mid=new d,t.mid.segment=f.value()),i.push([0,t]),t=t.mid;else break}const r=t.value;t.value=v,t.key=b;for(let c=i.length-1;c>=0;c--){const o=i[c][1];o.updateHeight();const h=o.balanceFactor();if(h<-1||h>1){const n=i[c][0],s=i[c+1][0];if(n===1&&s===1)i[c][1]=o.rotateLeft();else if(n===-1&&s===-1)i[c][1]=o.rotateRight();else if(n===1&&s===-1)o.right=i[c+1][1]=i[c+1][1].rotateRight(),i[c][1]=o.rotateLeft();else if(n===-1&&s===1)o.left=i[c+1][1]=i[c+1][1].rotateLeft(),i[c][1]=o.rotateRight();else throw new Error;if(c>0)switch(i[c-1][0]){case-1:i[c-1][1].left=i[c][1];break;case 1:i[c-1][1].right=i[c][1];break;case 0:i[c-1][1].mid=i[c][1];break}else this.c=i[0][1]}}return r}get(b){return this.d(b)?.value}d(b){const v=this.b.reset(b);let f=this.c;for(;f;){const t=v.cmp(f.segment);if(t>0)f=f.left;else if(t<0)f=f.right;else if(v.hasNext())v.next(),f=f.mid;else break}return f}has(b){const v=this.d(b);return!(v?.value===void 0&&v?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,v){const f=this.b.reset(b),t=[];let i=this.c;for(;i;){const r=f.cmp(i.segment);if(r>0)t.push([-1,i]),i=i.left;else if(r<0)t.push([1,i]),i=i.right;else if(f.hasNext())f.next(),t.push([0,i]),i=i.mid;else break}if(i){if(v?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const r=this.f(i.right);if(r.key){const{key:c,value:o,segment:h}=r;this.e(r.key,!1),i.key=c,i.value=o,i.segment=h}}else{const r=i.left??i.right;if(t.length>0){const[c,o]=t[t.length-1];switch(c){case-1:o.left=r;break;case 0:o.mid=r;break;case 1:o.right=r;break}}else this.c=r}for(let r=t.length-1;r>=0;r--){const c=t[r][1];c.updateHeight();const o=c.balanceFactor();if(o>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),t[r][1]=c.rotateLeft()):o<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),t[r][1]=c.rotateRight()),r>0)switch(t[r-1][0]){case-1:t[r-1][1].left=t[r][1];break;case 1:t[r-1][1].right=t[r][1];break;case 0:t[r-1][1].mid=t[r][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const v=this.b.reset(b);let f=this.c,t;for(;f;){const i=v.cmp(f.segment);if(i>0)f=f.left;else if(i<0)f=f.right;else if(v.hasNext())v.next(),t=f.value||t,f=f.mid;else break}return f&&f.value||t}findSuperstr(b){return this.g(b,!1)}g(b,v){const f=this.b.reset(b);let t=this.c;for(;t;){const i=f.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(f.hasNext())f.next(),t=t.mid;else return t.mid?this.h(t.mid):v?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[v,f]of this)b(f,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const v=[];return this.j(b,v),v[Symbol.iterator]()}j(b,v){b&&(b.left&&this.j(b.left,v),b.value&&v.push([b.key,b.value]),b.mid&&this.j(b.mid,v),b.right&&this.j(b.right,v))}_isBalanced(){const b=v=>{if(!v)return!0;const f=v.balanceFactor();return f<-1||f>1?!1:b(v.left)&&b(v.right)};return b(this.c)}}e.$2h=D}),define(Pe[45],Ae([1,0,90]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$2j=e.ThemeColor=void 0;var T;(function(A){function $(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=$})(T||(e.ThemeColor=T={}));function P(A){return{id:A}}e.$2j=P;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const $=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(r){const c=$.exec(r.id);if(!c)return E(y.$1j.error);const[,o,h]=c,n=["codicon","codicon-"+o];return h&&n.push("codicon-modifier-"+h.substring(1)),n}A.asClassNameArray=E;function d(r){return E(r).join(" ")}A.asClassName=d;function I(r){return"."+E(r).join(".")}A.asCSSSelector=I;function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||T.isThemeColor(r.color))}A.isThemeIcon=D;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(r){const c=l.exec(r);if(!c)return;const[,o]=c;return{id:o}}A.fromString=b;function v(r){return{id:r}}A.fromId=v;function f(r,c){let o=r.id;const h=o.lastIndexOf("~");return h!==-1&&(o=o.substring(0,h)),c&&(o=`${o}~${c}`),{id:o}}A.modify=f;function t(r){const c=r.id.lastIndexOf("~");if(c!==-1)return r.id.substring(c+1)}A.getModifier=t;function i(r,c){return r.id===c.id&&r.color?.id===c.color?.id}A.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Pe[125],Ae([1,0,123,12,45]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=void 0;const M="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),$=new RegExp(`(\\\\)?${A.source}`,"g");function E(i){return i.replace($,(r,c)=>c?r:`\\${r}`)}e.$3j=E;const d=new RegExp(`\\\\${A.source}`,"g");function I(i){return i.replace(d,r=>`\\${r}`)}e.$4j=I;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(i){return i.indexOf(M)===-1?i:i.replace(D,(r,c,o,h)=>o?r:c||h||"")}e.$5j=l;function b(i){return i?i.replace(/\$\((.*?)\)/g,(r,c)=>` ${c} `).trim():""}e.$6j=b;const v=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(i){v.lastIndex=0;let r="";const c=[];let o=0;for(;;){const h=v.lastIndex,n=v.exec(i),s=i.substring(h,n?.index);if(s.length>0){r+=s;for(let a=0;a<s.length;a++)c.push(o)}if(!n)break;o+=n[0].length}return{text:r,iconOffsets:c}}e.$7j=f;function t(i,r,c=!1){const{text:o,iconOffsets:h}=r;if(!h||h.length===0)return(0,y.$Pj)(i,o,c);const n=(0,T.$Ne)(o," "),s=o.length-n.length,a=(0,y.$Pj)(i,n,c);if(a)for(const g of a){const p=h[g.start+s]+s;g.start+=p,g.end+=p}return a}e.$8j=t}),define(Pe[33],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ig=e.$hg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(P){return y.test(P)}e.$hg=T,e.$ig=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function($){for(let E=0;E<$.length;E++)$[E]=Math.floor(Math.random()*256);return $};const M=new Uint8Array(16),A=[];for(let $=0;$<256;$++)A.push($.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let E=0,d="";return d+=A[M[E++]],d+=A[M[E++]],d+=A[M[E++]],d+=A[M[E++]],d+="-",d+=A[M[E++]],d+=A[M[E++]],d+="-",d+=A[M[E++]],d+=A[M[E++]],d+="-",d+=A[M[E++]],d+=A[M[E++]],d+="-",d+=A[M[E++]],d+=A[M[E++]],d+=A[M[E++]],d+=A[M[E++]],d+=A[M[E++]],d+=A[M[E++]],d}}()}),define(Pe[126],Ae([1,0,18,67,33]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=e.$8s=e.$7s=e.$6s=e.$5s=void 0;function M(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$5s=M;function A(D,l,b){const v={id:(0,P.$ig)(),name:D,uri:l,data:b};return{asString:async()=>"",asFile:()=>v,value:void 0}}e.$6s=A;class ${constructor(){this.a=new Map}get size(){let l=0;for(const b of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const b=[...this.a.keys()];return T.Iterable.some(this,([v,f])=>f.asFile())&&b.push("files"),I(E(l),b)}get(l){return this.a.get(this.b(l))?.[0]}append(l,b){const v=this.a.get(l);v?v.push(b):this.a.set(this.b(l),[b])}replace(l,b){this.a.set(this.b(l),[b])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,b]of this.a)for(const v of b)yield[l,v]}b(l){return E(l)}}e.$7s=$;function E(D){return D.toLowerCase()}function d(D,l){return I(E(D),l.map(E))}e.$8s=d;function I(D,l){if(D==="*/*")return l.length>0;if(l.includes(D))return!0;const b=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[v,f,t]=b;return t==="*"?l.some(i=>i.startsWith(f+"/")):!1}e.$9s=Object.freeze({create:D=>(0,y.$Lb)(D.map(l=>l.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$9s.split(D).filter(l=>!l.startsWith("#"))})}),define(Pe[127],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.StringEOL=void 0;var y;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(y||(e.StringEOL=y={}));function T(P){let M=0,A=0,$=0,E=0;for(let d=0,I=P.length;d<I;d++){const D=P.charCodeAt(d);D===13?(M===0&&(A=d),M++,d+1<I&&P.charCodeAt(d+1)===10?(E|=2,d++):E|=3,$=d+1):D===10&&(E|=1,M===0&&(A=d),M++,$=d+1)}return M===0&&(A=P.length),[M,A,P.length-$,E]}e.$_s=T}),define(Pe[128],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0,e.$9r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[129],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.$vt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class T{constructor($){if(this.e=null,this.f=!1,this.open=$.open,this.close=$.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray($.notIn))for(let E=0,d=$.notIn.length;E<d;E++)switch($.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK($){switch($){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose($,E){if($.getTokenCount()===0)return!0;const d=$.findTokenIndexAtOffset(E-2),I=$.getStandardTokenType(d);return this.isOK(I)}g($,E){for(let d=$;d<=E;d++){const I=String.fromCharCode(d);if(!this.open.includes(I)&&!this.close.includes(I))return I}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$vt=T;class P{constructor($){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of $)M(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),M(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),M(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),M(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&M(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$wt=P;function M(A,$,E){A.has($)?A.get($).push(E):A.set($,[E])}}),define(Pe[130],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AB=e.$zB=e.$yB=e.$xB=e.$wB=e.$vB=e.$uB=e.$tB=e.$sB=e.NodeColor=e.$rB=void 0;class y{constructor(t,i){this.piece=t,this.color=i,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$sB)return P(this.right);let t=this;for(;t.parent!==e.$sB&&t.parent.left!==t;)t=t.parent;return t.parent===e.$sB?e.$sB:t.parent}prev(){if(this.left!==e.$sB)return M(this.left);let t=this;for(;t.parent!==e.$sB&&t.parent.right!==t;)t=t.parent;return t.parent===e.$sB?e.$sB:t.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$rB=y;var T;(function(f){f[f.Black=0]="Black",f[f.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$sB=new y(null,0),e.$sB.parent=e.$sB,e.$sB.left=e.$sB,e.$sB.right=e.$sB,e.$sB.color=0;function P(f){for(;f.left!==e.$sB;)f=f.left;return f}e.$tB=P;function M(f){for(;f.right!==e.$sB;)f=f.right;return f}e.$uB=M;function A(f){return f===e.$sB?0:f.size_left+f.piece.length+A(f.right)}function $(f){return f===e.$sB?0:f.lf_left+f.piece.lineFeedCnt+$(f.right)}function E(){e.$sB.parent=e.$sB}function d(f,t){const i=t.right;i.size_left+=t.size_left+(t.piece?t.piece.length:0),i.lf_left+=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),t.right=i.left,i.left!==e.$sB&&(i.left.parent=t),i.parent=t.parent,t.parent===e.$sB?f.root=i:t.parent.left===t?t.parent.left=i:t.parent.right=i,i.left=t,t.parent=i}e.$vB=d;function I(f,t){const i=t.left;t.left=i.right,i.right!==e.$sB&&(i.right.parent=t),i.parent=t.parent,t.size_left-=i.size_left+(i.piece?i.piece.length:0),t.lf_left-=i.lf_left+(i.piece?i.piece.lineFeedCnt:0),t.parent===e.$sB?f.root=i:t===t.parent.right?t.parent.right=i:t.parent.left=i,i.right=t,t.parent=i}e.$wB=I;function D(f,t){let i,r;if(t.left===e.$sB?(r=t,i=r.right):t.right===e.$sB?(r=t,i=r.left):(r=P(t.right),i=r.right),r===f.root){f.root=i,i.color=0,t.detach(),E(),f.root.parent=e.$sB;return}const c=r.color===1;if(r===r.parent.left?r.parent.left=i:r.parent.right=i,r===t?(i.parent=r.parent,v(f,i)):(r.parent===t?i.parent=r:i.parent=r.parent,v(f,i),r.left=t.left,r.right=t.right,r.parent=t.parent,r.color=t.color,t===f.root?f.root=r:t===t.parent.left?t.parent.left=r:t.parent.right=r,r.left!==e.$sB&&(r.left.parent=r),r.right!==e.$sB&&(r.right.parent=r),r.size_left=t.size_left,r.lf_left=t.lf_left,v(f,r)),t.detach(),i.parent.left===i){const h=A(i),n=$(i);if(h!==i.parent.size_left||n!==i.parent.lf_left){const s=h-i.parent.size_left,a=n-i.parent.lf_left;i.parent.size_left=h,i.parent.lf_left=n,b(f,i.parent,s,a)}}if(v(f,i.parent),c){E();return}let o;for(;i!==f.root&&i.color===0;)i===i.parent.left?(o=i.parent.right,o.color===1&&(o.color=0,i.parent.color=1,d(f,i.parent),o=i.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.right.color===0&&(o.left.color=0,o.color=1,I(f,o),o=i.parent.right),o.color=i.parent.color,i.parent.color=0,o.right.color=0,d(f,i.parent),i=f.root)):(o=i.parent.left,o.color===1&&(o.color=0,i.parent.color=1,I(f,i.parent),o=i.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,i=i.parent):(o.left.color===0&&(o.right.color=0,o.color=1,d(f,o),o=i.parent.left),o.color=i.parent.color,i.parent.color=0,o.left.color=0,I(f,i.parent),i=f.root));i.color=0,E()}e.$xB=D;function l(f,t){for(v(f,t);t!==f.root&&t.parent.color===1;)if(t.parent===t.parent.parent.left){const i=t.parent.parent.right;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.right&&(t=t.parent,d(f,t)),t.parent.color=0,t.parent.parent.color=1,I(f,t.parent.parent))}else{const i=t.parent.parent.left;i.color===1?(t.parent.color=0,i.color=0,t.parent.parent.color=1,t=t.parent.parent):(t===t.parent.left&&(t=t.parent,I(f,t)),t.parent.color=0,t.parent.parent.color=1,d(f,t.parent.parent))}f.root.color=0}e.$yB=l;function b(f,t,i,r){for(;t!==f.root&&t!==e.$sB;)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}e.$zB=b;function v(f,t){let i=0,r=0;if(t!==f.root){for(;t!==f.root&&t===t.parent.right;)t=t.parent;if(t!==f.root)for(t=t.parent,i=A(t.left)-t.size_left,r=$(t.left)-t.lf_left,t.size_left+=i,t.lf_left+=r;t!==f.root&&(i!==0||r!==0);)t.parent.left===t&&(t.parent.size_left+=i,t.parent.lf_left+=r),t=t.parent}}e.$AB=v}),define(Pe[91],Ae([1,0,131,29,92,130,93]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=void 0;const $=65535;function E(i){let r;return i[i.length-1]<65536?r=new Uint16Array(i.length):r=new Uint32Array(i.length),r.set(i,0),r}class d{constructor(r,c,o,h,n){this.lineStarts=r,this.cr=c,this.lf=o,this.crlf=h,this.isBasicASCII=n}}function I(i,r=!0){const c=[0];let o=1;for(let h=0,n=i.length;h<n;h++){const s=i.charCodeAt(h);s===13?h+1<n&&i.charCodeAt(h+1)===10?(c[o++]=h+2,h++):c[o++]=h+1:s===10&&(c[o++]=h+1)}return r?E(c):c}e.$HB=I;function D(i,r){i.length=0,i[0]=0;let c=1,o=0,h=0,n=0,s=!0;for(let g=0,p=r.length;g<p;g++){const m=r.charCodeAt(g);m===13?g+1<p&&r.charCodeAt(g+1)===10?(n++,i[c++]=g+2,g++):(o++,i[c++]=g+1):m===10?(h++,i[c++]=g+1):s&&m!==9&&(m<32||m>126)&&(s=!1)}const a=new d(E(i),o,h,n,s);return i.length=0,a}e.$IB=D;class l{constructor(r,c,o,h,n){this.bufferIndex=r,this.start=c,this.end=o,this.lineFeedCnt=h,this.length=n}}e.$JB=l;class b{constructor(r,c){this.buffer=r,this.lineStarts=c}}e.$KB=b;class v{constructor(r,c){this.a=[],this.c=r,this.d=c,this.b=0,r.root!==M.$sB&&r.iterate(r.root,o=>(o!==M.$sB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class f{constructor(r){this.a=r,this.b=[]}get(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartOffset<=r&&o.nodeStartOffset+o.node.piece.length>=r)return o}return null}get2(r){for(let c=this.b.length-1;c>=0;c--){const o=this.b[c];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<r&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=r)return o}return null}set(r){this.b.length>=this.a&&this.b.shift(),this.b.push(r)}validate(r){let c=!1;const o=this.b;for(let h=0;h<o.length;h++){const n=o[h];if(n.node.parent===null||n.nodeStartOffset>=r){o[h]=null,c=!0;continue}}if(c){const h=[];for(const n of o)n!==null&&h.push(n);this.b=h}}}class t{constructor(r,c,o){this.create(r,c,o)}create(r,c,o){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=M.$sB,this.b=1,this.c=0,this.d=c,this.e=c.length,this.f=o;let h=null;for(let n=0,s=r.length;n<s;n++)if(r[n].buffer.length>0){r[n].lineStarts||(r[n].lineStarts=I(r[n].buffer));const a=new l(n+1,{line:0,column:0},{line:r[n].lineStarts.length-1,column:r[n].buffer.length-r[n].lineStarts[r[n].lineStarts.length-1]},r[n].lineStarts.length-1,r[n].buffer.length);this.a.push(r[n]),h=this.S(h,a)}this.h=new f(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(r){const c=$,o=c-Math.floor(c/3),h=o*2;let n="",s=0;const a=[];if(this.iterate(this.root,g=>{const p=this.R(g),m=p.length;if(s<=o||s+m<h)return n+=p,s+=m,!0;const k=n.replace(/\r\n|\r|\n/g,r);return a.push(new b(k,I(k))),n=p,s=m,!0}),s>0){const g=n.replace(/\r\n|\r|\n/g,r);a.push(new b(g,I(g)))}this.create(a,r,!0)}getEOL(){return this.d}setEOL(r){this.d=r,this.e=this.d.length,this.normalizeEOL(r)}createSnapshot(r){return new v(this,r)}equal(r){if(this.getLength()!==r.getLength()||this.getLineCount()!==r.getLineCount())return!1;let c=0;return this.iterate(this.root,h=>{if(h===M.$sB)return!0;const n=this.R(h),s=n.length,a=r.G(c),g=r.G(c+s),p=r.getValueInRange2(a,g);return c+=s,n===p})}getOffsetAt(r,c){let o=0,h=this.root;for(;h!==M.$sB;)if(h.left!==M.$sB&&h.lf_left+1>=r)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=r){o+=h.size_left;const n=this.B(h,r-h.lf_left-2);return o+=n+c-1}else r-=h.lf_left+h.piece.lineFeedCnt,o+=h.size_left+h.piece.length,h=h.right;return o}getPositionAt(r){r=Math.floor(r),r=Math.max(0,r);let c=this.root,o=0;const h=r;for(;c!==M.$sB;)if(c.size_left!==0&&c.size_left>=r)c=c.left;else if(c.size_left+c.piece.length>=r){const n=this.A(c,r-c.size_left);if(o+=c.lf_left+n.index,n.index===0){const s=this.getOffsetAt(o+1,1),a=h-s;return new y.$ys(o+1,a+1)}return new y.$ys(o+1,n.remainder+1)}else if(r-=c.size_left+c.piece.length,o+=c.lf_left+c.piece.lineFeedCnt,c.right===M.$sB){const n=this.getOffsetAt(o+1,1),s=h-r-n;return new y.$ys(o+1,s+1)}else c=c.right;return new y.$ys(1,1)}getValueInRange(r,c){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return"";const o=this.H(r.startLineNumber,r.startColumn),h=this.H(r.endLineNumber,r.endColumn),n=this.getValueInRange2(o,h);return c?c!==this.d||!this.f?n.replace(/\r\n|\r|\n/g,c):c===this.getEOL()&&this.f?n:n.replace(/\r\n|\r|\n/g,c):n}getValueInRange2(r,c){if(r.node===c.node){const a=r.node,g=this.a[a.piece.bufferIndex].buffer,p=this.u(a.piece.bufferIndex,a.piece.start);return g.substring(p+r.remainder,p+c.remainder)}let o=r.node;const h=this.a[o.piece.bufferIndex].buffer,n=this.u(o.piece.bufferIndex,o.piece.start);let s=h.substring(n+r.remainder,n+o.piece.length);for(o=o.next();o!==M.$sB;){const a=this.a[o.piece.bufferIndex].buffer,g=this.u(o.piece.bufferIndex,o.piece.start);if(o===c.node){s+=a.substring(g,g+c.remainder);break}else s+=a.substr(g,o.piece.length);o=o.next()}return s}getLinesContent(){const r=[];let c=0,o="",h=!1;return this.iterate(this.root,n=>{if(n===M.$sB)return!0;const s=n.piece;let a=s.length;if(a===0)return!0;const g=this.a[s.bufferIndex].buffer,p=this.a[s.bufferIndex].lineStarts,m=s.start.line,k=s.end.line;let C=p[m]+s.start.column;if(h&&(g.charCodeAt(C)===10&&(C++,a--),r[c++]=o,o="",h=!1,a===0))return!0;if(m===k)return!this.f&&g.charCodeAt(C+a-1)===13?(h=!0,o+=g.substr(C,a-1)):o+=g.substr(C,a),!0;o+=this.f?g.substring(C,Math.max(C,p[m+1]-this.e)):g.substring(C,p[m+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;for(let u=m+1;u<k;u++)o=this.f?g.substring(p[u],p[u+1]-this.e):g.substring(p[u],p[u+1]).replace(/(\r\n|\r|\n)$/,""),r[c++]=o;return!this.f&&g.charCodeAt(p[k]+s.end.column-1)===13?(h=!0,s.end.column===0?c--:o=g.substr(p[k],s.end.column-1)):o=g.substr(p[k],s.end.column),!0}),h&&(r[c++]=o,o=""),r[c++]=o,r}getLength(){return this.c}getLineCount(){return this.b}getLineContent(r){return this.j.lineNumber===r?this.j.value:(this.j.lineNumber=r,r===this.b?this.j.value=this.getLineRawContent(r):this.f?this.j.value=this.getLineRawContent(r,this.e):this.j.value=this.getLineRawContent(r).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(r){if(r.remainder===r.node.piece.length){const c=r.node.next();if(!c)return 0;const o=this.a[c.piece.bufferIndex],h=this.u(c.piece.bufferIndex,c.piece.start);return o.buffer.charCodeAt(h)}else{const c=this.a[r.node.piece.bufferIndex],h=this.u(r.node.piece.bufferIndex,r.node.piece.start)+r.remainder;return c.buffer.charCodeAt(h)}}getLineCharCode(r,c){const o=this.H(r,c+1);return this.l(o)}getLineLength(r){if(r===this.getLineCount()){const c=this.getOffsetAt(r,1);return this.getLength()-c}return this.getOffsetAt(r+1,1)-this.getOffsetAt(r,1)-this.e}getCharCode(r){const c=this.G(r);return this.l(c)}findMatchesInNode(r,c,o,h,n,s,a,g,p,m,k){const C=this.a[r.piece.bufferIndex],u=this.u(r.piece.bufferIndex,r.piece.start),w=this.u(r.piece.bufferIndex,n),S=this.u(r.piece.bufferIndex,s);let F;const V={line:0,column:0};let J,N;c._wordSeparators?(J=C.buffer.substring(w,S),N=R=>R+w,c.reset(0)):(J=C.buffer,N=R=>R,c.reset(w));do if(F=c.next(J),F){if(N(F.index)>=S)return m;this.s(r,N(F.index)-u,V);const R=this.t(r.piece.bufferIndex,n,V),L=V.line===n.line?V.column-n.column+h:V.column+1,O=L+F[0].length;if(k[m++]=(0,A.$DB)(new T.$zs(o+R,L,o+R,O),F,g),N(F.index)+F[0].length>=S||m>=p)return m}while(F);return m}findMatchesLineByLine(r,c,o,h){const n=[];let s=0;const a=new A.$GB(c.wordSeparators,c.regex);let g=this.H(r.startLineNumber,r.startColumn);if(g===null)return[];const p=this.H(r.endLineNumber,r.endColumn);if(p===null)return[];let m=this.s(g.node,g.remainder);const k=this.s(p.node,p.remainder);if(g.node===p.node)return this.findMatchesInNode(g.node,a,r.startLineNumber,r.startColumn,m,k,c,o,h,s,n),n;let C=r.startLineNumber,u=g.node;for(;u!==p.node;){const S=this.t(u.piece.bufferIndex,m,u.piece.end);if(S>=1){const V=this.a[u.piece.bufferIndex].lineStarts,J=this.u(u.piece.bufferIndex,u.piece.start),N=V[m.line+S],R=C===r.startLineNumber?r.startColumn:1;if(s=this.findMatchesInNode(u,a,C,R,m,this.s(u,N-J),c,o,h,s,n),s>=h)return n;C+=S}const F=C===r.startLineNumber?r.startColumn-1:0;if(C===r.endLineNumber){const V=this.getLineContent(C).substring(F,r.endColumn-1);return s=this.n(c,a,V,r.endLineNumber,F,s,n,o,h),n}if(s=this.n(c,a,this.getLineContent(C).substr(F),C,F,s,n,o,h),s>=h)return n;C++,g=this.H(C,1),u=g.node,m=this.s(g.node,g.remainder)}if(C===r.endLineNumber){const S=C===r.startLineNumber?r.startColumn-1:0,F=this.getLineContent(C).substring(S,r.endColumn-1);return s=this.n(c,a,F,r.endLineNumber,S,s,n,o,h),n}const w=C===r.startLineNumber?r.startColumn:1;return s=this.findMatchesInNode(p.node,a,C,w,m,k,c,o,h,s,n),n}n(r,c,o,h,n,s,a,g,p){const m=r.wordSeparators;if(!g&&r.simpleSearch){const C=r.simpleSearch,u=C.length,w=o.length;let S=-u;for(;(S=o.indexOf(C,S+u))!==-1;)if((!m||(0,A.$FB)(m,o,w,S,u))&&(a[s++]=new P.$Qu(new T.$zs(h,S+1+n,h,S+1+u+n),null),s>=p))return s;return s}let k;c.reset(0);do if(k=c.next(o),k&&(a[s++]=(0,A.$DB)(new T.$zs(h,k.index+1+n,h,k.index+1+k[0].length+n),k,g),s>=p))return s;while(k);return s}insert(r,c,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==M.$sB){const{node:h,remainder:n,nodeStartOffset:s}=this.G(r),a=h.piece,g=a.bufferIndex,p=this.s(h,n);if(h.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&s+a.length===r&&c.length<$){this.F(h,c),this.y();return}if(s===r)this.o(c,h),this.h.validate(r);else if(s+h.piece.length>r){const m=[];let k=new l(a.bufferIndex,p,a.end,this.t(a.bufferIndex,p,a.end),this.u(g,a.end)-this.u(g,p));if(this.K()&&this.M(c)&&this.I(h,n)===10){const S={line:k.start.line+1,column:0};k=new l(k.bufferIndex,S,k.end,this.t(k.bufferIndex,S,k.end),k.length-1),c+=`
`}if(this.K()&&this.L(c))if(this.I(h,n-1)===13){const S=this.s(h,n-1);this.C(h,S),c="\r"+c,h.piece.length===0&&m.push(h)}else this.C(h,p);else this.C(h,p);const C=this.w(c);k.length>0&&this.S(h,k);let u=h;for(let w=0;w<C.length;w++)u=this.S(u,C[w]);this.v(m)}else this.q(c,h)}else{const h=this.w(c);let n=this.T(null,h[0]);for(let s=1;s<h.length;s++)n=this.S(n,h[s])}this.y()}delete(r,c){if(this.j.lineNumber=0,this.j.value="",c<=0||this.root===M.$sB)return;const o=this.G(r),h=this.G(r+c),n=o.node,s=h.node;if(n===s){const C=this.s(n,o.remainder),u=this.s(n,h.remainder);if(o.nodeStartOffset===r){if(c===n.piece.length){const w=n.next();(0,M.$xB)(this,n),this.N(w),this.y();return}this.D(n,u),this.h.validate(r),this.N(n),this.y();return}if(o.nodeStartOffset+n.piece.length===r+c){this.C(n,C),this.O(n),this.y();return}this.E(n,C,u),this.y();return}const a=[],g=this.s(n,o.remainder);this.C(n,g),this.h.validate(r),n.piece.length===0&&a.push(n);const p=this.s(s,h.remainder);this.D(s,p),s.piece.length===0&&a.push(s);const m=n.next();for(let C=m;C!==M.$sB&&C!==s;C=C.next())a.push(C);const k=n.piece.length===0?n.prev():n;this.v(a),this.O(k),this.y()}o(r,c){const o=[];if(this.K()&&this.M(r)&&this.L(c)){const s=c.piece,a={line:s.start.line+1,column:0},g=new l(s.bufferIndex,a,s.end,this.t(s.bufferIndex,a,s.end),s.length-1);c.piece=g,r+=`
`,(0,M.$zB)(this,c,-1,-1),c.piece.length===0&&o.push(c)}const h=this.w(r);let n=this.T(c,h[h.length-1]);for(let s=h.length-2;s>=0;s--)n=this.T(n,h[s]);this.N(n),this.v(o)}q(r,c){this.Q(r,c)&&(r+=`
`);const o=this.w(r),h=this.S(c,o[0]);let n=h;for(let s=1;s<o.length;s++)n=this.S(n,o[s]);this.N(h)}s(r,c,o){const h=r.piece,n=r.piece.bufferIndex,s=this.a[n].lineStarts,g=s[h.start.line]+h.start.column+c;let p=h.start.line,m=h.end.line,k=0,C=0,u=0;for(;p<=m&&(k=p+(m-p)/2|0,u=s[k],k!==m);)if(C=s[k+1],g<u)m=k-1;else if(g>=C)p=k+1;else break;return o?(o.line=k,o.column=g-u,null):{line:k,column:g-u}}t(r,c,o){if(o.column===0)return o.line-c.line;const h=this.a[r].lineStarts;if(o.line===h.length-1)return o.line-c.line;const n=h[o.line+1],s=h[o.line]+o.column;if(n>s+1)return o.line-c.line;const a=s-1;return this.a[r].buffer.charCodeAt(a)===13?o.line-c.line+1:o.line-c.line}u(r,c){return this.a[r].lineStarts[c.line]+c.column}v(r){for(let c=0;c<r.length;c++)(0,M.$xB)(this,r[c])}w(r){if(r.length>$){const m=[];for(;r.length>$;){const C=r.charCodeAt($-1);let u;C===13||C>=55296&&C<=56319?(u=r.substring(0,$-1),r=r.substring($-1)):(u=r.substring(0,$),r=r.substring($));const w=I(u);m.push(new l(this.a.length,{line:0,column:0},{line:w.length-1,column:u.length-w[w.length-1]},w.length-1,u.length)),this.a.push(new b(u,w))}const k=I(r);return m.push(new l(this.a.length,{line:0,column:0},{line:k.length-1,column:r.length-k[k.length-1]},k.length-1,r.length)),this.a.push(new b(r,k)),m}let c=this.a[0].buffer.length;const o=I(r,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===c&&c!==0&&this.L(r)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let m=0;m<o.length;m++)o[m]+=c+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+r,c+=1}else{if(c!==0)for(let m=0;m<o.length;m++)o[m]+=c;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=r}const n=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,a=n-this.a[0].lineStarts[s],g={line:s,column:a},p=new l(0,h,g,this.t(0,h,g),n-c);return this.g=g,[p]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(r,c=0){let o=this.root,h="";const n=this.h.get2(r);if(n){o=n.node;const s=this.B(o,r-n.nodeStartLineNumber-1),a=this.a[o.piece.bufferIndex].buffer,g=this.u(o.piece.bufferIndex,o.piece.start);if(n.nodeStartLineNumber+o.piece.lineFeedCnt===r)h=a.substring(g+s,g+o.piece.length);else{const p=this.B(o,r-n.nodeStartLineNumber);return a.substring(g+s,g+p-c)}}else{let s=0;const a=r;for(;o!==M.$sB;)if(o.left!==M.$sB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const g=this.B(o,r-o.lf_left-2),p=this.B(o,r-o.lf_left-1),m=this.a[o.piece.bufferIndex].buffer,k=this.u(o.piece.bufferIndex,o.piece.start);return s+=o.size_left,this.h.set({node:o,nodeStartOffset:s,nodeStartLineNumber:a-(r-1-o.lf_left)}),m.substring(k+g,k+p-c)}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const g=this.B(o,r-o.lf_left-2),p=this.a[o.piece.bufferIndex].buffer,m=this.u(o.piece.bufferIndex,o.piece.start);h=p.substring(m+g,m+o.piece.length);break}else r-=o.lf_left+o.piece.lineFeedCnt,s+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==M.$sB;){const s=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const a=this.B(o,0),g=this.u(o.piece.bufferIndex,o.piece.start);return h+=s.substring(g,g+a-c),h}else{const a=this.u(o.piece.bufferIndex,o.piece.start);h+=s.substr(a,o.piece.length)}o=o.next()}return h}y(){let r=this.root,c=1,o=0;for(;r!==M.$sB;)c+=r.lf_left+r.piece.lineFeedCnt,o+=r.size_left+r.piece.length,r=r.right;this.b=c,this.c=o,this.h.validate(this.c)}A(r,c){const o=r.piece,h=this.s(r,c),n=h.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===c){const s=this.t(r.piece.bufferIndex,o.start,h);if(s!==n)return{index:s,remainder:0}}return{index:n,remainder:h.column}}B(r,c){if(c<0)return 0;const o=r.piece,h=this.a[o.bufferIndex].lineStarts,n=o.start.line+c+1;return n>o.end.line?h[o.end.line]+o.end.column-h[o.start.line]-o.start.column:h[n]-h[o.start.line]-o.start.column}C(r,c){const o=r.piece,h=o.lineFeedCnt,n=this.u(o.bufferIndex,o.end),s=c,a=this.u(o.bufferIndex,s),g=this.t(o.bufferIndex,o.start,s),p=g-h,m=a-n,k=o.length+m;r.piece=new l(o.bufferIndex,o.start,s,g,k),(0,M.$zB)(this,r,m,p)}D(r,c){const o=r.piece,h=o.lineFeedCnt,n=this.u(o.bufferIndex,o.start),s=c,a=this.t(o.bufferIndex,s,o.end),g=this.u(o.bufferIndex,s),p=a-h,m=n-g,k=o.length+m;r.piece=new l(o.bufferIndex,s,o.end,a,k),(0,M.$zB)(this,r,m,p)}E(r,c,o){const h=r.piece,n=h.start,s=h.end,a=h.length,g=h.lineFeedCnt,p=c,m=this.t(h.bufferIndex,h.start,p),k=this.u(h.bufferIndex,c)-this.u(h.bufferIndex,n);r.piece=new l(h.bufferIndex,h.start,p,m,k),(0,M.$zB)(this,r,k-a,m-g);const C=new l(h.bufferIndex,o,s,this.t(h.bufferIndex,o,s),this.u(h.bufferIndex,s)-this.u(h.bufferIndex,o)),u=this.S(r,C);this.N(u)}F(r,c){this.Q(c,r)&&(c+=`
`);const o=this.K()&&this.L(c)&&this.M(r),h=this.a[0].buffer.length;this.a[0].buffer+=c;const n=I(c,!1);for(let u=0;u<n.length;u++)n[u]+=h;if(o){const u=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-u}}this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1));const s=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[s],g={line:s,column:a},p=r.piece.length+c.length,m=r.piece.lineFeedCnt,k=this.t(0,r.piece.start,g),C=k-m;r.piece=new l(r.piece.bufferIndex,r.piece.start,g,k,p),this.g=g,(0,M.$zB)(this,r,c.length,C)}G(r){let c=this.root;const o=this.h.get(r);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:r-o.nodeStartOffset};let h=0;for(;c!==M.$sB;)if(c.size_left>r)c=c.left;else if(c.size_left+c.piece.length>=r){h+=c.size_left;const n={node:c,remainder:r-c.size_left,nodeStartOffset:h};return this.h.set(n),n}else r-=c.size_left+c.piece.length,h+=c.size_left+c.piece.length,c=c.right;return null}H(r,c){let o=this.root,h=0;for(;o!==M.$sB;)if(o.left!==M.$sB&&o.lf_left>=r-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>r-1){const n=this.B(o,r-o.lf_left-2),s=this.B(o,r-o.lf_left-1);return h+=o.size_left,{node:o,remainder:Math.min(n+c-1,s),nodeStartOffset:h}}else if(o.lf_left+o.piece.lineFeedCnt===r-1){const n=this.B(o,r-o.lf_left-2);if(n+c-1<=o.piece.length)return{node:o,remainder:n+c-1,nodeStartOffset:h};c-=o.piece.length-n;break}else r-=o.lf_left+o.piece.lineFeedCnt,h+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==M.$sB;){if(o.piece.lineFeedCnt>0){const n=this.B(o,0),s=this.J(o);return{node:o,remainder:Math.min(c-1,n),nodeStartOffset:s}}else if(o.piece.length>=c-1){const n=this.J(o);return{node:o,remainder:c-1,nodeStartOffset:n}}else c-=o.piece.length;o=o.next()}return null}I(r,c){if(r.piece.lineFeedCnt<1)return-1;const o=this.a[r.piece.bufferIndex],h=this.u(r.piece.bufferIndex,r.piece.start)+c;return o.buffer.charCodeAt(h)}J(r){if(!r)return 0;let c=r.size_left;for(;r!==this.root;)r.parent.right===r&&(c+=r.parent.size_left+r.parent.piece.length),r=r.parent;return c}K(){return!(this.f&&this.d===`
`)}L(r){if(typeof r=="string")return r.charCodeAt(0)===10;if(r===M.$sB||r.piece.lineFeedCnt===0)return!1;const c=r.piece,o=this.a[c.bufferIndex].lineStarts,h=c.start.line,n=o[h]+c.start.column;return h===o.length-1||o[h+1]>n+1?!1:this.a[c.bufferIndex].buffer.charCodeAt(n)===10}M(r){return typeof r=="string"?r.charCodeAt(r.length-1)===13:r===M.$sB||r.piece.lineFeedCnt===0?!1:this.I(r,r.piece.length-1)===13}N(r){if(this.K()&&this.L(r)){const c=r.prev();this.M(c)&&this.P(c,r)}}O(r){if(this.K()&&this.M(r)){const c=r.next();this.L(c)&&this.P(r,c)}}P(r,c){const o=[],h=this.a[r.piece.bufferIndex].lineStarts;let n;r.piece.end.column===0?n={line:r.piece.end.line-1,column:h[r.piece.end.line]-h[r.piece.end.line-1]-1}:n={line:r.piece.end.line,column:r.piece.end.column-1};const s=r.piece.length-1,a=r.piece.lineFeedCnt-1;r.piece=new l(r.piece.bufferIndex,r.piece.start,n,a,s),(0,M.$zB)(this,r,-1,-1),r.piece.length===0&&o.push(r);const g={line:c.piece.start.line+1,column:0},p=c.piece.length-1,m=this.t(c.piece.bufferIndex,g,c.piece.end);c.piece=new l(c.piece.bufferIndex,g,c.piece.end,m,p),(0,M.$zB)(this,c,-1,-1),c.piece.length===0&&o.push(c);const k=this.w(`\r
`);this.S(r,k[0]);for(let C=0;C<o.length;C++)(0,M.$xB)(this,o[C])}Q(r,c){if(this.K()&&this.M(r)){const o=c.next();if(this.L(o)){if(r+=`
`,o.piece.length===1)(0,M.$xB)(this,o);else{const h=o.piece,n={line:h.start.line+1,column:0},s=h.length-1,a=this.t(h.bufferIndex,n,h.end);o.piece=new l(h.bufferIndex,n,h.end,a,s),(0,M.$zB)(this,o,-1,-1)}return!0}}return!1}iterate(r,c){if(r===M.$sB)return c(M.$sB);const o=this.iterate(r.left,c);return o&&c(r)&&this.iterate(r.right,c)}R(r){if(r===M.$sB)return"";const c=this.a[r.piece.bufferIndex],o=r.piece,h=this.u(o.bufferIndex,o.start),n=this.u(o.bufferIndex,o.end);return c.buffer.substring(h,n)}getPieceContent(r){const c=this.a[r.bufferIndex],o=this.u(r.bufferIndex,r.start),h=this.u(r.bufferIndex,r.end);return c.buffer.substring(o,h)}S(r,c){const o=new M.$rB(c,1);if(o.left=M.$sB,o.right=M.$sB,o.parent=M.$sB,o.size_left=0,o.lf_left=0,this.root===M.$sB)this.root=o,o.color=0;else if(r.right===M.$sB)r.right=o,o.parent=r;else{const n=(0,M.$tB)(r.right);n.left=o,o.parent=n}return(0,M.$yB)(this,o),o}T(r,c){const o=new M.$rB(c,1);if(o.left=M.$sB,o.right=M.$sB,o.parent=M.$sB,o.size_left=0,o.lf_left=0,this.root===M.$sB)this.root=o,o.color=0;else if(r.left===M.$sB)r.left=o,o.parent=r;else{const h=(0,M.$uB)(r.left);h.right=o,o.parent=h}return(0,M.$yB)(this,o),o}U(r){let c="";return this.iterate(r,o=>(c+=this.R(o),!0)),c}}e.$LB=t}),define(Pe[132],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7=e.$S7=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$S7=y;class T{constructor(M){this.identifier=M}}e.$T7=T}),define(Pe[133],Ae([9,10]),function(we,e){return we.create("vs/base/common/actions",e)}),define(Pe[134],Ae([1,0,5,6,133]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class M extends T.$Rc{constructor(l,b="",v="",f=!0,t){super(),this.h=this.B(new y.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=b,this.u=v,this.w=f,this.C=t}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,b){this.C&&await this.C(l)}}e.$Ai=M;class A extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new y.$Rd),this.onWillRun=this.f.event,this.m=this.B(new y.$Rd),this.onDidRun=this.m.event}async run(l,b){if(!l.enabled)return;this.f.fire({action:l});let v;try{await this.u(l,b)}catch(f){v=f}this.m.fire({action:l,error:v})}async u(l,b){await l.run(b)}}e.$Bi=A;class ${constructor(){this.id=$.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let b=[];for(const v of l)v.length&&(b.length?b=[...b,new $,...v]:b=v);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$Ci=$;class E{get actions(){return this.a}constructor(l,b,v,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=b,this.class=f,this.a=v}async run(){}}e.$Di=E;class d extends M{static{this.ID="vs.actions.empty"}constructor(){super(d.ID,P.localize(0,null),void 0,!1)}}e.$Ei=d;function I(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...l)=>D.run(...l),tooltip:D.label}}e.$Fi=I}),define(Pe[135],Ae([9,10]),function(we,e){return we.create("vs/base/common/date",e)}),define(Pe[136],Ae([1,0,135]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=void 0;const T=60,P=T*60,M=P*24,A=M*7,$=M*30,E=M*365;function d(D,l,b,v){typeof D!="number"&&(D=D.getTime());const f=Math.round((new Date().getTime()-D)/1e3);if(f<-30)return(0,y.localize)(0,null,d(new Date().getTime()+f*1e3,!1));if(!v&&f<30)return(0,y.localize)(1,null);let t;return f<T?(t=f,l?t===1?b?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):b?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?b?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):b?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):f<P?(t=Math.floor(f/T),l?t===1?b?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):b?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?b?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):b?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):f<M?(t=Math.floor(f/P),l?t===1?b?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):b?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?b?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):b?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):f<A?(t=Math.floor(f/M),l?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):f<$?(t=Math.floor(f/A),l?t===1?b?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):b?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?b?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):b?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):f<E?(t=Math.floor(f/$),l?t===1?b?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):b?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?b?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):b?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(f/E),l?t===1?b?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):b?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?b?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):b?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$jm=d;function I(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$km=I}),define(Pe[137],Ae([9,10]),function(we,e){return we.create("vs/base/common/errorMessage",e)}),define(Pe[39],Ae([1,0,18,16,137]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=e.$Gi=void 0;function M(D,l){return l&&(D.stack||D.stacktrace)?P.localize(0,null,$(D),A(D.stack)||A(D.stacktrace)):$(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function $(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?P.localize(1,null,D.message):D.message||P.localize(2,null)}function E(D=null,l=!1){if(!D)return P.localize(3,null);if(Array.isArray(D)){const b=y.$Gb(D),v=E(b[0],l);return b.length>1?P.localize(4,null,v,b.length):v}if(T.$Cf(D))return D;if(D.detail){const b=D.detail;if(b.error)return M(b.error,l);if(b.exception)return M(b.exception,l)}return D.stack?M(D,l):D.message?D.message:P.localize(5,null)}e.$Gi=E;function d(D){const l=D;return l instanceof Error&&Array.isArray(l.actions)}e.$Hi=d;function I(D,l){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=l,b}e.$Ii=I}),define(Pe[138],Ae([1,0,44,20]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=void 0;const P=new y.$U(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),M=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function $(C,u,w=!1){const S=C||"",F=u||"",V=P.value.collator.compare(S,F);return P.value.collatorIsNumeric&&V===0&&S!==F?S<F?-1:1:V}e.$nq=$;function E(C,u){const w=M.value.collator;return C=C||"",u=u||"",o(w,C,u)}e.$oq=E;function d(C,u){const w=M.value.collator;return C=C||"",u=u||"",a(C,u)||o(w,C,u)}e.$pq=d;function I(C,u){const w=M.value.collator;return C=C||"",u=u||"",s(C,u)||o(w,C,u)}e.$qq=I;function D(C,u){return C=C||"",u=u||"",C===u?0:C<u?-1:1}e.$rq=D;function l(C,u){const[w,S]=r(C),[F,V]=r(u);let J=P.value.collator.compare(S,V);if(J===0){if(P.value.collatorIsNumeric&&S!==V)return S<V?-1:1;if(J=P.value.collator.compare(w,F),P.value.collatorIsNumeric&&J===0&&w!==F)return w<F?-1:1}return J}e.$sq=l;function b(C,u){C=C||"",u=u||"";const w=c(C),S=c(u),F=M.value.collator,V=A.value.collator;return o(V,w,S)||o(F,C,u)}e.$tq=b;function v(C,u){C=C||"",u=u||"";const w=c(C),S=c(u),F=M.value.collator,V=A.value.collator;return o(V,w,S)||a(C,u)||o(F,C,u)}e.$uq=v;function f(C,u){C=C||"",u=u||"";const w=c(C),S=c(u),F=M.value.collator,V=A.value.collator;return o(V,w,S)||s(C,u)||o(F,C,u)}e.$vq=f;function t(C,u){C=C||"",u=u||"";const w=c(C).toLowerCase(),S=c(u).toLowerCase();return w!==S?w<S?-1:1:C!==u?C<u?-1:1:0}e.$wq=t;const i=/^(.*?)(\.([^.]*))?$/;function r(C,u=!1){const w=C?i.exec(C):[];let S=[w&&w[1]||"",w&&w[3]||""];return u&&(!S[0]&&S[1]||S[0]&&S[0].charAt(0)===".")&&(S=[S[0]+"."+S[1],""]),S}function c(C){const u=C?i.exec(C):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function o(C,u,w){const S=C.compare(u,w);return S!==0?S:u.length!==w.length?u.length<w.length?-1:1:0}function h(C){const u=C.charAt(0);return u.toLocaleUpperCase()!==u}function n(C){const u=C.charAt(0);return u.toLocaleLowerCase()!==u}function s(C,u){return h(C)&&n(u)?-1:n(C)&&h(u)?1:0}function a(C,u){return n(C)&&h(u)?-1:h(C)&&n(u)?1:0}function g(C,u,w=!1){return w||(C=C&&C.toLowerCase(),u=u&&u.toLowerCase()),C===u?0:C<u?-1:1}function p(C,u,w=!1){const S=C.split(T.sep),F=u.split(T.sep),V=S.length-1,J=F.length-1;let N,R;for(let L=0;;L++){if(N=V===L,R=J===L,N&&R)return $(S[L],F[L],w);if(N)return-1;if(R)return 1;const O=g(S[L],F[L],w);if(O!==0)return O}}e.$xq=p;function m(C,u,w){const S=C.toLowerCase(),F=u.toLowerCase(),V=k(C,u,w);if(V)return V;const J=S.endsWith(w),N=F.endsWith(w);if(J!==N)return J?-1:1;const R=$(S,F);return R!==0?R:S.localeCompare(F)}e.$yq=m;function k(C,u,w){const S=C.toLowerCase(),F=u.toLowerCase(),V=S.startsWith(w),J=F.startsWith(w);if(V!==J)return V?-1:1;if(V&&J){if(S.length<F.length)return-1;if(S.length>F.length)return 1}return 0}e.$zq=k}),define(Pe[46],Ae([1,0,20,21,12,16]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function A(m){return m===47||m===92}e.$Uf=A;function $(m){return m.replace(/[\\/]/g,y.$fc.sep)}e.$Vf=$;function E(m){return m.indexOf("/")===-1&&(m=$(m)),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m),m}e.$Wf=E;function d(m,k=y.$fc.sep){if(!m)return"";const C=m.length,u=m.charCodeAt(0);if(A(u)){if(A(m.charCodeAt(1))&&!A(m.charCodeAt(2))){let S=3;const F=S;for(;S<C&&!A(m.charCodeAt(S));S++);if(F!==S&&!A(m.charCodeAt(S+1))){for(S+=1;S<C;S++)if(A(m.charCodeAt(S)))return m.slice(0,S+1).replace(/[\\/]/g,k)}}return k}else if(i(u)&&m.charCodeAt(1)===58)return A(m.charCodeAt(2))?m.slice(0,2)+k:m.slice(0,2);let w=m.indexOf("://");if(w!==-1){for(w+=3;w<C;w++)if(A(m.charCodeAt(w)))return m.slice(0,w+1)}return""}e.$Xf=d;function I(m){if(!T.$i||!m||m.length<5)return!1;let k=m.charCodeAt(0);if(k!==92||(k=m.charCodeAt(1),k!==92))return!1;let C=2;const u=C;for(;C<m.length&&(k=m.charCodeAt(C),k!==92);C++);return!(u===C||(k=m.charCodeAt(C+1),isNaN(k)||k===92))}e.$Yf=I;const D=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(m,k=T.$i){const C=k?D:l;return!(!m||m.length===0||/^\s+$/.test(m)||(C.lastIndex=0,C.test(m))||k&&b.test(m)||m==="."||m===".."||k&&m[m.length-1]==="."||k&&m.length!==m.trim().length||m.length>255)}e.$Zf=v;function f(m,k,C){const u=m===k;return!C||u?u:!m||!k?!1:(0,P.$6e)(m,k)}e.$1f=f;function t(m,k,C,u=y.sep){if(m===k)return!0;if(!m||!k||k.length>m.length)return!1;if(C){if(!(0,P.$7e)(m,k))return!1;if(k.length===m.length)return!0;let S=k.length;return k.charAt(k.length-1)===u&&S--,m.charAt(S)===u}return k.charAt(k.length-1)!==u&&(k+=u),m.indexOf(k)===0}e.$2f=t;function i(m){return m>=65&&m<=90||m>=97&&m<=122}e.$3f=i;function r(m,k){return T.$i&&m.endsWith(":")&&(m+=y.sep),(0,y.$hc)(m)||(m=(0,y.$ic)(k,m)),m=(0,y.$gc)(m),T.$i?(m=(0,P.$Oe)(m,y.sep),m.endsWith(":")&&(m+=y.sep)):(m=(0,P.$Oe)(m,y.sep),m||(m=y.sep)),m}e.$4f=r;function c(m){const k=(0,y.$gc)(m);return T.$i?m.length>3?!1:o(k)&&(m.length===2||k.charCodeAt(2)===92):k===y.$fc.sep}e.$5f=c;function o(m,k=T.$i){return k?i(m.charCodeAt(0))&&m.charCodeAt(1)===58:!1}e.$6f=o;function h(m,k=T.$i){return o(m,k)?m[0]:void 0}e.$7f=h;function n(m,k,C){return k.length>m.length?-1:m===k?0:(C&&(m=m.toLowerCase(),k=k.toLowerCase()),m.indexOf(k))}e.$8f=n;function s(m){const k=m.split(":");let C,u,w;for(const S of k){const F=Number(S);(0,M.$Gf)(F)?u===void 0?u=F:w===void 0&&(w=F):C=C?[C,S].join(":"):S}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:u!==void 0?u:void 0,column:w!==void 0?w:u!==void 0?1:void 0}}e.$9f=s;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(m,k,C=8){let u="";for(let S=0;S<C;S++){let F;S===0&&T.$i&&!k&&(C===3||C===4)?F=g:F=a,u+=F.charAt(Math.floor(Math.random()*F.length))}let w;return k?w=`${k}-${u}`:w=u,m?(0,y.$ic)(m,w):w}e.$0f=p}),define(Pe[68],Ae([1,0,20]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.$Xr=e.$Wr=e.$Vr=void 0,e.$Vr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(I){const D=(0,y.$nc)(I),l=T[D.toLowerCase()];return l!==void 0?l:A(I)}e.$Wr=M;function A(I){const D=(0,y.$nc)(I);return P[D.toLowerCase()]}e.$Xr=A;function $(I){for(const D in P)if(P[D]===I)return D}e.$Yr=$;const E=/^(.+)\/(.+?)(;.+)?$/;function d(I,D){const l=E.exec(I);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:D?void 0:I}e.$Zr=d}),define(Pe[51],Ae([1,0,24,2]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=void 0;function P(E){return JSON.stringify(E,A)}e.$qh=P;function M(E){let d=JSON.parse(E);return d=$(d),d}e.$rh=M;function A(E,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function $(E,d=0){if(!E||d>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return T.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof y.$fe||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let I=0;I<E.length;++I)E[I]=$(E[I],d+1);else for(const I in E)Object.hasOwnProperty.call(E,I)&&(E[I]=$(E[I],d+1))}return E}e.$sh=$}),define(Pe[13],Ae([1,0,11,21,2]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var M;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$$f="vscode-tkn",e.$_f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(I){this.d=I}setDelegate(I){this.e=I}setServerRootPath(I){this.f=`${I}/${M.vscodeRemoteResource}`}set(I,D,l){this.a[I]=D,this.b[I]=l}setConnectionToken(I,D){this.c[I]=D}getPreferredWebSchema(){return this.d}rewrite(I){if(this.e)try{return this.e(I)}catch(t){return y.$Z(t),I}const D=I.authority;let l=this.a[D];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const b=this.b[D],v=this.c[D];let f=`path=${encodeURIComponent(I.path)}`;return typeof v=="string"&&(f+=`&${e.$_f}=${encodeURIComponent(v)}`),P.URI.from({scheme:T.$o?this.d:M.vscodeRemoteResource,authority:`${l}:${b}`,path:this.f,query:f})}}e.$ag=new A,e.$bg="vs/../../extensions",e.$cg="vs/../../node_modules",e.$dg="vs/../../node_modules.asar",e.$eg="vs/../../node_modules.asar.unpacked",e.$fg="vscode-app";class ${static{this.a=e.$fg}asBrowserUri(I){const D=this.b(I,we);return this.uriToBrowserUri(D)}uriToBrowserUri(I){return I.scheme===M.vscodeRemote?e.$ag.rewrite(I):I.scheme===M.file&&(T.$m||T.$q===`${M.vscodeFileResource}://${$.a}`)?I.with({scheme:M.vscodeFileResource,authority:I.authority||$.a,query:null,fragment:null}):I}asFileUri(I){const D=this.b(I,we);return this.uriToFileUri(D)}uriToFileUri(I){return I.scheme===M.vscodeFileResource?I.with({scheme:M.file,authority:I.authority!==$.a?I.authority:null,query:null,fragment:null}):I}b(I,D){return P.URI.isUri(I)?I:P.URI.parse(D.toUrl(I))}}e.$gg=new $;var E;(function(d){const I=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(I.get("3"));const D="vscode-coi";function l(v){let f;typeof v=="string"?f=new URL(v).searchParams:v instanceof URL?f=v.searchParams:P.URI.isUri(v)&&(f=new URL(v.toString(!0)).searchParams);const t=f?.get(D);if(t)return I.get(t)}d.getHeadersFromQuery=l;function b(v,f,t){if(!globalThis.crossOriginIsolated)return;const i=f&&t?"3":t?"2":"1";v instanceof URLSearchParams?v.set(D,i):v[D]=i}d.addSearchParam=b})(E||(e.COI=E={}))}),define(Pe[25],Ae([1,0,46,13,20,21,12,2]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jg=e.DataUri=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=void 0;function E(b){return(0,$.$vc)(b,!0)}e.$ng=E;class d{constructor(v){this.a=v}compare(v,f,t=!1){return v===f?0:(0,A.$Ye)(this.getComparisonKey(v,t),this.getComparisonKey(f,t))}isEqual(v,f,t=!1){return v===f?!0:!v||!f?!1:this.getComparisonKey(v,t)===this.getComparisonKey(f,t)}getComparisonKey(v,f=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,f,t=!1){if(v.scheme===f.scheme){if(v.scheme===T.Schemas.file)return y.$2f(E(v),E(f),this.a(v))&&v.query===f.query&&(t||v.fragment===f.fragment);if((0,e.$Eg)(v.authority,f.authority))return y.$2f(v.path,f.path,this.a(v),"/")&&v.query===f.query&&(t||v.fragment===f.fragment)}return!1}joinPath(v,...f){return $.URI.joinPath(v,...f)}basenameOrAuthority(v){return(0,e.$wg)(v)||v.authority}basename(v){return P.$fc.basename(v.path)}extname(v){return P.$fc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let f;return v.scheme===T.Schemas.file?f=$.URI.file(P.$lc(E(v))).path:(f=P.$fc.dirname(v.path),v.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),f="/")),v.with({path:f})}normalizePath(v){if(!v.path.length)return v;let f;return v.scheme===T.Schemas.file?f=$.URI.file(P.$gc(E(v))).path:f=P.$fc.normalize(v.path),v.with({path:f})}relativePath(v,f){if(v.scheme!==f.scheme||!(0,e.$Eg)(v.authority,f.authority))return;if(v.scheme===T.Schemas.file){const r=P.$kc(E(v),E(f));return M.$i?y.$Vf(r):r}let t=v.path||"/";const i=f.path||"/";if(this.a(v)){let r=0;for(const c=Math.min(t.length,i.length);r<c&&!(t.charCodeAt(r)!==i.charCodeAt(r)&&t.charAt(r).toLowerCase()!==i.charAt(r).toLowerCase());r++);t=i.substr(0,r)+t.substr(r)}return P.$fc.relative(t,i)}resolvePath(v,f){if(v.scheme===T.Schemas.file){const t=$.URI.file(P.$jc(E(v),f));return v.with({authority:t.authority,path:t.path})}return f=y.$Wf(f),v.with({path:P.$fc.resolve(v.path,f)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,f){return v===f||v!==void 0&&f!==void 0&&(0,A.$6e)(v,f)}hasTrailingPathSeparator(v,f=P.sep){if(v.scheme===T.Schemas.file){const t=E(v);return t.length>y.$Xf(t).length&&t[t.length-1]===f}else{const t=v.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,f=P.sep){return(0,e.$Fg)(v,f)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,f=P.sep){let t=!1;if(v.scheme===T.Schemas.file){const i=E(v);t=i!==void 0&&i.length===y.$Xf(i).length&&i[i.length-1]===f}else{f="/";const i=v.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Fg)(v,f)?v.with({path:v.path+"/"}):v}}e.$og=d,e.$pg=new d(()=>!1),e.$qg=new d(b=>b.scheme===T.Schemas.file?!M.$k:!0),e.$rg=new d(b=>!0),e.$sg=e.$pg.isEqual.bind(e.$pg),e.$tg=e.$pg.isEqualOrParent.bind(e.$pg),e.$ug=e.$pg.getComparisonKey.bind(e.$pg),e.$vg=e.$pg.basenameOrAuthority.bind(e.$pg),e.$wg=e.$pg.basename.bind(e.$pg),e.$xg=e.$pg.extname.bind(e.$pg),e.$yg=e.$pg.dirname.bind(e.$pg),e.$zg=e.$pg.joinPath.bind(e.$pg),e.$Ag=e.$pg.normalizePath.bind(e.$pg),e.$Bg=e.$pg.relativePath.bind(e.$pg),e.$Cg=e.$pg.resolvePath.bind(e.$pg),e.$Dg=e.$pg.isAbsolutePath.bind(e.$pg),e.$Eg=e.$pg.isEqualAuthority.bind(e.$pg),e.$Fg=e.$pg.hasTrailingPathSeparator.bind(e.$pg),e.$Gg=e.$pg.removeTrailingPathSeparator.bind(e.$pg),e.$Hg=e.$pg.addTrailingPathSeparator.bind(e.$pg);function I(b,v){const f=[];for(let t=0;t<b.length;t++){const i=v(b[t]);b.some((r,c)=>c===t?!1:(0,e.$tg)(i,v(r)))||f.push(b[t])}return f}e.$Ig=I;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function v(f){const t=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(c=>{const[o,h]=c.split(":");o&&h&&t.set(o,h)});const r=f.path.substring(0,f.path.indexOf(";"));return r&&t.set(b.META_DATA_MIME,r),t}b.parseMetaData=v})(D||(e.DataUri=D={}));function l(b,v,f){if(v){let t=b.path;return t&&t[0]!==P.$fc.sep&&(t=P.$fc.sep+t),b.with({scheme:f,authority:v,path:t})}return b.with({scheme:f})}e.$Jg=l}),define(Pe[14],Ae([1,0,19,11,5,6,25,21,124]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=e.$lh=e.$kh=e.$jh=e.Promises=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0;function d(pe){return!!pe&&typeof pe.then=="function"}e.$Kg=d;function I(pe){const re=new y.$2d,le=pe(re.token),ce=new Promise((ye,_)=>{const de=re.token.onCancellationRequested(()=>{de.dispose(),re.dispose(),_(new T.$4)});Promise.resolve(le).then(ie=>{de.dispose(),re.dispose(),ye(ie)},ie=>{de.dispose(),re.dispose(),_(ie)})});return new class{cancel(){re.cancel()}then(ye,_){return ce.then(ye,_)}catch(ye){return this.then(void 0,ye)}finally(ye){return ce.finally(ye)}}}e.$Lg=I;function D(pe,re,le){return new Promise((ce,ye)=>{const _=re.onCancellationRequested(()=>{_.dispose(),ce(le)});pe.then(ce,ye).finally(()=>_.dispose())})}e.$Mg=D;function l(pe,re){return new Promise((le,ce)=>{const ye=re.onCancellationRequested(()=>{ye.dispose(),ce(new T.$4)});pe.then(le,ce).finally(()=>ye.dispose())})}e.$Ng=l;async function b(pe){let re=-1;const le=pe.map((ce,ye)=>ce.then(_=>(re=ye,_)));try{return await Promise.race(le)}finally{pe.forEach((ce,ye)=>{ye!==re&&ce.cancel()})}}e.$Og=b;function v(pe,re,le){let ce;const ye=setTimeout(()=>{ce?.(void 0),le?.()},re);return Promise.race([pe.finally(()=>clearTimeout(ye)),new Promise(_=>ce=_)])}e.$Pg=v;function f(pe){return new Promise((re,le)=>{const ce=pe();d(ce)?ce.then(re,le):re(ce)})}e.$Qg=f;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(re){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=re,!this.b){const le=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(le,le).then(ce)})}return new Promise((le,ce)=>{this.b.then(le,ce)})}return this.a=re(),new Promise((le,ce)=>{this.a.then(ye=>{this.a=null,le(ye)},ye=>{this.a=null,ce(ye)})})}dispose(){this.f=!0}}e.$Rg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(re){return this.a=this.a.then(()=>re(),()=>re())}}e.$Sg=i;class r{constructor(){this.a=new Map}queue(re,le){const ye=(this.a.get(re)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(re)===ye&&this.a.delete(re)});return this.a.set(re,ye),ye}}e.$Tg=r;const c=(pe,re)=>{let le=!0;const ce=setTimeout(()=>{le=!1,re()},pe);return{isTriggered:()=>le,dispose:()=>{clearTimeout(ce),le=!1}}},o=pe=>{let re=!0;return queueMicrotask(()=>{re&&(re=!1,pe())}),{isTriggered:()=>re,dispose:()=>{re=!1}}};class h{constructor(re){this.defaultDelay=re,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(re,le=this.defaultDelay){this.g=re,this.h(),this.b||(this.b=new Promise((ye,_)=>{this.d=ye,this.f=_}).then(()=>{if(this.b=null,this.d=null,this.g){const ye=this.g;return this.g=null,ye()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=le===E.$Od?o(ce):c(le,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ug=h;class n{constructor(re){this.a=new h(re),this.b=new t}trigger(re,le){return this.a.trigger(()=>this.b.queue(re),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Vg=n;class s{constructor(){this.a=!1,this.b=new Promise((re,le)=>{this.d=re})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Wg=s;class a extends s{constructor(re){super(),this.f=setTimeout(()=>this.open(),re)}open(){clearTimeout(this.f),super.open()}}e.$Xg=a;function g(pe,re){return re?new Promise((le,ce)=>{const ye=setTimeout(()=>{_.dispose(),le()},pe),_=re.onCancellationRequested(()=>{clearTimeout(ye),_.dispose(),ce(new T.$4)})}):I(le=>g(pe,le))}e.$Yg=g;function p(pe,re=0,le){const ce=setTimeout(()=>{pe(),le&&ye.dispose()},re),ye=(0,M.$Pc)(()=>{clearTimeout(ce),le?.deleteAndLeak(ye)});return le?.add(ye),ye}e.$Zg=p;function m(pe){const re=[];let le=0;const ce=pe.length;function ye(){return le<ce?pe[le++]():null}function _(de){de!=null&&re.push(de);const ie=ye();return ie?ie.then(_):Promise.resolve(re)}return Promise.resolve(null).then(_)}e.$1g=m;function k(pe,re=ce=>!!ce,le=null){let ce=0;const ye=pe.length,_=()=>{if(ce>=ye)return Promise.resolve(le);const de=pe[ce++];return Promise.resolve(de()).then(ae=>re(ae)?Promise.resolve(ae):_())};return _()}e.$2g=k;function C(pe,re=ce=>!!ce,le=null){if(pe.length===0)return Promise.resolve(le);let ce=pe.length;const ye=()=>{ce=-1;for(const _ of pe)_.cancel?.()};return new Promise((_,de)=>{for(const ie of pe)ie.then(ae=>{--ce>=0&&re(ae)?(ye(),_(ae)):ce===0&&_(le)}).catch(ae=>{--ce>=0&&(ye(),de(ae))})})}e.$3g=C;class u{constructor(re){this.a=0,this.d=re,this.f=[],this.b=0,this.g=new P.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(re){return this.a++,new Promise((le,ce)=>{this.f.push({factory:re,c:le,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const re=this.f.shift();this.b++;const le=re.factory();le.then(re.c,re.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$4g=u;class w extends u{constructor(){super(1)}}e.$5g=w;class S{constructor(){this.a=new De,this.b=0}queue(re){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,re())):this.a.run(this.b++,re())}}e.$6g=S;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const re=new ve;return this.b.add(re),re.p}g(){for(const[,re]of this.a)if(re.size>0)return!1;return!0}queueFor(re,le=A.$pg){const ce=le.getComparisonKey(re);let ye=this.a.get(ce);if(!ye){ye=new w;const _=this.f++,de=P.Event.once(ye.onDrained)(()=>{ye?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(_),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(_,de),this.a.set(ce,ye)}return ye}h(){this.g()&&this.j()}j(){for(const re of this.b)re.complete();this.b.clear()}dispose(){for(const[,re]of this.a)re.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$7g=F;class V{constructor(re,le){this.a=-1,typeof re=="function"&&typeof le=="number"&&this.setIfNotSet(re,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(re,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,re()},le)}setIfNotSet(re,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,re()},le))}}e.$8g=V;class J{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(re,le,ce=globalThis){this.cancel();const ye=ce.setInterval(()=>{re()},le);this.d=(0,M.$Pc)(()=>{ce.clearInterval(ye),this.d=void 0})}dispose(){this.cancel()}}e.$9g=J;class N{constructor(re,le){this.b=-1,this.a=re,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(re=this.d){this.cancel(),this.b=setTimeout(this.f,re)}get delay(){return this.d}set delay(re){this.d=re}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$0g=N;class R{constructor(re,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=re,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(re=this.b){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(re/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$$g=R;class L extends N{constructor(re,le){super(re,le),this.j=[]}work(re){this.j.push(re),this.isScheduled()||this.schedule()}h(){const re=this.j;this.j=[],this.a?.(re)}dispose(){this.j=[],super.dispose()}}e.$_g=L;class O extends M.$Rc{constructor(re,le){super(),this.g=re,this.h=le,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(re){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+re.length>this.g.maxBufferedWork)return!1}else if(this.pending+re.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of re)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ah=O,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ch=(pe,re)=>{(0,$.$B)(()=>{if(le)return;const ce=Date.now()+15;re(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let le=!1;return{dispose(){le||(le=!0)}}}:e.$ch=(pe,re,le)=>{const ce=pe.requestIdleCallback(re,typeof le=="number"?{timeout:le}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,pe.cancelIdleCallback(ce))}}},e.$bh=pe=>(0,e.$ch)(globalThis,pe)}();class Z{constructor(re,le){this.g=!1,this.d=()=>{try{this.j=le()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$ch)(re,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$dh=Z;class he extends Z{constructor(re){super(globalThis,re)}}e.$eh=he;async function $e(pe,re,le){let ce;for(let ye=0;ye<le;ye++)try{return await pe()}catch(_){ce=_,await g(re)}throw ce}e.$fh=$e;class De{isRunning(re){return typeof re=="number"?this.a?.taskId===re:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(re,le,ce){return this.a={taskId:re,cancel:()=>ce?.(),promise:le},le.then(()=>this.d(re),()=>this.d(re)),le}d(re){this.a&&re===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const re=this.b;this.b=void 0,re.run().then(re.promiseResolve,re.promiseReject)}}queue(re){if(this.b)this.b.run=re;else{let le,ce;const ye=new Promise((_,de)=>{le=_,ce=de});this.b={run:re,promise:ye,promiseResolve:le,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$gh=De;class ke{constructor(re,le=()=>Date.now()){this.d=re,this.f=le,this.a=0,this.b=0}increment(){const re=this.f();return re-this.a>this.d&&(this.a=re,this.b=0),this.b++,this.b}}e.$hh=ke;var fe;(function(pe){pe[pe.Resolved=0]="Resolved",pe[pe.Rejected=1]="Rejected"})(fe||(fe={}));class ve{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((re,le)=>{this.a=re,this.b=le})}complete(re){return new Promise(le=>{this.a(re),this.d={outcome:0,value:re},le()})}error(re){return new Promise(le=>{this.b(re),this.d={outcome:1,value:re},le()})}cancel(){return this.error(new T.$4)}}e.$ih=ve;var te;(function(pe){async function re(ce){let ye;const _=await Promise.all(ce.map(de=>de.then(ie=>ie,ie=>{ye||(ye=ie)})));if(typeof ye<"u")throw ye;return _}pe.settled=re;function le(ce){return new Promise(async(ye,_)=>{try{await ce(ye,_)}catch(de){_(de)}})}pe.withAsyncBody=le})(te||(e.Promises=te={}));var Re;(function(pe){pe[pe.Initial=0]="Initial",pe[pe.DoneOK=1]="DoneOK",pe[pe.DoneError=2]="DoneError"})(Re||(Re={}));class se{static fromArray(re){return new se(le=>{le.emitMany(re)})}static fromPromise(re){return new se(async le=>{le.emitMany(await re)})}static fromPromises(re){return new se(async le=>{await Promise.all(re.map(async ce=>le.emitOne(await ce)))})}static merge(re){return new se(async le=>{await Promise.all(re.map(async ce=>{for await(const ye of ce)le.emitOne(ye)}))})}static{this.EMPTY=se.fromArray([])}constructor(re){this.a=0,this.b=[],this.d=null,this.f=new P.$Rd,queueMicrotask(async()=>{const le={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(re(le)),this.j()}catch(ce){this.k(ce)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let re=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(re<this.b.length)return{done:!1,value:this.b[re++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(re,le){return new se(async ce=>{for await(const ye of re)ce.emitOne(le(ye))})}map(re){return se.map(this,re)}static filter(re,le){return new se(async ce=>{for await(const ye of re)le(ye)&&ce.emitOne(ye)})}filter(re){return se.filter(this,re)}static coalesce(re){return se.filter(re,le=>!!le)}coalesce(){return se.coalesce(this)}static async toPromise(re){const le=[];for await(const ce of re)le.push(ce);return le}toPromise(){return se.toPromise(this)}g(re){this.a===0&&(this.b.push(re),this.f.fire())}h(re){this.a===0&&(this.b=this.b.concat(re),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(re){this.a===0&&(this.a=2,this.d=re,this.f.fire())}}e.$jh=se;class Y extends se{constructor(re,le){super(le),this.l=re}cancel(){this.l.cancel()}}e.$kh=Y;function B(pe){const re=new y.$2d,le=pe(re.token);return new Y(re,async ce=>{const ye=re.token.onCancellationRequested(()=>{ye.dispose(),re.dispose(),ce.reject(new T.$4)});try{for await(const _ of le){if(re.token.isCancellationRequested)return;ce.emitOne(_)}ye.dispose(),re.dispose()}catch(_){ye.dispose(),re.dispose(),ce.reject(_)}})}e.$lh=B;class ne{constructor(){this.a=new ve,this.b=new se(ce=>{if(re){ce.reject(re);return}return le&&ce.emitMany(le),this.d=ye=>ce.reject(ye),this.f=ye=>ce.emitOne(ye),this.a.p});let re,le;this.f=ce=>{le||(le=[]),le.push(ce)},this.d=ce=>{re||(re=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(re){this.d(re),this.a.complete()}emitOne(re){this.f(re)}}e.$mh=ne}),define(Pe[34],Ae([1,0,18,14,46,28,20,21,12]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=void 0;function d(){return Object.create(null)}e.$xj=d,e.$yj="**",e.$zj="/";const I="[/\\\\]",D="[^/\\\\]",l=/\//g;function b($e,De){switch($e){case 0:return"";case 1:return`${D}*?`;default:return`(?:${I}|${D}+${I}${De?`|${I}${D}+`:""})*?`}}function v($e,De){if(!$e)return[];const ke=[];let fe=!1,ve=!1,te="";for(const Re of $e){switch(Re){case De:if(!fe&&!ve){ke.push(te),te="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}te+=Re}return te&&ke.push(te),ke}e.$Aj=v;function f($e){if(!$e)return"";let De="";const ke=v($e,e.$zj);if(ke.every(fe=>fe===e.$yj))De=".*";else{let fe=!1;ke.forEach((ve,te)=>{if(ve===e.$yj){if(fe)return;De+=b(2,te===ke.length-1)}else{let Re=!1,se="",Y=!1,B="";for(const ne of ve){if(ne!=="}"&&Re){se+=ne;continue}if(Y&&(ne!=="]"||!B)){let pe;ne==="-"?pe=ne:(ne==="^"||ne==="!")&&!B?pe="^":ne===e.$zj?pe="":pe=(0,E.$Je)(ne),B+=pe;continue}switch(ne){case"{":Re=!0;continue;case"[":Y=!0;continue;case"}":{const re=`(?:${v(se,",").map(le=>f(le)).join("|")})`;De+=re,Re=!1,se="";break}case"]":{De+="["+B+"]",Y=!1,B="";break}case"?":De+=D;continue;case"*":De+=b(1);continue;default:De+=(0,E.$Je)(ne)}}te<ke.length-1&&(ke[te+1]!==e.$yj||te+2<ke.length)&&(De+=I)}fe=ve===e.$yj})}return De}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.$Cc(1e4),s=function(){return!1},a=function(){return null};function g($e,De){if(!$e)return a;let ke;typeof $e!="string"?ke=$e.pattern:ke=$e,ke=ke.trim();const fe=`${ke}_${!!De.trimForExclusions}`;let ve=n.get(fe);if(ve)return p(ve,$e);let te;return t.test(ke)?ve=k(ke.substr(4),ke):(te=i.exec(m(ke,De)))?ve=C(te[1],ke):(De.trimForExclusions?c:r).test(ke)?ve=u(ke,De):(te=o.exec(m(ke,De)))?ve=w(te[1].substr(1),ke,!0):(te=h.exec(m(ke,De)))?ve=w(te[1],ke,!1):ve=S(ke),n.set(fe,ve),p(ve,$e)}function p($e,De){if(typeof De=="string")return $e;const ke=function(fe,ve){return(0,P.$2f)(fe,De.base,!$.$k)?$e((0,E.$Ne)(fe.substr(De.base.length),A.sep),ve):null};return ke.allBasenames=$e.allBasenames,ke.allPaths=$e.allPaths,ke.basenames=$e.basenames,ke.patterns=$e.patterns,ke}function m($e,De){return De.trimForExclusions&&$e.endsWith("/**")?$e.substr(0,$e.length-2):$e}function k($e,De){return function(ke,fe){return typeof ke=="string"&&ke.endsWith($e)?De:null}}function C($e,De){const ke=`/${$e}`,fe=`\\${$e}`,ve=function(Re,se){return typeof Re!="string"?null:se?se===$e?De:null:Re===$e||Re.endsWith(ke)||Re.endsWith(fe)?De:null},te=[$e];return ve.basenames=te,ve.patterns=[De],ve.allBasenames=te,ve}function u($e,De){const ke=Z($e.slice(1,-1).split(",").map(se=>g(se,De)).filter(se=>se!==a),$e),fe=ke.length;if(!fe)return a;if(fe===1)return ke[0];const ve=function(se,Y){for(let B=0,ne=ke.length;B<ne;B++)if(ke[B](se,Y))return $e;return null},te=ke.find(se=>!!se.allBasenames);te&&(ve.allBasenames=te.allBasenames);const Re=ke.reduce((se,Y)=>Y.allPaths?se.concat(Y.allPaths):se,[]);return Re.length&&(ve.allPaths=Re),ve}function w($e,De,ke){const fe=A.sep===A.$fc.sep,ve=fe?$e:$e.replace(l,A.sep),te=A.sep+ve,Re=A.$fc.sep+$e;let se;return ke?se=function(Y,B){return typeof Y=="string"&&(Y===ve||Y.endsWith(te)||!fe&&(Y===$e||Y.endsWith(Re)))?De:null}:se=function(Y,B){return typeof Y=="string"&&(Y===ve||!fe&&Y===$e)?De:null},se.allPaths=[(ke?"*/":"./")+$e],se}function S($e){try{const De=new RegExp(`^${f($e)}$`);return function(ke){return De.lastIndex=0,typeof ke=="string"&&De.test(ke)?$e:null}}catch{return a}}function F($e,De,ke){return!$e||typeof De!="string"?!1:V($e)(De,void 0,ke)}e.$Bj=F;function V($e,De={}){if(!$e)return s;if(typeof $e=="string"||J($e)){const ke=g($e,De);if(ke===a)return s;const fe=function(ve,te){return!!ke(ve,te)};return ke.allBasenames&&(fe.allBasenames=ke.allBasenames),ke.allPaths&&(fe.allPaths=ke.allPaths),fe}return L($e,De)}e.$Cj=V;function J($e){const De=$e;return De?typeof De.base=="string"&&typeof De.pattern=="string":!1}e.$Dj=J;function N($e){return $e.allBasenames||[]}e.$Ej=N;function R($e){return $e.allPaths||[]}e.$Fj=R;function L($e,De){const ke=Z(Object.getOwnPropertyNames($e).map(se=>O(se,$e[se],De)).filter(se=>se!==a)),fe=ke.length;if(!fe)return a;if(!ke.some(se=>!!se.requiresSiblings)){if(fe===1)return ke[0];const se=function(ne,pe){let re;for(let le=0,ce=ke.length;le<ce;le++){const ye=ke[le](ne,pe);if(typeof ye=="string")return ye;(0,T.$Kg)(ye)&&(re||(re=[]),re.push(ye))}return re?(async()=>{for(const le of re){const ce=await le;if(typeof ce=="string")return ce}return null})():null},Y=ke.find(ne=>!!ne.allBasenames);Y&&(se.allBasenames=Y.allBasenames);const B=ke.reduce((ne,pe)=>pe.allPaths?ne.concat(pe.allPaths):ne,[]);return B.length&&(se.allPaths=B),se}const ve=function(se,Y,B){let ne,pe;for(let re=0,le=ke.length;re<le;re++){const ce=ke[re];ce.requiresSiblings&&B&&(Y||(Y=(0,A.$mc)(se)),ne||(ne=Y.substr(0,Y.length-(0,A.$nc)(se).length)));const ye=ce(se,Y,ne,B);if(typeof ye=="string")return ye;(0,T.$Kg)(ye)&&(pe||(pe=[]),pe.push(ye))}return pe?(async()=>{for(const re of pe){const le=await re;if(typeof le=="string")return le}return null})():null},te=ke.find(se=>!!se.allBasenames);te&&(ve.allBasenames=te.allBasenames);const Re=ke.reduce((se,Y)=>Y.allPaths?se.concat(Y.allPaths):se,[]);return Re.length&&(ve.allPaths=Re),ve}function O($e,De,ke){if(De===!1)return a;const fe=g($e,ke);if(fe===a)return a;if(typeof De=="boolean")return fe;if(De){const ve=De.when;if(typeof ve=="string"){const te=(Re,se,Y,B)=>{if(!B||!fe(Re,se))return null;const ne=ve.replace("$(basename)",()=>Y),pe=B(ne);return(0,T.$Kg)(pe)?pe.then(re=>re?$e:null):pe?$e:null};return te.requiresSiblings=!0,te}}return fe}function Z($e,De){const ke=$e.filter(se=>!!se.basenames);if(ke.length<2)return $e;const fe=ke.reduce((se,Y)=>{const B=Y.basenames;return B?se.concat(B):se},[]);let ve;if(De){ve=[];for(let se=0,Y=fe.length;se<Y;se++)ve.push(De)}else ve=ke.reduce((se,Y)=>{const B=Y.patterns;return B?se.concat(B):se},[]);const te=function(se,Y){if(typeof se!="string")return null;if(!Y){let ne;for(ne=se.length;ne>0;ne--){const pe=se.charCodeAt(ne-1);if(pe===47||pe===92)break}Y=se.substr(ne)}const B=fe.indexOf(Y);return B!==-1?ve[B]:null};te.basenames=fe,te.patterns=ve,te.allBasenames=fe;const Re=$e.filter(se=>!se.basenames);return Re.push(te),Re}function he($e,De){return(0,y.$tb)($e,De,(ke,fe)=>typeof ke=="string"&&typeof fe=="string"?ke===fe:typeof ke!="string"&&typeof fe!="string"?ke.base===fe.base&&ke.pattern===fe.pattern:!1)}e.$Gj=he}),define(Pe[52],Ae([1,0,11,125,25,12,2]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.MarkdownStringTextNewlineStyle=void 0;var $;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})($||(e.MarkdownStringTextNewlineStyle=$={}));class E{constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$6)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=l(this.supportThemeIcons?(0,T.$3j)(i):i).replace(/([ \t]+)/g,(c,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=r,this.value+="\n```\n",this}appendLink(i,r,c){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,r){const c=new RegExp((0,M.$Je)(r),"g");return i.replace(c,(o,h)=>i.charAt(h-1)!=="\\"?`\\${o}`:o)}}e.$9j=E;function d(t){return I(t)?!t.value:Array.isArray(t)?t.every(d):!0}e.$0j=d;function I(t){return t instanceof E?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$$j=I;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,P.$sg)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$_j=D;function l(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ak=l;function b(t){return t.replace(/"/g,"&quot;")}e.$bk=b;function v(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ck=v;function f(t){const i=[],r=t.split("|").map(o=>o.trim());t=r[0];const c=r[1];if(c){const o=/height=(\d+)/.exec(c),h=/width=(\d+)/.exec(c),n=o?o[1]:"",s=h?h[1]:"",a=isFinite(parseInt(s)),g=isFinite(parseInt(n));a&&i.push(`width="${s}"`),g&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$dk=f}),define(Pe[94],Ae([1,0,18,46,20,21,25,12]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=void 0;function E(g,p){const{os:m,tildify:k,relative:C}=p;if(C){const S=d(g,C,m);if(typeof S=="string")return S}let u=g.fsPath;if(m===1&&!M.$i?u=u.replace(/\//g,"\\"):m!==1&&M.$i&&(u=u.replace(/\\/g,"/")),m!==1&&k?.userHome){const S=k.userHome.fsPath;let F;g.scheme!==k.userHome.scheme&&g.path[0]===P.$fc.sep&&g.path[1]!==P.$fc.sep?F=k.userHome.with({path:g.path}).fsPath:F=u,u=l(F,S,m)}return(m===1?P.$ec:P.$fc).normalize(I(u,m===1))}e.$yv=E;function d(g,p,m){const k=m===1?P.$ec:P.$fc,C=m===3?A.$pg:A.$rg,u=p.getWorkspace(),w=(0,y.$Nb)(u.folders);if(!w)return;g.scheme!==w.uri.scheme&&g.path[0]===P.$fc.sep&&g.path[1]!==P.$fc.sep&&(g=w.uri.with({path:g.path}));const S=p.getWorkspaceFolder(g);if(!S)return;let F;if(C.isEqual(S.uri,g)?F="":F=C.relativePath(S.uri,g)??"",F&&(F=k.normalize(F)),u.folders.length>1&&!p.noPrefix){const V=S.name?S.name:C.basenameOrAuthority(S.uri);F=F?`${V} \u2022 ${F}`:V}return F}function I(g,p=M.$i){return(0,T.$6f)(g,p)?g.charAt(0).toUpperCase()+g.slice(1):g}e.$zv=I;let D=Object.create(null);function l(g,p,m=M.OS){if(m===1||!g||!p)return g;let k=D.original===p?D.normalized:void 0;k||(k=p,M.$i&&(k=(0,T.$Vf)(k)),k=`${(0,$.$Oe)(k,P.$fc.sep)}${P.$fc.sep}`,D={original:p,normalized:k});let C=g;return M.$i&&(C=(0,T.$Vf)(C)),(m===3?C.startsWith(k):(0,$.$7e)(C,k))?`~/${C.substr(k.length)}`:g}e.$Av=l;function b(g,p){return g.replace(/^~($|\/|\\)/,`${p}$1`)}e.$Bv=b;const v="\u2026",f="\\\\",t="~";function i(g,p=P.sep){const m=new Array(g.length);let k=!1;for(let C=0;C<g.length;C++){const u=g[C];if(u===""){m[C]=`.${p}`;continue}if(!u){m[C]=u;continue}k=!0;let w="",S=u;S.indexOf(f)===0?(w=S.substr(0,S.indexOf(f)+f.length),S=S.substr(S.indexOf(f)+f.length)):S.indexOf(p)===0?(w=S.substr(0,S.indexOf(p)+p.length),S=S.substr(S.indexOf(p)+p.length)):S.indexOf(t)===0&&(w=S.substr(0,S.indexOf(t)+t.length),S=S.substr(S.indexOf(t)+t.length));const F=S.split(p);for(let V=1;k&&V<=F.length;V++)for(let J=F.length-V;k&&J>=0;J--){k=!1;let N=F.slice(J,J+V).join(p);for(let R=0;!k&&R<g.length;R++)if(R!==C&&g[R]&&g[R].indexOf(N)>-1){const L=J+V===F.length,O=J>0&&g[R].indexOf(p)>-1?p+N:N,Z=g[R].endsWith(O);k=!L||Z}if(!k){let R="";(F[0].endsWith(":")||w!=="")&&(J===1&&(J=0,V++,N=F[0]+p+N),J>0&&(R=F[0]+p),R=w+R),J>0&&(R=R+v+p),R=R+N,J+V<F.length&&(R=R+p+v),m[C]=R}}k&&(m[C]=u)}return m}e.$Cv=i;var r;(function(g){g[g.TEXT=0]="TEXT",g[g.VARIABLE=1]="VARIABLE",g[g.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function c(g,p=Object.create(null)){const m=[];let k=!1,C="";for(const u of g)if(u==="$"||k&&u==="{")C&&m.push({value:C,type:r.TEXT}),C="",k=!0;else if(u==="}"&&k){const w=p[C];if(typeof w=="string")w.length&&m.push({value:w,type:r.VARIABLE});else if(w){const S=m[m.length-1];(!S||S.type!==r.SEPARATOR)&&m.push({value:w.label,type:r.SEPARATOR})}C="",k=!1}else C+=u;return C&&!k&&m.push({value:C,type:r.TEXT}),m.filter((u,w)=>{if(u.type===r.SEPARATOR){const S=m[w-1],F=m[w+1];return[S,F].every(V=>V&&(V.type===r.VARIABLE||V.type===r.TEXT)&&V.value.length>0)}return!0}).map(u=>u.value).join("")}e.$Dv=c;function o(g,p){return M.$j||p?g.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):g.replace(/&&|&/g,m=>m==="&"?"&&":"&")}e.$Ev=o;function h(g,p){return M.$j||p?g.replace(/\(&&\w\)|&&/g,""):M.$i?g.replace(/&&|&/g,m=>m==="&"?"&&":"&"):g.replace(/&&/g,"_")}e.$Fv=h;function n(g){return g.replace(/&/g,"&&")}e.$Gv=n;function s(g){if(g.endsWith("]")){const p=g.lastIndexOf(" [",g.length-2);if(p!==-1){const m=a(g.substring(0,p));return{name:m.name,parentPath:m.parentPath+g.substring(p)}}}return a(g)}e.$Hv=s;function a(g){const p=g.indexOf("/")!==-1?P.$fc:P.$ec,m=p.basename(g),k=p.dirname(g);return m.length?{name:m,parentPath:k}:{name:k,parentPath:""}}}),define(Pe[139],Ae([1,0,24,2]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0;function P(D){return D.toJSON()}class M{constructor(l){this.a=l}transformIncoming(l){const b=this.a.transformIncoming(l);return b===l?l:P(T.URI.from(b))}transformOutgoing(l){const b=this.a.transformOutgoing(l);return b===l?l:P(T.URI.from(b))}transformOutgoingURI(l){const b=this.a.transformOutgoing(l);return b===l?l:T.URI.from(b)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Rm=M,e.$Sm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,l,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof T.URI)return l.transformOutgoing(D);for(const v in D)if(Object.hasOwnProperty.call(D,v)){const f=A(D[v],l,b+1);f!==null&&(D[v]=f)}}return null}function $(D,l){const b=A(D,l,0);return b===null?D:b}e.$Tm=$;function E(D,l,b,v){if(!D||v>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?T.URI.revive(l.transformIncoming(D)):l.transformIncoming(D);if(D instanceof y.$fe)return null;for(const f in D)if(Object.hasOwnProperty.call(D,f)){const t=E(D[f],l,b,v+1);t!==null&&(D[f]=t)}}return null}function d(D,l){const b=E(D,l,!1,0);return b===null?D:b}e.$Um=d;function I(D,l){const b=E(D,l,!0,0);return b===null?D:b}e.$Vm=I}),define(Pe[140],Ae([1,0,12,21,24]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=e.$Rs=void 0;let M;function A(){return M||(M=new TextDecoder("UTF-16LE")),M}let $;function E(){return $||($=new TextDecoder("UTF-16BE")),$}let d;function I(){return d||(d=T.$D()?A():E()),d}e.$Rs=I;function D(v,f,t){const i=new Uint16Array(v.buffer,f,t);return t>0&&(i[0]===65279||i[0]===65534)?l(v,f,t):A().decode(i)}e.$Ss=D;function l(v,f,t){const i=[];let r=0;for(let c=0;c<t;c++){const o=P.$he(v,f);f+=2,i[r++]=String.fromCharCode(o)}return i.join("")}class b{constructor(f){this.a=f|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const f=new Uint16Array(this.b.buffer,0,this.d);return I().decode(f)}f(){const f=this.e();this.d=0,this.c===null?this.c=[f]:this.c[this.c.length]=f}appendCharCode(f){const t=this.a-this.d;t<=1&&(t===0||y.$0e(f))&&this.f(),this.b[this.d++]=f}appendASCIICharCode(f){this.d===this.a&&this.f(),this.b[this.d++]=f}appendString(f){const t=f.length;if(this.d+t>=this.a){this.f(),this.c[this.c.length]=f;return}for(let i=0;i<t;i++)this.b[this.d++]=f.charCodeAt(i)}}e.$Ts=b}),define(Pe[141],Ae([1,0,24,140]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=e.$Us=void 0;function P(E){return E.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(d,I,D,l){this.oldPosition=d,this.oldText=I,this.newPosition=D,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(d){return 4+2*d.length}static c(d,I,D){const l=I.length;y.$ke(d,l,D),D+=4;for(let b=0;b<l;b++)y.$ie(d,I.charCodeAt(b),D),D+=2;return D}static d(d,I){const D=y.$je(d,I);return I+=4,(0,T.$Ss)(d,I,D)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(d,I){return y.$ke(d,this.oldPosition,I),I+=4,y.$ke(d,this.newPosition,I),I+=4,I=M.c(d,this.oldText,I),I=M.c(d,this.newText,I),I}static read(d,I,D){const l=y.$je(d,I);I+=4;const b=y.$je(d,I);I+=4;const v=M.d(d,I);I+=M.a(v);const f=M.d(d,I);return I+=M.a(f),D.push(new M(l,v,b,f)),I}}e.$Us=M;function A(E,d){return E===null||E.length===0?d:new $(E,d).compress()}e.$Vs=A;class ${constructor(d,I){this.a=d,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let d=0,I=0,D=this.n(d),l=this.l(I);for(;d<this.f||I<this.h;){if(D===null){this.k(l),l=this.l(++I);continue}if(l===null){this.m(D),D=this.n(++d);continue}if(l.oldEnd<=D.newPosition){this.k(l),l=this.l(++I);continue}if(D.newEnd<=l.oldPosition){this.m(D),D=this.n(++d);continue}if(l.oldPosition<D.newPosition){const[i,r]=$.r(l,D.newPosition-l.oldPosition);this.k(i),l=r;continue}if(D.newPosition<l.oldPosition){const[i,r]=$.q(D,l.oldPosition-D.newPosition);this.m(i),D=r;continue}let f,t;if(l.oldEnd===D.newEnd)f=D,t=l,D=this.n(++d),l=this.l(++I);else if(l.oldEnd<D.newEnd){const[i,r]=$.q(D,l.oldLength);f=i,t=l,D=r,l=this.l(++I)}else{const[i,r]=$.r(l,D.newLength);f=D,t=i,D=this.n(++d),l=r}this.d[this.e++]=new M(f.oldPosition,f.oldText,t.newPosition,t.newText),this.g+=f.newLength-f.oldLength,this.j+=t.newLength-t.oldLength}const b=$.s(this.d);return $.t(b)}k(d){this.d[this.e++]=$.o(this.g,d),this.j+=d.newLength-d.oldLength}l(d){return d<this.h?this.c[d]:null}m(d){this.d[this.e++]=$.p(this.j,d),this.g+=d.newLength-d.oldLength}n(d){return d<this.f?this.a[d]:null}static o(d,I){return new M(I.oldPosition-d,I.oldText,I.newPosition,I.newText)}static p(d,I){return new M(I.oldPosition,I.oldText,I.newPosition+d,I.newText)}static q(d,I){const D=d.newText.substr(0,I),l=d.newText.substr(I);return[new M(d.oldPosition,d.oldText,d.newPosition,D),new M(d.oldEnd,"",d.newPosition+I,l)]}static r(d,I){const D=d.oldText.substr(0,I),l=d.oldText.substr(I);return[new M(d.oldPosition,D,d.newPosition,d.newText),new M(d.oldPosition+I,l,d.newEnd,"")]}static s(d){if(d.length===0)return d;const I=[];let D=0,l=d[0];for(let b=1;b<d.length;b++){const v=d[b];l.oldEnd===v.oldPosition?l=new M(l.oldPosition,l.oldText+v.oldText,l.newPosition,l.newText+v.newText):(I[D++]=l,l=v)}return I[D++]=l,I}static t(d){if(d.length===0)return d;const I=[];let D=0;for(let l=0;l<d.length;l++){const b=d[l];b.oldText!==b.newText&&(I[D++]=b)}return I}}}),define(Pe[142],Ae([1,0,34,20]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LE=void 0;function P(M,A,$,E,d,I){if(Array.isArray(M)){let D=0;for(const l of M){const b=P(l,A,$,E,d,I);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof M=="string")return E?M==="*"?5:M===$?10:0:0;if(M){const{language:D,pattern:l,scheme:b,hasAccessToAllModels:v,notebookType:f}=M;if(!E&&!v)return 0;f&&d&&(A=d);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(D)if(D===$)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(f)if(f===I)t=10;else if(f==="*"&&I!==void 0)t=Math.max(t,5);else return 0;if(l){let i;if(typeof l=="string"?i=l:i={...l,base:(0,T.$gc)(l.base)},i===A.fsPath||(0,y.$Bj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$LE=P}),define(Pe[143],Ae([1,0,5,12,29,92,91,127,141,6]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MB=void 0;class I extends d.$Rc{constructor(l,b,v,f,t,i,r){super(),this.m=this.B(new y.$Rd),this.onDidChangeContent=this.m.event,this.f=b,this.j=!i,this.g=f,this.h=t,this.c=new A.$LB(l,v,r)}equals(l){return!(l instanceof I)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,b){return this.c.getOffsetAt(l,b)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,b){const v=l+b,f=this.getPositionAt(l),t=this.getPositionAt(v);return new P.$zs(f.lineNumber,f.column,t.lineNumber,t.column)}getValueInRange(l,b=0){if(l.isEmpty())return"";const v=this.n(b);return this.c.getValueInRange(l,v)}getValueLengthInRange(l,b=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const v=this.getOffsetAt(l.startLineNumber,l.startColumn),f=this.getOffsetAt(l.endLineNumber,l.endColumn);let t=0;const i=this.n(b),r=this.getEOL();if(i.length!==r.length){const c=i.length-r.length,o=l.endLineNumber-l.startLineNumber;t=c*o}return f-v+t}getCharacterCountInRange(l,b=0){if(this.j){let v=0;const f=l.startLineNumber,t=l.endLineNumber;for(let i=f;i<=t;i++){const r=this.getLineContent(i),c=i===f?l.startColumn-1:0,o=i===t?l.endColumn-1:r.length;for(let h=c;h<o;h++)T.$0e(r.charCodeAt(h))?(v=v+1,h=h+1):v=v+1}return v+=this.n(b).length*(t-f),v}return this.getValueLengthInRange(l,b)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,b){return this.c.getLineCharCode(l,b)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const b=T.$Ue(this.getLineContent(l));return b===-1?0:b+1}getLineLastNonWhitespaceColumn(l){const b=T.$We(this.getLineContent(l));return b===-1?0:b+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,b,v){let f=this.g,t=this.h,i=this.j,r=!0,c=[];for(let p=0;p<l.length;p++){const m=l[p];r&&m._isTracked&&(r=!1);const k=m.range;if(m.text){let F=!0;i||(F=!T.$if(m.text),i=F),!f&&F&&(f=T.$hf(m.text)),!t&&F&&(t=T.$kf(m.text))}let C="",u=0,w=0,S=0;if(m.text){let F;[u,w,S,F]=(0,$.$_s)(m.text);const V=this.getEOL();F===0||F===(V===`\r
`?2:1)?C=m.text:C=m.text.replace(/\r\n|\r|\n/g,V)}c[p]={sortIndex:p,identifier:m.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:C,eolCount:u,firstLineLength:w,lastLineLength:S,forceMoveMarkers:!!m.forceMoveMarkers,isAutoWhitespaceEdit:m.isAutoWhitespaceEdit||!1}}c.sort(I.u);let o=!1;for(let p=0,m=c.length-1;p<m;p++){const k=c[p].range.getEndPosition(),C=c[p+1].range.getStartPosition();if(C.isBeforeOrEqual(k)){if(C.isBefore(k))throw new Error("Overlapping ranges are not allowed!");o=!0}}r&&(c=this.s(c));const h=v||b?I._getInverseEditRanges(c):[],n=[];if(b)for(let p=0;p<c.length;p++){const m=c[p],k=h[p];if(m.isAutoWhitespaceEdit&&m.range.isEmpty())for(let C=k.startLineNumber;C<=k.endLineNumber;C++){let u="";C===k.startLineNumber&&(u=this.getLineContent(m.range.startLineNumber),T.$Ue(u)!==-1)||n.push({lineNumber:C,oldContent:u})}}let s=null;if(v){let p=0;s=[];for(let m=0;m<c.length;m++){const k=c[m],C=h[m],u=this.getValueInRange(k.range),w=k.rangeOffset+p;p+=k.text.length-u.length,s[m]={sortIndex:k.sortIndex,identifier:k.identifier,range:C,text:u,textChange:new E.$Us(k.rangeOffset,u,w,k.text)}}o||s.sort((m,k)=>m.sortIndex-k.sortIndex)}this.g=f,this.h=t,this.j=i;const a=this.t(c);let g=null;if(b&&n.length>0){n.sort((p,m)=>m.lineNumber-p.lineNumber),g=[];for(let p=0,m=n.length;p<m;p++){const k=n[p].lineNumber;if(p>0&&n[p-1].lineNumber===k)continue;const C=n[p].oldContent,u=this.getLineContent(k);u.length===0||u===C||T.$Ue(u)!==-1||g.push(k)}}return this.m.fire(),new M.$Uu(s,a,g)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let b=!1;const v=l[0].range,f=l[l.length-1].range,t=new P.$zs(v.startLineNumber,v.startColumn,f.endLineNumber,f.endColumn);let i=v.startLineNumber,r=v.startColumn;const c=[];for(let a=0,g=l.length;a<g;a++){const p=l[a],m=p.range;b=b||p.forceMoveMarkers,c.push(this.getValueInRange(new P.$zs(i,r,m.startLineNumber,m.startColumn))),p.text.length>0&&c.push(p.text),i=m.endLineNumber,r=m.endColumn}const o=c.join(""),[h,n,s]=(0,$.$_s)(o);return{sortIndex:0,identifier:l[0].identifier,range:t,rangeOffset:this.getOffsetAt(t.startLineNumber,t.startColumn),rangeLength:this.getValueLengthInRange(t,0),text:o,eolCount:h,firstLineLength:n,lastLineLength:s,forceMoveMarkers:b,isAutoWhitespaceEdit:!1}}t(l){l.sort(I.w);const b=[];for(let v=0;v<l.length;v++){const f=l[v],t=f.range.startLineNumber,i=f.range.startColumn,r=f.range.endLineNumber,c=f.range.endColumn;if(t===r&&i===c&&f.text.length===0)continue;f.text?(this.c.delete(f.rangeOffset,f.rangeLength),this.c.insert(f.rangeOffset,f.text,!0)):this.c.delete(f.rangeOffset,f.rangeLength);const o=new P.$zs(t,i,r,c);b.push({range:o,rangeLength:f.rangeLength,text:f.text,rangeOffset:f.rangeOffset,forceMoveMarkers:f.forceMoveMarkers})}return b}findMatchesLineByLine(l,b,v,f){return this.c.findMatchesLineByLine(l,b,v,f)}getPieceTree(){return this.c}static _getInverseEditRange(l,b){const v=l.startLineNumber,f=l.startColumn,[t,i,r]=(0,$.$_s)(b);let c;if(b.length>0){const o=t+1;o===1?c=new P.$zs(v,f,v,f+i):c=new P.$zs(v,f,v+o-1,r+1)}else c=new P.$zs(v,f,v,f);return c}static _getInverseEditRanges(l){const b=[];let v=0,f=0,t=null;for(let i=0,r=l.length;i<r;i++){const c=l[i];let o,h;t?t.range.endLineNumber===c.range.startLineNumber?(o=v,h=f+(c.range.startColumn-t.range.endColumn)):(o=v+(c.range.startLineNumber-t.range.endLineNumber),h=c.range.startColumn):(o=c.range.startLineNumber,h=c.range.startColumn);let n;if(c.text.length>0){const s=c.eolCount+1;s===1?n=new P.$zs(o,h,o,h+c.firstLineLength):n=new P.$zs(o,h,o+s-1,c.lastLineLength+1)}else n=new P.$zs(o,h,o,h);v=n.endLineNumber,f=n.endColumn,b.push(n),t=c}return b}static u(l,b){const v=P.$zs.compareRangesUsingEnds(l.range,b.range);return v===0?l.sortIndex-b.sortIndex:v}static w(l,b){const v=P.$zs.compareRangesUsingEnds(l.range,b.range);return v===0?b.sortIndex-l.sortIndex:-v}}e.$MB=I}),define(Pe[144],Ae([1,0,12,91,143]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NB=void 0;class M{constructor(E,d,I,D,l,b,v,f,t){this.a=E,this.b=d,this.c=I,this.d=D,this.e=l,this.f=b,this.g=v,this.h=f,this.j=t}k(E){const d=this.c+this.d+this.e,I=this.c+this.e;return d===0?E===1?`
`:`\r
`:I>d/2?`\r
`:`
`}create(E){const d=this.k(E),I=this.a;if(this.j&&(d===`\r
`&&(this.c>0||this.d>0)||d===`
`&&(this.c>0||this.e>0)))for(let l=0,b=I.length;l<b;l++){const v=I[l].buffer.replace(/\r\n|\r|\n/g,d),f=(0,T.$HB)(v);I[l]=new T.$KB(v,f)}const D=new P.$MB(I,this.b,d,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(E){return this.a[0].buffer.substr(0,E).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(E){if(E.length===0)return;this.a.length===0&&y.$qf(E)&&(this.b=y.$pf,E=E.substr(1));const d=E.charCodeAt(E.length-1);d===13||d>=55296&&d<=56319?(this.m(E.substr(0,E.length-1),!1),this.c=!0,this.d=d):(this.m(E,!1),this.c=!1,this.d=d)}m(E,d){!d&&E.length===0||(this.c?this.n(String.fromCharCode(this.d)+E):this.n(E))}n(E){const d=(0,T.$IB)(this.e,E);this.a.push(new T.$KB(E,d.lineStarts)),this.f+=d.cr,this.g+=d.lf,this.h+=d.crlf,d.isBasicASCII||(this.l=!1,this.j||(this.j=y.$hf(E)),this.k||(this.k=y.$kf(E)))}finish(E=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,E)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const E=this.a[this.a.length-1];E.buffer+=String.fromCharCode(this.d);const d=(0,T.$HB)(E.buffer);E.lineStarts=d,this.d===13&&this.f++}}}e.$NB=A}),define(Pe[95],Ae([1,0,24,21]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30=e.$20=void 0;var P;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(P||(P={}));function M(D){for(let l=0,b=D.length;l<b;l+=4){const v=D[l+0],f=D[l+1],t=D[l+2],i=D[l+3];D[l+0]=i,D[l+1]=t,D[l+2]=f,D[l+3]=v}}function A(D){const l=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return T.$D()||M(l),y.$fe.wrap(l)}function $(D){const l=D.buffer;if(T.$D()||M(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const b=new Uint8Array(l.byteLength);return b.set(l),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function E(D){const l=new Uint32Array(d(D));let b=0;if(l[b++]=D.id,D.type==="full")l[b++]=1,l[b++]=D.data.length,l.set(D.data,b),b+=D.data.length;else{l[b++]=2,l[b++]=D.deltas.length;for(const v of D.deltas)l[b++]=v.start,l[b++]=v.deleteCount,v.data?(l[b++]=v.data.length,l.set(v.data,b),b+=v.data.length):l[b++]=0}return A(l)}e.$20=E;function d(D){let l=0;if(l+=1+1,D.type==="full")l+=1+D.data.length;else{l+=1,l+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(l+=b.data.length)}return l}function I(D){const l=$(D);let b=0;const v=l[b++];if(l[b++]===1){const r=l[b++],c=l.subarray(b,b+r);return b+=r,{id:v,type:"full",data:c}}const t=l[b++],i=[];for(let r=0;r<t;r++){const c=l[b++],o=l[b++],h=l[b++];let n;h>0&&(n=l.subarray(b,b+h),b+=h),i[r]={start:c,deleteCount:o,data:n}}return{id:v,type:"delta",deltas:i}}e.$30=I}),define(Pe[145],Ae([9,10]),function(we,e){return we.create("vs/editor/common/config/editorOptions",e)}),define(Pe[146],Ae([1,0,18,26,21,128,147,145]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class d{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=d;class I{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=I;class D{constructor(Q,Ee,Be,He){this.id=Q,this.name=Ee,this.defaultValue=Be,this.schema=He}applyUpdate(Q,Ee){return b(Q,Ee)}compute(Q,Ee,Be){return Be}}class l{constructor(Q,Ee){this.newValue=Q,this.didChange=Ee}}e.ApplyUpdateResult=l;function b(X,Q){if(typeof X!="object"||typeof Q!="object"||!X||!Q)return new l(Q,X!==Q);if(Array.isArray(X)||Array.isArray(Q)){const Be=Array.isArray(X)&&Array.isArray(Q)&&y.$tb(X,Q);return new l(Q,!Be)}let Ee=!1;for(const Be in Q)if(Q.hasOwnProperty(Be)){const He=b(X[Be],Q[Be]);He.didChange&&(X[Be]=He.newValue,Ee=!0)}return new l(X,Ee)}class v{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,Ee){return b(Q,Ee)}validate(Q){return this.defaultValue}}class f{constructor(Q,Ee,Be,He){this.id=Q,this.name=Ee,this.defaultValue=Be,this.schema=He}applyUpdate(Q,Ee){return b(Q,Ee)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,Ee,Be){return Be}}function t(X,Q){return typeof X>"u"?Q:X==="false"?!1:!!X}e.boolean=t;class i extends f{constructor(Q,Ee,Be,He=void 0){typeof He<"u"&&(He.type="boolean",He.default=Be),super(Q,Ee,Be,He)}validate(Q){return t(Q,this.defaultValue)}}function r(X,Q,Ee,Be){if(typeof X>"u")return Q;let He=parseInt(X,10);return isNaN(He)?Q:(He=Math.max(Ee,He),He=Math.min(Be,He),He|0)}e.clampedInt=r;class c extends f{static clampedInt(Q,Ee,Be,He){return r(Q,Ee,Be,He)}constructor(Q,Ee,Be,He,Xe,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Be,st.minimum=He,st.maximum=Xe),super(Q,Ee,Be,st),this.minimum=He,this.maximum=Xe}validate(Q){return c.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function o(X,Q,Ee,Be){if(typeof X>"u")return Q;const He=h.float(X,Q);return h.clamp(He,Ee,Be)}e.clampedFloat=o;class h extends f{static clamp(Q,Ee,Be){return Q<Ee?Ee:Q>Be?Be:Q}static float(Q,Ee){if(typeof Q=="number")return Q;if(typeof Q>"u")return Ee;const Be=parseFloat(Q);return isNaN(Be)?Ee:Be}constructor(Q,Ee,Be,He,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=Be),super(Q,Ee,Be,Xe),this.validationFn=He}validate(Q){return this.validationFn(h.float(Q,this.defaultValue))}}class n extends f{static string(Q,Ee){return typeof Q!="string"?Ee:Q}constructor(Q,Ee,Be,He=void 0){typeof He<"u"&&(He.type="string",He.default=Be),super(Q,Ee,Be,He)}validate(Q){return n.string(Q,this.defaultValue)}}function s(X,Q,Ee,Be){return typeof X!="string"?Q:Be&&X in Be?Be[X]:Ee.indexOf(X)===-1?Q:X}e.stringSet=s;class a extends f{constructor(Q,Ee,Be,He,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=He,Xe.default=Be),super(Q,Ee,Be,Xe),this.c=He}validate(Q){return s(Q,this.defaultValue,this.c)}}class g extends D{constructor(Q,Ee,Be,He,Xe,st,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=Xe,vt.default=He),super(Q,Ee,Be,vt),this.c=Xe,this.d=st}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function p(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[$.localize(0,null),$.localize(1,null),$.localize(2,null)],default:"auto",tags:["accessibility"],description:$.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,Ee,Be){return Be===0?Q.accessibilitySupport:Be}}class k extends D{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:$.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:$.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function u(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function S(X){switch(X){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function F(X){switch(X){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class V extends v{constructor(){super(140)}compute(Q,Ee,Be){const He=["monaco-editor"];return Ee.get(39)&&He.push(Ee.get(39)),Q.extraEditorClassName&&He.push(Q.extraEditorClassName),Ee.get(73)==="default"?He.push("mouse-default"):Ee.get(73)==="copy"&&He.push("mouse-copy"),Ee.get(110)&&He.push("showUnused"),Ee.get(138)&&He.push("showDeprecated"),He.join(" ")}}class J extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:$.localize(6,null)})}compute(Q,Ee,Be){return Be&&Q.emptySelectionClipboard}}class N extends D{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:$.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[$.localize(8,null),$.localize(9,null),$.localize(10,null)],description:$.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[$.localize(12,null),$.localize(13,null),$.localize(14,null)],description:$.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:$.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:$.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:$.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":s(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":s(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class R extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",R.OFF,{anyOf:[{type:"boolean",description:$.localize(19,null)},{type:"string",description:$.localize(20,null)}],description:$.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?R.OFF:Q==="true"?R.ON:Q:Q?R.ON:R.OFF}}e.EditorFontLigatures=R;class L extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",L.OFF,{anyOf:[{type:"boolean",description:$.localize(22,null)},{type:"string",description:$.localize(23,null)}],description:$.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?L.OFF:Q==="true"?L.TRANSLATE:Q:Q?L.TRANSLATE:L.OFF}compute(Q,Ee,Be){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=L;class O extends v{constructor(){super(50)}compute(Q,Ee,Be){return Q.fontInfo}}class Z extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:$.localize(25,null)})}validate(Q){const Ee=h.float(Q,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ee,6,100)}compute(Q,Ee,Be){return Q.fontInfo.fontSize}}class he extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:he.d,maximum:he.e,errorMessage:$.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:he.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:$.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(c.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,he.d,he.e))}}class $e extends D{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[$.localize(28,null),$.localize(29,null),$.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:$.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:$.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:$.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:$.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:$.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:$.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Be,description:$.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Be,description:$.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Be,description:$.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Be,description:$.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Be,description:$.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{multiple:s(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??s(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??s(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??s(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??s(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??s(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class De extends D{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:$.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:$.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:$.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:$.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:$.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:c.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var ke;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ke||(e.RenderMinimap=ke={}));class fe extends v{constructor(){super(143)}compute(Q,Ee,Be){return fe.computeLayout(Ee,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const Ee=Q.height/Q.lineHeight,Be=Math.floor(Q.paddingTop/Q.lineHeight);let He=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(He=Math.max(He,Ee-1));const Xe=(Be+Q.viewLineCount+He)/(Q.pixelRatio*Q.height),st=Math.floor(Q.viewLineCount/Xe);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:He,desiredRatio:Xe,minimapLineCount:st}}static c(Q,Ee){const Be=Q.outerWidth,He=Q.outerHeight,Xe=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const st=Ee.stableMinimapLayoutInput,vt=st&&Q.outerHeight===st.outerHeight&&Q.lineHeight===st.lineHeight&&Q.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&Q.pixelRatio===st.pixelRatio&&Q.scrollBeyondLastLine===st.scrollBeyondLastLine&&Q.paddingTop===st.paddingTop&&Q.paddingBottom===st.paddingBottom&&Q.minimap.enabled===st.minimap.enabled&&Q.minimap.side===st.minimap.side&&Q.minimap.size===st.minimap.size&&Q.minimap.showSlider===st.minimap.showSlider&&Q.minimap.renderCharacters===st.minimap.renderCharacters&&Q.minimap.maxColumn===st.minimap.maxColumn&&Q.minimap.scale===st.minimap.scale&&Q.verticalScrollbarWidth===st.verticalScrollbarWidth&&Q.isViewportWrapping===st.isViewportWrapping,Dt=Q.lineHeight,Ne=Q.typicalHalfwidthCharacterWidth,Kt=Q.scrollBeyondLastLine,Ht=Q.minimap.renderCharacters;let yt=Xe>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const jt=Q.minimap.maxColumn,Nt=Q.minimap.size,Gt=Q.minimap.side,Bt=Q.verticalScrollbarWidth,St=Q.viewLineCount,Lt=Q.remainingWidth,Vt=Q.isViewportWrapping,Ye=Ht?2:3;let Wt=Math.floor(Xe*He);const qt=Wt/Xe;let ct=!1,gt=!1,Ot=Ye*yt,Pt=yt/Xe,At=1;if(Nt==="fill"||Nt==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Ce,extraLinesBeyondLastLine:Me,desiredRatio:be,minimapLineCount:K}=fe.computeContainedMinimapLineCount({viewLineCount:St,scrollBeyondLastLine:Kt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:He,lineHeight:Dt,pixelRatio:Xe});if(St/K>1)ct=!0,gt=!0,yt=1,Ot=1,Pt=yt/Xe;else{let je=!1,Qe=yt+1;if(Nt==="fit"){const qe=Math.ceil((Ce+St+Me)*Ot);Vt&&vt&&Lt<=Ee.stableFitRemainingWidth?(je=!0,Qe=Ee.stableFitMaxMinimapScale):je=qe>Wt}if(Nt==="fill"||je){ct=!0;const qe=yt;Ot=Math.min(Dt*Xe,Math.max(1,Math.floor(1/be))),Vt&&vt&&Lt<=Ee.stableFitRemainingWidth&&(Qe=Ee.stableFitMaxMinimapScale),yt=Math.min(Qe,Math.max(1,Math.floor(Ot/Ye))),yt>qe&&(At=Math.min(2,yt/qe)),Pt=yt/Xe/At,Wt=Math.ceil(Math.max(Jt,Ce+St+Me)*Ot),Vt?(Ee.stableMinimapLayoutInput=Q,Ee.stableFitRemainingWidth=Lt,Ee.stableFitMaxMinimapScale=yt):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const ft=Math.floor(jt*Pt),kt=Math.min(ft,Math.max(0,Math.floor((Lt-Bt-2)*Pt/(Ne+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Rt=Math.floor(Xe*kt);const Ct=Rt/Xe;Rt=Math.floor(Rt*At);const We=Ht?1:2,zt=Gt==="left"?0:Be-kt-Bt;return{renderMinimap:We,minimapLeft:zt,minimapWidth:kt,minimapHeightIsEditorHeight:ct,minimapIsSampling:gt,minimapScale:yt,minimapLineHeight:Ot,minimapCanvasInnerWidth:Rt,minimapCanvasInnerHeight:Wt,minimapCanvasOuterWidth:Ct,minimapCanvasOuterHeight:qt}}static computeLayout(Q,Ee){const Be=Ee.outerWidth|0,He=Ee.outerHeight|0,Xe=Ee.lineHeight|0,st=Ee.lineNumbersDigitCount|0,vt=Ee.typicalHalfwidthCharacterWidth,Dt=Ee.maxDigitWidth,Ne=Ee.pixelRatio,Kt=Ee.viewLineCount,Ht=Q.get(135),yt=Ht==="inherit"?Q.get(134):Ht,jt=yt==="inherit"?Q.get(130):yt,Nt=Q.get(133),Gt=Ee.isDominatedByLongLines,Bt=Q.get(57),St=Q.get(67).renderType!==0,Lt=Q.get(68),Vt=Q.get(104),Ye=Q.get(83),Wt=Q.get(72),qt=Q.get(102),ct=qt.verticalScrollbarSize,gt=qt.verticalHasArrows,Ot=qt.arrowSize,Pt=qt.horizontalScrollbarSize,At=Q.get(43),ft=Q.get(109)!=="never";let kt=Q.get(65);At&&ft&&(kt+=16);let Rt=0;if(St){const pt=Math.max(st,Lt);Rt=Math.round(pt*Dt)}let Ct=0;Bt&&(Ct=Xe*Ee.glyphMarginDecorationLaneCount);let We=0,zt=We+Ct,Jt=zt+Rt,Ce=Jt+kt;const Me=Be-Ct-Rt-kt;let be=!1,K=!1,Le=-1;yt==="inherit"&&Gt?(be=!0,K=!0):jt==="on"||jt==="bounded"?K=!0:jt==="wordWrapColumn"&&(Le=Nt);const je=fe.c({outerWidth:Be,outerHeight:He,lineHeight:Xe,typicalHalfwidthCharacterWidth:vt,pixelRatio:Ne,scrollBeyondLastLine:Vt,paddingTop:Ye.top,paddingBottom:Ye.bottom,minimap:Wt,verticalScrollbarWidth:ct,viewLineCount:Kt,remainingWidth:Me,isViewportWrapping:K},Ee.memory||new I);je.renderMinimap!==0&&je.minimapLeft===0&&(We+=je.minimapWidth,zt+=je.minimapWidth,Jt+=je.minimapWidth,Ce+=je.minimapWidth);const Qe=Me-je.minimapWidth,qe=Math.max(1,Math.floor((Qe-ct-2)/vt)),it=gt?Ot:0;return K&&(Le=Math.max(1,qe),jt==="bounded"&&(Le=Math.min(Le,Nt))),{width:Be,height:He,glyphMarginLeft:We,glyphMarginWidth:Ct,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:Rt,decorationsLeft:Jt,decorationsWidth:kt,contentLeft:Ce,contentWidth:Qe,minimap:je,viewportColumn:qe,isWordWrapMinified:be,isViewportWrapping:K,wrappingColumn:Le,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Pt,overviewRuler:{top:it,width:ct,height:He-2*it,right:0}}}}e.EditorLayoutInfoComputer=fe;class ve extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[$.localize(47,null),$.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:$.localize(49,null)}})}validate(Q){return s(Q,"simple",["simple","advanced"])}compute(Q,Ee,Be){return Ee.get(2)===2?"advanced":Be}}class te extends D{constructor(){const Q={enabled:!0};super(64,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:$.localize(50,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:t(Q.enabled,this.defaultValue.enabled)}}}class Re extends D{constructor(){const Q={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:$.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:10,description:$.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:$.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:$.localize(54,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends D{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:$.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[$.localize(56,null),$.localize(57,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(58,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),$.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:$.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:$.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:$.localize(62,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:s(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class Y extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):c.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,Ee,Be){return Be<0?c.clampedInt(-Be*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class B extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>h.clamp(Q,0,150),{markdownDescription:$.localize(63,null)})}compute(Q,Ee,Be){return Q.fontInfo.lineHeight}}class ne extends D{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:$.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:$.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[$.localize(66,null),$.localize(67,null),$.localize(68,null)],default:Q.size,description:$.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:$.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:$.localize(71,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:$.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:$.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:$.localize(74,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:s(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(Ee.side,this.defaultValue.side,["right","left"]),showSlider:s(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Ee.scale,1,1,3),maxColumn:c.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(X){return X==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class re extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:$.localize(76,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{top:c.clampedInt(Ee.top,0,0,1e3),bottom:c.clampedInt(Ee.bottom,0,0,1e3)}}}class le extends D{constructor(){const Q={enabled:!0,cycle:!0};super(85,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:$.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:$.localize(78,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class ce extends v{constructor(){super(141)}compute(Q,Ee,Be){return Q.pixelRatio}}class ye extends D{constructor(){const Q={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[$.localize(79,null),$.localize(80,null),$.localize(81,null)]}];super(88,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:Q.strings,description:$.localize(82,null)},comments:{anyOf:Ee,default:Q.comments,description:$.localize(83,null)},other:{anyOf:Ee,default:Q.other,description:$.localize(84,null)}},default:Q,markdownDescription:$.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Ne=Q?"on":"off";return{comments:Ne,strings:Ne,other:Ne}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:Ee,comments:Be,strings:He}=Q,Xe=["on","inline","off"];let st,vt,Dt;return typeof Ee=="boolean"?st=Ee?"on":"off":st=s(Ee,this.defaultValue.other,Xe),typeof Be=="boolean"?vt=Be?"on":"off":vt=s(Be,this.defaultValue.comments,Xe),typeof He=="boolean"?Dt=He?"on":"off":Dt=s(He,this.defaultValue.strings,Xe),{other:st,comments:vt,strings:Dt}}}var _;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(_||(e.RenderLineNumbersType=_={}));class de extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[$.localize(86,null),$.localize(87,null),$.localize(88,null),$.localize(89,null)],default:"on",description:$.localize(90,null)})}validate(Q){let Ee=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(Ee=4,Be=Q):Q==="interval"?Ee=3:Q==="relative"?Ee=2:Q==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:Be}}}function ie(X){const Q=X.get(97);return Q==="editable"?X.get(90):Q!=="on"}e.filterValidationDecorations=ie;class ae extends D{constructor(){const Q=[],Ee={type:"number",description:$.localize(91,null)};super(101,"rulers",Q,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:$.localize(92,null),format:"color-hex"}}}]},default:Q,description:$.localize(93,null)})}validate(Q){if(Array.isArray(Q)){const Ee=[];for(const Be of Q)if(typeof Be=="number")Ee.push({column:c.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const He=Be;Ee.push({column:c.clampedInt(He.column,0,0,1e4),color:He.color})}return Ee.sort((Be,He)=>Be.column-He.column),Ee}return this.defaultValue}}class me extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Ie(X,Q){if(typeof X!="string")return Q;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends D{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(94,null),$.localize(95,null),$.localize(96,null)],default:"auto",description:$.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[$.localize(98,null),$.localize(99,null),$.localize(100,null)],default:"auto",description:$.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:$.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:$.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:$.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:$.localize(105,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q,Be=c.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=c.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ee.vertical,this.defaultValue.vertical),horizontal:Ie(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:c.clampedInt(Ee.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:He,verticalSliderSize:c.clampedInt(Ee.verticalSliderSize,He,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class W extends D{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:$.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:$.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:$.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:$.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:$.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:$.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:$.localize(112,null)}})}applyUpdate(Q,Ee){let Be=!1;Ee.allowedCharacters&&Q&&(T.$en(Q.allowedCharacters,Ee.allowedCharacters)||(Q={...Q,allowedCharacters:Ee.allowedCharacters},Be=!0)),Ee.allowedLocales&&Q&&(T.$en(Q.allowedLocales,Ee.allowedLocales)||(Q={...Q,allowedLocales:Ee.allowedLocales},Be=!0));const He=super.applyUpdate(Q,Ee);return Be?new l(He.newValue,!0):He}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{nonBasicASCII:x(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,Ee){if(typeof Q!="object"||!Q)return Ee;const Be={};for(const[He,Xe]of Object.entries(Q))Xe===!0&&(Be[He]=!0);return Be}}class H extends D{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:$.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[$.localize(114,null),$.localize(115,null),$.localize(116,null)],description:$.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:$.localize(118,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:s(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class G extends D{constructor(){const Q={enabled:M.$9r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$9r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:$.localize(120,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class q extends D{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(121,null),$.localize(122,null),$.localize(123,null)],default:Q.bracketPairs,description:$.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[$.localize(125,null),$.localize(126,null),$.localize(127,null)],default:Q.bracketPairsHorizontal,description:$.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:$.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:$.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[$.localize(131,null),$.localize(132,null),$.localize(133,null)],default:Q.highlightActiveIndentation,description:$.localize(134,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{bracketPairs:x(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(X,Q,Ee){const Be=Ee.indexOf(X);return Be===-1?Q:Ee[Be]}class ue extends D{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[$.localize(135,null),$.localize(136,null)],default:Q.insertMode,description:$.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:$.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:$.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:$.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[$.localize(141,null),$.localize(142,null),$.localize(143,null),$.localize(144,null)],default:Q.selectionMode,markdownDescription:$.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:$.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:$.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:$.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:$.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:$.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:$.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:$.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:$.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:$.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:$.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:$.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:$.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:$.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:$.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:$.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:$.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:$.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:$.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:$.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:$.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:$.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:$.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:$.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:$.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:$.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:$.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:$.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:$.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:$.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:$.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:$.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:$.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:$.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:$.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:$.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:$.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:$.localize(182,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{insertMode:s(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:s(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class Oe extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:$.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:$.localize(184,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Q.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Ze extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[$.localize(185,null),$.localize(186,null),$.localize(187,null),$.localize(188,null)],description:$.localize(189,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,Ee,Be){return Ee.get(2)===2?0:Be}}class Je extends v{constructor(){super(144)}compute(Q,Ee,Be){const He=Ee.get(143);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}class tt extends D{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:$.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[$.localize(192,null),$.localize(193,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:s(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class _e extends D{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:$.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:$.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[$.localize(196,null),$.localize(197,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ee=Q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:s(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?rt:P.$k?nt:et,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(X){return e.editorOptionsRegistry[X.id]=X,X}var dt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(dt||(e.EditorOption=dt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:$.localize(198,null)})),acceptSuggestionOnEnter:ze(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",$.localize(199,null),""],markdownDescription:$.localize(200,null)})),accessibilitySupport:ze(new m),accessibilityPageSize:ze(new c(3,"accessibilityPageSize",10,1,1073741824,{description:$.localize(201,null),tags:["accessibility"]})),ariaLabel:ze(new n(4,"ariaLabel",$.localize(202,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:$.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:ze(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(204,null),$.localize(205,null),""],description:$.localize(206,null)})),autoClosingComments:ze(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(207,null),$.localize(208,null),""],description:$.localize(209,null)})),autoClosingDelete:ze(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",$.localize(210,null),""],description:$.localize(211,null)})),autoClosingOvertype:ze(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",$.localize(212,null),""],description:$.localize(213,null)})),autoClosingQuotes:ze(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",$.localize(214,null),$.localize(215,null),""],description:$.localize(216,null)})),autoIndent:ze(new g(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[$.localize(217,null),$.localize(218,null),$.localize(219,null),$.localize(220,null),$.localize(221,null)],description:$.localize(222,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[$.localize(223,null),$.localize(224,null),$.localize(225,null),""],description:$.localize(226,null)})),bracketPairColorization:ze(new G),bracketPairGuides:ze(new q),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:$.localize(227,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:$.localize(228,null)})),codeLensFontFamily:ze(new n(18,"codeLensFontFamily","",{description:$.localize(229,null)})),codeLensFontSize:ze(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:$.localize(230,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:$.localize(231,null)})),colorDecoratorActivatedOn:ze(new a(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[$.localize(232,null),$.localize(233,null),$.localize(234,null)],description:$.localize(235,null)})),colorDecoratorsLimit:ze(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:$.localize(236,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:$.localize(237,null)})),comments:ze(new k),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:$.localize(238,null)})),cursorBlinking:ze(new g(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:$.localize(239,null)})),cursorSmoothCaretAnimation:ze(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[$.localize(240,null),$.localize(241,null),$.localize(242,null)],description:$.localize(243,null)})),cursorStyle:ze(new g(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:$.localize(244,null)})),cursorSurroundingLines:ze(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:$.localize(245,null)})),cursorSurroundingLinesStyle:ze(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[$.localize(246,null),$.localize(247,null)],markdownDescription:$.localize(248,null)})),cursorWidth:ze(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:$.localize(249,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:$.localize(250,null)})),emptySelectionClipboard:ze(new J),dropIntoEditor:ze(new tt),stickyScroll:ze(new Re),experimentalWhitespaceRendering:ze(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[$.localize(251,null),$.localize(252,null),$.localize(253,null)],description:$.localize(254,null)})),extraEditorClassName:ze(new n(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:$.localize(255,null)})),find:ze(new N),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:$.localize(256,null)})),foldingStrategy:ze(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[$.localize(257,null),$.localize(258,null)],description:$.localize(259,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:$.localize(260,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:$.localize(261,null)})),foldingMaximumRegions:ze(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:$.localize(262,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:$.localize(263,null)})),fontFamily:ze(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:$.localize(264,null)})),fontInfo:ze(new O),fontLigatures2:ze(new R),fontSize:ze(new Z),fontWeight:ze(new he),fontVariations:ze(new L),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:$.localize(265,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:$.localize(266,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:$.localize(267,null)})),gotoLocation:ze(new $e),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:$.localize(268,null)})),hover:ze(new De),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:$.localize(269,null)})),lightbulb:ze(new te),lineDecorationsWidth:ze(new Y),lineHeight:ze(new B),lineNumbers:ze(new de),lineNumbersMinChars:ze(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:$.localize(270,null)})),links:ze(new i(70,"links",!0,{description:$.localize(271,null)})),matchBrackets:ze(new a(71,"matchBrackets","always",["always","near","never"],{description:$.localize(272,null)})),minimap:ze(new ne),mouseStyle:ze(new a(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new h(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:$.localize(273,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:$.localize(274,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:$.localize(275,null)})),multiCursorModifier:ze(new g(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[$.localize(276,null),$.localize(277,null)],markdownDescription:$.localize(278,null)})),multiCursorPaste:ze(new a(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[$.localize(279,null),$.localize(280,null)],markdownDescription:$.localize(281,null)})),multiCursorLimit:ze(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:$.localize(282,null)})),occurrencesHighlight:ze(new a(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[$.localize(283,null),$.localize(284,null),$.localize(285,null)],markdownDescription:$.localize(286,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:$.localize(287,null)})),overviewRulerLanes:ze(new c(82,"overviewRulerLanes",3,0,3)),padding:ze(new re),pasteAs:ze(new _e),parameterHints:ze(new le),peekWidgetDefaultFocus:ze(new a(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[$.localize(288,null),$.localize(289,null)],description:$.localize(290,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:$.localize(291,null)})),quickSuggestions:ze(new ye),quickSuggestionsDelay:ze(new c(89,"quickSuggestionsDelay",10,0,1073741824,{description:$.localize(292,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new me),renameOnType:ze(new i(92,"renameOnType",!1,{description:$.localize(293,null),markdownDeprecationMessage:$.localize(294,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:$.localize(295,null),restricted:!0})),renderFinalNewline:ze(new a(94,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:$.localize(296,null)})),renderLineHighlight:ze(new a(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",$.localize(297,null)],description:$.localize(298,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:$.localize(299,null)})),renderValidationDecorations:ze(new a(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new a(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",$.localize(300,null),$.localize(301,null),$.localize(302,null),""],description:$.localize(303,null)})),revealHorizontalRightPadding:ze(new c(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:$.localize(304,null)})),rulers:ze(new ae),scrollbar:ze(new z),scrollBeyondLastColumn:ze(new c(103,"scrollBeyondLastColumn",4,0,1073741824,{description:$.localize(305,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:$.localize(306,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:$.localize(307,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:$.localize(308,null),included:P.$k})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:$.localize(309,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new a(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[$.localize(310,null),$.localize(311,null),$.localize(312,null)],description:$.localize(313,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:$.localize(314,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:$.localize(315,null)})),inlayHints:ze(new se),snippetSuggestions:ze(new a(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[$.localize(316,null),$.localize(317,null),$.localize(318,null),$.localize(319,null)],description:$.localize(320,null)})),smartSelect:ze(new Oe),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:$.localize(321,null)})),stopRenderingLineAfter:ze(new c(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ue),inlineSuggest:ze(new H),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:$.localize(322,null)})),suggestFontSize:ze(new c(118,"suggestFontSize",0,0,1e3,{markdownDescription:$.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new c(119,"suggestLineHeight",0,0,1e3,{markdownDescription:$.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:$.localize(325,null)})),suggestSelection:ze(new a(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[$.localize(326,null),$.localize(327,null),$.localize(328,null)],description:$.localize(329,null)})),tabCompletion:ze(new a(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[$.localize(330,null),$.localize(331,null),$.localize(332,null)],description:$.localize(333,null)})),tabIndex:ze(new c(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new W),unusualLineTerminators:ze(new a(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[$.localize(334,null),$.localize(335,null),$.localize(336,null)],description:$.localize(337,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:$.localize(338,null)})),wordBreak:ze(new a(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[$.localize(339,null),$.localize(340,null)],description:$.localize(341,null)})),wordSeparators:ze(new n(129,"wordSeparators",A.$0r,{description:$.localize(342,null)})),wordWrap:ze(new a(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[$.localize(343,null),$.localize(344,null),$.localize(345,null),$.localize(346,null)],description:$.localize(347,null)})),wordWrapBreakAfterCharacters:ze(new n(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new n(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new c(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:$.localize(348,null)})),wordWrapOverride1:ze(new a(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new a(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new V),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:$.localize(349,null)})),pixelRatio:ze(new ce),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:$.localize(350,null)})),layoutInfo:ze(new fe),wrappingInfo:ze(new Je),wrappingIndent:ze(new Ze),wrappingStrategy:ze(new ve)}}),define(Pe[148],Ae([9,10]),function(we,e){return we.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[149],Ae([9,10]),function(we,e){return we.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[150],Ae([9,10]),function(we,e){return we.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[151],Ae([9,10]),function(we,e){return we.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[152],Ae([9,10]),function(we,e){return we.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[153],Ae([9,10]),function(we,e){return we.create("vs/platform/files/common/files",e)}),define(Pe[154],Ae([9,10]),function(we,e){return we.create("vs/platform/markers/common/markers",e)}),define(Pe[155],Ae([9,10]),function(we,e){return we.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[156],Ae([9,10]),function(we,e){return we.create("vs/platform/workspace/common/workspace",e)}),define(Pe[157],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[158],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[159],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[160],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[161],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[162],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[163],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[164],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[165],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[166],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[167],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[168],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[169],Ae([9,10]),function(we,e){return we.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[170],Ae([9,10]),function(we,e){return we.create("vs/workbench/common/configuration",e)}),define(Pe[171],Ae([9,10]),function(we,e){return we.create("vs/workbench/common/editor",e)}),define(Pe[172],Ae([9,10]),function(we,e){return we.create("vs/workbench/common/views",e)}),define(Pe[173],Ae([9,10]),function(we,e){return we.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[174],Ae([9,10]),function(we,e){return we.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[175],Ae([9,10]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[176],Ae([9,10]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[177],Ae([9,10]),function(we,e){return we.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[178],Ae([9,10]),function(we,e){return we.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[179],Ae([9,10]),function(we,e){return we.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[180],Ae([9,10]),function(we,e){return we.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[181],Ae([1,0,11,150]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.TokenType=void 0;var P;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...d){switch(d.length){case 1:return(0,T.localize)(0,null,d[0]);case 2:return(0,T.localize)(1,null,d[0],d[1]);case 3:return(0,T.localize)(2,null,d[0],d[1],d[2]);default:return}}const A=(0,T.localize)(3,null),$=(0,T.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(I){switch(I.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return I.isTripleEq?"===":"==";case 4:return I.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return I.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return I.lexeme;case 18:return I.lexeme;case 19:return I.lexeme;case 20:return"EOF";default:throw(0,y.$7)(`unhandled token type: ${JSON.stringify(I)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(I){return this.c=I,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(I){return this.r()||this.c.charCodeAt(this.e)!==I?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(I){this.f.push({type:I,offset:this.d})}l(I){const D=this.d,l=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:l};this.g.push({offset:D,lexeme:l,additionalInfo:I}),this.f.push(b)}n(){this.m.lastIndex=this.d;const I=this.m.exec(this.c);if(I){this.e=this.d+I[0].length;const D=this.c.substring(this.d,this.e),l=E.b.get(D);l?this.k(l):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let I=this.e,D=!1,l=!1;for(;;){if(I>=this.c.length){this.e=I,this.l($);return}const v=this.c.charCodeAt(I);if(D)D=!1;else if(v===47&&!l){I++;break}else v===91?l=!0:v===92?D=!0:v===93&&(l=!1);I++}for(;I<this.c.length&&E.a.has(this.c.charCodeAt(I));)I++;this.e=I;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Qi=E}),define(Pe[182],Ae([1,0,25,31,152,294]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,$=/^-(\d{4})(\d{2})(\d{2})$/;function E(i){return i=i.trim(),i==="*"||A.test(i)}e.$Ro=E;function d(i){if(!E(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=i.match(A);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$So=d;function I(i){if(!i)return null;const r=i.majorBase,c=i.majorMustEqual,o=i.minorBase;let h=i.minorMustEqual;const n=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(r===0||(h=!1),s=!1);let a=0;if(i.preRelease){const g=$.exec(i.preRelease);if(g){const[,p,m,k]=g;a=Date.UTC(Number(p),Number(m)-1,Number(k))}}return{majorBase:r,majorMustEqual:c,minorBase:o,minorMustEqual:h,patchBase:n,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:a}}e.$To=I;function D(i,r,c){let o;typeof i=="string"?o=I(d(i)):o=i;let h;r instanceof Date?h=r.getTime():typeof r=="string"&&(h=new Date(r).getTime());let n;if(typeof c=="string"?n=I(d(c)):n=c,!o||!n)return!1;const s=o.majorBase,a=o.minorBase,g=o.patchBase;let p=n.majorBase,m=n.minorBase,k=n.patchBase;const C=n.notBefore;let u=n.majorMustEqual,w=n.minorMustEqual,S=n.patchMustEqual;return n.isMinimum?s>p?!0:s<p?!1:a>m?!0:a<m||h&&h<C?!1:g>=k:(s===1&&p===0&&(!u||!w||!S)&&(p=1,m=0,k=0,u=!0,w=!1,S=!1),s<p?!1:s>p?!u:a<m?!1:a>m?!w:g<k?!1:g>k?!S:!(h&&h<C))}e.$Uo=D;function l(i,r,c,o,h){const n=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return n.push([T.default.Error,P.localize(0,null)]),n;if(typeof o.name!="string")return n.push([T.default.Error,P.localize(1,null,"name")]),n;if(typeof o.version!="string")return n.push([T.default.Error,P.localize(2,null,"version")]),n;if(!o.engines)return n.push([T.default.Error,P.localize(3,null,"engines")]),n;if(typeof o.engines.vscode!="string")return n.push([T.default.Error,P.localize(4,null,"engines.vscode")]),n;if(typeof o.extensionDependencies<"u"&&!t(o.extensionDependencies))return n.push([T.default.Error,P.localize(5,null,"extensionDependencies")]),n;if(typeof o.activationEvents<"u"){if(!t(o.activationEvents))return n.push([T.default.Error,P.localize(6,null,"activationEvents")]),n;if(typeof o.main>"u"&&typeof o.browser>"u")return n.push([T.default.Error,P.localize(7,null,"activationEvents","main","browser")]),n}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&n.push([T.default.Warning,P.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return n.push([T.default.Error,P.localize(9,null,"main")]),n;{const g=(0,y.$zg)(c,o.main);(0,y.$tg)(g,c)||n.push([T.default.Warning,P.localize(10,null,g.path,c.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return n.push([T.default.Error,P.localize(11,null,"browser")]),n;{const g=(0,y.$zg)(c,o.browser);(0,y.$tg)(g,c)||n.push([T.default.Warning,P.localize(12,null,g.path,c.path)])}}if(!M.valid(o.version))return n.push([T.default.Error,P.localize(13,null)]),n;const s=[];if(!b(i,r,o,h,s))for(const g of s)n.push([T.default.Error,g]);return n}e.$Vo=l;function b(i,r,c,o,h){return o||typeof c.main>"u"&&typeof c.browser>"u"?!0:f(i,r,c.engines.vscode,h)}e.$Wo=b;function v(i,r,c){return i==="*"||f(r,c,i)}e.$Xo=v;function f(i,r,c,o=[]){const h=I(d(c));if(!h)return o.push(P.localize(14,null,c)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return o.push(P.localize(15,null,c)),!1}else if(!h.majorMustEqual)return o.push(P.localize(16,null,c)),!1;return D(i,r,h)?!0:(o.push(P.localize(17,null,i,c)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let r=0,c=i.length;r<c;r++)if(typeof i[r]!="string")return!1;return!0}}),define(Pe[69],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=void 0;class y{constructor(P,M=[],A=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$Sh=y}),define(Pe[70],Ae([1,0,69]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.InstantiationType=void 0;const T=[];var P;(function($){$[$.Eager=0]="Eager",$[$.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M($,E,d){E instanceof y.$Sh||(E=new y.$Sh(E,[],!!d)),T.push([$,E])}e.$Cr=M;function A(){return T}e.$Dr=A}),define(Pe[183],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=e.$hq=void 0;class y{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$hq=y;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const $=this.lookupOrInsertNode(M),E=this.lookupOrInsertNode(A);$.outgoing.set(E.key,E),E.incoming.set($.key,$)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const $ of this.a.values())$.outgoing.delete(A),$.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let $=this.a.get(A);return $||($=new y(A,M),this.a.set(A,$)),$}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,$]of this.a)M.push(`${A}
	(-> incoming)[${[...$.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...$.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const $=new Set([M]),E=this.c(A,$);if(E)return E}}c(M,A){for(const[$,E]of M.outgoing){if(A.has($))return[...A,$].join(" -> ");A.add($);const d=this.c(E,A);if(d)return d;A.delete($)}}}e.$iq=T}),define(Pe[4],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function $(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=$})(y||(e._util=y={})),e.$Uh=P("instantiationService");function T(A,$,E){$[y.DI_TARGET]===$?$[y.DI_DEPENDENCIES].push({id:A,index:E}):($[y.DI_DEPENDENCIES]=[{id:A,index:E}],$[y.DI_TARGET]=$)}function P(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const $=function(E,d,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T($,E,I)};return $.toString=()=>A,y.serviceIds.set(A,$),$}e.$Vh=P;function M(A){return A}e.$Wh=M}),define(Pe[40],Ae([1,0,16,2,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ConfigurationTarget=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,P.$Vh)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof T.URI)}e.$qi=M;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof T.URI)}e.$ri=A;var $;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})($||(e.ConfigurationTarget=$={}));function E(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$si=E;function d(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$ti=d;function I(i,r){const c=Object.create(null);for(const o in i)D(c,o,i[o],r);return c}e.$ui=I;function D(i,r,c,o){const h=r.split("."),n=h.pop();let s=i;for(let a=0;a<h.length;a++){const g=h[a];let p=s[g];switch(typeof p){case"undefined":p=s[g]=Object.create(null);break;case"object":break;default:o(`Ignoring ${r} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(p)}`);return}s=p}if(typeof s=="object"&&s!==null)try{s[n]=c}catch{o(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${r} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$vi=D;function l(i,r){const c=r.split(".");b(i,c)}e.$wi=l;function b(i,r){const c=r.shift();if(r.length===0){delete i[c];return}if(Object.keys(i).indexOf(c)!==-1){const o=i[c];typeof o=="object"&&!Array.isArray(o)&&(b(o,r),Object.keys(o).length===0&&delete i[c])}}function v(i,r,c){function o(s,a){let g=s;for(const p of a){if(typeof g!="object"||g===null)return;g=g[p]}return g}const h=r.split("."),n=o(i,h);return typeof n>"u"?c:n}e.$xi=v;function f(i,r,c){Object.keys(r).forEach(o=>{o!=="__proto__"&&(o in i?y.$Ef(i[o])&&y.$Ef(r[o])?f(i[o],r[o],c):c&&(i[o]=r[o]):i[o]=r[o])})}e.$yi=f;function t(i){return i.replace(/[\[\]]/g,"")}e.$zi=t}),define(Pe[35],Ae([1,0,21,12,181,4,149,11]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.ContextKeyExprType=e.$Ri=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",y.$j),E.set("isLinux",y.$k),E.set("isWindows",y.$i),E.set("isWeb",y.$o),E.set("isMacNative",y.$j&&!y.$o),E.set("isEdge",y.$H),E.set("isFirefox",y.$F),E.set("isChrome",y.$E),E.set("isSafari",y.$G);function d(Y,B){if(E.get(Y)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(Y,B)}e.$Ri=d;const I=Object.prototype.hasOwnProperty;var D;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const l={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),v=(0,A.localize)(1,null),f=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),r=(0,A.localize)(5,null),c=(0,A.localize)(6,null),o=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=l){this.k=B,this.d=new P.$Qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const pe=this.D(),re=pe.type===17?r:void 0;throw this.h.push({message:i,offset:pe.offset,lexeme:P.$Qi.getLexeme(pe),additionalInfo:re}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ne=this.o();B.push(ne)}return B.length===1?B[0]:n.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ne=this.s();B.push(ne)}return B.length===1?B[0]:n.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),p.INSTANCE;case 12:return this.z(),m.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,t),ne?.negate()}case 17:return this.z(),F.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const ne=this.l();return this.A(1,t),ne}case 17:{const ne=B.lexeme;if(this.z(),this.y(9)){const re=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),re.type!==10)throw this.B("REGEX",re);const le=re.lexeme,ce=le.lastIndexOf("/"),ye=ce===le.length-1?void 0:this.w(le.substring(ce+1));let _;try{_=new RegExp(le.substring(1,ce),ye)}catch{throw this.B("REGEX",re)}return O.create(ne,_)}switch(re.type){case 10:case 19:{const le=[re.lexeme];this.z();let ce=this.D(),ye=0;for(let me=0;me<re.lexeme.length;me++)re.lexeme.charCodeAt(me)===40?ye++:re.lexeme.charCodeAt(me)===41&&ye--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:ye++;break;case 1:ye--;break;case 10:case 18:for(let me=0;me<ce.lexeme.length;me++)ce.lexeme.charCodeAt(me)===40?ye++:re.lexeme.charCodeAt(me)===41&&ye--}if(ye<0)break;le.push(P.$Qi.getLexeme(ce)),this.z(),ce=this.D()}const _=le.join(""),de=_.lastIndexOf("/"),ie=de===_.length-1?void 0:this.w(_.substring(de+1));let ae;try{ae=new RegExp(_.substring(1,de),ie)}catch{throw this.B("REGEX",re)}return n.regex(ne,ae)}case 18:{const le=re.lexeme;this.z();let ce=null;if(!(0,T.$Fe)(le)){const ye=le.indexOf("/"),_=le.lastIndexOf("/");if(ye!==_&&ye>=0){const de=le.slice(ye+1,_),ie=le[_+1]==="i"?"i":"";try{ce=new RegExp(de,ie)}catch{throw this.B("REGEX",re)}}}if(ce===null)throw this.B("REGEX",re);return O.create(ne,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const re=this.u();return n.notIn(ne,re)}switch(this.D().type){case 3:{this.z();const re=this.u();if(this.x().type===18)return n.equals(ne,re);switch(re){case"true":return n.has(ne);case"false":return n.not(ne);default:return n.equals(ne,re)}}case 4:{this.z();const re=this.u();if(this.x().type===18)return n.notEquals(ne,re);switch(re){case"true":return n.not(ne);case"false":return n.has(ne);default:return n.notEquals(ne,re)}}case 5:return this.z(),R.create(ne,this.u());case 6:return this.z(),L.create(ne,this.u());case 7:return this.z(),J.create(ne,this.u());case 8:return this.z(),N.create(ne,this.u());case 13:return this.z(),n.in(ne,this.u());default:return n.has(ne)}}case 20:throw this.h.push({message:c,offset:B.offset,lexeme:"",additionalInfo:o}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ne){if(this.C(B))return this.z();throw this.B(ne,this.D())}B(B,ne,pe){const re=(0,A.localize)(8,null,B,P.$Qi.getLexeme(ne)),le=ne.offset,ce=P.$Qi.getLexeme(ne);return this.h.push({message:re,offset:le,lexeme:ce,additionalInfo:pe}),h.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Si=h;class n{static false(){return p.INSTANCE}static true(){return m.INSTANCE}static has(B){return k.create(B)}static equals(B,ne){return C.create(B,ne)}static notEquals(B,ne){return S.create(B,ne)}static regex(B,ne){return O.create(B,ne)}static in(B,ne){return u.create(B,ne)}static notIn(B,ne){return w.create(B,ne)}static not(B){return F.create(B)}static and(...B){return $e.create(B,null,!0)}static or(...B){return De.create(B,null,!0)}static greater(B,ne){return J.create(B,ne)}static greaterEquals(B,ne){return N.create(B,ne)}static smaller(B,ne){return R.create(B,ne)}static smallerEquals(B,ne){return L.create(B,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Ti=n;function s(Y){const B=new h({regexParsingWithErrorRecovery:!1});return Y.map(ne=>(B.parse(ne),B.lexingErrors.length>0?B.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,A.localize)(9,null,pe.additionalInfo):(0,A.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.$Ui=s;function a(Y,B){const ne=Y?Y.substituteConstants():void 0,pe=B?B.substituteConstants():void 0;return!ne&&!pe?!0:!ne||!pe?!1:ne.equals(pe)}e.$Vi=a;function g(Y,B){return Y.cmp(B)}class p{static{this.INSTANCE=new p}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return m.INSTANCE}}e.$Wi=p;class m{static{this.INSTANCE=new m}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return p.INSTANCE}}e.$Xi=m;class k{static create(B,ne=null){const pe=E.get(B);return typeof pe=="boolean"?pe?m.INSTANCE:p.INSTANCE:new k(B,ne)}constructor(B,ne){this.key=B,this.c=ne,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:fe(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?m.INSTANCE:p.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Yi=k;class C{static create(B,ne,pe=null){if(typeof ne=="boolean")return ne?k.create(B,pe):F.create(B,pe);const re=E.get(B);return typeof re=="boolean"?ne===(re?"true":"false")?m.INSTANCE:p.INSTANCE:new C(B,ne,pe)}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?m.INSTANCE:p.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Zi=C;class u{static create(B,ne){return new u(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.f),pe=B.getValue(this.d);return Array.isArray(ne)?ne.includes(pe):typeof pe=="string"&&typeof ne=="object"&&ne!==null?I.call(ne,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$1i=u;class w{static create(B,ne){return new w(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=11,this.c=u.create(B,ne)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$2i=w;class S{static create(B,ne,pe=null){if(typeof ne=="boolean")return ne?F.create(B,pe):k.create(B,pe);const re=E.get(B);return typeof re=="boolean"?ne===(re?"true":"false")?p.INSTANCE:m.INSTANCE:new S(B,ne,pe)}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?p.INSTANCE:m.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$3i=S;class F{static create(B,ne=null){const pe=E.get(B);return typeof pe=="boolean"?pe?p.INSTANCE:m.INSTANCE:new F(B,ne)}constructor(B,ne){this.c=B,this.d=ne,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:fe(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=E.get(this.c);return typeof B=="boolean"?B?p.INSTANCE:m.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$4i=F;function V(Y,B){if(typeof Y=="string"){const ne=parseFloat(Y);isNaN(ne)||(Y=ne)}return typeof Y=="string"||typeof Y=="number"?B(Y):p.INSTANCE}class J{static create(B,ne,pe=null){return V(ne,re=>new J(B,re,pe))}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$5i=J;class N{static create(B,ne,pe=null){return V(ne,re=>new N(B,re,pe))}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$6i=N;class R{static create(B,ne,pe=null){return V(ne,re=>new R(B,re,pe))}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$7i=R;class L{static create(B,ne,pe=null){return V(ne,re=>new L(B,re,pe))}constructor(B,ne,pe){this.c=B,this.d=ne,this.f=pe,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ve(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$8i=L;class O{static create(B,ne){return new O(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ne=this.f?this.f.source:"",pe=B.f?B.f.source:"";return ne<pe?-1:ne>pe?1:0}equals(B){if(B.type===this.type){const ne=this.f?this.f.source:"",pe=B.f?B.f.source:"";return this.d===B.d&&ne===pe}return!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$9i=O;class Z{static create(B){return new Z(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new Z(this.c.map(B))}negate(){return this.c}}e.$0i=Z;function he(Y){let B=null;for(let ne=0,pe=Y.length;ne<pe;ne++){const re=Y[ne].substituteConstants();if(Y[ne]!==re&&B===null){B=[];for(let le=0;le<ne;le++)B[le]=Y[le]}B!==null&&(B[ne]=re)}return B===null?Y:B}class $e{static create(B,ne,pe){return $e.d(B,ne,pe)}constructor(B,ne){this.expr=B,this.c=ne,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,pe=this.expr.length;ne<pe;ne++){const re=g(this.expr[ne],B.expr[ne]);if(re!==0)return re}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=he(this.expr);return B===this.expr?this:$e.create(B,this.c,!1)}evaluate(B){for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].evaluate(B))return!1;return!0}static d(B,ne,pe){const re=[];let le=!1;for(const ce of B)if(ce){if(ce.type===1){le=!0;continue}if(ce.type===0)return p.INSTANCE;if(ce.type===6){re.push(...ce.expr);continue}re.push(ce)}if(re.length===0&&le)return m.INSTANCE;if(re.length!==0){if(re.length===1)return re[0];re.sort(g);for(let ce=1;ce<re.length;ce++)re[ce-1].equals(re[ce])&&(re.splice(ce,1),ce--);if(re.length===1)return re[0];for(;re.length>1;){const ce=re[re.length-1];if(ce.type!==9)break;re.pop();const ye=re.pop(),_=re.length===0,de=De.create(ce.expr.map(ie=>$e.create([ie,ye],null,pe)),null,_);de&&(re.push(de),re.sort(g))}if(re.length===1)return re[0];if(pe){for(let ce=0;ce<re.length;ce++)for(let ye=ce+1;ye<re.length;ye++)if(re[ce].negate().equals(re[ye]))return p.INSTANCE;if(re.length===1)return re[0]}return new $e(re,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new $e(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());this.c=De.create(B,this,!0)}return this.c}}e.$$i=$e;class De{static create(B,ne,pe){return De.d(B,ne,pe)}constructor(B,ne){this.expr=B,this.c=ne,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,pe=this.expr.length;ne<pe;ne++){const re=g(this.expr[ne],B.expr[ne]);if(re!==0)return re}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=he(this.expr);return B===this.expr?this:De.create(B,this.c,!1)}evaluate(B){for(let ne=0,pe=this.expr.length;ne<pe;ne++)if(this.expr[ne].evaluate(B))return!0;return!1}static d(B,ne,pe){let re=[],le=!1;if(B){for(let ce=0,ye=B.length;ce<ye;ce++){const _=B[ce];if(_){if(_.type===0){le=!0;continue}if(_.type===1)return m.INSTANCE;if(_.type===9){re=re.concat(_.expr);continue}re.push(_)}}if(re.length===0&&le)return p.INSTANCE;re.sort(g)}if(re.length!==0){if(re.length===1)return re[0];for(let ce=1;ce<re.length;ce++)re[ce-1].equals(re[ce])&&(re.splice(ce,1),ce--);if(re.length===1)return re[0];if(pe){for(let ce=0;ce<re.length;ce++)for(let ye=ce+1;ye<re.length;ye++)if(re[ce].negate().equals(re[ye]))return m.INSTANCE;if(re.length===1)return re[0]}return new De(re,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new De(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());for(;B.length>1;){const ne=B.shift(),pe=B.shift(),re=[];for(const le of se(ne))for(const ce of se(pe))re.push($e.create([le,ce],null,!1));B.unshift(De.create(re,null,!1))}this.c=De.create(B,this,!0)}return this.c}}e.$_i=De;class ke extends k{static{this.d=[]}static all(){return ke.d.values()}constructor(B,ne,pe){super(B,null),this.f=ne,typeof pe=="object"?ke.d.push({...pe,key:B}):pe!==!0&&ke.d.push({key:B,description:pe,type:ne!=null?typeof ne:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return C.create(this.key,B)}notEqualsTo(B){return S.create(this.key,B)}}e.$aj=ke,e.$bj=(0,M.$Vh)("contextKeyService");function fe(Y,B){return Y<B?-1:Y>B?1:0}function ve(Y,B,ne,pe){return Y<ne?-1:Y>ne?1:B<pe?-1:B>pe?1:0}function te(Y,B){if(Y.type===0||B.type===1)return!0;if(Y.type===9)return B.type===9?Re(Y.expr,B.expr):!1;if(B.type===9){for(const ne of B.expr)if(te(Y,ne))return!0;return!1}if(Y.type===6){if(B.type===6)return Re(B.expr,Y.expr);for(const ne of Y.expr)if(te(ne,B))return!0;return!1}return Y.equals(B)}e.$cj=te;function Re(Y,B){let ne=0,pe=0;for(;ne<Y.length&&pe<B.length;){const re=Y[ne].cmp(B[pe]);if(re<0)return!1;re===0&&ne++,pe++}return ne===Y.length}function se(Y){return Y.type===9?Y.expr:[Y]}}),define(Pe[184],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=void 0,e.$3h=(0,y.$Vh)("environmentService"),e.$4h=(0,y.$Wh)(e.$3h)}),define(Pe[96],Ae([1,0,151,4]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$do=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0,e.$4n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$5n=new RegExp(e.$4n),e.$6n="__web_extension",e.$7n="skipWalkthrough",e.$8n="extensionsSync",e.$9n="dependecyOrPackExtensionInstall";function P(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$0n=P;function M(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$$n=M;function A(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$_n=A;function $(i,r){return r==="web"&&!i.includes("web")}e.$ao=$;function E(i,r,c){return $(r,c)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===c}e.$bo=E;function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$co=d;var I;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var D;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var l;(function(i){i.Install="install",i.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$do=(0,T.$Vh)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var f;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class t extends Error{constructor(r,c){super(r),this.code=c,this.name=c}}e.$eo=t,e.$fo=(0,T.$Vh)("extensionManagementService"),e.$go="extensionsIdentifiers/disabled",e.$ho="extensionsIdentifiers/enabled",e.$io=(0,T.$Vh)("IGlobalExtensionEnablementService"),e.$jo=(0,T.$Vh)("IExtensionTipsService"),e.$ko=(0,y.localize)(0,null),e.$lo={value:e.$ko,original:"Extensions"},e.$mo={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Pe[41],Ae([1,0,50,20,12,16,2,153,4,21,13,44]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileKind=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileOperationResult=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileChangeType=e.$wk=e.FileOperation=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileSystemProviderErrorCode=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.FileSystemProviderCapabilities=e.$gk=e.FilePermission=e.FileType=e.$fk=e.$ek=void 0,e.$ek=(0,E.$Vh)("fileService");function l(te){return te.create===!0}e.$fk=l;var b;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var v;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function f(te){const Re=te;return!!Re&&typeof Re.onDidChange=="function"}e.$gk=f;var t;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(te){return!!(te.capabilities&2)}e.$hk=i;function r(te){return!!(te.capabilities&8)}e.$ik=r;function c(te){return!!(te.capabilities&131072)}e.$jk=c;function o(te){return!!(te.capabilities&4)}e.$kk=o;function h(te){return!!(te.capabilities&16)}e.$lk=h;function n(te){return i(te)?!!(te.capabilities&16384):!1}e.$mk=n;function s(te){return i(te)?!!(te.capabilities&32768):!1}e.$nk=s;function a(te){return!!(te.capabilities&65536)}e.$ok=a;function g(te){return!!(te.capabilities&2048)}e.$pk=g;var p;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(p||(e.FileSystemProviderErrorCode=p={}));class m extends Error{static create(Re,se){const Y=new m(Re.toString(),se);return u(Y,se),Y}constructor(Re,se){super(Re),this.code=se}}e.$qk=m;function k(te,Re){return m.create(te,Re)}e.$rk=k;function C(te){return te||k((0,$.localize)(0,null),p.Unknown)}e.$sk=C;function u(te,Re){return te.name=Re?`${Re} (FileSystemError)`:"FileSystemError",te}e.$tk=u;function w(te){if(!te)return p.Unknown;if(te instanceof m)return te.code;const Re=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!Re)return p.Unknown;switch(Re[1]){case p.FileExists:return p.FileExists;case p.FileIsADirectory:return p.FileIsADirectory;case p.FileNotADirectory:return p.FileNotADirectory;case p.FileNotFound:return p.FileNotFound;case p.FileTooLarge:return p.FileTooLarge;case p.FileWriteLocked:return p.FileWriteLocked;case p.NoPermissions:return p.NoPermissions;case p.Unavailable:return p.Unavailable}return p.Unknown}e.$uk=w;function S(te){if(te instanceof L)return te.fileOperationResult;switch(w(te)){case p.FileNotFound:return 1;case p.FileIsADirectory:return 0;case p.FileNotADirectory:return 9;case p.FileWriteLocked:return 5;case p.NoPermissions:return 6;case p.FileExists:return 4;case p.FileTooLarge:return 7;default:return 10}}e.$vk=S;var F;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(F||(e.FileOperation=F={}));class V{constructor(Re,se,Y){this.resource=Re,this.operation=se,this.target=Y}isOperation(Re){return this.operation===Re}}e.$wk=V;var J;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class N{static{this.a=null}constructor(Re,se){this.c=se,this.b=void 0,this.d=new D.$U(()=>{const Y=y.$2h.forUris(()=>this.c);return Y.fill(this.rawAdded.map(B=>[B,!0])),Y}),this.f=new D.$U(()=>{const Y=y.$2h.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(B=>[B,!0])),Y}),this.g=new D.$U(()=>{const Y=y.$2h.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(B=>[B,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Re){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==N.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=N.a):this.b!==void 0&&(this.b=N.a))}}contains(Re,...se){return this.h(Re,{includeChildren:!1},...se)}affects(Re,...se){return this.h(Re,{includeChildren:!0},...se)}h(Re,se,...Y){if(!Re)return!1;const B=Y.length>0;return!!((!B||Y.includes(1))&&(this.d.value.get(Re)||se.includeChildren&&this.d.value.findSuperstr(Re))||(!B||Y.includes(0))&&(this.f.value.get(Re)||se.includeChildren&&this.f.value.findSuperstr(Re))||(!B||Y.includes(2))&&(this.g.value.findSubstr(Re)||se.includeChildren&&this.g.value.findSuperstr(Re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Re){return this.b===Re}hasCorrelation(){return typeof this.b=="number"}}e.$xk=N;function R(te,Re,se){return!te||!Re||te===Re||Re.length>te.length?!1:(Re.charAt(Re.length-1)!==T.sep&&(Re+=T.sep),se?(0,P.$7e)(te,Re):te.indexOf(Re)===0)}e.$yk=R;class L extends Error{constructor(Re,se,Y){super(Re),this.fileOperationResult=se,this.options=Y}}e.$zk=L;class O extends L{constructor(Re,se,Y,B){super(Re,se,B),this.fileOperationResult=se,this.size=Y}}e.$Ak=O;class Z extends L{constructor(Re,se,Y){super(Re,2,Y),this.stat=se}}e.$Bk=Z;var he;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(he||(e.FileOperationResult=he={})),e.$Ck={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Dk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ek="files.associations",e.$Fk="files.exclude",e.$Gk="files.readonlyInclude",e.$Hk="files.readonlyExclude",e.$Ik="files.readonlyFromPermissions";var $e;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})($e||(e.FileKind=$e={})),e.$Jk="";function De(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}e.$Kk=De;async function ke(te,Re){if(!Re.hasProvider(A.URI.from({scheme:te.scheme})))return new Promise(se=>{const Y=Re.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===te.scheme&&B.added&&(Y.dispose(),se())})})}e.$Lk=ke;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(Re){return(0,M.$Gf)(Re)||(Re=0),Re<fe.KB?(0,$.localize)(1,null,Re.toFixed(0)):Re<fe.MB?(0,$.localize)(2,null,(Re/fe.KB).toFixed(2)):Re<fe.GB?(0,$.localize)(3,null,(Re/fe.MB).toFixed(2)):Re<fe.TB?(0,$.localize)(4,null,(Re/fe.GB).toFixed(2)):(0,$.localize)(5,null,(Re/fe.TB).toFixed(2))}}e.$Mk=fe;function ve(te){const Re=typeof te=="string"||te?.scheme===I.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===I.Schemas.file?1024*fe.MB:Re?10*fe.MB:d.$o?50*fe.MB:1024*fe.MB}e.$Nk=ve}),define(Pe[71],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=void 0;class y{constructor(...P){this.a=new Map;for(const[M,A]of P)this.set(M,A)}set(P,M){const A=this.a.get(P);return this.a.set(P,M),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Th=y}),define(Pe[185],Ae([1,0,14,11,6,69,183,4,71,186]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=void 0;const I=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class l{constructor(t=new E.$Th,i=!1,r,c=I){this.f=t,this.g=i,this.h=r,this.i=c,this.o=new Set,this.f.set($.$Uh,this),this._globalGraph=c?r?._globalGraph??new A.$iq(o=>o):void 0}createChild(t){return new l(t,this.g,this,this.i)}invokeFunction(t,...i){const r=v.traceInvocation(this.i,t);let c=!1;try{return t({get:h=>{if(c)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const n=this.m(h,r);if(!n)throw new Error(`[invokeFunction] unknown service '${h}'`);return n}},...i)}finally{c=!0,r.stop()}}createInstance(t,...i){let r,c;return t instanceof M.$Sh?(r=v.traceCreation(this.i,t.ctor),c=this.j(t.ctor,t.staticArguments.concat(i),r)):(r=v.traceCreation(this.i,t),c=this.j(t,i,r)),r.stop(),c}j(t,i=[],r){const c=$._util.getServiceDependencies(t).sort((n,s)=>n.index-s.index),o=[];for(const n of c){const s=this.m(n.id,r);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),o.push(s)}const h=c.length>0?c[0].index:i.length;if(i.length!==h){console.trace(`[createInstance] First service dependency of ${t.name} at position ${h+1} conflicts with ${i.length} static arguments`);const n=h-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,h)}return Reflect.construct(t,i.concat(o))}k(t,i){if(this.f.get(t)instanceof M.$Sh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const r=this.l(t);return r instanceof M.$Sh?this.q(t,r,i.branch(t,!0)):(i.branch(t,!1),r)}q(t,i,r){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,r)}finally{this.o.delete(t)}}r(t,i,r){const c=new A.$iq(n=>n.id.toString());let o=0;const h=[{id:t,desc:i,_trace:r}];for(;h.length;){const n=h.pop();if(c.lookupOrInsertNode(n),o++>1e3)throw new D(c);for(const s of $._util.getServiceDependencies(n.desc.ctor)){const a=this.l(s.id);if(a||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),a instanceof M.$Sh){const g={id:s.id,desc:a,_trace:n._trace.branch(s.id,!0)};c.insertEdge(n,g),h.push(g)}}}for(;;){const n=c.roots();if(n.length===0){if(!c.isEmpty())throw new D(c);break}for(const{data:s}of n){if(this.l(s.id)instanceof M.$Sh){const g=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,g)}c.removeNode(s)}}return this.l(t)}s(t,i,r=[],c,o){if(this.f.get(t)instanceof M.$Sh)return this.t(t,i,r,c,o);if(this.h)return this.h.s(t,i,r,c,o);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,r=[],c,o){if(c){const h=new l(void 0,this.g,this,this.i);h.c=String(t);const n=new Map,s=new y.$eh(()=>{const a=h.j(i,r,o);for(const[g,p]of n){const m=a[g];if(typeof m=="function")for(const k of p)m.apply(a,k)}return n.clear(),a});return new Proxy(Object.create(null),{get(a,g){if(!s.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let k=n.get(g);return k||(k=new d.$2c,n.set(g,k)),(u,w,S)=>{const F=k.push([u,w,S]);return(0,P.$Pc)(F)}}if(g in a)return a[g];const p=s.value;let m=p[g];return typeof m!="function"||(m=m.bind(p),a[g]=m),m},set(a,g,p){return s.value[g]=p,!0},getPrototypeOf(a){return i.prototype}})}else return this.j(i,r,o)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$jq=l;var b;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(b||(b={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new v(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(t,i){return t?new v(1,i.name):v.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const r=new v(3,t.toString());return this.h.push([t,i,r]),r}stop(){const t=Date.now()-this.g;v.f+=t;let i=!1;function r(o,h){const n=[],s=new Array(o+1).join("	");for(const[a,g,p]of h.h)if(g&&p){i=!0,n.push(`${s}CREATES -> ${a}`);const m=r(o+1,p);m&&n.push(m)}else n.push(`${s}uses -> ${a}`);return n.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(t>2||i)&&v.all.add(c.join(`
`))}}e.$kq=v}),define(Pe[15],Ae([1,0,39,5,97,6,28,21,25,16,2,35,4]),function(we,e,y,T,P,M,A,$,E,d,I,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.log=e.$gj=e.LogLevel=e.$fj=e.$ej=e.$dj=void 0,e.$dj=(0,l.$Vh)("logService"),e.$ej=(0,l.$Vh)("loggerService");function b(){return new Date().toISOString()}function v(u){return(0,d.$Gf)(u)}e.$fj=v;var f;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$gj=f.Info;function t(u,w,S){switch(w){case f.Trace:u.trace(S);break;case f.Debug:u.debug(S);break;case f.Info:u.info(S);break;case f.Warning:u.warn(S);break;case f.Error:u.error(S);break;case f.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=t;function i(u,w=!1){let S="";for(let F=0;F<u.length;F++){let V=u[F];if(V instanceof Error&&(V=(0,y.$Gi)(V,w)),typeof V=="object")try{V=JSON.stringify(V)}catch{}S+=(F>0?" ":"")+V}return S}class r extends M.$Rc{constructor(){super(...arguments),this.b=e.$gj,this.c=this.B(new T.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==f.Off&&this.b<=w}}e.$ij=r;class c extends r{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...S){this.f(f.Trace)&&this.g(f.Trace,i([w,...S],!0))}debug(w,...S){this.f(f.Debug)&&this.g(f.Debug,i([w,...S]))}info(w,...S){this.f(f.Info)&&this.g(f.Info,i([w,...S]))}warn(w,...S){this.f(f.Warning)&&this.g(f.Warning,i([w,...S]))}error(w,...S){if(this.f(f.Error))if(w instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=w.stack,this.g(f.Error,i(F))}else this.g(f.Error,i([w,...S]))}flush(){}}e.$jj=c;class o extends r{constructor(w=e.$gj){super(),this.setLevel(w),this.g=!$.$i}trace(w,...S){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...S):console.log(`[main ${b()}]`,w,...S))}debug(w,...S){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...S):console.log(`[main ${b()}]`,w,...S))}info(w,...S){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...S):console.log(`[main ${b()}]`,w,...S))}warn(w,...S){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,w,...S):console.warn(`[main ${b()}]`,w,...S))}error(w,...S){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,w,...S):console.error(`[main ${b()}]`,w,...S))}dispose(){}flush(){}}e.$kj=o;class h extends r{constructor(w=e.$gj,S=!0){super(),this.g=S,this.setLevel(w)}trace(w,...S){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...S):console.log(w,...S))}debug(w,...S){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...S):console.log(w,...S))}info(w,...S){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...S):console.log(w,...S))}warn(w,...S){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...S):console.log(w,...S))}error(w,...S){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...S):console.error(w,...S))}dispose(){}flush(){}}e.$lj=h;class n extends r{constructor(w,S=e.$gj){super(),this.g=w,this.setLevel(S)}trace(w,...S){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(w),...S])}debug(w,...S){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(w),...S])}info(w,...S){this.f(f.Info)&&this.g.log(f.Info,[this.h(w),...S])}warn(w,...S){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(w),...S])}error(w,...S){this.f(f.Error)&&this.g.log(f.Error,[this.h(w),...S])}h(w){return typeof w=="string"?w:(0,y.$Gi)(w,this.f(f.Trace))}dispose(){}flush(){}}e.$mj=n;class s extends r{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const S of this.g)S.setLevel(w);super.setLevel(w)}trace(w,...S){for(const F of this.g)F.trace(w,...S)}debug(w,...S){for(const F of this.g)F.debug(w,...S)}info(w,...S){for(const F of this.g)F.info(w,...S)}warn(w,...S){for(const F of this.g)F.warn(w,...S)}error(w,...S){for(const F of this.g)F.error(w,...S)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$nj=s;class a extends M.$Rc{constructor(w,S,F){if(super(),this.h=w,this.j=S,this.b=new A.$zc,this.c=this.B(new T.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Rd),this.onDidChangeVisibility=this.g.event,F)for(const V of F)this.b.set(V.resource,{logger:void 0,info:V})}m(w){return(0,d.$Cf)(w)?[...this.b.values()].find(S=>S.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,S){const F=this.n(w),V=(0,d.$Cf)(w)?w:S?.id??(0,P.$Ji)(F.toString()).toString(16);let J=this.b.get(F)?.logger;const N=S?.logLevel==="always"?f.Trace:S?.logLevel;J||(J=this.s(F,N??this.getLogLevel(F)??this.h,{...S,id:V}));const R={logger:J,info:{resource:F,id:V,logLevel:N,name:S?.name,hidden:S?.hidden,extensionId:S?.extensionId,when:S?.when}};return this.registerLogger(R.info),this.b.set(F,R),J}n(w){return(0,d.$Cf)(w)?(0,E.$zg)(this.j,`${w}.log`):w}setLogLevel(w,S){if(I.URI.isUri(w)){const F=w,V=S,J=this.b.get(F);J&&V!==J.info.logLevel&&(J.info.logLevel=V===this.h?void 0:V,J.logger?.setLevel(V),this.b.set(J.info.resource,J),this.f.fire([F,V]))}else{this.h=w;for(const[F,V]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,S){const F=this.m(w);F&&S!==!F.info.hidden&&(F.info.hidden=!S,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,S]))}getLogLevel(w){let S;return w&&(S=this.b.get(w)?.info.logLevel),S??this.h}registerLogger(w){const S=this.b.get(w.resource);S?S.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const S=this.b.get(w);S&&(S.logger&&S.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[S.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$oj=a;class g{constructor(){this.onDidChangeLogLevel=new T.$Rd().event}setLevel(w){}getLevel(){return f.Info}trace(w,...S){}debug(w,...S){}info(w,...S){}warn(w,...S){}error(w,...S){}critical(w,...S){}dispose(){}flush(){}}e.$pj=g;class p extends g{}e.$qj=p;function m(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const w=C(u.logLevel.toLowerCase());if(w!==void 0)return w}return e.$gj}e.$rj=m;function k(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$sj=k;function C(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$tj=C,e.$uj=new D.$aj("logLevel",k(f.Info))}),define(Pe[187],Ae([1,0,6,15]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=void 0;class P extends y.$Rc{constructor(A,$=[]){super(),this.a=new T.$nj([A,...$]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...$){this.a.trace(A,...$)}debug(A,...$){this.a.debug(A,...$)}info(A,...$){this.a.info(A,...$)}warn(A,...$){this.a.warn(A,...$)}error(A,...$){this.a.error(A,...$)}flush(){this.a.flush()}}e.$XN=P}),define(Pe[98],Ae([1,0,31,154,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function d(v,f){return f-v}E.compare=d;const I=Object.create(null);I[E.Error]=(0,T.localize)(0,null),I[E.Warning]=(0,T.localize)(1,null),I[E.Info]=(0,T.localize)(2,null);function D(v){return I[v]||""}E.toString=D;function l(v){switch(v){case y.default.Error:return E.Error;case y.default.Warning:return E.Warning;case y.default.Info:return E.Info;case y.default.Ignore:return E.Hint}}E.fromSeverity=l;function b(v){switch(v){case E.Error:return y.default.Error;case E.Warning:return y.default.Warning;case E.Info:return y.default.Info;case E.Hint:return y.default.Ignore}}E.toSeverity=b}(A||(e.MarkerSeverity=A={}));var $;(function(E){const d="";function I(l){return D(l,!0)}E.makeKey=I;function D(l,b){const v=[d];return l.source?v.push(l.source.replace("\xA6","\\\xA6")):v.push(d),l.code?typeof l.code=="string"?v.push(l.code.replace("\xA6","\\\xA6")):v.push(l.code.value.replace("\xA6","\\\xA6")):v.push(d),l.severity!==void 0&&l.severity!==null?v.push(A.toString(l.severity)):v.push(d),l.message&&b?v.push(l.message.replace("\xA6","\\\xA6")):v.push(d),l.startLineNumber!==void 0&&l.startLineNumber!==null?v.push(l.startLineNumber.toString()):v.push(d),l.startColumn!==void 0&&l.startColumn!==null?v.push(l.startColumn.toString()):v.push(d),l.endLineNumber!==void 0&&l.endLineNumber!==null?v.push(l.endLineNumber.toString()):v.push(d),l.endColumn!==void 0&&l.endColumn!==null?v.push(l.endColumn.toString()):v.push(d),v.push(d),v.join("\xA6")}E.makeKeyOptionalMessage=D})($||(e.IMarkerData=$={})),e.$ft=(0,P.$Vh)("markerService")}),define(Pe[188],Ae([1,0,5,31,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8u=e.$7u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$6u=e.Severity=void 0,e.Severity=T.default,e.$6u=(0,P.$Vh)("notificationService");var M;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var $;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})($||(e.NotificationsFilter=$={}));class E{constructor(){this.progress=new d,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$7u=E;class d{infinite(){}done(){}total(D){}worked(D){}}e.$8u=d}),define(Pe[99],Ae([1,0,12,2,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UU=e.$TU=e.$SU=e.$RU=e.$QU=void 0,e.$QU=(0,P.$Vh)("openerService");function M(d,I){return T.URI.isUri(d)?(0,y.$6e)(d.scheme,I):(0,y.$7e)(d,I+":")}e.$RU=M;function A(d,...I){return I.some(D=>M(d,D))}e.$SU=A;function $(d,I){return d.with({fragment:`${I.startLineNumber},${I.startColumn}${I.endLineNumber?`-${I.endLineNumber}${I.endColumn?`,${I.endColumn}`:""}`:""}`})}e.$TU=$;function E(d){let I;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(d.fragment);return D&&(I={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},d=d.with({fragment:""})),{selection:I,uri:d}}e.$UU=E}),define(Pe[189],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=void 0,e.$vj=(0,y.$Vh)("productService"),e.$wj="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(we,e,y,T){var P=arguments.length,M=P<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,y):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(we,e,y,T);else for(var $=we.length-1;$>=0;$--)(A=we[$])&&(M=(P<3?A(M):P>3?A(e,y,M):A(e,y))||M);return P>3&&M&&Object.defineProperty(e,y,M),M},Ve=this&&this.__param||function(we,e){return function(y,T){e(y,T,we)}};define(Pe[72],Ae([1,0,14,19,6,4]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.ProgressLocation=e.$9u=void 0,e.$9u=(0,M.$Vh)("progressService");var A;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$0u=Object.freeze({total(){},worked(){},done(){}});class ${static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$$u=$;class E{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const b=this.d;this.d=()=>{b?.(),l()}}):Promise.resolve()}}e.$_u=E;let d=class extends P.$Rc{constructor(l,b){super(),this.a=new y.$ih,b.withProgress(l,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,P.$Pc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$av=d,e.$av=d=Ke([Ve(1,e.$9u)],d);class I extends P.$Rc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new P.$Qc)}start(l){this.stop();const b=++this.a,v=new T.$2d;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,P.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Pc)(()=>v.cancel())),this.b.add((0,P.$Pc)(()=>this.c?this.c.done():void 0)),{id:b,token:v.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$bv=I,e.$cv=(0,M.$Vh)("editorProgressService")}),define(Pe[30],Ae([1,0,53,16]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class P{constructor(){this.a=new Map}add(A,$){y.ok(T.$Cf(A)),y.ok(T.$Ef($)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,$)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$mn=new P}),define(Pe[73],Ae([1,0,5,30]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0,e.$nn={JSONContribution:"base.contributions.json"};function P($){return $.length>0&&$.charAt($.length-1)==="#"?$.substring(0,$.length-1):$}class M{constructor(){this.b=new y.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,d){this.a[P(E)]=d,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;T.$mn.add(e.$nn.JSONContribution,A)}),define(Pe[54],Ae([1,0,18,5,16,148,40,73,30]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.ConfigurationScope=e.$rn=e.EditPresentationTypes=void 0;var d;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$rn={Configuration:"base.contributions.configuration"};var I;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn="vscode://schemas/settings/resourceLanguage",e.$zn="vscode://schemas/settings/configurationDefaults";const D=E.$mn.as($.$nn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Rd,this.onDidSchemaChange=this.i.event,this.j=new T.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$yn,this.g),this.v()}registerConfiguration(n,s=!0){this.registerConfigurations([n],s)}registerConfigurations(n,s=!0){const a=new Set;this.n(n,s,a),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(n){const s=new Set;this.o(n,s),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:n,remove:s}){const a=new Set;this.o(s,a),this.n(n,!1,a),D.registerSchema(e.$yn,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(n){const s=new Set;this.k(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(n,s){const a=[];for(const{overrides:g,source:p}of n)for(const m in g)if(s.add(m),e.$Bn.test(m)){const k=this.a.get(m),C=k?.valuesSources??new Map;if(p)for(const F of Object.keys(g[m]))C.set(F,p);const u={...k?.value||{},...g[m]};this.a.set(m,{source:p,value:u,valuesSources:C});const w=(0,A.$zi)(m),S={type:"object",default:u,description:M.localize(1,null,w),$ref:e.$yn,defaultDefaultValue:u,source:P.$Cf(p)?void 0:p,defaultValueSource:p};a.push(...f(m)),this.d[m]=S,this.b.properties[m]=S}else{this.a.set(m,{value:g[m],source:p});const k=this.d[m];k&&(this.w(m,k),this.r(m,k))}this.m(a)}deregisterDefaultConfigurations(n){const s=new Set;this.l(n,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(n,s){for(const{overrides:a,source:g}of n)for(const p in a){const m=this.a.get(p),k=P.$Cf(g)?g:g?.id,C=P.$Cf(m?.source)?m?.source:m?.source?.id;if(k===C)if(s.add(p),this.a.delete(p),e.$Bn.test(p))delete this.d[p],delete this.b.properties[p];else{const u=this.d[p];u&&(this.w(p,u),this.r(p,u))}}this.u()}deltaConfiguration(n){let s=!1;const a=new Set;n.removedDefaults&&(this.l(n.removedDefaults,a),s=!0),n.addedDefaults&&(this.k(n.addedDefaults,a),s=!0),n.removedConfigurations&&this.o(n.removedConfigurations,a),n.addedConfigurations&&this.n(n.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const s of n)this.h.add(s);this.u()}n(n,s,a){n.forEach(g=>{this.p(g,s,g.extensionInfo,g.restrictedProperties,void 0,a),this.c.push(g),this.q(g)})}o(n,s){const a=g=>{if(g.properties)for(const p in g.properties){s.add(p);const m=this.d[p];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[p],this.s(p,g.properties[p])}g.allOf?.forEach(p=>a(p))};for(const g of n){a(g);const p=this.c.indexOf(g);p!==-1&&this.c.splice(p,1)}}p(n,s=!0,a,g,p=3,m){p=P.$Lf(n.scope)?p:n.scope;const k=n.properties;if(k)for(const u in k){const w=k[u];if(s&&c(u,w)){delete k[u];continue}if(w.source=a,w.defaultDefaultValue=k[u].default,this.w(u,w),e.$Bn.test(u)?w.scope=void 0:(w.scope=P.$Lf(w.scope)?p:w.scope,w.restricted=P.$Lf(w.restricted)?!!g?.includes(u):w.restricted),k[u].hasOwnProperty("included")&&!k[u].included){this.f[u]=k[u],delete k[u];continue}else this.d[u]=k[u],k[u].policy?.name&&this.e.set(k[u].policy.name,u);!k[u].deprecationMessage&&k[u].markdownDeprecationMessage&&(k[u].deprecationMessage=k[u].markdownDeprecationMessage),m.add(u)}const C=n.allOf;if(C)for(const u of C)this.p(u,s,a,g,p,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const s=a=>{const g=a.properties;if(g)for(const m in g)this.r(m,g[m]);a.allOf?.forEach(s)};s(n)}r(n,s){switch(e.$sn.properties[n]=s,s.scope){case 1:e.$tn.properties[n]=s;break;case 2:e.$un.properties[n]=s;break;case 6:e.$vn.properties[n]=s;break;case 3:e.$wn.properties[n]=s;break;case 4:e.$xn.properties[n]=s;break;case 5:e.$xn.properties[n]=s,this.g.properties[n]=s;break}}s(n,s){switch(delete e.$sn.properties[n],s.scope){case 1:delete e.$tn.properties[n];break;case 2:delete e.$un.properties[n];break;case 6:delete e.$vn.properties[n];break;case 3:delete e.$wn.properties[n];break;case 4:case 5:delete e.$xn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const s=`[${n}]`,a={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$yn};this.w(s,a),e.$sn.properties[s]=a,e.$tn.properties[s]=a,e.$un.properties[s]=a,e.$vn.properties[s]=a,e.$wn.properties[s]=a,e.$xn.properties[s]=a}}v(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$yn};e.$sn.patternProperties[e.$An]=n,e.$tn.patternProperties[e.$An]=n,e.$un.patternProperties[e.$An]=n,e.$vn.patternProperties[e.$An]=n,e.$wn.patternProperties[e.$An]=n,e.$xn.patternProperties[e.$An]=n,this.i.fire()}w(n,s){const a=this.a.get(n);let g=a?.value,p=a?.source;P.$Jf(g)&&(g=s.defaultDefaultValue,p=void 0),P.$Jf(g)&&(g=i(s.type)),s.default=g,s.defaultValueSource=p}}const b="\\[([^\\]]+)\\]",v=new RegExp(b,"g");e.$An=`^(${b})+$`,e.$Bn=new RegExp(e.$An);function f(h){const n=[];if(e.$Bn.test(h)){let s=v.exec(h);for(;s?.length;){const a=s[1].trim();a&&n.push(a),s=v.exec(h)}}return(0,y.$Lb)(n)}e.$Cn=f;function t(h){return h.reduce((n,s)=>`${n}[${s}]`,"")}e.$Dn=t;function i(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$En=i;const r=new l;E.$mn.add(e.$rn.Configuration,r);function c(h,n){return h.trim()?e.$Bn.test(h)?M.localize(7,null,h):r.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):n.policy?.name&&r.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,h,n.policy?.name,r.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.$Fn=c;function o(){const h=[],n=r.getConfigurationProperties();for(const s of Object.keys(n))h.push([s,n[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$Gn=o}),define(Pe[190],Ae([1,0,18,5,119,6,28,26,16,2,40,54,30]),function(we,e,y,T,P,M,A,$,E,d,I,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=void 0;function b(s){return Object.isFrozen(s)?s:$.$bn(s)}class v{constructor(a={},g=[],p=[],m){this.b=a,this.c=g,this.d=p,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const a=this.raw.map(g=>{if(g instanceof v)return g;const p=new f("");return p.parseRaw(g),p.configurationModel});this.f=a.reduce((g,p)=>p===g?p:g.merge(p),a[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,I.$xi)(this.contents,a):this.contents}inspect(a,g){const p=this.rawConfiguration.getValue(a),m=g?this.rawConfiguration.getOverrideValue(a,g):void 0,k=g?this.rawConfiguration.override(g).getValue(a):p;return{value:p,override:m,merged:k}}getOverrideValue(a,g){const p=this.i(g);return p?a?(0,I.$xi)(p,a):p:void 0}getKeysForOverrideIdentifier(a){const g=[];for(const p of this.overrides)p.identifiers.includes(a)&&g.push(...p.keys);return y.$Lb(g)}getAllOverrideIdentifiers(){const a=[];for(const g of this.overrides)a.push(...g.identifiers);return y.$Lb(a)}override(a){let g=this.a.get(a);return g||(g=this.g(a),this.a.set(a,g)),g}merge(...a){const g=$.$an(this.contents),p=$.$an(this.overrides),m=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const C of a)if(k.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(g,C.contents);for(const u of C.overrides){const[w]=p.filter(S=>y.$tb(S.identifiers,u.identifiers));w?(this.h(w.contents,u.contents),w.keys.push(...u.keys),w.keys=y.$Lb(w.keys)):p.push($.$an(u))}for(const u of C.keys)m.indexOf(u)===-1&&m.push(u)}return new v(g,m,p,k.every(C=>C instanceof v)?void 0:k)}g(a){const g=this.i(a);if(!g||typeof g!="object"||!Object.keys(g).length)return this;const p={};for(const m of y.$Lb([...Object.keys(this.contents),...Object.keys(g)])){let k=this.contents[m];const C=g[m];C&&(typeof k=="object"&&typeof C=="object"?(k=$.$an(k),this.h(k,C)):k=C),p[m]=k}return new v(p,this.keys,this.overrides)}h(a,g){for(const p of Object.keys(g)){if(p in a&&E.$Ef(a[p])&&E.$Ef(g[p])){this.h(a[p],g[p]);continue}a[p]=$.$an(g[p])}}i(a){let g=null,p=null;const m=k=>{k&&(p?this.h(p,k):p=$.$an(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===a?g=k.contents:k.identifiers.includes(a)&&m(k.contents);return m(g),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,g){this.j(a,g,!0)}setValue(a,g){this.j(a,g,!1)}removeValue(a){const g=this.keys.indexOf(a);g!==-1&&(this.keys.splice(g,1),(0,I.$wi)(this.contents,a),D.$Bn.test(a)&&this.overrides.splice(this.overrides.findIndex(p=>y.$tb(p.identifiers,(0,D.$Cn)(a))),1))}j(a,g,p){(0,I.$vi)(this.contents,a,g,m=>console.error(m)),p=p||this.keys.indexOf(a)===-1,p&&this.keys.push(a),D.$Bn.test(a)&&this.overrides.push({identifiers:(0,D.$Cn)(a),keys:Object.keys(this.contents[a]),contents:(0,I.$ui)(this.contents[a],m=>console.error(m))})}}e.$Hn=v;class f{constructor(a){this.f=a,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,g){if(!E.$Lf(a)){const p=this.g(a);this.parseRaw(p,g)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,g){this.a=a;const{contents:p,keys:m,overrides:k,restricted:C,hasExcludedProperties:u}=this.h(a,g);this.b=new v(p,m,k,u?[a]:void 0),this.c=C||[]}g(a){let g={},p=null,m=[];const k=[],C=[];function u(S){Array.isArray(m)?m.push(S):p!==null&&(m[p]=S)}const w={onObjectBegin:()=>{const S={};u(S),k.push(m),m=S,p=null},onObjectProperty:S=>{p=S},onObjectEnd:()=>{m=k.pop()},onArrayBegin:()=>{const S=[];u(S),k.push(m),m=S,p=null},onArrayEnd:()=>{m=k.pop()},onLiteralValue:u,onError:(S,F,V)=>{C.push({error:S,offset:F,length:V})}};if(a)try{P.$0m(a,w),g=m[0]||{}}catch(S){console.error(`Error while parsing settings file ${this.f}: ${S}`),this.d=[S]}return g}h(a,g){const p=l.$mn.as(D.$rn.Configuration).getConfigurationProperties(),m=this.i(a,p,!0,g);a=m.raw;const k=(0,I.$ui)(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),C=Object.keys(a),u=this.j(a,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:k,keys:C,overrides:u,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(a,g,p,m){let k=!1;if(!m?.scopes&&!m?.skipRestricted&&!m?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:k};const C={},u=[];for(const w in a)if(D.$Bn.test(w)&&p){const S=this.i(a[w],g,!1,m);C[w]=S.raw,k=k||S.hasExcludedProperties,u.push(...S.restricted)}else{const S=g[w],F=S?typeof S.scope<"u"?S.scope:3:void 0;S?.restricted&&u.push(w),!m.exclude?.includes(w)&&(m.include?.includes(w)||(F===void 0||m.scopes===void 0||m.scopes.includes(F))&&!(m.skipRestricted&&S?.restricted))?C[w]=a[w]:k=!0}return{raw:C,restricted:u,hasExcludedProperties:k}}j(a,g){const p=[];for(const m of Object.keys(a))if(D.$Bn.test(m)){const k={};for(const C in a[m])k[C]=a[m][C];p.push({identifiers:(0,D.$Cn)(m),keys:Object.keys(k),contents:(0,I.$ui)(k,g)})}return p}}e.$In=f;class t extends M.$Rc{constructor(a,g,p,m){super(),this.c=a,this.f=g,this.g=m,this.b=this.B(new T.$Rd),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(p.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&p.isEqual(k.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Jn=t;class i{constructor(a,g,p,m,k,C,u,w,S,F,V,J,N){this.a=a,this.b=g,this.c=p,this.overrideIdentifiers=m,this.d=k,this.f=C,this.g=u,this.h=w,this.i=S,this.j=F,this.k=V,this.l=J,this.m=N}get value(){return b(this.c)}n(a,g,p){const m=a.inspect(g,p);return{get value(){return b(m.value)},get override(){return b(m.override)},get merged(){return b(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(a,g,p,m,k=new v,C=new v,u=new A.$zc,w=new v,S=new A.$zc){this.c=a,this.d=g,this.f=p,this.g=m,this.h=k,this.i=C,this.j=u,this.l=w,this.m=S,this.a=null,this.b=new A.$zc,this.n=null}getValue(a,g,p){return this.p(a,g,p).getValue(a)}updateValue(a,g,p={}){let m;p.resource?(m=this.m.get(p.resource),m||(m=new v,this.m.set(p.resource,m))):m=this.l,g===void 0?m.removeValue(a):m.setValue(a,g),p.resource||(this.a=null)}inspect(a,g,p){const m=this.p(a,g,p),k=this.t(g.resource,p),C=g.resource?this.m.get(g.resource)||this.l:this.l,u=new Set;for(const w of m.overrides)for(const S of w.identifiers)m.getOverrideValue(a,S)!==void 0&&u.add(S);return new i(a,g,m.getValue(a),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,p?this.i:void 0,k||void 0,C)}keys(a){const g=this.t(void 0,a);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:g?g.keys.slice(0):[]}}updateDefaultConfiguration(a){this.c=a,this.a=null,this.b.clear()}updatePolicyConfiguration(a){this.d=a}updateApplicationConfiguration(a){this.f=a,this.a=null,this.b.clear()}updateLocalUserConfiguration(a){this.g=a,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(a){this.h=a,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(a){this.i=a,this.a=null,this.b.clear()}updateFolderConfiguration(a,g){this.j.set(a,g),this.b.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.b.delete(a)}compareAndUpdateDefaultConfiguration(a,g){const p=[];if(!g){const{added:m,updated:k,removed:C}=h(this.c,a);g=[...m,...k,...C]}for(const m of g)for(const k of(0,D.$Cn)(m)){const C=this.c.getKeysForOverrideIdentifier(k),u=a.getKeysForOverrideIdentifier(k),w=[...u.filter(S=>C.indexOf(S)===-1),...C.filter(S=>u.indexOf(S)===-1),...C.filter(S=>!$.$en(this.c.override(k).getValue(S),a.override(k).getValue(S)))];p.push([k,w])}return this.updateDefaultConfiguration(a),{keys:g,overrides:p}}compareAndUpdatePolicyConfiguration(a){const{added:g,updated:p,removed:m}=h(this.d,a),k=[...g,...p,...m];return k.length&&this.updatePolicyConfiguration(a),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:g,updated:p,removed:m,overrides:k}=h(this.applicationConfiguration,a),C=[...g,...p,...m];return C.length&&this.updateApplicationConfiguration(a),{keys:C,overrides:k}}compareAndUpdateLocalUserConfiguration(a){const{added:g,updated:p,removed:m,overrides:k}=h(this.localUserConfiguration,a),C=[...g,...p,...m];return C.length&&this.updateLocalUserConfiguration(a),{keys:C,overrides:k}}compareAndUpdateRemoteUserConfiguration(a){const{added:g,updated:p,removed:m,overrides:k}=h(this.remoteUserConfiguration,a),C=[...g,...p,...m];return C.length&&this.updateRemoteUserConfiguration(a),{keys:C,overrides:k}}compareAndUpdateWorkspaceConfiguration(a){const{added:g,updated:p,removed:m,overrides:k}=h(this.workspaceConfiguration,a),C=[...g,...p,...m];return C.length&&this.updateWorkspaceConfiguration(a),{keys:C,overrides:k}}compareAndUpdateFolderConfiguration(a,g){const p=this.folderConfigurations.get(a),{added:m,updated:k,removed:C,overrides:u}=h(p,g),w=[...m,...k,...C];return(w.length||!p)&&this.updateFolderConfiguration(a,g),{keys:w,overrides:u}}compareAndDeleteFolderConfiguration(a){const g=this.folderConfigurations.get(a);if(!g)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:p,updated:m,removed:k,overrides:C}=h(g,void 0);return{keys:[...p,...m,...k],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(a,g,p){let m=this.q(g,p);return g.overrideIdentifier&&(m=m.override(g.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(a)!==void 0&&(m=m.merge(this.d)),m}q({resource:a},g){let p=this.r();if(g&&a){const m=g.getFolder(a);m&&(p=this.s(m.uri)||p);const k=this.m.get(a);k&&(p=p.merge(k))}return p}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(a){let g=this.b.get(a);if(!g){const p=this.r(),m=this.j.get(a);m?(g=p.merge(m),this.b.set(a,g)):g=p}return g}t(a,g){if(g&&a){const p=g.getFolder(a);if(p)return this.j.get(p.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((a,g)=>{const{contents:p,overrides:m,keys:k}=this.j.get(g);return a.push([g,{contents:p,overrides:m,keys:k}]),a},[])}}allKeys(){const a=new Set;return this.c.keys.forEach(g=>a.add(g)),this.userConfiguration.keys.forEach(g=>a.add(g)),this.i.keys.forEach(g=>a.add(g)),this.j.forEach(g=>g.keys.forEach(p=>a.add(p))),[...a.values()]}u(){const a=new Set;return this.c.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.userConfiguration.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.i.getAllOverrideIdentifiers().forEach(g=>a.add(g)),this.j.forEach(g=>g.getAllOverrideIdentifiers().forEach(p=>a.add(p))),[...a.values()]}v(a){const g=new Set;return this.c.getKeysForOverrideIdentifier(a).forEach(p=>g.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(p=>g.add(p)),this.i.getKeysForOverrideIdentifier(a).forEach(p=>g.add(p)),this.j.forEach(p=>p.getKeysForOverrideIdentifier(a).forEach(m=>g.add(m))),[...g.values()]}static parse(a){const g=this.w(a.defaults),p=this.w(a.policy),m=this.w(a.application),k=this.w(a.user),C=this.w(a.workspace),u=a.folders.reduce((w,S)=>(w.set(d.URI.revive(S[0]),this.w(S[1])),w),new A.$zc);return new r(g,p,m,k,new v,C,u,new v,new A.$zc)}static w(a){return new v(a.contents,a.keys,a.overrides)}}e.$Kn=r;function c(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const a=new Set,g=new Map;for(const m of s)m.keys.forEach(k=>a.add(k)),m.overrides.forEach(([k,C])=>{const u=(0,A.$wc)(g,k,new Set);C.forEach(w=>u.add(w))});const p=[];return g.forEach((m,k)=>p.push([k,[...m.values()]])),{keys:[...a.values()],overrides:p}}e.$Ln=c;class o{constructor(a,g,p,m){this.change=a,this.f=g,this.g=p,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of a.keys)this.affectedKeys.add(k);for(const[,k]of a.overrides)for(const C of k)this.affectedKeys.add(C);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(a,g){const p=this.a+a,m=this.d.indexOf(p);if(m<0)return!1;const k=m+p.length;if(k>=this.d.length)return!1;const C=this.d.charCodeAt(k);if(C!==this.b&&C!==this.c)return!1;if(g){const u=this.previousConfiguration?this.previousConfiguration.getValue(a,g,this.f?.workspace):void 0,w=this.g.getValue(a,g,this.h);return!$.$en(u,w)}return!0}}e.$Mn=o;function h(s,a){const{added:g,removed:p,updated:m}=n(a?.rawConfiguration,s?.rawConfiguration),k=[],C=s?.getAllOverrideIdentifiers()||[],u=a?.getAllOverrideIdentifiers()||[];if(a){const w=u.filter(S=>!C.includes(S));for(const S of w)k.push([S,a.getKeysForOverrideIdentifier(S)])}if(s){const w=C.filter(S=>!u.includes(S));for(const S of w)k.push([S,s.getKeysForOverrideIdentifier(S)])}if(a&&s){for(const w of C)if(u.includes(w)){const S=n({contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)},{contents:a.getOverrideValue(void 0,w)||{},keys:a.getKeysForOverrideIdentifier(w)});k.push([w,[...S.added,...S.removed,...S.updated]])}}return{added:g,removed:p,updated:m,overrides:k}}function n(s,a){const g=s?a?s.keys.filter(k=>a.keys.indexOf(k)===-1):[...s.keys]:[],p=a?s?a.keys.filter(k=>s.keys.indexOf(k)===-1):[...a.keys]:[],m=[];if(s&&a){for(const k of a.keys)if(s.keys.indexOf(k)!==-1){const C=(0,I.$xi)(a.contents,k),u=(0,I.$xi)(s.contents,k);$.$en(C,u)||m.push(k)}}return{added:g,removed:p,updated:m}}}),define(Pe[100],Ae([1,0,11,4]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.RemoteAuthorityResolverErrorCode=e.$Xk=e.$Wk=e.RemoteConnectionType=e.$Vk=void 0,e.$Vk=(0,T.$Vh)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Wk=M;class A{constructor(D,l){this.host=D,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Xk=A;var $;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})($||(e.RemoteAuthorityResolverErrorCode=$={}));class E extends y.$ab{static isNotAvailable(D){return D instanceof E&&D._code===$.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof E&&D._code===$.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof E&&D._code===$.NoResolverFound}static isInvalidAuthority(D){return D instanceof E&&D._code===$.InvalidAuthority}static isHandled(D){return D instanceof E&&D.isHandled}constructor(D,l=$.Unknown,b){super(D),this._message=D,this._code=l,this._detail=b,this.isHandled=l===$.NotAvailable&&b===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Yk=E;function d(I){const D=I.indexOf("+");return D===-1?I:I.substring(0,D)}e.$Zk=d}),define(Pe[55],Ae([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=void 0;function T(d){return d.scheme===y.Schemas.vscodeRemote?d.authority:void 0}e.$1k=T;function P(d){if(!d)return;const I=d.indexOf("+");return I<0?d:d.substr(0,I)}e.$2k=P;function M(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$3k=M;function A(d){const{host:I,port:D}=E(d);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:D}}e.$4k=A;function $(d,I){let{host:D,port:l}=E(d);return typeof l>"u"&&(l=I),{host:D,port:l}}e.$5k=$;function E(d){const I=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const D=d.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const l=d.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:d,port:void 0}}}),define(Pe[22],Ae([1,0,12,4,55]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.TargetPlatform=e.ExtensionType=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l="extensions.user.cache",e.$7l="extensions.builtin.cache",e.$8l="undefined_publisher",e.$9l=["ui","workspace","web"];function M(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$0l=M,e.$$l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(A||(e.ExtensionType=A={}));var $;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})($||(e.TargetPlatform=$={}));class E{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const r=typeof t=="string"?t:t.value,c=typeof i=="string"?i:i.value;return y.$6e(r,c)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$_l=E;class d{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(E.toKey(t))}delete(t){return this.c.delete(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}}e.$am=d;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(E.toKey(t))}get(t){return this.c.get(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}set(t,i){this.c.set(E.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$bm=I;function D(f){return l(f)}e.$cm=D;function l(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$dm=l;function b(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$em=b;function v(f,t){if(t){const i=`onResolveRemoteAuthority:${(0,P.$2k)(t)}`;return!!f.activationEvents?.includes(i)}return!1}e.$fm=v,e.$gm=(0,T.$Vh)("IBuiltinExtensionsScannerService")}),define(Pe[101],Ae([1,0,11,22]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xF=e.$wF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,$){this.a.set(A,$)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const $=Object.create(null);for(const E of A){const d=this.readActivationEvents(E);d.length>0&&($[T.$_l.toKey(E.identifier)]=d)}return $}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const $=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let E=0;E<$.length;E++)$[E]==="onUri"&&($[E]=`onUri:${T.$_l.toKey(A.identifier)}`);if(!A.contributes)return $;for(const E in A.contributes){const d=this.a.get(E);if(!d)continue;const I=A.contributes[E],D=Array.isArray(I)?I:[I];try{d(D,$)}catch(l){(0,y.$Z)(l)}}return $}}e.$wF=P,e.$xF=new P}),define(Pe[191],Ae([1,0,21,74,33]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=void 0;function M(E){if(y.$u===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,d,I,D,l,b,v,f,t){const i=Object.create(null);i["common.machineId"]=b,i["common.sqmId"]=v,i.sessionID=(0,P.$ig)()+Date.now(),i.commitHash=D,i.version=l,i["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,y.$h)(y.$u),i["common.nodePlatform"]=T.$cc,i["common.nodeArch"]=I,i["common.product"]=t||"desktop",f&&(i["common.msftInternal"]=f);let r=0;const c=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),y.$l&&(i["common.snap"]="true");const o=M(d);return o&&(i["common.platformDetail"]=o),i}e.$no=A;function $(E){const d=T.env.USERDNSDOMAIN;if(!d)return!1;const I=d.toLowerCase();return E.some(D=>I===D)}e.$oo=$}),define(Pe[192],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0,e.$il=(0,y.$Vh)("telemetryService"),e.$jl=(0,y.$Vh)("customEndpointTelemetryService"),e.$kl="telemetry.currentSessionDate",e.$ll="telemetry.firstSessionDate",e.$ml="telemetry.lastSessionDate",e.$nl="telemetry.machineId",e.$ol="telemetry.sqmId",e.$pl="telemetry",e.$ql="telemetry.telemetryLevel",e.$rl="telemetry.enableCrashReporter",e.$sl="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Pe[56],Ae([1,0,26,16,5,40,55,191,192]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;class d{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$po=d;class I{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$qo=I,e.$ro=new I;class D{async publicLog(p,m,k){}async publicLogError(p,m,k){}}e.$so=D,e.$to="telemetry",e.$uo="extensionTelemetryLog",e.$vo={log:()=>null,flush:()=>Promise.resolve(null)};function l(g,p){return P.Event.debounce(p.onDidChangeConfiguration,(k,C)=>{const u=k?new Set([...k.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:u}},1e3,!0)(k=>{k.source!==7&&g.publicLog2("updateConfiguration",{configurationSource:(0,M.$si)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$wo=l;function b(g,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!g.enableTelemetry)}e.$xo=b;function v(g,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}e.$yo=v;function f(g){const p=g.getValue(E.$ql),m=g.getValue(E.$rl);if(g.getValue(E.$sl)===!1||m===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$zo=f;function t(g){const p={},m={},k={};c(g,k);for(let C in k){C=C.length>150?C.substr(C.length-149):C;const u=k[C];typeof u=="number"?m[C]=u:typeof u=="boolean"?m[C]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${u.length}`),p[C]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(p[C]=u)}return{properties:p,measurements:m}}e.$Ao=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(g){if(!g)return"none";const p=(0,A.$2k)(g);return i.has(p)?p:"other"}e.$Bo=r;function c(g,p,m=0,k){if(g)for(const C of Object.getOwnPropertyNames(g)){const u=g[C],w=k?k+C:C;Array.isArray(u)?p[w]=(0,y.$fn)(u):u instanceof Date?p[w]=u.toISOString():(0,T.$Ef)(u)?m<2?c(u,p,m+1,w+"."):p[w]=(0,y.$fn)(u):p[w]=u}}function o(g,p){const m=g.msftInternalDomains||[],k=p.getValue("telemetry.internalTesting");return(0,$.$oo)(m)||k}e.$Co=o;function h(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}e.$Do=h;function n(g,p){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let m=g;const k=[];for(const S of p)for(;;){const F=S.exec(g);if(!F)break;k.push([F.index,S.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(m="";;){const S=u.exec(g);if(!S)break;const F=k.some(([V,J])=>S.index<J&&V<u.lastIndex);!C.test(S[0])&&!F&&(m+=g.substring(w,S.index)+"<REDACTED: user-file-path>",w=u.lastIndex)}return w<g.length&&(m+=g.substr(w)),m}function s(g){if(!g)return g;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of p)if(m.regex.test(g))return`<REDACTED: ${m.label}>`;return g}function a(g,p){return(0,y.$cn)(g,m=>{if(m instanceof d||Object.hasOwnProperty.call(m,"isTrustedTelemetryValue"))return m.value;if(typeof m=="string"){let k=m.replaceAll("%20"," ");k=n(k,p);for(const C of p)k=k.replace(C,"");return k=s(k),k}})}e.$Eo=a}),define(Pe[193],Ae([1,0,12,96,22,21,2,11,74,56]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0;function I(a,g){return a.uuid&&g.uuid?a.uuid===g.uuid:a.id===g.id?!0:(0,y.$1e)(a.id,g.id)===0}e.$Fo=I;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(g){const p=g.manifest?g.manifest.version:g.version,m=g.manifest?g.targetPlatform:g.properties.targetPlatform;return new l(g.identifier,p,m)}static parse(g){const p=D.exec(g);return p&&p[1]&&p[2]?new l({id:p[1]},p[2],p[4]||void 0):null}constructor(g,p,m="undefined"){this.version=p,this.targetPlatform=m,this.id=g.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(g){return g instanceof l?I(this,g)&&this.version===g.version&&this.targetPlatform===g.targetPlatform:!1}}e.$Go=l;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(a){const g=b.exec(a);return g&&g[1]?[t(g[1]),g[2]]:[t(a),void 0]}e.$Ho=v;function f(a,g){return`${a}.${g}`}e.$Io=f;function t(a){return a.toLowerCase()}e.$Jo=t;function i(a,g){return t(f(a??P.$8l,g))}e.$Ko=i;function r(a,g){const p=[],m=k=>{for(const C of p)if(C.some(u=>I(g(u),g(k))))return C;return null};for(const k of a){const C=m(k);C?C.push(k):p.push([k])}return p}e.$Lo=r;function c(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.$Mo=c;function o(a){return{id:new d.$po(a.identifier.id),name:new d.$po(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$No=o,e.$Oo=new P.$_l("pprice.better-merge");function h(a,g){const p=[],m=g.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const k=m.shift();if(k&&p.every(C=>!I(C.identifier,{id:k}))){const C=a.filter(u=>I(u.identifier,{id:k}));C.length===1&&(p.push(C[0]),m.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.$Po=h;async function n(a,g){if(!M.$k)return!1;let p;try{p=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){g.debug("Error while getting the os-release file.",(0,$.$9)(k))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(a,g){const p=await n(a,g),m=(0,T.$_n)(p?"alpine":M.$u,E.$dc);return g.debug("ComputeTargetPlatform:",m),m}e.$Qo=s}),define(Pe[194],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=void 0;function y(E){return[...E.entries()]}e.$qr=y;function T(E){return E?[...E.entries()]:[]}e.$rr=T;function P(E){return new Map(E)}e.$sr=P;function M(E){return new Map(E??[])}e.$tr=M;function A(E){return Array.from(E.entries()).map(d=>[d[0],y(d[1].map),T(d[1].descriptionMap)])}e.$ur=A;function $(E){return new Map(E.map(d=>[d[0],{map:P(d[1]),descriptionMap:M(d[2])}]))}e.$vr=$}),define(Pe[195],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yqb=void 0;class y{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,A=5){const $=M(E=>{const d=typeof E=="string"?E:E.data;let I=this.a.get(P);if(I){I.data.push(d);return}const D=setTimeout(()=>this.flushBuffer(P),A);I={data:[d],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(P),$.dispose()}},this.a.set(P,I)});return $}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$yqb=y}),define(Pe[196],Ae([1,0,14,90,45,5,16,2,155,73,30]),function(we,e,y,T,P,M,A,$,E,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.IconFontDefinition=e.IconContribution=e.$_v=void 0,e.$_v={IconContribution:"base.contributions.icons"};var D;(function(o){function h(n,s){let a=n.defaults;for(;P.ThemeIcon.isThemeIcon(a);){const g=v.getIcon(a.id);if(!g)return;a=g.defaults}return a}o.getDefinition=h})(D||(e.IconContribution=D={}));var l;(function(o){function h(s){return{weight:s.weight,style:s.style,src:s.src.map(a=>({format:a.format,location:a.location.toString()}))}}o.toJSONObject=h;function n(s){const a=g=>(0,A.$Cf)(g)?g:void 0;if(s&&Array.isArray(s.src)&&s.src.every(g=>(0,A.$Cf)(g.format)&&(0,A.$Cf)(g.location)))return{weight:a(s.weight),style:a(s.style),src:s.src.map(g=>({format:g.format,location:$.URI.parse(g.location)}))}}o.fromJSONObject=n})(l||(e.IconFontDefinition=l={}));class b{constructor(){this.a=new M.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,n,s,a){const g=this.b[h];if(g){if(s&&!g.description){g.description=s,this.d.properties[h].markdownDescription=`${s} $(${h})`;const k=this.e.enum.indexOf(h);k!==-1&&(this.e.enumDescriptions[k]=s),this.a.fire()}return g}const p={id:h,description:s,defaults:n,deprecationMessage:a};this.b[h]=p;const m={$ref:"#/definitions/icons"};return a&&(m.deprecationMessage=a),s&&(m.markdownDescription=`${s}: $(${h})`),this.d.properties[h]=m,this.e.enum.push(h),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const n=this.e.enum.indexOf(h);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,n){const s=this.f[h];return s||(this.f[h]=n,this.a.fire(),n)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(g,p)=>g.id.localeCompare(p.id),n=g=>{for(;P.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(g=>this.b[g]);for(const g of a.filter(p=>!!p.description).sort(h))s.push(`|<i class="${n(g)}"></i>|${g.id}|${P.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const g of a.filter(p=>!P.ThemeIcon.isThemeIcon(p.defaults)).sort(h))s.push(`|<i class="${n(g)}"></i>|${g.id}|`);return s.join(`
`)}}const v=new b;I.$mn.add(e.$_v.IconContribution,v);function f(o,h,n,s){return v.registerIcon(o,h,n,s)}e.$aw=f;function t(){return v}e.$bw=t;function i(){const o=(0,T.$Yj)();for(const h in o){const n="\\"+o[h].toString(16);v.registerIcon(h,{fontCharacter:n})}}i(),e.$cw="vscode://schemas/icons";const r=I.$mn.as(d.$nn.JSONContribution);r.registerSchema(e.$cw,v.getIconSchema());const c=new y.$0g(()=>r.notifySchemaChanged(e.$cw),200);v.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$dw=f("widget-close",T.$1j.close,(0,E.localize)(2,null)),e.$ew=f("goto-previous-location",T.$1j.arrowUp,(0,E.localize)(3,null)),e.$fw=f("goto-next-location",T.$1j.arrowDown,(0,E.localize)(4,null)),e.$gw=P.ThemeIcon.modify(T.$1j.sync,"spin"),e.$hw=P.ThemeIcon.modify(T.$1j.loading,"spin")}),define(Pe[197],Ae([1,0,5,40,4,15]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProvidedOnAutoForward=e.$fv=e.TunnelPrivacyId=e.TunnelProtocol=e.$ev=e.$dv=void 0,e.$dv=(0,P.$Vh)("tunnelService"),e.$ev=(0,P.$Vh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var $;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})($||(e.TunnelPrivacyId=$={}));function E(t){return!!t.forwardPort}e.$fv=E;var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function I(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$gv=I,e.$hv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$hv.indexOf(t)>=0}e.$iv=D,e.$jv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(t){return e.$jv.indexOf(t)>=0}e.$kv=l;function b(t,i,r,c){if(r===1)return!1;if(r===2&&l(i)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(o?.length===4&&parseInt(o[1])>=18)return!1}return t<1024}e.$lv=b;class v{constructor(i,r,c){this.remoteAddress=i,this.localAddress=r,this.b=c,this.a=new y.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$mv=v;let f=class{constructor(i,r){this.j=i,this.k=r,this.a=new y.$Rd,this.onTunnelOpened=this.a.event,this.b=new y.$Rd,this.onTunnelClosed=this.b.event,this.c=new y.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],r=Array.from(this.e.values());for(const c of r){const o=Array.from(c.values());for(const h of o){const n=await h.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(c=>typeof c!="string"?c?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,c,o,h){this.p(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:c,privacy:o,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(l(i)||D(i))&&(i=e.$hv[0]);const c=this.r(i,r);if(c)return++c.refcount,c.value}openTunnel(i,r,c,o,h,n=!1,s,a){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${c} on local port ${h}.`);const g=this.f??i;if(!g)return;if(r||(r="localhost"),o||(o=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const p=this.s(g,r,c,o,h,n,s,a);return p?p.then(m=>{if(m){if(typeof m=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,c),m}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(m);return(m.tunnelRemoteHost!==r||m.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&m.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const c=r.get(i.tunnelRemotePort);c&&(c.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,c))}}}}async o(i,r,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const o=c.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),o}}async closeTunnel(i,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const c=this.e.get(i);if(c&&c.has(r)){const o=c.get(r);o.refcount=0,await this.o(i,r,o)}}p(i,r,c){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:c})}async q(i,r){const c=this.e.get(i);if(c){const o=c.get(r),h=o?await o.value:void 0;(!h||typeof h=="string")&&c.delete(r),c.size===0&&this.e.delete(i)}}r(i,r){const c=[i];D(i)?(c.push(...e.$hv),c.push(...e.$jv)):l(i)&&c.push(...e.$jv);const o=c.map(h=>this.e.get(h));for(const h of o){const n=h?.get(r);if(n)return n}}canTunnel(i){return!!I(i)}t(i,r,c,o,h,n,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${c} on local port ${o}.`);const a=c;this.i.add(a);const g=o===void 0?c:o,p={elevationRequired:h?this.isPortPrivileged(g):!1},m={remoteAddress:{host:r,port:c},localAddressPort:o,privacy:n,public:n?n!==$.Private:void 0,protocol:s},k=i.forwardPort(m,p);return k?(this.p(r,c,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(a)})):this.i.delete(a),k}};e.$nv=f,e.$nv=f=Ke([Ve(0,M.$dj),Ve(1,T.$pi)],f)}),define(Pe[198],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$ov=void 0,e.$ov=(0,y.$Vh)("editSessionIdentityService");var T;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[199],Ae([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=void 0;function T(E){return E.scheme!==y.Schemas.file&&E.scheme!==y.Schemas.vscodeRemote}e.$8J=T;function P(E){if(E.folders.length)return E.folders.every(d=>T(d.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.$9J=P;function M(E){return P(E)?.scheme}e.$0J=M;function A(E){return P(E)?.authority}e.$$J=A;function $(E){return P(E)!==void 0}e.$_J=$}),define(Pe[47],Ae([1,0,156,20,50,25,2,4,13]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.WorkbenchState=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0,e.$5h=(0,$.$Vh)("contextService");function d(g){const p=g;return typeof p?.id=="string"&&A.URI.isUri(p.uri)}e.$6h=d;function I(g){return typeof g?.id=="string"&&!d(g)&&!l(g)}e.$7h=I,e.$8h={id:"ext-dev"},e.$9h={id:"empty-window"};function D(g,p){if(typeof g=="string"||typeof g>"u")return typeof g=="string"?{id:(0,T.$mc)(g)}:p?e.$8h:e.$9h;const m=g;return m.configuration?{id:m.id,configPath:m.configuration}:m.folders.length===1?{id:m.id,uri:m.folders[0].uri}:{id:m.id}}e.$0h=D;function l(g){const p=g;return typeof p?.id=="string"&&A.URI.isUri(p.configPath)}e.$$h=l;function b(g){const p=g;if(p?.uri)return{id:p.id,uri:A.URI.revive(p.uri)};const m=g;if(m?.configPath)return{id:m.id,configPath:A.URI.revive(m.configPath)};if(g?.id)return{id:g.id}}e.$_h=b;var v;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function f(g){const p=g;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.$ai=f;function t(g){const p=g;return!!(p&&typeof p=="object"&&A.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.$bi=t;class i{constructor(p,m,k,C,u){this.h=p,this.j=k,this.k=C,this.l=u,this.c=P.$2h.forUris(this.l,()=>!0),this.folders=m}update(p){this.h=p.id,this.k=p.configuration,this.j=p.transient,this.l=p.l,this.folders=p.folders}get folders(){return this.g}set folders(p){this.g=p,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(p){this.k=p}getFolder(p){return p&&this.c.findSubstr(p)||null}n(){this.c=P.$2h.forUris(this.l,()=>!0);for(const p of this.folders)this.c.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ci=i;class r{constructor(p,m){this.raw=m,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,M.$zg)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$di=r;function c(g){return new r({uri:g,index:0,name:(0,M.$vg)(g)},{uri:g.toString()})}e.$ei=c,e.$fi="code-workspace",e.$gi=`.${e.$fi}`,e.$hi=[{name:(0,y.localize)(0,null),extensions:[e.$fi]}],e.$ii="workspace.json";function o(g,p){return M.$qg.isEqualOrParent(g,p.untitledWorkspacesHome)}e.$ji=o;function h(g){let p;return A.URI.isUri(g)?p=g:p=g.configuration,p?.scheme===E.Schemas.tmp}e.$ki=h,e.$li="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(g){return g.id===e.$li}e.$mi=n;function s(g,p){return!o(g,p)&&!h(g)}e.$ni=s;function a(g){return(typeof g=="string"?(0,T.$nc)(g):(0,M.$xg)(g))===e.$gi}e.$oi=a}),define(Pe[75],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=void 0;class y{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Xdc=y}),define(Pe[42],Ae([1,0,13,25,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=e.$1dc=void 0;class M{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new T.$og($=>{const E=this.b.get($.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos($,E){E===null?this.b.delete($.scheme):this.b.set($.scheme,E)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$1dc=M,e.$2dc=(0,P.$Vh)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=void 0,e.$QM=(0,y.$Vh)("IExtHostInitDataService")}),define(Pe[200],Ae([1,0,161,15,187,27]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;let A=class extends P.$XN{constructor(E,d,I){const D=I.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",l=I.remote.isRemote?(0,y.localize)(0,null):E?(0,y.localize)(1,null):(0,y.localize)(2,null);super(d.createLogger(D,{name:l}))}};e.$8fc=A,e.$8fc=A=Ke([Ve(1,T.$ej),Ve(2,M.$QM)],A)}),define(Pe[201],Ae([1,0,14]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=e.$Jec=void 0;class T{constructor(A,$,E){this.h=new Map,this.a=A,this.b=$,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(d=>(this.f=d,this)),this.g=this.c.onDidChangeStorage(d=>{d.shared===this.b&&d.key===this.a&&(this.f=d.value)}),this.i=new y.$0g(()=>{const d=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of d.values())I.complete()}catch(I){for(const D of d.values())D.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,$){let E=this.f[A];return typeof E>"u"&&(E=$),E}update(A,$){this.f[A]=$;const E=this.h.get(A);if(E!==void 0)return E.p;const d=new y.$ih;return this.h.set(A,d),this.i.isScheduled()||this.i.schedule(),d.p}dispose(){this.g.dispose()}}e.$Jec=T;class P extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,$){super(A.identifier.value,!0,$),this.j=A}}e.$Kec=P}),define(Pe[202],Ae([1,0,5,2]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class P{constructor(A){this.c=A,this.a=new y.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,$,E,d){const D=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged($.value,E,d);this.b.fire(D)}$acceptDirtyStateChanged(A,$){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty($)}$acceptModelSaved(A){const $=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire($.apiNotebook)}}e.$xfc=P}),define(Pe[17],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=void 0,e.$AM=(0,y.$Vh)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$BM=T}),define(Pe[203],Ae([1,0,22,5]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;class P{#e;constructor(A,$){this.b=new T.$Rd,this.onDidChange=this.b.event,this.a=y.$_l.toKey(A.identifier),this.#e=$,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,$){return this.#e.store(this.a,A,$)}delete(A){return this.#e.delete(this.a,A)}}e.$Rec=P}),define(Pe[57],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=e.$hec=void 0,e.$hec=(0,y.$Vh)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$iec=T}),define(Pe[204],Ae([1,0,24]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gcb=e.$Fcb=void 0;class T{constructor(){this.buffers=[]}add(E){let d=this.buffers.indexOf(E);return d<0&&(d=this.buffers.length,this.buffers.push(E)),d}}function P($,E){if(E.serializeBuffersForPostMessage){const d=new T,D=JSON.stringify($,(b,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:d.add(v)};if(ArrayBuffer.isView(v)){const f=M(v);if(f)return{$$vscode_array_buffer_reference$$:!0,index:d.add(v.buffer),view:{type:f,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),l=d.buffers.map(b=>{const v=new Uint8Array(b);return y.$fe.wrap(v)});return{message:D,buffers:l}}else return{message:JSON.stringify($),buffers:[]}}e.$Fcb=P;function M($){switch($.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A($,E){const d=E.map(l=>{const b=new ArrayBuffer(l.byteLength);return new Uint8Array(b).set(l.buffer),b}),I=E.length?(l,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const v=b,{index:f}=v,t=d[f];if(v.view)switch(v.view.type){case 1:return new Int8Array(t,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse($,I),arrayBuffers:d}}e.$Gcb=A}),define(Pe[102],Ae([1,0,171,16,2,6,4,30,41,13,39,134,31]),function(we,e,y,T,P,M,A,$,E,d,I,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BE=e.$AE=e.$zE=e.EditorsOrder=e.$yE=e.CloseDirection=e.$xE=e.$wE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.EditorInputCapabilities=e.$nE=e.SaveReason=e.Verbosity=e.$mE=e.$lE=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=e.$fE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=void 0,e.$aE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$bE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$cE="workbench.editor.sidebysideEditor",e.$dE="workbench.editors.textDiffEditor",e.$eE="workbench.editors.binaryResourceDiffEditor";var b;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var v;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function f(se){const Y=se;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$fE=f;function t(se,Y,B){for(const ne of B.visibleEditorPanes)if(ne.group.id===Y&&se.matches(ne.input))return ne.getViewState()}e.$gE=t;function i(se){if(k(se))return!1;const Y=se;return P.URI.isUri(Y?.resource)}e.$hE=i;function r(se){if(k(se))return!1;const Y=se;return Y?.original!==void 0&&Y.modified!==void 0}e.$iE=r;function c(se){if(k(se))return!1;const Y=se;return Array.isArray(Y?.resources)}e.$jE=c;function o(se){if(k(se)||r(se))return!1;const Y=se;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$kE=o;function h(se){if(k(se))return!1;const Y=se;return Y?Y.resource===void 0||Y.resource.scheme===d.Schemas.untitled||Y.forceUntitled===!0:!1}e.$lE=h;function n(se){if(k(se))return!1;const Y=se;return P.URI.isUri(Y?.base?.resource)&&P.URI.isUri(Y?.input1?.resource)&&P.URI.isUri(Y?.input2?.resource)&&P.URI.isUri(Y?.result?.resource)}e.$mE=n;var s;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var a;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class g{constructor(){this.a=new Map}registerSource(Y,B){let ne=this.a.get(Y);return ne||(ne={source:Y,label:B},this.a.set(Y,ne)),ne.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$nE=new g;var p;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(p||(e.EditorInputCapabilities=p={}));class m extends M.$Rc{}e.$oE=m;function k(se){return se instanceof m}e.$pE=k;function C(se){const Y=se;return P.URI.isUri(Y?.preferredResource)}function u(se){const Y=se;return k(Y?.primary)&&k(Y?.secondary)}e.$qE=u;function w(se){const Y=se;return k(Y?.modified)&&k(Y?.original)}e.$rE=w;function S(se,Y,B,ne,pe){return Re(ne,[(0,D.$Fi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const re={...B,limits:{size:Number.MAX_VALUE}};se.openEditor(Y,re)}}),(0,D.$Fi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>pe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$sE=S;function F(se){return k(se?.editor)}e.$tE=F;function V(se){const Y=se;return F(se)&&Y?.group!==void 0}e.$uE=V;function J(se){const Y=se;return typeof Y?.groupId=="number"&&k(Y.editor)}e.$vE=J;var N;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var R;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_STICKY=11]="EDITOR_STICKY",se[se.EDITOR_DIRTY=12]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var L;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(L||(e.SideBySideEditor=L={}));class O{getOriginalUri(Y,B){if(!Y)return;if(n(Y))return e.$xE.getOriginalUri(Y.result,B);if(B?.supportSideBySide){const{primary:pe,secondary:re}=this.a(Y);if(pe&&re){if(B?.supportSideBySide===L.BOTH)return{primary:this.getOriginalUri(pe,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(re,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===L.ANY)return this.getOriginalUri(pe,{filterByScheme:B.filterByScheme})??this.getOriginalUri(re,{filterByScheme:B.filterByScheme});Y=B.supportSideBySide===L.PRIMARY?pe:re}}if(r(Y)||c(Y)||o(Y)||n(Y))return;const ne=C(Y)?Y.preferredResource:Y.resource;return!ne||!B||!B.filterByScheme?ne:this.b(ne,B.filterByScheme)}a(Y){return u(Y)||o(Y)?{primary:Y.primary,secondary:Y.secondary}:w(Y)||r(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,B){if(!Y)return;if(n(Y))return e.$xE.getCanonicalUri(Y.result,B);if(B?.supportSideBySide){const{primary:pe,secondary:re}=this.a(Y);if(pe&&re){if(B?.supportSideBySide===L.BOTH)return{primary:this.getCanonicalUri(pe,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(re,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===L.ANY)return this.getCanonicalUri(pe,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(re,{filterByScheme:B.filterByScheme});Y=B.supportSideBySide===L.PRIMARY?pe:re}}if(r(Y)||c(Y)||o(Y)||n(Y))return;const ne=Y.resource;return!ne||!B||!B.filterByScheme?ne:this.b(ne,B.filterByScheme)}b(Y,B){if(Array.isArray(B)){if(B.some(ne=>Y.scheme===ne))return Y}else if(B===Y.scheme)return Y}}var Z;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function he(se,Y,B,ne){if(!se.isSticky(Y))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return B===Z.MOUSE||B===Z.KEYBOARD;case"mouse":return B===Z.MOUSE;case"keyboard":return B===Z.KEYBOARD}return!1}e.$wE=he,e.$xE=new O;var $e;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})($e||(e.CloseDirection=$e={}));class De{constructor(){this.c=new Map,this.d=new Map}start(Y){const B=this.a=Y.get(A.$Uh);for(const[ne,pe]of this.c)this.e(ne,pe,B);this.c.clear()}e(Y,B,ne){const pe=ne.createInstance(B);this.d.set(Y,pe)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,T.$Nf)(this.b)}registerEditorSerializer(Y,B){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,B,this.a):this.c.set(Y,B),(0,M.$Pc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}$.$mn.add(e.$aE.EditorFactory,new De);async function ke(se,Y,B){return!se||!se.length?[]:await Promise.all(se.map(async ne=>{const pe=P.URI.revive(ne.fileUri);if(!pe){B.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Y.canHandleResource(pe)){B.info("Cannot resolve the path because it cannot be handled",ne);return}let le=ne.exists,ce=ne.type;if(typeof le!="boolean"||typeof ce!="number")try{ce=(await Y.stat(pe)).isDirectory?E.FileType.Directory:E.FileType.Unknown,le=!0}catch(_){B.error(_),le=!1}if(!le&&ne.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ne);return}if(ce===E.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ne);return}const ye={...ne.options,pinned:!0};return le?{resource:pe,options:ye}:{resource:pe,options:ye,forceUntitled:!0}}))}e.$yE=ke;var fe;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(fe||(e.EditorsOrder=fe={}));function ve(se){const Y=se;if(!Y)return!1;const B=Y;if(B.modified)return ve(B.modified);const ne=Y;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$zE=ve;function te(se){return(0,I.$Hi)(se)}e.$AE=te;function Re(se,Y,B){const ne=(0,I.$Ii)(se,Y);return ne.forceMessage=B?.forceMessage,ne.forceSeverity=B?.forceSeverity,ne.allowDialog=B?.allowDialog,ne}e.$BE=Re}),define(Pe[205],Ae([1,0,5,172,4,6,28,30,18,26,90,196]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KE=e.$JE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$IE=e.$HE=e.ViewContentGroups=e.$GE=e.$FE=e.ViewContainerLocation=e.Extensions=e.$EE=e.$DE=e.$CE=void 0,e.$CE="views",e.$DE=(0,T.localize)(0,null),e.$EE=(0,D.$aw)("default-view-icon",I.$1j.window,(0,T.localize)(1,null));var l;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var b;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$FE=[0,1,2];function v(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$GE=v;class f extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new y.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Qb)([...this.g.values()])}registerViewContainer(a,g,p){const m=this.get(a.id);if(m)return m;const k=a;return k.openCommandActionDescriptor=p?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$wc)(this.g,g,[]).push(k),p?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:g}),k}deregisterViewContainer(a){for(const g of this.g.keys()){const p=this.g.get(g),m=p?.indexOf(a);if(m!==-1){p?.splice(m,1),p.length===0&&this.g.delete(g),this.f.fire({viewContainer:a,viewContainerLocation:g});return}}}get(a){return this.all.filter(g=>g.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(g=>this.getViewContainers(g).filter(p=>p?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(g=>this.getViewContainerLocation(g)===a)}}$.$mn.add(l.ViewContainersRegistry,new f);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,a){const g=s.group??t.More,p=a.group??t.More;return g!==p?g.localeCompare(p):(s.order??5)-(a.order??5)}class r extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Fc}registerViews(a,g){this.registerViews2([{views:a,viewContainer:g}])}registerViews2(a){a.forEach(({views:g,viewContainer:p})=>this.r(g,p)),this.c.fire(a)}deregisterViews(a,g){const p=this.s(a,g);p.length&&this.f.fire({views:p,viewContainer:g})}moveViews(a,g){for(const p of this.m.keys())if(p!==g){const m=this.s(a,p);m.length&&(this.r(m,g),this.g.fire({views:m,from:p,to:g}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const g of this.j){const p=(this.m.get(g)||[]).filter(m=>m.id===a)[0];if(p)return p}return null}getViewContainer(a){for(const g of this.j)if((this.m.get(g)||[]).filter(m=>m.id===a)[0])return g;return null}registerViewWelcomeContent(a,g){return this.n.add(a,g),this.h.fire(a),(0,M.$Pc)(()=>{this.n.delete(a,g),this.h.fire(a)})}registerViewWelcomeContent2(a,g){const p=new Map;for(const[m,k]of g)this.n.add(a,k),p.set(m,(0,M.$Pc)(()=>{this.n.delete(a,k),this.h.fire(a)}));return this.h.fire(a),p}getViewWelcomeContent(a){const g=[];return this.n.forEach(a,p=>g.push(p)),g.sort(i)}r(a,g){let p=this.m.get(g);p||(p=[],this.m.set(g,p),this.j.push(g));for(const m of a){if(this.getView(m.id)!==null)throw new Error((0,T.localize)(2,null,m.id));p.push(m)}}s(a,g){const p=this.m.get(g);if(!p)return[];const m=[],k=[];for(const C of p)a.includes(C)?m.push(C):k.push(C);return m.length&&(k.length?this.m.set(g,k):(this.m.delete(g),this.j.splice(this.j.indexOf(g),1))),m}}$.$mn.add(l.ViewsRegistry,new r),e.$HE=(0,P.$Vh)("viewsService"),e.$IE=(0,P.$Vh)("viewDescriptorService");var c;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var o;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class h{constructor(a,g){this.c=!1,this.d=!1,(0,d.$dn)(this,a),this.d=!!g,this.resolve=async p=>{if(g&&!this.c){const m=await g(p);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}p.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$JE=h;class n extends Error{constructor(a){super((0,T.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$KE=n}),define(Pe[206],Ae([1,0,2,29,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_E=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$$E=e.$0E=void 0;function M(d){return!!d&&typeof d=="object"&&"uri"in d&&d.uri instanceof y.URI&&"version"in d&&typeof d.version=="number"&&"ranges"in d&&Array.isArray(d.ranges)&&d.ranges.every(T.$zs.isIRange)}e.$0E=M;function A(d){return!!d&&typeof d=="object"&&"documents"in d&&Array.isArray(d.documents)&&d.documents.every(M)}e.$$E=A;var $;(function(d){d[d.Down=0]="Down",d[d.Up=1]="Up"})($||(e.InteractiveSessionVoteDirection=$={}));var E;(function(d){d[d.Action=1]="Action",d[d.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$_E=(0,P.$Vh)("IChatService")}),define(Pe[207],Ae([1,0,5,14,173]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new y.$Rd,this.n=new y.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage($){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=$}onEvent($){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=$}onRequest($){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=$}sendResponse($){$.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${$.command}`)):this.s("response",$)}sendRequest($,E,d,I){const D={command:$};if(E&&Object.keys(E).length>0&&(D.arguments=E),this.s("request",D),typeof I=="number"){const l=setTimeout(()=>{clearTimeout(l);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const v={type:"response",seq:0,request_seq:D.seq,success:!1,command:$,message:(0,P.localize)(0,null,I,$)};b(v)}},I)}return d&&this.f.set(D.seq,d),D.seq}acceptMessage($){this.j?this.j($):(this.k.push($),this.k.length===1&&this.q())}o($,E){return $.type!=="event"||E.type!=="event"}async q(){let $;for(;this.k.length;){if((!$||this.o(this.k[0],$))&&await(0,T.$Yg)(0),$=this.k.shift(),!$)return;switch($.type){case"event":this.i?.($);break;case"request":this.g?.($);break;case"response":{const E=$,d=this.f.get(E.request_seq);d&&(this.f.delete(E.request_seq),d(E));break}}}}s($,E){E.type=$,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const $=new Map;this.f.forEach((E,d)=>$.set(d,E)),await(0,T.$Yg)(500),$.forEach((E,d)=>{E({type:"response",seq:0,request_seq:d,success:!1,command:"canceled",message:"canceled"}),this.f.delete(d)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$_cb=M}),define(Pe[208],Ae([1,0,174,35,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$kH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$jH=e.MemoryRangeType=e.$iH=e.State=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=void 0,e.$fG="workbench.view.debug",e.$gG="workbench.debug.variablesView",e.$hG="workbench.debug.watchExpressionsView",e.$iG="workbench.debug.callStackView",e.$jG="workbench.debug.loadedScriptsView",e.$kG="workbench.debug.breakPointsView",e.$lG="workbench.debug.disassemblyView",e.$mG="workbench.panel.repl",e.$nG="workbench.panel.repl.view",e.$oG=new T.$aj("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$pG=new T.$aj("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$qG=new T.$aj("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$rG="debugUx",e.$sG=new T.$aj(e.$rG,"default",{type:"string",description:y.localize(3,null)}),e.$tG=new T.$aj("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$uG=new T.$aj("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$vG=new T.$aj("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$wG=new T.$aj("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$xG=new T.$aj("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$yG=new T.$aj("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$zG=new T.$aj("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$AG=new T.$aj("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$BG=new T.$aj("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$CG=new T.$aj("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$DG=new T.$aj("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$EG=new T.$aj("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$FG=new T.$aj("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$GG=new T.$aj("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$HG=new T.$aj("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$IG=new T.$aj("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$JG=new T.$aj("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$KG=new T.$aj("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$LG=new T.$aj("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$MG=new T.$aj("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$NG=new T.$aj("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$OG=new T.$aj("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$PG=new T.$aj("focusedSessionIsNoDebug",!1,{type:"boolean",description:y.localize(26,null)}),e.$QG=new T.$aj("stepBackSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$RG=new T.$aj("restartFrameSupported",!1,{type:"boolean",description:y.localize(28,null)}),e.$SG=new T.$aj("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(29,null)}),e.$TG=new T.$aj("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$UG=new T.$aj("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(31,null)}),e.$VG=new T.$aj("breakpointsExist",!1,{type:"boolean",description:y.localize(32,null)}),e.$WG=new T.$aj("debuggersAvailable",!1,{type:"boolean",description:y.localize(33,null)}),e.$XG=new T.$aj("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(34,null)}),e.$YG=new T.$aj("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(35,null)}),e.$ZG=new T.$aj("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$1G=new T.$aj("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$2G=new T.$aj("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$3G=new T.$aj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$4G=new T.$aj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$5G=new T.$aj("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$6G=new T.$aj("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(42,null)}),e.$7G=new T.$aj("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(43,null)}),e.$8G=new T.$aj("variableIsReadonly",!1,{type:"boolean",description:y.localize(44,null)}),e.$9G=new T.$aj("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(45,null)}),e.$0G=new T.$aj("multiSessionRepl",!1,{type:"boolean",description:y.localize(46,null)}),e.$$G=new T.$aj("multiSessionDebug",!1,{type:"boolean",description:y.localize(47,null)}),e.$_G=new T.$aj("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(48,null)}),e.$aH=new T.$aj("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(49,null)}),e.$bH=new T.$aj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(50,null)}),e.$cH=new T.$aj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(51,null)});const M=l=>y.localize(52,null,l);e.$dH=M,e.$eH="editor.contrib.debug",e.$fH="editor.contrib.breakpoint",e.$gH="debug",e.$hH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(53,null)};var A;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(A||(e.State=A={}));function $(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$iH=$;var E;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$jH="vscode-debug-memory";var d;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var I;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(I||(e.DebuggerString=I={})),e.$kH=(0,P.$Vh)("debugService");var D;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Pe[209],Ae([1,0,12,2,20,26,13,29,19,18]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=void 0;const I=/{([^}]+)}/g;function D(C,u,w){return C.replace(I,function(S,F){return u&&F.length>0&&F[0]!=="_"?S:w&&w.hasOwnProperty(F)?w[F]:S})}e.$eF=D;function l(C){const u={};for(const w of Object.keys(C))w.startsWith("!")||(u[w]=C[w]);return u}e.$fF=l;function b(C){return C.configuration.request==="attach"&&!v(C)&&(!C.parentSession||b(C.parentSession))}e.$gF=b;function v(C){let u=C.configuration.type;if(u)return u==="vslsShare"&&(u=C.configuration.adapterProxy.configuration.type),(0,y.$6e)(u,"extensionhost")||(0,y.$6e)(u,"pwa-extensionhost")?C:C.parentSession?v(C.parentSession):void 0}e.$hF=v;function f(C){return C.type&&(C.label||C.program||C.runtime)}e.$iF=f;function t(C,u,w){let S,F=0;const V=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let J=null;for(;J=V.exec(C);){const N=J.index+1,R=N+J[0].length;if(N<=u&&R>=w){S=J[0],F=N;break}}if(S){const N=/\w+/g;let R=null;for(;(R=N.exec(S))&&!(R.index+1+F+R[0].length>=w););R&&(S=S.substring(0,N.lastIndex))}return S?{start:F,end:F+S.length-1}:{start:0,end:0}}e.$jF=t;async function i(C,u,w,S){if(C.evaluatableExpressionProvider.has(u)){const F=C.evaluatableExpressionProvider.ordered(u),V=(0,d.$Gb)(await Promise.all(F.map(async J=>{try{return await J.provideEvaluatableExpression(u,w,S??E.CancellationToken.None)}catch{return}})));if(V.length>0){let J=V[0].expression;const N=V[0].range;return J||(J=u.getLineContent(w.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:J}}}else{const F=u.getLineContent(w.lineNumber),{start:V,end:J}=t(F,w.column,w.column),N=F.substring(V-1,J);return{matchingExpression:N,range:new $.$zs(w.lineNumber,V,w.lineNumber,V+N.length)}}return null}e.$kF=i;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(C){return!!(C&&C.match(r))}e.$lF=c;function o(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(c(C.path))return T.URI.parse(C.path);if((0,P.$hc)(C.path))return T.URI.file(C.path)}return C.path}function h(C){if(typeof C.path=="object"){const u=T.URI.revive(C.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return C.path}function n(C,u){const w=u?o:h,S=(0,M.$an)(C);return a(S,(F,V)=>{F&&V&&(V.path=w(V))}),S}e.$mF=n;function s(C,u){const w=u?o:h,S=(0,M.$an)(C);return a(S,(F,V)=>{!F&&V&&(V.path=w(V))}),S}e.$nF=s;function a(C,u){switch(C.type){case"event":{const w=C;switch(w.event){case"output":u(!1,w.body.source);break;case"loadedSource":u(!1,w.body.source);break;case"breakpoint":u(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=C;switch(w.command){case"setBreakpoints":u(!0,w.arguments.source);break;case"breakpointLocations":u(!0,w.arguments.source);break;case"source":u(!0,w.arguments.source);break;case"gotoTargets":u(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(S=>u(!1,S));break;default:break}break}case"response":{const w=C;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(S=>u(!1,S.source));break;case"loadedSources":w.body.sources.forEach(S=>u(!1,S));break;case"scopes":w.body.scopes.forEach(S=>u(!1,S.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(S=>u(!1,S.source));break;case"setBreakpoints":w.body.breakpoints.forEach(S=>u(!1,S.source));break;case"disassemble":w.body?.instructions.forEach(F=>u(!1,F.location));break;default:break}break}}}function g(C){return C.filter(u=>!u.presentation?.hidden).sort((u,w)=>u.presentation?w.presentation?u.presentation.group?w.presentation.group?u.presentation.group!==w.presentation.group?u.presentation.group.localeCompare(w.presentation.group):p(u.presentation.order,w.presentation.order):-1:w.presentation.group?1:p(u.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$oF=g;function p(C,u){return typeof C!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:C-u}async function m(C,u){const w=C.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(w!=="none"&&(await u.saveAll(),w==="allEditorsInActiveGroup")){const S=u.activeEditorPane;S&&S.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:S.input,groupId:S.group.id})}await C.reloadConfiguration()}e.$pF=m;const k=(C,u)=>!C||!u?C===u:C.name===u.name&&C.path===u.path&&C.sourceReference===u.sourceReference;e.$qF=k}),define(Pe[76],Ae([1,0,24,34,67,68,13,20,21,35]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EI=e.$DI=e.$CI=e.$BI=e.CellStatusbarAlignment=e.$AI=e.$zI=e.$yI=e.NotebookEditorPriority=e.$xI=e.$wI=e.$vI=e.$uI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$tI=e.$sI=e.$rI=e.$qI=e.CellKind=e.$pI=e.$oI=e.$nI=void 0,e.$nI="workbench.editor.notebook",e.$oI="workbench.editor.notebookTextDiffEditor",e.$pI="workbench.editor.interactive";var I;(function(O){O[O.Markup=1]="Markup",O[O.Code=2]="Code"})(I||(e.CellKind=I={})),e.$qI=["application/json","application/javascript","text/html","image/svg+xml",M.$Vr.latex,M.$Vr.markdown,"image/png","image/jpeg",M.$Vr.text],e.$rI=[M.$Vr.latex,M.$Vr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Vr.text],e.$sI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$tI="_notAvailable";var D;(function(O){O[O.Running=1]="Running",O[O.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var l;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var b;(function(O){O[O.Unconfirmed=1]="Unconfirmed",O[O.Pending=2]="Pending",O[O.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var v;(function(O){O[O.WithHardKernelDependency=0]="WithHardKernelDependency",O[O.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",O[O.Pure=2]="Pure",O[O.Never=3]="Never"})(v||(e.NotebookRendererMatch=v={}));var f;(function(O){O.Always="always",O.Never="never",O.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var t;(function(O){O[O.ModelChange=1]="ModelChange",O[O.Move=2]="Move",O[O.ChangeCellLanguage=5]="ChangeCellLanguage",O[O.Initialize=6]="Initialize",O[O.ChangeCellMetadata=7]="ChangeCellMetadata",O[O.Output=8]="Output",O[O.OutputItem=9]="OutputItem",O[O.ChangeCellContent=10]="ChangeCellContent",O[O.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",O[O.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",O[O.ChangeCellMime=13]="ChangeCellMime",O[O.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(O){O[O.Handle=0]="Handle",O[O.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(O){O[O.Replace=1]="Replace",O[O.Output=2]="Output",O[O.Metadata=3]="Metadata",O[O.CellLanguage=4]="CellLanguage",O[O.DocumentMetadata=5]="DocumentMetadata",O[O.Move=6]="Move",O[O.OutputItems=7]="OutputItems",O[O.PartialMetadata=8]="PartialMetadata",O[O.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var c;(function(O){O.scheme=A.Schemas.vscodeNotebookCell;const Z=["W","X","Y","Z","a","b","c","d","e","f"],he=new RegExp(`^[${Z.join("")}]+`),$e=7;function De(se,Y){const B=Y.toString($e),pe=`${B.length<Z.length?Z[B.length-1]:"z"}${B}s${(0,y.$ze)(y.$fe.fromString(se.scheme),!0,!0)}`;return se.with({scheme:O.scheme,fragment:pe})}O.generate=De;function ke(se){if(se.scheme!==O.scheme)return;const Y=se.fragment.indexOf("s");if(Y<0)return;const B=parseInt(se.fragment.substring(0,Y).replace(he,""),$e),ne=(0,y.$ye)(se.fragment.substring(Y+1)).toString();if(!isNaN(B))return{handle:B,notebook:se.with({scheme:ne,fragment:null})}}O.parse=ke;function fe(se,Y){return se.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Y??""},${se.scheme!==A.Schemas.file?se.scheme:""}`})}O.generateCellOutputUri=fe;function ve(se){if(se.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Y=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!Y)return;const B=Y[1]&&Y[1]!==""?Y[1]:void 0,ne=Y[2];return{outputId:B,notebook:se.with({scheme:ne||A.Schemas.file,fragment:null})}}O.parseCellOutputUri=ve;function te(se,Y,B){return O.generate(se,Y).with({scheme:B})}O.generateCellPropertyUri=te;function Re(se,Y){if(se.scheme===Y)return O.parse(se.with({scheme:O.scheme}))}O.parseCellPropertyUri=Re})(c||(e.CellUri=c={}));const o=O=>E.$i?O.replace(/\//g,"\\"):O;class h{constructor(Z=[],he=e.$qI){this.e=he,this.d=[...new Set(Z)].map($e=>({pattern:$e,matches:T.$Cj(o($e))}))}sort(Z){const he=new Map(P.Iterable.map(Z,De=>[De,o(De)]));let $e=[];for(const{matches:De}of this.d)for(const[ke,fe]of he)if(De(fe)){$e.push(ke),he.delete(ke);break}return he.size&&($e=$e.concat([...he.keys()].sort((De,ke)=>this.e.indexOf(De)-this.e.indexOf(ke)))),$e}prioritize(Z,he){const $e=this.f(Z);if($e===-1){this.d.unshift({pattern:Z,matches:T.$Cj(o(Z))});return}const De=new Set(he.map(fe=>this.f(fe,$e)));De.delete(-1);const ke=Array.from(De).sort();this.d.splice($e+1,0,...ke.map(fe=>this.d[fe]));for(let fe=ke.length-1;fe>=0;fe--)this.d.splice(ke[fe],1)}toArray(){return this.d.map(Z=>Z.pattern)}f(Z,he=this.d.length){const $e=o(Z);for(let De=0;De<he;De++)if(this.d[De].matches($e))return De;return-1}}e.$uI=h;function n(O,Z,he,$e=(De,ke)=>De===ke){const De=[];function ke(te,Re,se){if(Re===0&&se.length===0)return;const Y=De[De.length-1];Y&&Y.start+Y.deleteCount===te?(Y.deleteCount+=Re,Y.toInsert.push(...se)):De.push({start:te,deleteCount:Re,toInsert:se})}let fe=0,ve=0;for(;;){if(fe===O.length){ke(fe,0,Z.slice(ve));break}if(ve===Z.length){ke(fe,O.length-fe,[]);break}const te=O[fe],Re=Z[ve];if($e(te,Re)){fe+=1,ve+=1;continue}he(Re)?(ke(fe,1,[]),fe+=1):(ke(fe,0,[Re]),ve+=1)}return De}e.$vI=n,e.$wI=new d.$aj("notebookEditorCursorAtBoundary","none"),e.$xI=new d.$aj("notebookEditorCursorAtLineBoundary","none");var s;(function(O){O.default="default",O.option="option"})(s||(e.NotebookEditorPriority=s={}));function a(O){const Z=O;return!!((typeof Z.include=="string"||T.$Dj(Z.include))&&(typeof Z.exclude=="string"||T.$Dj(Z.exclude)))}e.$yI=a;function g(O,Z,he){if(Array.isArray(O.viewType)&&O.viewType.indexOf(Z)>=0||O.viewType===Z)return!0;if(O.filenamePattern){const $e=a(O.filenamePattern)?O.filenamePattern.include:O.filenamePattern,De=a(O.filenamePattern)?O.filenamePattern.exclude:void 0;if(T.$Bj($e,(0,$.$mc)(he.fsPath).toLowerCase()))return!(De&&T.$Bj(De,(0,$.$mc)(he.fsPath).toLowerCase()))}return!1}e.$zI=g,e.$AI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var p;(function(O){O[O.Left=1]="Left",O[O.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class m{static{this.d="notebook/"}static create(Z){return`${m.d}${Z}`}static parse(Z){if(Z.startsWith(m.d))return Z.substring(m.d.length)}}e.$BI=m;function k(O){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(O)}e.$CI=k;const C=new TextDecoder;function u(O){const Z=[];let he=!1;for(const fe of O)(Z.length===0||he)&&(Z.push(fe),he=!0);let $e=F(Z);const De=y.$fe.concat(Z.map(fe=>y.$fe.wrap(fe))),ke=L(De);return $e=$e||ke.byteLength!==De.byteLength,{data:ke,didCompression:$e}}e.$DI=u,e.$EI=`${String.fromCharCode(27)}[A`;const w=e.$EI.split("").map(O=>O.charCodeAt(0)),S=10;function F(O){let Z=!1;return O.forEach((he,$e)=>{if($e===0||he.length<e.$EI.length)return;const De=O[$e-1],ke=he.subarray(0,e.$EI.length);if(ke[0]===w[0]&&ke[1]===w[1]&&ke[2]===w[2]){const fe=De.lastIndexOf(S);if(fe===-1)return;Z=!0,O[$e-1]=De.subarray(0,fe),O[$e]=he.subarray(e.$EI.length)}}),Z}function V(O){let Z=O;do O=Z,Z=O.replace(/[^\n]\x08/gm,"");while(Z.length<O.length);return O}function J(O){for(O=O.replace(/\r+\n/gm,`
`);O.search(/\r[^$]/g)>-1;){const Z=O.match(/^(.*)\r+/m)[1];let he=O.match(/\r+(.*)$/m)[1];he=he+Z.slice(he.length,Z.length),O=O.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,he)}return O}const N="\b".charCodeAt(0),R="\r".charCodeAt(0);function L(O){return!O.buffer.includes(N)&&!O.buffer.includes(R)?O:y.$fe.fromString(J(V(C.decode(O.buffer))))}}),define(Pe[7],Ae([1,0,18,11,52,28,68,12,16,2,33,22,41,100,76]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v){"use strict";var f,t,i,r,c,o,h,n,s,a,g,p,m,k,C,u,w,S;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$pM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.TestRunProfileKind=e.TestResultState=e.$8L=e.$7L=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$6L=e.$5L=e.$4L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$3L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.ColorThemeKind=e.$WL=e.$VL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$UL=e.DebugConsoleMode=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OL=e.$NL=e.FileChangeType=e.$ML=e.$LL=e.$KL=e.$JL=e.InlineCompletionTriggerKind=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.ConfigurationTarget=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$mL=e.ViewBadge=e.ProgressLocation=e.$lL=e.$kL=e.TaskScope=e.ShellQuoting=e.$jL=e.$iL=e.$hL=e.TaskPanelKind=e.TaskRevealKind=e.$gL=e.TerminalLocation=e.$fL=e.$eL=e.$dL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$cL=e.$bL=e.$aL=e.$_K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$$K=e.StatusBarAlignment=e.ViewColumn=e.$0K=e.$9K=e.$8K=e.$7K=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$6K=e.$5K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.LanguageStatusSeverity=e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=e.$TK=e.CodeActionTriggerKind=e.$SK=e.$RK=e.SymbolTag=e.SymbolKind=e.$QK=e.DocumentHighlightKind=e.$PK=e.$OK=e.$NK=e.$MK=e.DiagnosticSeverity=e.DiagnosticTag=e.$LK=e.$KK=e.FileEditType=e.$JK=e.$IK=e.$HK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(j){return Object.assign(j,{apply:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const Se=oe.length===1?[]:oe[1];return Reflect.construct(j,Se,oe[0].constructor)}},call:function(...oe){if(oe.length===0)return Reflect.construct(j,[]);{const[Se,...Ge]=oe;return Reflect.construct(j,Ge,Se.constructor)}}})}var V;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(V||(e.TerminalOutputAnchor=V={}));var J;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(J||(e.TerminalQuickFixType=J={}));let N=f=class{static from(...U){let oe=U;return new f(function(){if(oe){for(const Se of oe)Se&&typeof Se.dispose=="function"&&Se.dispose();oe=void 0}})}#e;constructor(U){this.#e=U}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$AK=N,e.$AK=N=f=Ke([F],N);let R=t=class{static Min(...U){if(U.length===0)throw new TypeError;let oe=U[0];for(let Se=1;Se<U.length;Se++){const Ge=U[Se];Ge.isBefore(oe)&&(oe=Ge)}return oe}static Max(...U){if(U.length===0)throw new TypeError;let oe=U[0];for(let Se=1;Se<U.length;Se++){const Ge=U[Se];Ge.isAfter(oe)&&(oe=Ge)}return oe}static isPosition(U){if(!U)return!1;if(U instanceof t)return!0;const{line:oe,character:Se}=U;return typeof oe=="number"&&typeof Se=="number"}static of(U){if(U instanceof t)return U;if(this.isPosition(U))return new t(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(U,oe){if(U<0)throw(0,T.$6)("line must be non-negative");if(oe<0)throw(0,T.$6)("character must be non-negative");this.c=U,this.e=oe}isBefore(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<U.e}isBeforeOrEqual(U){return this.c<U.c?!0:U.c<this.c?!1:this.e<=U.e}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this.c===U.c&&this.e===U.e}compareTo(U){return this.c<U.c?-1:this.c>U.line?1:this.e<U.e?-1:this.e>U.e?1:0}translate(U,oe=0){if(U===null||oe===null)throw(0,T.$6)();let Se;return typeof U>"u"?Se=0:typeof U=="number"?Se=U:(Se=typeof U.lineDelta=="number"?U.lineDelta:0,oe=typeof U.characterDelta=="number"?U.characterDelta:0),Se===0&&oe===0?this:new t(this.line+Se,this.character+oe)}with(U,oe=this.character){if(U===null||oe===null)throw(0,T.$6)();let Se;return typeof U>"u"?Se=this.line:typeof U=="number"?Se=U:(Se=typeof U.line=="number"?U.line:this.line,oe=typeof U.character=="number"?U.character:this.character),Se===this.line&&oe===this.character?this:new t(Se,oe)}toJSON(){return{line:this.line,character:this.character}}};e.$BK=R,e.$BK=R=t=Ke([F],R);let L=i=class{static isRange(U){return U instanceof i?!0:U?R.isPosition(U.start)&&R.isPosition(U.end):!1}static of(U){if(U instanceof i)return U;if(this.isRange(U))return new i(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(U,oe,Se,Ge){let xe,at;if(typeof U=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new R(U,oe),at=new R(Se,Ge)):R.isPosition(U)&&R.isPosition(oe)&&(xe=R.of(U),at=R.of(oe)),!xe||!at)throw new Error("Invalid arguments");xe.isBefore(at)?(this.c=xe,this.e=at):(this.c=at,this.e=xe)}contains(U){return i.isRange(U)?this.contains(U.start)&&this.contains(U.end):R.isPosition(U)?!(R.of(U).isBefore(this.c)||this.e.isBefore(U)):!1}isEqual(U){return this.c.isEqual(U.c)&&this.e.isEqual(U.e)}intersection(U){const oe=R.Max(U.start,this.c),Se=R.Min(U.end,this.e);if(!oe.isAfter(Se))return new i(oe,Se)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const oe=R.Min(U.start,this.c),Se=R.Max(U.end,this.end);return new i(oe,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(U,oe=this.end){if(U===null||oe===null)throw(0,T.$6)();let Se;return U?R.isPosition(U)?Se=U:(Se=U.start||this.start,oe=U.end||this.end):Se=this.start,Se.isEqual(this.c)&&oe.isEqual(this.end)?this:new i(Se,oe)}toJSON(){return[this.start,this.end]}};e.$CK=L,e.$CK=L=i=Ke([F],L);let O=r=class extends L{static isSelection(U){return U instanceof r?!0:U?L.isRange(U)&&R.isPosition(U.anchor)&&R.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(U,oe,Se,Ge){let xe,at;if(typeof U=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"?(xe=new R(U,oe),at=new R(Se,Ge)):R.isPosition(U)&&R.isPosition(oe)&&(xe=R.of(U),at=R.of(oe)),!xe||!at)throw new Error("Invalid arguments");super(xe,at),this.f=xe,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$DK=O,e.$DK=O=r=Ke([F],O);const Z=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,T.$6)("connectionToken")};class he{static isResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.host=="string"&&typeof U.port=="number"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,oe,Se){if(typeof U!="string"||U.length===0)throw(0,T.$6)("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw(0,T.$6)("port");typeof Se<"u"&&Z(Se),this.host=U,this.port=Math.round(oe),this.connectionToken=Se}}e.$EK=he;class $e{static isManagedResolvedAuthority(U){return U&&typeof U=="object"&&typeof U.makeConnection=="function"&&(U.connectionToken===void 0||typeof U.connectionToken=="string")}constructor(U,oe){this.makeConnection=U,this.connectionToken=oe,typeof oe<"u"&&Z(oe)}}e.$FK=$e;class De extends Error{static NotAvailable(U,oe){return new De(U,b.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(U){return new De(U,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(U,oe=b.RemoteAuthorityResolverErrorCode.Unknown,Se){super(U),this._message=U,this._code=oe,this._detail=Se,Object.setPrototypeOf(this,De.prototype)}}e.$GK=De;var ke;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ke||(e.EndOfLine=ke={}));var fe;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(fe||(e.EnvironmentVariableMutatorType=fe={}));let ve=c=class{static isTextEdit(U){return U instanceof c?!0:U?L.isRange(U)&&typeof U.newText=="string":!1}static replace(U,oe){return new c(U,oe)}static insert(U,oe){return c.replace(new L(U,U),oe)}static delete(U){return c.replace(U,"")}static setEndOfLine(U){const oe=new c(new L(new R(0,0),new R(0,0)),"");return oe.newEol=U,oe}get range(){return this.c}set range(U){if(U&&!L.isRange(U))throw(0,T.$6)("range");this.c=U}get newText(){return this.e||""}set newText(U){if(U&&typeof U!="string")throw(0,T.$6)("newText");this.e=U}get newEol(){return this.f}set newEol(U){if(U&&typeof U!="number")throw(0,T.$6)("newEol");this.f=U}constructor(U,oe){this.c=U,this.e=oe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$HK=ve,e.$HK=ve=c=Ke([F],ve);let te=o=class{static isNotebookCellEdit(U){return U instanceof o?!0:U?_t.isNotebookRange(U)&&Array.isArray(U.newCells):!1}static replaceCells(U,oe){return new o(U,oe)}static insertCells(U,oe){return new o(new _t(U,U),oe)}static deleteCells(U){return new o(U,[])}static updateCellMetadata(U,oe){const Se=new o(new _t(U,U),[]);return Se.newCellMetadata=oe,Se}static updateNotebookMetadata(U){const oe=new o(new _t(0,0),[]);return oe.newNotebookMetadata=U,oe}constructor(U,oe){this.range=U,this.newCells=oe}};e.$IK=te,e.$IK=te=o=Ke([F],te);class Re{static isSnippetTextEdit(U){return U instanceof Re?!0:U?L.isRange(U.range)&&B.isSnippetString(U.snippet):!1}static replace(U,oe){return new Re(U,oe)}static insert(U,oe){return Re.replace(new L(U,U),oe)}constructor(U,oe){this.range=U,this.snippet=oe}}e.$JK=Re;var se;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Y=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(U,oe,Se,Ge){this.c.push({_type:1,from:U,to:oe,options:Se,metadata:Ge})}createFile(U,oe,Se){this.c.push({_type:1,from:void 0,to:U,options:oe,metadata:Se})}deleteFile(U,oe,Se){this.c.push({_type:1,from:U,to:void 0,options:oe,metadata:Se})}e(U,oe,Se){this.c.push({_type:3,metadata:Se,uri:U,edit:{editType:5,metadata:oe},notebookMetadata:oe})}f(U,oe,Se,Ge){const xe=oe.start,at=oe.end;(xe!==at||Se.length>0)&&this.c.push({_type:5,uri:U,index:xe,count:at-xe,cells:Se,metadata:Ge})}g(U,oe,Se,Ge){this.c.push({_type:3,metadata:Ge,uri:U,edit:{editType:3,index:oe,metadata:Se}})}replace(U,oe,Se,Ge){this.c.push({_type:2,uri:U,edit:new ve(oe,Se),metadata:Ge})}insert(U,oe,Se,Ge){this.replace(U,new L(oe,oe),Se,Ge)}delete(U,oe,Se){this.replace(U,oe,"",Se)}has(U){return this.c.some(oe=>oe._type===2&&oe.uri.toString()===U.toString())}set(U,oe){if(oe)for(const Se of oe){if(!Se)continue;let Ge,xe;Array.isArray(Se)?(Ge=Se[0],xe=Se[1]):Ge=Se,te.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(U,Ge.range.start,Ge.newCellMetadata,xe):Ge.newNotebookMetadata?this.e(U,Ge.newNotebookMetadata,xe):this.f(U,Ge.range,Ge.newCells,xe):Re.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:U,range:Ge.range,edit:Ge.snippet,metadata:xe}):this.c.push({_type:2,uri:U,edit:Ge,metadata:xe})}else{for(let Se=0;Se<this.c.length;Se++){const Ge=this.c[Se];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===U.toString()&&(this.c[Se]=void 0);break}}(0,y.$Hb)(this.c)}}get(U){const oe=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===U.toString()&&oe.push(Se.edit);return oe}entries(){const U=new M.$zc;for(const oe of this.c)if(oe._type===2){let Se=U.get(oe.uri);Se||(Se=[oe.uri,[]],U.set(oe.uri,Se)),Se[1].push(oe.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$KK=Y,e.$KK=Y=Ke([F],Y);let B=h=class{static isSnippetString(U){return U instanceof h?!0:U?typeof U.value=="string":!1}static c(U){return U.replace(/\$|}|\\/g,"\\$&")}constructor(U){this.e=1,this.value=U||""}appendText(U){return this.value+=h.c(U),this}appendTabstop(U=this.e++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,oe=this.e++){if(typeof U=="function"){const Se=new h;Se.e=this.e,U(Se),this.e=Se.e,U=Se.value}else U=h.c(U);return this.value+="${",this.value+=oe,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,oe=this.e++){const Se=U.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(U,oe){if(typeof oe=="function"){const Se=new h;Se.e=this.e,oe(Se),this.e=Se.e,oe=Se.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};e.$LK=B,e.$LK=B=h=Ke([F],B);var ne;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var pe;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(pe||(e.DiagnosticSeverity=pe={}));let re=n=class{static isLocation(U){return U instanceof n?!0:U?L.isRange(U.range)&&d.URI.isUri(U.uri):!1}constructor(U,oe){if(this.uri=U,oe)if(L.isRange(oe))this.range=L.of(oe);else if(R.isPosition(oe))this.range=new L(oe,oe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$MK=re,e.$MK=re=n=Ke([F],re);let le=class{static is(U){return U?typeof U.message=="string"&&U.location&&L.isRange(U.location.range)&&d.URI.isUri(U.location.uri):!1}constructor(U,oe){this.location=U,this.message=oe}static isEqual(U,oe){return U===oe?!0:!U||!oe?!1:U.message===oe.message&&U.location.range.isEqual(oe.location.range)&&U.location.uri.toString()===oe.location.uri.toString()}};e.$NK=le,e.$NK=le=Ke([F],le);let ce=class{constructor(U,oe,Se=pe.Error){if(!L.isRange(U))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=U,this.message=oe,this.severity=Se}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,oe){return U===oe?!0:!U||!oe?!1:U.message===oe.message&&U.severity===oe.severity&&U.code===oe.code&&U.severity===oe.severity&&U.source===oe.source&&U.range.isEqual(oe.range)&&(0,y.$tb)(U.tags,oe.tags)&&(0,y.$tb)(U.relatedInformation,oe.relatedInformation,le.isEqual)}};e.$OK=ce,e.$OK=ce=Ke([F],ce);let ye=class{constructor(U,oe){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=oe}};e.$PK=ye,e.$PK=ye=Ke([F],ye);var _;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(_||(e.DocumentHighlightKind=_={}));let de=class{constructor(U,oe=_.Text){this.range=U,this.kind=oe}toJSON(){return{range:this.range,kind:_[this.kind]}}};e.$QK=de,e.$QK=de=Ke([F],de);var ie;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ie||(e.SymbolKind=ie={}));var ae;(function(j){j[j.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let me=s=class{static validate(U){if(!U.name)throw new Error("name must not be falsy")}constructor(U,oe,Se,Ge,xe){this.name=U,this.kind=oe,this.containerName=xe,typeof Se=="string"&&(this.containerName=Se),Ge instanceof re?this.location=Ge:Se instanceof L&&(this.location=new re(Ge,Se)),s.validate(this)}toJSON(){return{name:this.name,kind:ie[this.kind],location:this.location,containerName:this.containerName}}};e.$RK=me,e.$RK=me=s=Ke([F],me);let Ie=a=class{static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children?.forEach(a.validate)}constructor(U,oe,Se,Ge,xe){this.name=U,this.detail=oe,this.kind=Se,this.range=Ge,this.selectionRange=xe,this.children=[],a.validate(this)}};e.$SK=Ie,e.$SK=Ie=a=Ke([F],Ie);var z;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(z||(e.CodeActionTriggerKind=z={}));let W=class{constructor(U,oe){this.title=U,this.kind=oe}};e.$TK=W,e.$TK=W=Ke([F],W);let H=class{static{g=this}static{this.c="."}constructor(U){this.value=U}append(U){return new g(this.value?this.value+g.c+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+g.c)}};e.$UK=H,e.$UK=H=g=Ke([F],H),H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorMove=H.Refactor.append("move"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll"),H.Notebook=H.Empty.append("notebook");let G=class{constructor(U,oe){if(this.range=U,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$VK=G,e.$VK=G=Ke([F],G);class q{constructor(U,oe,Se,Ge,xe,at){this.kind=U,this.name=oe,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$WK=q;class x{constructor(U,oe){this.fromRanges=oe,this.from=U}}e.$XK=x;class ue{constructor(U,oe){this.fromRanges=oe,this.to=U}}e.$YK=ue;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Ue=class{constructor(U,oe){this.range=U,this.command=oe}get isResolved(){return!!this.command}};e.$ZK=Ue,e.$ZK=Ue=Ke([F],Ue);let Ze=p=class{#e;static isMarkdownString(U){return U instanceof p?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}constructor(U,oe=!1){this.#e=new P.$9j(U,{supportThemeIcons:oe})}get value(){return this.#e.value}set value(U){this.#e.value=U}get isTrusted(){return this.#e.isTrusted}set isTrusted(U){this.#e.isTrusted=U}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(U){this.#e.supportThemeIcons=U}get supportHtml(){return this.#e.supportHtml}set supportHtml(U){this.#e.supportHtml=U}get baseUri(){return this.#e.baseUri}set baseUri(U){this.#e.baseUri=U}appendText(U){return this.#e.appendText(U),this}appendMarkdown(U){return this.#e.appendMarkdown(U),this}appendCodeblock(U,oe){return this.#e.appendCodeblock(oe??"",U),this}};e.$1K=Ze,e.$1K=Ze=p=Ke([F],Ze);let Je=class{constructor(U,oe){this.label=U,this.documentation=oe}};e.$2K=Je,e.$2K=Je=Ke([F],Je);let tt=class{constructor(U,oe){this.label=U,this.documentation=oe,this.parameters=[]}};e.$3K=tt,e.$3K=tt=Ke([F],tt);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$4K=_e,e.$4K=_e=Ke([F],_e);var et;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let nt=class{constructor(U){this.value=U}};e.$5K=nt,e.$5K=nt=Ke([F],nt);let ze=class{constructor(U,oe,Se){this.position=U,this.label=oe,this.kind=Se}};e.$6K=ze,e.$6K=ze=Ke([F],ze);var dt;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(dt||(e.CompletionTriggerKind=dt={}));var X;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(X||(e.CompletionItemKind=X={}));var Q;(function(j){j[j.Deprecated=1]="Deprecated"})(Q||(e.CompletionItemTag=Q={}));let Ee=class{constructor(U,oe){this.label=U,this.kind=oe}toJSON(){return{label:this.label,kind:this.kind&&X[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$7K=Ee,e.$7K=Ee=Ke([F],Ee);let Be=class{constructor(U=[],oe=!1){this.items=U,this.isIncomplete=oe}};e.$8K=Be,e.$8K=Be=Ke([F],Be);let He=class{constructor(U,oe,Se){this.insertText=U,this.range=oe,this.command=Se}};e.$9K=He,e.$9K=He=Ke([F],He);let Xe=class{constructor(U){this.commands=void 0,this.suppressSuggestions=void 0,this.items=U}};e.$0K=Xe,e.$0K=Xe=Ke([F],Xe);var st;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var vt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(vt||(e.StatusBarAlignment=vt={}));function Dt(j,U){return`${D.$_l.toKey(j)}.${U}`}e.$$K=Dt;var Ne;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Ne||(e.TextEditorLineNumbersStyle=Ne={}));var Kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var Ht;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var yt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(yt||(e.TextEditorSelectionChangeKind=yt={}));var jt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Nt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Nt||(e.DecorationRangeBehavior=Nt={})),function(j){function U(oe){switch(oe){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=U}(yt||(e.TextEditorSelectionChangeKind=yt={}));var Gt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Gt||(e.SyntaxTokenType=Gt={})),function(j){function U(oe){switch(oe){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=U}(Gt||(e.SyntaxTokenType=Gt={}));let Bt=class{constructor(U,oe){if(oe&&!d.URI.isUri(oe))throw(0,T.$6)("target");if(!L.isRange(U)||U.isEmpty)throw(0,T.$6)("range");this.range=U,this.target=oe}};e.$_K=Bt,e.$_K=Bt=Ke([F],Bt);let St=class{constructor(U,oe,Se,Ge){this.red=U,this.green=oe,this.blue=Se,this.alpha=Ge}};e.$aL=St,e.$aL=St=Ke([F],St);let Lt=class{constructor(U,oe){if(oe&&!(oe instanceof St))throw(0,T.$6)("color");if(!L.isRange(U)||U.isEmpty)throw(0,T.$6)("range");this.range=U,this.color=oe}};e.$bL=Lt,e.$bL=Lt=Ke([F],Lt);let Vt=class{constructor(U){if(!U||typeof U!="string")throw(0,T.$6)("label");this.label=U}};e.$cL=Vt,e.$cL=Vt=Ke([F],Vt);var Ye;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Ye||(e.ColorFormat=Ye={}));var Wt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Wt||(e.SourceControlInputBoxValidationType=Wt={}));var qt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));class ct{constructor(U,oe,Se){if(this.startIndex=U,this.length=oe,this.tooltip=Se,typeof U!="number"||U<0)throw(0,T.$6)("startIndex");if(typeof oe!="number"||oe<1)throw(0,T.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,T.$6)("tooltip")}}e.$dL=ct;class gt{constructor(U){this.uri=U}}e.$eL=gt;class Ot{constructor(U){this.terminalCommand=U}}e.$fL=Ot;var Pt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Pt||(e.TerminalLocation=Pt={}));class At{constructor(U){if(this.options=U,typeof U!="object")throw(0,T.$6)("options")}}e.$gL=At;var ft;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ft||(e.TaskRevealKind=ft={}));var kt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(kt||(e.TaskPanelKind=kt={}));let Rt=class{static{m=this}static{this.Clean=new m("clean","Clean")}static{this.Build=new m("build","Build")}static{this.Rebuild=new m("rebuild","Rebuild")}static{this.Test=new m("test","Test")}static from(U){switch(U){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}constructor(U,oe){if(this.label=oe,typeof U!="string"||typeof oe!="string")throw(0,T.$6)("name");this.c=U}get id(){return this.c}};e.$hL=Rt,e.$hL=Rt=m=Ke([F],Rt);function Ct(j){let U="";for(let oe=0;oe<j.length;oe++)U+=j[oe].replace(/,/g,",,")+",";return U}let We=class{constructor(U,oe,Se){if(typeof U!="string")throw(0,T.$6)("process");this.e=[],this.c=U,oe!==void 0&&(Array.isArray(oe)?(this.e=oe,this.f=Se):this.f=oe)}get process(){return this.c}set process(U){if(typeof U!="string")throw(0,T.$6)("process");this.c=U}get args(){return this.e}set args(U){Array.isArray(U)||(U=[]),this.e=U}get options(){return this.f}set options(U){this.f=U}computeId(){const U=[];if(U.push("process"),this.c!==void 0&&U.push(this.c),this.e&&this.e.length>0)for(const oe of this.e)U.push(oe);return Ct(U)}};e.$iL=We,e.$iL=We=Ke([F],We);let zt=class{constructor(U,oe,Se){if(this.f=[],Array.isArray(oe)){if(!U)throw(0,T.$6)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,T.$6)("command");this.e=U,this.f=oe,this.g=Se}else{if(typeof U!="string")throw(0,T.$6)("commandLine");this.c=U,this.g=oe}}get commandLine(){return this.c}set commandLine(U){if(typeof U!="string")throw(0,T.$6)("commandLine");this.c=U}get command(){return this.e?this.e:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,T.$6)("command");this.e=U}get args(){return this.f}set args(U){this.f=U||[]}get options(){return this.g}set options(U){this.g=U}computeId(){const U=[];if(U.push("shell"),this.c!==void 0&&U.push(this.c),this.e!==void 0&&U.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const oe of this.f)U.push(typeof oe=="string"?oe:oe.value);return Ct(U)}};e.$jL=zt,e.$jL=zt=Ke([F],zt);var Jt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var Ce;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ce||(e.TaskScope=Ce={}));class Me{constructor(U){this.c=U}computeId(){return"customExecution"+(0,I.$ig)()}set callback(U){this.c=U}get callback(){return this.c}}e.$kL=Me;let be=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(U,oe,Se,Ge,xe,at){this.j=!1,this.k=this.definition=U;let ht;typeof oe=="string"?(this.m=this.name=oe,this.t=this.source=Se,this.execution=Ge,ht=xe,this.j=!0):oe===Ce.Global||oe===Ce.Workspace?(this.target=oe,this.m=this.name=Se,this.t=this.source=Ge,this.execution=xe,ht=at):(this.target=oe,this.m=this.name=Se,this.t=this.source=Ge,this.execution=xe,ht=at),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(U){this.h=U}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof We?this.k={type:k.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:k.f,id:this.n.computeId()}:this.n instanceof Me?this.k={type:k.c,id:this.n.computeId()}:this.k={type:k.g,id:(0,I.$ig)()}}get definition(){return this.k}set definition(U){if(U==null)throw(0,T.$6)("Kind can't be undefined or null");this.z(),this.k=U}get scope(){return this.l}set target(U){this.z(),this.l=U}get name(){return this.m}set name(U){if(typeof U!="string")throw(0,T.$6)("name");this.z(),this.m=U}get execution(){return this.n}set execution(U){U===null&&(U=void 0),this.z(),this.n=U;const oe=this.k.type;(k.g===oe||k.e===oe||k.f===oe||k.c===oe)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(U){if(Array.isArray(U))this.z(),this.o=U,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.z(),this.r=U}get source(){return this.t}set source(U){if(typeof U!="string"||U.length===0)throw(0,T.$6)("source must be a string of length > 0");this.z(),this.t=U}get group(){return this.u}set group(U){U===null&&(U=void 0),this.z(),this.u=U}get detail(){return this.y}set detail(U){U===null&&(U=void 0),this.y=U}get presentationOptions(){return this.w}set presentationOptions(U){U==null&&(U=Object.create(null)),this.z(),this.w=U}get runOptions(){return this.x}set runOptions(U){U==null&&(U=Object.create(null)),this.z(),this.x=U}};e.$lL=be,e.$lL=be=k=Ke([F],be);var K;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(K||(e.ProgressLocation=K={}));var Le;(function(j){function U(oe){const Se=oe;return(0,E.$Gf)(Se.value)?Se.tooltip&&!(0,E.$Cf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=U})(Le||(e.ViewBadge=Le={}));let je=C=class{static isTreeItem(U,oe){const Se=U;if(Se.checkboxState!==void 0){const Ge=(0,E.$Gf)(Se.checkboxState)?Se.checkboxState:(0,E.$Ef)(Se.checkboxState)&&(0,E.$Gf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,xe=!(0,E.$Gf)(Se.checkboxState)&&(0,E.$Ef)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==qe.Checked&&Ge!==qe.Unchecked||xe!==void 0&&!(0,E.$Cf)(xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(U instanceof C)return!0;if(Se.label!==void 0&&!(0,E.$Cf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,E.$Cf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,E.$Cf)(Se.iconPath)&&!d.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,E.$Cf)(Se.iconPath.id))){const Ge=Se.iconPath;if(!Ge||!(0,E.$Cf)(Ge.light)&&!d.URI.isUri(Ge.light)&&!(0,E.$Cf)(Ge.dark)&&!d.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,E.$Cf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!d.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,E.$Cf)(Se.tooltip)&&!(Se.tooltip instanceof Ze)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Qe.None&&Se.collapsibleState>Qe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,E.$Cf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(U,oe=Qe.None){this.collapsibleState=oe,d.URI.isUri(U)?this.resourceUri=U:this.label=U}};e.$mL=je,e.$mL=je=C=Ke([F],je);var Qe;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Qe||(e.TreeItemCollapsibleState=Qe={}));var qe;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(qe||(e.TreeItemCheckboxState=qe={}));let it=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(U){this.value=U}};e.$nL=it,e.$nL=it=Ke([F],it);class pt extends it{}e.$oL=pt;class $t extends pt{#e;constructor(U){super(""),this.#e=U}asFile(){return this.#e}}e.$pL=$t;class bt{constructor(U,oe,Se,Ge){this.name=U,this.uri=oe,this._itemId=Se,this.c=Ge}data(){return this.c()}}e.$qL=bt;let ut=class{#e=new Map;constructor(U){for(const[oe,Se]of U??[]){const Ge=this.#e.get(this.#t(oe));Ge?Ge.push(Se):this.#e.set(this.#t(oe),[Se])}}get(U){return this.#e.get(this.#t(U))?.[0]}set(U,oe){this.#e.set(this.#t(U),[oe])}forEach(U,oe){for(const[Se,Ge]of this.#e)for(const xe of Ge)U.call(oe,xe,Se,this)}*[Symbol.iterator](){for(const[U,oe]of this.#e)for(const Se of oe)yield[U,Se]}#t(U){return U.toLowerCase()}};e.$rL=ut,e.$rL=ut=Ke([F],ut);let Mt=class{constructor(U){this.insertText=U}};e.$sL=Mt,e.$sL=Mt=Ke([F],Mt);let Qt=class{constructor(U,oe){this.label=oe,this.insertText=U}};e.$tL=Qt,e.$tL=Qt=Ke([F],Qt);let Xt=class{constructor(U,oe){this.id=U,this.color=oe}static isThemeIcon(U){return typeof U.id!="string"?(console.log("INVALID ThemeIcon, invalid id",U.id),!1):!0}};e.$uL=Xt,e.$uL=Xt=Ke([F],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let si=class{constructor(U){this.id=U}};e.$vL=si,e.$vL=si=Ke([F],si);var ki;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(ki||(e.ConfigurationTarget=ki={}));let It=class{get base(){return this.c}set base(U){this.c=U,this.e=d.URI.file(U)}get baseUri(){return this.e}set baseUri(U){this.e=U,this.c=U.fsPath}constructor(U,oe){if(typeof U!="string"&&(!U||!d.URI.isUri(U)&&!d.URI.isUri(U.uri)))throw(0,T.$6)("base");if(typeof oe!="string")throw(0,T.$6)("pattern");typeof U=="string"?this.baseUri=d.URI.file(U):d.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=oe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wL=It,e.$wL=It=Ke([F],It);const Zi=new WeakMap;function ln(j,U){Zi.set(j,U)}e.$xL=ln;let Et=class{constructor(U,oe,Se,Ge){this.enabled=typeof U=="boolean"?U:!0,typeof oe=="string"&&(this.condition=oe),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Zi.get(this)??(0,I.$ig)()),this.c}};e.$yL=Et,e.$yL=Et=Ke([F],Et);let mi=class extends Et{constructor(U,oe,Se,Ge,xe){if(super(oe,Se,Ge,xe),U===null)throw(0,T.$6)("location");this.location=U}};e.$zL=mi,e.$zL=mi=Ke([F],mi);let $i=class extends Et{constructor(U,oe,Se,Ge,xe){super(oe,Se,Ge,xe),this.functionName=U}};e.$AL=$i,e.$AL=$i=Ke([F],$i);let oi=class extends Et{constructor(U,oe,Se,Ge,xe,at,ht){if(super(Ge,xe,at,ht),!oe)throw(0,T.$6)("dataId");this.label=U,this.dataId=oe,this.canPersist=Se}};e.$BL=oi,e.$BL=oi=Ke([F],oi);let Si=class{constructor(U,oe,Se){this.command=U,this.args=oe||[],this.options=Se}};e.$CL=Si,e.$CL=Si=Ke([F],Si);let Ii=class{constructor(U,oe){this.port=U,this.host=oe}};e.$DL=Ii,e.$DL=Ii=Ke([F],Ii);let Ft=class{constructor(U){this.path=U}};e.$EL=Ft,e.$EL=Ft=Ke([F],Ft);let pi=class{constructor(U){this.implementation=U}};e.$FL=pi,e.$FL=pi=Ke([F],pi);let Ci=class{constructor(U,oe,Se){this.session=U,this.threadId=oe,this.frameId=Se}};e.$GL=Ci,e.$GL=Ci=Ke([F],Ci);let ai=class{constructor(U,oe){this.session=U,this.threadId=oe}};e.$HL=ai,e.$HL=ai=Ke([F],ai);let ci=class{constructor(U,oe){this.range=U,this.expression=oe}};e.$IL=ci,e.$IL=ci=Ke([F],ci);var lt;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(lt||(e.InlineCompletionTriggerKind=lt={}));let Pi=class{constructor(U,oe){this.range=U,this.text=oe}};e.$JL=Pi,e.$JL=Pi=Ke([F],Pi);let xt=class{constructor(U,oe,Se=!0){this.range=U,this.variableName=oe,this.caseSensitiveLookup=Se}};e.$KL=xt,e.$KL=xt=Ke([F],xt);let ni=class{constructor(U,oe){this.range=U,this.expression=oe}};e.$LL=ni,e.$LL=ni=Ke([F],ni);let hi=class{constructor(U,oe){this.frameId=U,this.stoppedLocation=oe}};e.$ML=hi,e.$ML=hi=Ke([F],hi);var Xi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let Ai=u=class extends Error{static FileExists(U){return new u(U,l.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(U){return new u(U,l.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(U){return new u(U,l.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(U){return new u(U,l.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(U){return new u(U,l.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(U){return new u(U,l.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(U,oe=l.FileSystemProviderErrorCode.Unknown,Se){super(d.URI.isUri(U)?U.toString(!0):U),this.code=Se?.name??"Unknown",(0,l.$tk)(this,oe),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$NL=Ai,e.$NL=Ai=u=Ke([F],Ai);let Ri=class{constructor(U,oe,Se){this.start=U,this.end=oe,this.kind=Se}};e.$OL=Ri,e.$OL=Ri=Ke([F],Ri);var Mi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Mi||(e.FoldingRangeKind=Mi={}));var xi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var Li;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Li||(e.CommentMode=Li={}));var ui;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ui||(e.CommentState=ui={}));var _i;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(_i||(e.CommentThreadState=_i={}));class Fi{constructor(U,oe=[]){this.tokenTypes=U,this.tokenModifiers=oe}}e.$PL=Fi;function Ti(j){return typeof j>"u"||(0,E.$Df)(j)}class Oi{constructor(U){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,U){this.l=!0;for(let oe=0,Se=U.tokenTypes.length;oe<Se;oe++)this.j.set(U.tokenTypes[oe],oe);for(let oe=0,Se=U.tokenModifiers.length;oe<Se;oe++)this.k.set(U.tokenModifiers[oe],oe)}}push(U,oe,Se,Ge,xe){if(typeof U=="number"&&typeof oe=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.n(U,oe,Se,Ge,xe);if(L.isRange(U)&&typeof oe=="string"&&Ti(Se))return this.m(U,oe,Se);throw(0,T.$6)()}m(U,oe,Se){if(!this.l)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ge=U.start.line,xe=U.start.character,at=U.end.character-U.start.character,ht=this.j.get(oe);let Ut=0;if(Se)for(const Zt of Se){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);Ut|=1<<ei>>>0}this.n(Ge,xe,at,ht,Ut)}n(U,oe,Se,Ge,xe){if(this.f&&(U<this.c||U===this.c&&oe<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Zt=0,ei=0;for(let ii=0;ii<Ut;ii++){let ri=this.g[5*ii],Qi=this.g[5*ii+1];ri===0?(ri=Zt,Qi+=ei):ri+=Zt,this.g[5*ii]=ri,this.g[5*ii+1]=Qi,Zt=ri,ei=Qi}}let at=U,ht=oe;this.f&&this.h>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ht,this.g[this.h++]=Se,this.g[this.h++]=Ge,this.g[this.h++]=xe,this.c=U,this.e=oe}static o(U){const oe=[],Se=U.length/5|0;for(let ht=0;ht<Se;ht++)oe[ht]=ht;oe.sort((ht,Ut)=>{const Zt=U[5*ht],ei=U[5*Ut];if(Zt===ei){const ii=U[5*ht+1],ri=U[5*Ut+1];return ii-ri}return Zt-ei});const Ge=new Uint32Array(U.length);let xe=0,at=0;for(let ht=0;ht<Se;ht++){const Ut=5*oe[ht],Zt=U[Ut+0],ei=U[Ut+1],ii=U[Ut+2],ri=U[Ut+3],Qi=U[Ut+4],Sn=Zt-xe,Tn=Sn===0?ei-at:ei,Yi=5*ht;Ge[Yi+0]=Sn,Ge[Yi+1]=Tn,Ge[Yi+2]=ii,Ge[Yi+3]=ri,Ge[Yi+4]=Qi,xe=Zt,at=ei}return Ge}build(U){return this.f?new Ni(new Uint32Array(this.g),U):new Ni(Oi.o(this.g),U)}}e.$QL=Oi;class Ni{constructor(U,oe){this.resultId=oe,this.data=U}}e.$RL=Ni;class di{constructor(U,oe,Se){this.start=U,this.deleteCount=oe,this.data=Se}}e.$SL=di;class hn{constructor(U,oe){this.resultId=oe,this.edits=U}}e.$TL=hn;var en;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(en||(e.DebugConsoleMode=en={}));let zi=class{static{this.Back={iconPath:new Xt("arrow-left")}}constructor(){}};e.$UL=zi,e.$UL=zi=Ke([F],zi);var vi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var tn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(tn||(e.InputBoxValidationSeverity=tn={}));var nn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class bi{static validate(U){if(typeof U.badge=="string"){let oe=(0,$.$df)(U.badge,0);if(oe<U.badge.length&&(oe+=(0,$.$df)(U.badge,oe)),U.badge.length>oe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(U.badge&&!Xt.isThemeIcon(U.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}constructor(U,oe,Se){this.badge=U,this.tooltip=oe,this.color=Se}}e.$VL=bi;let wi=class{constructor(U){this.kind=U}};e.$WL=wi,e.$WL=wi=Ke([F],wi);var rn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class _t{static isNotebookRange(U){return U instanceof _t?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(U,oe){if(U<0)throw(0,T.$6)("start must be positive");if(oe<0)throw(0,T.$6)("end must be positive");U<=oe?(this.c=U,this.e=oe):(this.c=oe,this.e=U)}with(U){let oe=this.c,Se=this.e;return U.start!==void 0&&(oe=U.start),U.end!==void 0&&(Se=U.end),oe===this.c&&Se===this.e?this:new _t(oe,Se)}}e.$XL=_t;class fi{static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(oe=>fi.isNotebookCellData(oe))}static isNotebookCellData(U){return!0}constructor(U,oe,Se,Ge,xe,at,ht){this.kind=U,this.value=oe,this.languageId=Se,this.mime=Ge,this.outputs=xe??[],this.metadata=at,this.executionSummary=ht,fi.validate(this)}}e.$YL=fi;class dn{constructor(U){this.cells=U}}e.$ZL=dn;class Yt{static isNotebookCellOutputItem(U){return U instanceof Yt?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const oe={name:U.name,message:U.message,stack:U.stack};return Yt.json(oe,"application/vnd.code.notebook.error")}static stdout(U){return Yt.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Yt.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,oe="application/octet-stream"){return new Yt(U,oe)}static#e=new TextEncoder;static text(U,oe=A.$Vr.text){const Se=Yt.#e.encode(String(U));return new Yt(Se,oe)}static json(U,oe="text/x-json"){const Se=JSON.stringify(U,void 0,"	");return Yt.text(Se,oe)}constructor(U,oe){this.data=U,this.mime=oe;const Se=(0,A.$Zr)(oe,!0);if(!Se)throw new Error(`INVALID mime type: ${oe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$1L=Yt;class yi{static isNotebookCellOutput(U){return U instanceof yi?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&Array.isArray(U.items)}static ensureUniqueMimeTypes(U,oe=!1){const Se=new Set,Ge=new Set;for(let xe=0;xe<U.length;xe++){const at=U[xe],ht=(0,A.$Zr)(at.mime);if(!Se.has(ht)||(0,v.$CI)(ht)){Se.add(ht);continue}Ge.add(xe),oe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?U:U.filter((xe,at)=>!Ge.has(at))}constructor(U,oe,Se){this.items=yi.ensureUniqueMimeTypes(U,!0),typeof oe=="string"?(this.id=oe,this.metadata=Se):(this.id=(0,I.$ig)(),this.metadata=oe??Se)}}e.$2L=yi;var sn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var Ei;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ei||(e.NotebookCellExecutionState=Ei={}));var Ui;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ui||(e.NotebookCellStatusBarAlignment=Ui={}));var Te;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Te||(e.NotebookEditorRevealType=Te={}));class ti{constructor(U,oe){this.text=U,this.alignment=oe}}e.$3L=ti;var ji;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(ji||(e.NotebookControllerAffinity=ji={}));var mt;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(mt||(e.NotebookControllerAffinity2=mt={}));class fn{constructor(U,oe=[]){this.uri=U,this.provides=(0,y.$2b)(oe)}}e.$4L=fn;class gn{constructor(U){this.label=U}}e.$5L=gn;let Di=class{constructor(U,oe){this.label=U,this.timestamp=oe}};e.$6L=Di,e.$6L=Di=Ke([F],Di);var on;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var gi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(gi||(e.ExtensionRuntime=gi={}));var an;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class mn{constructor(U,oe){this.ranges=U,this.wordPattern=oe}}e.$7L=mn;class $n{constructor(U){this.c=U}get autoForwardAction(){return this.c}}e.$8L=$n;var Bi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Bi||(e.TestResultState=Bi={}));var cn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Vi=class{constructor(U=void 0,oe=void 0,Se=void 0,Ge=!1){this.include=U,this.exclude=oe,this.profile=Se,this.continuous=Ge}};e.$9L=Vi,e.$9L=Vi=Ke([F],Vi);let Wi=w=class{static diff(U,oe,Se){const Ge=new w(U);return Ge.expectedOutput=oe,Ge.actualOutput=Se,Ge}constructor(U){this.message=U}};e.$0L=Wi,e.$0L=Wi=w=Ke([F],Wi);let qi=class{constructor(U){this.id=U}};e.$$L=qi,e.$$L=qi=Ke([F],qi);let li=class{constructor(U,oe){this.covered=U,this.total=oe}};e.$_L=li,e.$_L=li=Ke([F],li);let Ki=S=class{static fromDetails(U,oe){const Se=new li(0,0),Ge=new li(0,0),xe=new li(0,0);for(const ht of oe)if("branches"in ht){Se.total+=1,Se.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)Ge.total+=1,Ge.covered+=Ut.executionCount>0?1:0}else xe.total+=1,xe.covered+=ht.executionCount>0?1:0;const at=new S(U,Se,Ge.total>0?Ge:void 0,xe.total>0?xe:void 0);return at.detailedCoverage=oe,at}constructor(U,oe,Se,Ge){this.uri=U,this.statementCoverage=oe,this.branchCoverage=Se,this.functionCoverage=Ge}};e.$aM=Ki,e.$aM=Ki=S=Ke([F],Ki);let Hi=class{constructor(U,oe,Se=[]){this.executionCount=U,this.location=oe,this.branches=Se}};e.$bM=Hi,e.$bM=Hi=Ke([F],Hi);let Gi=class{constructor(U,oe){this.executionCount=U,this.location=oe}};e.$cM=Gi,e.$cM=Gi=Ke([F],Gi);let Ji=class{constructor(U,oe){this.executionCount=U,this.location=oe}};e.$dM=Ji,e.$dM=Ji=Ke([F],Ji);var un;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(un||(e.ExternalUriOpenerPriority=un={}));var ee;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(ee||(e.WorkspaceTrustState=ee={}));var ge;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(ge||(e.PortAutoForwardAction=ge={}));class Fe{constructor(U,oe,Se,Ge,xe,at){this.kind=U,this.name=oe,this.detail=Se,this.uri=Ge,this.range=xe,this.selectionRange=at}}e.$eM=Fe;class ot{constructor(U){this.uri=U}}e.$fM=ot;class wt{constructor(U,oe){this.original=U,this.modified=oe}}e.$gM=wt;class Tt{constructor(U,oe,Se,Ge){this.base=U,this.input1=oe,this.input2=Se,this.result=Ge}}e.$hM=Tt;class In{constructor(U,oe){this.uri=U,this.viewType=oe}}e.$iM=In;class Cn{constructor(U){this.viewType=U}}e.$jM=Cn;class Pn{constructor(U,oe){this.uri=U,this.notebookType=oe}}e.$kM=Pn;class An{constructor(U,oe,Se){this.original=U,this.modified=oe,this.notebookType=Se}}e.$lM=An;class Rn{constructor(){}}e.$mM=Rn;class Mn{constructor(U,oe){this.uri=U,this.inputBoxUri=oe}}e.$nM=Mn;class Ln{constructor(U){this.providerId=U}}e.$oM=Ln;var pn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var vn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var bn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));var yn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Fn{constructor(U,oe){this.role=U,this.content=oe}}e.$pM=Fn;var En;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(En||(e.ChatAgentResultFeedbackKind=En={}));var Dn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var kn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(kn||(e.SpeechToTextStatus=kn={}))}),define(Pe[103],Ae([1,0,53,13,12,295,147,7,18]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EM=e.$DM=e.$CM=void 0;const d=new Map;function I(v,f){f?d.set(v,f):d.delete(v)}e.$CM=I;function D(v){return d.get(v)}class l extends M.$2u{constructor(f,t,i,r,c,o,h,n){super(t,i,r,c),this.c=f,this.m=o,this.q=h,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,E.$tb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===T.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(t){return t?f.s(t):f.getText()},get eol(){return f.g===`
`?$.EndOfLine.LF:$.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(t){return f.t(t)},offsetAt(t){return f.u(t)},positionAt(t){return f.v(t)},validateRange(t){return f.w(t)},validatePosition(t){return f.x(t)},getWordRangeAtPosition(t,i){return f.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,y.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,y.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const t=this.w(f);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,r=t.start.line,c=t.end.line,o=[];o.push(this.f[r].substring(t.start.character));for(let h=r+1;h<c;h++)o.push(this.f[h]);return o.push(this.f[c].substring(0,t.end.character)),o.join(i)}t(f){let t;if(f instanceof $.$BK?t=f.line:typeof f=="number"&&(t=f),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const t=this.j.getIndexOf(f),i=this.f[t.index].length;return new $.$BK(t.index,Math.min(t.remainder,i))}w(f){if(!(f instanceof $.$CK))throw new Error("Invalid argument");const t=this.x(f.start),i=this.x(f.end);return t===f.start&&i===f.end?f:new $.$CK(t.line,t.character,i.line,i.character)}x(f){if(!(f instanceof $.$BK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:t,character:i}=f,r=!1;if(t<0)t=0,i=0,r=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,r=!0;else{const c=this.f[t].length;i<0?(i=0,r=!0):i>c&&(i=c,r=!0)}return r?new $.$BK(t,i):f}y(f,t){const i=this.x(f);if(!t)t=D(this.m);else if((0,P.$Se)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const r=(0,A.$bs)(i.character+1,(0,A.$_r)(t),this.f[i.line],0);if(r)return new $.$CK(i.line,r.startColumn-1,i.line,r.endColumn-1)}}e.$DM=l;class b{constructor(f,t,i){this.a=f,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new $.$CK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new $.$CK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$EM=b}),define(Pe[210],Ae([1,0,7,17,5]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vfc=void 0;let M=class{constructor($){this.a=new y.$WL(y.ColorThemeKind.Dark),this.b=new P.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange($){let E;switch($){case"light":E=y.ColorThemeKind.Light;break;case"hcDark":E=y.ColorThemeKind.HighContrast;break;case"hcLight":E=y.ColorThemeKind.HighContrastLight;break;default:E=y.ColorThemeKind.Dark}this.a=new y.$WL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Vfc=M,e.$Vfc=M=Ke([Ve(0,T.$AM)],M)}),define(Pe[211],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GI=e.CellExecutionUpdateType=void 0;var T;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$GI=(0,y.$Vh)("INotebookExecutionService")}),define(Pe[212],Ae([1,0,6,29,144,93]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Ob=void 0;class A extends y.$Rc{constructor(E,d,I){super(),this._source=E,this.b=d,this.c=I,this.a=void 0}f(E){const d=E.getLineCount();return new T.$zs(1,1,d,this.g(E,d))}g(E,d){if(d<1||d>E.getLineCount())throw new Error("Illegal value for lineNumber");return E.getLineLength(d)+1}get inputTextBuffer(){if(!this.b){const E=new P.$NB;E.acceptChunk(this._source);const d=E.finish(!0),{textBuffer:I,disposable:D}=d.create(1);this.b=I,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(E=>{const d=new P.$NB;d.acceptChunk(E);const I=d.finish(!0),{textBuffer:D,disposable:l}=I.create(1);return this.B(l),D})),this.a}findInInputs(E){const I=new M.$BB(E,!1,!1,null).parseSearchRequest();if(!I)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,I,!0,5e3)}findInOutputs(E){const I=new M.$BB(E,!1,!1,null).parseSearchRequest();return I?this.outputTextBuffers.map(D=>{const l=D.findMatchesLineByLine(this.f(D),I,!0,5e3);if(l.length!==0)return{textBuffer:D,matches:l}}).filter(D=>!!D):[]}}e.$5Ob=A}),define(Pe[48],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(M){M.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class P{static fromExtHostTestItem(A,$,E=A.parent){if(A._isRoot)return new P([$]);const d=[A.id];for(let I=E;I&&I.id!==$;I=I.parent)d.push(I.id);return d.push($),new P(d.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const $=A.indexOf("\0");return $===-1?A:A.slice(0,$)}static fromString(A){return new P(A.split("\0"))}static join(A,$){return new P([...A.path,$])}static joinToString(A,$){return A.toString()+"\0"+$}static parentId(A){const $=A.lastIndexOf("\0");return $===-1?void 0:A.slice(0,$)}static localId(A){const $=A.lastIndexOf("\0");return $===-1?A:A.slice($+1)}static isChild(A,$){return $.startsWith(A)&&$[A.length]==="\0"}static compare(A,$){return A===$?0:P.isChild(A,$)?2:P.isChild($,A)?3:1}constructor(A,$=A.length){if(this.path=A,this.d=$,A.length===0||$<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let $=0;$<A.d&&$<this.d;$++)if(A.path[$]!==this.path[$])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$rJ=P}),define(Pe[58],Ae([1,0,2,29,48]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$xJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$wJ=e.$vJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$uJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$tJ=e.$sJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var A;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var $;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$sJ=[2,4,8,16,32,64];const E=C=>"runId"in C;e.$tJ=E;var d;(function(C){C.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),C.deserialize=u=>({range:T.$zs.lift(u.range),uri:y.URI.revive(u.uri)})})(d||(e.IRichLocation=d={}));var I;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(I||(e.TestMessageType=I={}));var D;(function(C){C.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&d.serialize(u.location)}),C.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&d.deserialize(u.location)})})(D||(e.ITestErrorMessage=D={}));const l=(C,u)=>`${u?"s":"e"}${C}`;e.$uJ=l;var b;(function(C){C.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&d.serialize(u.location)}),C.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&d.deserialize(u.location)})})(b||(e.ITestOutputMessage=b={}));var v;(function(C){C.serialize=u=>u.type===0?D.serialize(u):b.serialize(u),C.deserialize=u=>u.type===0?D.deserialize(u):b.deserialize(u)})(v||(e.ITestMessage=v={}));var f;(function(C){C.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),C.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(v.serialize)}),C.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map(v.deserialize)})})(f||(e.ITestTaskState=f={}));const t="\0",i=(C,u)=>C+t+u;e.$vJ=i;const r=C=>{const u=C.indexOf(t);return{ctrlId:C.slice(0,u),tagId:C.slice(u+1)}};e.$wJ=r;var c;(function(C){C.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),C.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?y.URI.revive(u.uri):void 0,range:u.range?T.$zs.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(c||(e.ITestItem=c={}));var o;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(o||(e.TestItemExpandState=o={}));var h;(function(C){C.serialize=u=>({expand:u.expand,item:c.serialize(u.item)}),C.deserialize=u=>({controllerId:P.$rJ.root(u.item.extId),expand:u.expand,item:c.deserialize(u.item)})})(h||(e.InternalTestItem=h={}));var n;(function(C){C.serialize=u=>{let w;return u.item&&(w={},u.item.label!==void 0&&(w.label=u.item.label),u.item.tags!==void 0&&(w.tags=u.item.tags),u.item.busy!==void 0&&(w.busy=u.item.busy),u.item.uri!==void 0&&(w.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(w.range=u.item.range?.toJSON()),u.item.description!==void 0&&(w.description=u.item.description),u.item.error!==void 0&&(w.error=u.item.error),u.item.sortText!==void 0&&(w.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:w}},C.deserialize=u=>{let w;return u.item&&(w={},u.item.label!==void 0&&(w.label=u.item.label),u.item.tags!==void 0&&(w.tags=u.item.tags),u.item.busy!==void 0&&(w.busy=u.item.busy),u.item.range!==void 0&&(w.range=u.item.range?T.$zs.lift(u.item.range):null),u.item.description!==void 0&&(w.description=u.item.description),u.item.error!==void 0&&(w.error=u.item.error),u.item.sortText!==void 0&&(w.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:w}}})(n||(e.ITestItemUpdate=n={}));const s=(C,u)=>{u.expand!==void 0&&(C.expand=u.expand),u.item!==void 0&&(C.item=C.item?Object.assign(C.item,u.item):u.item)};e.$xJ=s;var a;(function(C){C.serializeWithoutMessages=u=>({...h.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serializeWithoutMessages)}),C.serialize=u=>({...h.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.serialize)}),C.deserialize=u=>({...h.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(f.deserialize),retired:!0})})(a||(e.TestResultItem=a={}));var g;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(g||(e.DetailType=g={}));var p;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(p||(e.TestDiffOpType=p={}));var m;(function(C){C.deserialize=u=>u.op===0?{op:u.op,item:h.deserialize(u.item)}:u.op===1?{op:u.op,item:n.deserialize(u.item)}:u.op===2?{op:u.op,uri:y.URI.revive(u.uri),docv:u.docv}:u,C.serialize=u=>u.op===0?{op:u.op,item:h.serialize(u.item)}:u.op===1?{op:u.op,item:n.serialize(u.item)}:u})(m||(e.TestsDiffOp=m={}));class k{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(u){const w=this.o();for(const S of u)switch(S.op){case 0:this.j(h.deserialize(S.item),w);break;case 1:this.k(n.deserialize(S.item),w);break;case 3:this.l(S.itemId,w);break;case 5:this.m(S.itemId);break;case 4:this.updatePendingRoots(S.amount);break;case 6:this.c.set(S.tag.id,S.tag);break;case 7:this.c.delete(S.id);break}w.complete?.()}j(u,w){const S=P.$rJ.parentId(u.item.extId)?.toString();let F;if(!S)F=this.p(u),this.f.add(F),this.d.set(u.item.extId,F);else if(this.d.has(S)){const V=this.d.get(S);V.children.add(u.item.extId),F=this.p(u,V),this.d.set(u.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return w.add?.(F),u.expand===2&&this.g++,F}k(u,w){const S=this.d.get(u.extId);if(S)return u.expand!==void 0&&(S.expand===2&&this.g--,u.expand===2&&this.g++),(0,e.$xJ)(S,u),w.update?.(S),S}l(u,w){const S=this.d.get(u);if(!S)return;const F=P.$rJ.parentId(S.item.extId)?.toString();F?this.d.get(F).children.delete(S.item.extId):this.f.delete(S);const V=[[u]];for(;V.length;)for(const J of V.pop()){const N=this.d.get(J);N&&(V.push(N.children),this.d.delete(J),w.remove?.(N,N!==S),N.expand===2&&this.g--)}}m(u){}updatePendingRoots(u){this.h+=u}o(){return{}}}e.$yJ=k}),define(Pe[77],Ae([1,0,14,5,6,53,58,48]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.TestItemEventOp=void 0;var E;(function(r){r[r.Upsert=0]="Upsert",r[r.SetTags=1]="SetTags",r[r.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",r[r.RemoveChild=3]="RemoveChild",r[r.SetProp=4]="SetProp",r[r.Bulk=5]="Bulk",r[r.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const d=(r,c)=>r===c,D=Object.entries({range:(r,c)=>r===c?!0:!r||!c?!1:r.equalsRange(c),busy:d,label:d,description:d,error:d,sortText:d,tags:(r,c)=>!(r.length!==c.length||r.some(o=>!c.includes(o)))}),l=(r,c)=>{let o;for(const[h,n]of D)n(r[h],c[h])||(o?o[h]=c[h]:o={[h]:c[h]});return o};class b extends P.$Rc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new y.$0g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===c.uri){o.docv=c.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===c.item.extId){(0,A.$xJ)(o.item,c.item);return}if(o.op===0&&o.item.item.extId===c.item.extId){(0,A.$xJ)(o.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,o){const h=this.tree.get(c);if(h){if((h.expandLevels===void 0||o>h.expandLevels)&&(h.expandLevels=o),h.expand===1){const n=this.L(h);return n.isOpen()?this.J(h,o-1):n.wait().then(()=>this.J(h,o-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,o-1)):this.J(h,o-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,o){switch(o.op){case 3:this.N($.$rJ.joinToString(c.fullId,o.id));break;case 0:this.y(o.item,c);break;case 5:for(const h of o.ops)this.u(c,h);break;case 1:this.z(o.new,o.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:o.update}});break;case 6:this.w(c.actual.uri);break;default:(0,M.$4c)(o)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,o){const h=$.$rJ.fromExtHostTestItem(c,this.root.id,o?.actual),n=this.s.getApiFor(c);n.parent&&n.parent!==o?.actual&&this.s.getChildren(n.parent).delete(c.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:c,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(c,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(c)}}),this.H(c,s,o);return}if(s.actual===c){this.G(c,s,o);return}if(s.actual.uri?.toString()!==c.uri?.toString())return this.N(h.toString()),this.y(c,o);const a=this.s.getChildren(s.actual),g=s.actual,p=l(this.s.toITestItem(g),this.s.toITestItem(c));this.s.getApiFor(g).listener=void 0,s.actual=c,s.expand=0,p&&(p.hasOwnProperty("tags")&&(this.z(c.tags,g.tags,h.toString()),delete p.tags),this.u(s,{op:4,update:p})),this.H(c,s,o);for(const[m,k]of a)this.s.getChildren(c).get(k.id)||this.N($.$rJ.joinToString(h,k.id));this.w(s.actual.uri)}z(c,o,h){const n=new Set(o.map(s=>s.id));for(const s of c)n.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:h,item:{tags:c.map(s=>(0,A.$vJ)(this.s.controllerId,s.id))}}}),n.forEach(this.D,this)}C(c){const o=this.j.get(c.id);o?o.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$vJ)(this.s.controllerId,c.id)}}))}D(c){const o=this.j.get(c);o&&!--o.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,A.$vJ)(this.s.controllerId,c)}))}F(c,o){this.s.getApiFor(c).parent=o&&o.actual!==this.root?o.actual:void 0}G(c,o,h){this.F(c,h);const n=this.s.getApiFor(c);n.parent=h?.actual,n.listener=s=>this.u(o,s),this.I(o)}H(c,o,h){this.G(c,o,h);for(const[n,s]of this.s.getChildren(c))this.y(s,o)}I(c){let o;this.h?c.resolveBarrier?o=c.resolveBarrier.isOpen()?3:2:o=c.actual.canResolveChildren?1:0:o=0,o!==c.expand&&(c.expand=o,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:o}}),o===1&&c.expandLevels!==void 0&&this.L(c))}J(c,o){if(o<0)return;const h=[];for(const[n,s]of this.s.getChildren(c.actual)){const a=this.expand($.$rJ.joinToString(c.fullId,s.id),o);(0,y.$Kg)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const s=new y.$Wg;return s.open(),s}c.expand=2,this.M(c);const o=c.resolveBarrier=new y.$Wg,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let n;try{n=this.h(c.actual===this.root?void 0:c.actual)}catch(s){h(s)}return(0,y.$Kg)(n)?n.catch(h).then(()=>{o.open(),this.I(c)}):(o.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const o=this.tree.get(c);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const h=[o];for(;h.length;){const n=h.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const s of n.actual.tags)this.D(s.id);this.tree.delete(n.fullId.toString());for(const[s,a]of this.s.getChildren(n.actual))h.push(this.tree.get($.$rJ.joinToString(n.fullId,a.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$qM=b;class v extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$rM=v;class f extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$sM=f;class t extends Error{constructor(c,o,h){super(`TestItem with ID "${c}" is from controller "${o}" and cannot be added as a child of an item from controller "${h}".`)}}e.$tM=t;const i=(r,c,o)=>{let h=new Map;return{get size(){return h.size},forEach(n,s){for(const a of h.values())n.call(s,a,this)},[Symbol.iterator](){return h.entries()},replace(n){const s=new Map,a=new Set(h.keys()),g={op:5,ops:[]};for(const p of n){if(!(p instanceof o))throw new f(p.id);const m=c(p).controllerId;if(m!==r.controllerId)throw new t(p.id,m,r.controllerId);if(s.has(p.id))throw new v(p.id);s.set(p.id,p),a.delete(p.id),g.ops.push({op:0,item:p})}for(const p of a.keys())g.ops.push({op:3,id:p});r.listener?.(g),h=s},add(n){if(!(n instanceof o))throw new f(n.id);h.set(n.id,n),r.listener?.({op:0,item:n})},delete(n){h.delete(n)&&r.listener?.({op:3,id:n})},get(n){return h.get(n)},toJSON(){return Array.from(h.values())}}};e.$uM=i}),define(Pe[104],Ae([1,0,77]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=void 0;const T=new WeakMap,P=(A,$)=>{const E={controllerId:$};return T.set(A,E),E};e.$vM=P;const M=A=>{const $=T.get(A);if(!$)throw new y.$sM(A?.id||"<unknown>");return $};e.$wM=M}),define(Pe[78],Ae([1,0,13,2]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kub=e.$jub=e.$iub=e.$hub=e.$gub=void 0,e.$gub="vscode-cdn.net",e.$hub=`vscode-resource.${e.$gub}`,e.$iub=`'self' https://*.${e.$gub}`;function P($,E){return $.scheme===y.Schemas.http||$.scheme===y.Schemas.https?$:(E&&E.authority&&E.isRemote&&$.scheme===y.Schemas.file&&($=T.URI.from({scheme:y.Schemas.vscodeRemote,authority:E.authority,path:$.path})),T.URI.from({scheme:y.Schemas.https,authority:`${$.scheme}+${M($.authority)}.${e.$hub}`,path:$.path,fragment:$.fragment,query:$.query}))}e.$jub=P;function M($){return $.replace(/./g,E=>{const d=E.charCodeAt(0);return d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57?E:"-"+d.toString(16).padStart(4,"0")})}function A($){return $.replace(/-([0-9a-f]{4})/g,(E,d)=>String.fromCharCode(parseInt(d,16)))}e.$kub=A}),define(Pe[213],Ae([1,0,5,6,78]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fec=void 0;class M{constructor($,E,d){this.d=$,this.e=E,this.f=d,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const I=E.getVisibleTextEditors();for(const D of this.c.values())I.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach($=>$.inset.dispose()),this.b.dispose()}createWebviewEditorInset($,E,d,I,D){let l;for(const c of this.e.getVisibleTextEditors(!0))if(c.value===$){l=c;break}if(!l)throw new Error("not a visible editor");const b=this,v=this.a++,f=new y.$Rd,t=new y.$Rd,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(c){return(0,P.$jub)(c,b.f)}get cspSource(){return P.$iub}set options(c){this.b=c,b.d.$setOptions(v,c)}get options(){return this.b}set html(c){this.a=c,b.d.$setHtml(v,c)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(c){return b.d.$postMessage(v,c)}},r=new class{constructor(){this.editor=$,this.line=E,this.height=d,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has(v)&&(b.c.delete(v),b.d.$disposeEditorInset(v),t.fire(),t.dispose(),f.dispose())}};return this.d.$createEditorInset(v,l.id,l.value.document.uri,E+1,d,I||{},D.identifier,D.extensionLocation),this.c.set(v,{editor:$,inset:r,onDidReceiveMessage:f}),r}$onDidDispose($){const E=this.c.get($);E&&E.inset.dispose()}$onDidReceiveMessage($,E){this.c.get($)?.onDidReceiveMessage.fire(E)}}e.$fec=M}),define(Pe[214],Ae([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=e.VariableKind=e.$mN=void 0,e.$mN=(0,y.$Vh)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class P extends Error{constructor(A,$){super($),this.variable=A}}e.$nN=P}),define(Pe[215],Ae([1,0,20,74,16,26,21,94,177,214,12]),function(we,e,y,T,P,M,A,$,E,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,v,f,t){this.h=new Map,this.a=b,this.b=v,this.g=f,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(A.$i){const v=Object.create(null);return Object.keys(b).forEach(f=>{v[f.toLowerCase()]=b[f]}),v}return b}resolveWithEnvironment(b,v,f){return this.l({env:this.i(b),userHome:void 0},v?v.uri:void 0,f)}async resolveAsync(b,v){const f={env:await this.c,userHome:await this.g};return this.l(f,b?b.uri:void 0,v)}async j(b,v,f,t){const i=M.$an(v);A.$i&&i.windows?Object.keys(i.windows).forEach(c=>i[c]=i.windows[c]):A.$j&&i.osx?Object.keys(i.osx).forEach(c=>i[c]=i.osx[c]):A.$k&&i.linux&&Object.keys(i.linux).forEach(c=>i[c]=i.linux[c]),delete i.windows,delete i.osx,delete i.linux;const r={env:await this.c,userHome:await this.g};return this.l(r,b?b.uri:void 0,i,f,t)}async resolveAnyAsync(b,v,f){return this.j(b,v,f)}async resolveAnyMap(b,v,f){const t=new Map;return{newConfig:await this.j(b,v,f,t),resolvedVariables:t}}resolveWithInteractionReplace(b,v,f,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,v,f,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,v){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,v)}async l(b,v,f,t,i){if(P.$Cf(f))return this.m(b,v,f,t,i);if(Array.isArray(f))return Promise.all(f.map(r=>this.l(b,v,r,t,i)));if(P.$Ef(f)){const r=Object.create(null),c=await Promise.all(Object.keys(f).map(async o=>[await this.m(b,v,o,t,i),await this.l(b,v,f[o],t,i)]));for(const[o,h]of c)r[o]=h;return r}return f}m(b,v,f,t,i){return(0,I.$Xe)(f,D.VARIABLE_REGEXP,async(r,c)=>{if(c.includes(D.VARIABLE_LHS))return r;let o=await this.o(b,r,c,v,t);return i?.set(c,o),o!==r&&P.$Cf(o)&&o.match(D.VARIABLE_REGEXP)&&(o=await this.m(b,v,o,t,i)),o})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,v,f,t,i){let r;const c=f.split(":");c.length>1&&(f=c[0],r=c[1]);const o=s=>{const a=this.a.getFilePath();if(a)return(0,$.$zv)(a);throw new d.$nN(s,(0,E.localize)(0,null,v))},h=s=>{const a=o(s);if(this.a.getWorkspaceFolderPathForFile){const g=this.a.getWorkspaceFolderPathForFile();if(g)return(0,$.$zv)(g)}throw new d.$nN(s,(0,E.localize)(1,null,v,y.$mc(a)))},n=s=>{if(r){const a=this.a.getFolderUri(r);if(a)return a;throw new d.$nN(s,(0,E.localize)(2,null,v,r))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new d.$nN(s,(0,E.localize)(3,null,v)):new d.$nN(s,(0,E.localize)(4,null,v))};switch(f){case"env":if(r){if(b.env){const s=b.env[A.$i?r.toLowerCase():r];if(P.$Cf(s))return s}return""}throw new d.$nN(d.VariableKind.Env,(0,E.localize)(5,null,v));case"config":if(r){const s=this.a.getConfigurationValue(t,r);if(P.$Lf(s))throw new d.$nN(d.VariableKind.Config,(0,E.localize)(6,null,v,r));if(P.$Ef(s))throw new d.$nN(d.VariableKind.Config,(0,E.localize)(7,null,v,r));return s}throw new d.$nN(d.VariableKind.Config,(0,E.localize)(8,null,v));case"command":return this.p(d.VariableKind.Command,v,r,i,"command");case"input":return this.p(d.VariableKind.Input,v,r,i,"input");case"extensionInstallFolder":if(r){const s=await this.a.getExtension(r);if(!s)throw new d.$nN(d.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,v,r));return this.n(s.extensionLocation)}throw new d.$nN(d.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,v));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,$.$zv)(this.n(n(d.VariableKind.WorkspaceFolder)));case"cwd":return t||r?(0,$.$zv)(this.n(n(d.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,$.$zv)(y.$mc(this.n(n(d.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new d.$nN(d.VariableKind.UserHome,(0,E.localize)(11,null,v))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new d.$nN(d.VariableKind.LineNumber,(0,E.localize)(12,null,v))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new d.$nN(d.VariableKind.SelectedText,(0,E.localize)(13,null,v))}case"file":return o(d.VariableKind.File);case"fileWorkspaceFolder":return h(d.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return y.$mc(h(d.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return t||r?y.$kc(this.n(n(d.VariableKind.RelativeFile)),o(d.VariableKind.RelativeFile)):o(d.VariableKind.RelativeFile);case"relativeFileDirname":{const s=y.$lc(o(d.VariableKind.RelativeFileDirname));if(t||r){const a=y.$kc(this.n(n(d.VariableKind.RelativeFileDirname)),s);return a.length===0?".":a}return s}case"fileDirname":return y.$lc(o(d.VariableKind.FileDirname));case"fileExtname":return y.$nc(o(d.VariableKind.FileExtname));case"fileBasename":return y.$mc(o(d.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=y.$mc(o(d.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-y.$nc(s).length)}case"fileDirnameBasename":return y.$mc(y.$lc(o(d.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||v}case"execInstallFolder":{const s=this.a.getAppRoot();return s||v}case"pathSeparator":return y.sep;default:try{const s=r?`${f}:${r}`:f;return this.p(d.VariableKind.Unknown,v,s,i,void 0)}catch{return v}}}}p(b,v,f,t,i){if(f&&t){const r=i===void 0?t[f]:t[i+":"+f];if(typeof r=="string")return r;throw new d.$nN(b,(0,E.localize)(14,null,v))}return v}}e.$BN=D}),define(Pe[105],Ae([1,0,4,102]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JC=e.$IC=e.OpenEditorContext=e.GroupsOrder=e.$HC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$GC=void 0,e.$GC=(0,y.$Vh)("editorGroupsService");var P;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var $;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})($||(e.GroupsArrangement=$={}));var E;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function d(v){const f=v;return(0,T.$pE)(f?.editor)&&(0,T.$pE)(f?.replacement)}e.$HC=d;var I;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var D;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function l(v){const f=v;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$IC=l;function b(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$JC=b}),define(Pe[216],Ae([1,0,4,105]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NC=e.$MC=e.$LC=e.$KC=void 0,e.$KC=(0,y.$Vh)("editorService"),e.$LC=-1,e.$MC=-2;function P(M){const A=M;return typeof M=="number"||(0,T.$IC)(A)}e.$NC=P}),define(Pe[217],Ae([1,0,4,184]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VJ=void 0,e.$VJ=(0,y.$Wh)(T.$3h)}),define(Pe[106],Ae([1,0,22,5,20,6]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=e.$b6b=e.$a6b=e.$_5b=e.$$5b=void 0;class A{constructor(i,r){this.versionId=i,this.removedDueToLooping=r}}e.$$5b=A;class ${static isHostExtension(i,r,c){if(r.getExtensionDescription(i))return!1;const o=c.getExtensionDescription(i);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(i,r){this.j=i,this.c=new T.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=r,this.k()}k(){this.e.sort(v),this.f=new y.$bm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const r=this.j.readActivationEvents(i);for(const c of r)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,r){this.e=f(this.e,r),this.e=this.e.concat(i);const c=$.l(this.e);return this.e=f(this.e,c.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,c)}static l(i){const r=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,a){this.addNode(s),this.addNode(a),this.c.has(s)?this.c.get(s).push(a):this.c.set(s,[a])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,a){const g=r.getArcs(s);for(let p=0;p<g.length;p++)if(!a.has(g[p]))return!1;return!0}getNodes(){return this.e}},c=new y.$bm;for(const s of i)if(c.set(s.identifier,s),s.extensionDependencies)for(const a of s.extensionDependencies)r.addArc(y.$_l.toKey(s.identifier),y.$_l.toKey(a));const o=new Set;r.getNodes().filter(s=>r.getArcs(s).length===0).forEach(s=>o.add(s));const h=r.getNodes().filter(s=>!o.has(s));let n;do{n=!1;for(let s=0;s<h.length;s++){const a=h[s];r.hasOnlyGoodArcs(a,o)&&(h.splice(s,1),s--,o.add(a),n=!0)}}while(n);return h.map(s=>c.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const r=this.h.get(i);return r?r.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const r=this.f.get(i);return r||void 0}getExtensionDescriptionByUUID(i){for(const r of this.g)if(r.uuid===i)return r}getExtensionDescriptionByIdOrUUID(i,r){return this.getExtensionDescription(i)??(r?this.getExtensionDescriptionByUUID(r):void 0)}}e.$_5b=$;class E{constructor(i,r){this.versionId=i,this.extensions=r}}e.$a6b=E;class d{constructor(i){this.d=new l,this.c=new $(i,[])}async acquireLock(i){const r=await this.d.acquire(i);return new I(this,r)}deltaExtensions(i,r,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(r,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,r){return this.c.getExtensionDescriptionByIdOrUUID(i,r)}}e.$b6b=d;class I extends M.$Rc{constructor(i,r){super(),this.f=i,this.c=!1,this.B(r)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$c6b=I;class D{constructor(i){this.name=i,this.promise=new Promise((r,c)=>{this.c=r})}resolve(i){this.c(i)}}class l{constructor(){this.c=[],this.d=!1}async acquire(i){const r=new D(i);return this.c.push(r),this.e(),r.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let r=!0;const c=setTimeout(()=>{r&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{r&&(clearTimeout(c),r=!1,this.d=!1,this.e())};i.resolve((0,M.$Pc)(o))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function v(t,i){const r=t.isBuiltin?0:t.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(r!==c)return r-c;const o=P.$fc.basename(t.extensionLocation.path),h=P.$fc.basename(i.extensionLocation.path);return o<h?-1:o>h?1:0}function f(t,i){const r=new y.$am(i);return t.filter(c=>!r.has(c.identifier))}}),define(Pe[79],Ae([1,0,24]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$im=e.$hm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(T||(e.UIKind=T={}));var P;(function(d){d[d.VersionMismatch=55]="VersionMismatch",d[d.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(d){d[d.Initialized=0]="Initialized",d[d.Ready=1]="Ready",d[d.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(d){const I=y.$fe.alloc(1);switch(d){case 0:I.writeUInt8(1,0);break;case 1:I.writeUInt8(2,0);break;case 2:I.writeUInt8(3,0);break}return I}e.$hm=A;function $(d,I){if(d.byteLength!==1)return!1;switch(d.readUInt8(0)){case 1:return I===0;case 2:return I===1;case 3:return I===2;default:return!1}}e.$im=$;var E;(function(d){d.Start="START_NATIVE_LOG",d.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Pe[59],Ae([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(we,e,y,T,P,M,A,$,E,d,I,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=e.$RM=void 0;let b=class extends D.$Rc{constructor(i,r){super(),this.s=i,this.t=r,this.a=this.B(new T.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=I.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=r.createLogger(this.m,{id:E.$uo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(r.onDidChangeLogLevel(c=>{(0,P.$fj)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,r,c){const o=this.getTelemetryDetails(),h=new v(r,c,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(i,r,c){this.f=i,this.g=r,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const r=Object.create(null);switch(r["common.extname"]=`${i.publisher}.${i.name}`,r["common.extversion"]=i.version,r["common.vscodemachineid"]=this.s.telemetryInfo.machineId,r["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,r["common.vscodeversion"]=this.s.version,r["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),r["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:r["common.uikind"]="web";break;case A.UIKind.Desktop:r["common.uikind"]="desktop";break;default:r["common.uikind"]="unknown"}return r["common.remotename"]=(0,$.$2k)((0,E.$Bo)(this.s.remote.authority)),r}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const r=this.getTelemetryDetails();this.r.forEach((c,o)=>{const h=c.filter(n=>!n.isDisposed);h.length===0?this.r.delete(o):this.r.set(o,h)}),this.r.forEach(c=>{for(const o of c)o.updateTelemetryEnablements(r.isUsageEnabled,r.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,r){const o=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!o)return this.r.delete(i.value),!1;let h=!1;for(const n of o)n.ignoreUnhandledExtHostErrors||(n.logError(r),h=!0);return h}};e.$RM=b,e.$RM=b=Ke([Ve(0,M.$QM),Ve(1,P.$ej)],b);class v{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,r,c,o,h,n,s){this.g=c,this.h=o,this.i=h,this.j=n,this.a=new T.$Rd,this.ignoreUnhandledExtHostErrors=r?.ignoreUnhandledErrors??!1,this.b=r?.ignoreBuiltInCommonProperties??!1,this.c=r?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,r){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:r},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let r="properties"in i?i.properties??{}:i;return r=(0,E.$Eo)(r,[]),this.c&&(r=(0,d.$dn)(r,this.c)),this.b||(r=(0,d.$dn)(r,this.j)),"properties"in i?i.properties=r:i=r,i}k(i,r){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f?.sendEventData(i,r),this.h.trace(i,r))}logUsage(i,r){this.d.isUsageEnabled&&this.k(i,r)}logError(i,r){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,r);else{const c={name:i.name,message:i.message,stack:i.stack,cause:i.cause},o=(0,E.$Eo)(c,[]),h=new Error(o.message,{cause:o.cause});h.stack=o.stack,h.name=o.name,r=this.mixInCommonPropsAndCleanData(r||{}),this.i||this.f.sendErrorData(h,r),this.h.trace("exception",r)}}get apiTelemetryLogger(){if(!this.e){const i=this,r={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(r)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$SM=v;function f(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$TM=f,e.$UM=(0,y.$Vh)("IExtHostTelemetry")}),define(Pe[23],Ae([1,0,5,2,193,101,22,4]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RF=e.$QF=e.$PF=e.ActivationKind=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=e.ExtensionHostStartup=e.$JF=e.$IF=e.$HF=e.$GF=void 0,e.$GF=Object.freeze({identifier:new A.$_l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HF="extensions.webWorker",e.$IF=(0,$.$Vh)("extensionService");class E{constructor(h){this.dependency=h}}e.$JF=E;var d;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(d||(e.ExtensionHostStartup=d={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,n,s){this.c=h,this.d=n.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$xF.createActivationEventsMap(this.d)}}set(h,n,s){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],g=[],p=[],m=[],k=D(this.d),C=D(n),u=(J,N)=>J.extensionLocation.toString()===N.extensionLocation.toString()||J.isBuiltin===N.isBuiltin||J.isUserBuiltin===N.isUserBuiltin||J.isUnderDevelopment===N.isUnderDevelopment;for(const J of this.d){const N=C.get(J.identifier);if(!N){a.push(J.identifier),k.delete(J.identifier);continue}if(!u(J,N)){a.push(J.identifier),k.delete(J.identifier);continue}}for(const J of n){const N=k.get(J.identifier);if(!N){g.push(J);continue}if(!u(N,J)){a.push(N.identifier),k.delete(N.identifier);continue}}const w=new A.$am(this.e),S=new A.$am(s);for(const J of this.e)S.has(J)||p.push(J);for(const J of s)w.has(J)||m.push(J);const F=M.$xF.createActivationEventsMap(g),V={versionId:h,toRemove:a,toAdd:g,addActivationEvents:F,myToRemove:p,myToAdd:m};return this.delta(V),V}delta(h){if(this.c>=h.versionId)return null;const{toRemove:n,toAdd:s,myToRemove:a,myToAdd:g}=h,p=new A.$am(n),m=new A.$am(a);for(let k=0;k<this.d.length;k++)p.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)m.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of s)this.d.push(k);for(const k of g)this.e.push(k);return this.f=null,h}containsExtension(h){for(const n of this.e)if(A.$_l.equals(n,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const n of this.d){if(!this.containsExtension(n.identifier))continue;const s=M.$xF.readActivationEvents(n);for(const a of s)h.add(a)}return h}}e.$KF=I;function D(o){const h=new A.$bm;for(const n of o)h.set(n.identifier,n);return h}function l(o,h){return o.enabledApiProposals?o.enabledApiProposals.includes(h):!1}e.$LF=l;function b(o,h){if(!l(o,h))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$MF=b;class v{constructor(h,n,s,a){this.codeLoadingTime=h,this.activateCallTime=n,this.activateResolvedTime=s,this.activationReason=a}}e.$NF=v;class f{constructor(h,n){this.description=h,this.value=n}}e.$OF=f;var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.$Ko)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$PF=i;function r(o,h){return{identifier:new A.$_l((0,P.$Io)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!h,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$QF=r;class c{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,n){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RF=c}),define(Pe[218],Ae([1,0,11,106,22,23,15,14]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=e.$Fec=e.$Eec=e.$Dec=e.$Cec=e.$Bec=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(i,r,c,o){this.startup=i,this.codeLoadingTime=r,this.activateCallTime=c,this.activateResolvedTime=o}}e.$Bec=E;class d{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,r){return i===-1||r===-1?-1:r-i}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Cec=d;class I{constructor(i,r,c,o,h,n){this.activationFailed=i,this.activationFailedError=r,this.activationTimes=c,this.module=o,this.exports=h,this.subscriptions=n}}e.$Dec=I;class D extends I{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Eec=D;class l extends I{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Fec=l;class b extends I{constructor(i){super(!0,i,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(i,r,c,o){this.g=o,this.a=i,this.b=r,this.c=c,this.d=new P.$bm,this.f=Object.create(null)}dispose(){for(const[i,r]of this.d)r.dispose()}async waitForActivatingExtensions(){const i=[];for(const[r,c]of this.d)i.push(c.wait());await Promise.all(i)}isActivated(i){const r=this.d.get(i);return!!(r&&r.value)}getActivatedExtension(i){const r=this.d.get(i);if(!r||!r.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return r.value}async activateByEvent(i,r){if(this.f[i])return;const c=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(c.map(o=>({id:o.identifier,reason:{startup:r,extensionId:o.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,r){const c=this.a.getExtensionDescription(i);if(!c)throw new Error(`Extension '${i}' is not known`);return this.h([{id:c.identifier,reason:r}])}async h(i){const r=i.filter(c=>!this.isActivated(c.id)).map(c=>this.j(c));await Promise.all(r.map(c=>c.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const r=this.a.getExtensionDescription(i.id);if(!r){const h=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(h));return this.c.onExtensionActivationError(i.id,h,new M.$JF(i.id.value)),n}const c=[],o=typeof r.extensionDependencies>"u"?[]:r.extensionDependencies;for(const h of o){if(this.m(h))continue;const n=this.d.get(h);if(n){c.push(n);continue}if(this.l(h)){c.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;c.push(this.j({id:s.identifier,reason:i.reason}));continue}const a=r.displayName||r.identifier.value,g=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),p=this.k(i,r.displayName,[],new b(g));return this.c.onExtensionActivationError(r.identifier,g,new M.$JF(h)),p}return this.k(i,r.displayName,c,null)}k(i,r,c,o){const h=new f(i.id,r,i.reason,c,o,this.c,this.g);return this.d.set(i.id,h),h}l(i){return T.$_5b.isHostExtension(i,this.a,this.b)}m(i){const r=this.b.getExtensionDescription(i);return r?!r.main&&!r.browser:!1}};e.$Gec=v,e.$Gec=v=Ke([Ve(3,A.$dj)],v);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,r,c,o,h,n,s){this.c=i,this.d=r,this.f=c,this.g=o,this.h=h,this.j=n,this.k=s,this.a=new $.$Wg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const r=this.g[i];if(r.value&&!r.value.activationFailed){this.g.splice(i,1),i--;continue}if(r.value&&r.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${r.friendlyName}' failed to activate`);c.detail=r.value.activationFailedError,this.h=new b(c),this.j.onExtensionActivationError(this.c,c,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const r=new Error;if(i&&i.name&&(r.name=i.name),i&&i.message?r.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:r.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(r.stack=i.stack),this.h=new b(r),this.b&&y.$3(i))return;this.j.onExtensionActivationError(this.c,r,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};f=Ke([Ve(6,A.$dj)],f)}),define(Pe[8],Ae([1,0,18,24,126,219,52,28,120,51,68,26,16,2,29,80,98,104,102,76,48,58,216,7,23]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o,h,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$zM=e.$yM=e.MarkdownString=e.$xM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var g;(function(Ce){function Me(K){const{selectionStartLineNumber:Le,selectionStartColumn:je,positionLineNumber:Qe,positionColumn:qe}=K,it=new s.$BK(Le-1,je-1),pt=new s.$BK(Qe-1,qe-1);return new s.$DK(it,pt)}Ce.to=Me;function be(K){const{anchor:Le,active:je}=K;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}Ce.from=be})(g||(e.Selection=g={}));var p;(function(Ce){function Me(K){if(!K)return;const{start:Le,end:je}=K;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}Ce.from=Me;function be(K){if(!K)return;const{startLineNumber:Le,startColumn:je,endLineNumber:Qe,endColumn:qe}=K;return new s.$CK(Le-1,je-1,Qe-1,qe-1)}Ce.to=be})(p||(e.Range=p={}));var m;(function(Ce){function Me(be){switch(be){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Me})(m||(e.TokenType=m={}));var k;(function(Ce){function Me(K){return new s.$BK(K.lineNumber-1,K.column-1)}Ce.to=Me;function be(K){return{lineNumber:K.line+1,column:K.character+1}}Ce.from=be})(k||(e.Position=k={}));var C;(function(Ce){function Me(Le,je,Qe){return(0,y.$Gb)((0,y.$2b)(Le).map(qe=>be(qe,je,Qe)))}Ce.from=Me;function be(Le,je,Qe){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Qe?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:K(Le.scheme,je),pattern:X.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Qe?.isBuiltin}}function K(Le,je){return je&&typeof Le=="string"?je.transformOutgoingScheme(Le):Le}})(C||(e.DocumentSelector=C={}));var u;(function(Ce){function Me(K){switch(K){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Me;function be(K){switch(K){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=be})(u||(e.DiagnosticTag=u={}));var w;(function(Ce){function Me(K){let Le;return K.code&&((0,l.$Cf)(K.code)||(0,l.$Gf)(K.code)?Le=String(K.code):Le={value:String(K.code.value),target:K.code.target}),{...p.from(K.range),message:K.message,source:K.source,code:Le,severity:F.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(S.from),tags:Array.isArray(K.tags)?(0,y.$Gb)(K.tags.map(u.from)):void 0}}Ce.from=Me;function be(K){const Le=new s.$OK(p.to(K),K.message,F.to(K.severity));return Le.source=K.source,Le.code=(0,l.$Cf)(K.code)?K.code:K.code?.value,Le.relatedInformation=K.relatedInformation&&K.relatedInformation.map(S.to),Le.tags=K.tags&&(0,y.$Gb)(K.tags.map(u.to)),Le}Ce.to=be})(w||(e.Diagnostic=w={}));var S;(function(Ce){function Me(K){return{...p.from(K.location.range),message:K.message,resource:K.location.uri}}Ce.from=Me;function be(K){return new s.$NK(new s.$MK(K.resource,p.to(K)),K.message)}Ce.to=be})(S||(e.DiagnosticRelatedInformation=S={}));var F;(function(Ce){function Me(K){switch(K){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Me;function be(K){switch(K){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=be})(F||(e.DiagnosticSeverity=F={}));var V;(function(Ce){function Me(K){return typeof K=="number"&&K>=s.ViewColumn.One?K-1:K===s.ViewColumn.Beside?n.$MC:n.$LC}Ce.from=Me;function be(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=be})(V||(e.ViewColumn=V={}));function J(Ce){return typeof Ce.range<"u"}function N(Ce){return Ce.length===0?!0:!!J(Ce[0])}e.$xM=N;var R;(function(Ce){function Me(qe){return qe.map(Ce.from)}Ce.fromMany=Me;function be(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function K(qe){let it;if(be(qe)){const{language:ut,value:Mt}=qe;it={value:"```"+ut+`
`+Mt+"\n```\n"}}else s.$1K.isMarkdownString(qe)?it={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?it={value:qe}:it={value:""};const pt=Object.create(null);it.uris=pt;const $t=ut=>{try{let Mt=b.URI.parse(ut,!0);Mt=Mt.with({query:Le(Mt.query,pt)}),pt[ut]=Mt}catch{}return""},bt=new E.marked.Renderer;return bt.link=$t,bt.image=ut=>typeof ut=="string"?$t(A.$dk(ut).href):"",(0,E.marked)(it.value,{renderer:bt}),it}Ce.from=K;function Le(qe,it){if(!qe)return qe;let pt;try{pt=(0,d.$rh)(qe)}catch{}if(!pt)return qe;let $t=!1;return pt=(0,D.$cn)(pt,bt=>{if(b.URI.isUri(bt)){const ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[ut]=bt,$t=!0,ut}else return}),$t?JSON.stringify(pt):qe}function je(qe){const it=new s.$1K(qe.value,qe.supportThemeIcons);return it.isTrusted=qe.isTrusted,it.supportHtml=qe.supportHtml,it.baseUri=qe.baseUri?b.URI.from(qe.baseUri):void 0,it}Ce.to=je;function Qe(qe){if(qe)return typeof qe=="string"?qe:Ce.from(qe)}Ce.fromStrict=Qe})(R||(e.MarkdownString=R={}));function L(Ce){return N(Ce)?Ce.map(Me=>({range:p.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?R.fromMany(Me.hoverMessage):Me.hoverMessage?R.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ce.map(Me=>({range:p.from(Me)}))}e.$yM=L;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?b.URI.file(Ce):Ce}e.$zM=O;var Z;(function(Ce){function Me(be){return typeof be>"u"?be:{contentText:be.contentText,contentIconPath:be.contentIconPath?O(be.contentIconPath):void 0,border:be.border,borderColor:be.borderColor,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,color:be.color,backgroundColor:be.backgroundColor,margin:be.margin,width:be.width,height:be.height}}Ce.from=Me})(Z||(e.ThemableDecorationAttachmentRenderOptions=Z={}));var he;(function(Ce){function Me(be){return typeof be>"u"?be:{backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?O(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?Z.from(be.before):void 0,after:be.after?Z.from(be.after):void 0}}Ce.from=Me})(he||(e.ThemableDecorationRenderOptions=he={}));var $e;(function(Ce){function Me(be){if(typeof be>"u")return be;switch(be){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Me})($e||(e.DecorationRangeBehavior=$e={}));var De;(function(Ce){function Me(be){return{isWholeLine:be.isWholeLine,rangeBehavior:be.rangeBehavior?$e.from(be.rangeBehavior):void 0,overviewRulerLane:be.overviewRulerLane,light:be.light?he.from(be.light):void 0,dark:be.dark?he.from(be.dark):void 0,backgroundColor:be.backgroundColor,outline:be.outline,outlineColor:be.outlineColor,outlineStyle:be.outlineStyle,outlineWidth:be.outlineWidth,border:be.border,borderColor:be.borderColor,borderRadius:be.borderRadius,borderSpacing:be.borderSpacing,borderStyle:be.borderStyle,borderWidth:be.borderWidth,fontStyle:be.fontStyle,fontWeight:be.fontWeight,textDecoration:be.textDecoration,cursor:be.cursor,color:be.color,opacity:be.opacity,letterSpacing:be.letterSpacing,gutterIconPath:be.gutterIconPath?O(be.gutterIconPath):void 0,gutterIconSize:be.gutterIconSize,overviewRulerColor:be.overviewRulerColor,before:be.before?Z.from(be.before):void 0,after:be.after?Z.from(be.after):void 0}}Ce.from=Me})(De||(e.DecorationRenderOptions=De={}));var ke;(function(Ce){function Me(K){return{text:K.newText,eol:K.newEol&&et.from(K.newEol),range:p.from(K.range)}}Ce.from=Me;function be(K){const Le=new s.$HK(p.to(K.range),K.text);return Le.newEol=typeof K.eol>"u"?void 0:et.to(K.eol),Le}Ce.to=be})(ke||(e.TextEdit=ke={}));var fe;(function(Ce){function Me(K,Le){const je={edits:[]};if(K instanceof s.$KK){const Qe=new $.$Ac;for(const qe of K._allEntries())qe._type===1&&b.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of K._allEntries())if(qe._type===1){let it;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?it={type:"base64",value:(0,T.$ze)(T.$fe.wrap(qe.options.contents))}:it={type:"dataTransferItem",id:qe.options.contents._itemId}),je.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:it},metadata:qe.metadata})}else qe._type===2?je.edits.push({resource:qe.uri,textEdit:ke.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?je.edits.push({resource:qe.uri,textEdit:{range:p.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Le?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?je.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&je.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Dt.from)}})}return je}Ce.from=Me;function be(K){const Le=new s.$KK,je=new $.$zc;for(const Qe of K.edits)if(Qe.textEdit){const qe=Qe,it=b.URI.revive(qe.resource),pt=p.to(qe.textEdit.range),$t=qe.textEdit.text,bt=qe.textEdit.insertAsSnippet;let ut;bt?ut=s.$JK.replace(pt,new s.$LK($t)):ut=s.$HK.replace(pt,$t);const Mt=je.get(it);Mt?Mt.push(ut):je.set(it,[ut])}else Le.renameFile(b.URI.revive(Qe.oldResource),b.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of je)Le.set(Qe,qe);return Le}Ce.to=be})(fe||(e.WorkspaceEdit=fe={}));var ve;(function(Ce){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function be(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ce.from=be;function K(Le){for(const je in Me)if(Me[je]===Le)return Number(je);return s.SymbolKind.Property}Ce.to=K})(ve||(e.SymbolKind=ve={}));var te;(function(Ce){function Me(K){switch(K){case s.SymbolTag.Deprecated:return 1}}Ce.from=Me;function be(K){switch(K){case 1:return s.SymbolTag.Deprecated}}Ce.to=be})(te||(e.SymbolTag=te={}));var Re;(function(Ce){function Me(K){return{name:K.name,kind:ve.from(K.kind),tags:K.tags&&K.tags.map(te.from),containerName:K.containerName,location:pe.from(K.location)}}Ce.from=Me;function be(K){const Le=new s.$RK(K.name,ve.to(K.kind),K.containerName,pe.to(K.location));return Le.tags=K.tags&&K.tags.map(te.to),Le}Ce.to=be})(Re||(e.WorkspaceSymbol=Re={}));var se;(function(Ce){function Me(K){const Le={name:K.name||"!!MISSING: name!!",detail:K.detail,range:p.from(K.range),selectionRange:p.from(K.selectionRange),kind:ve.from(K.kind),tags:K.tags?.map(te.from)??[]};return K.children&&(Le.children=K.children.map(Me)),Le}Ce.from=Me;function be(K){const Le=new s.$SK(K.name,K.detail,ve.to(K.kind),p.to(K.range),p.to(K.selectionRange));return(0,y.$Kb)(K.tags)&&(Le.tags=K.tags.map(te.to)),K.children&&(Le.children=K.children.map(be)),Le}Ce.to=be})(se||(e.DocumentSymbol=se={}));var Y;(function(Ce){function Me(K){const Le=new s.$WK(ve.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),p.to(K.range),p.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Ce.to=Me;function be(K,Le,je){if(Le=Le??K._sessionId,je=je??K._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,name:K.name,detail:K.detail,kind:ve.from(K.kind),uri:K.uri,range:p.from(K.range),selectionRange:p.from(K.selectionRange),tags:K.tags?.map(te.from)}}Ce.from=be})(Y||(e.CallHierarchyItem=Y={}));var B;(function(Ce){function Me(be){return new s.$XK(Y.to(be.from),be.fromRanges.map(K=>p.to(K)))}Ce.to=Me})(B||(e.CallHierarchyIncomingCall=B={}));var ne;(function(Ce){function Me(be){return new s.$YK(Y.to(be.to),be.fromRanges.map(K=>p.to(K)))}Ce.to=Me})(ne||(e.CallHierarchyOutgoingCall=ne={}));var pe;(function(Ce){function Me(K){return{range:K.range&&p.from(K.range),uri:K.uri}}Ce.from=Me;function be(K){return new s.$MK(b.URI.revive(K.uri),p.to(K.range))}Ce.to=be})(pe||(e.location=pe={}));var re;(function(Ce){function Me(K){const Le=K,je=K;return{originSelectionRange:Le.originSelectionRange?p.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:je.uri,range:p.from(Le.targetRange?Le.targetRange:je.range),targetSelectionRange:Le.targetSelectionRange?p.from(Le.targetSelectionRange):void 0}}Ce.from=Me;function be(K){return{targetUri:b.URI.revive(K.uri),targetRange:p.to(K.range),targetSelectionRange:K.targetSelectionRange?p.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?p.to(K.originSelectionRange):void 0}}Ce.to=be})(re||(e.DefinitionLink=re={}));var le;(function(Ce){function Me(K){return{range:p.from(K.range),contents:R.fromMany(K.contents)}}Ce.from=Me;function be(K){return new s.$PK(K.contents.map(R.to),p.to(K.range))}Ce.to=be})(le||(e.Hover=le={}));var ce;(function(Ce){function Me(K){return{range:p.from(K.range),expression:K.expression}}Ce.from=Me;function be(K){return new s.$IL(p.to(K.range),K.expression)}Ce.to=be})(ce||(e.EvaluatableExpression=ce={}));var ye;(function(Ce){function Me(K){if(K instanceof s.$JL)return{type:"text",range:p.from(K.range),text:K.text};if(K instanceof s.$KL)return{type:"variable",range:p.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof s.$LL)return{type:"expression",range:p.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Me;function be(K){switch(K.type){case"text":return{range:p.to(K.range),text:K.text};case"variable":return{range:p.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:p.to(K.range),expression:K.expression}}}Ce.to=be})(ye||(e.InlineValue=ye={}));var _;(function(Ce){function Me(K){return{frameId:K.frameId,stoppedLocation:p.from(K.stoppedLocation)}}Ce.from=Me;function be(K){return new s.$ML(K.frameId,p.to(K.stoppedLocation))}Ce.to=be})(_||(e.InlineValueContext=_={}));var de;(function(Ce){function Me(K){return{range:p.from(K.range),kind:K.kind}}Ce.from=Me;function be(K){return new s.$QK(p.to(K.range),K.kind)}Ce.to=be})(de||(e.DocumentHighlight=de={}));var ie;(function(Ce){function Me(be){switch(be){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Me})(ie||(e.CompletionTriggerKind=ie={}));var ae;(function(Ce){function Me(be){return{triggerKind:ie.to(be.triggerKind),triggerCharacter:be.triggerCharacter}}Ce.to=Me})(ae||(e.CompletionContext=ae={}));var me;(function(Ce){function Me(K){switch(K){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Me;function be(K){switch(K){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=be})(me||(e.CompletionItemTag=me={}));var Ie;(function(Ce){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function be(je){return Me.get(je)??9}Ce.from=be;const K=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(je){return K.get(je)??s.CompletionItemKind.Property}Ce.to=Le})(Ie||(e.CompletionItemKind=Ie={}));var z;(function(Ce){function Me(be,K){const Le=new s.$7K(be.label);return Le.insertText=be.insertText,Le.kind=Ie.to(be.kind),Le.tags=be.tags?.map(me.to),Le.detail=be.detail,Le.documentation=A.$$j(be.documentation)?R.to(be.documentation):be.documentation,Le.sortText=be.sortText,Le.filterText=be.filterText,Le.preselect=be.preselect,Le.commitCharacters=be.commitCharacters,v.$zs.isIRange(be.range)?Le.range=p.to(be.range):typeof be.range=="object"&&(Le.range={inserting:p.to(be.range.insert),replacing:p.to(be.range.replace)}),Le.keepWhitespace=typeof be.insertTextRules>"u"?!1:!!(be.insertTextRules&1),typeof be.insertTextRules<"u"&&be.insertTextRules&4?Le.insertText=new s.$LK(be.insertText):(Le.insertText=be.insertText,Le.textEdit=Le.range instanceof s.$CK?new s.$HK(Le.range,Le.insertText):void 0),be.additionalTextEdits&&be.additionalTextEdits.length>0&&(Le.additionalTextEdits=be.additionalTextEdits.map(je=>ke.to(je))),Le.command=K&&be.command?K.fromInternal(be.command):void 0,Le}Ce.to=Me})(z||(e.CompletionItem=z={}));var W;(function(Ce){function Me(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:R.fromStrict(K.documentation)}}Ce.from=Me;function be(K){return{label:K.label,documentation:A.$$j(K.documentation)?R.to(K.documentation):K.documentation}}Ce.to=be})(W||(e.ParameterInformation=W={}));var H;(function(Ce){function Me(K){return{label:K.label,documentation:R.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(W.from):[],activeParameter:K.activeParameter}}Ce.from=Me;function be(K){return{label:K.label,documentation:A.$$j(K.documentation)?R.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(W.to):[],activeParameter:K.activeParameter}}Ce.to=be})(H||(e.SignatureInformation=H={}));var G;(function(Ce){function Me(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.from):[]}}Ce.from=Me;function be(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(H.to):[]}}Ce.to=be})(G||(e.SignatureHelp=G={}));var q;(function(Ce){function Me(be,K){const Le=new s.$6K(k.to(K.position),typeof K.label=="string"?K.label:K.label.map(x.to.bind(void 0,be)),K.kind&&ue.to(K.kind));return Le.textEdits=K.textEdits&&K.textEdits.map(ke.to),Le.tooltip=A.$$j(K.tooltip)?R.to(K.tooltip):K.tooltip,Le.paddingLeft=K.paddingLeft,Le.paddingRight=K.paddingRight,Le}Ce.to=Me})(q||(e.InlayHint=q={}));var x;(function(Ce){function Me(be,K){const Le=new s.$5K(K.label);return Le.tooltip=A.$$j(K.tooltip)?R.to(K.tooltip):K.tooltip,f.Command.is(K.command)&&(Le.command=be.fromInternal(K.command)),K.location&&(Le.location=pe.to(K.location)),Le}Ce.to=Me})(x||(e.InlayHintLabelPart=x={}));var ue;(function(Ce){function Me(K){return K}Ce.from=Me;function be(K){return K}Ce.to=be})(ue||(e.InlayHintKind=ue={}));var Oe;(function(Ce){function Me(K){return{range:p.from(K.range),url:K.target,tooltip:K.tooltip}}Ce.from=Me;function be(K){let Le;if(K.url)try{Le=typeof K.url=="string"?b.URI.parse(K.url,!0):b.URI.revive(K.url)}catch{}return new s.$_K(p.to(K.range),Le)}Ce.to=be})(Oe||(e.DocumentLink=Oe={}));var Ue;(function(Ce){function Me(K){const Le=new s.$cL(K.label);return K.textEdit&&(Le.textEdit=ke.to(K.textEdit)),K.additionalTextEdits&&(Le.additionalTextEdits=K.additionalTextEdits.map(je=>ke.to(je))),Le}Ce.to=Me;function be(K){return{label:K.label,textEdit:K.textEdit?ke.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Le=>ke.from(Le)):void 0}}Ce.from=be})(Ue||(e.ColorPresentation=Ue={}));var Ze;(function(Ce){function Me(K){return new s.$aL(K[0],K[1],K[2],K[3])}Ce.to=Me;function be(K){return[K.red,K.green,K.blue,K.alpha]}Ce.from=be})(Ze||(e.Color=Ze={}));var Je;(function(Ce){function Me(K){return{range:p.from(K.range)}}Ce.from=Me;function be(K){return new s.$VK(p.to(K.range))}Ce.to=be})(Je||(e.SelectionRange=Je={}));var tt;(function(Ce){function Me(be){switch(be){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Me})(tt||(e.TextDocumentSaveReason=tt={}));var _e;(function(Ce){function Me(K){switch(K){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Me;function be(K){switch(K){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=be})(_e||(e.TextEditorLineNumbersStyle=_e={}));var et;(function(Ce){function Me(K){if(K===s.EndOfLine.CRLF)return 1;if(K===s.EndOfLine.LF)return 0}Ce.from=Me;function be(K){if(K===1)return s.EndOfLine.CRLF;if(K===0)return s.EndOfLine.LF}Ce.to=be})(et||(e.EndOfLine=et={}));var rt;(function(Ce){function Me(be){if(typeof be=="object")return be.viewId;switch(be){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Me})(rt||(e.ProgressLocation=rt={}));var nt;(function(Ce){function Me(K){const Le={start:K.start+1,end:K.end+1};return K.kind&&(Le.kind=ze.from(K.kind)),Le}Ce.from=Me;function be(K){const Le={start:K.start-1,end:K.end-1};return K.kind&&(Le.kind=ze.to(K.kind)),Le}Ce.to=be})(nt||(e.FoldingRange=nt={}));var ze;(function(Ce){function Me(K){if(K)switch(K){case s.FoldingRangeKind.Comment:return f.$ot.Comment;case s.FoldingRangeKind.Imports:return f.$ot.Imports;case s.FoldingRangeKind.Region:return f.$ot.Region}}Ce.from=Me;function be(K){if(K)switch(K.value){case f.$ot.Comment.value:return s.FoldingRangeKind.Comment;case f.$ot.Imports.value:return s.FoldingRangeKind.Imports;case f.$ot.Region.value:return s.FoldingRangeKind.Region}}Ce.to=be})(ze||(e.FoldingRangeKind=ze={}));var dt;(function(Ce){function Me(be){if(be)return{pinned:typeof be.preview=="boolean"?!be.preview:void 0,inactive:be.background,preserveFocus:be.preserveFocus,selection:typeof be.selection=="object"?p.from(be.selection):void 0,override:typeof be.override=="boolean"?r.$bE.id:void 0}}Ce.from=Me})(dt||(e.TextEditorOpenOptions=dt={}));var X;(function(Ce){function Me(je){return je instanceof s.$wL?je.toJSON():typeof je=="string"?je:be(je)||K(je)?new s.$wL(je.baseUri??je.base,je.pattern).toJSON():je}Ce.from=Me;function be(je){const Qe=je;return Qe?b.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function K(je){const Qe=je;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Le(je){return typeof je=="string"?je:new s.$wL(b.URI.revive(je.baseUri),je.pattern)}Ce.to=Le})(X||(e.GlobPattern=X={}));var Q;(function(Ce){function Me(be){if(be){if(Array.isArray(be))return be.map(Me);if(typeof be=="string")return be;{const K=be;return{language:K.language,scheme:K.scheme,pattern:X.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Ce.from=Me})(Q||(e.LanguageSelector=Q={}));var Ee;(function(Ce){function Me(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Le=>Array.isArray(Le)&&Le.every(je=>je&&typeof je=="object"&&"uri"in je&&b.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Qe=>Qe instanceof s.$CK)))}Ce.is=Me;function be(K){return{documents:K.documents.map(Le=>Le.map(je=>({uri:b.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Qe=>p.from(Qe))})))}}Ce.from=be})(Ee||(e.MappedEditsContext=Ee={}));var Be;(function(Ce){function Me(K){return{start:K.start,end:K.end}}Ce.from=Me;function be(K){return new s.$XL(K.start,K.end)}Ce.to=be})(Be||(e.NotebookRange=Be={}));var He;(function(Ce){function Me(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ce.to=Me;function be(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Ce.from=be})(He||(e.NotebookCellExecutionSummary=He={}));var Xe;(function(Ce){function Me(be){if(be===c.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(be===c.NotebookCellExecutionState.Pending)return;if(be===c.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${be}`)}Ce.to=Me})(Xe||(e.NotebookCellExecutionState=Xe={}));var st;(function(Ce){function Me(K){switch(K){case s.NotebookCellKind.Markup:return c.CellKind.Markup;case s.NotebookCellKind.Code:default:return c.CellKind.Code}}Ce.from=Me;function be(K){switch(K){case c.CellKind.Markup:return s.NotebookCellKind.Markup;case c.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=be})(st||(e.NotebookCellKind=st={}));var vt;(function(Ce){function Me(K){const Le={metadata:K.metadata??Object.create(null),cells:[]};for(const je of K.cells)s.$YL.validate(je),Le.cells.push(Dt.from(je));return Le}Ce.from=Me;function be(K){const Le=new s.$ZL(K.cells.map(Dt.to));return(0,l.$Pf)(K.metadata)||(Le.metadata=K.metadata),Le}Ce.to=be})(vt||(e.NotebookData=vt={}));var Dt;(function(Ce){function Me(K){return{cellKind:st.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:He.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Kt.from):[]}}Ce.from=Me;function be(K){return new s.$YL(st.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Kt.to):void 0,K.metadata,K.internalMetadata?He.to(K.internalMetadata):void 0)}Ce.to=be})(Dt||(e.NotebookCellData=Dt={}));var Ne;(function(Ce){function Me(K){return{mime:K.mime,valueBytes:T.$fe.wrap(K.data)}}Ce.from=Me;function be(K){return new s.$1L(K.valueBytes.buffer,K.mime)}Ce.to=be})(Ne||(e.NotebookCellOutputItem=Ne={}));var Kt;(function(Ce){function Me(K){return{outputId:K.id,items:K.items.map(Ne.from),metadata:K.metadata}}Ce.from=Me;function be(K){const Le=K.items.map(Ne.to);return new s.$2L(Le,K.outputId,K.metadata)}Ce.to=be})(Kt||(e.NotebookCellOutput=Kt={}));var Ht;(function(Ce){function Me(Le){return K(Le)?{include:X.from(Le.include)??void 0,exclude:X.from(Le.exclude)??void 0}:X.from(Le)??void 0}Ce.from=Me;function be(Le){return K(Le)?{include:X.to(Le.include),exclude:X.to(Le.exclude)}:X.to(Le)}Ce.to=be;function K(Le){const je=Le;return je?!(0,l.$Lf)(je.include)&&!(0,l.$Lf)(je.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var yt;(function(Ce){function Me(be,K,Le){const je=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{alignment:be.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(je,Le),text:be.text,tooltip:be.tooltip,accessibilityInformation:be.accessibilityInformation,priority:be.priority}}Ce.from=Me})(yt||(e.NotebookStatusBarItem=yt={}));var jt;(function(Ce){function Me(be,K,Le){const je=typeof be.command=="string"?{title:"",command:be.command}:be.command;return{command:K.toInternal(je,Le),label:be.label,description:be.description,detail:be.detail,documentation:be.documentation}}Ce.from=Me})(jt||(e.NotebookKernelSourceAction=jt={}));var Nt;(function(Ce){function Me(be){return{transientOutputs:be?.transientOutputs??!1,transientCellMetadata:be?.transientCellMetadata??{},transientDocumentMetadata:be?.transientDocumentMetadata??{},cellContentMetadata:be?.cellContentMetadata??{}}}Ce.from=Me})(Nt||(e.NotebookDocumentContentOptions=Nt={}));var Gt;(function(Ce){function Me(K){return{uri:K.uri,provides:K.provides}}Ce.from=Me;function be(K){return new s.$4L(b.URI.revive(K.uri),K.provides)}Ce.to=be})(Gt||(e.NotebookRendererScript=Gt={}));var Bt;(function(Ce){function Me(K){return{message:R.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:p.from(K.location.range),uri:K.location.uri}}}Ce.from=Me;function be(K){const Le=new s.$0L(typeof K.message=="string"?K.message:R.to(K.message));return Le.actualOutput=K.actual,Le.expectedOutput=K.expected,Le.contextValue=K.contextValue,Le.location=K.location?pe.to(K.location):void 0,Le}Ce.to=be})(Bt||(e.TestMessage=Bt={}));var St;(function(Ce){Ce.namespace=h.$vJ,Ce.denamespace=h.$wJ})(St||(e.TestTag=St={}));var Lt;(function(Ce){function Me(K){const Le=(0,i.$wM)(K).controllerId;return{extId:o.$rJ.fromExtHostTestItem(K,Le).toString(),label:K.label,uri:b.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(je=>St.namespace(Le,je.id)),range:v.$zs.lift(p.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&R.fromStrict(K.error)||null}}Ce.from=Me;function be(K){return{parent:void 0,error:void 0,id:o.$rJ.fromString(K.extId).localId,label:K.label,uri:b.URI.revive(K.uri),tags:(K.tags||[]).map(Le=>{const{tagId:je}=St.denamespace(Le);return new s.$$L(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:p.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Ce.toPlain=be})(Lt||(e.TestItem=Lt={})),function(Ce){function Me(K){return{id:K.id}}Ce.from=Me;function be(K){return new s.$$L(K.id)}Ce.to=be}(St||(e.TestTag=St={}));var Vt;(function(Ce){const Me=(K,Le)=>{const je=[];for(const[qe,it]of Le)o.$rJ.compare(it.item.extId,qe)===2&&(Le.delete(qe),je.push(it));const Qe={...Lt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(it=>it.type===0).map(Bt.to)})),children:je.map(qe=>Me(qe,Le))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function be(K){const Le=[],je=new Map;for(const Qe of K.items){je.set(Qe.item.extId,Qe);const qe=o.$rJ.root(Qe.item.extId);K.request.targets.some(it=>it.controllerId===qe&&it.testIds.includes(Qe.item.extId))&&Le.push(Qe)}return{completedAt:K.completedAt,results:Le.map(Qe=>Me(Qe,je))}}Ce.to=be})(Vt||(e.TestResults=Vt={}));var Ye;(function(Ce){function Me(je){return{covered:je.covered,total:je.covered}}function be(je){return"line"in je?k.from(je):p.from(je)}function K(je){return"branches"in je?{count:je.executionCount,location:be(je.location),type:1,branches:je.branches.length?je.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&be(Qe.location)})):void 0}:{type:0,count:je.executionCount,location:be(je.location)}}Ce.fromDetailed=K;function Le(je){return{uri:je.uri,statement:Me(je.statementCoverage),branch:je.branchCoverage&&Me(je.branchCoverage),function:je.functionCoverage&&Me(je.functionCoverage),details:je.detailedCoverage?.map(K)}}Ce.fromFile=Le})(Ye||(e.TestCoverage=Ye={}));var Wt;(function(Ce){function Me(be){switch(be){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Me})(Wt||(e.CodeActionTriggerKind=Wt={}));var qt;(function(Ce){function Me(K){const Le=new s.$eM(ve.to(K.kind),K.name,K.detail||"",b.URI.revive(K.uri),p.to(K.range),p.to(K.selectionRange));return Le._sessionId=K._sessionId,Le._itemId=K._itemId,Le}Ce.to=Me;function be(K,Le,je){if(Le=Le??K._sessionId,je=je??K._itemId,Le===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:je,kind:ve.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:p.from(K.range),selectionRange:p.from(K.selectionRange),tags:K.tags?.map(te.from)}}Ce.from=be})(qt||(e.TypeHierarchyItem=qt={}));var ct;(function(Ce){function Me(be){if(be)return{value:be.value,tooltip:be.tooltip}}Ce.from=Me})(ct||(e.ViewBadge=ct={}));var gt;(function(Ce){function Me(je,Qe,qe){const it=Qe.fileData;return it?new s.$pL(new s.$qL(it.name,b.URI.revive(it.uri),it.id,(0,M.$cb)(()=>qe(it.id)))):je===I.$Vr.uriList&&Qe.uriListData?new s.$oL(Le(Qe.uriListData)):new s.$oL(Qe.asString)}Ce.to=Me;async function be(je,Qe){const qe=await Qe.asString();if(je===I.$Vr.uriList)return{asString:qe,fileData:void 0,uriListData:K(qe)};const it=Qe.asFile();return{asString:qe,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Ce.from=be;function K(je){return P.$9s.split(je).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return b.URI.parse(Qe)}catch{}return Qe})}function Le(je){return P.$9s.create(je.map(Qe=>typeof Qe=="string"?Qe:b.URI.revive(Qe)))}})(gt||(e.DataTransferItem=gt={}));var Ot;(function(Ce){function Me(K,Le){const je=K.items.map(([Qe,qe])=>[Qe,gt.to(Qe,qe,Le)]);return new s.$rL(je)}Ce.toDataTransfer=Me;async function be(K){const Le={items:[]},je=[];for(const[Qe,qe]of K)je.push((async()=>{Le.items.push([Qe,await gt.from(Qe,qe)])})());return await Promise.all(je),Le}Ce.from=be})(Ot||(e.DataTransfer=Ot={}));var Pt;(function(Ce){function Me(be){return{kind:"reply",message:be.message,title:be.title,tooltip:be.tooltip}}Ce.from=Me})(Pt||(e.ChatReplyFollowup=Pt={}));var At;(function(Ce){function Me(be){return typeof be=="string"?{title:be,message:be,kind:"reply"}:"commandId"in be?{kind:"command",title:be.title??"",commandId:be.commandId??"",when:be.when??"",args:be.args}:Pt.from(be)}Ce.from=Me})(At||(e.ChatFollowup=At={}));var ft;(function(Ce){function Me(K){const Le=new s.$pM(kt.to(K.role),K.content);return Le.name=K.name,Le}Ce.to=Me;function be(K){return{role:kt.from(K.role),content:K.content,name:K.name}}Ce.from=be})(ft||(e.ChatMessage=ft={}));var kt;(function(Ce){function Me(K){switch(K){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Me;function be(K){switch(K){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=be})(kt||(e.ChatMessageRole=kt={}));var Rt;(function(Ce){function Me(Le){const je={};for(const Qe of Object.keys(Le))je[Qe]=Le[Qe].map(Ce.to);return je}Ce.objectTo=Me;function be(Le){return{level:Ct.to(Le.level),value:Le.value,description:Le.description}}Ce.to=be;function K(Le){return{level:Ct.from(Le.level),value:Le.value,description:Le.description}}Ce.from=K})(Rt||(e.ChatVariable=Rt={}));var Ct;(function(Ce){function Me(K){switch(K){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Me;function be(K){switch(K){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=be})(Ct||(e.ChatVariableLevel=Ct={}));var We;(function(Ce){function Me(be){switch(be){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Ce.to=Me})(We||(e.InteractiveEditorResponseFeedbackKind=We={}));var zt;(function(Ce){function Me(be,K){return"placeholder"in K&&"resolvedContent"in K?{content:K.placeholder,kind:"asyncContent"}:"markdownContent"in K?((0,a.$MF)(be,"chatAgents2Additions"),{content:R.from(K.markdownContent),kind:"markdownContent"}):"content"in K?typeof K.content=="string"?{content:K.content,kind:"content"}:((0,a.$MF)(be,"chatAgents2Additions"),{content:R.from(K.content),kind:"markdownContent"}):"documents"in K?{documents:K.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(je=>p.from(je))})),kind:"usedContext"}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:p.from(K.reference.range)}:K.reference,kind:"reference"}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:p.from(K.inlineReference.range)}:K.inlineReference,name:K.title,kind:"inlineReference"}:"agentName"in K?((0,a.$MF)(be,"chatAgents2Additions"),{agentName:K.agentName,command:K.command,kind:"agentDetection"}):{treeData:K.treeData,kind:"treeData"}}Ce.from=Me})(zt||(e.ChatResponseProgress=zt={}));var Jt;(function(Ce){function Me(be,K,Le){return"terminalCommand"in be?{terminalCommand:be.terminalCommand}:"uri"in be?{uri:be.uri}:K.toInternal(be,Le)}Ce.from=Me})(Jt||(e.TerminalQuickFix=Jt={}))}),define(Pe[220],Ae([1,0,2,11,7,8,186]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class ${constructor(d,I,D,l={timeout:1500,errors:3}){this.c=d,this.d=I,this.f=D,this.g=l,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(d){return(I,D,l)=>{const v={dispose:this.a.push([I,D,d])};return Array.isArray(l)&&l.push(v),v}}async $participateInSave(d,I){const D=y.URI.revive(d);let l=!1;const b=setTimeout(()=>l=!0,this.g.timeout),v=[];try{for(const f of[...this.a]){if(l)break;const t=this.d.getDocument(D),i=await this.h(f,{document:t,reason:M.TextDocumentSaveReason.to(I)});v.push(i)}}finally{clearTimeout(b)}return v}h([d,I,D],l){const b=this.b.get(d);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,d,I,l).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const f=this.b.get(d);this.b.set(d,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(d,I,D,l){const b=[],v=Date.now(),{document:f,reason:t}=l,{version:i}=f,r=Object.freeze({document:f,reason:t,waitUntil(c){if(Object.isFrozen(b))throw(0,T.$7)("waitUntil can not be called async");b.push(Promise.resolve(c))}});try{I.apply(D,[r])}catch(c){return Promise.reject(c)}return Object.freeze(b),new Promise((c,o)=>{const h=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(h),c(n)}).catch(n=>{clearTimeout(h),o(n)})}).then(c=>{const o={edits:[]};for(const h of c)if(Array.isArray(h)&&h.every(n=>n instanceof P.$HK))for(const{newText:n,newEol:s,range:a}of h)o.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:a&&M.Range.from(a),text:n,eol:s&&M.EndOfLine.from(s)}});if(o.edits.length!==0)return i===f.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$afc=$}),define(Pe[221],Ae([1,0,13,2,8,7,76]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0;class ${constructor(D,l,b,v){this.start=D,this.deletedCount=l,this.deletedItems=b,this.items=v}asApiEvent(){return{range:new M.$XL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(D,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,l,b){this.notebook=D,this.h=l,this.j=b,this.handle=b.handle,this.uri=T.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(P.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return D.g},set mime(v){D.g=v},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(P.NotebookCellOutput.to)}setOutputItems(D,l,b){const v=b.map(P.NotebookCellOutputItem.to),f=this.a.find(t=>t.id===D);if(f&&(l||(f.items.length=0),f.items.push(...v),f.items.length>1&&f.items.every(t=>A.$CI(t.mime)))){const t=new Map,i=[];f.items.forEach(r=>{let c;t.has(r.mime)?c=t.get(r.mime):(c=[],t.set(r.mime,c),i.push(r.mime)),c.push(r.data)}),f.items.length=0,i.forEach(r=>{const c=A.$DI(t.get(r));f.items.push({mime:r,data:c.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$ffc=E;class d{static{this.a=0}constructor(D,l,b,v,f){this.k=D,this.l=l,this.m=b,this.uri=v,this.handle=d.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,l={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===y.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(f=>f.apiCell)},save(){return D.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,l,b){this.g=D.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:b});const v={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},f=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,v.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,v.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),f.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),f.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),f.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<f.length;i++){const r=f[i],c=t.get(r.cell);if(c===void 0){const o=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...r});t.set(r.cell,o-1)}else v.cellChanges[c]={...v.cellChanges[c],...r}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let l=D.start|0,b=D.end|0;return l<0&&(l=0),b>this.b.length&&(b=this.b.length),D.with({start:l,end:b})}p(D){D=this.o(D);const l=[];for(let b=D.start;b<D.end;b++)l.push(this.b[b]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,l,b){if(this.j)return;const v=[],f=[],t=[];if(D.reverse().forEach(i=>{const c=i[2].map(n=>{const s=new E(this,this.l,n);return l||f.push(E.asModelAddData(this.apiNotebook,n)),s}),o=new $(i[0],i[1],[],c),h=this.b.splice(i[0],i[1],...c);for(const n of h)t.push(n.uri),o.deletedItems.push(n.apiCell);v.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:t}),b)for(const i of v)b.push(i.asApiEvent())}s(D,l,b,v){const f=this.b.splice(D,l);this.b.splice(b,0,...f);const t=[new $(D,l,f.map(i=>i.apiCell),[]),new $(b,0,[],f)];for(const i of t)v.push(i.asApiEvent())}t(D,l){this.b[D].setOutputs(l)}u(D,l,b,v){this.b[D].setOutputItems(l,b,v)}v(D,l){const b=this.b[D];b.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(b.uri,l)}w(D,l){const b=this.b[D];b.apiCell.mime=l}x(D,l){this.b[D].setMetadata(l)}y(D,l){this.b[D].setInternalMetadata(l)}getCellFromApiCell(D){return this.b.find(l=>l.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(l=>l.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$gfc=d}),define(Pe[222],Ae([1,0,5,2,8,7]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class A{constructor(E,d,I,D={timeout:1500,errors:3}){this.b=E,this.c=d,this.d=I,this.f=D,this.a=new y.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(d,I,D)=>{const l=function(v){d.call(I,v)};return l.extension=E,this.a.event(l,void 0,D)}}async $participateInSave(E,d,I){const D=T.URI.revive(E),l=this.c.getNotebookDocument(D);if(!l)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:P.TextDocumentSaveReason.to(d)},I,async(f,t)=>{const i=Date.now(),r=await await Promise.resolve(f);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!I.isCancellationRequested&&r&&(r instanceof M.$KK?b.push(r):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),I.isCancellationRequested)return!1;if(b.length===0)return!0;const v={edits:[]};for(const f of b){const{edits:t}=P.WorkspaceEdit.from(f);v.edits=v.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$wfc=A}),define(Pe[107],Ae([1,0,11,8,7]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor($,E,d,I,D,l){this.id=$,this.f=E,this.notebookData=d,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=I,this.c=l}get apiEditor(){if(!this.e){const $=this;this.e={get notebook(){return $.notebookData.apiNotebook},get selection(){return $.a[0]},set selection(E){this.selections=[E]},get selections(){return $.a},set selections(E){if(!Array.isArray(E)||!E.every(P.$XL.isNotebookRange))throw(0,y.$6)("selections");$.a=E,$.g(E)},get visibleRanges(){return $.b},revealRange(E,d){$.f.$tryRevealRange($.id,T.NotebookRange.from(E),d??P.NotebookEditorRevealType.Default)},get viewColumn(){return $.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility($){this.d=$}_acceptVisibleRanges($){this.b=$}_acceptSelections($){this.a=$}g($){this.f.$trySetSelections(this.id,$.map(T.NotebookRange.from))}_acceptViewColumn($){this.c=$}}e.$hfc=M}),define(Pe[223],Ae([1,0,11,5,15,8]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;let A=class{constructor(E,d){this.c=E,this.d=d,this.a=new T.$Rd({onListenerError:y.$1}),this.b=new T.$Rd({onListenerError:y.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,d);const I=this.d.getEditorById(E);d.visibleRanges&&I._acceptVisibleRanges(d.visibleRanges.ranges.map(M.NotebookRange.to)),d.selections&&I._acceptSelections(d.selections.selections.map(M.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const d in E)this.d.getEditorById(d)._acceptViewColumn(M.ViewColumn.to(E[d]))}};e.$yfc=A,e.$yfc=A=Ke([Ve(0,P.$dj)],A)}),define(Pe[224],Ae([1,0,8,72,163,19,66,11]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class E{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,b,v){const f=this.b++,{title:t,location:i,cancellable:r}=b,c={label:(0,P.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(f,{location:y.ProgressLocation.from(i),title:t,source:c,cancellable:r},l.isUnderDevelopment?void 0:l.identifier.value).catch($.$1),this.d(f,v,!!r)}d(l,b,v){let f;v&&(f=new M.$2d,this.c.set(l,f));const t=r=>{this.a.$progressEnd(r),this.c.delete(r),f?.dispose()};let i;try{i=b(new I(this.a,l),v&&f?f.token:M.CancellationToken.None)}catch(r){throw t(l),r}return i.then(r=>t(l),r=>t(l)),i}$acceptProgressCanceled(l){const b=this.c.get(l);b&&(b.cancel(),this.c.delete(l))}}e.$Ffc=E;function d(D,l){return D.message=l.message,typeof l.increment=="number"&&(typeof D.increment=="number"?D.increment+=l.increment:D.increment=l.increment),D}class I extends T.$$u{constructor(l,b){super(v=>this.throttledReport(v)),this.c=l,this.d=b}throttledReport(l){this.c.$progressReport(this.d,l)}}Ke([(0,A.$ph)(100,(D,l)=>d(D,l),()=>Object.create(null))],I.prototype,"throttledReport",null)}),define(Pe[108],Ae([1,0,29,104,48,77,58,8,2]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PM=e.$OM=e.$NM=e.$MM=void 0;const d=(c,o,h,n)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(a){if(!h(s,a)){const g=s;s=a,c.listener?.(n(a,g))}}}},I=(c,o)=>c===o,D={range:(c,o)=>c===o?!0:!c||!o?!1:c.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(c,o)=>!(c.length!==o.length||c.some(h=>!o.find(n=>h.id===n.id)))},l=c=>o=>({op:4,update:c(o)}),b=(c,o)=>({range:(()=>{let h;const n=l(s=>({range:y.$zs.lift($.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){c.listener?.({op:6}),D.range(h,s)||(h=s,c.listener?.(n(s)))}}})(),label:d(c,o,D.label,l(h=>({label:h}))),description:d(c,void 0,D.description,l(h=>({description:h}))),sortText:d(c,void 0,D.sortText,l(h=>({sortText:h}))),canResolveChildren:d(c,!1,D.canResolveChildren,h=>({op:2,state:h})),busy:d(c,!1,D.busy,l(h=>({busy:h}))),error:d(c,void 0,D.error,l(h=>({error:$.MarkdownString.fromStrict(h)||null}))),tags:d(c,[],D.tags,(h,n)=>({op:1,new:h.map($.TestTag.from),old:n.map($.TestTag.from)}))}),v=c=>{const o=P.$rJ.fromString(c.extId),h=new t(o.controllerId,o.localId,c.label,E.URI.revive(c.uri)||void 0);return h.range=$.Range.to(c.range||void 0),h.description=c.description||void 0,h.sortText=c.sortText||void 0,h.tags=c.tags.map(n=>$.TestTag.to({id:(0,A.$wJ)(n).tagId})),h},f=c=>{let o;for(const h of c.tests){const n=v(h.item);(0,T.$wM)(n).parent=o,o=n}return o};e.$MM=f;class t{constructor(o,h,n,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,T.$vM)(this,o);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof i?void 0:a.parent}},children:{value:(0,M.$uM)(a,T.$wM,t),enumerable:!0,writable:!1},...b(a,n)})}}e.$NM=t;class i extends t{constructor(o,h){super(o,o,h,void 0),this._isRoot=!0}}e.$OM=i;class r extends M.$qM{constructor(o,h,n){super({controllerId:o,getDocumentVersion:s=>s&&n.getDocument(s)?.version,getApiFor:T.$wM,getChildren:s=>s.children,root:new i(o,h),toITestItem:$.TestItem.from})}}e.$PM=r}),define(Pe[109],Ae([1,0,53,11,89,8,7]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=e.$IM=e.$HM=void 0;class ${static{this.c=new P.$FM("TextEditorDecorationType")}constructor(l,b,v){const f=$.c.nextId();l.$registerTextEditorDecorationType(b.identifier,f,M.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:f,dispose(){l.$removeTextEditorDecorationType(f)}})}}e.$HM=$;class E{constructor(l,b){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,b){this.k();let v=null;if(l instanceof A.$BK)v=new A.$CK(l,l);else if(l instanceof A.$CK)v=l;else throw new Error("Unrecognized location");this.l(v,b,!1)}insert(l,b){this.k(),this.l(new A.$CK(l,l),b,!0)}delete(l){this.k();let b=null;if(l instanceof A.$CK)b=l;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(l,b,v){const f=this.c.validateRange(l);this.g.push({range:f,text:b,forceMoveMarkers:v})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=l}}class d{constructor(l,b,v,f){this.c=l,this.d=b,this._accept(v),this.e=f;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.insertSpaces,this.j=l.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(l.lineNumbers)}l(l){if(l==="auto")return"auto";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}m(l){const b=this.l(l);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const b=Math.floor(l);return b>0?b:null}if(typeof l=="string"){const b=parseInt(l,10);return isNaN(b)?null:b>0?b:null}return null}o(l){const b=this.n(l);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(l){return l==="auto"?"auto":l==="false"?!1:!!l}q(l){const b=this.p(l);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(l){this.j!==l&&(this.j=l,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}t(l){this.k!==l&&(this.k=l,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(l)})))}assign(l){const b={};let v=!1;if(typeof l.tabSize<"u"){const f=this.l(l.tabSize);f==="auto"?(v=!0,b.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,v=!0,b.tabSize=f)}if(typeof l.indentSize<"u"){const f=this.n(l.indentSize);f==="tabSize"?(v=!0,b.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,v=!0,b.indentSize=f)}if(typeof l.insertSpaces<"u"){const f=this.p(l.insertSpaces);f==="auto"?(v=!0,b.insertSpaces=f):this.h!==f&&(this.h=f,v=!0,b.insertSpaces=f)}typeof l.cursorStyle<"u"&&this.j!==l.cursorStyle&&(this.j=l.cursorStyle,v=!0,b.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.k!==l.lineNumbers&&(this.k=l.lineNumbers,v=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(l.lineNumbers)),v&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(l,b){b.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(v)})}}e.$IM=d;class I{constructor(l,b,v,f,t,i,r,c){this.id=l,this.j=b,this.k=v,this.g=!1,this.h=new Set,this.c=t,this.d=new d(this.j,this.id,i,v),this.e=r,this.f=c;const o=this;this.value=Object.freeze({get document(){return f.value},set document(h){throw new T.$8("document")},get selection(){return o.c&&o.c[0]},set selection(h){if(!(h instanceof A.$DK))throw(0,T.$6)("selection");o.c=[h],o.l()},get selections(){return o.c},set selections(h){if(!Array.isArray(h)||h.some(n=>!(n instanceof A.$DK)))throw(0,T.$6)("selections");o.c=h,o.l()},get visibleRanges(){return o.e},set visibleRanges(h){throw new T.$8("visibleRanges")},get options(){return o.d.value},set options(h){o.g||o.d.assign(h)},get viewColumn(){return o.f},set viewColumn(h){throw new T.$8("viewColumn")},edit(h,n={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new E(f.value,n);return h(s),o.m(s)},insertSnippet(h,n,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!n||Array.isArray(n)&&n.length===0)a=o.c.map(g=>M.Range.from(g));else if(n instanceof A.$BK){const{lineNumber:g,column:p}=M.Position.from(n);a=[{startLineNumber:g,startColumn:p,endLineNumber:g,endColumn:p}]}else if(n instanceof A.$CK)a=[M.Range.from(n)];else{a=[];for(const g of n)if(g instanceof A.$CK)a.push(M.Range.from(g));else{const{lineNumber:p,column:m}=M.Position.from(g);a.push({startLineNumber:p,startColumn:m,endLineNumber:p,endColumn:m})}}return b.$tryInsertSnippet(l,f.value.version,h.value,a,s)},setDecorations(h,n){const s=n.length===0;s&&!o.h.has(h.key)||(s?o.h.delete(h.key):o.h.add(h.key),o.n(()=>{if(M.$xM(n))return b.$trySetDecorations(l,h.key,M.$yM(n));{const a=new Array(4*n.length);for(let g=0,p=n.length;g<p;g++){const m=n[g];a[4*g]=m.start.line+1,a[4*g+1]=m.start.character+1,a[4*g+2]=m.end.line+1,a[4*g+3]=m.end.character+1}return b.$trySetDecorationsFast(l,h.key,a)}}))},revealRange(h,n){o.n(()=>b.$tryRevealRange(l,M.Range.from(h),n||A.TextEditorRevealType.Default))},show(h){b.$tryShowEditor(l,M.ViewColumn.from(h))},hide(){b.$tryHideEditor(l)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,y.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,y.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,y.ok)(!this.g),this.f=l}_acceptSelections(l){(0,y.ok)(!this.g),this.c=l}async l(){const l=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const b=l.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const v=b.edits.map(t=>t.range);v.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=v.length-1;t<i;t++){const r=v[t].end;if(v[t+1].start.isBefore(r))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=b.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,f,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$JM=I}),define(Pe[225],Ae([1,0,167,25,2,5,6,205,14,7,16,18,8,52,19,132,23]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;function i(o,h){if((0,I.$Cf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let n;return Array.isArray(o.highlights)&&(n=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),n=n.length?n:void 0),{label:o.label,highlights:n}}}class r extends A.$Rc{constructor(h,n,s){super(),this.f=h,this.g=n,this.h=s,this.a=new Map,this.b=new f.$S7;function a(g){return g&&g.$treeViewId&&(g.$treeItemHandle||g.$selectedTreeItems||g.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:g=>a(g)?this.r(g):Array.isArray(g)&&g.length>0?g.map(p=>a(p)?this.r(p):p):g})}registerTreeDataProvider(h,n,s){const a=this.createTreeView(h,{treeDataProvider:n},s);return{dispose:()=>a.dispose()}}createTreeView(h,n,s){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=n.dragAndDropController?.dropMimeTypes??[],g=n.dragAndDropController?.dragMimeTypes??[],p=!!n.dragAndDropController?.handleDrag,m=!!n.dragAndDropController?.handleDrop,k=this.m(h,n,s),C={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:a,dragMimeTypes:g,hasHandleDrag:p,hasHandleDrop:m,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(h,C),w={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,t.$MF)(s,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,t.$MF)(s,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(S){(0,b.$$j)(S)&&(0,t.$MF)(s,"treeViewMarkdownMessage"),k.message=S},get title(){return k.title},set title(S){k.title=S},get description(){return k.description},set description(S){k.description=S},get badge(){return k.badge},set badge(S){S!==void 0&&d.ViewBadge.isViewBadge(S)?k.badge={value:Math.floor(Math.abs(S.value)),tooltip:S.tooltip}:S===void 0&&(k.badge=void 0)},reveal:(S,F)=>k.reveal(S,F),dispose:async()=>{await u,this.a.delete(h),k.dispose()}};return this.B(w),w}$getChildren(h,n){const s=this.a.get(h);return s?s.getChildren(n):Promise.reject(new $.$KE(h))}async $handleDrop(h,n,s,a,g,p,m,k){const C=this.a.get(h);if(!C)return Promise.reject(new $.$KE(h));const u=l.DataTransfer.toDataTransfer(s,async w=>(await this.f.$resolveDropFileData(h,n,w)).buffer);return m===h&&k&&await this.j(u,C,k,g,p),C.onDrop(u,a,g)}async j(h,n,s,a,g){const p=this.b.removeDragOperationTransfer(g);if(p)(await p)?.forEach((m,k)=>{m&&h.set(k,m)});else if(g&&n.handleDrag){const m=n.handleDrag(s,h,a);this.b.addDragOperationTransfer(g,m),await m}return h}async $handleDrag(h,n,s,a){const g=this.a.get(h);if(!g)return Promise.reject(new $.$KE(h));const p=await this.j(new d.$rL,g,n,a,s);if(!(!p||a.isCancellationRequested))return l.DataTransfer.from(p)}async $hasResolve(h){const n=this.a.get(h);if(!n)throw new $.$KE(h);return n.hasResolve}$resolve(h,n,s){const a=this.a.get(h);if(!a)throw new $.$KE(h);return a.resolveTreeItem(n,s)}$setExpanded(h,n,s){const a=this.a.get(h);if(!a)throw new $.$KE(h);a.setExpanded(n,s)}$setSelectionAndFocus(h,n,s){const a=this.a.get(h);if(!a)throw new $.$KE(h);a.setSelectionAndFocus(n,s)}$setVisible(h,n){const s=this.a.get(h);if(!s){if(!n)return;throw new $.$KE(h)}s.setVisible(n)}$changeCheckboxState(h,n){const s=this.a.get(h);if(!s)throw new $.$KE(h);s.setCheckboxState(n)}m(h,n,s){const a=this.B(new c(h,n,this.f,this.g.converter,this.h,s));return this.a.set(h,a),a}r(h){const n=this.a.get(h.$treeViewId);return n&&"$treeItemHandle"in h?n.getExtensionElement(h.$treeItemHandle):n&&"$focusedTreeItem"in h&&h.$focusedTreeItem?n.focusedElement:null}}e.$Yfc=r;class c extends A.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,I.$Lf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,n,s,a,g,p){if(super(),this.I=h,this.J=s,this.L=a,this.M=g,this.N=p,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$2d,p.contributes&&p.contributes.views)for(const u in p.contributes.views)for(const w of p.contributes.views[u])w.id===h&&(this.P=w.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let m,k;const C=M.Event.debounce(this.F.event,(u,w)=>(u||(u={message:!1,elements:[]}),w.element!==!1&&(m||(m=new Promise(S=>k=S),this.G=this.G.then(()=>m)),Array.isArray(w.element)?u.elements.push(...w.element):u.elements.push(w.element)),w.message&&(u.message=!0),u),200,!0);this.B(C(({message:u,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const S=k;return m=null,this.$(w).then(()=>S())})),u&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const n=h?this.getExtensionElement(h):void 0;if(h&&!n)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.X(h);return s||(s=await this.Y(n)),s?s.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,n){n=n||{select:!0,focus:!1};const s=(0,I.$Lf)(n.select)?!0:n.select,a=(0,I.$Lf)(n.focus)?!1:n.focus,g=(0,I.$Lf)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(p=>this.W(h,p[p.length-1]).then(m=>this.J.$reveal(this.I,{item:m.item,parentChain:p.map(k=>k.item)},{select:s,focus:a,expand:g})),p=>this.M.error(p)):this.J.$reveal(this.I,void 0,{select:s,focus:a,expand:g})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,n){const s=this.getExtensionElement(h);s&&(n?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(h,n){const s=!(0,D.$tb)(this.s,h);this.s=h;const a=this.t!==n;this.t=n,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const n=(await Promise.all(h.map(async s=>{const a=this.getExtensionElement(s.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:s.newState?d.TreeItemCheckboxState.Checked:d.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);n.forEach(s=>{s.treeItem.checkboxState=s.newState?d.TreeItemCheckboxState.Checked:d.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,n,s){const a=[];for(const g of h){const p=this.getExtensionElement(g);p&&a.push(p)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,n,s),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,n,s){const a=n?this.getExtensionElement(n):void 0;if(!(!a&&n||!this.g?.handleDrop))return(0,E.$Qg)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,n){if(!this.f.resolveTreeItem)return;const s=this.j.get(h);if(s){const a=this.m.get(s);if(a){const g=await this.f.resolveTreeItem(a.extensionItem,s,n)??a.extensionItem;return this.hb(g),a.item.tooltip=this.eb(g.tooltip),a.item.command=this.fb(a.disposableStore,g.command),a.item}}}S(h){return this.U(h).then(n=>n?this.S(n).then(s=>this.W(n,s[s.length-1]).then(a=>(s.push(a),s))):Promise.resolve([]))}U(h){const n=this.m.get(h);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,E.$Qg)(()=>this.f.getParent(h))}W(h,n){const s=this.m.get(h);return s?Promise.resolve(s):(0,E.$Qg)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,n,!0)).then(a=>this.getChildren(n?n.item.handle:void 0).then(()=>{const g=this.getExtensionElement(a);if(g){const p=this.m.get(g);if(p)return Promise.resolve(p)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let n;if(typeof h=="string"){const s=this.getExtensionElement(h);n=s?this.m.get(s):void 0}else n=h;return n&&n.children||void 0}return this.h}async Y(h){this.rb(h);const n=new v.$2d(this.Z.token);try{const s=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(n.token.isCancellationRequested)return;const g=await Promise.all((0,D.$Gb)(a||[]).map(async p=>{const m=await this.f.getTreeItem(p);return m&&!n.token.isCancellationRequested?this.db(p,m,s):null}));return n.token.isCancellationRequested?void 0:(0,D.$Gb)(g)}finally{n.dispose()}}$(h){if(h.some(s=>!s))return this.Z.dispose(!0),this.Z=new v.$2d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(h);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(h){const n=new Set,s=h.map(g=>this.m.get(g));for(const g of s)if(g&&!n.has(g.item.handle)){let p=g;for(;p&&p.parent&&s.findIndex(m=>p&&p.parent&&m&&m.item.handle===p.parent.item.handle)===-1;){const m=this.j.get(p.parent.item.handle);p=m?this.m.get(m):void 0}p&&!p.parent&&n.add(g.item.handle)}const a=[];return n.forEach(g=>{const p=this.j.get(g);if(p){const m=this.m.get(p);m&&(!m.parent||!n.has(m.parent.item.handle))&&a.push(g)}}),a}bb(h){const n={};return Promise.all(h.map(s=>this.cb(s).then(a=>{a&&(n[s]=a.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(h){const n=this.getExtensionElement(h);if(n){const s=this.m.get(n);if(s)return this.rb(n),(0,E.$Qg)(()=>this.f.getTreeItem(n)).then(a=>{if(a){const g=this.ib(n,a,s.parent);return this.pb(n,g,s,s.parent),s.dispose(),g}return null})}return Promise.resolve(null)}db(h,n,s){const a=this.ib(h,n,s);if(n.id&&this.j.has(a.item.handle))throw new Error((0,y.localize)(0,null,n.id));return this.ob(h,a),this.qb(a,s),a}eb(h){return d.$1K.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,n){return n?{...this.L.toInternal(n,h),originalId:n.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let n,s,a;return typeof h.checkboxState=="number"?n=h.checkboxState:(n=h.checkboxState.state,s=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:n===d.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:a}}hb(h){if(!d.$mL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,n,s){this.hb(n);const a=this.B(new A.$Qc),g=this.kb(h,n,s),p=this.lb(n);return{item:{handle:g,parentHandle:s?s.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(a,n.command),contextValue:n.contextValue,icon:p,iconDark:this.mb(n)||p,themeIcon:this.jb(n),collapsibleState:(0,I.$Lf)(n.collapsibleState)?d.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:s,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof d.$uL?h.iconPath:void 0}kb(h,{id:n,label:s,resourceUri:a},g,p){if(n)return`${c.b}/${n}`;const m=i(s,this.N),k=g?g.item.handle:c.a;let C=m?m.label:a?(0,T.$wg)(a):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const u=this.m.has(h)?this.m.get(h).item.handle:void 0,w=this.X(g)||[];let S,F=0;do{if(S=`${k}/${F}:${C}`,p||!this.j.has(S)||u===S)break;F++}while(F<=w.length);return S}lb(h){if(h.iconPath&&!(h.iconPath instanceof d.$uL))return typeof h.iconPath=="string"||P.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof d.$uL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return P.URI.isUri(h)?h:P.URI.file(h)}ob(h,n){this.j.set(n.item.handle,h),this.m.set(h,n)}pb(h,n,s,a){this.j.delete(n.item.handle),this.m.delete(h),n.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(h,n);const g=this.X(a)||[],p=g.filter(m=>m.item.handle===s.item.handle)[0];p&&g.splice(g.indexOf(p),1,n)}qb(h,n){n?(n.children||(n.children=[]),n.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const n=this.m.get(h);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}n.children=void 0}}else this.tb()}sb(h){const n=this.m.get(h);if(n){if(n.children)for(const s of n.children){const a=this.j.get(s.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[226],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[227],Ae([1,0,179,11,31,96,73,30,22,226,189,101]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=void 0;const l=$.$mn.as(A.$nn.JSONContribution);class b{constructor(h,n,s){this.a=h,this.b=n,this.c=s}d(h,n){this.a({type:h,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(P.default.Error,h)}warn(h){this.d(P.default.Warning,h)}info(h){this.d(P.default.Info,h)}}e.$SF=b;class v{static a(h){const n=new E.$am;for(let s=0,a=h.length;s<a;s++)n.add(h[s].description.identifier);return n}static compute(h,n){if(!h||!h.length)return new v(n,[]);if(!n||!n.length)return new v([],h);const s=this.a(h),a=this.a(n),g=n.filter(m=>!s.has(m.description.identifier)),p=h.filter(m=>!a.has(m.description.identifier));return new v(g,p)}constructor(h,n){this.added=h,this.removed=n}}e.$TF=v;class f{constructor(h,n){this.name=h,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=v.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$Z)(h)}}}e.$UF=f;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$VF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$$l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(d.allApiProposals),markdownEnumDescriptions:Object.values(d.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:y.localize(42,null)},{label:"*",description:y.localize(43,null),body:"*"}]}},badges:{type:"array",description:y.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(45,null)},href:{type:"string",description:y.localize(46,null)},description:{type:"string",description:y.localize(47,null)}}}},markdown:{type:"string",description:y.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionPack:{description:y.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$4n}},extensionKind:{description:y.localize(52,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(53,null)},{body:["workspace"],description:y.localize(54,null)},{body:["ui","workspace"],description:y.localize(55,null)},{body:["workspace","ui"],description:y.localize(56,null)},{body:[],description:y.localize(57,null)}]},capabilities:{description:y.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(61,null),y.localize(62,null),y.localize(63,null)]},description:{type:"string",markdownDescription:y.localize(64,null)}}},untrustedWorkspaces:{description:y.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(67,null),y.localize(68,null),y.localize(69,null)]},restrictedConfigurations:{description:y.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(71,null)}}}}},sponsor:{description:y.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(74,null),type:"string"},"vscode:uninstall":{description:y.localize(75,null),type:"string"}}},icon:{type:"string",description:y.localize(76,null)},l10n:{type:"string",description:y.localize(77,null)},pricing:{type:"string",markdownDescription:y.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class r{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const n=new f(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,n),h.activationEventsGenerator&&D.$xF.register(h.extensionPoint,h.activationEventsGenerator),e.$VF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(i,e.$VF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$WF=r;const c={ExtensionsRegistry:"ExtensionsRegistry"};$.$mn.add(c.ExtensionsRegistry,new r),e.$XF=$.$mn.as(c.ExtensionsRegistry),l.registerSchema(i,e.$VF),l.registerSchema(I.$wj,{properties:{extensionEnabledApiProposals:{description:y.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(d.allApiProposals),markdownEnumDescriptions:Object.values(d.allApiProposals)}}]}}}})}),define(Pe[228],Ae([1,0,175,16,26,227,35,5]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7F=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var d;(function(l){function b(v,f,t){if(!v)return;const i=T.$Cf(v.type)?v.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const r=[];if(Array.isArray(v.required))for(const c of v.required)T.$Cf(c)&&r.push(c);return{extensionId:f.value,taskType:i,required:r,properties:v.properties?P.$an(v.properties):{},when:v.when?A.$Ti.deserialize(v.when):void 0}}l.from=b})(d||(d={}));const I=M.$XF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,b)=>{for(const v of l)v.type&&b.push(`onTaskType:${v.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:E}});class D{constructor(){this.d=new $.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,v)=>{I.setHandler((f,t)=>{this.c=void 0;try{for(const i of t.removed){const r=i.value;for(const c of r)this.a&&c.type&&this.a[c.type]&&delete this.a[c.type]}for(const i of t.added){const r=i.value;for(const c of r){const o=d.from(c,i.description.identifier,i.collector);o&&(this.a[o.taskType]=o)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const v of this.all()){const f={type:"object",additionalProperties:!1};v.required.length>0&&(f.required=v.required.slice(0)),v.properties!==void 0?f.properties=P.$an(v.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[v.taskType]},b.push(f)}this.c={oneOf:b}}return this.c}}e.$7F=new D}),define(Pe[229],Ae([1,0,176,16,25,26,35,228]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$eG=e.JsonSchemaVersion=e.ExecutionEngine=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$$F=e.ShellQuoting=e.$0F=e.$9F=e.$8F=void 0,e.$8F="settings",e.$9F=new A.$aj("taskRunning",!1,y.localize(0,null)),e.$0F={value:y.localize(1,null),original:"Tasks"};var E;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$$F="$customized",function(L){function O(Z){if(!Z)return L.Strong;switch(Z.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=O}(E||(e.ShellQuoting=E={}));var d;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(d||(e.CommandOptions=d={}));var I;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(I||(e.RevealKind=I={})),function(L){function O(Z){switch(Z.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=O}(I||(e.RevealKind=I={}));var D;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(L){function O(Z){switch(Z.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=O}(D||(e.RevealProblemKind=D={}));var l;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(l||(e.PanelKind=l={})),function(L){function O(Z){switch(Z.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=O}(l||(e.PanelKind=l={}));var b;(function(L){L.defaults={echo:!0,reveal:I.Always,revealProblems:D.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var v;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(L){function O(he){switch(he.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=O;function Z(he){switch(he){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=Z}(v||(e.RuntimeType=v={}));var f;(function(L){function O(Z){return T.$Cf(Z)?Z:Z.value}L.value=O})(f||(e.CommandString=f={}));var t;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function O(he){return he===L.Clean._id||he===L.Build._id||he===L.Rebuild._id||he===L.Test._id}L.is=O;function Z(he){if(he!==void 0)return T.$Cf(he)?O(he)?{_id:he,isDefault:!1}:void 0:he}L.from=Z})(t||(e.TaskGroup=t={}));var i;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var r;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function O(Z){switch(Z){case L.User:return 2;case L.WorkspaceFile:return 5;default:return 6}}L.toConfigurationTarget=O})(r||(e.TaskSourceKind=r={}));var c;(function(L){L.parallel="parallel",L.sequence="sequence"})(c||(e.DependsOrder=c={}));var o;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var h;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class n{constructor(O,Z,he,$e,De,ke){this._label="",this._id=O,Z&&(this._label=Z),he&&(this.type=he),this.runOptions=$e,this.configurationProperties=De,this._source=ke}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,Z=!1){if(O===void 0)return!1;if(T.$Cf(O))return O===this._label||O===this.configurationProperties.identifier||Z&&O===this._id;const he=this.getDefinition(!0);return he!==void 0&&he._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$_F=n;class s extends n{constructor(O,Z,he,$e,De,ke,fe,ve){super(O,he,void 0,fe,ve,Z),this.command={},this._source=Z,this.hasDefinedMatchers=ke,De&&(this.command=De)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let Z;switch(this.command?this.command.runtime:void 0){case v.Shell:Z="shell";break;case v.Process:Z="process";break;case v.CustomExecution:Z="customExecution";break;case void 0:Z="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Z,_key:this._id,id:this._id}}}static is(O){return O instanceof s}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===r.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let Z=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Z+=this._source.kind);const he={type:e.$$F,folder:O,id:Z};return JSON.stringify(he)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$wg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new s(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$aG=s;class a extends n{constructor(O,Z,he,$e,De,ke,fe){super(O,he,$e,ke,fe,Z),this._source=Z,this.configures=De}static is(O){return O instanceof a}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$wg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===r.User?e.$8F:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let Z=this.configurationProperties.identifier;this._source.kind!==r.Workspace&&(Z+=this._source.kind);const he={type:e.$$F,folder:O,id:Z};return JSON.stringify(he)}}e.$bG=a;class g extends n{constructor(O,Z,he,$e,De,ke,fe,ve,te){super(O,he,$e,ve,te,Z),this.defines=De,this.hasDefinedMatchers=fe,this.command=ke,this.icon=te.icon,this.hide=te.hide}clone(){return new g(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof g}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new g(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$cG=g;class p extends n{constructor(O,Z,he,$e,De,ke){super(O,he,$e,De,ke,Z),this._source=Z}clone(){return new p(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof p}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new p(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$dG=p;var m;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(m||(e.ExecutionEngine=m={})),function(L){L._default=L.Terminal}(m||(e.ExecutionEngine=m={}));var k;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class C{constructor(O){this.c=new Map;for(let Z=0;Z<O.length;Z++)this.c.set(O[Z].uri.toString(),Z)}compare(O,Z){const he=O.getWorkspaceFolder(),$e=Z.getWorkspaceFolder();if(he&&$e){let De=this.c.get(he.uri.toString());De=De===void 0?0:De+1;let ke=this.c.get($e.uri.toString());return ke=ke===void 0?0:ke+1,De===ke?O._label.localeCompare(Z._label):De-ke}else return!he&&$e?-1:he&&!$e?1:0}}e.$eG=C;var u;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(u||(e.TaskEventKind=u={}));var w;(function(L){L.SingleRun="singleRun",L.Background="background"})(w||(e.TaskRunType=w={}));var S;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(S||(e.TaskRunSource=S={}));var F;(function(L){function O(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function Z(ve,te,Re){return{...O(ve),kind:"start",terminalId:te,resolvedVariables:Re}}L.start=Z;function he(ve,te,Re){return{...O(ve),kind:"processStarted",terminalId:te,processId:Re}}L.processStarted=he;function $e(ve,te,Re){return{...O(ve),kind:"processEnded",terminalId:te,exitCode:Re}}L.processEnded=$e;function De(ve,te,Re){return{...O(ve),kind:"terminated",exitReason:Re,terminalId:te}}L.terminated=De;function ke(ve,te,Re){return{...O(te),kind:ve,terminalId:Re}}L.general=ke;function fe(){return{kind:"changed"}}L.changed=fe})(F||(e.TaskEvent=F={}));var V;(function(L){function O(he){const $e=Object.keys(he).sort();let De="";for(const ke of $e){let fe=he[ke];fe instanceof Object?fe=O(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),De+=ke+","+fe+","}return De}function Z(he){const De={_key:O(he),type:he.taskType};return Object.assign(De,he),De}L.create=Z})(V||(e.KeyedTaskIdentifier=V={}));var J;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(J||(e.TaskSettingId=J={}));var N;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(N||(e.TasksSchemaProperties=N={}));var R;(function(L){function O(Z,he){const $e=$.$7F.get(Z.type);if($e===void 0){const ve=M.$an(Z);return delete ve._key,V.create(ve)}const De=Object.create(null);De.type=$e.taskType;const ke=new Set;$e.required.forEach(ve=>ke.add(ve));const fe=$e.properties;for(const ve of Object.keys(fe)){const te=Z[ve];if(te!=null)De[ve]=te;else if(ke.has(ve)){const Re=fe[ve];if(Re.default!==void 0)De[ve]=M.$an(Re.default);else switch(Re.type){case"boolean":De[ve]=!1;break;case"number":case"integer":De[ve]=0;break;case"string":De[ve]="";break;default:he.error(y.localize(2,null,JSON.stringify(Z,void 0,0),ve));return}}}return V.create(De)}L.createTaskIdentifier=O})(R||(e.TaskDefinition=R={}))}),define(Pe[230],Ae([1,0,11]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=e.$d6b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,$)=>{this.b=A,this.d=$,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$Z)(A))}then(A,$){return this.j().then(A,$)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$d6b=T;class P extends T{constructor(){super(),this.h=!0,this.i=new y.$4}}e.$e6b=P}),define(Pe[49],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=void 0;class y{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++y.count}}e.$tv=y;const T=[];function P($){const E=new y($);return T[E.nid]=E,E}e.$uv=P;function M($){return T[$].sid}e.$vv=M;class A{constructor(E){this.value=E}}e.$wv=A}),define(Pe[3],Ae([1,0,49]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zK=e.$yK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$xK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var P;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var $;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})($||(e.WebviewMessageArrayBufferViewType=$={}));var E;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var d;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(d||(e.NotebookEditorRevealType=d={}));var I;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(I||(e.CandidatePortSource=I={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$xK=D;var l;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var b;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var v;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$yK={MainThreadAuthentication:(0,y.$uv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$uv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$uv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,y.$uv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$uv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$uv)("MainThreadClipboard"),MainThreadCommands:(0,y.$uv)("MainThreadCommands"),MainThreadComments:(0,y.$uv)("MainThreadComments"),MainThreadConfiguration:(0,y.$uv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$uv)("MainThreadConsole"),MainThreadDebugService:(0,y.$uv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$uv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$uv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$uv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$uv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$uv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$uv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$uv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$uv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$uv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$uv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$uv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$uv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$uv)("MainThreadLanguages"),MainThreadLogger:(0,y.$uv)("MainThreadLogger"),MainThreadMessageService:(0,y.$uv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$uv)("MainThreadOutputService"),MainThreadProgress:(0,y.$uv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$uv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$uv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$uv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$uv)("MainThreadSecretState"),MainThreadStorage:(0,y.$uv)("MainThreadStorage"),MainThreadSpeech:(0,y.$uv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$uv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$uv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$uv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$uv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$uv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$uv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$uv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$uv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$uv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$uv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$uv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$uv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$uv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$uv)("MainThreadSCM"),MainThreadSearch:(0,y.$uv)("MainThreadSearch"),MainThreadShare:(0,y.$uv)("MainThreadShare"),MainThreadTask:(0,y.$uv)("MainThreadTask"),MainThreadWindow:(0,y.$uv)("MainThreadWindow"),MainThreadLabelService:(0,y.$uv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$uv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$uv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$uv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$uv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$uv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$uv)("MainThreadInteractive"),MainThreadChat:(0,y.$uv)("MainThreadChat"),MainThreadInlineChat:(0,y.$uv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$uv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$uv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$uv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$uv)("MainThreadTimeline"),MainThreadTesting:(0,y.$uv)("MainThreadTesting"),MainThreadLocalization:(0,y.$uv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$uv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$uv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$uv)("MainThreadIssueReporter")},e.$zK={ExtHostCommands:(0,y.$uv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$uv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$uv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$uv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$uv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$uv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$uv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$uv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$uv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$uv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$uv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$uv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$uv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$uv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$uv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$uv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$uv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$uv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$uv)("ExtHostStatusBar"),ExtHostShare:(0,y.$uv)("ExtHostShare"),ExtHostExtensionService:(0,y.$uv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$uv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$uv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$uv)("ExtHostSCM"),ExtHostSearch:(0,y.$uv)("ExtHostSearch"),ExtHostTask:(0,y.$uv)("ExtHostTask"),ExtHostWorkspace:(0,y.$uv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$uv)("ExtHostWindow"),ExtHostWebviews:(0,y.$uv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$uv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$uv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$uv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$uv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$uv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$uv)("ExtHostProgress"),ExtHostComments:(0,y.$uv)("ExtHostComments"),ExtHostSecretState:(0,y.$uv)("ExtHostSecretState"),ExtHostStorage:(0,y.$uv)("ExtHostStorage"),ExtHostUrls:(0,y.$uv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$uv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$uv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$uv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$uv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$uv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$uv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$uv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$uv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$uv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$uv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$uv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$uv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$uv)("ExtHostChat"),ExtHostChatAgents2:(0,y.$uv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$uv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$uv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$uv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$uv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$uv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$uv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$uv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$uv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$uv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$uv)("ExtHostTimeline"),ExtHostTesting:(0,y.$uv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$uv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$uv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$uv)("ExtHostIssueReporter")}}),define(Pe[231],Ae([1,0,3,7]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$yK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,$,E){if(this.a.size===0)throw new Error("No related information providers registered");const d=this.a.get(A);if(!d)throw new Error("related information provider not found");return await d.provideRelatedInformation($,E)??[]}getRelatedInformation(A,$,E){return this.c.$getAiRelatedInformation($,E)}registerRelatedInformationProvider(A,$,E){const d=this.b;return this.b++,this.a.set(d,E),this.c.$registerAiRelatedInformationProvider(d,$),new T.$AK(()=>{this.c.$unregisterAiRelatedInformationProvider(d),this.a.delete(d)})}}e.$Ydc=P}),define(Pe[81],Ae([1,0,4,15,3,17]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=e.$6dc=e.$5dc=void 0,e.$5dc=(0,y.$Vh)("IExtHostApiDeprecationService");let A=class{constructor(E,d){this.c=d,this.a=new Set,this.b=E.getProxy(P.$yK.MainThreadTelemetry)}report(E,d,I){const D=this.d(E,d);this.a.has(D)||(this.a.add(D),d.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:d.identifier.value,apiId:E}))}d(E,d){return`${E}-${d.identifier.value}`}};e.$6dc=A,e.$6dc=A=Ke([Ve(0,M.$AM),Ve(1,T.$dj)],A),e.$7dc=Object.freeze(new class{report($,E,d){}})}),define(Pe[232],Ae([1,0,5,3,7,22]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;class A{constructor(d){this.b=new Map,this.c=[],this.d=new y.$Rd,this.onDidChangeSessions=this.d.event,this.f=new $,this.g=new $,this.a=d.getProxy(T.$yK.MainThreadAuthentication)}$setProviders(d){return this.c=d,Promise.resolve()}async getSession(d,I,D,l={}){const b=M.$_l.toKey(d.identifier),v=[...D].sort().join(" ");return await this.f.getOrCreate(`${b} ${I} ${v}`,async()=>{await this.a.$ensureProvider(I);const f=d.displayName||d.name;return this.a.$getSession(I,D,b,f,l)})}async getSessions(d,I,D){const l=M.$_l.toKey(d.identifier),b=[...D].sort().join(" ");return await this.g.getOrCreate(`${l} ${b}`,async()=>{await this.a.$ensureProvider(I);const v=d.displayName||d.name;return this.a.$getSessions(I,D,l,v)})}async removeSession(d,I){const D=this.b.get(d);return D?D.provider.removeSession(I):this.a.$removeSession(d,I)}registerAuthenticationProvider(d,I,D,l){if(this.b.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this.b.set(d,{label:I,provider:D,options:l??{supportsMultipleAccounts:!1}}),this.c.find(v=>v.id===d)||this.c.push({id:d,label:I});const b=D.onDidChangeSessions(v=>{this.a.$sendDidChangeSessions(d,{added:v.added??[],changed:v.changed??[],removed:v.removed??[]})});return this.a.$registerAuthenticationProvider(d,I,l?.supportsMultipleAccounts??!1),new P.$AK(()=>{b.dispose(),this.b.delete(d);const v=this.c.findIndex(f=>f.id===d);v>-1&&this.c.splice(v),this.a.$unregisterAuthenticationProvider(d)})}$createSession(d,I,D){const l=this.b.get(d);if(l)return Promise.resolve(l.provider.createSession(I,D));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$removeSession(d,I){const D=this.b.get(d);if(D)return Promise.resolve(D.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$getSessions(d,I){const D=this.b.get(d);if(D)return Promise.resolve(D.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,I){return this.d.fire({provider:{id:d,label:I}}),Promise.resolve()}}e.$0dc=A;class ${constructor(){this.a=new Map}getOrCreate(d,I){const D=this.a.get(d);if(D)return D;const l=I().finally(()=>this.a.delete(d));return this.a.set(d,l),l}}}),define(Pe[233],Ae([1,0,3,17,8]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;let M=class{constructor($,E){this.a=$.getProxy(y.$yK.MainThreadBulkEdits),this.b={getTextDocumentVersion:d=>E.getDocument(d)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,E,d){const I=P.WorkspaceEdit.from($,this.b);return this.a.$tryApplyWorkspaceEdit(I,void 0,d?.isRefactoring??!1)}};e.$$dc=M,e.$$dc=M=Ke([Ve(0,T.$AM)],M)}),define(Pe[234],Ae([1,0,5,67,6,3,8]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;class ${static{this.a=0}constructor(I,D){this.extension=I,this.provider=D,this.handle=$.a++}}class E{static{this.a=0}constructor(I){this.b=new Map,this.c=new Map,this.d=new y.$Rd,this.onDidPerformUserAction=this.d.event,this.e=I.getProxy(M.$yK.MainThreadChat)}registerChatProvider(I,D,l){const b=new $(I,l);return this.b.set(b.handle,b),this.e.$registerChatProvider(b.handle,D),(0,P.$Pc)(()=>{this.e.$unregisterChatProvider(b.handle),this.b.delete(b.handle)})}transferChatSession(I,D){const l=T.Iterable.find(this.c.keys(),b=>this.c.get(b)===I)??0;typeof l=="number"&&this.e.$transferChatSession(l,D)}sendInteractiveRequestToProvider(I,D){this.e.$sendRequestToProvider(I,D)}async $prepareChat(I,D){const l=this.b.get(I);if(!l)return;const b=await l.provider.prepareSession(D);if(!b)return;const v=E.a++;return this.c.set(v,b),{id:v,requesterUsername:b.requester?.name,requesterAvatarIconUri:b.requester?.icon,responderUsername:b.responder?.name,responderAvatarIconUri:b.responder?.icon,inputPlaceholder:b.inputPlaceholder}}async $provideWelcomeMessage(I,D){const l=this.b.get(I);if(!l||!l.provider.provideWelcomeMessage)return;const b=await l.provider.provideWelcomeMessage(D);if(b)return b.map(v=>typeof v=="string"?v:Array.isArray(v)?v.map(f=>A.ChatReplyFollowup.from(f)):A.MarkdownString.from(v))}async $provideSampleQuestions(I,D){const l=this.b.get(I);if(!l||!l.provider.provideSampleQuestions)return;const b=await l.provider.provideSampleQuestions(D);if(b)return b?.map(v=>A.ChatReplyFollowup.from(v))}$releaseSession(I){this.c.delete(I)}async $onDidPerformUserAction(I){this.d.fire(I)}}e.$_dc=E}),define(Pe[235],Ae([1,0,14,19,39,5,60,16,2,157,72,3,8,7,206,23]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class t{static{this.a=0}constructor(c,o,h){this.i=o,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=c.getProxy(D.$yK.MainThreadChatAgents2)}createChatAgent(c,o,h){const n=t.a++,s=new i(c,o,this.d,n,h);return this.b.set(n,s),this.d.$registerAgent(n,o,{}),s.apiAgent}async $invokeAgent(c,o,h,n,s,a){this.g.delete(o);const g=this.b.get(c);if(!g)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let p=!1;function m(){if(p)throw new Error("Only valid while executing the command")}const k=new y.$ih;a.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(g.extension.identifier,k.p);const C=n.command?await g.validateSlashCommand(n.command):void 0,u=A.$Nd.create(!1);let w;try{const S=g.invoke({prompt:n.message,variables:l.ChatVariable.objectTo(n.variables),slashCommand:C},{history:s.history.map(l.ChatMessage.to)},new I.$$u(F=>{m(),typeof w>"u"&&"content"in F&&(w=u.elapsed());const V=l.ChatResponseProgress.from(g.extension,F);if("placeholder"in F&&"resolvedContent"in F){const J=Promise.all([this.d.$handleProgressChunk(h,V),F.resolvedContent]);(0,y.$Mg)(J,a).then(N=>{if(!N)return;const[R,L]=N,O=l.ChatResponseProgress.from(g.extension,L);this.d.$handleProgressChunk(h,O,R??void 0)})}else this.d.$handleProgressChunk(h,V)}),a);return await(0,y.$Mg)(Promise.resolve(S).then(F=>{if(F){this.g.set(o,F);let V=this.h.get(o);V||(V=new Map,this.h.set(o,V)),V.set(h,F);const J={firstProgress:w,totalElapsed:u.elapsed()};return{errorDetails:F.errorDetails,timings:J}}else this.g.delete(o)}),a)}catch(S){return this.j.error(S,g.extension),{errorDetails:{message:(0,d.localize)(0,null,(0,P.$Gi)(S)),responseIsIncomplete:!0}}}finally{p=!0,k.complete()}}$releaseSession(c){this.g.delete(c),this.h.delete(c)}async $provideSlashCommands(c,o){const h=this.b.get(c);return h?h.provideSlashCommand(o):[]}$provideFollowups(c,o,h){const n=this.b.get(c);if(!n)return Promise.resolve([]);const s=this.g.get(o);return s?n.provideFollowups(s,h):Promise.resolve([])}$acceptFeedback(c,o,h,n,s){const a=this.b.get(c);if(!a)return;const g=this.h.get(o)?.get(h);if(!g)return;let p;switch(n){case v.InteractiveSessionVoteDirection.Down:p=b.ChatAgentResultFeedbackKind.Unhelpful;break;case v.InteractiveSessionVoteDirection.Up:p=b.ChatAgentResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(s?{result:g,kind:p,reportIssue:s}:{result:g,kind:p}))}$acceptAction(c,o,h,n){const s=this.b.get(c);if(!s)return;const a=this.h.get(o)?.get(h);a&&n.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:n.action,result:a}))}}e.$bec=t;class i{constructor(c,o,h,n,s){this.extension=c,this.s=o,this.t=h,this.u=n,this.w=s,this.o=new M.$Rd,this.q=new M.$Rd}acceptFeedback(c){this.o.fire(c)}acceptAction(c){this.q.fire(c)}async validateSlashCommand(c){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,$.$Mf)(this.b));const o=this.b.find(h=>h.name===c);if(!o)throw new Error(`Unknown slashCommand: ${c}`);return o}async provideSlashCommand(c){if(!this.a)return[];const o=await this.a.provideSlashCommands(c);return o?(this.b=o,o.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(c,o){if(!this.d)return[];const h=await this.d.provideFollowups(c,o);return h?h.map(n=>l.ChatFollowup.from(n)):[]}get apiAgent(){let c=!1,o=!1;const h=()=>{c||o||(o=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof b.$uL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),o=!1}))},n=this;return{get name(){return n.s},get description(){return n.g??""},set description(s){n.g=s,h()},get fullName(){return n.h??n.extension.displayName??n.extension.name},set fullName(s){n.h=s,h()},get iconPath(){return n.i},set iconPath(s){n.i=s,h()},get slashCommandProvider(){return n.a},set slashCommandProvider(s){n.a=s,h()},get followupProvider(){return n.d},set followupProvider(s){n.d=s,h()},get isDefault(){return(0,f.$MF)(n.extension,"defaultChatAgent"),n.j},set isDefault(s){(0,f.$MF)(n.extension,"defaultChatAgent"),n.j=s,h()},get helpTextPrefix(){return(0,f.$MF)(n.extension,"defaultChatAgent"),n.k},set helpTextPrefix(s){if((0,f.$MF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPrefix is only available on the default chat agent");n.k=s,h()},get helpTextPostfix(){return(0,f.$MF)(n.extension,"defaultChatAgent"),n.l},set helpTextPostfix(s){if((0,f.$MF)(n.extension,"defaultChatAgent"),!n.j)throw new Error("helpTextPostfix is only available on the default chat agent");n.l=s,h()},get isSecondary(){return(0,f.$MF)(n.extension,"defaultChatAgent"),n.n},set isSecondary(s){(0,f.$MF)(n.extension,"defaultChatAgent"),n.n=s,h()},get sampleRequest(){return n.m},set sampleRequest(s){n.m=s,h()},get supportIssueReporting(){return(0,f.$MF)(n.extension,"chatAgents2Additions"),n.r},set supportIssueReporting(s){(0,f.$MF)(n.extension,"chatAgents2Additions"),n.r=s,h()},get onDidReceiveFeedback(){return n.o.event},onDidPerformAction:(0,f.$LF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){c=!0,n.a=void 0,n.d=void 0,n.o.dispose(),n.t.$unregisterAgent(n.u)}}}invoke(c,o,h,n){return this.w(c,o,h,n)}}}),define(Pe[236],Ae([1,0,19,6,3,8,72,22,14,5]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;class I{constructor(v,f){this.stream=new E.$mh,this.stream=f??new E.$mh;const t=this;this.apiObj={option:v,response:t.stream.asyncIterable}}}class D{constructor(v,f){this.a=new d.$Rd,this.b=new Map,this.c=new E.$mh,this.d=!1;const t=this;this.apiObject={result:v,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){f.cancel()}},v.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(v){if(this.d)return;let f=this.b.get(v.index);f||(this.b.size===0?f=new I(v.index,this.c):f=new I(v.index),this.b.set(v.index,f),this.a.fire(f.apiObj)),f.stream.emitOne(v.part)}}class l{static{this.a=1}constructor(v,f){this.d=f,this.c=new Map,this.e=new Map,this.f=new $.$bm,this.b=v.getProxy(P.$yK.MainThreadChatProvider)}registerProvider(v,f,t,i){const r=l.a++;return this.c.set(r,{extension:v,provider:t}),this.b.$registerProvider(r,f,{extension:v,displayName:i.name??v.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(r),this.c.delete(r)})}async $provideChatResponse(v,f,t,i,r){const c=this.c.get(v);if(!c)return;const o=new A.$$u(async h=>{if(r.isCancellationRequested){this.d.warn(`[CHAT](${c.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:h.index,part:h.part})});return c.provider.provideChatResponse(t.map(M.ChatMessage.to),i,o,r)}allowListExtensionWhile(v,f){this.f.set(v,f),f.finally(()=>this.f.delete(v))}async requestChatResponseProvider(v,f){if(!this.f.has(v))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(v)},makeRequest(i,r,c){if(!t.f.has(v))throw new Error("Access to chat has been revoked");const o=new y.$2d(c),h=Math.random()*1e6|0,n=t.b.$fetchResponse(v,f,h,i.map(M.ChatMessage.from),r??{},o.token),s=new D(n,o);return t.e.set(h,{res:s}),n.finally(()=>{t.e.delete(h)}),s.apiObject}}}async $handleResponseFragment(v,f){const t=this.e.get(v);t&&t.res.handleFragment(f)}}e.$aec=l}),define(Pe[237],Ae([1,0,6,3,11,8]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class A{static{this.a=0}constructor(E){this.b=new Map,this.c=E.getProxy(T.$yK.MainThreadChatVariables)}async $resolveVariable(E,d,I){const D=this.b.get(E);if(D)try{const l=await D.resolver.resolve(D.data.name,{message:d},I);if(l)return l.map(M.ChatVariable.from)}catch(l){(0,P.$1)(l)}}registerVariableResolver(E,d,I,D){const l=A.a++;return this.b.set(l,{extension:E.identifier,data:{name:d,description:I},resolver:D}),this.c.$registerVariable(l,{name:d,description:I}),(0,y.$Pc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$cec=A}),define(Pe[238],Ae([1,0,3]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;class T{constructor(M){const A=M.getProxy(y.$yK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText($){return A.$writeText($)}})}}e.$dec=T}),define(Pe[32],Ae([1,0,16,7,8,26,3,18,15,51,29,131,2,6,4,17,108,24,49,39,60,56,59,33]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=void 0;let a=class{#e;#t;#i;constructor(u,w,S){this.b=new Map,this.c=new Map,this.#e=u.getProxy(A.$yK.MainThreadCommands),this.d=w,this.#i=S,this.#t=u.getProxy(A.$yK.MainThreadTelemetry),this.converter=new g(this,F=>{const V=this.c.get(F);return V?.result===m.Void?V:void 0},w),this.f=[{processArgument(F){return(0,d.$sh)(F)}},{processArgument(F){return(0,M.$cn)(F,function(V){if(I.$zs.isIRange(V))return P.Range.to(V);if(D.$ys.isIPosition(V))return P.Position.to(V);if(I.$zs.isIRange(V.range)&&l.URI.isUri(V.uri))return P.location.to(V);if(V instanceof i.$fe)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(u){this.f.push(u)}registerApiCommand(u){const w=this.registerCommand(!1,u.id,async(...S)=>{const F=u.args.map((J,N)=>{if(!J.validate(S[N]))throw new Error(`Invalid argument '${J.name}' when running '${u.id}', received: ${typeof S[N]=="object"?JSON.stringify(S[N],null,"	"):S[N]} `);return J.convert(S[N])}),V=await this.executeCommand(u.internalId,...F);return u.result.convert(V,S,this.converter)},void 0,{description:u.description,args:u.args,returns:u.result.description});return this.c.set(u.id,u),new T.$AK(()=>{w.dispose(),this.c.delete(u.id)})}registerCommand(u,w,S,F,V,J){if(this.d.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this.b.has(w))throw new Error(`command '${w}' already exists`);return this.b.set(w,{callback:S,thisArg:F,metadata:V,extension:J}),u&&this.#e.$registerCommand(w),new T.$AK(()=>{this.b.delete(w)&&u&&this.#e.$unregisterCommand(w)})}executeCommand(u,...w){return this.d.trace("ExtHostCommands#executeCommand",u),this.g(u,w,!0)}async g(u,w,S){if(this.b.has(u))return this.#e.$fireCommandActivationEvent(u),this.h(u,w,!1);{let F=!1;const V=(0,M.$cn)(w,function(J){if(J instanceof T.$BK)return P.Position.from(J);if(J instanceof T.$CK)return P.Range.from(J);if(J instanceof T.$MK)return P.location.from(J);if(T.$XL.isNotebookRange(J))return P.NotebookRange.from(J);if(J instanceof ArrayBuffer)return F=!0,i.$fe.wrap(new Uint8Array(J));if(J instanceof Uint8Array)return F=!0,i.$fe.wrap(J);if(J instanceof i.$fe)return F=!0,J;if(!Array.isArray(J))return J});try{const J=await this.#e.$executeCommand(u,F?new r.$wv(V):V,S);return(0,d.$sh)(J)}catch(J){if(J instanceof Error&&J.message==="$executeCommand:retry")return this.g(u,w,!1);throw J}}}async h(u,w,S){const F=this.b.get(u);if(!F)throw new Error("Unknown command");const{callback:V,thisArg:J,metadata:N}=F;if(N?.args)for(let L=0;L<N.args.length;L++)try{(0,y.$Tf)(w[L],N.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${u}' failed. Illegal argument '${N.args[L].name}' - ${N.args[L].description}`)}const R=o.$Nd.create();try{return await V.apply(J,w)}catch(L){if(u===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...w);O&&(u=O.command)}if(this.d.error(L,u,F.extension?.identifier),!S)throw L;if(F.extension?.identifier){const O=this.#i.onExtensionError(F.extension.identifier,L);this.d.trace("forwarded error to extension?",O,F.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$Gi)(L)),this.id=u,this.source=F.extension?.displayName??F.extension?.name}}}finally{this.j(F,u,R.elapsed())}}j(u,w,S){u.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:u.extension.identifier.value,id:new h.$po(w),duration:S})}$executeContributedCommand(u,...w){this.d.trace("ExtHostCommands#$executeContributedCommand",u);const S=this.b.get(u);return S?(w=w.map(F=>this.f.reduce((V,J)=>J.processArgument(V,S.extension?.identifier),F)),this.h(u,w,!0)):Promise.reject(new Error(`Contributed command '${u}' does not exist.`))}getCommands(u=!1){return this.d.trace("ExtHostCommands#getCommands",u),this.#e.$getCommands().then(w=>(u&&(w=w.filter(S=>S[0]!=="_")),w))}$getContributedCommandMetadata(){const u=Object.create(null);for(const[w,S]of this.b){const{metadata:F}=S;F&&(u[w]=F)}return Promise.resolve(u)}};e.$VM=a,e.$VM=a=Ke([Ve(0,f.$AM),Ve(1,E.$dj),Ve(2,n.$UM)],a),e.$WM=(0,v.$Vh)("IExtHostCommands");class g{constructor(u,w,S){this.d=u,this.f=w,this.g=S,this.delegatingCommandId=`__vsc${(0,s.$ig)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(u,w){if(!u)return;const S={$ident:void 0,id:u.command,title:u.title,tooltip:u.tooltip};if(!u.command)return S;const F=this.f(u.command);if(F)S.id=F.internalId,S.arguments=F.args.map((V,J)=>V.convert(u.arguments&&u.arguments[J]));else if((0,$.$Kb)(u.arguments)){const V=`${u.command} /${++this.c}`;this.b.set(V,u),w.add((0,b.$Pc)(()=>{this.b.delete(V),this.g.trace("CommandsConverter#DISPOSE",V)})),S.$ident=V,S.id=this.delegatingCommandId,S.arguments=[V],this.g.trace("CommandsConverter#CREATE",u.command,V)}return S}fromInternal(u){return typeof u.$ident=="string"?this.b.get(u.$ident):{command:u.id,title:u.title,arguments:u.arguments}}getActualCommand(...u){return this.b.get(u[0])}h(...u){const w=this.getActualCommand(...u);return this.g.trace("CommandsConverter#EXECUTE",u[0],w?w.command:"MISSING"),w?this.d.executeCommand(w.command,...w.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${u[0]}`)}}e.$XM=g;class p{static{this.Uri=new p("uri","Uri of a text document",u=>l.URI.isUri(u),u=>u)}static{this.Position=new p("position","A position in a text document",u=>T.$BK.isPosition(u),P.Position.from)}static{this.Range=new p("range","A range in a text document",u=>T.$CK.isRange(u),P.Range.from)}static{this.Selection=new p("selection","A selection in a text document",u=>T.$DK.isSelection(u),P.Selection.from)}static{this.Number=new p("number","",u=>typeof u=="number",u=>u)}static{this.String=new p("string","",u=>typeof u=="string",u=>u)}static{this.StringArray=p.Arr(p.String)}static Arr(u){return new p(`${u.name}_array`,`Array of ${u.name}, ${u.description}`,w=>Array.isArray(w)&&w.every(S=>u.validate(S)),w=>w.map(S=>u.convert(S)))}static{this.CallHierarchyItem=new p("item","A call hierarchy item",u=>u instanceof T.$WK,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new p("item","A type hierarchy item",u=>u instanceof T.$eM,P.TypeHierarchyItem.from)}static{this.TestItem=new p("testItem","A VS Code TestItem",u=>u instanceof t.$NM,P.TestItem.from)}constructor(u,w,S,F){this.name=u,this.description=w,this.validate=S,this.convert=F}optional(){return new p(this.name,`(optional) ${this.description}`,u=>u==null||this.validate(u),u=>u===void 0?void 0:u===null?null:this.convert(u))}with(u,w){return new p(u??this.name,w??this.description,this.validate,this.convert)}}e.$YM=p;class m{static{this.Void=new m("no result",u=>u)}constructor(u,w){this.description=u,this.convert=w}}e.$ZM=m;class k{constructor(u,w,S,F,V){this.id=u,this.internalId=w,this.description=S,this.args=F,this.result=V}}e.$1M=k}),define(Pe[239],Ae([1,0,18,13,2,80,95,35,99,32,8,7]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;const l=[new d.$1M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to an array of DocumentHighlight-instances.",v(I.DocumentHighlight.to))),new d.$1M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$YM.Uri],new d.$ZM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Jb)(t))return;class r extends D.$RK{static to(o){const h=new r(o.name,I.SymbolKind.to(o.kind),o.containerName||"",new D.$MK(i[0],I.Range.to(o.range)));return h.detail=o.detail,h.range=h.location.range,h.selectionRange=I.Range.to(o.selectionRange),h.children=o.children?o.children.map(r.to):[],h}}return t.map(r.to)})),new d.$1M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$YM.Uri,new d.$YM("options","Formatting options",t=>!0,t=>t)],new d.$ZM("A promise that resolves to an array of TextEdits.",v(I.TextEdit.to))),new d.$1M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$YM.Uri,d.$YM.Range,new d.$YM("options","Formatting options",t=>!0,t=>t)],new d.$ZM("A promise that resolves to an array of TextEdits.",v(I.TextEdit.to))),new d.$1M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$YM.Uri,d.$YM.Position,new d.$YM("ch","Trigger character",t=>typeof t=="string",t=>t),new d.$YM("options","Formatting options",t=>!0,t=>t)],new d.$ZM("A promise that resolves to an array of TextEdits.",v(I.TextEdit.to))),new d.$1M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$1M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$1M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$1M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to an array of Location or LocationLink instances.",f)),new d.$1M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to an array of Location-instances.",v(I.location.to))),new d.$1M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to an array of Hover-instances.",v(I.Hover.to))),new d.$1M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$YM.Uri,new d.$YM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$BK.isPosition(i)),t=>t.map(I.Position.from))],new d.$ZM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let r;for(const c of i.reverse())r=new D.$VK(I.Range.to(c),r);return r}))),new d.$1M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$YM.String.with("query","Search string")],new d.$ZM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(I.WorkspaceSymbol.to))),new d.$1M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(I.CallHierarchyItem.to))),new d.$1M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$YM.CallHierarchyItem],new d.$ZM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(I.CallHierarchyIncomingCall.to))),new d.$1M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$YM.CallHierarchyItem],new d.$ZM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(I.CallHierarchyOutgoingCall.to))),new d.$1M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:I.Range.to(t.range),placeholder:t.text}})),new d.$1M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$YM.Uri,d.$YM.Position,d.$YM.String.with("newName","The new symbol name")],new d.$ZM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return I.WorkspaceEdit.to(t)}})),new d.$1M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$YM.Uri,d.$YM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$ZM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(I.DocumentLink.to))),new d.$1M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$YM.Uri],new d.$ZM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$PL(t.tokenTypes,t.tokenModifiers)})),new d.$1M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$YM.Uri],new d.$ZM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$30)(t);if(i.type==="full")return new D.$RL(i.data,void 0)})),new d.$1M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$YM.Uri,d.$YM.Range.optional()],new d.$ZM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$PL(t.tokenTypes,t.tokenModifiers)})),new d.$1M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$YM.Uri,d.$YM.Range],new d.$ZM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$30)(t);if(i.type==="full")return new D.$RL(i.data,void 0)})),new d.$1M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$YM.Uri,d.$YM.Position,d.$YM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$YM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$ZM("A promise that resolves to a CompletionList-instance.",(t,i,r)=>{if(!t)return new D.$8K([]);const c=t.suggestions.map(o=>I.CompletionItem.to(o,r));return new D.$8K(c,t.incomplete)})),new d.$1M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$YM.Uri,d.$YM.Position,d.$YM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$ZM("A promise that resolves to SignatureHelp.",t=>{if(t)return I.SignatureHelp.to(t)})),new d.$1M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$YM.Uri,d.$YM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$ZM("A promise that resolves to an array of CodeLens-instances.",(t,i,r)=>v(c=>new D.$ZK(I.Range.to(c.range),c.command&&r.fromInternal(c.command)))(t))),new d.$1M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$YM.Uri,new d.$YM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$CK.isRange(t),t=>D.$DK.isSelection(t)?I.Selection.from(t):I.Range.from(t)),d.$YM.String.with("kind","Code action kind to return code actions for").optional(),d.$YM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$ZM("A promise that resolves to an array of Command-instances.",(t,i,r)=>v(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(c.command)}else{const o=new D.$TK(c.title,c.kind?new D.$UK(c.kind):void 0);return c.edit&&(o.edit=I.WorkspaceEdit.to(c.edit)),c.command&&(o.command=r.fromInternal(c.command)),o.isPreferred=c.isPreferred,o}})(t))),new d.$1M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$YM.Uri],new d.$ZM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$bL(I.Range.to(i.range),I.Color.to(i.color))):[])),new d.$1M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$YM("color","The color to show and insert",t=>t instanceof D.$aL,I.Color.from),new d.$YM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:I.Range.from(t.range)}))],new d.$ZM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(I.ColorPresentation.to):[])),new d.$1M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$YM.Uri,d.$YM.Range],new d.$ZM("A promise that resolves to an array of Inlay objects",(t,i,r)=>t.map(I.InlayHint.to.bind(void 0,r)))),new d.$1M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$YM.Uri],new d.$ZM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(I.FoldingRange.to)})),new d.$1M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$ZM("A promise that resolves to an array of NotebookContentProvider static info objects.",v(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>I.NotebookExclusiveDocumentPattern.to(i))})))),new d.$1M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$YM.Uri,d.$YM.Range,new d.$YM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$CK,t=>I.InlineValueContext.from(t))],new d.$ZM("A promise that resolves to an array of InlineValue objects",t=>t.map(I.InlineValue.to))),new d.$1M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$YM("uriOrString","Uri-instance or string (only http/https)",t=>P.URI.isUri(t)||typeof t=="string"&&(0,E.$SU)(t,T.Schemas.http,T.Schemas.https),t=>t),new d.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[I.ViewColumn.from(t),void 0]:[I.ViewColumn.from(t.viewColumn),I.TextEditorOpenOptions.from(t)])).optional(),d.$YM.String.with("label","").optional()],d.$ZM.Void),new d.$1M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$YM.Uri.with("resource","Resource to open"),d.$YM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new d.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[I.ViewColumn.from(t),void 0]:[I.ViewColumn.from(t.viewColumn),I.TextEditorOpenOptions.from(t)])).optional()],d.$ZM.Void),new d.$1M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$YM.Uri.with("left","Left-hand side resource of the diff editor"),d.$YM.Uri.with("right","Right-hand side resource of the diff editor"),d.$YM.String.with("title","Human readable title for the diff editor").optional(),new d.$YM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[I.ViewColumn.from(t.viewColumn),I.TextEditorOpenOptions.from(t)]).optional()],d.$ZM.Void),new d.$1M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[d.$YM.String.with("title","Human readable title for the changes editor"),new d.$YM("resourceList","List of resources to compare",t=>{for(const i of t){if(i.length!==3)return!1;const[r,c,o]=i;if(!P.URI.isUri(r)||!P.URI.isUri(c)&&c!==void 0&&c!==null||!P.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},t=>t)],d.$ZM.Void),new d.$1M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$YM.Uri,d.$YM.Position],new d.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(I.TypeHierarchyItem.to))),new d.$1M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$YM.TypeHierarchyItem],new d.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(I.TypeHierarchyItem.to))),new d.$1M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$YM.TypeHierarchyItem],new d.$ZM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(I.TypeHierarchyItem.to))),new d.$1M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$YM.TestItem],d.$ZM.Void),new d.$1M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$YM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$ZM.Void),new d.$1M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$YM.String.with("name","The context key name"),new d.$YM("value","The context key value",()=>!0,t=>t)],d.$ZM.Void),new d.$1M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$YM.Uri,d.$YM.StringArray,new d.$YM("MappedEditsContext","Mapped Edits Context",t=>I.MappedEditsContext.is(t),t=>I.MappedEditsContext.from(t))],new d.$ZM("A promise that resolves to a workspace edit or null",t=>t?I.WorkspaceEdit.to(t):null))];class b{static register(i){l.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",$.$Ui)}}e.$9dc=b;function v(t){return i=>{if(Array.isArray(i))return i.map(t)}}function f(t){if(!Array.isArray(t))return;const i=[];for(const r of t)M.$kt(r)?i.push(I.DefinitionLink.to(r)):i.push(I.location.to(r));return i}}),define(Pe[240],Ae([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(we,e,y,T,P,M,A,$,E,d,I,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;function b(v,f,t){const i=v.getProxy(D.$yK.MainThreadComments);class r{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$bm,f.registerArgumentProcessor({processArgument:m=>{if(m&&m.$mid===6){const k=this.b.get(m.handle);return k?k.value:m}else if(m&&m.$mid===7){const k=this.b.get(m.commentControlHandle);if(!k)return m;const C=k.getCommentThread(m.commentThreadHandle);return C?C.value:m}else if(m&&(m.$mid===9||m.$mid===8)){const k=this.b.get(m.thread.commentControlHandle);if(!k)return m;const C=k.getCommentThread(m.thread.commentThreadHandle);return C?m.$mid===8?C.value:{thread:C.value,text:m.text}:m}else if(m&&m.$mid===10){const k=this.b.get(m.thread.commentControlHandle);if(!k)return m;const C=k.getCommentThread(m.thread.commentThreadHandle);if(!C)return m;const u=m.commentUniqueId,w=C.getCommentByUniqueId(u);return w||m}else if(m&&m.$mid===11){const k=this.b.get(m.thread.commentControlHandle);if(!k)return m;const C=k.getCommentThread(m.thread.commentThreadHandle);if(!C)return m;const u=m.text,w=m.commentUniqueId,S=C.getCommentByUniqueId(w);return S?(typeof S.body=="string"?S.body=u:S.body=new I.$1K(u),S):m}return m}})}createCommentController(m,k,C){const u=r.a++,w=new o(m,u,k,C);this.b.set(w.handle,w);const S=this.c.get(m.identifier)||[];return S.push(w),this.c.set(m.identifier,S),w.value}async $createCommentThreadTemplate(m,k,C){const u=this.b.get(m);u&&u.$createCommentThreadTemplate(k,C)}async $updateCommentThreadTemplate(m,k,C){const u=this.b.get(m);u&&u.$updateCommentThreadTemplate(k,C)}$deleteCommentThread(m,k){this.b.get(m)?.$deleteCommentThread(k)}$provideCommentingRanges(m,k,C){const u=this.b.get(m);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const w=t.getDocument(A.URI.revive(k));return(0,y.$Qg)(async()=>{const S=await u.commentingRangeProvider.provideCommentingRanges(w,C);let F;return Array.isArray(S)?F={ranges:S,fileComments:!1}:S?F={ranges:S.ranges||[],fileComments:S.fileComments||!1}:F=S??void 0,F}).then(S=>{let F;return S&&(F={ranges:S.ranges.map(V=>d.Range.from(V)),fileComments:S.fileComments}),F})}$toggleReaction(m,k,C,u,w){const S=this.b.get(m);return!S||!S.reactionHandler?Promise.resolve(void 0):(0,y.$Qg)(()=>{const F=S.getCommentThread(k);if(F){const V=F.getCommentByUniqueId(u.uniqueIdInThread);if(S!==void 0&&V&&S.reactionHandler)return S.reactionHandler(V,s(w))}return Promise.resolve(void 0)})}}class c{static{this.a=0}set threadId(m){this.n=m}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(m){(m===void 0!=(this.p===void 0)||!m||!this.p||!m.isEqual(this.p))&&(this.p=m,this.b.range=m,this.c.fire())}get range(){return this.p}set canReply(m){this.d!==m&&(this.d=m,this.b.canReply=m,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(m){this.e=m,this.b.label=m,this.c.fire()}get contextValue(){return this.f}set contextValue(m){this.f=m,this.b.contextValue=m,this.c.fire()}get comments(){return this.q}set comments(m){this.q=m,this.b.comments=m,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(m){this.g=m,this.b.collapsibleState=m,this.c.fire()}get state(){return this.h}set state(m){this.h=m,this.b.state=m,this.c.fire()}get isDisposed(){return this.j}constructor(m,k,C,u,w,S,F,V){this.m=k,this.n=C,this.o=u,this.p=w,this.q=S,this.extensionDescription=F,this.r=V,this.handle=c.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${m}.${this.handle}`),i.$createCommentThread(k,this.handle,this.n,this.o,d.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=S,this.i.push({dispose:()=>{i.$deleteCommentThread(k,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(N){J.range=N},get comments(){return J.comments},set comments(N){J.comments=N},get collapsibleState(){return J.collapsibleState},set collapsibleState(N){J.collapsibleState=N},get canReply(){return J.canReply},set canReply(N){J.canReply=N},get contextValue(){return J.contextValue},set contextValue(N){J.contextValue=N},get label(){return J.label},set label(N){J.label=N},get state(){return J.state},set state(N){J.state=N},dispose:()=>{J.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const m=C=>Object.prototype.hasOwnProperty.call(this.b,C),k={};m("range")&&(k.range=d.Range.from(this.p)),m("label")&&(k.label=this.label),m("contextValue")&&(k.contextValue=this.contextValue??null),m("comments")&&(k.comments=this.q.map(C=>h(this,C,this.k,this.extensionDescription))),m("collapsibleState")&&(k.collapseState=a(this.g)),m("canReply")&&(k.canReply=this.canReply),m("state")&&(k.state=g(this.h)),m("isTemplate")&&(k.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(m){for(const k of this.k){const C=k[0],u=k[1];if(m===u)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(m=>m.dispose())}}Ke([(0,T.$oh)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(m){this.b=m,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(m){this.c=m,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this.d}set options(m){this.d=m,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(m,k,C,u){this.f=m,this.g=k,this.h=C,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,C,u,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(S){w.options=S},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(S){w.commentingRangeProvider=S},get reactionHandler(){return w.reactionHandler},set reactionHandler(S){w.reactionHandler=S},createCommentThread(S,F,V){return w.createCommentThread(S,F,V).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(m,k,C){k===void 0&&(0,l.$MF)(this.f,"fileComments");const u=new c(this.id,this.handle,void 0,m,k,C,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(m,k){const C=new c(this.id,this.handle,void 0,A.URI.revive(m),d.Range.to(k),[],this.f,!0);return C.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(C.handle,C),C}$updateCommentThreadTemplate(m,k){const C=this.a.get(m);C&&(C.range=d.Range.to(k))}$deleteCommentThread(m){this.a.get(m)?.dispose(),this.a.delete(m)}getCommentThread(m){return this.a.get(m)}dispose(){this.a.forEach(m=>{m.dispose()}),this.e.forEach(m=>m.dispose())}}function h(p,m,k,C){let u=k.get(m);return u||(u=++p.commentHandle,k.set(m,u)),m.state!==void 0&&(0,l.$MF)(C,"commentsDraftState"),{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:u,body:typeof m.body=="string"?m.body:d.MarkdownString.from(m.body),userName:m.author.name,userIconPath:m.author.iconPath,label:m.label,commentReactions:m.reactions?m.reactions.map(w=>n(w)):void 0,state:m.state,timestamp:m.timestamp?.toJSON()}}function n(p){return{label:p.label,iconPath:p.iconPath?d.$zM(p.iconPath):void 0,count:p.count,hasReacted:p.authorHasReacted}}function s(p){return{label:p.label||"",count:p.count||0,iconPath:p.iconPath?A.URI.revive(p.iconPath):"",authorHasReacted:p.hasReacted||!1}}function a(p){if(p!==void 0)switch(p){case I.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case I.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function g(p){if(p!==void 0)switch(p){case I.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case I.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}return new r}e.$gec=b}),define(Pe[241],Ae([1,0,26,3,27,17]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;let A=class{constructor(I,D){this.a=I.getProxy(T.$yK.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(I,D){const l=this,b=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){l.e(I,D,b,arguments)}})}e(I,D,l,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:E(b,this.b)}),this.c&&this.f(I,l,b)}};e.$7fc=A,e.$7fc=A=Ke([Ve(0,M.$AM),Ve(1,P.$QM)],A);const $=1e5;function E(d,I){const D=[];if(d.length)for(let l=0;l<d.length;l++){let b=d[l];if(typeof b>"u")b="undefined";else if(b instanceof Error){const v=b;v.stack?b=v.stack:b=v.toString()}D.push(b)}if(I){const l=new Error().stack;l&&D.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,y.$fn)(D);return l.length>$?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[110],Ae([1,0,2,3,7,4,17,15,18,12,20,23]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$0ec=e.$9ec=void 0;let b=class{static{l=this}static{this.c=0}static{this.d=250}constructor(f,t){this.h=t,this.f=new Map,this.g=f.getProxy(T.$yK.MainThreadDecorations)}registerFileDecorationProvider(f,t){const i=l.c++;this.f.set(i,{provider:f,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const r=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(i,null);return}const o=(0,E.$2b)(c);if(o.length<=l.d){this.g.$onDidChange(i,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,o.length);const h=o.map(a=>({uri:a,rank:(0,d.$Ke)(a.path,"/")})),n=(0,E.$yb)(h,(a,g)=>a.rank-g.rank||(0,d.$Ye)(a.uri.path,g.uri.path)),s=[];e:for(const a of n){let g;for(const p of a){const m=(0,I.$lc)(p.uri.path);if(g!==m&&(g=m,s.push(p.uri)>=l.d))break e}}this.g.$onDidChange(i,s)});return new P.$AK(()=>{r?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(f,t,i){if(!this.f.has(f))return Object.create(null);const r=Object.create(null),{provider:c,extensionDescription:o}=this.f.get(f);return await Promise.all(t.map(async h=>{try{const{uri:n,id:s}=h,a=await Promise.resolve(c.provideFileDecoration(y.URI.revive(n),i));if(!a)return;try{P.$VL.validate(a),a.badge&&typeof a.badge!="string"&&(0,D.$MF)(o,"codiconDecoration"),r[s]=[a.propagate,a.tooltip,a.badge,a.color]}catch(g){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${g}`)}}catch(n){this.h.error(n)}})),r}};e.$9ec=b,e.$9ec=b=l=Ke([Ve(0,A.$AM),Ve(1,$.$dj)],b),e.$0ec=(0,M.$Vh)("IExtHostDecorations")}),define(Pe[242],Ae([1,0,158,98,2,3,7,8,5,15,28,42]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=e.$3dc=void 0;class b{#e;#t;#i;constructor(t,i,r,c,o,h,n,s){this.d=t,this.e=i,this.f=r,this.g=c,this.h=o,this.c=!1,this.f=Math.max(c,r),this.#i=new I.$zc(a=>h.getComparisonKey(a)),this.#e=n,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let r=[];if(P.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),r=[t]}else if(Array.isArray(t)){r=[];let h;t=[...t].sort(b.k);for(const n of t){const[s,a]=n;if((!h||s.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=s,r.push(s),this.#i.set(s,[])),a)this.#i.get(s)?.push(...a);else{const g=this.#i.get(s);g&&(g.length=0)}}}if(this.#t.fire(r),!this.#e)return;const c=[];let o=0;for(const h of r){let n=[];const s=this.#i.get(h);if(s)if(s.length>this.g){n=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let g=0;g<4;g++)for(const p of s)if(p.severity===a[g]&&n.push({...$.Diagnostic.from(p),modelVersionId:this.h(h)})===this.g)break e;n.push({severity:T.MarkerSeverity.Info,message:(0,y.localize)(0,null,s.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=s.map(a=>({...$.Diagnostic.from(a),modelVersionId:this.h(h)}));if(c.push([h,n]),o+=n.length,o>this.f)break}this.#e.$changeMany(this.e,c)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[r,c]of this)t.call(i,r,c,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$3dc=b;let v=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(t){const i=new I.$zc;for(const r of t)i.set(r,r);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,r,c){this.j=i,this.k=r,this.l=c,this.g=new Map,this.h=new E.$Vd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,l._mapper),this.f=t.getProxy(M.$yK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:r,f:c,h:o,j:h,k:n,l:s}=this,a=new class{$changeMany(m,k){c.$changeMany(m,k),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,m,k.length===0?"CLEARING":k)}$clear(m){c.$clear(m),h.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,m)}dispose(){c.dispose()}};let g;if(!i)i="_generated_diagnostic_collection_name_#"+l.c++,g=i;else if(!r.has(i))g=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do g=i+l.c++;while(r.has(g))}return new class extends b{constructor(){super(i,g,l.e,l.d,m=>s.getDocument(m)?.version,n.extUri,a,o),r.set(g,this)}dispose(){super.dispose(),r.delete(g)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,r=[];for(const c of this.g.values())c.forEach((o,h)=>{let n=i.get(o.toString());typeof n>"u"&&(n=r.length,i.set(o.toString(),n),r.push([o,[]])),r[n][1]=r[n][1].concat(...h)});return r}}m(t){let i=[];for(const r of this.g.values())r.has(t)&&(i=i.concat(r.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",r=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(i,r),this.n=r}for(const[i,r]of t)this.n.set(P.URI.revive(i),r.map($.Diagnostic.to))}};e.$4dc=v,e.$4dc=v=l=Ke([Ve(1,d.$dj),Ve(2,D.$2dc)],v)}),define(Pe[243],Ae([1,0,2,3,23]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=void 0;class M{constructor($){this.a=$.getProxy(T.$yK.MainThreadDialogs)}showOpenDialog($,E){return E?.allowUIResources&&(0,P.$MF)($,"showLocal"),this.a.$showOpenDialog(E).then(d=>d?d.map(I=>y.URI.revive(I)):void 0)}showSaveDialog($){return this.a.$showSaveDialog($).then(E=>E?y.URI.revive(E):void 0)}}e.$$ec=M}),define(Pe[244],Ae([1,0,11,2,7,3,13,19,12]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class d{static{this.a=0}constructor(D,l,b){this.d=l,this.e=b,this.b=new Map,this.c=D.getProxy(M.$yK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,l){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=d.a++;this.b.set(b,l),this.c.$registerTextContentProvider(b,D);let v;return typeof l.onDidChange=="function"&&(v=l.onDidChange(f=>{if(f.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(b,f).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(f);if(!i)return;const r=(0,E.$Te)(t);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(f,t)},y.$Z)})),new P.$AK(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(D,l){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(T.URI.revive(l),$.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$_ec=d}),define(Pe[245],Ae([1,0,5,6,2,3,103,8,16,26,7,11]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class l{constructor(v,f){this.a=new y.$Rd({onListenerError:D.$1}),this.b=new y.$Rd({onListenerError:D.$1}),this.c=new y.$Rd({onListenerError:D.$1}),this.d=new y.$Rd({onListenerError:D.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=v.getProxy(M.$yK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(v){if(!v)return;const f=this.g.getDocument(v);if(f)return f}getDocument(v){const f=this.getDocumentData(v);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${v}'`);return f.document}ensureDocumentData(v){const f=this.g.getDocument(v);if(f)return Promise.resolve(f);let t=this.h.get(v.toString());return t||(t=this.f.$tryOpenDocument(v).then(i=>{this.h.delete(v.toString());const r=P.URI.revive(i);return(0,E.$Nf)(this.g.getDocument(r))},i=>(this.h.delete(v.toString()),Promise.reject(i))),this.h.set(v.toString(),t)),t}createDocumentData(v){return this.f.$tryCreateDocument(v).then(f=>P.URI.revive(f))}$acceptModelLanguageChanged(v,f){const t=P.URI.revive(v),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(f),this.a.fire(i.document)}$acceptModelSaved(v){const f=P.URI.revive(v),t=this.g.getDocument(f);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(v,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(v,f){const t=P.URI.revive(v),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(f),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(v,f,t){const i=P.URI.revive(v),r=this.g.getDocument(i);if(!r)throw new Error("unknown document");r._acceptIsDirty(t),r.onEvents(f);let c;f.isUndoing?c=I.TextDocumentChangeReason.Undo:f.isRedoing&&(c=I.TextDocumentChangeReason.Redo),this.c.fire((0,d.$bn)({document:r.document,contentChanges:f.changes.map(o=>({range:$.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:c}))}setWordDefinitionFor(v,f){(0,A.$CM)(v,f)}}e.$Zdc=l}),define(Pe[61],Ae([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,44]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=void 0;class i{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let r=class{constructor(o,h){this.h=o,this.i=h,this.a=null,this.b=new Map,this.c=new b.$zc,this.d=new T.$Rd,this.e=new T.$Rd,this.f=new T.$Rd,this.g=new T.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const h=[],n=[],s=[];if(o.removedDocuments)for(const a of o.removedDocuments){const g=M.URI.revive(a),p=this.c.get(g);p?.unref()&&(this.c.delete(g),h.push(p.value))}if(o.addedDocuments)for(const a of o.addedDocuments){const g=M.URI.revive(a.uri);let p=this.c.get(g);if(p&&g.scheme!==v.Schemas.vscodeNotebookCell&&g.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${g} already exists!'`);p||(p=new i(new E.$DM(this.h.getProxy($.$yK.MainThreadDocuments),g,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty,a.notebook)),this.c.set(g,p),n.push(p.value)),p.ref()}if(o.removedEditors)for(const a of o.removedEditors){const g=this.b.get(a);this.b.delete(a),g&&s.push(g)}if(o.addedEditors)for(const a of o.addedEditors){const g=M.URI.revive(a.documentUri);y.ok(this.c.has(g),`document '${g}' does not exist`),y.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const p=this.c.get(g).value,m=new I.$JM(a.id,this.h.getProxy($.$yK.MainThreadTextEditors),this.i,new t.$U(()=>p.document),a.selections.map(D.Selection.to),a.options,a.visibleRanges.map(k=>D.Range.to(k)),typeof a.editorPosition=="number"?D.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,m)}o.newActiveEditor!==void 0&&(y.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,P.$Mc)(h),(0,P.$Mc)(s),o.removedDocuments&&this.e.fire(h),o.addedDocuments&&this.d.fire(n),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return f.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const h=this.b.get(this.a);return o?h:h?.value}allEditors(){return[...this.b.values()]}};e.$KM=r,e.$KM=r=Ke([Ve(0,d.$AM),Ve(1,l.$dj)],r),e.$LM=(0,A.$Vh)("IExtHostDocumentsAndEditors")}),define(Pe[62],Ae([1,0,246,5,16,2,4,3,17,8,7]),function(we,e,y,T,P,M,A,$,E,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=e.$zec=void 0,e.$zec=(0,A.$Vh)("IExtHostEditorTabs");class D{constructor(t,i,r){this.e=r,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new I.$fM(M.URI.revive(this.b.input.uri));case 2:return new I.$gM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new I.$hM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new I.$iM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new I.$jM(this.b.input.viewType);case 4:return new I.$kM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new I.$lM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new I.$mM;case 9:return new I.$nM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new I.$oM(this.b.input.providerId);default:return}}}class l{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const r of t.tabs)r.isActive&&(this.d=r.id),this.c.push(new D(r,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return d.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(r=>r.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(r=>r.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const r=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,r),t.tabDto.isActive&&(this.d=r.tabId),r}else if(t.kind===1){const r=this.c.splice(t.index,1)[0];if(!r)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return r.tabId===this.d&&(this.d=""),r}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const r=this.c.splice(t.oldIndex,1)[0];if(!r)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,r),r}const i=this.c.find(r=>r.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new T.$Rd,this.c=new T.$Rd,this.e=[],this.a=t.getProxy($.$yK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(r=>r.apiObject))},get activeTabGroup(){const r=t.d;return(0,P.$Nf)(t.e.find(o=>o.groupId===r)?.apiObject)},close:async(r,c)=>{const o=Array.isArray(r)?r:[r];return o.length?v(o[0])?this.j(o,c):this.i(o,c):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(a=>a.groupId)),r=new Set(t.map(a=>a.groupId)),c=(0,y.$K)(i,r),o=this.e.filter(a=>c.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],n=[];this.e=t.map(a=>{const g=new l(a,()=>this.d);return c.added.includes(g.groupId)?h.push(g.apiObject):n.push(g.apiObject),g});const s=(0,P.$Nf)(t.find(a=>a.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:h,closed:o,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(r=>r.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const r=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[r.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[r.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[r.apiObject]}));return}}g(t){for(const i of this.e)for(const r of i.tabs)if(r.apiObject===t)return r}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const r=[];for(const c of t){const o=this.g(c);if(!o)throw new Error("Tab close: Invalid tab not found!");r.push(o.tabId)}return this.a.$closeTab(r,i)}async j(t,i){const r=[];for(const c of t){const o=this.h(c);if(!o)throw new Error("Group close: Invalid group not found!");r.push(o.groupId)}return this.a.$closeGroup(r,i)}};e.$Aec=b,e.$Aec=b=Ke([Ve(0,E.$AM)],b);function v(f){return f.tabs!==void 0}}),define(Pe[247],Ae([1,0,3,7]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$yK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,$,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const d=this.a.get(A);if(!d)throw new Error("Embedding vector provider not found");const I=await d.provideEmbeddingVector($,E);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(A,$,E){const d=this.b;return this.b++,this.a.set(d,E),this.c.$registerAiEmbeddingVectorProvider($,d),new T.$AK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(d),this.a.delete(d)})}}e.$bfc=P}),define(Pe[248],Ae([1,0,2,3,6,7,8,296,12,24,23,52]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;class l{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const t=this.a.indexOf(f);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),t=[];let i,r,c=14,o=14;for(const h of f){let n=i?(0,E.$8e)(i,h):0;for(n===0?r=1:r=o;n<h.length;n++)n+1===h.length?(c=o,o=9):o+=1,t.push([r,h.toUpperCase().charCodeAt(n),o]),t.push([r,h.toLowerCase().charCodeAt(n),o]),r=o;i=h,o=c}t.push([9,58,10]),t.push([10,47,12]),this.b=new $.$4Y(t)}}provideDocumentLinks(f){this.c();const t=[],i=$.$5Y.computeLinks({getLineContent(r){return f.lineAt(r-1).text},getLineCount(){return f.lineCount}},this.b);for(const r of i){const c=A.DocumentLink.to(r);c.target&&t.push(c)}return t}}class b{constructor(f,t){this.i=t,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(T.$yK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,t,i,r={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const c=this.h++;this.b.add(t),this.d.add(t),this.c.set(c,i);let o=2;r.isCaseSensitive&&(o+=1024),r.isReadonly&&(o+=2048),typeof i.copy=="function"&&(o+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,I.$MF)(f,"fsChunks"),o+=4);let h;r.isReadonly&&(0,D.$$j)(r.isReadonly)&&((0,I.$MF)(f,"readonlyMessage"),h={value:r.isReadonly.value,isTrusted:r.isReadonly.isTrusted,supportThemeIcons:r.isReadonly.supportThemeIcons,supportHtml:r.isReadonly.supportHtml,baseUri:r.isReadonly.baseUri,uris:r.isReadonly.uris}),this.a.$registerFileSystemProvider(c,t,o,h).catch(s=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${t}`),console.error(s)});const n=i.onDidChangeFile(s=>{const a=[];for(const g of s){const{uri:p,type:m}=g;if(p.scheme!==t)continue;let k;switch(m){case M.FileChangeType.Changed:k=0;break;case M.FileChangeType.Created:k=1;break;case M.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:p,type:k})}this.a.$onFileSystemChange(c,a)});return(0,P.$Pc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(c),this.a.$unregisterProvider(c)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:t,ctime:i,mtime:r,size:c,permissions:o}=f;return{type:t,ctime:i,mtime:r,size:c,permissions:o}}$stat(f,t){return Promise.resolve(this.l(f).stat(y.URI.revive(t))).then(i=>b.k(i))}$readdir(f,t){return Promise.resolve(this.l(f).readDirectory(y.URI.revive(t)))}$readFile(f,t){return Promise.resolve(this.l(f).readFile(y.URI.revive(t))).then(i=>d.$fe.wrap(i))}$writeFile(f,t,i,r){return Promise.resolve(this.l(f).writeFile(y.URI.revive(t),i.buffer,r))}$delete(f,t,i){return Promise.resolve(this.l(f).delete(y.URI.revive(t),i))}$rename(f,t,i,r){return Promise.resolve(this.l(f).rename(y.URI.revive(t),y.URI.revive(i),r))}$copy(f,t,i,r){const c=this.l(f);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(y.URI.revive(t),y.URI.revive(i),r))}$mkdir(f,t){return Promise.resolve(this.l(f).createDirectory(y.URI.revive(t)))}$watch(f,t,i,r){const c=this.l(f).watch(y.URI.revive(i),r);this.f.set(t,c)}$unwatch(f,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(f,t,i){const r=this.l(f);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(y.URI.revive(t),i))}$close(f,t){const i=this.l(f);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(f,t,i,r){const c=this.l(f);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const o=d.$fe.alloc(r);return Promise.resolve(c.read(t,i,o.buffer,0,r)).then(h=>o.slice(0,h))}$write(f,t,i,r){const c=this.l(f);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(t,i,r.buffer,0,r.byteLength))}l(f){const t=this.c.get(f);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$cfc=b}),define(Pe[63],Ae([1,0,3,41,7,24,4,17,42,6,14,25,13]),function(we,e,y,T,P,M,A,$,E,d,I,D,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=e.$oec=void 0;let v=b=class{constructor(t,i){this.b=new Map,this.c=new I.$7g,this.a=t.getProxy(y.$yK.MainThreadFileSystem);const r=this;this.value=Object.freeze({async stat(c){try{let o;const h=r.b.get(c.scheme);return h?(await r.a.$ensureActivation(c.scheme),o=await h.impl.stat(c)):o=await r.a.$stat(c),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===T.FilePermission.Readonly?1:void 0}}catch(o){b.e(o)}},async readDirectory(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readDirectory(c)).slice()):await r.a.$readdir(c)}catch(o){return b.e(o)}},async createDirectory(c){try{const o=r.b.get(c.scheme);return o&&!o.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(o.impl,o.extUri,c)):await r.a.$mkdir(c)}catch(o){return b.e(o)}},async readFile(c){try{const o=r.b.get(c.scheme);return o?(await r.a.$ensureActivation(c.scheme),(await o.impl.readFile(c)).slice()):(await r.a.$readFile(c)).buffer}catch(o){return b.e(o)}},async writeFile(c,o){try{const h=r.b.get(c.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(c.scheme),await r.d(h.impl,h.extUri,h.extUri.dirname(c)),await r.c.queueFor(c).queue(()=>Promise.resolve(h.impl.writeFile(c,o,{create:!0,overwrite:!0})))):await r.a.$writeFile(c,M.$fe.wrap(o))}catch(h){return b.e(h)}},async delete(c,o){try{const h=r.b.get(c.scheme);return h&&!h.isReadonly?(await r.a.$ensureActivation(c.scheme),await h.impl.delete(c,{recursive:!1,...o})):await r.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(h){return b.e(h)}},async rename(c,o,h){try{return await r.a.$rename(c,o,{overwrite:!1,...h})}catch(n){return b.e(n)}},async copy(c,o,h){try{return await r.a.$copy(c,o,{overwrite:!1,...h})}catch(n){return b.e(n)}},isWritableFileSystem(c){const o=i.getCapabilities(c);if(typeof o=="number")return!(o&2048)}})}async d(t,i,r){const c=[];for(;!i.isEqual(r,i.dirname(r));)try{if(!((await t.stat(r)).type&T.FileType.Directory))throw P.$NL.FileExists(`Unable to create folder '${r.scheme===l.Schemas.file?r.fsPath:r.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(T.$uk(o)!==T.FileSystemProviderErrorCode.FileNotFound)throw o;c.push(i.basename(r)),r=i.dirname(r)}for(let o=c.length-1;o>=0;o--){r=i.joinPath(r,c[o]);try{await t.createDirectory(r)}catch(h){if(T.$uk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(t){if(t instanceof P.$NL)throw t;if(t instanceof T.$qk)switch(t.code){case T.FileSystemProviderErrorCode.FileExists:throw P.$NL.FileExists(t.message);case T.FileSystemProviderErrorCode.FileNotFound:throw P.$NL.FileNotFound(t.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw P.$NL.FileNotADirectory(t.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw P.$NL.FileIsADirectory(t.message);case T.FileSystemProviderErrorCode.NoPermissions:throw P.$NL.NoPermissions(t.message);case T.FileSystemProviderErrorCode.Unavailable:throw P.$NL.Unavailable(t.message);default:throw new P.$NL(t.message,t.name)}if(!(t instanceof Error))throw new P.$NL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw P.$NL.Unavailable(t.message);switch(t.name){case T.FileSystemProviderErrorCode.FileExists:throw P.$NL.FileExists(t.message);case T.FileSystemProviderErrorCode.FileNotFound:throw P.$NL.FileNotFound(t.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw P.$NL.FileNotADirectory(t.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw P.$NL.FileIsADirectory(t.message);case T.FileSystemProviderErrorCode.NoPermissions:throw P.$NL.NoPermissions(t.message);case T.FileSystemProviderErrorCode.Unavailable:throw P.$NL.Unavailable(t.message);default:throw new P.$NL(t.message,t.name)}}addFileSystemProvider(t,i,r){return this.b.set(t,{impl:i,extUri:r?.isCaseSensitive?D.$pg:D.$rg,isReadonly:!!r?.isReadonly}),(0,d.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$pg}};e.$oec=v,e.$oec=v=b=Ke([Ve(0,$.$AM),Ve(1,E.$2dc)],v),e.$pec=(0,A.$Vh)("IExtHostConsumerFileSystem")}),define(Pe[249],Ae([1,0,5,34,2,3,8,7,44]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=void 0;class d{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,v,f,t,i,r){this.a=Math.random(),this.b=new y.$Rd,this.c=new y.$Rd,this.d=new y.$Rd,this.h=0,r?.ignoreCreateEvents&&(this.h+=1),r?.ignoreChangeEvents&&(this.h+=2),r?.ignoreDeleteEvents&&(this.h+=4);const c=(0,T.$Cj)(i),o=typeof i=="string",h=r?.correlate,n=t(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(h&&typeof s.session>"u")){if(!r?.ignoreCreateEvents)for(const a of s.created){const g=P.URI.revive(a);c(g.fsPath)&&(!o||v.getWorkspaceFolder(g))&&this.b.fire(g)}if(!r?.ignoreChangeEvents)for(const a of s.changed){const g=P.URI.revive(a);c(g.fsPath)&&(!o||v.getWorkspaceFolder(g))&&this.c.fire(g)}if(!r?.ignoreDeleteEvents)for(const a of s.deleted){const g=P.URI.revive(a);c(g.fsPath)&&(!o||v.getWorkspaceFolder(g))&&this.d.fire(g)}}});this.g=$.$AK.from(this.i(b,f,i,r,r?.correlate),this.b,this.c,this.d,n)}i(b,v,f,t,i){const r=$.$AK.from();if(typeof f=="string")return r;const c=b.getProxy(M.$yK.MainThreadFileSystemEventService);let o=!1;return(f.pattern.includes(T.$yj)||f.pattern.includes(T.$zj))&&(o=!0),c.$watch(v.identifier.value,this.a,f.baseUri,{recursive:o,excludes:t?.excludes??[]},!!i),$.$AK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class I{constructor(b){this.a=b,this.session=this.a.session,this.b=new E.$U(()=>this.a.created.map(P.URI.revive)),this.c=new E.$U(()=>this.a.changed.map(P.URI.revive)),this.d=new E.$U(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(b,v,f){this.j=b,this.k=v,this.l=f,this.a=new y.$Rd,this.b=new y.$Rd,this.c=new y.$Rd,this.d=new y.$Rd,this.g=new y.$Td,this.h=new y.$Td,this.i=new y.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,v,f,t){return new d(this.j,b,v,this.a.event,A.GlobPattern.from(f),t)}$onFileEvent(b){this.a.fire(new I(b))}$onDidRunFileOperation(b,v){switch(b){case 2:this.b.fire(Object.freeze({files:v.map(f=>({oldUri:P.URI.revive(f.source),newUri:P.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(f=>P.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(f=>P.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,v){return(f,t,i)=>{const r=function(o){f.call(t,o)};return r.extension=b,v.event(r,void 0,i)}}async $onWillRunFileOperation(b,v,f,t){switch(b){case 2:return await this.n(this.g,{files:v.map(i=>({oldUri:P.URI.revive(i.source),newUri:P.URI.revive(i.target)}))},f,t);case 1:return await this.n(this.i,{files:v.map(i=>P.URI.revive(i.target))},f,t);case 0:case 3:return await this.n(this.h,{files:v.map(i=>P.URI.revive(i.target))},f,t)}}async n(b,v,f,t){const i=new Set,r=[];if(await b.fireAsync(v,t,async(o,h)=>{const n=Date.now(),s=await Promise.resolve(o);s instanceof $.$KK&&(r.push([h.extension,s]),i.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-n>f&&this.k.warn("SLOW file-participant",h.extension.identifier)}),t.isCancellationRequested||r.length===0)return;const c={edits:[]};for(const[,o]of r){const{edits:h}=A.WorkspaceEdit.from(o,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(h)}return{edit:c,extensionNames:Array.from(i)}}}e.$dfc=D}),define(Pe[250],Ae([1,0,6,2,3,8,7,32,14]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class d{static{this.a=0}constructor(b,v){this.extension=b,this.provider=v,this.handle=d.a++}}class I{constructor(b){this.session=b,this.responses=[]}}class D{static{this.a=0}constructor(b,v,f,t){this.f=f,this.g=t,this.b=new Map,this.d=new Map,this.e=b.getProxy(P.$yK.MainThreadInlineChat),v.registerApiCommand(new $.$1M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$YM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?M.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?M.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?M.Position.from(i.position):void 0}})],$.$ZM.Void))}registerProvider(b,v,f){const t=new d(b,v);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,f?.label??b.displayName??b.name,b.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",f?.supportReportIssue??!1),(0,y.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(b,v,f,t){const i=this.b.get(b);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const r=this.f.getDocument(T.URI.revive(v)),c=M.Selection.to(f),o=await i.provider.prepareInteractiveEditorSession({document:r,selection:c},t);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=D.a++;return this.d.set(h,new I(o)),{id:h,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:M.Range.from(o.wholeRange),message:o.message}}async $provideResponse(b,v,f,t){const i=this.b.get(b);if(!i)return;const r=this.d.get(v.id);if(!r)return;const c={prompt:f.prompt,selection:M.Selection.to(f.selection),wholeRange:M.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let o=!1;const h={report:async p=>{if(!f.live&&p.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||t.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:p.message,edits:p.edits?.map(M.TextEdit.from),editsShouldBeInstant:p.editsShouldBeInstant,slashCommand:p.slashCommand?.command,markdownFragment:A.$1K.isMarkdownString(p.content)?p.content.value:p.content})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(r.session,c,h,t));let s;try{s=await(0,E.$Mg)(n,t)}finally{o=!0}if(!s)return;const a=r.responses.push(s)-1,g={wholeRange:M.Range.from(s.wholeRange),placeholder:s.placeholder};if(D.h(s)){const{edits:p,contents:m}=s,k=m!==void 0?M.MarkdownString.from(m):void 0;return p instanceof A.$KK?{...g,id:a,type:"bulkEdit",edits:M.WorkspaceEdit.from(p),message:k}:{...g,id:a,type:"editorEdit",edits:p.map(M.TextEdit.from),message:k}}return{...g,id:a,type:"message",message:M.MarkdownString.from(s.contents)}}$handleFeedback(b,v,f,t){const i=this.b.get(b),r=this.d.get(v),c=r?.responses[f];if(i&&c){const o=M.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(r.session,c,o)}}$releaseSession(b,v){}static h(b){return typeof b=="object"&&typeof b.edits=="object"}}e.$efc=D}),define(Pe[251],Ae([1,0,2,32]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class P{constructor(A,$,E,d,I){this.a=$,this.b=E,this.c=d;const D=new T.$1M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$YM("showOptions","Show Options",l=>!0,l=>l),new T.$YM("resource","Interactive resource Uri",l=>!0,l=>l),new T.$YM("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$YM("title","Interactive editor title",l=>!0,l=>l)],new T.$ZM("Notebook and input URI",l=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const b=this.a.getEditorById(l.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:y.URI.revive(l.notebookUri),inputUri:y.URI.revive(l.inputUri),notebookEditor:b.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:y.URI.revive(l.notebookUri),inputUri:y.URI.revive(l.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,$,E,d){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:$,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(d))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,$){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$rfc=P}),define(Pe[252],Ae([1,0,3,7]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class P{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(y.$yK.MainThreadIssueReporter)}async $getIssueReporterUri(A,$){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const d=await E.handleIssueUrlRequest();if(!d)throw new Error("Issue request handler returned no result");return d}async $getIssueReporterData(A,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const d=await E.provideIssueData($);if(!d)throw new Error("Issue data provider returned no result");return d}async $getIssueReporterTemplate(A,$){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const d=await E.provideIssueTemplate($);if(!d)throw new Error("Issue template provider returned no result");return d}registerIssueUriRequestHandler(A,$){const E=A.identifier.value;return this.a.set(E,$),this.c.$registerIssueUriRequestHandler(E),new T.$AK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(A,$){const E=A.identifier.value;return this.b.set(E,$),this.c.$registerIssueDataProvider(E),new T.$AK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$sfc=P}),define(Pe[253],Ae([1,0,6,3]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(T.$yK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const $=this.b++;return this.a.$registerResourceLabelFormatter($,A),(0,y.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter($)})}}e.$tfc=P}),define(Pe[254],Ae([1,0,2,26,8,7,80,3,12,29,18,16,297,19,22,6,95,89,75,60,11,14,23,160]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class a{constructor(z,W){this.d=z,this.e=W}async provideDocumentSymbols(z,W){const H=this.d.getDocument(z),G=await this.e.provideDocumentSymbols(H,W);if(!(0,I.$Jb)(G))return G[0]instanceof M.$SK?G.map(P.DocumentSymbol.from):a.f(G)}static f(z){z=z.slice(0).sort((G,q)=>{let x=G.location.range.start.compareTo(q.location.range.start);return x===0&&(x=q.location.range.end.compareTo(G.location.range.end)),x});const W=[],H=[];for(const G of z){const q={name:G.name||"!!MISSING: name!!",kind:P.SymbolKind.from(G.kind),tags:G.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:P.Range.from(G.location.range),selectionRange:P.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(q),W.push(q);break}const x=H[H.length-1];if(d.$zs.containsRange(x.range,q.range)&&!d.$zs.equalsRange(x.range,q.range)){x.children?.push(q),H.push(q);break}H.pop()}}return W}}class g{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(z,W,H){this.g=z,this.h=W,this.j=H,this.e=new r.$Xdc("CodeLens"),this.f=new Map}async provideCodeLenses(z,W){const H=this.g.getDocument(z),G=await this.j.provideCodeLenses(H,W);if(!G||W.isCancellationRequested)return;const q=this.e.add(G),x=new f.$Qc;this.f.set(q,x);const ue={cacheId:q,lenses:[]};for(let Oe=0;Oe<G.length;Oe++)ue.lenses.push({cacheId:[q,Oe],range:P.Range.from(G[Oe].range),command:this.h.toInternal(G[Oe].command,x)});return ue}async resolveCodeLens(z,W){const H=z.cacheId&&this.e.get(...z.cacheId);if(!H)return;let G;if(typeof this.j.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.j.resolveCodeLens(H,W),G||(G=H),W.isCancellationRequested)return;const q=z.cacheId&&this.f.get(z.cacheId[0]);if(q)return z.command=this.h.toInternal(G.command??g.d,q),z}releaseCodeLenses(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}}function p(Ie){return Array.isArray(Ie)?Ie.map(P.DefinitionLink.from):Ie?[P.DefinitionLink.from(Ie)]:[]}class m{constructor(z,W){this.d=z,this.e=W}async provideDefinition(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideDefinition(G,q,H);return p(x)}}class k{constructor(z,W){this.d=z,this.e=W}async provideDeclaration(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideDeclaration(G,q,H);return p(x)}}class C{constructor(z,W){this.d=z,this.e=W}async provideImplementation(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideImplementation(G,q,H);return p(x)}}class u{constructor(z,W){this.d=z,this.e=W}async provideTypeDefinition(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideTypeDefinition(G,q,H);return p(x)}}class w{constructor(z,W){this.d=z,this.e=W}async provideHover(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideHover(G,q,H);if(!(!x||(0,I.$Jb)(x.contents)))return x.range||(x.range=G.getWordRangeAtPosition(q)),x.range||(x.range=new M.$CK(q,q)),P.Hover.from(x)}}class S{constructor(z,W){this.d=z,this.e=W}async provideEvaluatableExpression(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideEvaluatableExpression(G,q,H);if(x)return P.EvaluatableExpression.from(x)}}class F{constructor(z,W){this.d=z,this.e=W}async provideInlineValues(z,W,H,G){const q=this.d.getDocument(z),x=await this.e.provideInlineValues(q,P.Range.to(W),P.InlineValueContext.to(H),G);if(Array.isArray(x))return x.map(ue=>P.InlineValue.from(ue))}}class V{constructor(z,W){this.d=z,this.e=W}async provideDocumentHighlights(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideDocumentHighlights(G,q,H);if(Array.isArray(x))return x.map(P.DocumentHighlight.from)}}class J{constructor(z,W){this.d=z,this.e=W}async provideLinkedEditingRanges(z,W,H){const G=this.d.getDocument(z),q=P.Position.to(W),x=await this.e.provideLinkedEditingRanges(G,q,H);if(x&&Array.isArray(x.ranges))return{ranges:(0,I.$Gb)(x.ranges.map(P.Range.from)),wordPattern:x.wordPattern}}}class N{constructor(z,W){this.d=z,this.e=W}async provideReferences(z,W,H,G){const q=this.d.getDocument(z),x=P.Position.to(W),ue=await this.e.provideReferences(q,x,H,G);if(Array.isArray(ue))return ue.map(P.location.from)}}class R{static{this.d=1e3}constructor(z,W,H,G,q,x,ue){this.g=z,this.h=W,this.j=H,this.k=G,this.l=q,this.m=x,this.n=ue,this.e=new r.$Xdc("CodeAction"),this.f=new Map}async provideCodeActions(z,W,H,G){const q=this.g.getDocument(z),x=l.$Bs.isISelection(W)?P.Selection.to(W):P.Range.to(W),ue=[];for(const _e of this.j.getDiagnostics(z))if(x.intersection(_e.range)&&ue.push(_e)>R.d)break;const Oe={diagnostics:ue,only:H.only?new M.$UK(H.only):void 0,triggerKind:P.CodeActionTriggerKind.to(H.trigger)},Ue=await this.k.provideCodeActions(q,x,Oe,G);if(!(0,I.$Kb)(Ue)||G.isCancellationRequested)return;const Ze=this.e.add(Ue),Je=new f.$Qc;this.f.set(Ze,Je);const tt=[];for(let _e=0;_e<Ue.length;_e++){const et=Ue[_e];et&&(R.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Je)})):(Oe.only&&(et.kind?Oe.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Oe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ze,_e],title:et.title,command:et.command&&this.h.toInternal(et.command,Je),diagnostics:et.diagnostics&&et.diagnostics.map(P.Diagnostic.from),edit:et.edit&&P.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,n.$LF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:Ze,actions:tt}}async resolveCodeAction(z,W){const[H,G]=z,q=this.e.get(H,G);if(!q||R.o(q))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(q,W)??q;let ue;x.edit&&(ue=P.WorkspaceEdit.from(x.edit,void 0));let Oe;if(x.command){const Ue=this.f.get(H);Ue&&(Oe=this.h.toInternal(x.command,Ue))}return{edit:ue,command:Oe}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class L{static toInternalProviderId(z,W){return z+"."+W}constructor(z,W,H,G,q){this.d=z,this.e=W,this.f=H,this.g=G,this.h=q}async prepareDocumentPaste(z,W,H,G){if(!this.f.prepareDocumentPaste)return;const q=this.e.getDocument(z),x=W.map(Ue=>P.Range.to(Ue)),ue=P.DataTransfer.toDataTransfer(H,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(q,x,ue,G),G.isCancellationRequested)return;const Oe=Array.from(ue).filter(([,Ue])=>!(Ue instanceof M.$oL));return P.DataTransfer.from(Oe)}async providePasteEdits(z,W,H,G,q){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(W),ue=H.map(Ze=>P.Range.to(Ze)),Oe=P.DataTransfer.toDataTransfer(G,async Ze=>(await this.d.$resolvePasteFileData(this.g,z,Ze)).buffer),Ue=await this.f.provideDocumentPasteEdits(x,ue,Oe,q);if(Ue)return{label:Ue.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:L.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?P.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class O{constructor(z,W){this.d=z,this.e=W}async provideDocumentFormattingEdits(z,W,H){const G=this.d.getDocument(z),q=await this.e.provideDocumentFormattingEdits(G,W,H);if(Array.isArray(q))return q.map(P.TextEdit.from)}}class Z{constructor(z,W){this.d=z,this.e=W}async provideDocumentRangeFormattingEdits(z,W,H,G){const q=this.d.getDocument(z),x=P.Range.to(W),ue=await this.e.provideDocumentRangeFormattingEdits(q,x,H,G);if(Array.isArray(ue))return ue.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,W,H,G){(0,D.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const q=this.d.getDocument(z),x=W.map(P.Range.to),ue=await this.e.provideDocumentRangesFormattingEdits(q,x,H,G);if(Array.isArray(ue))return ue.map(P.TextEdit.from)}}class he{constructor(z,W){this.d=z,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,W,H,G,q){const x=this.d.getDocument(z),ue=P.Position.to(W),Oe=await this.e.provideOnTypeFormattingEdits(x,ue,H,G,q);if(Array.isArray(Oe))return Oe.map(P.TextEdit.from)}}class $e{constructor(z,W){this.e=z,this.f=W,this.d=new r.$Xdc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,W){const H=await this.e.provideWorkspaceSymbols(z,W);if(!(0,I.$Kb)(H))return{symbols:[]};const G=this.d.add(H),q={cacheId:G,symbols:[]};for(let x=0;x<H.length;x++){const ue=H[x];if(!ue||!ue.name){this.f.warn("INVALID SymbolInformation",ue);continue}q.symbols.push({...P.WorkspaceSymbol.from(ue),cacheId:[G,x]})}return q}async resolveWorkspaceSymbol(z,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const H=this.d.get(...z.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,W);return G&&(0,T.$dn)(z,P.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class De{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,W,H){this.d=z,this.e=W,this.f=H}async provideRenameEdits(z,W,H,G){const q=this.d.getDocument(z),x=P.Position.to(W);try{const ue=await this.e.provideRenameEdits(q,x,H,G);return ue?P.WorkspaceEdit.from(ue):void 0}catch(ue){const Oe=De.g(ue);return Oe?{rejectReason:Oe,edits:void 0}:Promise.reject(ue)}}async resolveRenameLocation(z,W,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(z),q=P.Position.to(W);try{const x=await this.e.prepareRename(G,q,H);let ue,Oe;if(M.$CK.isRange(x)?(ue=x,Oe=G.getText(x)):(0,D.$Ef)(x)&&(ue=x.range,Oe=x.placeholder),!ue||!Oe)return;if(ue.start.line>q.line||ue.end.line<q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(ue),text:Oe}}catch(x){const ue=De.g(x);return ue?{rejectReason:ue,range:void 0,text:void 0}:Promise.reject(x)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ke{constructor(z,W){this.resultId=z,this.tokens=W}}class fe{constructor(z,W){this.f=z,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,W,H){const G=this.f.getDocument(z),q=W!==0?this.d.get(W):null;let x=typeof q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,q.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return q&&this.d.delete(W),x?(x=fe.h(x),this.o(fe.n(q,x),x)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return fe.j(z)?fe.k(z)?z:new M.$RL(new Uint32Array(z.data),z.resultId):fe.l(z)?fe.m(z)?z:new M.$TL(z.edits.map(W=>new M.$SL(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const W of z.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(z,W){if(!fe.j(W)||!z||!z.tokens)return W;const H=z.tokens,G=H.length,q=W.data,x=q.length;let ue=0;const Oe=Math.min(G,x);for(;ue<Oe&&H[ue]===q[ue];)ue++;if(ue===G&&ue===x)return new M.$TL([],W.resultId);let Ue=0;const Ze=Oe-ue;for(;Ue<Ze&&H[G-Ue-1]===q[x-Ue-1];)Ue++;return new M.$TL([{start:ue,deleteCount:G-ue-Ue,data:q.subarray(ue,x-Ue)}],W.resultId)}o(z,W){if(fe.j(z)){const H=this.e++;return this.d.set(H,new ke(z.resultId,z.data)),(0,t.$20)({id:H,type:"full",data:z.data})}if(fe.l(z)){const H=this.e++;return fe.j(W)?this.d.set(H,new ke(W.resultId,W.data)):this.d.set(H,new ke(z.resultId)),(0,t.$20)({id:H,type:"delta",deltas:(z.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class ve{constructor(z,W){this.d=z,this.e=W}async provideDocumentRangeSemanticTokens(z,W,H){const G=this.d.getDocument(z),q=await this.e.provideDocumentRangeSemanticTokens(G,P.Range.to(W),H);return q?this.f(q):null}f(z){return(0,t.$20)({id:0,type:"full",data:z.data})}}class te{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,W,H,G,q){this.f=z,this.g=W,this.h=H,this.j=G,this.k=q,this.d=new r.$Xdc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,W,H,G){const q=this.f.getDocument(z),x=P.Position.to(W),ue=q.getWordRangeAtPosition(x)||new M.$CK(x,x),Oe=ue.with({end:x}),Ue=new c.$Nd,Ze=await this.h.provideCompletionItems(q,x,G,P.CompletionContext.to(H));if(!Ze||G.isCancellationRequested)return;const Je=Array.isArray(Ze)?new M.$8K(Ze):Ze,tt=te.supportsResolving(this.h)?this.d.add(Je.items):this.d.add([]),_e=new f.$Qc;this.e.set(tt,_e);const et=[],rt={x:tt,b:et,a:{replace:P.Range.from(ue),insert:P.Range.from(Oe)},c:Je.isIncomplete||void 0,d:Ue.elapsed()};for(let nt=0;nt<Je.items.length;nt++){const ze=Je.items[nt],dt=this.l(ze,[tt,nt],Oe,ue);et.push(dt)}return rt}async resolveCompletionItem(z,W){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...z);if(!H)return;const G=this.l(H,z),q=await this.h.resolveCompletionItem(H,W);if(!q)return;const x=this.l(q,z);return(G.h!==x.h||G.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==x.n||G.o!==x.o||!(0,T.$en)(G.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,W,H,G){const q=this.e.get(W[0]);if(!q)throw Error("DisposableStore is missing...");const x=this.g.toInternal(z.command,q),ue={x:W,a:z.label,b:z.kind!==void 0?P.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(P.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:P.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(P.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=z.textEdit.newText):typeof z.insertText=="string"?ue.h=z.insertText:z.insertText instanceof M.$LK&&(ue.h=z.insertText.value,ue.i|=4);let Oe;return z.textEdit?Oe=z.textEdit.range:z.range&&(Oe=z.range),M.$CK.isRange(Oe)?ue.j=P.Range.from(Oe):Oe&&(!H?.isEqual(Oe.inserting)||!G?.isEqual(Oe.replacing))&&(ue.j={insert:P.Range.from(Oe.inserting),replace:P.Range.from(Oe.replacing)}),ue}}class Re{async provideInlineCompletions(z,W,H,G){}disposeCompletions(z){}handleDidShowCompletionItem(z,W,H){}handlePartialAccept(z,W,H){}}class se extends Re{constructor(z,W,H,G){super(),this.f=z,this.g=W,this.h=H,this.j=G,this.d=new Y,this.e=(0,n.$LF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$LF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,W,H,G){const q=this.g.getDocument(z),x=P.Position.to(W),ue=await this.h.provideInlineCompletionItems(q,x,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:P.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!ue||G.isCancellationRequested)return;const Oe=Array.isArray(ue)?ue:ue.items,Ue=this.e?Array.isArray(ue)?[]:ue.commands||[]:[],Ze=this.e&&!Array.isArray(ue)?ue.enableForwardStability:void 0;let Je;return{pid:this.d.createReferenceId({dispose(){Je?.dispose()},items:Oe}),items:Oe.map((_e,et)=>{let rt;_e.command&&(Je||(Je=new f.$Qc),rt=this.j.toInternal(_e.command,Je));const nt=_e.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:_e.filterText,range:_e.range?P.Range.from(_e.range):void 0,command:rt,idx:et,completeBracketPairs:this.e?_e.completeBracketPairs:!1}}),commands:Ue.map(_e=>(Je||(Je=new f.$Qc),this.j.toInternal(_e,Je))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,W,H){const G=this.d.get(z)?.items[W];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(z,W,H){const G=this.d.get(z)?.items[W];G&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(G,H)}}class Y{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const W=this.e++;return this.d.set(W,z),W}disposeReferenceId(z){const W=this.d.get(z);return this.d.delete(z),W}get(z){return this.d.get(z)}}class B{constructor(z,W){this.e=z,this.f=W,this.d=new r.$Xdc("SignatureHelp")}async provideSignatureHelp(z,W,H,G){const q=this.e.getDocument(z),x=P.Position.to(W),ue=this.g(H),Oe=await this.f.provideSignatureHelp(q,x,G,ue);if(Oe){const Ue=this.d.add([Oe]);return{...P.SignatureHelp.from(Oe),id:Ue}}}g(z){let W;if(z.activeSignatureHelp){const H=P.SignatureHelp.to(z.activeSignatureHelp),G=this.d.get(z.activeSignatureHelp.id,0);G?(W=G,W.activeSignature=H.activeSignature,W.activeParameter=H.activeParameter):W=H}return{...z,activeSignatureHelp:W}}releaseSignatureHelp(z){this.d.delete(z)}}class ne{constructor(z,W,H,G,q){this.f=z,this.g=W,this.h=H,this.j=G,this.k=q,this.d=new r.$Xdc("InlayHints"),this.e=new Map}async provideInlayHints(z,W,H){const G=this.f.getDocument(z),q=P.Range.to(W),x=await this.h.provideInlayHints(G,q,H);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(H.isCancellationRequested)return;const ue=this.d.add(x);this.e.set(ue,new f.$Qc);const Oe={hints:[],cacheId:ue};for(let Ue=0;Ue<x.length;Ue++)this.l(x[Ue],q)&&Oe.hints.push(this.m(x[Ue],[ue,Ue]));return this.j.trace(`[InlayHints] ${Oe.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),Oe}async resolveInlayHint(z,W){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...z);if(!H)return;const G=await this.h.resolveInlayHint(H,W);if(G&&this.l(G))return this.m(G,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,W){return z.label.length===0||Array.isArray(z.label)&&z.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(W&&!W.contains(z.position))}m(z,W){const H=this.e.get(W[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:W,tooltip:P.MarkdownString.fromStrict(z.tooltip),position:P.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(P.TextEdit.from),kind:z.kind&&P.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};return typeof z.label=="string"?G.label=z.label:G.label=z.label.map(q=>{const x={label:q.value};return x.tooltip=P.MarkdownString.fromStrict(q.tooltip),M.$MK.isLocation(q.location)&&(x.location=P.location.from(q.location)),q.command&&(x.command=this.g.toInternal(q.command,H)),x}),G}}class pe{constructor(z,W){this.e=z,this.f=W,this.d=new r.$Xdc("DocumentLink")}async provideLinks(z,W){const H=this.e.getDocument(z),G=await this.f.provideDocumentLinks(H,W);if(!(!Array.isArray(G)||G.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(pe.g).map(P.DocumentLink.from)};{const q=this.d.add(G),x={links:[],cacheId:q};for(let ue=0;ue<G.length;ue++){if(!pe.g(G[ue]))continue;const Oe=P.DocumentLink.from(G[ue]);Oe.cacheId=[q,ue],x.links.push(Oe)}return x}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,W){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...z);if(!H)return;const G=await this.f.resolveDocumentLink(H,W);if(!(!G||!pe.g(G)))return P.DocumentLink.from(G)}releaseLinks(z){this.d.delete(z)}}class re{constructor(z,W){this.d=z,this.e=W}async provideColors(z,W){const H=this.d.getDocument(z),G=await this.e.provideDocumentColors(H,W);return Array.isArray(G)?G.map(x=>({color:P.Color.from(x.color),range:P.Range.from(x.range)})):[]}async provideColorPresentations(z,W,H){const G=this.d.getDocument(z),q=P.Range.to(W.range),x=P.Color.to(W.color),ue=await this.e.provideColorPresentations(x,{document:G,range:q},H);if(Array.isArray(ue))return ue.map(P.ColorPresentation.from)}}class le{constructor(z,W){this.d=z,this.e=W}async provideFoldingRanges(z,W,H){const G=this.d.getDocument(z),q=await this.e.provideFoldingRanges(G,W,H);if(Array.isArray(q))return q.map(P.FoldingRange.from)}}class ce{constructor(z,W,H){this.d=z,this.e=W,this.f=H}async provideSelectionRanges(z,W,H){const G=this.d.getDocument(z),q=W.map(P.Position.to),x=await this.e.provideSelectionRanges(G,q,H);if(!(0,I.$Kb)(x))return[];if(x.length!==q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ue=[];for(let Oe=0;Oe<q.length;Oe++){const Ue=[];ue.push(Ue);let Ze=q[Oe],Je=x[Oe];for(;;){if(!Je.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(P.SelectionRange.from(Je)),!Je.parent)break;Ze=Je.range,Je=Je.parent}}return ue}}class ye{constructor(z,W){this.f=z,this.g=W,this.d=new i.$FM(""),this.e=new Map}async prepareSession(z,W,H){const G=this.f.getDocument(z),q=P.Position.to(W),x=await this.g.prepareCallHierarchy(G,q,H);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Oe=>this.h(ue,Oe)):[this.h(ue,x)]}async provideCallsTo(z,W,H){const G=this.j(z,W);if(!G)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyIncomingCalls(G,H);if(q)return q.map(x=>({from:this.h(z,x.from),fromRanges:x.fromRanges.map(ue=>P.Range.from(ue))}))}async provideCallsFrom(z,W,H){const G=this.j(z,W);if(!G)throw new Error("missing call hierarchy item");const q=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(q)return q.map(x=>({to:this.h(z,x.to),fromRanges:x.fromRanges.map(ue=>P.Range.from(ue))}))}releaseSession(z){this.e.delete(z)}h(z,W){const H=this.e.get(z),G=P.CallHierarchyItem.from(W,z,H.size.toString(36));return H.set(G._itemId,W),G}j(z,W){return this.e.get(z)?.get(W)}}class _{constructor(z,W){this.f=z,this.g=W,this.d=new i.$FM(""),this.e=new Map}async prepareSession(z,W,H){const G=this.f.getDocument(z),q=P.Position.to(W),x=await this.g.prepareTypeHierarchy(G,q,H);if(!x)return;const ue=this.d.nextId();return this.e.set(ue,new Map),Array.isArray(x)?x.map(Oe=>this.h(ue,Oe)):[this.h(ue,x)]}async provideSupertypes(z,W,H){const G=this.j(z,W);if(!G)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySupertypes(G,H);if(q)return q.map(x=>this.h(z,x))}async provideSubtypes(z,W,H){const G=this.j(z,W);if(!G)throw new Error("missing type hierarchy item");const q=await this.g.provideTypeHierarchySubtypes(G,H);if(q)return q.map(x=>this.h(z,x))}releaseSession(z){this.e.delete(z)}h(z,W){const H=this.e.get(z),G=P.TypeHierarchyItem.from(W,z,H.size.toString(36));return H.set(G._itemId,W),G}j(z,W){return this.e.get(z)?.get(W)}}class de{static toInternalProviderId(z,W){return z+"."+W}constructor(z,W,H,G,q){this.d=z,this.e=W,this.f=H,this.g=G,this.h=q}async provideDocumentOnDropEdits(z,W,H,G,q){const x=this.e.getDocument(W),ue=P.Position.to(H),Oe=P.DataTransfer.toDataTransfer(G,async Ze=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,Ze)).buffer),Ue=await this.f.provideDocumentDropEdits(x,ue,Oe,q);if(Ue)return{label:Ue.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:de.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?P.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class ie{constructor(z,W){this.d=z,this.e=W}async provideMappedEdits(z,W,H,G){const q=y.URI.revive(z),x=this.d.getDocument(q),ue=H.documents.map(Ze=>Ze.map(Je=>({uri:y.URI.revive(Je.uri),version:Je.version,ranges:Je.ranges.map(tt=>P.Range.to(tt))}))),Oe={documents:ue,selections:ue[0]?.[0]?.ranges??[]},Ue=await this.e.provideMappedEdits(x,W,Oe,G);return Ue?P.WorkspaceEdit.from(Ue):null}}class ae{constructor(z,W){this.adapter=z,this.extension=W}}class me{static{this.d=0}constructor(z,W,H,G,q,x,ue,Oe){this.g=W,this.h=H,this.j=G,this.k=q,this.l=x,this.m=ue,this.n=Oe,this.f=new Map,this.e=z.getProxy($.$yK.MainThreadLanguageFeatures)}o(z,W){return P.DocumentSelector.from(z,this.g,W)}p(z){return new M.$AK(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return me.d++}async s(z,W,H,G,q,x=!1){const ue=this.f.get(z);if(!ue||!(ue.adapter instanceof W))return G;const Oe=Date.now();x||this.l.trace(`[${ue.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ue=H(ue.adapter,ue.extension);return Promise.resolve(Ue).catch(Ze=>{(0,o.$3)(Ze)||(this.l.error(`[${ue.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(ue.extension.identifier,Ze))}).finally(()=>{x||this.l.trace(`[${ue.extension.identifier.value}] provider DONE after ${Date.now()-Oe}ms`)}),b.CancellationToken.isCancellationToken(q)?(0,h.$Ng)(Ue,q):Ue}t(z,W){const H=this.q();return this.f.set(H,new ae(z,W)),H}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,W,H,G){const q=this.t(new a(this.h,H),z),x=G&&G.label||me.u(z);return this.e.$registerDocumentSymbolProvider(q,this.o(W,z),x),this.p(q)}$provideDocumentSymbols(z,W,H){return this.s(z,a,G=>G.provideDocumentSymbols(y.URI.revive(W),H),void 0,H)}registerCodeLensProvider(z,W,H){const G=this.q(),q=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new ae(new g(this.h,this.j.converter,H),z)),this.e.$registerCodeLensSupport(G,this.o(W,z),q);let x=this.p(G);if(q!==void 0){const ue=H.onDidChangeCodeLenses(Oe=>this.e.$emitCodeLensEvent(q));x=M.$AK.from(x,ue)}return x}$provideCodeLenses(z,W,H){return this.s(z,g,G=>G.provideCodeLenses(y.URI.revive(W),H),void 0,H)}$resolveCodeLens(z,W,H){return this.s(z,g,G=>G.resolveCodeLens(W,H),void 0,void 0)}$releaseCodeLenses(z,W){this.s(z,g,H=>Promise.resolve(H.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(z,W,H){const G=this.t(new m(this.h,H),z);return this.e.$registerDefinitionSupport(G,this.o(W,z)),this.p(G)}$provideDefinition(z,W,H,G){return this.s(z,m,q=>q.provideDefinition(y.URI.revive(W),H,G),[],G)}registerDeclarationProvider(z,W,H){const G=this.t(new k(this.h,H),z);return this.e.$registerDeclarationSupport(G,this.o(W,z)),this.p(G)}$provideDeclaration(z,W,H,G){return this.s(z,k,q=>q.provideDeclaration(y.URI.revive(W),H,G),[],G)}registerImplementationProvider(z,W,H){const G=this.t(new C(this.h,H),z);return this.e.$registerImplementationSupport(G,this.o(W,z)),this.p(G)}$provideImplementation(z,W,H,G){return this.s(z,C,q=>q.provideImplementation(y.URI.revive(W),H,G),[],G)}registerTypeDefinitionProvider(z,W,H){const G=this.t(new u(this.h,H),z);return this.e.$registerTypeDefinitionSupport(G,this.o(W,z)),this.p(G)}$provideTypeDefinition(z,W,H,G){return this.s(z,u,q=>q.provideTypeDefinition(y.URI.revive(W),H,G),[],G)}registerHoverProvider(z,W,H,G){const q=this.t(new w(this.h,H),z);return this.e.$registerHoverProvider(q,this.o(W,z)),this.p(q)}$provideHover(z,W,H,G){return this.s(z,w,q=>q.provideHover(y.URI.revive(W),H,G),void 0,G)}registerEvaluatableExpressionProvider(z,W,H,G){const q=this.t(new S(this.h,H),z);return this.e.$registerEvaluatableExpressionProvider(q,this.o(W,z)),this.p(q)}$provideEvaluatableExpression(z,W,H,G){return this.s(z,S,q=>q.provideEvaluatableExpression(y.URI.revive(W),H,G),void 0,G)}registerInlineValuesProvider(z,W,H,G){const q=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new F(this.h,H),z);this.e.$registerInlineValuesProvider(x,this.o(W,z),q);let ue=this.p(x);if(q!==void 0){const Oe=H.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(q));ue=M.$AK.from(ue,Oe)}return ue}$provideInlineValues(z,W,H,G,q){return this.s(z,F,x=>x.provideInlineValues(y.URI.revive(W),H,G,q),void 0,q)}registerDocumentHighlightProvider(z,W,H){const G=this.t(new V(this.h,H),z);return this.e.$registerDocumentHighlightProvider(G,this.o(W,z)),this.p(G)}$provideDocumentHighlights(z,W,H,G){return this.s(z,V,q=>q.provideDocumentHighlights(y.URI.revive(W),H,G),void 0,G)}registerLinkedEditingRangeProvider(z,W,H){const G=this.t(new J(this.h,H),z);return this.e.$registerLinkedEditingRangeProvider(G,this.o(W,z)),this.p(G)}$provideLinkedEditingRanges(z,W,H,G){return this.s(z,J,async q=>{const x=await q.provideLinkedEditingRanges(y.URI.revive(W),H,G);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?me.w(x.wordPattern):void 0}},void 0,G)}registerReferenceProvider(z,W,H){const G=this.t(new N(this.h,H),z);return this.e.$registerReferenceSupport(G,this.o(W,z)),this.p(G)}$provideReferences(z,W,H,G,q){return this.s(z,N,x=>x.provideReferences(y.URI.revive(W),H,G,q),void 0,q)}registerCodeActionProvider(z,W,H,G){const q=new f.$Qc,x=this.t(new R(this.h,this.j.converter,this.k,H,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(x,this.o(W,z),{providedKinds:G?.providedCodeActionKinds?.map(ue=>ue.value),documentation:G?.documentation?.map(ue=>({kind:ue.kind.value,command:this.j.converter.toInternal(ue.command,q)}))},me.u(z),!!H.resolveCodeAction),q.add(this.p(x)),q}$provideCodeActions(z,W,H,G,q){return this.s(z,R,x=>x.provideCodeActions(y.URI.revive(W),H,G,q),void 0,q)}$resolveCodeAction(z,W,H){return this.s(z,R,G=>G.resolveCodeAction(W,H),{},void 0)}$releaseCodeActions(z,W){this.s(z,R,H=>Promise.resolve(H.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(z,W,H){const G=this.t(new O(this.h,H),z);return this.e.$registerDocumentFormattingSupport(G,this.o(W,z),z.identifier,z.displayName||z.name),this.p(G)}$provideDocumentFormattingEdits(z,W,H,G){return this.s(z,O,q=>q.provideDocumentFormattingEdits(y.URI.revive(W),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(z,W,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",q=this.t(new Z(this.h,H),z);return this.e.$registerRangeFormattingSupport(q,this.o(W,z),z.identifier,z.displayName||z.name,G),this.p(q)}$provideDocumentRangeFormattingEdits(z,W,H,G,q){return this.s(z,Z,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(W),H,G,q),void 0,q)}$provideDocumentRangesFormattingEdits(z,W,H,G,q){return this.s(z,Z,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(W),H,G,q),void 0,q)}registerOnTypeFormattingEditProvider(z,W,H,G){const q=this.t(new he(this.h,H),z);return this.e.$registerOnTypeFormattingSupport(q,this.o(W,z),G,z.identifier),this.p(q)}$provideOnTypeFormattingEdits(z,W,H,G,q,x){return this.s(z,he,ue=>ue.provideOnTypeFormattingEdits(y.URI.revive(W),H,G,q,x),void 0,x)}registerWorkspaceSymbolProvider(z,W){const H=this.t(new $e(W,this.l),z);return this.e.$registerNavigateTypeSupport(H,typeof W.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(z,W,H){return this.s(z,$e,G=>G.provideWorkspaceSymbols(W,H),{symbols:[]},H)}$resolveWorkspaceSymbol(z,W,H){return this.s(z,$e,G=>G.resolveWorkspaceSymbol(W,H),void 0,void 0)}$releaseWorkspaceSymbols(z,W){this.s(z,$e,H=>H.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(z,W,H){const G=this.t(new De(this.h,H,this.l),z);return this.e.$registerRenameSupport(G,this.o(W,z),De.supportsResolving(H)),this.p(G)}$provideRenameEdits(z,W,H,G,q){return this.s(z,De,x=>x.provideRenameEdits(y.URI.revive(W),H,G,q),void 0,q)}$resolveRenameLocation(z,W,H,G){return this.s(z,De,q=>q.resolveRenameLocation(y.URI.revive(W),H,G),void 0,G)}registerDocumentSemanticTokensProvider(z,W,H,G){const q=this.t(new fe(this.h,H),z),x=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(q,this.o(W,z),G,x);let ue=this.p(q);if(x){const Oe=H.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(x));ue=M.$AK.from(ue,Oe)}return ue}$provideDocumentSemanticTokens(z,W,H,G){return this.s(z,fe,q=>q.provideDocumentSemanticTokens(y.URI.revive(W),H,G),null,G)}$releaseDocumentSemanticTokens(z,W){this.s(z,fe,H=>H.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,W,H,G){const q=this.t(new ve(this.h,H),z);return this.e.$registerDocumentRangeSemanticTokensProvider(q,this.o(W,z),G),this.p(q)}$provideDocumentRangeSemanticTokens(z,W,H,G){return this.s(z,ve,q=>q.provideDocumentRangeSemanticTokens(y.URI.revive(W),H,G),null,G)}registerCompletionItemProvider(z,W,H,G){const q=this.t(new te(this.h,this.j.converter,H,this.m,z),z);return this.e.$registerCompletionsProvider(q,this.o(W,z),G,te.supportsResolving(H),z.identifier),this.p(q)}$provideCompletionItems(z,W,H,G,q){return this.s(z,te,x=>x.provideCompletionItems(y.URI.revive(W),H,G,q),void 0,q)}$resolveCompletionItem(z,W,H){return this.s(z,te,G=>G.resolveCompletionItem(W,H),void 0,H)}$releaseCompletionItems(z,W){this.s(z,te,H=>H.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(z,W,H,G){const q=new se(z,this.h,H,this.j.converter),x=this.t(q,z);return this.e.$registerInlineCompletionsSupport(x,this.o(W,z),q.supportsHandleEvents,v.$_l.toKey(z.identifier.value),G?.yieldTo?.map(ue=>v.$_l.toKey(ue))||[]),this.p(x)}$provideInlineCompletions(z,W,H,G,q){return this.s(z,Re,x=>x.provideInlineCompletions(y.URI.revive(W),H,G,q),void 0,q)}$handleInlineCompletionDidShow(z,W,H,G){this.s(z,Re,async q=>{q.handleDidShowCompletionItem(W,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,W,H,G){this.s(z,Re,async q=>{q.handlePartialAccept(W,H,G)},void 0,void 0)}$freeInlineCompletionsList(z,W){this.s(z,Re,async H=>{H.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(z,W,H,G){const q=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,x=this.t(new B(this.h,H),z);return this.e.$registerSignatureHelpProvider(x,this.o(W,z),q),this.p(x)}$provideSignatureHelp(z,W,H,G,q){return this.s(z,B,x=>x.provideSignatureHelp(y.URI.revive(W),H,G,q),void 0,q)}$releaseSignatureHelp(z,W){this.s(z,B,H=>H.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(z,W,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,q=this.t(new ne(this.h,this.j.converter,H,this.l,z),z);this.e.$registerInlayHintsProvider(q,this.o(W,z),typeof H.resolveInlayHint=="function",G,me.u(z));let x=this.p(q);if(G!==void 0){const ue=H.onDidChangeInlayHints(Oe=>this.e.$emitInlayHintsEvent(G));x=M.$AK.from(x,ue)}return x}$provideInlayHints(z,W,H,G){return this.s(z,ne,q=>q.provideInlayHints(y.URI.revive(W),H,G),void 0,G)}$resolveInlayHint(z,W,H){return this.s(z,ne,G=>G.resolveInlayHint(W,H),void 0,H)}$releaseInlayHints(z,W){this.s(z,ne,H=>H.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(z,W,H){const G=this.t(new pe(this.h,H),z);return this.e.$registerDocumentLinkProvider(G,this.o(W,z),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(z,W,H){return this.s(z,pe,G=>G.provideLinks(y.URI.revive(W),H),void 0,H,W.scheme==="output")}$resolveDocumentLink(z,W,H){return this.s(z,pe,G=>G.resolveLink(W,H),void 0,void 0,!0)}$releaseDocumentLinks(z,W){this.s(z,pe,H=>H.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(z,W,H){const G=this.t(new re(this.h,H),z);return this.e.$registerDocumentColorProvider(G,this.o(W,z)),this.p(G)}$provideDocumentColors(z,W,H){return this.s(z,re,G=>G.provideColors(y.URI.revive(W),H),[],H)}$provideColorPresentations(z,W,H,G){return this.s(z,re,q=>q.provideColorPresentations(y.URI.revive(W),H,G),void 0,G)}registerFoldingRangeProvider(z,W,H){const G=this.q(),q=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new ae(new le(this.h,H),z)),this.e.$registerFoldingRangeProvider(G,this.o(W,z),z.identifier,q);let x=this.p(G);if(q!==void 0){const ue=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(q));x=M.$AK.from(x,ue)}return x}$provideFoldingRanges(z,W,H,G){return this.s(z,le,q=>q.provideFoldingRanges(y.URI.revive(W),H,G),void 0,G)}registerSelectionRangeProvider(z,W,H){const G=this.t(new ce(this.h,H,this.l),z);return this.e.$registerSelectionRangeProvider(G,this.o(W,z)),this.p(G)}$provideSelectionRanges(z,W,H,G){return this.s(z,ce,q=>q.provideSelectionRanges(y.URI.revive(W),H,G),[],G)}registerCallHierarchyProvider(z,W,H){const G=this.t(new ye(this.h,H),z);return this.e.$registerCallHierarchyProvider(G,this.o(W,z)),this.p(G)}$prepareCallHierarchy(z,W,H,G){return this.s(z,ye,q=>Promise.resolve(q.prepareSession(y.URI.revive(W),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(z,W,H,G){return this.s(z,ye,q=>q.provideCallsTo(W,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(z,W,H,G){return this.s(z,ye,q=>q.provideCallsFrom(W,H,G),void 0,G)}$releaseCallHierarchy(z,W){this.s(z,ye,H=>Promise.resolve(H.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(z,W,H){const G=this.t(new _(this.h,H),z);return this.e.$registerTypeHierarchyProvider(G,this.o(W,z)),this.p(G)}$prepareTypeHierarchy(z,W,H,G){return this.s(z,_,q=>Promise.resolve(q.prepareSession(y.URI.revive(W),H,G)),void 0,G)}$provideTypeHierarchySupertypes(z,W,H,G){return this.s(z,_,q=>q.provideSupertypes(W,H,G),void 0,G)}$provideTypeHierarchySubtypes(z,W,H,G){return this.s(z,_,q=>q.provideSubtypes(W,H,G),void 0,G)}$releaseTypeHierarchy(z,W){this.s(z,_,H=>Promise.resolve(H.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(z,W,H,G){const q=this.q();this.f.set(q,new ae(new de(this.e,this.h,H,q,z),z));const x=(0,n.$LF)(z,"dropMetadata")&&G?de.toInternalProviderId(z.identifier.value,G.id):void 0;return this.e.$registerDocumentOnDropEditProvider(q,this.o(W,z),x,(0,n.$LF)(z,"dropMetadata")?G:void 0),this.p(q)}$provideDocumentOnDropEdits(z,W,H,G,q,x){return this.s(z,de,ue=>Promise.resolve(ue.provideDocumentOnDropEdits(W,y.URI.revive(H),G,q,x)),void 0,void 0)}registerMappedEditsProvider(z,W,H){const G=this.t(new ie(this.h,H),z);return this.e.$registerMappedEditsProvider(G,this.o(W,z)),this.p(G)}$provideMappedEdits(z,W,H,G,q){return this.s(z,ie,x=>Promise.resolve(x.provideMappedEdits(W,H,G,q)),null,q)}registerDocumentPasteEditProvider(z,W,H,G){const q=this.q();this.f.set(q,new ae(new L(this.e,this.h,H,q,z),z));const x=L.toInternalProviderId(z.identifier.value,G.id);return this.e.$registerPasteEditProvider(q,this.o(W,z),x,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(q)}$prepareDocumentPaste(z,W,H,G,q){return this.s(z,L,x=>x.prepareDocumentPaste(y.URI.revive(W),H,G,q),void 0,q)}$providePasteEdits(z,W,H,G,q,x){return this.s(z,L,ue=>ue.providePasteEdits(W,y.URI.revive(H),G,q,x),void 0,x)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:me.w(z.decreaseIndentPattern),increaseIndentPattern:me.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?me.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?me.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:me.w(z.beforeText),afterText:z.afterText?me.w(z.afterText):void 0,previousLineText:z.previousLineText?me.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(me.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(W=>M.SyntaxTokenType.toString(W)):void 0}}static D(z){return z.map(me.C)}setLanguageConfiguration(z,W,H){const{wordPattern:G}=H;if(G&&(0,E.$Se)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(W,G):this.h.setWordDefinitionFor(W,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const q=this.q(),x={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?me.w(H.wordPattern):void 0,indentationRules:H.indentationRules?me.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?me.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?me.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(q,W,x),this.p(q)}$setWordDefinitions(z){for(const W of z)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$8dc=me}),define(Pe[255],Ae([1,0,3,8,7,31,14,6,23]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;class d{constructor(D,l,b,v){this.c=l,this.d=b,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(y.$yK.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,l){await this.a.$changeLanguage(D,l);const b=this.c.getDocumentData(D);if(!b)throw new Error(`document '${D.toString()}' NOT found`);return b.document}async tokenAtPosition(D,l){const b=D.version,v=T.Position.from(l),f=await this.a.$tokensAtPosition(D.uri,v),t={type:P.StandardTokenType.Other,range:D.getWordRangeAtPosition(l)??new P.$CK(l.line,l.character,l.line,l.character)};if(!f)return t;const i={range:T.Range.to(f.range),type:T.TokenType.to(f.type)};return!i.range.contains(l)||b!==D.version?t:i}createLanguageStatusItem(D,l,b){const v=this.f++,f=this.a,t=this.g,i=`${D.identifier.value}/${l}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);t.add(i);const r={selector:b,id:l,name:D.displayName??D.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const o=new $.$Qc,h=()=>{if(c?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${l}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Zg)(()=>{o.clear(),this.a.$setLanguageStatus(v,{id:i,name:r.name??D.displayName??D.name,source:D.displayName??D.name,selector:T.DocumentSelector.from(r.selector,this.e),label:r.text,detail:r.detail??"",severity:r.severity===P.LanguageStatusSeverity.Error?M.default.Error:r.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:r.command&&this.d.toInternal(r.command,o),accessibilityInfo:r.accessibilityInformation,busy:r.busy})},0)},n={dispose(){o.dispose(),c?.dispose(),f.$removeLanguageStatus(v),t.delete(i)},get id(){return r.id},get name(){return r.name},set name(s){r.name=s,h()},get selector(){return r.selector},set selector(s){r.selector=s,h()},get text(){return r.text},set text(s){r.text=s,h()},set text2(s){(0,E.$MF)(D,"languageStatusText"),r.text=s,h()},get text2(){return(0,E.$MF)(D,"languageStatusText"),r.text},get detail(){return r.detail},set detail(s){r.detail=s,h()},get severity(){return r.severity},set severity(s){r.severity=s,h()},get accessibilityInformation(){return r.accessibilityInformation},set accessibilityInformation(s){r.accessibilityInformation=s,h()},get command(){return r.command},set command(s){r.command=s,h()},get busy(){return r.busy},set busy(s){r.busy=s,h()}};return h(),n}}e.$ufc=d}),define(Pe[82],Ae([1,0,21,12,2,4,15,3,27,17]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tec=e.$Sec=void 0;let I=class{constructor(l,b,v){this.f=v,this.d=new Map,this.a=b.getProxy($.$yK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===y.$g}getMessage(l,b){const{message:v,args:f,comment:t}=b;if(this.c)return(0,T.$He)(v,f??{});let i=v;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const r=this.d.get(l)?.contents[i];return r||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,T.$He)(r??v,f??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let b;const v=await this.g(l);if(!v){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(v),t=JSON.parse(f);b=l.isBuiltin?t.contents?.bundle:t}catch(f){this.f.error(`Failed to load translations for ${l.identifier.value} from ${v}: ${f.message}`);return}b&&this.d.set(l.identifier.value,{contents:b,uri:v})}async g(l){if(l.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return P.URI.revive(b)}return l.l10n?P.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Sec=I,e.$Sec=I=Ke([Ve(0,E.$QM),Ve(1,d.$AM),Ve(2,A.$dj)],I),e.$Tec=(0,M.$Vh)("IExtHostLocalizationService")}),define(Pe[256],Ae([1,0,15,3,27,17,2,51]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;let E=class extends y.$oj{constructor(D,l){super(l.logLevel,l.logsLocation,l.loggers.map(b=>(0,$.$sh)(b))),this.r=D.getProxy(T.$yK.MainThreadLogger)}$setLogLevel(D,l){l?this.setLogLevel(A.URI.revive(l),D):this.setLogLevel(D)}setVisibility(D,l){super.setVisibility(D,l),this.r.$setVisibility(D,l)}s(D,l,b){return new d(this.r,D,l,b)}};e.$6fc=E,e.$6fc=E=Ke([Ve(0,M.$AM),Ve(1,P.$QM)],E);class d extends y.$jj{constructor(D,l,b,v){super(v?.logLevel==="always"),this.r=D,this.s=l,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(l,v).then(()=>{this.u(this.n),this.m=!0})}g(D,l){const b=[[D,l]];this.m?this.u(b):this.n.push(...b)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Ae([1,0,3,4,6,17,24]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vec=e.$Uec=void 0,e.$Uec=(0,T.$Vh)("IExtHostManagedSockets");let $=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(y.$yK.MainThreadManagedSockets)}setFactory(D,l){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(D,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const l=++this.b,b=await this.c.makeConnection(),v=new P.$Qc;return this.d.set(l,new d(l,b,v)),v.add((0,P.$Pc)(()=>this.d.delete(l))),v.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),v.dispose()})),v.add(b.onDidClose(f=>{this.a.$onDidManagedSocketClose(l,f?.stack??f?.message),v.dispose()})),v.add(b.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(l,A.$fe.wrap(f)))),l}$remoteSocketWrite(D,l){this.d.get(D)?.actual.send(l.buffer)}$remoteSocketEnd(D){const l=this.d.get(D);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Vec=$,e.$Vec=$=Ke([Ve(0,M.$AM)],$);class E{constructor(D,l){this.socketFactoryId=D,this.makeConnection=l}}class d extends P.$Rc{constructor(D,l,b){super(),this.socketId=D,this.actual=l,this.B(b)}}}),define(Pe[257],Ae([1,0,3,15,23]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;function M($){return $&&$.title}let A=class{constructor(E,d){this.b=d,this.a=E.getProxy(y.$yK.MainThreadMessageService)}showMessage(E,d,I,D,l){const b={source:{identifier:E.identifier,label:E.displayName||E.name}};let v;typeof D=="string"||M(D)?v=[D,...l]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,v=l),b.useCustom&&(0,P.$MF)(E,"resolvers");const f=[];for(let t=0;t<v.length;t++){const i=v[t];if(typeof i=="string")f.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:c}=i;f.push({title:r,isCloseAffordance:!!c,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(d,I,b,f).then(t=>{if(typeof t=="number")return v[t]})}};e.$vfc=A,e.$vfc=A=Ke([Ve(1,T.$dj)],A)}),define(Pe[258],Ae([1,0,18,14,19,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0;let c=class{constructor(m,k,C,u,w){this.l=k,this.m=C,this.n=u,this.o=w,this.b=new $.$zc,this.c=new $.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new M.$Rd,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=m.getProxy(D.$yK.MainThreadNotebookKernels);const S=new l.$1M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$YM("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const V=this.m.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:V}}else if(F&&"notebookEditor"in F){const V=this.m.getIdByEditor(F.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return F})],l.$ZM.Void);this.n.registerApiCommand(S)}createNotebookController(m,k,C,u,w,S){for(const ve of this.i.values())if(ve.controller.id===k&&d.$_l.equals(m.identifier,ve.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const F=this.j++,V=this;this.o.trace(`NotebookController[${F}], CREATED by ${m.identifier.value}, ${k}`);const J=()=>console.warn(`NO execute handler from notebook controller '${O.id}' of extension: '${m.identifier}'`);let N=!1;const R=new M.$Rd,L=new M.$Rd,O={id:g(m.identifier,k),notebookType:C,extensionId:m.identifier,extensionLocation:m.extensionLocation,label:u||m.identifier.value,preloads:S?S.map(b.NotebookRendererScript.from):[]};let Z=w??J,he;this.a.$addKernel(F,O).catch(ve=>{console.log(ve),N=!0});let $e=0;const De=()=>{if(N)return;const ve=++$e;Promise.resolve().then(()=>{ve===$e&&this.a.$updateKernel(F,O)})},ke=new $.$zc,fe={get id(){return k},get notebookType(){return O.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return O.label},set label(ve){O.label=ve??m.displayName??m.name,De()},get detail(){return O.detail??""},set detail(ve){O.detail=ve,De()},get description(){return O.description??""},set description(ve){O.description=ve,De()},get supportedLanguages(){return O.supportedLanguages},set supportedLanguages(ve){O.supportedLanguages=ve,De()},get supportsExecutionOrder(){return O.supportsExecutionOrder??!1},set supportsExecutionOrder(ve){O.supportsExecutionOrder=ve,De()},get rendererScripts(){return O.preloads?O.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return Z},set executeHandler(ve){Z=ve??J},get interruptHandler(){return he},set interruptHandler(ve){he=ve,O.supportsInterrupt=!!ve,De()},createNotebookCellExecution(ve){if(N)throw new Error("notebook controller is DISPOSED");if(!ke.has(ve.notebook.uri))throw V.o.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ke.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${ve.notebook.uri.toString()}`);return V._createNotebookCellExecution(ve,g(m.identifier,this.id))},createNotebookExecution(ve){if((0,i.$MF)(m,"notebookExecution"),N)throw new Error("notebook controller is DISPOSED");if(!ke.has(ve.uri))throw V.o.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ke.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${ve.uri.toString()}`);return V._createNotebookExecution(ve,g(m.identifier,this.id))},dispose:()=>{N||(this.o.trace(`NotebookController[${F}], DISPOSED`),N=!0,this.i.delete(F),R.dispose(),L.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(ve,te){te===v.NotebookControllerAffinity2.Hidden&&(0,i.$MF)(m,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(F,ve.uri,te)},onDidReceiveMessage:L.event,postMessage(ve,te){return(0,i.$MF)(m,"notebookMessaging"),V.a.$postMessage(F,te&&V.m.getIdByEditor(te),ve)},asWebviewUri(ve){return(0,i.$MF)(m,"notebookMessaging"),(0,f.$jub)(ve,V.l.remote)}};return this.i.set(F,{extensionId:m.identifier,controller:fe,onDidReceiveMessage:L,onDidChangeSelection:R,associatedNotebooks:ke}),fe}getIdByController(m){for(const[k,C]of this.i)if(C.controller===m)return g(C.extensionId,m.id);return null}createNotebookControllerDetectionTask(m,k){const C=this.f++,u=this;this.o.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${m.identifier.value}`),this.a.$addKernelDetectionTask(C,k);const w={dispose:()=>{this.e.delete(C),u.a.$removeKernelDetectionTask(C)}};return this.e.set(C,w),w}registerKernelSourceActionProvider(m,k,C){const u=this.h++,w=typeof C.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,S=this;this.g.set(u,C),this.o.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${m.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,k);let F;return w!==void 0&&(F=C.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(u),S.a.$removeKernelSourceActionProvider(u,u),F?.dispose()}}}async $provideKernelSourceActions(m,k){const C=this.g.get(m);if(C){const u=new A.$Qc;return(await C.provideNotebookKernelSourceActions(k)??[]).map(S=>b.NotebookKernelSourceAction.from(S,this.n.converter,u))}return[]}$acceptNotebookAssociation(m,k,C){const u=this.i.get(m);if(u){const w=this.m.getNotebookDocument(E.URI.revive(k));C?u.associatedNotebooks.set(w.uri,!0):u.associatedNotebooks.delete(w.uri),this.o.trace(`NotebookController[${m}] ASSOCIATE notebook`,w.uri.toString(),C),u.onDidChangeSelection.fire({selected:C,notebook:w.apiNotebook})}}async $executeCells(m,k,C){const u=this.i.get(m);if(!u)return;const w=this.m.getNotebookDocument(E.URI.revive(k)),S=[];for(const F of C){const V=w.getCell(F);V&&S.push(V.apiCell)}try{this.o.trace(`NotebookController[${m}] EXECUTE cells`,w.uri.toString(),S.length),await u.controller.executeHandler.call(u.controller,S,w.apiNotebook,u.controller)}catch(F){this.o.error(`NotebookController[${m}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(m,k,C){const u=this.i.get(m);if(!u)return;const w=this.m.getNotebookDocument(E.URI.revive(k));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,w.apiNotebook);else for(const S of C){const F=w.getCell(S);F&&this.b.get(F.uri)?.cancel()}if(u.controller.interruptHandler){const S=this.c.get(w.uri);C.length&&Array.isArray(S)&&S.length&&S.forEach(F=>F.dispose())}}$acceptKernelMessageFromRenderer(m,k,C){const u=this.i.get(m);if(!u)return;const w=this.m.getEditorById(k);u.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:C}))}$cellExecutionChanged(m,k,C){const w=this.m.getNotebookDocument(E.URI.revive(m)).getCell(k);if(w){const S=C?b.NotebookCellExecutionState.to(C):v.NotebookCellExecutionState.Idle;S!==void 0&&this.k.fire({cell:w.apiCell,state:S})}}_createNotebookCellExecution(m,k){if(m.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.m.getNotebookDocument(m.notebook.uri).getCellFromApiCell(m);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const w=new h(k,u,this.a);this.b.set(u.uri,w);const S=w.onDidChangeState(()=>{w.state===o.Resolved&&(w.dispose(),S.dispose(),this.b.delete(u.uri))});return w.asApiObject()}_createNotebookExecution(m,k){const C=this.m.getNotebookDocument(m.uri),u=m.getCells().find(F=>{const V=C.getCellFromApiCell(F);return V&&this.b.has(V.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const w=new s(k,C,this.a),S=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),S.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[w,S]),w.asApiObject()}};e.$zfc=c,e.$zfc=c=Ke([Ve(4,I.$dj)],c);var o;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(o||(o={}));class h extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(m,k,C){super(),this.m=k,this.n=C,this.b=h.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new P.$2d),this.h=new a(10,u=>this.s(u)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,m,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(m){await this.h.addItem(m)}async s(m){const k=Array.isArray(m)?m:[m];return this.n.$updateExecution(this.b,new r.$wv(k))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(m){let k=this.m;if(m&&(k=this.m.notebook.getCellFromApiCell(m)),!k)throw new Error("INVALID cell");return k.handle}y(m){return m.map(k=>{const C=v.$2L.ensureUniqueMimeTypes(k.items,!0);return C===k.items?b.NotebookCellOutput.from(k):b.NotebookCellOutput.from({items:C,id:k.id,metadata:k.metadata})})}async z(m,k,C){const u=this.w(k),w=this.y((0,y.$2b)(m));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:u,append:C,outputs:w})}async C(m,k,C){return m=v.$2L.ensureUniqueMimeTypes((0,y.$2b)(m),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:m.map(b.NotebookCellOutputItem.from),outputId:k.id,append:C})}asApiObject(){const m=this;return Object.freeze({get token(){return m.g.token},get cell(){return m.m.apiCell},get executionOrder(){return m.j},set executionOrder(C){m.j=C,m.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:m.j}])},start(C){if(m.f===o.Resolved||m.f===o.Started)throw new Error("Cannot call start again");m.f=o.Started,m.c.fire(),m.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,u){if(m.f===o.Resolved)throw new Error("Cannot call resolve twice");m.f=o.Resolved,m.c.fire(),m.h.flush(),m.n.$completeExecution(m.b,new r.$wv({runEndTime:u,lastRunSuccess:C}))},clearOutput(C){return m.t(),m.z([],C,!1)},appendOutput(C,u){return m.t(),m.z(C,u,!0)},replaceOutput(C,u){return m.t(),m.z(C,u,!1)},appendOutputItems(C,u){return m.t(),m.C(C,u,!0)},replaceOutputItems(C,u){return m.t(),m.C(C,u,!1)}})}}var n;(function(p){p[p.Init=0]="Init",p[p.Started=1]="Started",p[p.Resolved=2]="Resolved"})(n||(n={}));class s extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(m,k,C){super(),this.h=k,this.j=C,this.b=s.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new P.$2d),this.j.$createNotebookExecution(this.b,m,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(m,k){this.e=m,this.f=k,this.a=[],this.b=Date.now()}addItem(m){return this.a.push(m),this.c||(this.c=new T.$ih,this.b=Date.now(),(0,T.$Yg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const m=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>m.complete())}}function g(p,m){return`${p.value}/${m}`}e.$Afc=g}),define(Pe[259],Ae([1,0,5,3,107]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=void 0;class M{constructor($,E){this.c=E,this.a=new Map,this.b=$.getProxy(T.$yK.MainThreadNotebookRenderers)}$postRendererMessage($,E,d){const I=this.c.getEditorById($);this.a.get(E)?.fire({editor:I.apiEditor,message:d})}createRendererMessaging($,E){if(!$.contributes?.notebookRenderer?.some(I=>I.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(I,D,l)=>this.d(E).event(I,D,l),postMessage:(I,D)=>{P.$hfc.apiEditorsToExtHost.has(I)&&([I,D]=[D,I]);const l=D&&P.$hfc.apiEditorsToExtHost.get(D);return this.b.$postMessage(l?.id,E,I)}}}d($){let E=this.a.get($);return E||(E=new y.$Rd({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete($)}}),this.a.set($,E),E)}}e.$Bfc=M}),define(Pe[260],Ae([1,0,6,16,2,23,3]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Efc=void 0;class ${constructor(d){this.b=new Map,this.a=d.getProxy(A.$yK.MainThreadProfileContentHandlers)}registrProfileContentHandler(d,I,D){if((0,M.$MF)(d,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,D),this.a.$registerProfileContentHandler(I,D.name,D.description,d.identifier.value),(0,y.$Pc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(d,I,D,l){const b=this.b.get(d);if(!b)throw new Error(`Unknown handler with id: ${d}`);return b.saveProfile(I,D,l)}async $readProfile(d,I,D){const l=this.b.get(d);if(!l)throw new Error(`Unknown handler with id: ${d}`);return l.readProfile((0,T.$Cf)(I)?I:P.URI.revive(I),D)}}e.$Efc=$}),define(Pe[261],Ae([1,0,2,3,14,8]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gfc=void 0;class A{static{this.a=0}constructor(E,d){this.d=d,this.c=new Map,this.b=E.getProxy(T.$yK.MainThreadQuickDiff)}$provideOriginalResource(E,d,I){const D=y.URI.revive(d),l=this.c.get(E);return l?(0,P.$Qg)(()=>l.provideOriginalResource(D,I)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(E,d,I,D){const l=A.a++;return this.c.set(l,d),this.b.$registerQuickDiffProvider(l,M.DocumentSelector.from(E,this.d),I,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Gfc=A}),define(Pe[262],Ae([1,0,19,5,6,3,2,7,11,18,31,45,23,8]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=void 0;function v(f,t,i){const r=f.getProxy(M.$yK.MainThreadQuickOpen);class c{constructor(k,C){this.e=new Map,this.f=0,this.a=k,this.b=C}showQuickPick(k,C,u,w=y.CancellationToken.None){this.c=void 0;const S=Promise.resolve(C),F=++this.f,V=r.$show(F,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},w),J={},N=V.then(()=>J);return Promise.race([N,S]).then(R=>{if(R===J)return;const L=(0,l.$LF)(k,"quickPickItemTooltip");return S.then(O=>{const Z=[];for(let he=0;he<O.length;he++){const $e=O[he];if(typeof $e=="string")Z.push({label:$e,handle:he});else if($e.kind===$.QuickPickItemKind.Separator)Z.push({type:"separator",label:$e.label});else{$e.tooltip&&!L&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const De=$e.iconPath?a($e.iconPath):void 0;Z.push({label:$e.label,iconPath:De?.iconPath,iconClass:De?.iconClass,description:$e.description,detail:$e.detail,picked:$e.picked,alwaysShow:$e.alwaysShow,tooltip:L?b.MarkdownString.fromStrict($e.tooltip):void 0,handle:he})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=he=>{u.onDidSelectItem(O[he])}),r.$setItems(F,Z),V.then(he=>{if(typeof he=="number")return O[he];if(Array.isArray(he))return he.map($e=>O[$e])})})}).then(void 0,R=>{if(!(0,E.$3)(R))return r.$setError(F,R),Promise.reject(R)})}$onItemSelected(k){this.c?.(k)}showInput(k,C=y.CancellationToken.None){return this.d=k?.validateInput,r.$input(k,typeof this.d=="function",C).then(void 0,u=>{if(!(0,E.$3)(u))return Promise.reject(u)})}async $validateInput(k){if(!this.d)return;const C=await this.d(k);if(!C||typeof C=="string")return C;let u;switch(C.severity){case $.InputBoxValidationSeverity.Info:u=I.default.Info;break;case $.InputBoxValidationSeverity.Warning:u=I.default.Warning;break;case $.InputBoxValidationSeverity.Error:u=I.default.Error;break;default:u=C.message?I.default.Error:I.default.Ignore;break}return{content:C.message,severity:u}}async showWorkspaceFolderPick(k,C=y.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!u)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(S=>S.uri.toString()===u.uri.toString())}createQuickPick(k){const C=new g(k,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}createInputBox(k){const C=new p(k,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}$onDidChangeValue(k,C){this.e.get(k)?._fireDidChangeValue(C)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,C){const u=this.e.get(k);u instanceof g&&u._fireDidChangeActive(C)}$onDidChangeSelection(k,C){const u=this.e.get(k);u instanceof g&&u._fireDidChangeSelection(C)}$onDidTriggerButton(k,C){this.e.get(k)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(k,C,u){const w=this.e.get(k);w instanceof g&&w._fireDidTriggerItemButton(C,u)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class o{static{this.a=1}constructor(k,C){this.x=k,this.y=C,this._id=g.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Rd,this.q=new T.$Rd,this.r=new T.$Rd,this.s=new T.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((C,u)=>{const w=C===$.$UL.Back?-1:u;this.o.set(w,C)}),this.z({buttons:k.map((C,u)=>({...a(C.iconPath),tooltip:C.tooltip,handle:C===$.$UL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const C=this.o.get(k);C&&this.r.fire(C)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),r.$dispose(this._id))}z(k){if(!this.v){for(const C of Object.keys(k)){const u=k[C];this.u[C]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){r.$createOrUpdate(this.u),this.u={id:this._id}}}function h(m){if(m instanceof $.$uL)return{id:m.id};const k=s(m),C=n(m);return{dark:typeof k=="string"?A.URI.file(k):k,light:typeof C=="string"?A.URI.file(C):C}}function n(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function a(m){const k=h(m);let C,u;return"id"in k?u=D.ThemeIcon.asClassName(k):C=k,{iconPath:C,iconClass:u}}class g extends o{constructor(k,C){super(k.identifier,C),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Rd,this.L=[],this.M=new T.$Rd,this.N=new T.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((w,S)=>{this.C.set(S,w),this.D.set(w,S)});const C=(0,l.$LF)(this.O,"quickPickItemTooltip"),u=[];for(let w=0;w<k.length;w++){const S=k[w];if(S.kind===$.QuickPickItemKind.Separator)u.push({type:"separator",label:S.label});else{S.tooltip&&!C&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const F=S.iconPath?a(S.iconPath):void 0;u.push({handle:w,label:S.label,iconPath:F?.iconPath,iconClass:F?.iconClass,description:S.description,detail:S.detail,picked:S.picked,alwaysShow:S.alwaysShow,tooltip:C?b.MarkdownString.fromStrict(S.tooltip):void 0,buttons:S.buttons?.map((V,J)=>({...a(V.iconPath),tooltip:V.tooltip,handle:J}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(C=>this.D.has(C)),this.z({activeItems:this.J.map(C=>this.D.get(C))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(C=>this.D.has(C)),this.z({selectedItems:this.L.map(C=>this.D.get(C))})}_fireDidChangeActive(k){const C=(0,d.$Gb)(k.map(u=>this.C.get(u)));this.J=C,this.K.fire(C)}_fireDidChangeSelection(k){const C=(0,d.$Gb)(k.map(u=>this.C.get(u)));this.L=C,this.M.fire(C)}_fireDidTriggerItemButton(k,C){const u=this.C.get(k);if(!u||!u.buttons||!u.buttons.length)return;const w=u.buttons[C];w&&this.N.fire({button:w,item:u})}}class p extends o{constructor(k,C){super(k.identifier,C),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:I.default.Error}):this.z({validationMessage:k.message,severity:k.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new c(t,i)}e.$Hfc=v}),define(Pe[263],Ae([1,0,2,5,66,6,14,3,18,138,15,19,22,45,8,23,13,21]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=e.$Ifc=void 0;function c(N){return N instanceof y.URI}function o(N,R){return N.scheme===t.Schemas.file&&R.scheme===t.Schemas.file&&i.$k?N.toString()===R.toString():N.toString().toLowerCase()===R.toString().toLowerCase()}function h(N){if(N)return typeof N.iconPath=="string"?y.URI.file(N.iconPath):y.URI.isUri(N.iconPath)||b.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function n(N){if(N?.icon){if(y.URI.isUri(N.icon))return N.icon;if(b.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function s(N){if(N.icon){if(y.URI.isUri(N.icon))return N.icon;if(b.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function a(N){if(N.icon){if(y.URI.isUri(N.icon))return N.icon;if(b.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const R=N.icon;return{light:R.light,dark:R.dark}}}else return}function g(N,R){if(!N.iconPath&&!R.iconPath)return 0;if(N.iconPath){if(!R.iconPath)return 1}else return-1;const L=typeof N.iconPath=="string"?N.iconPath:y.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,O=typeof R.iconPath=="string"?R.iconPath:y.URI.isUri(R.iconPath)?R.iconPath.fsPath:R.iconPath.id;return(0,d.$xq)(L,O)}function p(N,R){let L=0;if(N.strikeThrough!==R.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==R.faded)return N.faded?1:-1;if(N.tooltip!==R.tooltip)return(N.tooltip||"").localeCompare(R.tooltip||"");if(L=g(N,R),L!==0)return L;if(N.light&&R.light)L=g(N.light,R.light);else{if(N.light)return 1;if(R.light)return-1}if(L!==0)return L;if(N.dark&&R.dark)L=g(N.dark,R.dark);else{if(N.dark)return 1;if(R.dark)return-1}return L}function m(N,R){if(N.command!==R.command)return N.command<R.command?-1:1;if(N.title!==R.title)return N.title<R.title?-1:1;if(N.tooltip!==R.tooltip){if(N.tooltip!==void 0&&R.tooltip!==void 0)return N.tooltip<R.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(R.tooltip!==void 0)return-1}if(N.arguments===R.arguments)return 0;if(N.arguments)if(R.arguments){if(N.arguments.length!==R.arguments.length)return N.arguments.length-R.arguments.length}else return 1;else return-1;for(let L=0;L<N.arguments.length;L++){const O=N.arguments[L],Z=R.arguments[L];if(O!==Z&&!(c(O)&&c(Z)&&o(O,Z)))return O<Z?-1:1}return 0}function k(N,R){let L=(0,d.$xq)(N.resourceUri.fsPath,R.resourceUri.fsPath,!0);if(L!==0)return L;if(N.command&&R.command)L=m(N.command,R.command);else{if(N.command)return 1;if(R.command)return-1}if(L!==0)return L;if(N.decorations&&R.decorations)L=p(N.decorations,R.decorations);else{if(N.decorations)return 1;if(R.decorations)return-1}return L}function C(N,R){for(let L=0;L<N.length;L++)if(N[L]!==R[L])return!1;return!0}function u(N,R){return N.command===R.command&&N.title===R.title&&N.tooltip===R.tooltip&&(N.arguments&&R.arguments?C(N.arguments,R.arguments):N.arguments===R.arguments)}function w(N,R){return(0,E.$tb)(N,R,u)}class S{#e;#t;get value(){return this.d}set value(R){R=R??"",this.#e.$setInputBoxValue(this.o,R),this.q(R)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(R){this.#e.$setInputBoxPlaceholder(this.o,R),this.f=R}get validateInput(){return(0,f.$MF)(this.m,"scmValidation"),this.g}set validateInput(R){if((0,f.$MF)(this.m,"scmValidation"),R&&typeof R!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=R,this.#e.$setValidationProviderIsEnabled(this.o,!!R)}get enabled(){return this.h}set enabled(R){R=!!R,this.h!==R&&(this.h=R,this.#e.$setInputBoxEnablement(this.o,R))}get visible(){return this.j}set visible(R){R=!!R,this.j!==R&&(this.j=R,this.#e.$setInputBoxVisibility(this.o,R))}get actionButton(){return(0,f.$MF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(R){(0,f.$MF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=R;const L=R!==void 0?{command:this.n.converter.toInternal(R.command,this.l.value),icon:n(R),enabled:R.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,L??null)}get document(){return(0,f.$MF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(R,L,O,Z,he,$e){this.m=R,this.n=L,this.o=he,this.p=$e,this.d="",this.e=new T.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=O,this.#e=Z}showValidationMessage(R,L){(0,f.$MF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,R,L)}$onInputBoxValueChange(R){this.q(R)}q(R){this.d=R,this.e.fire(R)}}e.$Ifc=S;class F{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(R){this.v=R,this.q.$updateGroupLabel(this.t,this.handle,R)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(R){this.p=R,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(R){this.f=[...R],this.k.fire()}constructor(R,L,O,Z,he){this.q=R,this.s=L,this.t=O,this.u=Z,this.v=he,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=F.d++}getResourceState(R){return this.g.get(R)}$executeResourceCommand(R,L){const O=this.h.get(R);return O?(0,A.$Qg)(()=>this.s.executeCommand(O.command,...O.arguments||[],L)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const R=[...this.f].sort(k),O=(0,E.$Cb)(this.o,R,k).map($e=>{const De=$e.toInsert.map(ke=>{const fe=this.e++;this.g.set(fe,ke);const ve=ke.resourceUri;let te;if(ke.command)if(ke.command.command==="vscode.open"||ke.command.command==="vscode.diff"||ke.command.command==="vscode.changes"){const ye=new M.$Qc;te=this.s.converter.toInternal(ke.command,ye),this.j.set(fe,ye)}else this.h.set(fe,ke.command);const Re=h(ke.decorations),se=ke.decorations&&h(ke.decorations.light)||Re,Y=ke.decorations&&h(ke.decorations.dark)||Re,B=[se,Y],ne=ke.decorations&&ke.decorations.tooltip||"",pe=ke.decorations&&!!ke.decorations.strikeThrough,re=ke.decorations&&!!ke.decorations.faded,le=ke.contextValue||"";return{rawResource:[fe,ve,B,ne,pe,re,le,te],handle:fe}});return{start:$e.start,deleteCount:$e.deleteCount,toInsert:De}}),Z=O.map(({start:$e,deleteCount:De,toInsert:ke})=>[$e,De,ke.map(fe=>fe.rawResource)]),he=O.reverse();for(const{start:$e,deleteCount:De,toInsert:ke}of he){const fe=ke.map(te=>te.handle),ve=this.n.splice($e,De,...fe);for(const te of ve)this.g.delete(te),this.h.delete(te),this.j.get(te)?.dispose(),this.j.delete(te)}return this.o=R,Z}dispose(){this.l=!0,this.m.fire()}}class V{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(R){this.g!==R&&(this.g=R,this.#e.$updateSourceControl(this.x,{count:R}))}get quickDiffProvider(){return this.h}set quickDiffProvider(R){this.h=R;let L;(0,f.$LF)(this.y,"quickDiffProvider")&&(L=R?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!R,quickDiffLabel:L})}get historyProvider(){return(0,f.$MF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(R){(0,f.$MF)(this.y,"scmHistoryProvider"),this.j=R,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!R}),R&&(this.k.value.add(R.onDidChangeCurrentHistoryItemGroup(()=>{this.l=R?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(R.onDidChangeActionButton(()=>{(0,f.$MF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const L=R.actionButton!==void 0?{command:this.z.converter.toInternal(R.actionButton.command,this.m.value),description:R.actionButton.description,enabled:R.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,L??null)})))}get commitTemplate(){return this.n}set commitTemplate(R){R!==this.n&&(this.n=R,this.#e.$updateSourceControl(this.x,{commitTemplate:R}))}get acceptInputCommand(){return this.p}set acceptInputCommand(R){this.o.value=new M.$Qc,this.p=R;const L=this.z.converter.toInternal(R,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:L})}get actionButton(){return(0,f.$MF)(this.y,"scmActionButton"),this.s}set actionButton(R){(0,f.$MF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=R;const L=R!==void 0?{command:this.z.converter.toInternal(R.command,this.q.value),secondaryCommands:R.secondaryCommands?.map(O=>O.map(Z=>this.z.converter.toInternal(Z,this.q.value))),description:R.description,enabled:R.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:L??null})}get statusBarCommands(){return this.u}set statusBarCommands(R){if(this.u&&R&&w(this.u,R))return;this.t.value=new M.$Qc,this.u=R;const L=(R||[]).map(O=>this.z.converter.toInternal(O,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:L})}get selected(){return this.v}constructor(R,L,O,Z,he,$e,De){this.y=R,this.z=Z,this.A=he,this.B=$e,this.C=De,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Rd,this.onDidChangeSelection=this.w.event,this.x=V.d++,this.D=new Map,this.E=new Set,this.#e=O;const ke=y.URI.from({scheme:t.Schemas.vscodeSourceControl,path:`${he}/scm${this.x}/input`,query:De?`rootUri=${encodeURIComponent(De.toString())}`:void 0});this.f=new S(R,Z,L,this.#e,this.x,ke),this.#e.$registerSourceControl(this.x,he,$e,De,ke)}createResourceGroup(R,L){const O=new F(this.#e,this.z,this.x,R,L),Z=T.Event.once(O.onDidDispose)(()=>this.D.delete(O));return this.D.set(O,Z),this.eventuallyAddResourceGroups(),O}eventuallyAddResourceGroups(){const R=[],L=[];for(const[O,Z]of this.D){Z.dispose();const he=O.onDidUpdateResourceStates(()=>{this.E.add(O),this.eventuallyUpdateResourceStates()});T.Event.once(O.onDidDispose)(()=>{this.E.delete(O),he.dispose(),this.e.delete(O.handle),this.#e.$unregisterGroup(this.x,O.handle)}),R.push([O.handle,O.id,O.label,O.features]);const $e=O._takeResourceStateSnapshot();$e.length>0&&L.push([O.handle,$e]),this.e.set(O.handle,O)}this.#e.$registerGroups(this.x,R,L),this.D.clear()}eventuallyUpdateResourceStates(){const R=[];this.E.forEach(L=>{const O=L._takeResourceStateSnapshot();O.length!==0&&R.push([L.handle,O])}),R.length>0&&this.#e.$spliceResourceStates(this.x,R),this.E.clear()}getResourceGroup(R){return this.e.get(R)}setSelectionState(R){this.v=R,this.w.fire(R)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(R=>R.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,P.$oh)(100)],V.prototype,"eventuallyAddResourceGroups",null),Ke([(0,P.$oh)(100)],V.prototype,"eventuallyUpdateResourceStates",null);let J=class{static{r=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(R,L,O,Z){this.n=L,this.o=O,this.p=Z,this.h=new Map,this.j=new l.$bm,this.k=new T.$Rd,this.l=new Map,this.f=R.getProxy($.$yK.MainThreadSCM),this.g=R.getProxy($.$yK.MainThreadTelemetry),L.registerArgumentProcessor({processArgument:he=>{if(he&&he.$mid===3){const $e=this.h.get(he.sourceControlHandle);if(!$e)return he;const De=$e.getResourceGroup(he.groupHandle);return De?De.getResourceState(he.handle):he}else if(he&&he.$mid===4){const $e=this.h.get(he.sourceControlHandle);return $e?$e.getResourceGroup(he.groupHandle):he}else if(he&&he.$mid===5){const $e=this.h.get(he.handle);return $e||he}return he}})}createSourceControl(R,L,O,Z){this.p.trace("ExtHostSCM#createSourceControl",R.identifier.value,L,O,Z),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:R.identifier.value});const he=r.d++,$e=new V(R,this.o,this.f,this.n,L,O,Z);this.h.set(he,$e);const De=this.j.get(R.identifier)||[];return De.push($e),this.j.set(R.identifier,De),$e}registerSourceControlInputBoxValueProvider(R,L){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",R.identifier.value,L.label);const O=r.e++;return this.l.set(O,L),this.f.$registerSourceControlInputBoxValueProvider(O,L.label,a(L)),(0,M.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(O),this.l.delete(O)})}async $provideInputBoxValue(R,L,O){const Z=this.l.get(R);if(Z)return await Z.provideValue(L,O,D.CancellationToken.None)??void 0}getLastInputBox(R){this.p.trace("ExtHostSCM#getLastInputBox",R.identifier.value);const L=this.j.get(R.identifier),O=L&&L[L.length-1];return O&&O.inputBox}$provideOriginalResource(R,L,O){const Z=y.URI.revive(L);this.p.trace("ExtHostSCM#$provideOriginalResource",R,Z.toString());const he=this.h.get(R);return!he||!he.quickDiffProvider||!he.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Qg)(()=>he.quickDiffProvider.provideOriginalResource(Z,O)).then($e=>$e||null)}$onInputBoxValueChange(R,L){this.p.trace("ExtHostSCM#$onInputBoxValueChange",R);const O=this.h.get(R);return O&&O.inputBox.$onInputBoxValueChange(L),Promise.resolve(void 0)}$executeResourceCommand(R,L,O,Z){this.p.trace("ExtHostSCM#$executeResourceCommand",R,L,O);const he=this.h.get(R);if(!he)return Promise.resolve(void 0);const $e=he.getResourceGroup(L);return $e?$e.$executeResourceCommand(O,Z):Promise.resolve(void 0)}$validateInput(R,L,O){this.p.trace("ExtHostSCM#$validateInput",R);const Z=this.h.get(R);return!Z||!Z.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Qg)(()=>Z.inputBox.validateInput(L,O)).then(he=>{if(!he)return Promise.resolve(void 0);const $e=v.MarkdownString.fromStrict(he.message);return $e?Promise.resolve([$e,he.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(R){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",R),R!==void 0&&this.h.get(R)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=R,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(R,L,O){return await this.h.get(R)?.historyProvider?.resolveHistoryItemGroupBase(L,O)??void 0}async $resolveHistoryItemGroupCommonAncestor(R,L,O,Z){return await this.h.get(R)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(L,O,Z)??void 0}async $provideHistoryItems(R,L,O,Z){return(await this.h.get(R)?.historyProvider?.provideHistoryItems(L,O,Z))?.map(De=>({...De,icon:s(De)}))??void 0}async $provideHistoryItemChanges(R,L,O){return await this.h.get(R)?.historyProvider?.provideHistoryItemChanges(L,O)??void 0}};e.$Jfc=J,e.$Jfc=J=r=Ke([Ve(3,I.$dj)],J)}),define(Pe[84],Ae([1,0,3,5,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=e.$Pec=void 0;class M{constructor($){this.b=new T.$Rd,this.onDidChangePassword=this.b.event,this.a=$.getProxy(y.$yK.MainThreadSecretState)}async $onDidChangePassword($){this.b.fire($)}get($,E){return this.a.$getPassword($,E)}store($,E,d){return this.a.$setPassword($,E,d)}delete($,E){return this.a.$deletePassword($,E)}}e.$Pec=M,e.$Qec=(0,P.$Vh)("IExtHostSecretState")}),define(Pe[264],Ae([1,0,3,8,2]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class M{static{this.a=0}constructor($,E){this.d=E,this.c=new Map,this.b=$.getProxy(y.$yK.MainThreadShare)}async $provideShare($,E,d){return await this.c.get($)?.provideShare({selection:T.Range.to(E.selection),resourceUri:P.URI.revive(E.resourceUri)},d)??void 0}registerShareProvider($,E){const d=M.a++;return this.c.set(d,E),this.b.$registerShareProvider(d,T.DocumentSelector.from($,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(d),this.c.delete(d)}}}}e.$Kfc=M}),define(Pe[265],Ae([1,0,19,6,3]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class M{static{this.a=1}constructor($){this.c=new Map,this.d=new Map,this.b=$.getProxy(P.$yK.MainThreadSpeech)}async $createSpeechToTextSession($,E){const d=this.c.get($);if(!d)return;const I=new T.$Qc,D=new y.$2d;this.d.set(E,D);const l=I.add(d.provideSpeechToTextSession(D.token));I.add(l.onDidChange(b=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,b)})),I.add(D.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession($){this.d.get($)?.dispose(!0),this.d.delete($)}registerProvider($,E,d){const I=M.a++;return this.c.set(I,d),this.b.$registerProvider(I,E,{extension:$,displayName:$.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$Lfc=M}),define(Pe[266],Ae([1,0,7,3,164,6,8,16]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=e.$Mfc=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$vL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$vL("statusBarItem.warningForeground")]])}#e;#t;constructor(l,b,v,f,t,i=y.StatusBarAlignment.Left,r){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=l,this.#t=b,t&&f){this.c=(0,y.$$K)(f.identifier,t);const c=v.get(this.c);c&&(i=c.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,r=c.priority,this.j=!0,this.name=c.name,this.text=c.text,this.tooltip=c.tooltip,this.command=c.command,this.accessibilityInformation=c.accessibilityInformation)}else this.c=String(E.a++);this.e=f,this.f=t,this.g=i,this.h=this.u(r)}u(l){if((0,$.$Gf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!E.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let b;this.m?b=this.m:b=(0,P.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=E.b.get(this.o.id));const f=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,b,this.k,f,this.r?.internal,v,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Mfc=E;class d{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const b={message:l};return this.b.unshift(b),this.c(),new y.$AK(()=>{const v=this.b.indexOf(b);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(l,b){this.e=new Map,this.a=l.getProxy(T.$yK.MainThreadStatusBar),this.b=b,this.c=new d(this)}$acceptStaticEntries(l){for(const b of l)this.e.set(b.entryId,b)}createStatusBarEntry(l,b,v,f){return new E(this.a,this.b,this.e,l,b,v,f)}setStatusBarMessage(l,b){const v=this.c.setMessage(l);let f;return typeof b=="number"?f=setTimeout(()=>v.dispose(),b):typeof b<"u"&&b.then(()=>v.dispose(),()=>v.dispose()),new y.$AK(()=>{v.dispose(),clearTimeout(f)})}}e.$Nfc=I}),define(Pe[85],Ae([1,0,3,5,4]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=e.$Hec=void 0;class M{constructor($,E){this.c=E,this.b=new T.$Rd,this.onDidChangeStorage=this.b.event,this.a=$.getProxy(y.$yK.MainThreadStorage)}registerExtensionStorageKeysToSync($,E){this.a.$registerExtensionStorageKeysToSync($,E)}async initializeExtensionStorage($,E,d){const I=await this.a.$initializeExtensionStorage($,E);let D;return I&&(D=this.d($,E,I)),D||d}setValue($,E,d){return this.a.$setValue($,E,d)}$acceptValue($,E,d){const I=this.d($,E,d);I&&this.b.fire({shared:$,key:E,value:I})}d($,E,d){try{return JSON.parse(d)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${$}): ${I}`)}}}e.$Hec=M,e.$Iec=(0,P.$Vh)("IExtHostStorage")}),define(Pe[86],Ae([1,0,4,27,15,63,2]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=void 0,e.$qec=(0,y.$Vh)("IExtensionStoragePaths");let $=class{constructor(d,I,D){this.d=I,this.f=D,this.a=d.workspace??void 0,this.b=d.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(d){return A.URI.joinPath(this.b.workspaceStorageHome,d)}async h(){if(!this.a)return Promise.resolve(void 0);const d=this.a.id,I=await this.g(d);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(d){if(this.c)return A.URI.joinPath(this.c,d.identifier.value)}globalValue(d){return A.URI.joinPath(this.b.globalStorageHome,d.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$rec=$,e.$rec=$=Ke([Ve(0,T.$QM),Ve(1,P.$dj),Ve(2,M.$pec)],$)}),define(Pe[64],Ae([1,0,5,3,4,2,17,6,7,166,11,194,19,33,195,45,14,8,32]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=e.$Nec=e.$Mec=e.$Lec=void 0,e.$Lec=(0,P.$Vh)("IExtHostTerminalService");class c{constructor(u,w,S,F){this.l=u,this._id=w,this.m=S,this.n=F,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(J=>this.f=J);const V=this;this.value={get name(){return V.n||""},get processId(){return V.b},get creationOptions(){return V.m},get exitStatus(){return V.h},get state(){return V.j},get selection(){return V.k},sendText(J,N=!0){V.q(),V.l.$sendText(V._id,J,N)},show(J){V.q(),V.l.$show(V._id,J)},hide(){V.q(),V.l.$hide(V._id)},dispose(){V.a||(V.a=!0,V.l.$dispose(V._id))},get dimensions(){if(!(V.d===void 0||V.g===void 0))return{columns:V.d,rows:V.g}}}}async create(u,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??w?.cwd??void 0,env:u.env??void 0,icon:p(u.iconPath)??void 0,color:f.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(u.location,w?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,w,S,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:S,color:f.ThemeColor.isThemeColor(F)?F.id:void 0,location:this.o(u,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,w){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,w){this.h=Object.freeze({code:u,reason:w})}setDimensions(u,w){return u===this.d&&w===this.g||u===0||w===0?!1:(this.d=u,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(w=>{w!==u&&(this.b=Promise.resolve(u))})}}e.$Mec=c;class o{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new y.$Rd,this.onProcessData=this.a.event,this.b=new y.$Rd,this.d=new y.$Rd,this.onDidChangeProperty=this.d.event,this.f=new y.$Rd,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,w){this.g.setDimensions?.({columns:u,rows:w})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,n=class extends $.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,w,S){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new $.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new y.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new y.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Rd,this.onDidChangeShell=this.N.event,this.O=new y.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=S.getProxy(T.$yK.MainThreadTerminalService),this.y=new v.$yqb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:F=>{const V=J=>{const N=J;return this.W(N.instanceId)?.value};switch(F?.$mid){case 15:return V(F);default:{if(Array.isArray(F))for(let J=0;J<F.length&&F[J].$mid===15;J++)F[J]=V(F[J]);return F}}}}),this.B({dispose:()=>{for(const[F,V]of this.g)V.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,w){const S=new c(this.a,(0,b.$ig)(),u,u.name),F=new o(u.pty);return S.createExtensionTerminal(u.location,this.R(u,w).resolvedExtHostIdentifier,p(u.iconPath),m(u.color)).then(V=>{const J=this.S(V,F);this.h[V]=J}),this.f.push(S),S.value}R(u,w){if(w=w||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const S=u.location.parentTerminal;if(S){const F=this.f.find(V=>V.value===S);F&&(w.resolvedExtHostIdentifier=F._id)}}else u.location&&typeof u.location!="object"?w.location=u.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(u,w){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const F=new o(w),V=this.S(u,F);this.h[u]=V}async $acceptActiveTerminalChanged(u){const w=this.b;if(u===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const S=this.W(u);S&&(this.b=S,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,w){const S=this.W(u);S&&this.O.fire({terminal:S.value,data:w})}async $acceptTerminalDimensions(u,w,S){const F=this.W(u);F&&F.setDimensions(w,S)&&this.L.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptDidExecuteCommand(u,w){const S=this.W(u);S&&this.P.fire({terminal:S.value,...w})}async $acceptTerminalMaximumDimensions(u,w,S){this.g.get(u)?.resize(w,S)}async $acceptTerminalTitleChange(u,w){const S=this.W(u);S&&(S.name=w)}async $acceptTerminalClosed(u,w,S){const F=this.Y(this.f,u);if(F!==null){const V=this.f.splice(F,1)[0];V.setExitStatus(w,S),this.H.fire(V.value)}}$acceptTerminalOpened(u,w,S,F){if(w){const N=this.Y(this.f,w);if(N!==null){this.f[N]._id=u,this.I.fire(this.terminals[N]),this.f[N].isOpen=!0;return}}const V={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:M.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},J=new c(this.a,u,V,S);this.f.push(J),this.I.fire(J.value),J.isOpen=!0}async $acceptTerminalProcessId(u,w){this.W(u)?._setProcessId(w)}async $startExtensionTerminal(u,w){const S=this.W(u);if(!S)return{message:(0,d.localize)(0,null,u)};S.isOpen||await new Promise(V=>{const J=this.onDidOpenTerminal(async N=>{N===S.value&&(J.dispose(),V())})});const F=this.g.get(u);F?F.startSendingEvents(w):this.j[u]={initialDimensions:w}}S(u,w){const S=new $.$Qc;S.add(w.onProcessReady(V=>this.a.$sendProcessReady(u,V.pid,V.cwd,V.windowsPty))),S.add(w.onDidChangeProperty(V=>this.a.$sendProcessProperty(u,V))),this.y.startBuffering(u,w.onProcessData),S.add(w.onProcessExit(V=>this.U(u,V))),this.g.set(u,w);const F=this.j[u];return F&&w instanceof o&&(w.startSendingEvents(F.initialDimensions),delete this.j[u]),S}$acceptProcessAckDataEvent(u,w){this.g.get(u)?.acknowledgeDataEvent(w)}$acceptProcessInput(u,w){this.g.get(u)?.input(w)}$acceptTerminalInteraction(u){const w=this.W(u);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(u,w){this.W(u)?.setSelection(w)}$acceptProcessResize(u,w,S){try{this.g.get(u)?.resize(w,S)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(u,w){this.g.get(u)?.shutdown(w)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(w=>this.a.$sendProcessProperty(u,{type:"cwd",value:w}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new E.$AK(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,w,S){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,S),this.a.$registerProfileProvider(w,u.identifier.value),new E.$AK(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(u,w,S){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,S),this.a.$registerQuickFixProvider(u,w),new E.$AK(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,w){const S=new l.$2d().token;if(S.isCancellationRequested)return;const F=this.D.get(u);if(!F)return;const V=await F.provideTerminalQuickFixes(w,S);if(V===null||Array.isArray(V)&&V.length===0)return;const J=new $.$Qc;if(this.w.value=J,!Array.isArray(V))return V?i.TerminalQuickFix.from(V,this.Q.converter,J):void 0;const N=[];for(const R of V){const L=i.TerminalQuickFix.from(R,this.Q.converter,J);L&&N.push(L)}return N}async $createContributedProfileTerminal(u,w){const S=new l.$2d().token;let F=await this.C.get(u)?.provideTerminalProfile(S);if(!S.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,w);return}this.createTerminalFromOptions(F.options,w)}}async $provideLinks(u,w){const S=this.W(u);if(!S)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const V=new l.$2d;this.G.set(u,V);const J=[],N={terminal:S.value,line:w},R=[];for(const Z of this.z)R.push(t.Promises.withAsyncBody(async he=>{V.token.onCancellationRequested(()=>he({provider:Z,links:[]}));const $e=await Z.provideTerminalLinks(N,V.token)||[];V.token.isCancellationRequested||he({provider:Z,links:$e})}));const L=await Promise.all(R);if(V.token.isCancellationRequested)return[];const O=new Map;for(const Z of L)Z&&Z.links.length>0&&J.push(...Z.links.map(he=>{const $e={id:h++,startIndex:he.startIndex,length:he.length,label:he.tooltip};return O.set($e.id,{provider:Z.provider,link:he}),$e}));return this.F.set(u,O),J}$activateLink(u,w){const S=this.F.get(u)?.get(w);S&&S.provider.handleTerminalLink(S.link)}U(u,w){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const S=this.h[u];S&&(S.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,w)}W(u){return this.X(this.f,u)}X(u,w){const S=this.Y(u,w);return S!==null?u[S]:null}Y(u,w){const S=u.findIndex(F=>F._id===w);return S===-1?null:S}getEnvironmentVariableCollection(u){let w=this.n.get(u.identifier.value);return w||(w=new s,this.$(u.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(u,w){const S=(0,D.$qr)(w.map),F=(0,D.$rr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(u,w.persistent,S.length===0?void 0:S,F)}$initEnvironmentVariableCollections(u){u.forEach(w=>{const S=w[0],F=new s(w[1]);this.$(S,F)})}$acceptDefaultProfile(u,w){const S=this.s;this.s=u,this.u=w,S?.path!==u.path&&this.N.fire(u.path)}$(u,w){this.n.set(u,w),w.onDidChangeCollection(()=>{this.Z(u,w)})}};e.$Nec=n,e.$Nec=n=Ke([Ve(1,r.$WM),Ve(2,A.$AM)],n);class s{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Rd,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const w=this.h(u);let S=this.a.get(w);return S||(S=new a(this,u),this.a.set(w,S),S.onDidChangeCollection(()=>this.d.fire())),S}replace(u,w,S,F){this.f(u,{value:w,type:E.EnvironmentVariableMutatorType.Replace,options:S??{applyAtProcessCreation:!0},scope:F})}append(u,w,S,F){this.f(u,{value:w,type:E.EnvironmentVariableMutatorType.Append,options:S??{applyAtProcessCreation:!0},scope:F})}prepend(u,w,S,F){this.f(u,{value:w,type:E.EnvironmentVariableMutatorType.Prepend,options:S??{applyAtProcessCreation:!0},scope:F})}f(u,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const S=this.g(u,w.scope),F=this.map.get(S),V=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!F||F.value!==w.value||F.type!==w.type||F.options?.applyAtProcessCreation!==V.applyAtProcessCreation||F.options?.applyAtShellIntegration!==V.applyAtShellIntegration||F.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const J=this.g(u,w.scope),N={variable:u,...w,options:V};this.map.set(J,N),this.d.fire()}}get(u,w){const S=this.g(u,w),F=this.map.get(S);return F?k(F):void 0}g(u,w){const S=this.h(w);return S.length?`${u}:::${S}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const w=new Map;for(const[S,F]of this.map)this.h(F.scope)===this.h(u)&&w.set(F.variable,k(F));return w}delete(u,w){const S=this.g(u,w);this.map.delete(S),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[w,S]of this.map)S.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(w);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,w){const S=this.h(w),F=this.descriptionMap.get(S);if(!F||F.description!==u){let V;typeof u=="string"?V=u:V=u?.value.split(`

`)[0];const J={description:V,scope:w};this.descriptionMap.set(S,J),this.d.fire()}}getDescription(u){const w=this.h(u);return this.descriptionMap.get(w)?.description}k(u){const w=this.h(u);this.descriptionMap.delete(w)}}class a{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,w){this.b=u,this.d=w,this.a=new y.$Rd}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,w,S){this.b.replace(u,w,S,this.d)}append(u,w,S){this.b.append(u,w,S,this.d)}prepend(u,w,S){this.b.prepend(u,w,S,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,w){this.b.getVariableMap(this.d).forEach((S,F)=>u.call(w,F,S,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let g=class extends n{constructor(u,w){super(!1,u,w)}createTerminal(u,w,S){throw new I.$$}createTerminalFromOptions(u,w){throw new I.$$}};e.$Oec=g,e.$Oec=g=Ke([Ve(0,r.$WM),Ve(1,A.$AM)],g);function p(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function m(C){return f.ThemeColor.isThemeColor(C)?C:void 0}function k(C){const u={...C};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Pe[267],Ae([1,0,298,14,24,19,5,219,97,6,26,16,33,3,17,108,8,7,48,77,58,23]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=e.$Sfc=e.$Rfc=void 0;let n=class extends d.$Rc{constructor(N,R,L){super(),this.u=L,this.f=this.B(new A.$Rd),this.g=new Map,this.s=this.B(new A.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=N.getProxy(b.$yK.MainThreadTesting),this.m=new S(this.h),this.j=new p(this.h),R.registerArgumentProcessor({processArgument:O=>{switch(O?.$mid){case 16:{const Z=O,he=Z.tests[Z.tests.length-1].item.extId;return this.g.get(r.$rJ.root(he))?.collection.tree.get(he)?.actual??(0,f.$MM)(O)}case 18:{const{extId:Z,message:he}=O;return{test:this.g.get(r.$rJ.root(Z))?.collection.tree.get(Z)?.actual,message:t.TestMessage.to(he)}}default:return O}}}),R.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await R.executeCommand("_testing.getExplorerSelection"),Z=he=>{const $e=this.g.get(r.$rJ.root(he));if($e)return r.$rJ.isRoot(he)?$e.controller:$e.collection.tree.get(he)?.actual};return{include:O?.include.map(Z).filter(D.$Kf)||[],exclude:O?.exclude.map(Z).filter(D.$Kf)||[]}})}createTestController(N,R,L,O){if(this.g.has(R))throw new Error(`Attempt to insert a duplicate controller with ID "${R}"`);const Z=new d.$Qc,he=Z.add(new f.$PM(R,L,this.u));he.root.label=L;const $e=new Map,De=new Set,ke=this.h,fe={items:he.root.children,get label(){return L},set label(te){L=te,he.root.label=te,ke.$updateController(R,{label:L})},get refreshHandler(){return O},set refreshHandler(te){O=te,ke.$updateController(R,{canRefresh:!!te})},get id(){return R},createRunProfile:(te,Re,se,Y,B,ne)=>{let pe=(0,E.$Ji)(te);for(;$e.has(pe);)pe++;return new F(this.h,$e,N,De,this.s.event,R,pe,te,Re,se,Y,B,ne)},createTestItem(te,Re,se){return new f.$NM(R,te,Re,se)},createTestRun:(te,Re,se=!0)=>this.j.createTestRun(N,R,he,te,Re,se),invalidateTestResults:te=>{if(te===void 0)this.h.$markTestRetired(void 0);else{const Re=te instanceof Array?te:[te];this.h.$markTestRetired(Re.map(se=>r.$rJ.fromExtHostTestItem(se,R).toString()))}},set resolveHandler(te){he.resolveHandler=te},get resolveHandler(){return he.resolveHandler},dispose:()=>{Z.dispose()}};ke.$registerTestController(R,L,!!O),Z.add((0,d.$Pc)(()=>ke.$unregisterTestController(R)));const ve={controller:fe,collection:he,profiles:$e,extension:N,activeProfiles:De};return this.g.set(R,ve),Z.add((0,d.$Pc)(()=>this.g.delete(R))),Z.add(he.onDidGenerateDiff(te=>ke.$publishDiff(R,te.map(o.TestsDiffOp.serialize)))),fe}createTestObserver(){return this.m.checkout()}async runTests(N,R=M.CancellationToken.None){const L=m(N);if(!L)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.g.get(L.controllerId);if(!O)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(Z=>r.$rJ.fromExtHostTestItem(Z,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:V[L.kind],profileId:L.profileId,controllerId:L.controllerId}],exclude:N.exclude?.map(Z=>Z.id)},R)}$syncTests(){for(const{collection:N}of this.g.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,R,L){return(0,y.$qb)(this.j.trackers,Z=>Z.id===N?Z.getCoverage(R):void 0)?.provideFileCoverage(L)??Promise.resolve([])}$resolveFileCoverage(N,R,L,O){return(0,y.$qb)(this.j.trackers,he=>he.id===N?he.getCoverage(R):void 0)?.resolveFileCoverage(L,O)??Promise.resolve([])}$configureRunProfile(N,R){this.g.get(N)?.profiles.get(R)?.configureHandler?.()}$setActiveRunProfiles(N){const R=new Map;for(const[L,O]of Object.entries(N)){const Z=this.g.get(L);if(!Z)continue;const he=new Map,$e=O.filter(ke=>!Z.activeProfiles.has(ke)),De=[...Z.activeProfiles].filter(ke=>!O.includes(ke));for(const ke of $e)he.set(ke,!0),Z.activeProfiles.add(ke);for(const ke of De)he.set(ke,!1),Z.activeProfiles.delete(ke);he.size&&R.set(L,he)}this.s.fire(R)}async $refreshTests(N,R){await this.g.get(N)?.controller.refreshHandler?.(R)}$publishTestResults(N){this.results=Object.freeze(N.map(R=>(0,I.$bn)(t.TestResults.to(R))).concat(this.results).sort((R,L)=>L.completedAt-R.completedAt).slice(0,32)),this.f.fire()}async $expandTest(N,R){const L=this.g.get(r.$rJ.fromString(N).controllerId)?.collection;L&&(await L.expand(N,R<0?1/0:R),L.flushDiff())}$acceptDiff(N){this.m.applyDiff(N.map(o.TestsDiffOp.deserialize))}async $runControllerTests(N,R){return Promise.all(N.map(L=>this.w(L,!1,R)))}async $startContinuousRun(N,R){const L=new M.$2d(R),O=await Promise.all(N.map(Z=>this.w(Z,!0,L.token)));return!R.isCancellationRequested&&!O.some(Z=>Z.error)&&await new Promise(Z=>R.onCancellationRequested(Z)),L.dispose(!0),O}async w(N,R,L){const O=this.g.get(N.controllerId);if(!O)return{};const{collection:Z,profiles:he,extension:$e}=O,De=he.get(N.profileId);if(!De)return{};const ke=N.testIds.map(Re=>Z.tree.get(Re)).filter(D.$Kf),fe=N.excludeExtIds.map(Re=>O.collection.tree.get(Re)).filter(D.$Kf).filter(Re=>ke.some(se=>se.fullId.compare(Re.fullId)===2));if(!ke.length)return{};const ve=new i.$9L(ke.some(Re=>Re.actual instanceof f.$OM)?void 0:ke.map(Re=>Re.actual),fe.map(Re=>Re.actual),De,R),te=(0,o.$tJ)(N)&&this.j.prepareForMainThreadTestRun(ve,k.fromInternal(N,O.collection),$e,L);try{return await De.runHandler(ve,L),{}}catch(Re){return{error:String(Re)}}finally{te&&(te.hasRunningTasks&&!L.isCancellationRequested&&await A.Event.toPromise(te.onEnd),te.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.j.cancelAllRuns():this.j.cancelRunById(N)}};e.$Rfc=n,e.$Rfc=n=Ke([Ve(0,v.$AM)],n);const s=1e4;var a;(function(J){J[J.Running=0]="Running",J[J.Cancelling=1]="Cancelling",J[J.Ended=2]="Ended"})(a||(a={}));class g extends d.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(N,R,L){super(),this.m=N,this.s=R,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Rd),this.onEnd=this.j.event,this.h=this.B(new M.$2d(L));const O=this.B(new T.$0g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(N){return this.f.get(N)?.coverage}createRun(N){const R=this.m.id,L=this.m.controllerId,O=(0,l.$ig)(),Z=new C(this.s,R,O),he=fe=>(ve,...te)=>{if(De){console.warn(`Setting the state of test "${ve.id}" is a no-op after the run ends.`);return}this.m.isIncluded(ve)&&(this.y(ve),fe(ve,...te))},$e=(fe,ve)=>{const te=ve instanceof Array?ve.map(t.TestMessage.from):[t.TestMessage.from(ve)];if(fe.uri&&fe.range){const Re={range:t.Range.from(fe.range),uri:fe.uri};for(const se of te)se.location=se.location||Re}this.s.$appendTestMessagesInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),te)};let De=!1;const ke={isPersisted:this.m.isPersisted,token:this.h.token,name:N,get coverageProvider(){return Z.coverageProvider},set coverageProvider(fe){Z.coverageProvider=fe},enqueued:he(fe=>{this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),1)}),skipped:he(fe=>{this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),5)}),started:he(fe=>{this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),2)}),errored:he((fe,ve,te)=>{$e(fe,ve),this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),6,te)}),failed:he((fe,ve,te)=>{$e(fe,ve),this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,L).toString(),4,te)}),passed:he((fe,ve)=>{this.s.$updateTestStateInRun(R,O,r.$rJ.fromExtHostTestItem(fe,this.m.controllerId).toString(),3,ve)}),appendOutput:(fe,ve,te)=>{De||(te&&(this.m.isIncluded(te)?this.y(te):te=void 0),this.s.$appendOutputToRun(R,O,P.$fe.fromString(fe),ve&&t.location.from(ve),te&&r.$rJ.fromExtHostTestItem(te,L).toString()))},end:()=>{De||(De=!0,this.s.$finishedTestRunTask(R,O),this.f.delete(O),this.f.size||this.w())}};return this.f.set(O,{run:ke,coverage:Z}),this.s.$startedTestRunTask(R,{id:O,name:N,running:!0}),ke}u(){for(const{run:N}of this.f.values())N.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(N){if(!(N instanceof f.$NM))throw new c.$sM(N.id);if(this.g.has(r.$rJ.fromExtHostTestItem(N,this.m.controllerId).toString()))return;const R=[],L=this.m.colllection.root;for(;;){const O=t.TestItem.from(N);if(R.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),N===L))break;N=N.parent||L}this.s.$addTestsToRun(this.m.controllerId,this.m.id,R)}dispose(){this.w(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(N){this.d=N,this.c=new Map}prepareForMainThreadTestRun(N,R,L,O){return this.f(N,R,L,O)}cancelRunById(N){for(const R of this.c.values())if(R.id===N){R.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,R,L,O,Z,he){const $e=this.c.get(O);if($e)return $e.createRun(Z);const De=k.fromPublic(R,L,O,he),ke=m(O);this.d.$startedExtensionTestRun({controllerId:R,continuous:!!O.continuous,profile:ke&&{group:V[ke.kind],id:ke.profileId},exclude:O.exclude?.map(ve=>r.$rJ.fromExtHostTestItem(ve,L.root.id).toString())??[],id:De.id,include:O.include?.map(ve=>r.$rJ.fromExtHostTestItem(ve,L.root.id).toString())??[L.root.id],persist:he});const fe=this.f(O,De,N);return A.Event.once(fe.onEnd)(()=>{this.d.$finishedExtensionTestRun(De.id),fe.dispose()}),fe.createRun(Z)}f(N,R,L,O){const Z=new g(R,this.d,O);return this.c.set(N,Z),A.Event.once(Z.onEnd)(()=>this.c.delete(N)),Z}}e.$Sfc=p;const m=J=>{if(J.profile){if(!(J.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return J.profile}};class k{static fromPublic(N,R,L,O){return new k(N,(0,l.$ig)(),L.include?.map(Z=>r.$rJ.fromExtHostTestItem(Z,N).toString())??[N],L.exclude?.map(Z=>r.$rJ.fromExtHostTestItem(Z,N).toString())??[],O,R)}static fromInternal(N,R){return new k(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,R)}constructor(N,R,L,O,Z,he){this.controllerId=N,this.id=R,this.isPersisted=Z,this.colllection=he,this.c=L.map($e=>$e+"\0"),this.d=O.map($e=>$e+"\0")}isIncluded(N){const R=r.$rJ.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const L of this.d)if(R===L||R.startsWith(L))return!1;for(const L of this.c)if(R===L||R.startsWith(L))return!0;return!1}}e.$Tfc=k;class C{set coverageProvider(N){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this.c=N,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(N,R,L){this.f=N,this.g=R,this.h=L}async provideFileCoverage(N){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(N))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(R){throw this.d=void 0,R}}async resolveFileCoverage(N,R){const L=await this.d;let O=L?.[N];return!this.c||!L||!O?[]:(O.detailedCoverage||(O=L[N]=await this.c.resolveFileCoverage?.(O,R)??O),O.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,t.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const R=r.$rJ.parentId(N.item.extId);if(R&&this.g.has(R.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:R,f:L}=this;return{get added(){return[...N].map(O=>O.revived)},get updated(){return[...R].map(O=>O.revived)},get removed(){return[...L].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends o.$yJ{constructor(){super(...arguments),this.q=new A.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,R){return{...N,revived:t.TestItem.toPlain(N.item),depth:R?R.depth+1:0,children:new Set}}o(){return new u(this.q)}}class S{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(R=>R.revived)},dispose:(0,$.$cb)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class F{#e;#t;#i;#o;#r;get label(){return this.d}set label(N){N!==this.d&&(this.d=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?t.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}get isSelected(){return(0,h.$MF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,h.$MF)(this.#t,"testingActiveProfile"),A.Event.chain(this.#o,N=>N.map(R=>R.get(this.controllerId)?.get(this.profileId)).filter(D.$Kf))}constructor(N,R,L,O,Z,he,$e,De,ke,fe,ve=!1,te=void 0,Re=!1){this.controllerId=he,this.profileId=$e,this.d=De,this.kind=ke,this.runHandler=fe,this.f=ve,this._tag=te,this.g=Re,this.#e=N,this.#r=R,this.#t=L,this.#i=O,this.#o=Z,R.set($e,this);const se=V[ke];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${ke}`);this.#e.$publishTestRunProfile({profileId:$e,controllerId:he,tag:te?t.TestTag.namespace(this.controllerId,te.id):null,label:De,group:se,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:Re})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$Ufc=F;const V={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[268],Ae([1,0,18,11,5,3,109,8,7]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class d{constructor(D,l){this.i=l,this.a=new P.$Rd({onListenerError:T.$1}),this.b=new P.$Rd({onListenerError:T.$1}),this.c=new P.$Rd({onListenerError:T.$1}),this.d=new P.$Rd({onListenerError:T.$1}),this.f=new P.$Rd({onListenerError:T.$1}),this.g=new P.$Rd({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(M.$yK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const l=this.i.allEditors();return D?l:l.map(b=>b.value)}async showTextDocument(D,l,b){let v;typeof l=="number"?v={position:$.ViewColumn.from(l),preserveFocus:b}:typeof l=="object"?v={position:$.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?$.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:v={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(D.uri,v),t=f&&this.i.getEditor(f);if(t)return t.value;throw f?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,l){return new A.$HM(this.h,D,l).value}$acceptEditorPropertiesChanged(D,l){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(l.options&&b._acceptOptions(l.options),l.selections){const v=l.selections.selections.map($.Selection.to);b._acceptSelections(v)}if(l.visibleRanges){const v=y.$Gb(l.visibleRanges.map($.Range.to));b._acceptVisibleRanges(v)}if(l.options&&this.b.fire({textEditor:b.value,options:{...l.options,lineNumbers:$.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const v=E.TextEditorSelectionChangeKind.fromValue(l.selections.source),f=l.selections.selections.map($.Selection.to);this.a.fire({textEditor:b.value,selections:f,kind:v})}if(l.visibleRanges){const v=y.$Gb(l.visibleRanges.map($.Range.to));this.c.fire({textEditor:b.value,visibleRanges:v})}}$acceptEditorPositionData(D){for(const l in D){const b=this.i.getEditor(l);if(!b)throw new Error("Unknown text editor");const v=$.ViewColumn.to(D[l]);b.value.viewColumn!==v&&(b._acceptViewColumn(v),this.d.fire({textEditor:b.value,viewColumn:v}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$eec=d}),define(Pe[269],Ae([1,0,2,4,3,6,7,8,22,16]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfc=e.$Wfc=void 0,e.$Wfc=(0,T.$Vh)("IExtHostTimeline");class I{constructor(b,v){this.b=new Map,this.c=new Map,this.a=b.getProxy(P.$yK.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(f,t)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&E.$_l.equals(t,this.b.get(f.source)?.extension)){const i=f.uri===void 0?void 0:y.URI.revive(f.uri);return this.c.get(f.source)?.get(D(i))?.get(f.handle)}else return;return f}})}async $getTimeline(b,v,f,t){return this.b.get(b)?.provider.provideTimeline(y.URI.revive(v),f,t)}registerTimelineProvider(b,v,f,t){const i=new M.$Qc,r=this.d(v.id,t,i).bind(this);let c;v.onDidChange&&(c=v.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:v.id}),this));const o=this.c;return this.f({...v,scheme:b,onDidChange:void 0,async provideTimeline(h,n,s){n?.resetCache&&(i.clear(),o.get(v.id)?.clear());const a=await v.provideTimeline(h,n,s);if(a==null)return;const g=r(h,n);return{...a,source:v.id,items:a.items.map(g)}},dispose(){for(const h of o.values())h.get(v.id)?.clear();c?.dispose(),i.dispose()}},f)}d(b,v,f){return(t,i)=>{let r;if(i?.cacheResults){let c=this.c.get(b);c===void 0&&(c=new Map,this.c.set(b,c));const o=D(t);r=c.get(o),r===void 0&&(r=new Map,c.set(o,r))}return c=>{const{iconPath:o,...h}=c,n=`${b}|${c.id??c.timestamp}`;r?.set(n,c);let s,a,g;c.iconPath&&(o instanceof A.$uL?g={id:o.id,color:o.color}:y.URI.isUri(o)?(s=o,a=o):{light:s,dark:a}=o);let p;return A.$1K.isMarkdownString(h.tooltip)?p=$.MarkdownString.from(h.tooltip):(0,d.$Cf)(h.tooltip)?p=h.tooltip:A.$1K.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=$.MarkdownString.from(h.detail)):(0,d.$Cf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=h.detail),{...h,id:h.id??void 0,handle:n,source:b,command:c.command?v.toInternal(c.command,f):void 0,icon:s,iconDark:a,themeIcon:g,tooltip:p,accessibilityInformation:c.accessibilityInformation}}}}f(b,v){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:v}),(0,M.$Pc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Xfc=I;function D(l){return l?.toString()}}),define(Pe[87],Ae([1,0,19,5,6,168,4,15,197,3,27,17,7]),function(we,e,y,T,P,M,A,$,E,d,I,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bxb=e.$axb=e.TunnelDtoConverter=void 0;class b extends E.$mv{}var v;(function(t){function i(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:c.protocol}}t.fromApiTunnel=i;function r(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==E.TunnelPrivacyId.ConstantPrivate&&c.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}t.fromServiceTunnel=r})(v||(e.TunnelDtoConverter=v={})),e.$axb=(0,A.$Vh)("IExtHostTunnelService");let f=class extends P.$Rc{constructor(i,r,c){super(),this.s=c,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(d.$yK.MainThreadTunnelService)}async openTunnel(i,r){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${r.remoteAddress.host}:${r.remoteAddress.port}.`);const c=await this.a.$openTunnel(r,i.displayName);if(c){const o=new b(c.remoteAddress,c.localAddress,()=>this.a.$closeTunnel(c.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,r){const c=this.u();return this.r.set(c,{selector:i,provider:r}),this.a.$registerPortsAttributesProvider(i,c),new l.$AK(()=>{this.r.delete(c),this.a.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(i,r,c,o,h){const n=[];for(const a of i){const g=this.r.get(a);if(!g)return[];n.push(...await Promise.all(r.map(async p=>{let m;try{m=await g.provider.providePortAttributes({port:p,pid:c,commandLine:o},h)}catch{m=await g.provider.providePortAttributes(p,c,o,h)}return{providedAttributes:m,port:p}})))}const s=n.filter(a=>!!a.providedAttributes);return s.length>0?s.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,r){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,h)=>await i.provideTunnel(o,h,new y.$2d().token)??void 0;const c=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,privacyOptions:r.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(c),Promise.resolve((0,P.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,r){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const c=i.tunnelFactory??(r?this.w(r):void 0);if(c){this.b=c;let o=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const h=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,P.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,r){if(this.g.has(i.host)){const c=this.g.get(i.host);c.has(i.port)&&(r&&c.get(i.port).disposeListener.dispose(),await c.get(i.port).tunnel.dispose(),c.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,r){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this.b(i,r);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const o=await c;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const h=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:o,disposeListener:h}),v.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(i){const r=await Promise.all(i.map(o=>this.f(o.host,o.port,o.detail??""))),c=i.filter((o,h)=>r[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(o=>o.port).join(", ")} to ${c.map(o=>o.port).join(", ")}`),c}};e.$bxb=f,e.$bxb=f=Ke([Ve(0,D.$AM),Ve(1,I.$QM),Ve(2,$.$dj)],f)}),define(Pe[270],Ae([1,0,6,13,2,3]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(M.$yK.MainThreadUriOpeners)}registerExternalUriOpener(E,d,I,D){if(this.c.has(d))throw new Error(`Opener with id '${d}' already registered`);const l=D.schemes.find(b=>!A.a.has(b));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(d,I),this.b.$registerUriOpener(d,D.schemes,E,D.label),(0,y.$Pc)(()=>{this.c.delete(d),this.b.$unregisterUriOpener(d)})}async $canOpenUri(E,d,I){const D=this.c.get(E);if(!D)throw new Error(`Unknown opener with id: ${E}`);const l=P.URI.revive(d);return D.canOpenExternalUri(l,I)}async $openUri(E,d,I){const D=this.c.get(E);if(!D)throw new Error(`Unknown opener id: '${E}'`);return D.openExternalUri(P.URI.revive(d.resolvedUri),{sourceUri:P.URI.revive(d.sourceUri)},I)}}e.$Zfc=A}),define(Pe[271],Ae([1,0,3,2,6,11,22]),function(we,e,y,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;class ${static{this.a=0}constructor(d){this.c=new A.$am,this.d=new Map,this.b=d.getProxy(y.$yK.MainThreadUrls)}registerUriHandler(d,I){const D=d.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const l=$.a++;return this.c.add(D),this.d.set(l,I),this.b.$registerUriHandler(l,D,d.displayName||d.name),(0,P.$Pc)(()=>{this.c.delete(D),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(d,I){const D=this.d.get(d);if(!D)return Promise.resolve(void 0);try{D.handleUri(T.URI.revive(I))}catch(l){(0,M.$Z)(l)}return Promise.resolve(void 0)}async createAppUri(d){return T.URI.revive(await this.b.$createAppUri(d))}}e.$1fc=$}),define(Pe[65],Ae([1,0,5,6,13,26,2,182,204,78,3]),function(we,e,y,T,P,M,A,$,E,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=e.$vec=e.$uec=e.$tec=e.$sec=void 0;class D{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,h,n,s,a,g,p){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new y.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Rd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=h,this.#s=n,this.#o=s,this.#r=a,this.#n=g,this.#l=l(g),this.#d=b(g),this.#i=p}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,d.$jub)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===P.Schemas.https||o.scheme===P.Schemas.http){let h=o.toString();return h.endsWith("/")||(h+="/"),h+" "+d.$iub}return d.$iub}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),M.$en(this.#s,o)||this.#t.$setOptions(this.#e,t(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const h=(0,E.$Fcb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const h=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,n=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,g,p,m,k)=>{const C=A.URI.from({scheme:p||"file",path:decodeURIComponent(m)}),u=(0,d.$jub)(C,{isRemote:h,authority:n}).toString();return`${a}${u}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,a,g,p,m,k)=>{const C=A.URI.from({scheme:p||"file",path:decodeURIComponent(m)}),u=(0,d.$jub)(C,{isRemote:h,authority:n}).toString();return`${a}${u}${k}`})}}e.$sec=D;function l(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$tec=l;function b(c){try{const o=(0,$.$To)((0,$.$So)(c.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class v extends T.$Rc{constructor(o,h,n,s,a){super(),this.c=h,this.f=n,this.g=s,this.h=a,this.b=new Map,this.a=o.getProxy(I.$yK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,h,n){const s=this.j(o);if(s){const{message:a}=(0,E.$Gcb)(h,n.value);s._onMessageEmitter.fire(a)}}$onMissingCsp(o,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,h,n){const s=new D(o,this.a,i(h),this.c,this.f,n,this.h);this.b.set(o,s);const a=s._onDidDispose(()=>{a.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$uec=v;function f(c){return{id:c.identifier,location:c.extensionLocation}}e.$vec=f;function t(c,o,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||r(c,o)}}e.$wec=t;function i(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(o=>A.URI.from(o))}}function r(c,o){return[...(o?.getWorkspaceFolders()||[]).map(h=>h.uri),c.extensionLocation]}}),define(Pe[272],Ae([1,0,19,97,6,13,25,2,8,65,75,3,7]),function(we,e,y,T,P,M,A,$,E,d,I,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class b{constructor(s,a){this.document=s,this.b=a,this.a=1,this.c=new I.$Xdc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,a){await this.f(s).undo(),a||this.disposeBackup()}async redo(s,a){await this.f(s).redo(),a||this.disposeBackup()}disposeEdits(s){for(const a of s)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=h(this.document.uri)+this.a++;return(0,A.$zg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const a=this.c.get(s,0);if(!a)throw new Error("No edit found");return a}}class v{constructor(){this.a=new Map}get(s,a){return this.a.get(this.b(s,a))}add(s,a,g){const p=this.b(s,a.uri);if(this.a.has(p))throw new Error(`Document already exists for viewType:${s} resource:${a.uri}`);const m=new b(a,g);return this.a.set(p,m),m}delete(s,a){const g=this.b(s,a.uri);this.a.delete(g)}b(s,a){return`${s}@@@${a}`}}var f;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(f||(f={}));class t{constructor(){this.a=new Map}addTextProvider(s,a,g){return this.b(0,s,a,g)}addCustomProvider(s,a,g){return this.b(1,s,a,g)}get(s){return this.a.get(s)}b(s,a,g,p){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:s,extension:g,provider:p}),new l.$AK(()=>this.a.delete(a))}}class i{constructor(s,a,g,p,m){this.d=a,this.f=g,this.g=p,this.h=m,this.b=new t,this.c=new v,this.a=s.getProxy(D.$yK.MainThreadCustomEditors)}registerCustomEditorProvider(s,a,g,p){const m=new P.$Qc;return c(g)?(m.add(this.b.addTextProvider(a,s,g)),this.a.$registerTextEditorProvider((0,d.$vec)(s),a,p.webviewOptions||{},{supportsMove:!!g.moveCustomTextEditor},(0,d.$tec)(s))):(m.add(this.b.addCustomProvider(a,s,g)),r(g)&&m.add(g.onDidChangeCustomDocument(k=>{const C=this.i(a,k.document.uri);if(o(k)){const u=C.addEdit(k);this.a.$onDidEdit(k.document.uri,a,u,k.label)}else this.a.$onContentChange(k.document.uri,a)})),this.a.$registerCustomEditorProvider((0,d.$vec)(s),a,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,d.$tec)(s))),l.$AK.from(m,new l.$AK(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(s,a,g,p,m){const k=this.b.get(a);if(!k)throw new Error(`No provider found for '${a}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${a}'`);const C=$.URI.revive(s),u=await k.provider.openCustomDocument(C,{backupId:g,untitledDocumentData:p?.buffer},m);let w;return r(k.provider)&&this.f&&(w=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(a,u,w),{editable:r(k.provider)}}async $disposeCustomDocument(s,a){const g=this.b.get(a);if(!g)throw new Error(`No provider found for '${a}'`);if(g.type!==1)throw new Error(`Invalid provider type for '${a}'`);const p=$.URI.revive(s),{document:m}=this.i(a,p);this.c.delete(a,m),m.dispose()}async $resolveCustomEditor(s,a,g,p,m,k){const C=this.b.get(g);if(!C)throw new Error(`No provider found for '${g}'`);const u=E.ViewColumn.to(m),w=this.g.createNewWebview(a,p.contentOptions,C.extension),S=this.h.createNewWebviewPanel(a,g,p.title,u,p.options,w,p.active),F=$.URI.revive(s);switch(C.type){case 1:{const{document:V}=this.i(g,F);return C.provider.resolveCustomEditor(V,S,k)}case 0:{const V=this.d.getDocument(F);return C.provider.resolveCustomTextEditor(V,S,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,a,g){this.i(a,s).disposeEdits(g)}async $onMoveCustomEditor(s,a,g){const p=this.b.get(g);if(!p)throw new Error(`No provider found for '${g}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${g}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const k=$.URI.revive(a),C=this.d.getDocument(k);await p.provider.moveCustomTextEditor(C,m,y.CancellationToken.None)}async $undo(s,a,g,p){return this.i(a,s).undo(g,p)}async $redo(s,a,g,p){return this.i(a,s).redo(g,p)}async $revert(s,a,g){const p=this.i(a,s);await this.j(a).revertCustomDocument(p.document,g),p.disposeBackup()}async $onSave(s,a,g){const p=this.i(a,s);await this.j(a).saveCustomDocument(p.document,g),p.disposeBackup()}async $onSaveAs(s,a,g,p){const m=this.i(a,s);return this.j(a).saveCustomDocumentAs(m.document,$.URI.revive(g),p)}async $backup(s,a,g){const p=this.i(a,s),k=await this.j(a).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},g);return p.updateBackup(k),k.id}i(s,a){const g=this.c.get(s,$.URI.revive(a));if(!g)throw new Error("No custom document found");return g}j(s){const g=this.b.get(s)?.provider;if(!g||!r(g))throw new Error("Custom document is not editable");return g}}e.$yec=i;function r(n){return!!n.onDidChangeCustomDocument}function c(n){return typeof n.resolveCustomTextEditor=="function"}function o(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function h(n){const s=n.scheme===M.Schemas.file||n.scheme===M.Schemas.untitled?n.fsPath:n.toString();return(0,T.$Ji)(s)+""}}),define(Pe[273],Ae([1,0,5,6,2,33,8,65,3,7]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class I extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(v,f,t,i){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new y.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=f,this.#o=t,this.#i=i.viewType,this.#r=i.panelOptions,this.#s=i.viewColumn,this.#n=i.title,this.#u=i.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(v){this.c(),this.#n!==v&&(this.#n=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,P.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#s=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:A.ViewColumn.from(v),preserveFocus:!!f})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends T.$Rc{static c(){return(0,M.$ig)()}constructor(v,f,t){super(),this.j=f,this.m=t,this.g=new Map,this.h=new Map,this.f=v.getProxy(E.$yK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,f,t,i,r={}){const c=typeof i=="object"?i.viewColumn:i,o={viewColumn:A.ViewColumn.from(c),preserveFocus:typeof i=="object"&&!!i.preserveFocus},h=(0,$.$tec)(v),n=D.c();this.f.$createWebviewPanel((0,$.$vec)(v),n,f,{title:t,panelOptions:l(r),webviewOptions:(0,$.$wec)(v,this.m,r),serializeBuffersForPostMessage:h},o);const s=this.j.createNewWebview(n,r,v);return this.createNewWebviewPanel(n,f,t,c,r,s,!0)}$onDidChangeWebviewPanelViewStates(v){const f=Object.keys(v);f.sort((t,i)=>{const r=v[t],c=v[i];return r.active?1:c.active?-1:+r.visible-+c.visible});for(const t of f){const i=this.getWebviewPanel(t);if(!i)continue;const r=v[t];i._updateViewState({active:r.active,visible:r.visible,viewColumn:A.ViewColumn.to(r.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,f,t){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:t,extension:v}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,$.$tec)(v)}),new d.$AK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(v,f,t,i){const r=this.h.get(f);if(!r)throw new Error(`No serializer found for '${f}'`);const{serializer:c,extension:o}=r,h=this.j.createNewWebview(v,t.webviewOptions,o),n=this.createNewWebviewPanel(v,f,t.title,i,t.panelOptions,h,t.active);await c.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(v,f,t,i,r,c,o){const h=new I(v,this.f,c,{viewType:f,title:t,viewColumn:i,panelOptions:r,active:o});return this.g.set(v,h),h}getWebviewPanel(v){return this.g.get(v)}}e.$xec=D;function l(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Pe[274],Ae([1,0,5,6,65,8,3,7]),function(we,e,y,T,P,M,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;class E extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(D,l,b,v,f,t){super(),this.#r=!1,this.#u=this.B(new y.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new y.$Rd),this.onDidDispose=this.#l.event,this.#i=b,this.#a=v,this.#e=D,this.#t=l,this.#o=f,this.#n=t}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#s}set description(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#r||(this.#n=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#r)throw new Error("Webview is disposed")}}class d{constructor(D,l){this.d=l,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$yK.MainThreadWebviewViews)}registerWebviewViewProvider(D,l,b,v){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:b,extension:D}),this.a.$registerWebviewViewProvider((0,P.$vec)(D),l,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$tec)(D)}),new $.$AK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(D,l,b,v,f){const t=this.b.get(l);if(!t)throw new Error(`No view provider found for '${l}'`);const{provider:i,extension:r}=t,c=this.d.createNewWebview(D,{},r),o=new E(D,this.a,l,b,c,!0);this.c.set(D,o),await i.resolveWebviewView(o,{state:v},f)}async $onDidChangeWebviewViewVisibility(D,l){this.e(D)._setVisible(l)}async $disposeWebviewView(D){const l=this.e(D);this.c.delete(D),l.dispose(),this.d.deleteWebview(D)}e(D){const l=this.c.get(D);if(!l)throw new Error("No webview found");return l}}e.$2fc=d}),define(Pe[111],Ae([1,0,5,3,2,13,12,4,17,23]),function(we,e,y,T,P,M,A,$,E,d){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=e.$3fc=void 0;let D=class{static{I=this}static{this.a={focused:!0,active:!0}}getState(b){const v=this.d;return{get focused(){return v.focused},get active(){return(0,d.$MF)(b,"windowActivity"),v.active}}}constructor(b){this.c=new y.$Rd,this.onDidChangeWindowState=this.c.event,this.d=I.a,this.b=b.getProxy(T.$yK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:f})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,v){v!==this.d[b]&&(this.d={...this.d,[b]:v},this.c.fire(this.d))}openUri(b,v){let f;if(typeof b=="string"){f=b;try{b=P.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Fe)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,f,v)}async asExternalUri(b,v){if((0,A.$Fe)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(b,v);return P.URI.from(f)}};e.$3fc=D,e.$3fc=D=I=Ke([Ve(0,E.$AM)],D),e.$4fc=(0,$.$Vh)("IExtHostWindow")}),define(Pe[275],Ae([1,0,241,27,17]),function(we,e,y,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;let M=class extends y.$7fc{constructor($,E){super($,E)}f($,E,d){E.apply(console,d)}};e.$cic=M,e.$cic=M=Ke([Ve(0,P.$AM),Ve(1,T.$QM)],M)}),define(Pe[276],Ae([1,0,14,24,19,11,5,6,139,230,49]),function(we,e,y,T,P,M,A,$,E,d,I){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=e.ResponsiveState=e.RequestInitiator=e.$g6b=e.$f6b=void 0;function l(S,F){try{return JSON.stringify(S,F)}catch{return"null"}}const b="$$ref$$",v={[b]:-1};class f{constructor(F,V){this.jsonString=F,this.referencedBuffers=V}}function t(S,F=null,V=!1){const J=[];return{jsonString:(V?l:JSON.stringify)(S,(R,L)=>{if(typeof L>"u")return v;if(typeof L=="object"){if(L instanceof T.$fe){const O=J.push(L)-1;return{[b]:O}}if(F)return F(R,L)}return L}),referencedBuffers:J}}e.$f6b=t;function i(S,F,V){return JSON.parse(S,(J,N)=>{if(N){const R=N[b];if(typeof R=="number")return F[R];if(V&&N.$mid===1)return V.transformIncoming(N)}return N})}e.$g6b=i;function r(S,F){return JSON.stringify(S,F)}function c(S){return S?(F,V)=>V&&V.$mid===1?S.transformOutgoing(V):V:null}var o;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var h;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const n=()=>{},s=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class g extends $.$Rc{static{D=s}static{this.a=3*1e3}constructor(F,V=null,J=null){super(),this[D]=!0,this.b=this.B(new A.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=F,this.f=V,this.g=J,this.h=c(this.g),this.j=!1,this.m=[],this.s=[];for(let N=0,R=I.$tv.count;N<R;N++)this.m[N]=null,this.s[N]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$0g(()=>this.H(),1e3)),this.c.onMessage(N=>this.L(N))}dispose(){this.j=!0,Object.keys(this.w).forEach(F=>{const V=this.w[F];delete this.w[F],V.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(F){this.z===0&&(this.C=Date.now()+g.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(F){this.C=Date.now()+g.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(F){this.y!==F&&(this.y=F,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(F){return this.g?(0,E.$Um)(F,this.g):F}getProxy(F){const{nid:V,sid:J}=F;return this.s[V]||(this.s[V]=this.J(V,J)),this.s[V]}J(F,V){const J={get:(N,R)=>(typeof R=="string"&&!N[R]&&R.charCodeAt(0)===36&&(N[R]=(...L)=>this.U(F,R,L)),R===a?V:N[R])};return new Proxy(Object.create(null),J)}set(F,V){return this.m[F.nid]=V,V}assertRegistered(F){for(let V=0,J=F.length;V<J;V++){const N=F[V];if(!this.m[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}L(F){if(this.j)return;const V=F.byteLength,J=m.read(F,0),N=J.readUInt8(),R=J.readUInt32();switch(N){case 1:case 2:{let{rpcId:L,method:O,args:Z}=C.deserializeRequestJSONArgs(J);this.g&&(Z=(0,E.$Um)(Z,this.g)),this.M(V,R,L,O,Z,N===2);break}case 3:case 4:{let{rpcId:L,method:O,args:Z}=C.deserializeRequestMixedArgs(J);this.g&&(Z=(0,E.$Um)(Z,this.g)),this.M(V,R,L,O,Z,N===4);break}case 5:{this.f?.logIncoming(V,R,0,"ack"),this.G(R);break}case 6:{this.N(V,R);break}case 7:{this.O(V,R,void 0);break}case 9:{let L=C.deserializeReplyOKJSON(J);this.g&&(L=(0,E.$Um)(L,this.g)),this.O(V,R,L);break}case 10:{const L=C.deserializeReplyOKJSONWithBuffers(J,this.g);this.O(V,R,L);break}case 8:{const L=C.deserializeReplyOKVSBuffer(J);this.O(V,R,L);break}case 11:{let L=C.deserializeReplyErrError(J);this.g&&(L=(0,E.$Um)(L,this.g)),this.P(V,R,L);break}case 12:{this.P(V,R,void 0);break}default:console.error("received unexpected message"),console.error(F)}}M(F,V,J,N,R,L){this.f?.logIncoming(F,V,1,`receiveRequest ${(0,I.$vv)(J)}.${N}(`,R);const O=String(V);let Z,he;if(L){const De=new P.$2d;R.push(De.token),Z=this.Q(J,N,R),he=()=>De.cancel()}else Z=this.Q(J,N,R),he=n;this.u[O]=he;const $e=C.serializeAcknowledged(V);this.f?.logOutgoing($e.byteLength,V,1,"ack"),this.c.send($e),Z.then(De=>{delete this.u[O];const ke=C.serializeReplyOK(V,De,this.h);this.f?.logOutgoing(ke.byteLength,V,1,"reply:",De),this.c.send(ke)},De=>{delete this.u[O];const ke=C.serializeReplyErr(V,De);this.f?.logOutgoing(ke.byteLength,V,1,"replyErr:",De),this.c.send(ke)})}N(F,V){this.f?.logIncoming(F,V,1,"receiveCancel");const J=String(V);this.u[J]?.()}O(F,V,J){this.f?.logIncoming(F,V,0,"receiveReply:",J);const N=String(V);if(!this.w.hasOwnProperty(N))return;const R=this.w[N];delete this.w[N],R.resolveOk(J)}P(F,V,J){this.f?.logIncoming(F,V,0,"receiveReplyErr:",J);const N=String(V);if(!this.w.hasOwnProperty(N))return;const R=this.w[N];delete this.w[N];let L;J&&(J.$isError?(L=new Error,L.name=J.name,L.message=J.message,L.stack=J.stack):L=J),R.resolveErr(L)}Q(F,V,J){try{return Promise.resolve(this.S(F,V,J))}catch(N){return Promise.reject(N)}}S(F,V,J){const N=this.m[F];if(!N)throw new Error("Unknown actor "+(0,I.$vv)(F));const R=N[V];if(typeof R!="function")throw new Error("Unknown method "+V+" on actor "+(0,I.$vv)(F));return R.apply(N,J)}U(F,V,J){if(this.j)return new d.$e6b;let N=null;if(J.length>0&&P.CancellationToken.isCancellationToken(J[J.length-1])&&(N=J.pop()),N&&N.isCancellationRequested)return Promise.reject(M.$5());const R=C.serializeRequestArguments(J,this.h),L=++this.t,O=String(L),Z=new d.$d6b,he=new $.$Qc;N&&he.add(N.onCancellationRequested(()=>{const De=C.serializeCancel(L);this.f?.logOutgoing(De.byteLength,L,0,"cancel"),this.c.send(C.serializeCancel(L))})),this.w[O]=new p(Z,he),this.F(L);const $e=C.serializeRequest(L,F,V,R,!!N);return this.f?.logOutgoing($e.byteLength,L,0,`request: ${(0,I.$vv)(F)}.${V}(`,J),this.c.send($e),Z}}e.$h6b=g;class p{constructor(F,V){this.a=F,this.b=V}resolveOk(F){this.a.resolveOk(F),this.b.dispose()}resolveErr(F){this.a.resolveErr(F),this.b.dispose()}}class m{static alloc(F,V,J){const N=new m(T.$fe.alloc(J+1+4),0);return N.writeUInt8(F),N.writeUInt32(V),N}static read(F,V){return new m(F,V)}get buffer(){return this.a}constructor(F,V){this.a=F,this.b=V}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(F){this.a.writeUInt8(F,this.b),this.b+=1}readUInt8(){const F=this.a.readUInt8(this.b);return this.b+=1,F}writeUInt32(F){this.a.writeUInt32BE(F,this.b),this.b+=4}readUInt32(){const F=this.a.readUInt32BE(this.b);return this.b+=4,F}static sizeShortString(F){return 1+F.byteLength}writeShortString(F){this.a.writeUInt8(F.byteLength,this.b),this.b+=1,this.a.set(F,this.b),this.b+=F.byteLength}readShortString(){const F=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+F).toString();return this.b+=F,J}static sizeLongString(F){return 4+F.byteLength}writeLongString(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readLongString(){const F=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+F).toString();return this.b+=F,J}writeBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}static sizeVSBuffer(F){return 4+F.byteLength}writeVSBuffer(F){this.a.writeUInt32BE(F.byteLength,this.b),this.b+=4,this.a.set(F,this.b),this.b+=F.byteLength}readVSBuffer(){const F=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+F);return this.b+=F,V}static sizeMixedArray(F){let V=0;V+=1;for(let J=0,N=F.length;J<N;J++){const R=F[J];switch(V+=1,R.type){case 1:V+=this.sizeLongString(R.value);break;case 2:V+=this.sizeVSBuffer(R.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(R.value);for(let L=0;L<R.buffers.length;++L)V+=this.sizeVSBuffer(R.buffers[L]);break;case 4:break}}return V}writeMixedArray(F){this.a.writeUInt8(F.length,this.b),this.b+=1;for(let V=0,J=F.length;V<J;V++){const N=F[V];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let R=0;R<N.buffers.length;++R)this.writeBuffer(N.buffers[R]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const F=this.a.readUInt8(this.b);this.b+=1;const V=new Array(F);for(let J=0;J<F;J++)switch(this.readUInt8()){case 1:V[J]=this.readLongString();break;case 2:V[J]=this.readVSBuffer();break;case 3:{const R=this.readUInt32(),L=this.readLongString(),O=[];for(let Z=0;Z<R;++Z)O.push(this.readVSBuffer());V[J]=new I.$wv(i(L,O,null));break}case 4:V[J]=void 0;break}return V}}var k;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(k||(k={}));class C{static a(F){for(let V=0,J=F.length;V<J;V++)if(F[V]instanceof T.$fe||F[V]instanceof I.$wv||typeof F[V]>"u")return!0;return!1}static serializeRequestArguments(F,V){if(this.a(F)){const J=[];for(let N=0,R=F.length;N<R;N++){const L=F[N];if(L instanceof T.$fe)J[N]={type:2,value:L};else if(typeof L>"u")J[N]={type:4};else if(L instanceof I.$wv){const{jsonString:O,referencedBuffers:Z}=t(L.value,V);J[N]={type:3,value:T.$fe.fromString(O),buffers:Z}}else J[N]={type:1,value:T.$fe.fromString(r(L,V))}}return{type:1,args:J}}return{type:0,args:r(F,V)}}static serializeRequest(F,V,J,N,R){switch(N.type){case 0:return this.b(F,V,J,N.args,R);case 1:return this.c(F,V,J,N.args,R)}}static b(F,V,J,N,R){const L=T.$fe.fromString(J),O=T.$fe.fromString(N);let Z=0;Z+=m.sizeUInt8(),Z+=m.sizeShortString(L),Z+=m.sizeLongString(O);const he=m.alloc(R?2:1,F,Z);return he.writeUInt8(V),he.writeShortString(L),he.writeLongString(O),he.buffer}static deserializeRequestJSONArgs(F){const V=F.readUInt8(),J=F.readShortString(),N=F.readLongString();return{rpcId:V,method:J,args:JSON.parse(N)}}static c(F,V,J,N,R){const L=T.$fe.fromString(J);let O=0;O+=m.sizeUInt8(),O+=m.sizeShortString(L),O+=m.sizeMixedArray(N);const Z=m.alloc(R?4:3,F,O);return Z.writeUInt8(V),Z.writeShortString(L),Z.writeMixedArray(N),Z.buffer}static deserializeRequestMixedArgs(F){const V=F.readUInt8(),J=F.readShortString(),N=F.readMixedArray(),R=new Array(N.length);for(let L=0,O=N.length;L<O;L++){const Z=N[L];typeof Z=="string"?R[L]=JSON.parse(Z):R[L]=Z}return{rpcId:V,method:J,args:R}}static serializeAcknowledged(F){return m.alloc(5,F,0).buffer}static serializeCancel(F){return m.alloc(6,F,0).buffer}static serializeReplyOK(F,V,J){if(typeof V>"u")return this.d(F);if(V instanceof T.$fe)return this.e(F,V);if(V instanceof I.$wv){const{jsonString:N,referencedBuffers:R}=t(V.value,J,!0);return this.g(F,N,R)}else return this.f(F,l(V,J))}static d(F){return m.alloc(7,F,0).buffer}static e(F,V){let J=0;J+=m.sizeVSBuffer(V);const N=m.alloc(8,F,J);return N.writeVSBuffer(V),N.buffer}static deserializeReplyOKVSBuffer(F){return F.readVSBuffer()}static f(F,V){const J=T.$fe.fromString(V);let N=0;N+=m.sizeLongString(J);const R=m.alloc(9,F,N);return R.writeLongString(J),R.buffer}static g(F,V,J){const N=T.$fe.fromString(V);let R=0;R+=m.sizeUInt32,R+=m.sizeLongString(N);for(const O of J)R+=m.sizeVSBuffer(O);const L=m.alloc(10,F,R);L.writeUInt32(J.length),L.writeLongString(N);for(const O of J)L.writeBuffer(O);return L.buffer}static deserializeReplyOKJSON(F){const V=F.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(F,V){const J=F.readUInt32(),N=F.readLongString(),R=[];for(let L=0;L<J;++L)R.push(F.readVSBuffer());return new I.$wv(i(N,R,V))}static serializeReplyErr(F,V){const J=V?l(M.$2(V),null):void 0;if(typeof J!="string")return this.h(F);const N=T.$fe.fromString(J);let R=0;R+=m.sizeLongString(N);const L=m.alloc(11,F,R);return L.writeLongString(N),L.buffer}static deserializeReplyErrError(F){const V=F.readLongString();return JSON.parse(V)}static h(F){return m.alloc(12,F,0).buffer}}var u;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var w;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(w||(w={}))}),define(Pe[277],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;const y=function(M){const A=$=>{globalThis.removeEventListener("message",A);const E=$.data;Object.defineProperties(globalThis,{postMessage:{value(d,I){E.postMessage(d,I)}},onmessage:{get(){return E.onmessage},set(d){E.onmessage=d}}}),E.addEventListener("message",d=>{globalThis.dispatchEvent(new MessageEvent("message",{data:d.data,ports:d.ports?[...d.ports]:void 0}))}),E.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(M,A,$){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${y})('${A}'))`,d=new Blob([E],{type:"application/javascript"}),I=URL.createObjectURL(d),D=new MessageChannel,l=I,b={type:"_newWorker",id:l,port:D.port2,url:I,options:$};M(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{M({type:"_terminateWorker",id:l}),URL.revokeObjectURL(I),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(v){D.port1.onmessage=v}},onmessageerror:{get(){return D.port1.onmessageerror},set(v){D.port1.onmessageerror=v}}}),D.port1.addEventListener("messageerror",v=>{const f=new MessageEvent("messageerror",{data:v.data});this.dispatchEvent(f)}),D.port1.addEventListener("message",v=>{const f=new MessageEvent("message",{data:v.data});this.dispatchEvent(f)}),D.port1.start()}}e.$eic=T}),define(Pe[278],Ae([1,0,5,30,35,4]),function(we,e,y,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UJ=e.$TJ=e.OutputChannelUpdateMode=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=void 0,e.$JJ="text/x-code-output",e.$KJ="output",e.$LJ="Log",e.$MJ="text/x-code-log-output",e.$NJ="log",e.$OJ="workbench.panel.output",e.$PJ=new P.$aj("inOutput",!1),e.$QJ=new P.$aj("activeLogOutput",!1),e.$RJ=new P.$aj("outputView.scrollLock",!1),e.$SJ=(0,M.$Vh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$TJ={OutputChannels:"workbench.contributions.outputChannels"};class ${constructor(){this.a=new Map,this.b=new y.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new y.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(d){this.a.has(d.id)||(this.a.set(d.id,d),this.b.fire(d.id))}getChannels(){const d=[];return this.a.forEach(I=>d.push(I)),d}getChannel(d){return this.a.get(d)}removeChannel(d){this.a.delete(d),this.c.fire(d)}}T.$mn.add(e.$TJ.OutputChannels,new $),e.$UJ=new P.$aj("activeOutputChannel","")}),define(Pe[112],Ae([1,0,3,4,17,22,15,278,63,27,42,136,24,16,41,5,6]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=e.$Cfc=void 0;class i extends A.$jj{get disposed(){return this.n}constructor(h,n,s,a,g){super(),this.id=h,this.name=n,this.r=s,this.s=a,this.extension=g,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Clear,h)}replace(h){const n=this.m;this.info(h),this.s.$update(this.id,$.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(h,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:n))}hide(){this.s.$close(this.id)}g(h,n){this.m+=l.$fe.fromString(n).byteLength,(0,A.log)(this.r,h,n),this.visible&&(this.r.flush(),this.s.$update(this.id,$.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class r extends i{appendLine(h){this.append(h)}}let c=class{constructor(h,n,s,a,g,p){this.i=n,this.j=s,this.k=a,this.l=g,this.m=p,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(y.$yK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,D.$km)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[n,s]of this.g)s.visible=n===this.h}createOutputChannel(h,n,s){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof n=="object"&&n.log,g=(0,b.$Cf)(n)?n:void 0;if((0,b.$Cf)(g)&&!g.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const m=this.i.environment.extensionLogLevel?.find(([C])=>M.$_l.equals(s.identifier,C))?.[1];m&&(p=(0,A.$tj)(m));const k=a?this.o(h,p,s):this.n(h,g,s);return k.then(C=>{this.g.set(C.id,C),C.visible=C.id===this.h}),a?this.r(h,p??this.m.getLevel(),k):this.q(h,k)}async n(h,n,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,g=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.l.createLogger(g,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(h,g,n,s.identifier.value);return new i(m,h,p,this.a,s)}async o(h,n,s){const a=await this.p(s),g=h.replace(/[\\/:\*\?"<>\|]/g,""),p=this.k.extUri.joinPath(a,`${g}.log`),m=`${s.identifier.value}.${g}`,k=this.l.createLogger(p,{id:m,name:h,logLevel:n,extensionId:s.identifier.value});return new r(m,h,k,this.a,s)}p(h){let n=this.d.get(h.identifier.value);if(!n){const s=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(s)}catch(a){if((0,v.$uk)(a)!==v.FileSystemProviderErrorCode.FileExists)throw a}return s})())}return n}q(h,n){let s=!1;const a=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return h},append(g){a(),n.then(p=>p.append(g))},appendLine(g){a(),n.then(p=>p.appendLine(g))},clear(){a(),n.then(g=>g.clear())},replace(g){a(),n.then(p=>p.replace(g))},show(g,p){a(),n.then(m=>m.show(g,p))},hide(){a(),n.then(g=>g.hide())},dispose(){s=!0,n.then(g=>g.dispose())}}}r(h,n,s){const a=new t.$Qc,g=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},p=a.add(new f.$Rd);function m(k){n=k,p.fire(k)}return s.then(k=>{a.add(k),k.logLevel!==n&&m(k.logLevel),a.add(k.onDidChangeLogLevel(C=>m(C)))}),{...this.q(h,s),get logLevel(){return n},onDidChangeLogLevel:p.event,trace(k,...C){g(),s.then(u=>u.trace(k,...C))},debug(k,...C){g(),s.then(u=>u.debug(k,...C))},info(k,...C){g(),s.then(u=>u.info(k,...C))},warn(k,...C){g(),s.then(u=>u.warn(k,...C))},error(k,...C){g(),s.then(u=>u.error(k,...C))},dispose(){a.dispose()}}}};e.$Cfc=c,e.$Cfc=c=Ke([Ve(0,P.$AM),Ve(1,d.$QM),Ve(2,E.$pec),Ve(3,I.$2dc),Ve(4,A.$ej),Ve(5,A.$dj)],c),e.$Dfc=(0,T.$Vh)("IExtHostOutputService")}),define(Pe[113],Ae([1,0,4,14]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=void 0,e.$zm=(0,y.$Vh)("remoteAgentService"),e.$Am=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let $=0;$<this.maxSampleCount;$++){const E=await P.getRoundTripTime();if(E===void 0)return;M=Math.min(M,E/2),await(0,T.$Yg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce(($,E)=>$+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce(($,E)=>$+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[279],Ae([1,0,170,54,30,47,40,6,5,113,21,26]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=void 0,e.$oH=Object.freeze({id:"application",order:100,title:(0,y.localize)(0,null),type:"object"}),e.$pH=Object.freeze({id:"workbench",order:7,title:(0,y.localize)(1,null),type:"object"}),e.$qH=Object.freeze({id:"security",scope:1,title:(0,y.localize)(2,null),type:"object",order:7}),e.$rH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new E.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const b=new l;P.$mn.add(e.$rH.ConfigurationMigration,b);let v=class extends $.$Rc{constructor(i,r){super(),this.a=i,this.b=r,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const o of c.added)await this.f(o,b.migrations)})),this.c(b.migrations),this.B(b.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const r of this.b.getWorkspace().folders)await this.f(r,i)}async f(i,r){await Promise.all([r.map(c=>this.g(c,i?.uri))])}async g(i,r){const c=this.a.inspect(i.key,{resource:r}),o=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[h,n]of o){const s=[];for(const g of c.overrideIdentifiers??[]){const p=await this.h(i,{resource:r,overrideIdentifier:g},h);for(const m of p??[]){let k=s.find(([[C,u]])=>C===m[0]&&(0,D.$en)(u.value,m[1].value));k||s.push(k=[m,[]]),k[1].push(g)}}const a=await this.h(i,{resource:r},h,c);for(const g of a??[])s.push([g,[]]);s.length&&await Promise.allSettled(s.map(async([[g,p],m])=>this.a.updateValue(g,p.value,{resource:r,overrideIdentifiers:m},n)))}}async h(i,r,c,o){const h=(o??this.a.inspect(i.key,r))[c];if(h===void 0)return;const n=a=>this.a.inspect(a,r)[c],s=await i.migrateFn(h,n);return Array.isArray(s)?s:[[i.key,s]]}};e.$sH=v,e.$sH=v=Ke([Ve(0,A.$pi),Ve(1,M.$5h)],v);let f=class extends $.$Rc{constructor(i){super(),(async()=>{if(!I.$i&&(await i.getEnvironment())?.os!==1)return;P.$mn.as(T.$rn.Configuration).registerConfiguration({...e.$qH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,y.localize)(3,null)},default:[],markdownDescription:(0,y.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,y.localize)(5,null),scope:2}}})})()}};e.$tH=f,e.$tH=f=Ke([Ve(0,d.$zm)],f)}),define(Pe[280],Ae([1,0,34,13,20,25,178,279,54,4,30]),function(we,e,y,T,P,M,A,$,E,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbb=e.$Ybb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Xbb=e.$Wbb=void 0,e.$Wbb=(0,d.$Vh)("editorResolverService"),e.$Xbb="workbench.editorAssociations";const D=I.$mn.as(E.$rn.Configuration),l={...$.$pH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(l);var b;(function(i){i.builtin="builtin",i.option="option",i.exclusive="exclusive",i.default="default"})(b||(e.RegisteredEditorPriority=b={}));var v;(function(i){i[i.ABORT=1]="ABORT",i[i.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function f(i){switch(i){case b.exclusive:return 5;case b.default:return 4;case b.builtin:return 3;case b.option:default:return 1}}e.$Ybb=f;function t(i,r){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(r.scheme))return!1;const h=typeof i=="string"&&i.indexOf(P.$fc.sep)>=0?`${r.scheme}:${r.path}`:(0,M.$wg)(r);return y.$Bj(typeof i=="string"?i.toLowerCase():i,h.toLowerCase())}e.$Zbb=t}),define(Pe[281],Ae([1,0,46,13,20,21,25,2,4,199,47,217,113]),function(we,e,y,T,P,M,A,$,E,d,I,D,l){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=void 0,e.$aK=(0,E.$Vh)("pathService");let v=b=class{constructor(t,i,r,c){this.d=t,this.e=i,this.f=r,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??t})()}hasValidBasename(t,i,r){return typeof i=="string"||typeof i>"u"?this.a.then(c=>this.h(t,c,i)):this.h(t,i,r)}h(t,i,r){return t.scheme===T.Schemas.file||t.scheme===T.Schemas.vscodeRemote?(0,y.$Zf)(r??(0,A.$wg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return T.Schemas.vscodeRemote;const r=(0,d.$0J)(i.getWorkspace());if(r)return r;const c=i.getWorkspace().folders[0];if(c)return c.uri.scheme;const o=i.getWorkspace().configuration;return o?o.scheme:T.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?P.$ec:P.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const c=t.indexOf("/",2);c===-1?(i=t.substring(2),t="/"):(i=t.substring(2,c),t=t.substring(c)||"/")}return $.URI.from({scheme:T.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$bK=v,e.$bK=v=b=Ke([Ve(1,l.$zm),Ve(2,D.$VJ),Ve(3,I.$5h)],v)}),define(Pe[114],Ae([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$QI=e.$PI=void 0;class y{constructor(A,$){this.line=A,this.character=$}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,$){return new y(0,0)}with(A){return new y(0,0)}}e.$PI=y;class T{constructor(A,$,E,d){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,$),this.end=new y(E,d)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$QI=T;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Pe[43],Ae([1,0,18,34,26,46,12,4,20,11,114,14]),function(we,e,y,T,P,M,A,$,E,d,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.SearchErrorCode=e.$6I=e.$5I=e.SearchSortOrder=e.ViewMode=e.$4I=e.$3I=e.$2I=e.$1I=e.SearchCompletionExitCode=e.$ZI=e.$YI=e.$XI=e.QueryType=e.SearchProviderType=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$RI="workbench.view.search",e.$SI="workbench.panel.search",e.$TI="workbench.view.search",e.$UI="search-result",e.$VI="search.exclude";const l="\u27EA ",b=" characters skipped \u27EB",v=(l.length+b.length+5)*2;e.$WI=(0,$.$Vh)("searchService");var f;(function(fe){fe[fe.file=0]="file",fe[fe.text=1]="text"})(f||(e.SearchProviderType=f={}));var t;(function(fe){fe[fe.File=1]="File",fe[fe.Text=2]="Text"})(t||(e.QueryType=t={}));function i(fe){return!!fe.preview}e.$XI=i;function r(fe){return!!fe.resource}e.$YI=r;function c(fe){return!!fe.message}e.$ZI=c;var o;(function(fe){fe[fe.Normal=0]="Normal",fe[fe.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class h{constructor(ve){this.resource=ve,this.results=[]}}e.$1I=h;class n{constructor(ve,te,Re,se){this.ranges=te,this.webviewIndex=se;const Y=Array.isArray(te)?te:[te];if(Re&&Re.matchLines===1&&s(Y)){ve=(0,A.$vf)(ve,Re.matchLines);let B="",ne=0,pe=0;const re=Math.floor(Re.charsPerLine/5),le=[];for(const ce of Y){const ye=Math.max(ce.startColumn-re,0),_=ce.startColumn+Re.charsPerLine;if(ye>pe+re+v){const de=l+(ye-pe)+b;B+=de+ve.slice(ye,_),ne+=ye-(pe+de.length)}else B+=ve.slice(pe,_);le.push(new g(0,ce.startColumn-ne,ce.endColumn-ne)),pe=_}this.preview={text:B,matches:Array.isArray(this.ranges)?le:le[0]}}else{const B=Array.isArray(te)?te[0].startLineNumber:te.startLineNumber;this.preview={text:ve,matches:(0,y.$1b)(te,ne=>new a(ne.startLineNumber-B,ne.startColumn,ne.endLineNumber-B,ne.endColumn))}}}}e.$2I=n;function s(fe){const ve=fe[0].startLineNumber;for(const te of fe)if(te.startLineNumber!==ve||te.endLineNumber!==ve)return!1;return!0}class a{constructor(ve,te,Re,se){this.startLineNumber=ve,this.startColumn=te,this.endLineNumber=Re,this.endColumn=se}}e.$3I=a;class g extends a{constructor(ve,te,Re){super(ve,te,ve,Re)}}e.$4I=g;var p;(function(fe){fe.List="list",fe.Tree="tree"})(p||(e.ViewMode=p={}));var m;(function(fe){fe.Default="default",fe.FileNames="fileNames",fe.Type="type",fe.Modified="modified",fe.CountDescending="countDescending",fe.CountAscending="countAscending"})(m||(e.SearchSortOrder=m={}));function k(fe,ve=!0){const te=fe&&fe.files&&fe.files.exclude,Re=ve&&fe&&fe.search&&fe.search.exclude;if(!te&&!Re)return;if(!te||!Re)return te||Re;let se=Object.create(null);return se=P.$dn(se,P.$an(te)),se=P.$dn(se,P.$an(Re),!0),se}e.$5I=k;function C(fe,ve){return fe.excludePattern&&T.$Bj(fe.excludePattern,ve)?!1:fe.includePattern||fe.usingSearchPaths?fe.includePattern&&T.$Bj(fe.includePattern,ve)?!0:fe.usingSearchPaths?!!fe.folderQueries&&fe.folderQueries.some(te=>{const Re=te.folder.fsPath;if(M.$2f(ve,Re)){const se=E.$kc(Re,ve);return!te.includePattern||!!T.$Bj(te.includePattern,se)}else return!1}):!1:!0}e.$6I=C;var u;(function(fe){fe[fe.unknownEncoding=1]="unknownEncoding",fe[fe.regexParseError=2]="regexParseError",fe[fe.globParseError=3]="globParseError",fe[fe.invalidLiteral=4]="invalidLiteral",fe[fe.rgProcessError=5]="rgProcessError",fe[fe.other=6]="other",fe[fe.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class w extends Error{constructor(ve,te){super(ve),this.code=te}}e.$7I=w;function S(fe){const ve=fe.message;if((0,d.$3)(fe))return new w(ve,u.canceled);try{const te=JSON.parse(ve);return new w(te.message,te.code)}catch{return new w(ve,u.other)}}e.$8I=S;function F(fe){const ve={message:fe.message,code:fe.code};return new Error(JSON.stringify(ve))}e.$9I=F;function V(fe){return fe.type==="error"?!0:fe.type==="success"}e.$0I=V;function J(fe){return fe.type==="success"}e.$$I=J;function N(fe){return!!fe.path}e.$_I=N;function R(fe,ve){const te=fe.searchPath?fe.searchPath:fe.relativePath;return(0,A.$sf)(te,ve)}e.$aJ=R;class L{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$bJ=L;function O(fe,ve){const te={...fe||{},...ve||{}};return Object.keys(te).filter(Re=>{const se=te[Re];return typeof se=="boolean"&&se})}e.$cJ=O;class Z{constructor(ve,te){this.c=null,this.a={...ve.excludePattern||{},...te.excludePattern||{}},this.b=T.$Cj(this.a);let Re=ve.includePattern;te.includePattern&&(Re?Re={...Re,...te.includePattern}:Re=te.includePattern),Re&&(this.c=T.$Cj(Re))}matchesExcludesSync(ve,te,Re){return!!(this.b&&this.b(ve,te,Re))}includedInQuerySync(ve,te,Re){return!(this.b&&this.b(ve,te,Re)||this.c&&!this.c(ve,te,Re))}includedInQuery(ve,te,Re){const se=this.b(ve,te,Re),Y=()=>this.c?!!this.c(ve,te,Re):!0;return(0,D.$Kg)(se)?se.then(B=>B?!1:Y()):Y()}hasSiblingExcludeClauses(){return he(this.a)}}e.$dJ=Z;function he(fe){for(const ve in fe)if(typeof fe[ve]!="boolean")return!0;return!1}function $e(fe){if(!fe)return;let ve;return te=>(ve||(ve=(fe()||Promise.resolve([])).then(Re=>Re?ke(Re):{})),ve.then(Re=>!!Re[te]))}e.$eJ=$e;function De(fe){if(!fe)return;let ve;return te=>{if(!ve){const Re=fe();ve=Re?ke(Re):{}}return!!ve[te]}}e.$fJ=De;function ke(fe){const ve={};for(const te of fe)ve[te]=!0;return ve}}),define(Pe[36],Ae([1,0,18,14,19,5,6,50,13,121,25,12,2,169,4,15,188,47,42,27,17,8,7,57,43,3,51]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o,h,n,s,a,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=e.$jec=void 0;function m(J,N,R){return new I.$og(L=>w(L,R)).isEqual(J,N)}function k(J,N,R){return m(J.uri,N.uri,R)?0:(0,D.$Ye)(J.uri.toString(),N.uri.toString())}function C(J,N,R){return J.index!==N.index?J.index<N.index?-1:1:m(J.uri,N.uri,R)?(0,D.$Ye)(J.name,N.name):(0,D.$Ye)(J.uri.toString(),N.uri.toString())}function u(J,N,R,L){const O=J.slice(0).sort((he,$e)=>R(he,$e,L)),Z=N.slice(0).sort((he,$e)=>R(he,$e,L));return(0,y.$Db)(O,Z,(he,$e)=>R(he,$e,L))}function w(J,N){const R=N.getCapabilities(J.scheme);return!(R&&R&1024)}class S extends i.$ci{static toExtHostWorkspace(N,R,L,O){if(!N)return{workspace:null,added:[],removed:[]};const{id:Z,name:he,folders:$e,configuration:De,transient:ke,isUntitled:fe}=N,ve=[],te=R;R?$e.forEach((B,ne)=>{const pe=l.URI.revive(B.uri),re=S.o(L||R,pe,O);re?(re.name=B.name,re.index=B.index,ve.push(re)):ve.push({uri:pe,name:B.name,index:ne})}):ve.push(...$e.map(({uri:B,name:ne,index:pe})=>({uri:l.URI.revive(B),name:ne,index:pe}))),ve.sort((B,ne)=>B.index<ne.index?-1:1);const Re=new S(Z,he,ve,!!ke,De?l.URI.revive(De):null,!!fe,B=>w(B,O)),{added:se,removed:Y}=u(te?te.workspaceFolders:[],Re.workspaceFolders,k,O);return{workspace:Re,added:se,removed:Y}}static o(N,R,L){for(let O=0;O<N.folders.length;O++){const Z=N.workspaceFolders[O];if(m(Z.uri,R,L))return Z}}constructor(N,R,L,O,Z,he,$e){super(N,L.map(De=>new i.$di(De)),O,Z,$e),this.t=R,this.u=he,this.q=[],this.s=$.$2h.forUris($e),L.forEach(De=>{this.q.push(De),this.s.set(De.uri,De)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(N,R){return R&&this.s.get(N)&&(N=(0,I.$yg)(N)),this.s.findSubstr(N)}resolveWorkspaceFolder(N){return this.s.get(N)}}let F=class{constructor(N,R,L,O,Z){this.c=new M.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Td,this.B=new Map,this.h=O,this.s=L,this.t=Z,this.j=new d.$Wl,this.k=new T.$Wg,this.o=N.getProxy(g.$yK.MainThreadWorkspace),this.q=N.getProxy(g.$yK.MainThreadMessageService);const he=R.workspace;this.l=he?new S(he.id,he.name,[],!!he.transient,he.configuration?l.URI.revive(he.configuration):null,!!he.isUntitled,$e=>w($e,L)):void 0}$initializeWorkspace(N,R){this.v=R,this.$acceptWorkspaceData(N),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:E.Schemas.untitled,path:(0,I.$wg)((0,I.$yg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(N,R,L,...O){const Z=[];if(Array.isArray(O)&&O.forEach(fe=>{l.URI.isUri(fe.uri)&&!Z.some(ve=>m(ve.uri,fe.uri,this.s))&&Z.push({uri:fe.uri,name:fe.name||(0,I.$vg)(fe.uri)})}),this.n||[R,L].some(fe=>typeof fe!="number"||fe<0)||L===0&&Z.length===0)return!1;const he=this.x?this.x.workspaceFolders:[];if(R+L>he.length)return!1;const $e=he.slice(0);$e.splice(R,L,...Z.map(fe=>({uri:fe.uri,name:fe.name||(0,I.$vg)(fe.uri),index:void 0})));for(let fe=0;fe<$e.length;fe++){const ve=$e[fe];if($e.some((te,Re)=>Re!==fe&&m(ve.uri,te.uri,this.s)))return!1}$e.forEach((fe,ve)=>fe.index=ve);const{added:De,removed:ke}=u(he,$e,C,this.s);if(De.length===0&&ke.length===0)return!1;if(this.o){const fe=N.displayName||N.name;this.o.$updateWorkspaceFolders(fe,R,L,Z).then(void 0,ve=>{this.n=void 0;const te={source:{identifier:N.identifier,label:N.displayName||N.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,fe,ve.toString()),te,[])})}return this.y($e),!0}getWorkspaceFolder(N,R){if(this.x)return this.x.getWorkspaceFolder(N,R)}async getWorkspaceFolder2(N,R){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(N,R)}async resolveWorkspaceFolder(N){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(N)}getPath(){if(!this.x)return;const{folders:N}=this.x;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,R){let L,O="";if(typeof N=="string"?(L=l.URI.file(N),O=N):typeof N<"u"&&(L=N,O=N.fsPath),!L)return O;const Z=this.getWorkspaceFolder(L,!0);if(!Z)return O;typeof R>"u"&&this.x&&(R=this.x.folders.length>1);let he=(0,I.$Bg)(Z.uri,L);return R&&Z.name&&(he=`${Z.name}/${he}`),he}y(N){this.x&&(this.n=S.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:N,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:R,added:L,removed:O}=S.toExtHostWorkspace(N,this.l,this.n,this.s);this.l=R||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:O}))}findFiles(N,R,L,O,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let he;if(R===null?he=!1:R&&(typeof R=="string"?he=R:he=R.pattern),Z&&Z.isCancellationRequested)return Promise.resolve([]);const{includePattern:$e,folder:De}=V(h.GlobPattern.from(N));return this.o.$startFileSearch($e??null,De??null,he??null,L??null,Z).then(ke=>Array.isArray(ke)?ke.map(fe=>l.URI.revive(fe)):[])}async findTextInFiles(N,R,L,O,Z=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const he=this.j.getNext(),$e=typeof R.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:R.previewOptions,{includePattern:De,folder:ke}=V(h.GlobPattern.from(R.include)),fe=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,ve={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!0,fileEncoding:R.encoding,maxResults:R.maxResults,previewOptions:$e,afterContext:R.afterContext,beforeContext:R.beforeContext,includePattern:De,excludePattern:fe},te=!1;if(this.u[he]=Re=>{if(te)return;const se=l.URI.revive(Re.resource);Re.results.forEach(Y=>{const B=(0,p.$sh)(Y);(0,a.$XI)(B)?L({uri:se,preview:{text:B.preview.text,matches:(0,y.$1b)(B.preview.matches,ne=>new n.$CK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,y.$1b)(B.ranges,ne=>new n.$CK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):L({uri:se,text:B.text,lineNumber:B.lineNumber})})},Z.isCancellationRequested)return{};try{const Re=await this.o.$startTextSearch(N,ke??null,ve,he,Z);return delete this.u[he],Re||{}}catch(Re){throw delete this.u[he],Re}}$handleTextSearchResult(N,R){this.u[R]?.(N)}async save(N){const R=await this.o.$save(N,{saveAs:!1});return l.URI.revive(R)}async saveAs(N){const R=await this.o.$save(N,{saveAs:!0});return l.URI.revive(R)}saveAll(N){return this.o.$saveAll(N)}resolveProxy(N){return this.o.$resolveProxy(N)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(N){return this.o.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(N,R){if(this.w.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.w.set(N,R);const L=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,L),(0,A.$Pc)(()=>{this.w.delete(N),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(N,R){this.h.info("Getting edit session identifier for workspaceFolder",N);const L=await this.resolveWorkspaceFolder(l.URI.revive(N));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const O=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!O),!O)return;const Z=await O.provideEditSessionIdentity(L,R);if(this.h.info("Provider returned edit session identifier: ",Z),!!Z)return Z}async $provideEditSessionIdentityMatch(N,R,L,O){this.h.info("Getting edit session identifier for workspaceFolder",N);const Z=await this.resolveWorkspaceFolder(l.URI.revive(N));if(!Z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Z);const he=this.w.get(Z.uri.scheme);if(this.h.info(`Provider for scheme ${Z.uri.scheme} is defined: `,!!he),!he)return;const $e=await he.provideEditSessionIdentityMatch?.(R,L,O);if(this.h.info("Provider returned edit session identifier match result: ",$e),!!$e)return $e}getOnWillCreateEditSessionIdentityEvent(N){return(R,L,O)=>{const Z=function($e){R.call(L,$e)};return Z.extension=N,this.A.event(Z,void 0,O)}}async $onWillCreateEditSessionIdentity(N,R,L){const O=await this.resolveWorkspaceFolder(l.URI.revive(N));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},R,async(Z,he)=>{const $e=Date.now();await Promise.resolve(Z),Date.now()-$e>L&&this.h.warn("SLOW edit session create-participant",he.extension.identifier)}),R.isCancellationRequested}registerCanonicalUriProvider(N,R){if(this.B.has(N))throw new Error(`A provider has already been registered for scheme ${N}`);this.B.set(N,R);const L=this.t.transformOutgoingScheme(N),O=this.z++;return this.o.$registerCanonicalUriProvider(O,L),(0,A.$Pc)(()=>{this.B.delete(N),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(N,R,L){const O=this.B.get(N.scheme);if(!O)return;const Z=await O.provideCanonicalUri?.(l.URI.revive(N),R,L);if(Z)return Z}async $provideCanonicalUri(N,R,L){return this.provideCanonicalUri(l.URI.revive(N),{targetScheme:R},L)}};e.$jec=F,e.$jec=F=Ke([Ve(0,o.$AM),Ve(1,c.$QM),Ve(2,r.$2dc),Ve(3,f.$dj),Ve(4,s.$hec)],F),e.$kec=(0,v.$Vh)("IExtHostWorkspace");function V(J){let N,R;return J&&(typeof J=="string"?N=J:(N=J.pattern,R=l.URI.revive(J.baseUri))),{includePattern:N,folder:R}}}),define(Pe[37],Ae([1,0,26,5,36,3,7,190,54,16,14,4,17,15,2]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=e.$mec=e.$lec=void 0;function f(s,a){if(a){const g=a.split(".");let p=s;for(let m=0;p&&m<g.length;m++)p=p[g[m]];return p}}function t(s){return s instanceof v.URI}function i(s){return s&&s.uri instanceof v.URI&&s.languageId&&typeof s.languageId=="string"}function r(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&s.uri instanceof v.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function o(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(r(s))return{overrideIdentifier:s.languageId};if(c(s))return{resource:s.uri};if(s===null)return{resource:null}}let h=class{constructor(a,g,p){this.a=a.getProxy(M.$yK.MainThreadConfiguration),this.c=g,this.b=p,this.d=new I.$Wg,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new n(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,g){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(a,g))}};e.$lec=h,e.$lec=h=Ke([Ve(0,l.$AM),Ve(1,P.$kec),Ve(2,b.$dj)],h);class n{constructor(a,g,p,m){this.a=new T.$Rd,this.b=a,this.f=m,this.c=g,this.e=$.$Kn.parse(p),this.d=this.k(p.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,g){const p={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Kn.parse(a),this.d=this.k(a.configurationScopes),this.a.fire(this.j(g,p))}getConfiguration(a,g,p){const m=o(g)||{},k=this.g(a?f(this.e.getValue(void 0,m,this.c.workspace),a):this.e.getValue(void 0,m,this.c.workspace));a&&this.h(a,m,p?.identifier);function C(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(w){return typeof f(k,w)<"u"},get:(w,S)=>{this.h(a?`${a}.${w}`:w,m,p?.identifier);let F=f(k,w);if(typeof F>"u")F=S;else{let V;const J=(N,R)=>{if((0,d.$Ef)(N)){let L;const O=()=>{V=V||(0,y.$an)(k),L=L||f(V,R)};return new Proxy(N,{get:(Z,he)=>{if(typeof he=="string"&&he.toLowerCase()==="tojson")return O(),()=>L;if(V)return L=L||f(V,R),L[he];const $e=Z[he];return typeof he=="string"?J($e,`${R}.${he}`):$e},set:(Z,he,$e)=>(O(),L&&(L[he]=$e),!0),deleteProperty:(Z,he)=>(O(),L&&delete L[he],!0),defineProperty:(Z,he,$e)=>(O(),L&&Object.defineProperty(L,he,$e),!0)})}return Array.isArray(N)?(0,y.$an)(N):N};F=J(F,w)}return F},update:(w,S,F,V)=>{w=a?`${a}.${w}`:w;const J=C(F);return S!==void 0?this.b.$updateConfigurationOption(J,w,S,m,V):this.b.$removeConfigurationOption(J,w,m,V)},inspect:w=>{w=a?`${a}.${w}`:w;const S=this.e.inspect(w,m,this.c.workspace);if(S)return{key:w,defaultValue:(0,y.$an)(S.policy?.value??S.default?.value),globalValue:(0,y.$an)(S.user?.value??S.application?.value),workspaceValue:(0,y.$an)(S.workspace?.value),workspaceFolderValue:(0,y.$an)(S.workspaceFolder?.value),defaultLanguageValue:(0,y.$an)(S.default?.override),globalLanguageValue:(0,y.$an)(S.user?.override??S.application?.override),workspaceLanguageValue:(0,y.$an)(S.workspace?.override),workspaceFolderLanguageValue:(0,y.$an)(S.workspaceFolder?.override),languageIds:(0,y.$an)(S.overrideIdentifiers)}}};return typeof k=="object"&&(0,y.$dn)(u,k,!1),Object.freeze(u)}g(a){const g=p=>(0,d.$Ef)(p)?new Proxy(p,{get:(m,k)=>g(m[k]),set:(m,k,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(m,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(m,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return g(a)}h(a,g,p){const m=E.$Bn.test(a)?4:this.d.get(a),k=p?`[${p.value}] `:"";if(m===4){typeof g?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){g?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,g){const p=new $.$Mn(a,g,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,k)=>p.affectsConfiguration(m,o(k))})}k(a){return a.reduce((g,p)=>(g.set(p[0],p[1]),g),new Map)}}e.$mec=n,e.$nec=(0,D.$Vh)("IExtHostConfiguration")}),define(Pe[115],Ae([1,0,2,14,5,3,7,36,61,37,19,64,17,27,4,13,21,15,81,229,11]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=e.$Ofc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(J){function N(L){if(L!=null)return L}J.from=N;function R(L){if(L!=null)return L}J.to=R})(h||(h={}));var n;(function(J){function N(L){if(L!=null)return L}J.from=N;function R(L){if(L!=null)return L}J.to=R})(n||(n={}));var s;(function(J){function N(L){if(L!=null)return L}J.from=N;function R(L){if(L!=null)return L}J.to=R})(s||(s={}));var a;(function(J){function N(O){if(O){const Z=O;return Z&&!!Z.process}else return!1}J.is=N;function R(O){if(O==null)return;const Z={process:O.process,args:O.args};return O.options&&(Z.options=s.from(O.options)),Z}J.from=R;function L(O){if(O!=null)return new A.$iL(O.process,O.args,O.options)}J.to=L})(a||(a={}));var g;(function(J){function N(L){if(L!=null)return L}J.from=N;function R(L){if(L!=null)return L}J.to=R})(g||(g={}));var p;(function(J){function N(O){if(O){const Z=O;return Z&&(!!Z.commandLine||!!Z.command)}else return!1}J.is=N;function R(O){if(O==null)return;const Z={};return O.commandLine!==void 0?Z.commandLine=O.commandLine:(Z.command=O.command,Z.args=O.args),O.options&&(Z.options=g.from(O.options)),Z}J.from=R;function L(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new A.$jL(O.commandLine,O.options):new A.$jL(O.command,O.args?O.args:[],O.options)}J.to=L})(p||(p={}));var m;(function(J){function N(O){if(O){const Z=O;return Z&&Z.customExecution==="customExecution"}else return!1}J.is=N;function R(O){return{customExecution:"customExecution"}}J.from=R;function L(O,Z){return Z.get(O)}J.to=L})(m||(e.CustomExecutionDTO=m={}));var k;(function(J){function N(R,L){let O;return R.scope!==void 0&&typeof R.scope!="number"?O=R.scope.uri:R.scope!==void 0&&typeof R.scope=="number"&&(R.scope===A.TaskScope.Workspace&&L&&L.workspaceFile?O=L.workspaceFile:O=c.$8F),{id:R._id,workspaceFolder:O}}J.from=N})(k||(e.TaskHandleDTO=k={}));var C;(function(J){function N(R){if(R!=null)return{_id:R.id,isDefault:R.isDefault}}J.from=N})(C||(C={}));var u;(function(J){function N(O,Z){if(O==null)return[];const he=[];for(const $e of O){const De=R($e,Z);De&&he.push(De)}return he}J.fromMany=N;function R(O,Z){if(O==null)return;let he;O.execution instanceof A.$iL?he=a.from(O.execution):O.execution instanceof A.$jL?he=p.from(O.execution):O.execution&&O.execution instanceof A.$kL&&(he=m.from(O.execution));const $e=h.from(O.definition);let De;return O.scope?typeof O.scope=="number"?De=O.scope:De=O.scope.uri:De=A.TaskScope.Workspace,!$e||!De?void 0:{_id:O._id,definition:$e,name:O.name,source:{extensionId:Z.identifier.value,label:O.source,scope:De},execution:he,isBackground:O.isBackground,group:C.from(O.group),presentationOptions:n.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}J.from=R;async function L(O,Z,he){if(O==null)return;let $e;a.is(O.execution)?$e=a.to(O.execution):p.is(O.execution)?$e=p.to(O.execution):m.is(O.execution)&&($e=m.to(O._id,he));const De=h.to(O.definition);let ke;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?ke=O.source.scope:ke=await Z.resolveWorkspaceFolder(y.URI.revive(O.source.scope)):ke=A.TaskScope.Workspace),!De||!ke)return;const fe=new A.$lL(De,ke,O.name,O.source.label,$e,O.problemMatchers);return O.isBackground!==void 0&&(fe.isBackground=O.isBackground),O.group!==void 0&&(fe.group=A.$hL.from(O.group._id),fe.group&&O.group.isDefault&&(fe.group=new A.$hL(fe.group.id,fe.group.label),O.group.isDefault===!0&&(fe.group.isDefault=O.group.isDefault))),O.presentationOptions&&(fe.presentationOptions=n.to(O.presentationOptions)),O._id&&(fe._id=O._id),O.detail&&(fe.detail=O.detail),fe}J.to=L})(u||(e.TaskDTO=u={}));var w;(function(J){function N(L){return L}J.from=N;function R(L){if(L)return Object.assign(Object.create(null),L)}J.to=R})(w||(w={}));class S{#e;constructor(N,R,L){this._id=R,this.a=L,this.#e=N}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}let F=class{constructor(N,R,L,O,Z,he,$e,De){this.q=new P.$Rd,this.r=new P.$Rd,this.s=new P.$Rd,this.t=new P.$Rd,this.a=N.getProxy(M.$yK.MainThreadTask),this.b=L,this.c=O,this.d=Z,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=$e,this.g=De,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(N,R,L){if(!L)return new A.$AK(()=>{});const O=this.w();return this.j.set(O,{type:R,provider:L,extension:N}),this.a.$registerTaskProvider(O,R),new A.$AK(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(N,R){this.a.$registerTaskSystem(N,R)}fetchTasks(N){return this.a.$fetchTasks(w.from(N)).then(async R=>{const L=[];for(const O of R){const Z=await u.to(O,this.b,this.m);Z&&L.push(Z)}return L})}get taskExecutions(){const N=[];return this.k.forEach(R=>N.push(R)),N}terminateTask(N){if(!(N instanceof S))throw new Error("No valid task execution provided");return this.a.$terminateTask(N._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(N,R,L){const O=this.m.get(N.id);O&&(this.o.set(N.id,O),this.e.attachPtyToTerminal(R,await O.callback(L))),this.p=N.id,this.q.fire({execution:await this.y(N)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(N){const R=await this.y(N);this.l.delete(N.id),this.k.delete(N.id),this.A(N),this.r.fire({execution:R})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(N){const R=await this.y(N.id);this.s.fire({execution:R,processId:N.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(N){const R=await this.y(N.id);this.t.fire({execution:R,exitCode:N.exitCode})}$provideTasks(N,R){const L=this.j.get(N);if(!L)return Promise.reject(new Error("no handler found"));const O=[],Z=(0,T.$Qg)(()=>L.provider.provideTasks(I.CancellationToken.None)).then(he=>this.u(R,O,L,he));return new Promise(he=>{Z.then($e=>{Promise.all(O).then(()=>{he($e)})})})}async $resolveTask(N,R){const L=this.j.get(N);if(!L)return Promise.reject(new Error("no handler found"));if(R.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${R.definition.type}] cannot be resolved by provider of type [${L.type}].`);const O=await u.to(R,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const Z=await L.provider.resolveTask(O,I.CancellationToken.None);if(!Z)return;this.z(Z,L);const he=u.from(Z,L.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(Z.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(he.execution)&&await this.x(he,Z,!0),await this.v(he)}w(){return this.h++}async x(N,R,L){const O=await this.a.$createTaskId(N);!L&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,R.execution)),this.m.set(O,R.execution)}async y(N,R){if(typeof N=="string"){const Z=this.l.get(N);if(!Z)throw new o.$ab("Unexpected: The specified task is missing an execution");return Z}const L=this.l.get(N.id);if(L)return L;const O=new Promise((Z,he)=>{function $e(De,ke,fe){fe?Z(new S(De,ke.id,fe)):he("Unexpected: Task does not exist.")}R?$e(this,N,R):u.to(N.task,this.b,this.m).then(De=>$e(this,N,De))});return this.l.set(N.id,O),O.then(Z=>(this.k.set(N.id,Z),Z),Z=>Promise.reject(Z))}z(N,R){N._deprecated&&this.g.report("Task.constructor",R.extension,"Use the Task constructor that takes a `scope` instead.")}A(N){this.o.get(N.id)&&this.o.delete(N.id),this.n.has(N.id)&&this.p!==N.id&&(this.m.delete(N.id),this.n.delete(N.id));const L=this.n.values();let O=L.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=L.next()}};e.$Ofc=F,e.$Ofc=F=Ke([Ve(0,l.$AM),Ve(1,b.$QM),Ve(2,$.$kec),Ve(3,E.$LM),Ve(4,d.$nec),Ve(5,D.$Lec),Ve(6,i.$dj),Ve(7,r.$5dc)],F);let V=class extends F{constructor(N,R,L,O,Z,he,$e,De){super(N,R,L,O,Z,he,$e,De),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(N,R){if(!R.execution)throw new Error("Tasks to execute must include an execution");const L=u.from(R,N);if(L===void 0)throw new Error("Task is not valid");if(m.is(L.execution))await this.x(L,R,!1);else throw new o.$$;const O=await this.y(await this.a.$getTaskExecution(L),R);return this.a.$executeTask(L).catch(Z=>{throw new Error(Z)}),O}u(N,R,L,O){const Z=[];if(O)for(const he of O){if(this.z(he,L),!he.definition||!N[he.definition.type]){const De=he.source?he.source:"No task source";this.f.warn(`The task [${De}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`)}const $e=u.from(he,L.extension);$e&&m.is($e.execution)?(Z.push($e),R.push(this.x($e,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Z,extension:L.extension}}async v(N){if(m.is(N.execution))return N;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(N,R){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,R,L){}};e.$Pfc=V,e.$Pfc=V=Ke([Ve(0,l.$AM),Ve(1,b.$QM),Ve(2,$.$kec),Ve(3,E.$LM),Ve(4,d.$nec),Ve(5,D.$Lec),Ve(6,i.$dj),Ve(7,r.$5dc)],V),e.$Qfc=(0,v.$Vh)("IExtHostTask")}),define(Pe[282],Ae([1,0,43,29]),function(we,e,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nJ=e.$mJ=e.$lJ=void 0;function P(A){return"cellResults"in A}e.$lJ=P,e.$mJ="rawCell#";function M(A,$){let E=-1;const d=[];let I=[];return A.forEach(l=>{l.range.startLineNumber!==E&&I.length>0&&(d.push([...I]),I=[]),I.push(l),E=l.range.endLineNumber}),I.length>0&&d.push([...I]),d.map(l=>{const b=[],v=l[0].range.startLineNumber,f=l[l.length-1].range.endLineNumber;for(let t=v;t<=f;t++)b.push($.getLineContent(t));return new y.$2I(b.join(`
`)+`
`,l.map(t=>new T.$zs(t.range.startLineNumber-1,t.range.startColumn-1,t.range.endLineNumber-1,t.range.endColumn-1)))})}e.$nJ=M}),define(Pe[283],Ae([1,0,162,24,5,6,28,12,16,2,41,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o,h,n,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class g{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(m=>m.apiEditor)}constructor(m,k,C,u,w,S){this.q=C,this.r=u,this.s=w,this.t=S,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new P.$Rd({onListenerError:c.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Rd({onListenerError:c.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Rd({onListenerError:c.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Rd({onListenerError:c.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Xdc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=m.getProxy(l.$yK.MainThreadNotebook),this.c=m.getProxy(l.$yK.MainThreadNotebookDocuments),this.d=m.getProxy(l.$yK.MainThreadNotebookEditors),this.i=k.converter,k.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===13){const V=F.notebookEditor?.notebookUri,J=F.cell.handle,R=this.g.get(V)?.getCell(J);if(R)return R.apiCell}if(F&&F.$mid===14){const V=F.uri,J=this.g.get(V);if(J)return J.apiNotebook}return F}}),g.B(k)}getEditorById(m){const k=this.h.get(m);if(!k)throw new Error(`unknown text editor: ${m}. known editors: ${[...this.h.keys()]} `);return k}getIdByEditor(m){for(const[k,C]of this.h)if(C.apiEditor===m)return k}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(m,k){const C=this.g.get(m);if(!C&&!k)throw new Error(`NO notebook document for '${m}'`);return C}static u(m,k){if(!k)return;const C=k.filenamePattern.map(u=>v.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(k.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${k.filenamePattern}`);return}return{extension:m.identifier,providerDisplayName:m.displayName||m.name,displayName:k.displayName,filenamePattern:C,exclusive:k.exclusive||!1}}registerNotebookCellStatusBarItemProvider(m,k,C){const u=g.a++,w=typeof C.onDidChangeCellStatusBarItems=="function"?g.a++:void 0;this.f.set(u,C),this.b.$registerNotebookCellStatusBarItemProvider(u,w,k);let S;return w!==void 0&&(S=C.onDidChangeCellStatusBarItems(F=>this.b.$emitCellStatusBarEvent(w))),new f.$AK(()=>{this.f.delete(u),this.b.$unregisterNotebookCellStatusBarItemProvider(u,w),S?.dispose()})}async createNotebookDocument(m){const k=await this.c.$tryCreateNotebook({viewType:m.viewType,content:m.content&&v.NotebookData.from(m.content)});return d.URI.revive(k)}async openNotebookDocument(m){const k=this.g.get(m);if(k)return k.apiNotebook;const C=await this.c.$tryOpenNotebook(m),u=this.g.get(d.URI.revive(C));return(0,E.$Nf)(u?.apiNotebook)}async showNotebookDocument(m,k){d.URI.isUri(m)&&(m=await this.openNotebookDocument(m));let C;typeof k=="object"?C={position:v.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selections:k.selections&&k.selections.map(v.NotebookRange.from),pinned:typeof k.preview=="boolean"?!k.preview:void 0}:C={preserveFocus:!1};const u=await this.d.$tryShowNotebookDocument(m.uri,m.notebookType,C),w=u&&this.h.get(u)?.apiEditor;if(w)return w;throw u?new Error(`Could NOT open editor for "${m.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${m.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(m,k,C,u){const w=this.f.get(m),S=d.URI.revive(k),F=this.g.get(S);if(!F||!w)return;const V=F.getCellFromIndex(C);if(!V)return;const J=await w.provideCellStatusBarItems(V.apiCell,u);if(!J)return;const N=new M.$Qc,R=this.p.add([N]),O=(Array.isArray(J)?J:[J]).map(Z=>v.NotebookStatusBarItem.from(Z,this.i,N));return{cacheId:R,items:O}}$releaseNotebookCellStatusBarItems(m){this.p.delete(m)}registerNotebookSerializer(m,k,C,u,w){if((0,$.$Fe)(k))throw new Error("viewType cannot be empty or just whitespace");const S=this.w++;return this.x.set(S,{viewType:k,serializer:C,options:u}),this.b.$registerNotebookSerializer(S,{id:m.identifier,location:m.extensionLocation},k,v.NotebookDocumentContentOptions.from(u),g.u(m,w)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(m,k,C){const u=this.x.get(m);if(!u)throw new Error("NO serializer found");const w=await u.serializer.deserializeNotebook(k.buffer,C);return new t.$wv(v.NotebookData.from(w))}async $notebookToData(m,k,C){const u=this.x.get(m);if(!u)throw new Error("NO serializer found");const w=await u.serializer.serializeNotebook(v.NotebookData.to(k.value),C);return T.$fe.wrap(w)}async $saveNotebook(m,k,C,u,w){const S=d.URI.revive(k),F=this.x.get(m);if(!F)throw new Error("NO serializer found");const V=this.g.get(S);if(!V)throw new Error("Document NOT found");if(V.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new I.$zk((0,y.localize)(0,null,this.z(S)),6);await this.y(S,u);const J={metadata:(0,o.$in)(V.apiNotebook.metadata,Z=>!(F.options?.transientDocumentMetadata??{})[Z]),cells:[]};for(const Z of V.apiNotebook.getCells()){const he=new f.$YL(Z.kind,Z.document.getText(),Z.document.languageId,Z.mime,F.options?.transientOutputs?[]:[...Z.outputs],Z.metadata,Z.executionSummary);he.metadata=(0,o.$in)(Z.metadata,$e=>!(F.options?.transientCellMetadata??{})[$e]),J.cells.push(he)}const N=await F.serializer.serializeNotebook(J,w);await this.s.value.writeFile(S,N);const R=this.s.getFileSystemProviderExtUri(S.scheme),L=await this.s.value.stat(S);return{name:R.basename(S),isFile:(L.type&I.FileType.File)!==0,isDirectory:(L.type&I.FileType.Directory)!==0,isSymbolicLink:(L.type&I.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&I.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((L.permissions??0)&I.FilePermission.Locked),etag:I.$Kk({mtime:L.mtime,size:L.size}),children:void 0}}async $searchInNotebooks(m,k,C,u,w){const S=this.x.get(m)?.serializer;if(!S)return{limitHit:!1,results:[]};const F=new A.$Ac;await(async(L,O,Z)=>{await Promise.all(L.map(async he=>await Promise.all(he.filenamePatterns.map($e=>{const De={...Z,type:1,filePattern:$e};return this.t.doInternalFileSearchWithCustomCallback(De,O,ke=>{ke.forEach(fe=>{F.has(fe)||u.some(te=>he.isFromSettings&&!te.isFromSettings?!1:te.filenamePatterns.some(Re=>(0,a.$Zbb)(Re,fe)))||F.add(fe)})})}))))})(C,w,k);const J=new A.$zc;let N=!1;const R=Array.from(F).map(async L=>{const O=[];try{if(w.isCancellationRequested)return;if(k.maxResults&&[...J.values()].reduce((De,ke)=>De+ke.cellResults.length,0)>k.maxResults){N=!0;return}const Z=[],he=this.g.get(L);if(he)he.apiNotebook.getCells().forEach(ke=>Z.push({input:ke.document.getText(),outputs:ke.outputs.flatMap(fe=>fe.items.map(ve=>ve.data.toString()))}));else{const De=await this.s.value.readFile(L),ke=T.$fe.fromString(De.toString()),fe=await S.deserializeNotebook(ke.buffer,w);if(w.isCancellationRequested)return;v.NotebookData.from(fe).cells.forEach(te=>Z.push({input:te.source,outputs:te.outputs.flatMap(Re=>Re.items.map(se=>se.valueBytes.toString()))}))}if(w.isCancellationRequested)return;Z.forEach((De,ke)=>{const fe=k.contentPattern.pattern,ve=new n.$5Ob(De.input,void 0,De.outputs),te=ve.findInInputs(fe),Re=ve.findInOutputs(fe),se=Re.flatMap(Y=>(0,s.$nJ)(Y.matches,Y.textBuffer)).map((Y,B)=>(Y.webviewIndex=B,Y));if(te.length>0||Re.length>0){const Y={index:ke,contentResults:(0,s.$nJ)(te,ve.inputTextBuffer),webviewResults:se};O.push(Y)}});const $e={resource:L,cellResults:O};J.set(L,$e);return}catch{return}});return await Promise.all(R),{limitHit:N,results:[...J.values()]}}async y(m,k){const C=await this.s.value.stat(m);if(typeof k?.mtime=="number"&&typeof k.etag=="string"&&k.etag!==I.$Jk&&typeof C.mtime=="number"&&typeof C.size=="number"&&k.mtime<C.mtime&&k.etag!==I.$Kk({mtime:k.mtime,size:C.size}))throw new I.$zk((0,y.localize)(1,null),3,k)}z(m){return m.scheme===h.Schemas.file?m.fsPath:m.toString()}A(m,k,C){if(this.h.has(k))throw new Error(`editor with id ALREADY EXSIST: ${k}`);const u=new r.$hfc(k,this.d,m,C.visibleRanges.map(v.NotebookRange.to),C.selections.map(v.NotebookRange.to),typeof C.viewColumn=="number"?v.ViewColumn.to(C.viewColumn):void 0);this.h.set(k,u)}$acceptDocumentAndEditorsDelta(m){if(m.value.removedDocuments)for(const C of m.value.removedDocuments){const u=d.URI.revive(C),w=this.g.get(u);w&&(w.dispose(),this.g.delete(u),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(w.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===u.toString()&&this.h.delete(S.id)}if(m.value.addedDocuments){const C=[];for(const u of m.value.addedDocuments){const w=d.URI.revive(u.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const S=new i.$gfc(this.c,this.q,this.r,w,u);C.push(...u.cells.map(F=>i.$ffc.asModelAddData(S.apiNotebook,F))),this.g.get(w)?.dispose(),this.g.set(w,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(S.apiNotebook)}}if(m.value.addedEditors)for(const C of m.value.addedEditors){if(this.h.has(C.id))return;const u=d.URI.revive(C.documentUri),w=this.g.get(u);w&&this.A(w,C.id,C)}const k=[];if(m.value.removedEditors)for(const C of m.value.removedEditors){const u=this.h.get(C);u&&(this.h.delete(C),this.k?.id===u.id&&(this.k=void 0),k.push(u))}if(m.value.visibleEditors){this.l=m.value.visibleEditors.map(u=>this.h.get(u)).filter(u=>!!u);const C=new Set;this.l.forEach(u=>C.add(u.id));for(const u of this.h.values()){const w=C.has(u.id);u._acceptVisibility(w)}this.l=[...this.h.values()].map(u=>u).filter(u=>u.visible),this.o.fire(this.visibleNotebookEditors)}m.value.newActiveEditor===null?this.k=void 0:m.value.newActiveEditor&&(this.h.get(m.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${m.value.newActiveEditor}`),this.k=this.h.get(m.value.newActiveEditor)),m.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(m){const k=b.$YM.String.with("notebookType","A notebook type"),C=new b.$1M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[k,new b.$YM("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>T.$fe.wrap(w))],new b.$ZM("Notebook Data",w=>v.NotebookData.to(w.value))),u=new b.$1M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[k,new b.$YM("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new t.$wv(v.NotebookData.from(w)))],new b.$ZM("Bytes",w=>w.buffer));m.registerApiCommand(C),m.registerApiCommand(u)}}e.$qfc=g}),define(Pe[284],Ae([1,0,20,19,39,34,25,60,43]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;class d{constructor(l,b,v){this.k=l,this.l=b,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&M.$Cj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&M.$Cj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const b=this.k.folderQueries||[];return new Promise((v,f)=>{const t=i=>{this.f++,l(i)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const r=i.toString(),c=y.$mc(r);this.j&&this.j(r,c)||this.v(t,{base:i,basename:c})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{v({limitHit:this.e,stats:i[0]||void 0})},i=>{f(new Error((0,P.$Gi)(i)))})})}async p(l,b){const v=new T.$2d,f=this.q(l),t=this.r(),i=new E.$dJ(this.k,l),r=!i.hasSiblingExcludeClauses();let c;try{this.h.add(v),c=$.$Nd.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,v.token),h=c.elapsed(),n=$.$Nd.create();return this.g&&!this.e||(o&&o.forEach(s=>{const a=y.$fc.relative(l.folder.path,s.path);if(r){const g=y.$mc(s.path);this.v(b,{base:l.folder,relativePath:a,basename:g});return}this.s(t,l.folder,a,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:h,postProcessTime:n.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(l){const b=(0,E.$cJ)(this.k.includePattern,l.includePattern),v=(0,E.$cJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:v,includes:b,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},b,v,f){if(v===this.a){const i=y.$mc(this.a);this.v(f,{base:b,relativePath:this.a,basename:i})}function t(i){const r=y.$mc(i),c=y.$lc(i);let o=l[c];o||(o=l[c]=[],t(c)),o.push({base:b,relativePath:i,basename:r})}t(v)}u({rootEntries:l,pathToEntries:b},v,f){const t=this,i=this.a;function r(c){const o=(0,E.$fJ)(()=>c.map(h=>h.basename));for(let h=0,n=c.length;h<n;h++){const s=c[h],{relativePath:a,basename:g}=s;if(v.matchesExcludesSync(a,g,i!==g?o:void 0))continue;const p=b[a];if(p)r(p);else{if(a===i)continue;t.v(f,s)}if(t.e)break}}r(l)}v(l,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(b))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,b,v,f){const t=this.c(l.cacheKey),i=new d(l,b,t&&t.token);let r=0;const c=o=>{r+=o.length,v(o.map(h=>this.d(h)))};return this.e(i,I.a,c,f).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:r,detailStats:o.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$2d),this.b.get(l)}d(l){return l.relativePath?{resource:A.$zg(l.base,l.relativePath)}:{resource:l.base}}e(l,b,v,f){const t=f.onCancellationRequested(()=>{l.cancel()}),i=c=>{c&&(r.push(c),b>0&&r.length>=b&&(v(r),r=[]))};let r=[];return l.search(i).then(c=>(r.length&&v(r),t.dispose(),c),c=>(r.length&&v(r),t.dispose(),Promise.reject(c)))}}e.$ifc=I}),define(Pe[285],Ae([1,0,18,246,34,94,28,13,20,25,12,16,2,93,180,40,15,47,105,281,43]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.$cK=void 0;let h=class{constructor(w,S,F,V,J){this.a=w,this.b=S,this.c=F,this.d=V,this.e=J}text(w,S,F={}){w=this.f(w,F);const V=this.a.getValue(),J=S&&S.some(R=>!this.a.getValue({resource:R}).search.useRipgrep);return{...this.h(S?.map(i.$ei),F),type:2,contentPattern:w,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:V.search.usePCRE2||J||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(w,S){const F=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const V={...w,wordSeparators:F.editor.wordSeparators};return this.j(w,S)&&(V.isCaseSensitive=!0),this.k(w)&&(V.isMultiline=!0),S.notebookSearchConfig?.includeMarkupInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownInput=S.notebookSearchConfig.includeMarkupInput),S.notebookSearchConfig?.includeMarkupPreview&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownPreview=S.notebookSearchConfig.includeMarkupPreview),S.notebookSearchConfig?.includeCodeInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellInput=S.notebookSearchConfig.includeCodeInput),S.notebookSearchConfig?.includeOutput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellOutput=S.notebookSearchConfig.includeOutput),V}file(w,S={}){return{...this.h(w,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}g(w,S){return w?(w=Array.isArray(w)?w.map(p):p(w),S?this.parseSearchPaths(w):{pattern:s(...Array.isArray(w)?w:[w])}):{}}h(w=[],S={}){const F=this.g(S.includePattern,S.expandPatterns),V=this.g(S.excludePattern,S.expandPatterns),J=w.length>1,N=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(O=>this.q(O,S,V)):w.map(O=>this.r(O,S,V,J))).filter(O=>!!O),R={_reason:S._reason,folderQueries:N,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:V.pattern,includePattern:F.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const O=y.$Gb(y.$Qb(this.c.groups.map($e=>$e.editors.map(De=>De.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const Z=O.filter($e=>(0,o.$6I)(R,$e.fsPath)),he=this.i(Z);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(he)),{...R,...he}}const L=S.extraFileResources&&S.extraFileResources.filter(O=>(0,o.$6I)(R,O.fsPath));return R.extraFileResources=L&&L.length?L:void 0,R}i(w){const S=[],F=new A.$zc,V={};let J=!1;return w.forEach(N=>{if(N.scheme===$.Schemas.walkThrough)return;if((0,d.$Dg)(N)){const L=this.b.getWorkspaceFolder(N)?.uri??N.with({path:E.$lc(N.fsPath)});let O=F.get(L);O||(J=!0,O={folder:L,includePattern:{}},S.push(O),F.set(L,O));const Z=E.$kc(L.fsPath,N.fsPath);(0,D.$Nf)(O.includePattern)[Z.replace(/\\/g,"/")]=!0}else N.fsPath&&(J=!0,V[N.fsPath]=!0)}),{folderQueries:S,includePattern:V,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}j(w,S){if(S.isSmartCase){if(w.isRegExp){if(I.$tf(w.pattern,!0))return!0}else if(I.$tf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,b.$CB)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const S=he=>E.$hc(he)||/^\.\.?([\/\\]|$)/.test(he),V=(Array.isArray(w)?w:a(w)).map(he=>{const $e=this.e.resolvedUserHome;return $e?(0,M.$Bv)(he,$e.scheme===$.Schemas.file?$e.fsPath:$e.path):he}),J=T.$J(V,he=>S(he)?"searchPaths":"exprSegments"),N=(J.exprSegments||[]).map(he=>I.$Oe(he,"/")).map(he=>I.$Oe(he,"\\")).map(he=>(he[0]==="."&&(he="*"+he),g(he))),R={},L=this.m(J.searchPaths||[]);L&&L.length&&(R.searchPaths=L);const O=y.$Qb(N),Z=s(...O);return Z&&(R.pattern=Z),R}l(w,S){return S.disregardExcludeSettings?void 0:(0,o.$5I)(w,!S.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const S=w.flatMap(V=>{let{pathPortion:J,globPortion:N}=n(V);return N&&(N=m(N)),this.n(J).flatMap(L=>this.o(L,N))}),F=new Map;return S.forEach(V=>{const J=V.searchPath.toString(),N=F.get(J);N?V.pattern&&(N.pattern=N.pattern||{},N.pattern[V.pattern]=!0):F.set(J,{searchPath:V.searchPath,pattern:V.pattern?s(V.pattern):void 0})}),Array.from(F.values())}n(w){if(E.$hc(w)){const S=this.b.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==$.Schemas.file?[{searchPath:S[0].uri.with({path:w})}]:[{searchPath:l.URI.file(E.$gc(w))}]}if(this.b.getWorkbenchState()===2){const S=this.b.getWorkspace().folders[0].uri;if(w=p(w),w.startsWith("../")||w===".."){const V=E.$fc.resolve(S.path,w);return[{searchPath:S.with({path:V})}]}const F=m(w);return[{searchPath:S,pattern:F}]}else{if(w==="./"||w===".\\")return[];{const S=w.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(J=>{const N=S.match(new RegExp(`^${I.$Je(J.name)}(?:/(.*)|$)`));return N?{match:N,folder:J}:null}).filter(D.$Kf);if(V.length)return V.map(J=>{const N=J.match[1];return{searchPath:J.folder.uri,pattern:N&&m(N)}});{const J=w.match(/\.[\/\\](.+)[\/\\]?/),N=J?J[1]:w,R=v.localize(0,null,N);throw new Error(R)}}}}o(w,S){const F=w.pattern&&S?`${w.pattern}/${S}`:w.pattern||S,V=[{searchPath:w.searchPath,pattern:F}];return F&&!F.endsWith("**")&&V.push({searchPath:w.searchPath,pattern:F+"/**"}),V}q(w,S,F){const V=this.r((0,i.$ei)(w.searchPath),S,F,!1);return V?{...V,includePattern:w.pattern}:null}r(w,S,F,V){let J;const N=l.URI.isUri(w)?w:w.uri;if(F.searchPaths){const he=F.searchPaths.filter($e=>(0,d.$sg)($e.searchPath,N))[0];if(he&&!he.pattern)return null;he&&(J=he.pattern)}const R=this.a.getValue({resource:N}),O={...this.l(R,S)||{},...J||{}},Z=l.URI.isUri(w)?(0,d.$wg)(w):w.name;return{folder:N,folderName:V?Z:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:R.files&&R.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!R.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!R.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!R.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!R.search.followSymlinks}}};e.$cK=h,e.$cK=h=Ke([Ve(0,f.$pi),Ve(1,i.$5h),Ve(2,r.$GC),Ve(3,t.$dj),Ve(4,c.$aK)],h);function n(u){const w=u.match(/[\*\{\}\(\)\[\]\?]/);if(w){const S=w.index,F=u.substr(0,S).match(/[/|\\][^/\\]*$/);if(F){let V=u.substr(0,F.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:u.substr((F.index||0)+1)}}}return{pathPortion:u}}function s(...u){return u.length?u.reduce((w,S)=>(w[S]=!0,w),Object.create(null)):void 0}function a(u){return P.$Aj(u,",").map(w=>w.trim()).filter(w=>!!w.length)}function g(u){return[`**/${u}/**`,`**/${u}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function p(u){return u.replace(/\\/g,"/")}function m(u){return p(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(u){return u.replace(/([?*[\]])/g,"[$1]")}function C(u,w){u=y.$Lb(u,V=>V.toString());const S=[],F=w.getWorkspace();return u&&u.forEach(V=>{let J;if(w.getWorkbenchState()===2)J=(0,d.$Bg)(F.folders[0].uri,V),J&&J!=="."&&(J="./"+J);else{const N=w.getWorkspaceFolder(V);if(N){const R=N.name;if(F.folders.filter(O=>O.name===R).length===1){const O=(0,d.$Bg)(N.uri,V);O===""?J=`./${N.name}`:J=`./${N.name}/${O}`}else J=V.fsPath}}J&&S.push(k(J))}),S}e.$dK=C}),define(Pe[286],Ae([1,0,25,2,19,11,4,285,43,47]),function(we,e,y,T,P,M,A,$,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frb=e.$erb=void 0;const I=7e3;function D(f,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const r=[],c=[];for(const g of i)if(/^workspaceContains:/.test(g)){const p=g.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||f.forceUsingSearch?c.push(p):r.push(p)}if(r.length===0&&c.length===0)return Promise.resolve(void 0);let o;const h=new Promise((g,p)=>{o=g}),n=g=>o({activationEvent:g}),s=Promise.all(r.map(g=>l(f,g,n))).then(()=>{}),a=b(f,t.identifier,c,n);return Promise.all([s,a]).then(()=>{o(void 0)}),h}e.$erb=D;async function l(f,t,i){for(const r of f.folders)if(await f.exists(y.$zg(T.URI.revive(r),t))){i(`workspaceContains:${t}`);return}}async function b(f,t,i,r){if(i.length===0)return Promise.resolve(void 0);const c=new P.$2d,o=f.checkExists(f.folders,i,c.token),h=setTimeout(async()=>{c.cancel(),f.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},I);let n=!1;try{n=await o}catch(s){M.$3(s)||M.$Z(s)}c.dispose(),clearTimeout(h),n&&r(`workspaceContains:${i.join(",")}`)}function v(f,t,i,r){const c=f.get(A.$Uh),o=f.get(E.$WI),n=c.createInstance($.$cK).file(t.map(s=>(0,d.$ei)(T.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return o.fileSearch(n,r).then(s=>!!s.limitHit,s=>M.$3(s)?!1:Promise.reject(s))}e.$frb=v}),define(Pe[38],Ae([1,0,159,20,88,25,14,6,50,2,15,3,37,218,85,36,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o,h,n,s,a,g,p,m,k,C,u,w,S,F,V,J,N,R,L,O){"use strict";var Z;Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=e.$Zec=e.$Yec=e.$Xec=e.$Wec=void 0,e.$Wec=(0,a.$Vh)("IHostUtils");let he=Z=class extends $.$Rc{constructor(Y,B,ne,pe,re,le,ce,ye,_,de,ie,ae){super(),this.X=ae,this.a=this.B(new w.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=B,this.g=ne,this.f=ce,this.j=pe,this.m=re,this.s=le,this.t=_,this.u=de,this.w=ie,this.y=this.g.getProxy(D.$yK.MainThreadWorkspace),this.z=this.g.getProxy(D.$yK.MainThreadTelemetry),this.C=this.g.getProxy(D.$yK.MainThreadExtensionService),this.D=new A.$Wg,this.F=new A.$Wg,this.G=new A.$Wg,this.H=new A.$Wg,this.I=new Re(this.f.extensions.activationEvents),this.L=new i.$_5b(this.I,this.f.extensions.allExtensions);const me=new c.$am(this.f.extensions.myExtensions);this.J=new i.$_5b(this.I,ve(this.L,me)),L.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ke(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ke(this.J)}`)),this.M=new v.$Hec(this.g,this.s),this.N=new F.$Pec(this.g),this.O=ye,this.h=Y.createChild(new k.$Th([v.$Iec,this.M],[F.$Qec,this.N])),this.P=this.B(new b.$Gec(this.J,this.L,{onExtensionActivationError:(Ie,z,W)=>{this.C.$onExtensionActivationError(Ie,r.$2(z),W)},actualActivateExtension:async(Ie,z)=>{if(i.$_5b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,z),new b.$Fec;const W=this.J.getExtensionDescription(Ie);return this.db(W,z)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){r.$Z(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(re=>re.identifier).filter(re=>this.isActivated(re)).map(re=>this.cb(re))}catch{}await Promise.all(Y)}terminate(Y,B=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),r.setUnexpectedErrorHandler(pe=>{this.s.error(pe)}),this.g.dispose();const ne=this.Y();Promise.race([(0,A.$Yg)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const B=await this.C.$getExtension(Y);return B&&{...B,identifier:new c.$_l(B.identifier.value),extensionLocation:d.URI.revive(B.extensionLocation)}}Z(Y,B){return this.P.activateByEvent(Y,B)}$(Y,B){return this.P.activateById(Y,B)}activateByIdWithErrors(Y,B){return this.$(Y,B).then(()=>{const ne=this.P.getActivatedExtension(Y);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===J.Schemas.file&&this.c.fsRealpath){const B=await this.c.fsRealpath(Y.fsPath);return d.URI.file(B)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new te(Y))),this.Q}async bb(Y){const B=E.$2h.forUris(ne=>M.$qg.ignorePathCasing(ne));return await Promise.all(Y.map(async ne=>{if(this.ub(ne)){const pe=await this.ab(ne.extensionLocation);B.set(pe,ne)}})),B}cb(Y){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return B;const ne=this.P.getActivatedExtension(Y);if(!ne)return B;try{typeof ne.module.deactivate=="function"&&(B=Promise.resolve(ne.module.deactivate()).then(void 0,pe=>(this.s.error(pe),Promise.resolve(void 0))))}catch(pe){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(pe)}try{(0,$.$Mc)(ne.subscriptions)}catch(pe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(pe)}return B}async db(Y,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,B).then(ne=>{const pe=ne.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,B),this.eb(Y,B,"success",pe),ne},ne=>{throw this.eb(Y,B,"failure"),ne})}eb(Y,B,ne,pe){const re=De(Y,B);this.z.$publicLog2("extensionActivationTimes",{...re,...pe||{},outcome:ne})}fb(Y,B){const ne=De(Y,B);this.z.$publicLog2("activatePlugin",ne);const pe=this.ub(Y);if(!pe)return Promise.resolve(new b.$Eec(b.$Bec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${Y.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const re=new b.$Cec(B.startup);return Promise.all([this.vb(Y,(0,M.$zg)(Y.extensionLocation,pe),re),this.gb(Y)]).then(le=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Z.hb(this.s,Y.identifier,le[0],le[1],re))).then(le=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),le))}gb(Y){const B=new h.$Kec(Y,this.M),ne=new h.$Jec(Y.identifier.value,!1,this.M),pe=new V.$Rec(Y,this.N),re=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,le=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([B.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ce=this;let ye,_;const de=(0,t.$LF)(Y,"ipc")?this.f.messagePorts?.get(c.$_l.toKey(Y.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:ne,secrets:pe,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(ie){return T.$ic(Y.extensionLocation.fsPath,ie)},get storagePath(){return ce.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ce.O.globalValue(Y).fsPath},get logPath(){return T.$ic(ce.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return d.URI.joinPath(ce.f.logsLocation,Y.identifier.value)},get storageUri(){return ce.O.workspaceValue(Y)},get globalStorageUri(){return ce.O.globalValue(Y)},get extensionMode(){return re},get extension(){return ye===void 0&&(ye=new fe(ce,Y.identifier,Y,le,!1)),ye},get extensionRuntime(){return(0,t.$MF)(Y,"extensionRuntime"),ce.extensionRuntime},get environmentVariableCollection(){return ce.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!_){if(!de)return;const ie=w.Event.buffer(w.Event.fromDOMEventEmitter(de,"message",ae=>ae.data));de.start(),_={onDidReceiveMessage:ie,postMessage:de.postMessage.bind(de)}}return _}})})}static hb(Y,B,ne,pe,re){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Y,B,ne,pe,re).then(le=>new b.$Dec(!1,null,re.build(),ne,le,pe.subscriptions))}static ib(Y,B,ne,pe,re){if(typeof ne.activate=="function")try{re.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${B.value}`);const le=typeof global=="object"?global:self,ce=ne.activate.apply(le,[pe]);return re.activateCallStop(),re.activateResolveStart(),Promise.resolve(ce).then(ye=>(re.activateResolveStop(),ye))}catch(le){return Promise.reject(le)}else return Promise.resolve(ne)}jb(Y,B){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:B}).then(void 0,ne=>{this.s.error(ne)})}kb(Y,B=0){const pe=Date.now();(0,L.$B)(()=>{for(let re=B;re<Y.length;re+=1){const le=Y[re];for(const ce of le.activationEvents??[])if(ce==="onStartupFinished")if(Date.now()-pe>50){this.kb(Y,re);break}else this.jb(le,ce)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const B=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(B)this.kb(ne);else for(const pe of ne)if(pe.activationEvents)for(const re of pe.activationEvents)re==="onStartupFinished"&&this.jb(pe,re)})}mb(){const Y=this.Z("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.nb(le.added)));const B=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(B),pe=this.pb(),re=Promise.all([pe,Y,ne]).then(()=>{});return Promise.race([re,(0,A.$Yg)(1e4)]).then(()=>{this.lb()}),re}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.ob(Y,B))).then(()=>{})}async ob(Y,B){if(this.isActivated(B.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.s,folders:Y.map(le=>le.uri),forceUsingSearch:ne||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,ce,ye)=>this.y.$checkExists(le,ce,ye)},re=await(0,S.$erb)(pe,B);if(re)return this.$(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:re.activationEvent}).then(void 0,le=>this.s.error(le))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:B}=this.f.environment;if(!Y||!B)throw new Error(y.localize(0,null));const ne=await this.vb(null,B,new b.$Cec(!1));if(!ne||typeof ne.run!="function")throw new Error(y.localize(1,null,B.toString()));return new Promise((pe,re)=>{const le=(_,de)=>{_?(L.$t&&this.s.error("Test runner called back with error",_),re(_)):(L.$t&&(de?this.s.info(`Test runner called back with ${de} failures.`):this.s.info("Test runner called back with successful outcome.")),pe(typeof de=="number"&&de>0?1:0))},ce=(0,M.$ng)(B),ye=ne.run(ce,le);ye&&ye.then&&ye.then(()=>{L.$t&&this.s.info("Test runner finished successfully."),pe(0)}).catch(_=>{L.$t&&this.s.error("Test runner finished with error",_),re(_ instanceof Error&&_.stack?_.stack:String(_))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Yg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,B){return this.R[Y]=B,(0,$.$Pc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:B}=await this.sb(Y);return B?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const B=Y.indexOf("+");if(B===-1)throw new n.$GK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Y.substr(0,B);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Y,B){const ne=R.$Nd.create(!1),pe=()=>`[resolveAuthority(${(0,s.$Zk)(Y)},${B})][${ne.elapsed()}ms] `,re=G=>this.s.info(`${pe()}${G}`),le=G=>this.s.warn(`${pe()}${G}`),ce=(G,q=void 0)=>this.s.error(`${pe()}${G}`,q),ye=G=>{if(G instanceof n.$GK)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},_=async G=>{re(`activating resolver for ${G}...`);const{resolver:q,authorityPrefix:x}=await this.sb(G);if(!q)throw ce(`no resolver for ${x}`),new n.$GK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:x,remoteAuthority:G}},de=Y.split(/@|%40/g).reverse();re(`activating remote resolvers ${de.join(" -> ")}`);let ie;try{ie=await Promise.all(de.map(_)).catch(async G=>{if(!(G instanceof n.$GK)||G._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return le(`resolving nested authorities failed: ${G.message}`),[await _(Y)]})}catch(G){return ye(G)}const ae=new A.$9g;ae.cancelAndSet(()=>re("waiting..."),1e3);let me,Ie;for(const[G,{authorityPrefix:q,resolver:x,remoteAuthority:ue}]of ie.entries())try{if(G===ie.length-1)re("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${q}`),me=await x.resolve(ue,{resolveAttempt:B,execServer:Ie}),P.mark(`code/extHost/didResolveAuthorityOK/${q}`),re("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,n.$FK.isManagedResolvedAuthority(me)?me:void 0));else{if(re(`invoking resolveExecServer() for ${ue}`),P.mark(`code/extHost/willResolveExecServer/${q}`),Ie=await x.resolveExecServer?.(ue,{resolveAttempt:B,execServer:Ie}),!Ie)throw new n.$GK(`Exec server was not available for ${ue}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Oe){return P.mark(`code/extHost/didResolveAuthorityError/${q}`),ce("returned an error",Oe),ae.dispose(),ye(Oe)}ae.dispose();const z={environmentTunnels:me.environmentTunnels,features:me.tunnelFeatures},W={extensionHostEnv:me.extensionHostEnv,isTrusted:me.isTrusted,authenticationSession:me.authenticationSessionForInitializingExtensions?{id:me.authenticationSessionForInitializingExtensions.id,providerId:me.authenticationSessionForInitializingExtensions.providerId}:void 0};re(`returned ${n.$FK.isManagedResolvedAuthority(me)?"managed authority":`${me.host}:${me.port}`}`);let H;if(n.$FK.isManagedResolvedAuthority(me)){const G=B;this.X.setFactory(G,me.makeConnection),H={authority:Y,connectTo:new s.$Wk(G),connectionToken:me.connectionToken}}else H={authority:Y,connectTo:new s.$Xk(me.host,me.port),connectionToken:me.connectionToken};return{type:"ok",value:{authority:H,options:W,tunnelInformation:z}}}async $getCanonicalURI(Y,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Zk)(Y)})`);const{resolver:ne}=await this.sb(Y);if(!ne)return null;const pe=d.URI.revive(B);if(typeof ne.getCanonicalURI>"u")return pe;const re=await(0,A.$Qg)(()=>ne.getCanonicalURI(pe));return re||pe}$startExtensionHost(Y){Y.toAdd.forEach(pe=>pe.extensionLocation=d.URI.revive(pe.extensionLocation));const{globalRegistry:B,myExtensions:ne}=$e(this.I,this.L,this.J,Y);return this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),L.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ke(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ke(this.J)}`)),this.rb()}$activateByEvent(Y,B){return B===1?this.D.wait().then(ne=>this.Z(Y,!1)):this.G.wait().then(ne=>this.Z(Y,!1))}async $activate(Y,B){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,B),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(le=>le.extensionLocation=d.URI.revive(le.extensionLocation));const{globalRegistry:B,myExtensions:ne}=$e(this.I,this.L,this.J,Y),pe=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),L.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ke(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ke(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const B=o.$fe.alloc(Y),ne=Math.random()%256;for(let pe=0;pe<Y;pe++)B.writeUInt8(ne,pe);return B}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$Xec=he,e.$Xec=he=Z=Ke([Ve(0,a.$Uh),Ve(1,e.$Wec),Ve(2,m.$AM),Ve(3,f.$kec),Ve(4,l.$nec),Ve(5,I.$dj),Ve(6,g.$QM),Ve(7,p.$qec),Ve(8,C.$axb),Ve(9,u.$Lec),Ve(10,N.$Tec),Ve(11,O.$Uec)],he);function $e(se,Y,B,ne){se.addActivationEvents(ne.addActivationEvents);const pe=new i.$_5b(se,Y.getAllExtensionDescriptions());pe.deltaExtensions(ne.toAdd,ne.toRemove);const re=new c.$am(B.getAllExtensionDescriptions().map(ce=>ce.identifier));for(const ce of ne.myToRemove)re.delete(ce);for(const ce of ne.myToAdd)re.add(ce);const le=ve(pe,re);return{globalRegistry:pe,myExtensions:le}}function De(se,Y){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function ke(se){return se.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$Yec=(0,a.$Vh)("IExtHostExtensionService");class fe{#e;#t;#i;constructor(Y,B,ne,pe,re){this.#e=Y,this.#t=B,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=T.$gc((0,M.$ng)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=pe,this.isFromDifferentExtensionHost=re}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Zec=fe;function ve(se,Y){return se.getAllExtensionDescriptions().filter(B=>Y.has(B.identifier))}class te{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$1ec=te;class Re{constructor(Y){this.a=new c.$bm,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const B of Object.keys(Y))this.a.set(B,Y[B])}}}),define(Pe[287],Ae([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;let f=class{constructor(o,h,n,s,a,g,p){this.c=o,this.d=h,this.e=n,this.f=s,this.g=a,this.h=g,this.i=p,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new i(this.c,h,this.d,o,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(r,h,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const h of o.nodeModuleName)this.a.set(h,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(h=>o.alternativeModuleName(h))}};e.$9fc=f,e.$9fc=f=Ke([Ve(2,I.$Uh),Ve(3,M.$nec),Ve(4,D.$Yec),Ve(5,d.$QM),Ve(6,l.$dj)],f);let t=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&v.a.size){const h=(0,b.$Je)(this.c(o.environment.appRoot.fsPath)),n="[a-z0-9_.-]",s=`@${n}+\\/${n}+|${n}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const h=this.b.exec(this.c(o));if(!h)return;const[,n,s,a]=h,g=v.a.get(s);if(g!==void 0)return console.warn(`${s} as been renamed to ${g}, please update your imports`),n+g+a}c(o){return o.replace(/\\/g,"/")}};t=v=Ke([Ve(0,d.$QM)],t);class i{constructor(o,h,n,s,a){this.c=o,this.d=h,this.e=n,this.f=s,this.g=a,this.nodeModuleName="vscode",this.a=new $.$bm}load(o,h){const n=this.d.findSubstr(h);if(n){let s=this.a.get(n.identifier);return s||(s=this.c(n,this.e,this.f),this.a.set(n.identifier,s)),s}if(!this.b){let s="";this.d.forEach((a,g)=>s+=`	${g} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$GF,this.e,this.f)}return this.b}}let r=class{constructor(o,h,n){this.e=o,this.f=h,this.nodeModuleName=["open","opn"],this.d=n.getProxy(P.$yK.MainThreadTelemetry);const s=n.getProxy(P.$yK.MainThreadWindow);this.c=(a,g)=>{const p=T.URI.parse(a);return g?this.g(a,g):p.scheme==="http"||p.scheme==="https"?s.$openUri(p,a,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?s.$openUri(p,a,{}):this.g(a,g)}}load(o,h,n){const s=this.e.findSubstr(h);return s&&(this.a=s.identifier.value,this.h()),this.b=n(o),this.c}g(o,h){return this.i(),this.b(o,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};r=Ke([Ve(2,E.$AM)],r)}),define(Pe[116],Ae([1,0,44,6,20,74,4,61,62,38,7,36,215,37]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=e.$2ec=void 0,e.$2ec=(0,A.$Vh)("IExtHostVariableResolverProvider");class v extends l.$BN{constructor(i,r,c,o,h,n,s){function a(){if(c){const g=c.activeEditor();if(g)return g.document.uri;const p=o.tabGroups.all.find(m=>m.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof I.$gM||p.input instanceof I.$lM)return p.input.modified;if(p.input instanceof I.$fM||p.input instanceof I.$kM||p.input instanceof I.$iM)return p.input.uri}}}super({getFolderUri:g=>{const p=n.folders.filter(m=>m.name===g);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(g,p)=>h.getConfiguration(void 0,g).get(p),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const g=a();if(g)return P.$gc(g.fsPath)},getWorkspaceFolderPathForFile:()=>{if(r){const g=a();if(g){const p=r.getWorkspaceFolder(g);if(p)return P.$gc(p.uri.fsPath)}}},getSelectedText:()=>{if(c){const g=c.activeEditor();if(g&&!g.selection.isEmpty)return g.document.getText(g.selection)}},getLineNumber:()=>{if(c){const g=c.activeEditor();if(g)return String(g.selection.end.line+1)}},getExtension:g=>i.getExtension(g)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(M.env))}}let f=class extends T.$Rc{constructor(i,r,c,o,h){super(),this.b=i,this.c=r,this.g=c,this.h=o,this.j=h,this.a=new y.$U(async()=>{const n=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async g=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,n,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$3ec=f,e.$3ec=f=Ke([Ve(0,d.$Yec),Ve(1,D.$kec),Ve(2,$.$LM),Ve(3,b.$nec),Ve(4,E.$zec)],f)}),define(Pe[117],Ae([1,0,14,5,2,4,3,62,38,17,7,36,207,209,37,116]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=e.$7ec=e.$6ec=e.$5ec=e.$4ec=void 0,e.$4ec=(0,M.$Vh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,a,g,p,m,k){this.E=a,this.F=g,this.G=p,this.H=m,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Rd,this.n=new T.$Rd,this.o=new T.$Rd,this.u=new T.$Rd,this.k=s.getProxy(A.$yK.MainThreadDebugService),this.y=new T.$Rd,this.A=new T.$Rd,this.v=new r(this.k),this.w=new Map,this.F.getExtensionRegistry().then(C=>{C.onDidChange(u=>{this.J(C)}),this.J(C)})}asDebugSourceUri(s,a){const g=s;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let p=`debug:${encodeURIComponent(g.path||"")}`,m="?";return a&&(p+=`${m}session=${encodeURIComponent(a.id)}`,m="&"),p+=`${m}ref=${g.sourceReference}`,P.URI.parse(p)}else{if(g.path)return P.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const a=[];for(const g of s.getAllExtensionDescriptions())if(g.contributes){const p=g.contributes.debuggers;if(p&&p.length>0)for(const m of p)(0,b.$iF)(m)&&a.push(m.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(a=>s.push(a)),s}addBreakpoints(s){const a=s.filter(m=>{const k=m.id;return this.w.has(k)?!1:(this.w.set(k,m),!0)});this.U(a,[],[]);const g=[],p=new Map;for(const m of a)if(m instanceof I.$zL){let k=p.get(m.location.uri.toString());k||(k={type:"sourceMulti",uri:m.location.uri,lines:[]},p.set(m.location.uri.toString(),k),g.push(k)),k.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof I.$AL&&g.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(g)}removeBreakpoints(s){const a=s.filter(k=>this.w.delete(k.id));this.U([],a,[]);const g=a.filter(k=>k instanceof I.$zL).map(k=>k.id),p=a.filter(k=>k instanceof I.$AL).map(k=>k.id),m=a.filter(k=>k instanceof I.$BL).map(k=>k.id);return this.k.$unregisterBreakpoints(g,p,m)}startDebugging(s,a,g){return this.k.$startDebugging(s?s.uri:void 0,a,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,suppressSaveBeforeStart:g.suppressSaveBeforeStart,suppressDebugStatusbar:g.suppressDebugStatusbar??g.debugUI?.simple,suppressDebugToolbar:g.suppressDebugToolbar??g.debugUI?.simple,suppressDebugView:g.suppressDebugView??g.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,a,g){if(!a)return new I.$AK(()=>{});const p=this.d++;return this.f.push({type:s,handle:p,provider:a}),this.k.$registerDebugConfigurationProvider(s,g,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,p),new I.$AK(()=>{this.f=this.f.filter(m=>m.provider!==a),this.k.$unregisterDebugConfigurationProvider(p)})}registerDebugAdapterDescriptorFactory(s,a,g){if(!g)return new I.$AK(()=>{});if(!this.Q(s,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.N(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const p=this.g++;return this.h.push({type:a,handle:p,factory:g}),this.k.$registerDebugAdapterDescriptorFactory(a,p),new I.$AK(()=>{this.h=this.h.filter(m=>m.factory!==g),this.k.$unregisterDebugAdapterDescriptorFactory(p)})}registerDebugAdapterTrackerFactory(s,a){if(!a)return new I.$AK(()=>{});const g=this.i++;return this.j.push({type:s,handle:g,factory:a}),new I.$AK(()=>{this.j=this.j.filter(p=>p.factory!==a)})}async $runInTerminal(s,a){return Promise.resolve(void 0)}async $substituteVariables(s,a){let g;const p=await this.W(s);return p&&(g={uri:p.uri,name:p.name,index:p.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(g,a)}K(s,a){if(s.type==="implementation")return new o(s.implementation)}L(){}async $startDASession(s,a){const g=this,p=await this.V(a);return this.S(this.N(p.type),p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}' (extension might have failed to activate)`);const k=this.M(m),C=this.K(k,p);if(!C)throw new Error(`Couldn't create a debug adapter for type '${p.type}'.`);const u=C;return this.B.set(s,u),this.R(p).then(w=>(w&&this.C.set(s,w),u.onMessage(async S=>{if(S.type==="request"&&S.command==="handshake"){const F=S,V={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const J=await this.D.sign(F.arguments.value);V.body={signature:J},u.sendResponse(V)}else throw new Error("no signer")}catch(J){V.success=!1,V.message=J.message,u.sendResponse(V)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(S),S=(0,b.$nF)(S,!0),g.k.$acceptDAMessage(s,S)}),u.onError(S=>{w&&w.onError&&w.onError(S),this.k.$acceptDAError(s,S.name,S.message,S.stack)}),u.onExit(S=>{w&&w.onExit&&w.onExit(S??void 0,void 0),this.k.$acceptDAExit(s,S??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),u.startSession()))})}$sendDAMessage(s,a){a=(0,b.$mF)(a,!1);const g=this.C.get(s);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(a),this.B.get(s)?.sendMessage(a)}$stopDASession(s){const a=this.C.get(s);this.C.delete(s),a&&a.onWillStopSession&&a.onWillStopSession();const g=this.B.get(s);return this.B.delete(s),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const a=[],g=[],p=[];if(s.added)for(const m of s.added){const k=m.id;if(k&&!this.w.has(k)){let C;if(m.type==="function")C=new I.$AL(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")C=new I.$BL(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const u=P.URI.revive(m.uri);C=new I.$zL(new I.$MK(u,new I.$BK(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,I.$xL)(C,k),this.w.set(k,C),a.push(C)}}if(s.removed)for(const m of s.removed){const k=this.w.get(m);k&&(this.w.delete(m),g.push(k))}if(s.changed){for(const m of s.changed)if(m.id){const k=this.w.get(m.id);if(k){if(k instanceof I.$AL&&m.type==="function"){const C=k;C.enabled=m.enabled,C.condition=m.condition,C.hitCondition=m.hitCondition,C.logMessage=m.logMessage,C.functionName=m.functionName}else if(k instanceof I.$zL&&m.type==="source"){const C=k;C.enabled=m.enabled,C.condition=m.condition,C.hitCondition=m.hitCondition,C.logMessage=m.logMessage,C.location=new I.$MK(P.URI.revive(m.uri),new I.$BK(m.line,m.character))}p.push(k)}}}this.U(a,g,p)}async $acceptStackFrameFocus(s){let a;const g=s.sessionId?await this.V(s.sessionId):void 0;if(!g)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?a=new I.$HL(g,s.threadId):a=new I.$GL(g,s.threadId,s.frameId),this.z=a,this.A.fire(this.z)}$provideDebugConfigurations(s,a,g){return(0,y.$Qg)(async()=>{const p=this.P(s);if(!p)throw new Error("no DebugConfigurationProvider found");if(!p.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.W(a);return p.provideDebugConfigurations(m,g)}).then(p=>{if(!p)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return p})}$resolveDebugConfiguration(s,a,g,p){return(0,y.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(a);return m.resolveDebugConfiguration(k,g,p)})}$resolveDebugConfigurationWithSubstitutedVariables(s,a,g,p){return(0,y.$Qg)(async()=>{const m=this.P(s);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(a);return m.resolveDebugConfigurationWithSubstitutedVariables(k,g,p)})}async $provideDebugAdapter(s,a){const g=this.O(s);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const p=await this.V(a);return this.S(g,p).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${p.type}'`);return this.M(m)})}async $acceptDebugSessionStarted(s){const a=await this.V(s);this.m.fire(a)}async $acceptDebugSessionTerminated(s){const a=await this.V(s);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,a){(await this.V(s))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(s,a){const p={session:await this.V(s),event:a.event,body:a.body};this.u.fire(p)}M(s){if(s instanceof I.$CL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof I.$DL)return{type:"server",port:s.port,host:s.host};if(s instanceof I.$EL)return{type:"pipeServer",path:s.path};if(s instanceof I.$FL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const a=this.h.filter(g=>g.type===s);if(a.length>0)return a[0].factory}O(s){const a=this.h.filter(g=>g.handle===s);if(a.length>0)return a[0].factory}P(s){const a=this.f.filter(g=>g.handle===s);if(a.length>0)return a[0].provider}Q(s,a){if(s.contributes){const g=s.contributes.debuggers;if(g&&g.length>0){for(const p of g)if(p.label&&p.type&&p.type===a)return!0}}return!1}R(s){const g=s.configuration.type,p=this.j.filter(m=>m.type===g||m.type==="*").map(m=>(0,y.$Qg)(()=>m.factory.createDebugAdapterTracker(s)).then(k=>k,k=>null));return Promise.race([Promise.all(p).then(m=>{const k=m.filter(C=>!!C);if(k.length>0)return new c(k)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async S(s,a){const g=a.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new I.$DL(g));if(s){const m=await this.F.getExtensionRegistry();return(0,y.$Qg)(()=>s.createDebugAdapterDescriptor(a,this.T(a,m))).then(k=>{if(k)return k})}const p=await this.F.getExtensionRegistry();return Promise.resolve(this.T(a,p))}T(s,a){}U(s,a,g){(s.length>0||a.length>0||g.length>0)&&this.y.fire(Object.freeze({added:s,removed:a,changed:g}))}async V(s){if(s)if(typeof s=="string"){const a=this.l.get(s);if(a)return a}else{let a=this.l.get(s.id);if(!a){const g=await this.W(s.folderUri),p=s.parent?this.l.get(s.parent):void 0;a=new i(this.k,s.id,s.type,s.name,g,s.configuration,p),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}W(s){if(s){const a=P.URI.revive(s);return this.E.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.$5ec=t,e.$5ec=t=Ke([Ve(0,d.$AM),Ve(1,D.$kec),Ve(2,E.$Yec),Ve(3,v.$nec),Ve(4,$.$zec),Ve(5,f.$2ec)],t);class i{constructor(s,a,g,p,m,k,C){this.d=s,this.f=a,this.g=g,this.h=p,this.i=m,this.j=k,this.k=C}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,a){return this.d.$customDebugAdapterRequest(this.f,s,a)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$6ec=i;class r{constructor(s){this.value=Object.freeze({append(a){s.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.$7ec=r;class c{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(a=>a.onError?a.onError(s):void 0)}onExit(s,a){this.d.forEach(g=>g.onExit?g.onExit(s,a):void 0)}}class o extends l.$_cb{constructor(s){super(),this.h=s,s.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends t{constructor(s,a,g,p,m,k){super(s,a,g,p,m,k)}};e.$8ec=h,e.$8ec=h=Ke([Ve(0,d.$AM),Ve(1,D.$kec),Ve(2,E.$Yec),Ve(3,v.$nec),Ve(4,$.$zec),Ve(5,f.$2ec)],h)}),define(Pe[288],Ae([1,0,11,88,2,3,276,15,70,71,27,185,17,57,38,59]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0;class t{static async installEarlyHandler(c){Error.stackTraceLimit=100;const o=c.get($.$dj),n=c.get(l.$AM).getProxy(M.$yK.MainThreadErrors);y.setUnexpectedErrorHandler(s=>{o.error(s);const a=y.$2(s);n.$onUnexpectedError(a)})}static async installFullHandler(c){const o=c.get($.$dj),h=c.get(l.$AM),n=c.get(v.$Yec),s=c.get(f.$UM),a=h.getProxy(M.$yK.MainThreadExtensionService),g=h.getProxy(M.$yK.MainThreadErrors),p=await n.getExtensionPathIndex(),m=new WeakMap;function k(w,S){if(m.has(w))return m.get(w).stack;let F="",V,J;for(const R of S)F+=`
	at ${R.toString()}`,J=R.getFileName(),!V&&J&&(V=p.findSubstr(P.URI.file(J)));const N=`${w.name||"Error"}: ${w.message||""}${F}`;return m.set(w,{extensionIdentifier:V?.identifier,stack:N}),N}const C=Symbol("prepareStackTrace wrapped");let u=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(w){if(w===k||!w||w[C]){u=w||k;return}u=function(S,F){return k(S,F),w.call(Error,S,F)},Object.assign(u,{[C]:!0})}}),y.setUnexpectedErrorHandler(w=>{o.error(w);const S=y.$2(w),F=m.get(w);if(!F?.extensionIdentifier){g.$onUnexpectedError(S);return}a.$onExtensionRuntimeError(F.extensionIdentifier,S);const V=s.onExtensionError(F.extensionIdentifier,w);o.trace("forwarded error to extension?",V,F)})}}e.$0fc=t;class i{constructor(c,o,h,n,s){this.a=h,this.b=new A.$h6b(c,null,n),o=i.e(o,this.b);const a=new d.$Th(...(0,E.$Dr)());a.set(I.$QM,{_serviceBrand:void 0,...o,messagePorts:s}),a.set(l.$AM,new l.$BM(this.b)),a.set(b.$hec,new b.$iec(n)),a.set(v.$Wec,h);const g=new D.$jq(a,!0);g.invokeFunction(t.installEarlyHandler),this.d=g.invokeFunction(p=>p.get($.$dj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=g.invokeFunction(p=>p.get(v.$Yec)),this.c.initialize(),g.invokeFunction(t.installFullHandler)}async asBrowserUri(c){const o=this.b.getProxy(M.$yK.MainThreadExtensionService);return P.URI.revive(await o.$asBrowserUri(c))}terminate(c){this.c.terminate(c)}static e(c,o){c.extensions.allExtensions.forEach(n=>{n.extensionLocation=P.URI.revive(o.transformIncomingURIs(n.extensionLocation))}),c.environment.appRoot=P.URI.revive(o.transformIncomingURIs(c.environment.appRoot));const h=c.environment.extensionDevelopmentLocationURI;return h&&(c.environment.extensionDevelopmentLocationURI=h.map(n=>P.URI.revive(o.transformIncomingURIs(n)))),c.environment.extensionTestsLocationURI=P.URI.revive(o.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=P.URI.revive(o.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=P.URI.revive(o.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=P.URI.revive(o.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=P.URI.revive(o.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=P.URI.revive(o.transformIncomingURIs(c.logsLocation)),c.workspace=o.transformIncomingURIs(c.workspace),c}}e.$$fc=i}),define(Pe[289],Ae([1,0,18,14,19,39,13,20,25,2,43]),function(we,e,y,T,P,M,A,$,E,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=e.$jfc=void 0;class D{constructor(r,c,o,h){this.d=r,this.e=c,this.f=o,this.g=h,this.a=null,this.b=!1,this.c=0}search(r,c){const o=this.d.folderQueries||[],h=new P.$2d(c);return new Promise((n,s)=>{this.a=new b(r);let a=!1;const g=(p,m)=>{if(!a&&!this.b){const k=this.h(p);f(p)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,a=!0,h.cancel(),p=this.j(p,this.d.maxResults-this.c));const C=this.h(p);this.c+=C,(C>0||!f(p))&&this.a.add(p,m)}};Promise.all(o.map((p,m)=>this.k(p,k=>g(k,m),h.token))).then(p=>{h.dispose(),this.a.flush();const m=p.some(k=>!!k&&!!k.limitHit);n({limitHit:this.b||m,messages:(0,y.$Qb)(p.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},p=>{h.dispose();const m=(0,M.$Gi)(p);s(new Error(m))})})}h(r){return f(r)?Array.isArray(r.ranges)?r.ranges.length:1:0}j(r,c){const o=Array.isArray(r.ranges)?r.ranges:[r.ranges],h=Array.isArray(r.preview.matches)?r.preview.matches:[r.preview.matches];return{ranges:o.slice(0,c),preview:{matches:h.slice(0,c),text:r.preview.text},uri:r.uri}}async k(r,c,o){const h=new I.$dJ(this.d,r),n=[],s={report:p=>{if(!this.l(p))return;const m=r.folder.scheme===A.Schemas.file?(0,I.$eJ)(()=>this.f.readdir(E.$yg(p.uri))):void 0,k=E.$Bg(r.folder,p.uri);if(k){const C=h.includedInQuery(k,$.$mc(k),m);(0,T.$Kg)(C)?n.push(C.then(u=>{u&&c(p)})):C&&c(p)}}},a=this.n(r),g=await this.e.provideTextSearchResults(l(this.d.contentPattern),a,s,o);return n.length&&await Promise.all(n),g}l(r){if(f(r)){if(Array.isArray(r.ranges)){if(!Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(r.preview.matches.length!==r.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(r.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(r){const c=(0,I.$cJ)(this.d.includePattern,r.includePattern),o=(0,I.$cJ)(this.d.excludePattern,r.excludePattern),h={folder:d.URI.from(r.folder),excludes:o,includes:c,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!r.disregardParentIgnoreFiles,followSymlinks:!r.ignoreSymlinks,encoding:r.fileEncoding&&this.f.toCanonicalName(r.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$jfc=D;function l(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(r){this.e=r,this.b=-1,this.d=null,this.a=new t(512,c=>this.g(c))}add(r,c){this.d&&(this.b!==c||!E.$sg(this.c,r.uri))&&(this.f(),this.d=null),this.d||(this.b=c,this.d={resource:r.uri,results:[]}),this.d.results.push(v(r))}f(){const r=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,r)}flush(){this.f(),this.a.flush()}g(r){this.e(r)}}e.$kfc=b;function v(i){return f(i)?{preview:{matches:(0,y.$1b)(i.preview.matches,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character})),text:i.preview.text},ranges:(0,y.$1b)(i.ranges,r=>({startLineNumber:r.start.line,startColumn:r.start.character,endLineNumber:r.end.line,endColumn:r.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function f(i){return!!i.preview}e.$lfc=f;class t{static{this.a=4e3}static{this.b=50}constructor(r,c){this.g=r,this.h=c,this.c=0,this.d=[],this.e=0}addItem(r,c){r&&this.j(r,c)}addItems(r,c){r&&this.k(r,c)}j(r,c){this.d.push(r),this.e+=c,this.l()}k(r,c){this.d=this.d.concat(r),this.e+=c,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$mfc=t}),define(Pe[118],Ae([1,0,6,3,4,284,17,57,15,2,289]),function(we,e,y,T,P,M,A,$,E,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=e.$ofc=e.$nfc=void 0,e.$nfc=(0,P.$Vh)("IExtHostSearch");let D=class{constructor(f,t,i){this.k=f,this.l=t,this.n=i,this.c=this.k.getProxy(T.$yK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$ifc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,t){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(f)),(0,y.$Pc)(()=>{this.g.delete(f),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(f,t){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(f)),(0,y.$Pc)(()=>{this.i.delete(f),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(f,t,i,r){const c=l(i),o=this.h.get(f);if(o)return this.j.fileSearch(c,o,h=>{this.c.$handleFileMatch(f,t,h.map(n=>n.resource))},r);throw new Error("unknown provider: "+f)}async doInternalFileSearchWithCustomCallback(f,t,i){return{messages:[]}}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,t,i,r){const c=this.e.get(f);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const o=l(i);return this.q(o,c).search(n=>this.c.$handleTextMatch(f,t,n),r)}$enableExtensionHostSearch(){}q(f,t){return new I.$jfc(f,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$ofc=D,e.$ofc=D=Ke([Ve(0,A.$AM),Ve(1,$.$hec),Ve(2,E.$dj)],D);function l(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(b),extraFileResources:v.extraFileResources&&v.extraFileResources.map(f=>d.URI.revive(f))}}e.$pfc=l;function b(v){return{...v,folder:d.URI.revive(v.folder)}}}),define(Pe[290],Ae([1,0,19,11,5,6,13,31,2,146,142,129,92,22,41,15,99,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,37,272,117,110,242,243,244,220,245,61,62,247,38,248,63,249,42,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,36,208,79,23,114]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o,h,n,s,a,g,p,m,k,C,u,w,S,F,V,J,N,R,L,O,Z,he,$e,De,ke,fe,ve,te,Re,se,Y,B,ne,pe,re,le,ce,ye,_,de,ie,ae,me,Ie,z,W,H,G,q,x,ue,Oe,Ue,Ze,Je,tt,_e,et,rt,nt,ze,dt,X,Q,Ee,Be,He,Xe,st,vt,Dt,Ne,Kt,Ht,yt,jt,Nt,Gt,Bt,St,Lt,Vt,Ye,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;function qt(ct){const gt=ct.get(B.$QM),Ot=ct.get(Y.$2dc),Pt=ct.get(Re.$pec),At=ct.get(ve.$Yec),ft=ct.get(St.$kec),kt=ct.get(X.$UM),Rt=ct.get(V.$nec),Ct=ct.get(Ht.$hec),We=ct.get(Ue.$AM),zt=ct.get(nt.$Iec),Jt=ct.get(ze.$qec),Ce=ct.get(f.$ej),Me=ct.get(f.$dj),be=ct.get(vt.$axb),K=ct.get(s.$5dc),Le=ct.get(Bt.$4fc),je=ct.get(tt.$Qec),Qe=ct.get(ke.$zec),qe=ct.get(de.$Uec);We.set(o.$zK.ExtHostFileSystemInfo,Ot),We.set(o.$zK.ExtHostLogLevelServiceShape,Ce),We.set(o.$zK.ExtHostWorkspace,ft),We.set(o.$zK.ExtHostConfiguration,Rt),We.set(o.$zK.ExtHostExtensionService,At),We.set(o.$zK.ExtHostStorage,zt),We.set(o.$zK.ExtHostTunnelService,be),We.set(o.$zK.ExtHostWindow,Le),We.set(o.$zK.ExtHostSecretState,je),We.set(o.$zK.ExtHostTelemetry,kt),We.set(o.$zK.ExtHostEditorTabs,Qe),We.set(o.$zK.ExtHostManagedSockets,qe);const it=We.set(o.$zK.ExtHostDecorations,ct.get(R.$0ec)),pt=We.set(o.$zK.ExtHostDocumentsAndEditors,ct.get(De.$LM)),$t=We.set(o.$zK.ExtHostCommands,ct.get(S.$WM)),bt=We.set(o.$zK.ExtHostTerminalService,ct.get(Q.$Lec)),ut=We.set(o.$zK.ExtHostDebugService,ct.get(N.$4ec)),Mt=We.set(o.$zK.ExtHostSearch,ct.get(Je.$nfc)),Qt=We.set(o.$zK.ExtHostTask,ct.get(dt.$Qfc)),Xt=We.set(o.$zK.ExtHostOutputService,ct.get(G.$Dfc)),si=We.set(o.$zK.ExtHostLocalization,ct.get(_.$Tec)),ki=We.set(o.$zK.ExtHostUrls,new yt.$1fc(We)),It=We.set(o.$zK.ExtHostDocuments,new $e.$Zdc(We,pt)),Zi=We.set(o.$zK.ExtHostDocumentContentProviders,new Z.$_ec(We,pt,Me)),ln=We.set(o.$zK.ExtHostDocumentSaveParticipant,new he.$afc(Me,It,We.getProxy(o.$yK.MainThreadBulkEdits))),Et=We.set(o.$zK.ExtHostNotebook,new ae.$qfc(We,$t,pt,It,Pt,Mt)),mi=We.set(o.$zK.ExtHostNotebookDocuments,new Ie.$xfc(Et)),$i=We.set(o.$zK.ExtHostNotebookEditors,new z.$yfc(Me,Et)),oi=We.set(o.$zK.ExtHostNotebookKernels,new W.$zfc(We,gt,Et,$t,Me)),Si=We.set(o.$zK.ExtHostNotebookRenderers,new H.$Bfc(We,Et)),Ii=We.set(o.$zK.ExtHostNotebookDocumentSaveParticipant,new me.$wfc(Me,Et,We.getProxy(o.$yK.MainThreadBulkEdits))),Ft=We.set(o.$zK.ExtHostEditors,new Be.$eec(We,pt)),pi=We.set(o.$zK.ExtHostTreeViews,new st.$Yfc(We.getProxy(o.$yK.MainThreadTreeViews),$t,Me)),Ci=We.set(o.$zK.ExtHostEditorInsets,new w.$fec(We.getProxy(o.$yK.MainThreadEditorInsets),Ft,gt.remote)),ai=We.set(o.$zK.ExtHostDiagnostics,new L.$4dc(We,Me,Ot,pt)),ci=We.set(o.$zK.ExtHostLanguages,new ye.$ufc(We,It,$t.converter,Ct)),lt=We.set(o.$zK.ExtHostLanguageFeatures,new ce.$8dc(We,Ct,It,$t,ai,Me,K,kt)),Pi=We.set(o.$zK.ExtHostFileSystem,new te.$cfc(We,lt)),xt=We.set(o.$zK.ExtHostFileSystemEventService,new se.$dfc(We,Me,pt)),ni=We.set(o.$zK.ExtHostQuickOpen,(0,Oe.$Hfc)(We,ft,$t)),hi=We.set(o.$zK.ExtHostSCM,new Ze.$Jfc(We,$t,It,Me)),Xi=We.set(o.$zK.ExtHostQuickDiff,new ue.$Gfc(We,Ct)),Ai=We.set(o.$zK.ExtHostShare,new _e.$Kfc(We,Ct)),Ri=We.set(o.$zK.ExtHostComments,(0,F.$gec)(We,$t,It)),Mi=We.set(o.$zK.ExtHostProgress,new x.$Ffc(We.getProxy(o.$yK.MainThreadProgress))),xi=We.set(o.$zK.ExtHosLabelService,new le.$tfc(We)),Li=We.set(o.$zK.ExtHostTheming,new He.$Vfc(We)),ui=We.set(o.$zK.ExtHostAuthentication,new a.$0dc(We)),_i=We.set(o.$zK.ExtHostTimeline,new Xe.$Xfc(We,$t)),Fi=We.set(o.$zK.ExtHostWebviews,new jt.$uec(We,gt.remote,ft,Me,K)),Ti=We.set(o.$zK.ExtHostWebviewPanels,new Nt.$xec(We,Fi,ft)),Oi=We.set(o.$zK.ExtHostCustomEditors,new J.$yec(We,It,Jt,Fi,Ti)),Ni=We.set(o.$zK.ExtHostWebviewViews,new Gt.$2fc(We,Fi)),di=We.set(o.$zK.ExtHostTesting,new Ee.$Rfc(We,$t,pt)),hn=We.set(o.$zK.ExtHostUriOpeners,new Kt.$Zfc(We)),en=We.set(o.$zK.ExtHostProfileContentHandlers,new q.$Efc(We));We.set(o.$zK.ExtHostInteractive,new pe.$rfc(We,Et,pt,$t,Me));const zi=We.set(o.$zK.ExtHostInlineChat,new ne.$efc(We,$t,It,Me)),vi=We.set(o.$zK.ExtHostChatProvider,new k.$aec(We,Me)),tn=We.set(o.$zK.ExtHostChatAgents2,new m.$bec(We,vi,Me)),nn=We.set(o.$zK.ExtHostChatVariables,new C.$cec(We)),bi=We.set(o.$zK.ExtHostChat,new p.$_dc(We)),wi=We.set(o.$zK.ExtHostAiRelatedInformation,new h.$Ydc(We)),rn=We.set(o.$zK.ExtHostAiEmbeddingVector,new fe.$bfc(We)),_t=We.set(o.$zK.ExtHostIssueReporter,new re.$sfc(We)),fi=We.set(o.$zK.ExtHostStatusBar,new rt.$Nfc(We,$t.converter)),dn=We.set(o.$zK.ExtHostSpeech,new et.$Lfc(We)),Yt=Object.values(o.$zK);We.assertRegistered(Yt);const yi=new g.$$dc(We,pt),sn=new u.$dec(We),Ei=new ie.$vfc(We,Me),Ui=new O.$$ec(We);return n.$9dc.register($t),function(Te,ti,ji){const mt=function(){let ee=!Te.isUnderDevelopment;function ge(){ee||(Me.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")ge();else{const wt=ot;typeof wt.scheme>"u"&&ge(),typeof wt.exclusive=="boolean"&&(0,Ye.$MF)(Te,"documentFiltersExclusive")}return ot}}(),fn={getSession(ee,ge,Fe){return ui.getSession(Te,ee,ge,Fe)},getSessions(ee,ge){return(0,Ye.$MF)(Te,"authGetSessions"),ui.getSessions(Te,ee,ge)},async hasSession(ee,ge){return(0,Ye.$MF)(Te,"authSession"),!!await ui.getSession(Te,ee,ge,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(ee,ge,Fe,ot){return ui.registerAuthenticationProvider(ee,ge,Fe,ot)}},gn={registerCommand(ee,ge,Fe){return $t.registerCommand(!0,ee,ge,Fe,void 0,Te)},registerTextEditorCommand(ee,ge,Fe){return $t.registerCommand(!0,ee,(...ot)=>{const wt=Ft.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}return wt.edit(Tt=>{ge.apply(Fe,[wt,Tt,...ot])}).then(Tt=>{Tt||Me.warn("Edits from command "+ee+" were not applied.")},Tt=>{Me.warn("An error occurred while running command "+ee,Tt)})},void 0,void 0,Te)},registerDiffInformationCommand:(ee,ge,Fe)=>((0,Ye.$MF)(Te,"diffCommand"),$t.registerCommand(!0,ee,async(...ot)=>{const wt=pt.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(wt.id);ge.apply(Fe,[Tt,...ot])},void 0,void 0,Te)),executeCommand(ee,...ge){return $t.executeCommand(ee,...ge)},getCommands(ee=!1){return $t.getCommands(ee)}},Di={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return sn.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return bt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ye.$MF)(Te,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$MF)(Te,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,X.$TM)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ge){return X.$SM.validateSender(ee),kt.instantiateLogger(Te,ee,ge)},openExternal(ee,ge){return Le.openUri(ee,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===gt.environment.appUriScheme)return ki.createAppUri(ee);try{return await Le.asExternalUri(ee,{allowTunneling:!!gt.remote.authority})}catch(ge){if((0,t.$RU)(ee,A.Schemas.http)||(0,t.$RU)(ee,A.Schemas.https))return ee;throw ge}},get remoteName(){return(0,i.$2k)(gt.remote.authority)},get remoteAuthority(){return(0,Ye.$MF)(Te,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return Me.getLevel()},get onDidChangeLogLevel(){return Me.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Ye.$MF)(Te,"handleIssueUri"),_t.registerIssueUriRequestHandler(Te,ee)},registerIssueDataProvider(ee){return(0,Ye.$MF)(Te,"handleIssueUri"),_t.registerIssueDataProvider(Te,ee)},get appQuality(){return(0,Ye.$MF)(Te,"resolvers"),gt.quality},get appCommit(){return(0,Ye.$MF)(Te,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(Di);const on={createTestController(ee,ge,Fe){return di.createTestController(Te,ee,ge,Fe)},createTestObserver(){return(0,Ye.$MF)(Te,"testObserver"),di.createTestObserver()},runTests(ee){return(0,Ye.$MF)(Te,"testObserver"),di.runTests(ee)},get onDidChangeTestResults(){return(0,Ye.$MF)(Te,"testObserver"),di.onResultsChanged},get testResults(){return(0,Ye.$MF)(Te,"testObserver"),di.results}},gi=gt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,an={getExtension(ee,ge){(0,Ye.$LF)(Te,"extensionsAny")||(ge=!1);const Fe=ti.mine.getExtensionDescription(ee);if(Fe)return new ve.$Zec(At,Te.identifier,Fe,gi,!1);if(ge){const ot=ti.all.getExtensionDescription(ee);if(ot)return new ve.$Zec(At,Te.identifier,ot,gi,!0)}},get all(){const ee=[];for(const ge of ti.mine.getAllExtensionDescriptions())ee.push(new ve.$Zec(At,Te.identifier,ge,gi,!1));return ee},get allAcrossExtensionHosts(){(0,Ye.$MF)(Te,"extensionsAny");const ee=new b.$am(ti.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),ge=[];for(const Fe of ti.all.getAllExtensionDescriptions()){const ot=!ee.has(Fe.identifier);ge.push(new ve.$Zec(At,Te.identifier,Fe,gi,ot))}return ge},get onDidChange(){return(0,Ye.$LF)(Te,"extensionsAny")?P.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},mn={createDiagnosticCollection(ee){return ai.createDiagnosticCollection(Te.identifier,ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ee=>ai.getDiagnostics(ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ee,ge){return ci.changeLanguage(ee.uri,ge)},match(ee,ge){const Fe=It.getDocumentData(ge.uri)?.notebook;return(0,I.$LE)(Dt.LanguageSelector.from(ee),ge.uri,ge.languageId,!0,Fe?.uri,Fe?.notebookType)},registerCodeActionsProvider(ee,ge,Fe){return lt.registerCodeActionProvider(Te,mt(ee),ge,Fe)},registerDocumentPasteEditProvider(ee,ge,Fe){return(0,Ye.$MF)(Te,"documentPaste"),lt.registerDocumentPasteEditProvider(Te,mt(ee),ge,Fe)},registerCodeLensProvider(ee,ge){return lt.registerCodeLensProvider(Te,mt(ee),ge)},registerDefinitionProvider(ee,ge){return lt.registerDefinitionProvider(Te,mt(ee),ge)},registerDeclarationProvider(ee,ge){return lt.registerDeclarationProvider(Te,mt(ee),ge)},registerImplementationProvider(ee,ge){return lt.registerImplementationProvider(Te,mt(ee),ge)},registerTypeDefinitionProvider(ee,ge){return lt.registerTypeDefinitionProvider(Te,mt(ee),ge)},registerHoverProvider(ee,ge){return lt.registerHoverProvider(Te,mt(ee),ge,Te.identifier)},registerEvaluatableExpressionProvider(ee,ge){return lt.registerEvaluatableExpressionProvider(Te,mt(ee),ge,Te.identifier)},registerInlineValuesProvider(ee,ge){return lt.registerInlineValuesProvider(Te,mt(ee),ge,Te.identifier)},registerDocumentHighlightProvider(ee,ge){return lt.registerDocumentHighlightProvider(Te,mt(ee),ge)},registerLinkedEditingRangeProvider(ee,ge){return lt.registerLinkedEditingRangeProvider(Te,mt(ee),ge)},registerReferenceProvider(ee,ge){return lt.registerReferenceProvider(Te,mt(ee),ge)},registerRenameProvider(ee,ge){return lt.registerRenameProvider(Te,mt(ee),ge)},registerDocumentSymbolProvider(ee,ge,Fe){return lt.registerDocumentSymbolProvider(Te,mt(ee),ge,Fe)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(Te,ee)},registerDocumentFormattingEditProvider(ee,ge){return lt.registerDocumentFormattingEditProvider(Te,mt(ee),ge)},registerDocumentRangeFormattingEditProvider(ee,ge){return lt.registerDocumentRangeFormattingEditProvider(Te,mt(ee),ge)},registerOnTypeFormattingEditProvider(ee,ge,Fe,...ot){return lt.registerOnTypeFormattingEditProvider(Te,mt(ee),ge,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(ee,ge,Fe){return lt.registerDocumentSemanticTokensProvider(Te,mt(ee),ge,Fe)},registerDocumentRangeSemanticTokensProvider(ee,ge,Fe){return lt.registerDocumentRangeSemanticTokensProvider(Te,mt(ee),ge,Fe)},registerSignatureHelpProvider(ee,ge,Fe,...ot){return typeof Fe=="object"?lt.registerSignatureHelpProvider(Te,mt(ee),ge,Fe):lt.registerSignatureHelpProvider(Te,mt(ee),ge,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(ee,ge,...Fe){return lt.registerCompletionItemProvider(Te,mt(ee),ge,Fe)},registerInlineCompletionItemProvider(ee,ge,Fe){return ge.handleDidShowCompletionItem&&(0,Ye.$MF)(Te,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$MF)(Te,"inlineCompletionsAdditions"),Fe&&(0,Ye.$MF)(Te,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Te,mt(ee),ge,Fe)},registerDocumentLinkProvider(ee,ge){return lt.registerDocumentLinkProvider(Te,mt(ee),ge)},registerColorProvider(ee,ge){return lt.registerColorProvider(Te,mt(ee),ge)},registerFoldingRangeProvider(ee,ge){return lt.registerFoldingRangeProvider(Te,mt(ee),ge)},registerSelectionRangeProvider(ee,ge){return lt.registerSelectionRangeProvider(Te,ee,ge)},registerCallHierarchyProvider(ee,ge){return lt.registerCallHierarchyProvider(Te,ee,ge)},registerTypeHierarchyProvider(ee,ge){return lt.registerTypeHierarchyProvider(Te,ee,ge)},setLanguageConfiguration:(ee,ge)=>lt.setLanguageConfiguration(Te,ee,ge),getTokenInformationAtPosition(ee,ge){return(0,Ye.$MF)(Te,"tokenInformation"),ci.tokenAtPosition(ee,ge)},registerInlayHintsProvider(ee,ge){return lt.registerInlayHintsProvider(Te,ee,ge)},createLanguageStatusItem(ee,ge){return ci.createLanguageStatusItem(Te,ee,ge)},registerDocumentDropEditProvider(ee,ge,Fe){return lt.registerDocumentOnDropEditProvider(Te,ee,ge,(0,Ye.$LF)(Te,"dropMetadata")?Fe:void 0)}},$n={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument(ee,ge,Fe){const ot=await(E.URI.isUri(ee)?Promise.resolve(Bi.openTextDocument(ee)):Promise.resolve(ee));return Ft.showTextDocument(ot,ge,Fe)},createTextEditorDecorationType(ee){return Ft.createTextEditorDecorationType(Te,ee)},onDidChangeActiveTextEditor(ee,ge,Fe){return Ft.onDidChangeActiveTextEditor(ee,ge,Fe)},onDidChangeVisibleTextEditors(ee,ge,Fe){return Ft.onDidChangeVisibleTextEditors(ee,ge,Fe)},onDidChangeTextEditorSelection(ee,ge,Fe){return Ft.onDidChangeTextEditorSelection(ee,ge,Fe)},onDidChangeTextEditorOptions(ee,ge,Fe){return Ft.onDidChangeTextEditorOptions(ee,ge,Fe)},onDidChangeTextEditorVisibleRanges(ee,ge,Fe){return Ft.onDidChangeTextEditorVisibleRanges(ee,ge,Fe)},onDidChangeTextEditorViewColumn(ee,ge,Fe){return Ft.onDidChangeTextEditorViewColumn(ee,ge,Fe)},onDidCloseTerminal(ee,ge,Fe){return bt.onDidCloseTerminal(ee,ge,Fe)},onDidOpenTerminal(ee,ge,Fe){return bt.onDidOpenTerminal(ee,ge,Fe)},onDidChangeActiveTerminal(ee,ge,Fe){return bt.onDidChangeActiveTerminal(ee,ge,Fe)},onDidChangeTerminalDimensions(ee,ge,Fe){return(0,Ye.$MF)(Te,"terminalDimensions"),bt.onDidChangeTerminalDimensions(ee,ge,Fe)},onDidChangeTerminalState(ee,ge,Fe){return bt.onDidChangeTerminalState(ee,ge,Fe)},onDidWriteTerminalData(ee,ge,Fe){return(0,Ye.$MF)(Te,"terminalDataWriteEvent"),bt.onDidWriteTerminalData(ee,ge,Fe)},onDidExecuteTerminalCommand(ee,ge,Fe){return(0,Ye.$MF)(Te,"terminalExecuteCommandEvent"),bt.onDidExecuteTerminalCommand(ee,ge,Fe)},get state(){return Le.getState(Te)},onDidChangeWindowState(ee,ge,Fe){return Le.onDidChangeWindowState(ee,ge,Fe)},showInformationMessage(ee,...ge){return Ei.showMessage(Te,$.default.Info,ee,ge[0],ge.slice(1))},showWarningMessage(ee,...ge){return Ei.showMessage(Te,$.default.Warning,ee,ge[0],ge.slice(1))},showErrorMessage(ee,...ge){return Ei.showMessage(Te,$.default.Error,ee,ge[0],ge.slice(1))},showQuickPick(ee,ge,Fe){return ni.showQuickPick(Te,ee,ge,Fe)},showWorkspaceFolderPick(ee){return ni.showWorkspaceFolderPick(ee)},showInputBox(ee,ge){return ni.showInput(ee,ge)},showOpenDialog(ee){return Ui.showOpenDialog(Te,ee)},showSaveDialog(ee){return Ui.showSaveDialog(ee)},createStatusBarItem(ee,ge,Fe){let ot,wt,Tt;return typeof ee=="string"?(ot=ee,wt=ge,Tt=Fe):(wt=ee,Tt=ge),fi.createStatusBarEntry(Te,ot,wt,Tt)},setStatusBarMessage(ee,ge){return fi.setStatusBarMessage(ee,ge)},withScmProgress(ee){return K.report("window.withScmProgress",Te,"Use 'withProgress' instead."),Mi.withProgress(Te,{location:Ne.ProgressLocation.SourceControl},(ge,Fe)=>ee({report(ot){}}))},withProgress(ee,ge){return Mi.withProgress(Te,ee,ge)},createOutputChannel(ee,ge){return Xt.createOutputChannel(ee,ge,Te)},createWebviewPanel(ee,ge,Fe,ot){return Ti.createWebviewPanel(Te,ee,ge,Fe,ot)},createWebviewTextEditorInset(ee,ge,Fe,ot){return(0,Ye.$MF)(Te,"editorInsets"),Ci.createWebviewEditorInset(ee,ge,Fe,ot,Te)},createTerminal(ee,ge,Fe){return typeof ee=="object"?"pty"in ee?bt.createExtensionTerminal(ee):bt.createTerminalFromOptions(ee):bt.createTerminal(ee,ge,Fe)},registerTerminalLinkProvider(ee){return bt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ge){return bt.registerProfileProvider(Te,ee,ge)},registerTerminalQuickFixProvider(ee,ge){return(0,Ye.$MF)(Te,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider(ee,Te.identifier.value,ge)},registerTreeDataProvider(ee,ge){return pi.registerTreeDataProvider(ee,ge,Te)},createTreeView(ee,ge){return pi.createTreeView(ee,ge,Te)},registerWebviewPanelSerializer:(ee,ge)=>Ti.registerWebviewPanelSerializer(Te,ee,ge),registerCustomEditorProvider:(ee,ge,Fe={})=>Oi.registerCustomEditorProvider(Te,ee,ge,Fe),registerFileDecorationProvider(ee){return it.registerFileDecorationProvider(ee,Te)},registerUriHandler(ee){return ki.registerUriHandler(Te,ee)},createQuickPick(){return ni.createQuickPick(Te)},createInputBox(){return ni.createInputBox(Te)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(ee,ge,Fe){return Li.onDidChangeActiveColorTheme(ee,ge,Fe)},registerWebviewViewProvider(ee,ge,Fe){return Ni.registerWebviewViewProvider(Te,ee,ge,Fe?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ge,Fe){return Et.onDidChangeActiveNotebookEditor(ee,ge,Fe)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,ge,Fe){return $i.onDidChangeNotebookEditorSelection(ee,ge,Fe)},onDidChangeNotebookEditorVisibleRanges(ee,ge,Fe){return $i.onDidChangeNotebookEditorVisibleRanges(ee,ge,Fe)},showNotebookDocument(ee,ge){return Et.showNotebookDocument(ee,ge)},registerExternalUriOpener(ee,ge,Fe){return(0,Ye.$MF)(Te,"externalUriOpener"),hn.registerExternalUriOpener(Te.identifier,ee,ge,Fe)},registerProfileContentHandler(ee,ge){return(0,Ye.$MF)(Te,"profileContentHandlers"),en.registrProfileContentHandler(Te,ee,ge)},registerQuickDiffProvider(ee,ge,Fe,ot){return(0,Ye.$MF)(Te,"quickDiffProvider"),Xi.registerQuickDiffProvider(mt(ee),ge,Fe,ot)},get tabGroups(){return Qe.tabGroups},registerShareProvider(ee,ge){return(0,Ye.$MF)(Te,"shareProvider"),Ai.registerShareProvider(mt(ee),ge)}},Bi={get rootPath(){return K.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(ee){throw new T.$8("rootPath")},getWorkspaceFolder(ee){return ft.getWorkspaceFolder(ee)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(ee){throw new T.$8("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(ee){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(ee,ge,...Fe)=>ft.updateWorkspaceFolders(Te,ee,ge||0,...Fe),onDidChangeWorkspaceFolders:function(ee,ge,Fe){return ft.onDidChangeWorkspace(ee,ge,Fe)},asRelativePath:(ee,ge)=>ft.getRelativePath(ee,ge),findFiles:(ee,ge,Fe,ot)=>ft.findFiles(ee,ge,Fe,Te.identifier,ot),findTextInFiles:(ee,ge,Fe,ot)=>{(0,Ye.$MF)(Te,"findTextInFiles");let wt,Tt;return typeof ge=="object"?(wt=ge,Tt=Fe):(wt={},Tt=ge,ot=Fe),ft.findTextInFiles(ee,wt||{},Tt,Te.identifier,ot)},save:ee=>((0,Ye.$MF)(Te,"saveEditor"),ft.save(ee)),saveAs:ee=>((0,Ye.$MF)(Te,"saveEditor"),ft.saveAs(ee)),saveAll:ee=>ft.saveAll(ee),applyEdit(ee,ge){return yi.applyWorkspaceEdit(ee,Te,ge)},createFileSystemWatcher:(ee,ge,Fe,ot)=>{let wt;return typeof ge=="boolean"?wt={ignoreCreateEvents:!!ge,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!ot,correlate:!1}:ge&&((0,Ye.$MF)(Te,"createFileSystemWatcher"),wt={...ge,correlate:!0}),xt.createFileSystemWatcher(ft,Te,ee,wt)},get textDocuments(){return It.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new T.$8("textDocuments")},openTextDocument(ee){let ge;const Fe=ee;if(typeof ee=="string")ge=Promise.resolve(E.URI.file(ee));else if(E.URI.isUri(ee))ge=Promise.resolve(ee);else if(!Fe||typeof Fe=="object")ge=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(ot=>It.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(ee,ge,Fe)=>It.onDidAddDocument(ee,ge,Fe),onDidCloseTextDocument:(ee,ge,Fe)=>It.onDidRemoveDocument(ee,ge,Fe),onDidChangeTextDocument:(ee,ge,Fe)=>It.onDidChangeDocument(ee,ge,Fe),onDidSaveTextDocument:(ee,ge,Fe)=>It.onDidSaveDocument(ee,ge,Fe),onWillSaveTextDocument:(ee,ge,Fe)=>ln.getOnWillSaveTextDocumentEvent(Te)(ee,ge,Fe),get notebookDocuments(){return Et.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ge){let Fe;if(E.URI.isUri(ee))Fe=ee,await Et.openNotebookDocument(ee);else if(typeof ee=="string")Fe=E.URI.revive(await Et.createNotebookDocument({viewType:ee,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ee,ge,Fe){return mi.onDidSaveNotebookDocument(ee,ge,Fe)},onDidChangeNotebookDocument(ee,ge,Fe){return mi.onDidChangeNotebookDocument(ee,ge,Fe)},onWillSaveNotebookDocument(ee,ge,Fe){return Ii.getOnWillSaveNotebookDocumentEvent(Te)(ee,ge,Fe)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(ee,ge,Fe,ot){return Et.registerNotebookSerializer(Te,ee,ge,Fe,(0,Ye.$LF)(Te,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,ge,Fe)=>ji.onDidChangeConfiguration(ee,ge,Fe),getConfiguration(ee,ge){return ge=arguments.length===1?void 0:ge,ji.getConfiguration(ee,ge,Te)},registerTextDocumentContentProvider(ee,ge){return Zi.registerTextDocumentContentProvider(ee,ge)},registerTaskProvider:(ee,ge)=>(K.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),Qt.registerTaskProvider(Te,ee,ge)),registerFileSystemProvider(ee,ge,Fe){return(0,M.$Oc)(Pi.registerFileSystemProvider(Te,ee,ge,Fe),Pt.addFileSystemProvider(ee,ge,Fe))},get fs(){return Pt.value},registerFileSearchProvider:(ee,ge)=>((0,Ye.$MF)(Te,"fileSearchProvider"),Mt.registerFileSearchProvider(ee,ge)),registerTextSearchProvider:(ee,ge)=>((0,Ye.$MF)(Te,"textSearchProvider"),Mt.registerTextSearchProvider(ee,ge)),registerRemoteAuthorityResolver:(ee,ge)=>((0,Ye.$MF)(Te,"resolvers"),At.registerRemoteAuthorityResolver(ee,ge)),registerResourceLabelFormatter:ee=>((0,Ye.$MF)(Te,"resolvers"),xi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Ye.$MF)(Te,"resolvers"),At.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ge,Fe)=>xt.onDidCreateFile(ee,ge,Fe),onDidDeleteFiles:(ee,ge,Fe)=>xt.onDidDeleteFile(ee,ge,Fe),onDidRenameFiles:(ee,ge,Fe)=>xt.onDidRenameFile(ee,ge,Fe),onWillCreateFiles:(ee,ge,Fe)=>xt.getOnWillCreateFileEvent(Te)(ee,ge,Fe),onWillDeleteFiles:(ee,ge,Fe)=>xt.getOnWillDeleteFileEvent(Te)(ee,ge,Fe),onWillRenameFiles:(ee,ge,Fe)=>xt.getOnWillRenameFileEvent(Te)(ee,ge,Fe),openTunnel:ee=>((0,Ye.$MF)(Te,"tunnels"),be.openTunnel(Te,ee).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,Ye.$MF)(Te,"tunnels"),be.getTunnels()},onDidChangeTunnels:(ee,ge,Fe)=>((0,Ye.$MF)(Te,"tunnels"),be.onDidChangeTunnels(ee,ge,Fe)),registerPortAttributesProvider:(ee,ge)=>((0,Ye.$MF)(Te,"portsAttributes"),be.registerPortsAttributesProvider(ee,ge)),registerTunnelProvider:(ee,ge)=>((0,Ye.$MF)(Te,"tunnelFactory"),be.registerTunnelProvider(ee,ge)),registerTimelineProvider:(ee,ge)=>((0,Ye.$MF)(Te,"timeline"),_i.registerTimelineProvider(ee,ge,Te.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:ee=>((0,Ye.$MF)(Te,"workspaceTrust"),ft.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ge,Fe)=>ft.onDidGrantWorkspaceTrust(ee,ge,Fe),registerEditSessionIdentityProvider:(ee,ge)=>((0,Ye.$MF)(Te,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(ee,ge)),onWillCreateEditSessionIdentity:(ee,ge,Fe)=>((0,Ye.$MF)(Te,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Te)(ee,ge,Fe)),registerCanonicalUriProvider:(ee,ge)=>((0,Ye.$MF)(Te,"canonicalUriProvider"),ft.registerCanonicalUriProvider(ee,ge)),getCanonicalUri:(ee,ge,Fe)=>((0,Ye.$MF)(Te,"canonicalUriProvider"),ft.provideCanonicalUri(ee,ge,Fe))},cn={get inputBox(){return K.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),hi.getLastInputBox(Te)},createSourceControl(ee,ge,Fe){return hi.createSourceControl(Te,ee,ge,Fe)},registerSourceControlInputBoxValueProvider(ee){return(0,Ye.$MF)(Te,"scmInputBoxValueProvider"),hi.registerSourceControlInputBoxValueProvider(Te,ee)}},Vi={createCommentController(ee,ge){return Ri.createCommentController(Te,ee,ge)}},Wi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},get stackFrameFocus(){return ut.stackFrameFocus},onDidStartDebugSession(ee,ge,Fe){return ut.onDidStartDebugSession(ee,ge,Fe)},onDidTerminateDebugSession(ee,ge,Fe){return ut.onDidTerminateDebugSession(ee,ge,Fe)},onDidChangeActiveDebugSession(ee,ge,Fe){return ut.onDidChangeActiveDebugSession(ee,ge,Fe)},onDidReceiveDebugSessionCustomEvent(ee,ge,Fe){return ut.onDidReceiveDebugSessionCustomEvent(ee,ge,Fe)},onDidChangeBreakpoints(ee,ge,Fe){return ut.onDidChangeBreakpoints(ee,ge,Fe)},onDidChangeStackFrameFocus(ee,ge,Fe){return(0,Ye.$MF)(Te,"debugFocus"),ut.onDidChangeStackFrameFocus(ee,ge,Fe)},registerDebugConfigurationProvider(ee,ge,Fe){return ut.registerDebugConfigurationProvider(ee,ge,Fe||Lt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ge){return ut.registerDebugAdapterDescriptorFactory(Te,ee,ge)},registerDebugAdapterTrackerFactory(ee,ge){return ut.registerDebugAdapterTrackerFactory(ee,ge)},startDebugging(ee,ge,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?ut.startDebugging(ee,ge,{parentSession:Fe}):ut.startDebugging(ee,ge,Fe||{})},stopDebugging(ee){return ut.stopDebugging(ee)},addBreakpoints(ee){return ut.addBreakpoints(ee)},removeBreakpoints(ee){return ut.removeBreakpoints(ee)},asDebugSourceUri(ee,ge){return ut.asDebugSourceUri(ee,ge)}},qi={registerTaskProvider:(ee,ge)=>Qt.registerTaskProvider(Te,ee,ge),fetchTasks:ee=>Qt.fetchTasks(ee),executeTask:ee=>Qt.executeTask(Te,ee),get taskExecutions(){return Qt.taskExecutions},onDidStartTask:(ee,ge,Fe)=>Qt.onDidStartTask(ee,ge,Fe),onDidEndTask:(ee,ge,Fe)=>Qt.onDidEndTask(ee,ge,Fe),onDidStartTaskProcess:(ee,ge,Fe)=>Qt.onDidStartTaskProcess(ee,ge,Fe),onDidEndTaskProcess:(ee,ge,Fe)=>Qt.onDidEndTaskProcess(ee,ge,Fe)},li={createNotebookController(ee,ge,Fe,ot,wt){return oi.createNotebookController(Te,ee,ge,Fe,ot,(0,Ye.$LF)(Te,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ge)=>Et.registerNotebookCellStatusBarItemProvider(Te,ee,ge),createRendererMessaging(ee){return Si.createRendererMessaging(Te,ee)},createNotebookControllerDetectionTask(ee){return(0,Ye.$MF)(Te,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Te,ee)},registerKernelSourceActionProvider(ee,ge){return(0,Ye.$MF)(Te,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Te,ee,ge)},onDidChangeNotebookCellExecutionState(ee,ge,Fe){return(0,Ye.$MF)(Te,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ee,ge,Fe)}},Ki={t(...ee){if(typeof ee[0]=="string"){const ge=ee.shift(),Fe=!ee||typeof ee[0]!="object"?ee:ee[0];return si.getMessage(Te.identifier.value,{message:ge,args:Fe})}return si.getMessage(Te.identifier.value,ee[0])},get bundle(){return si.getBundle(Te.identifier.value)},get uri(){return si.getBundleUri(Te.identifier.value)}},Hi={_version:1,registerInteractiveEditorSessionProvider(ee,ge){return(0,Ye.$MF)(Te,"interactive"),zi.registerProvider(Te,ee,ge)},registerInteractiveSessionProvider(ee,ge){return(0,Ye.$MF)(Te,"interactive"),bi.registerChatProvider(Te,ee,ge)},sendInteractiveRequestToProvider(ee,ge){return(0,Ye.$MF)(Te,"interactive"),bi.sendInteractiveRequestToProvider(ee,ge)},get onDidPerformUserAction(){return(0,Ye.$MF)(Te,"interactiveUserActions"),bi.onDidPerformUserAction},transferChatSession(ee,ge){return(0,Ye.$MF)(Te,"interactive"),bi.transferChatSession(ee,ge)}},Gi={getRelatedInformation(ee,ge){return(0,Ye.$MF)(Te,"aiRelatedInformation"),wi.getRelatedInformation(Te,ee,ge)},registerRelatedInformationProvider(ee,ge){return(0,Ye.$MF)(Te,"aiRelatedInformation"),wi.registerRelatedInformationProvider(Te,ee,ge)},registerEmbeddingVectorProvider(ee,ge){return(0,Ye.$MF)(Te,"aiRelatedInformation"),rn.registerEmbeddingVectorProvider(Te,ee,ge)}},Ji={registerChatResponseProvider(ee,ge,Fe){return(0,Ye.$MF)(Te,"chatProvider"),vi.registerProvider(Te.identifier,ee,ge,Fe)},requestChatAccess(ee){return(0,Ye.$MF)(Te,"chatRequestAccess"),vi.requestChatResponseProvider(Te.identifier,ee)},registerVariable(ee,ge,Fe){return(0,Ye.$MF)(Te,"chatVariables"),nn.registerVariableResolver(Te,ee,ge,Fe)},registerMappedEditsProvider(ee,ge){return(0,Ye.$MF)(Te,"mappedEditsProvider"),lt.registerMappedEditsProvider(Te,ee,ge)},createChatAgent(ee,ge){return(0,Ye.$MF)(Te,"chatAgents2"),tn.createChatAgent(Te,ee,ge)}},un={registerSpeechProvider(ee,ge){return(0,Ye.$MF)(Te,"speech"),dn.registerProvider(Te.identifier,ee,ge)}};return{version:gt.version,ai:Gi,authentication:fn,commands:gn,comments:Vi,chat:Ji,debug:Wi,env:Di,extensions:an,interactive:Hi,l10n:Ki,languages:mn,notebooks:li,scm:cn,speech:un,tasks:qi,tests:on,window:$n,workspace:Bi,Breakpoint:Ne.$yL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$pM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,CallHierarchyIncomingCall:Ne.$XK,CallHierarchyItem:Ne.$WK,CallHierarchyOutgoingCall:Ne.$YK,CancellationError:T.$4,CancellationTokenSource:y.$2d,CandidatePortSource:o.CandidatePortSource,CodeAction:Ne.$TK,CodeActionKind:Ne.$UK,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$ZK,Color:Ne.$aL,ColorInformation:Ne.$bL,ColorPresentation:Ne.$cL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$7K,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$8K,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$kL,DebugAdapterExecutable:Ne.$CL,DebugAdapterInlineImplementation:Ne.$FL,DebugAdapterNamedPipeServer:Ne.$EL,DebugAdapterServer:Ne.$DL,DebugConfigurationProviderTriggerKind:Lt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$OK,DiagnosticRelatedInformation:Ne.$NK,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$AK,DocumentHighlight:Ne.$QK,DocumentHighlightKind:Ne.DocumentHighlightKind,DocumentLink:Ne.$_K,DocumentSymbol:Ne.$SK,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$IL,InlineValueText:Ne.$JL,InlineValueVariableLookup:Ne.$KL,InlineValueEvaluatableExpression:Ne.$LL,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:P.$Rd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$VL,FileDecoration2:Ne.$VL,FileSystemError:Ne.$NL,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Ne.$OL,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$AL,InlineCompletionItem:Ne.$9K,InlineCompletionList:Ne.$0K,Hover:Ne.$PK,IndentAction:D.IndentAction,Location:Ne.$MK,MarkdownString:Ne.$1K,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$2K,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$BK,ProcessExecution:Ne.$iL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$UL,Range:Ne.$CK,RelativePattern:Ne.$wL,Selection:Ne.$DK,SelectionRange:Ne.$VK,SemanticTokens:Ne.$RL,SemanticTokensBuilder:Ne.$QL,SemanticTokensEdit:Ne.$SL,SemanticTokensEdits:Ne.$TL,SemanticTokensLegend:Ne.$PL,ShellExecution:Ne.$jL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$4K,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$3K,SnippetString:Ne.$LK,SourceBreakpoint:Ne.$zL,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$RK,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$lL,TaskGroup:Ne.$hL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$dL,TerminalQuickFixExecuteTerminalCommand:Ne.$fL,TerminalQuickFixOpener:Ne.$eL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$gL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$HK,SnippetTextEdit:Ne.$JK,TextEditorCursorStyle:d.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$vL,ThemeIcon:Ne.$uL,TreeItem:Ne.$mL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$eM,UIKind:Vt.UIKind,Uri:E.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$KK,DocumentDropEdit:Ne.$sL,DocumentPasteEdit:Ne.$tL,InlayHint:Ne.$6K,InlayHintLabelPart:Ne.$5K,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$GK,ResolvedAuthority:Ne.$EK,ManagedResolvedAuthority:Ne.$FK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$6L,NotebookRange:Ne.$XL,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$YL,NotebookData:Ne.$ZL,NotebookRendererScript:Ne.$4L,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$2L,NotebookCellOutputItem:Ne.$1L,NotebookCellStatusBarItem:Ne.$3L,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$IK,NotebookKernelSourceAction:Ne.$5L,PortAttributes:Ne.$8L,LinkedEditingRanges:Ne.$7L,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$9L,TestMessage:Ne.$0L,TestMessage2:Ne.$0L,TestTag:Ne.$$L,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Wt.TextSearchCompleteMessageType,DataTransfer:Ne.$rL,DataTransferItem:Ne.$nL,CoveredCount:Ne.$_L,FileCoverage:Ne.$aM,StatementCoverage:Ne.$bM,BranchCoverage:Ne.$cM,FunctionCoverage:Ne.$dM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$fM,TabInputTextDiff:Ne.$gM,TabInputTextMerge:Ne.$hM,TabInputCustom:Ne.$iM,TabInputNotebook:Ne.$kM,TabInputNotebookDiff:Ne.$lM,TabInputWebview:Ne.$jM,TabInputTerminal:Ne.$mM,TabInputInteractiveWindow:Ne.$nM,TabInputChat:Ne.$oM,TelemetryTrustedValue:r.$po,LogLevel:f.LogLevel,EditSessionIdentityMatch:c.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ne.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$GL,ThreadFocus:Ne.$HL,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$5fc=qt}),define(Pe[291],Ae([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,42,84,59,62,256,15,116,82,83]),function(we,e,y,T,P,M,A,$,E,d,I,D,l,b,v,f,t,i,r,c,o,h,n,s,a,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Cr)(g.$Tec,g.$Sec,1),(0,y.$Cr)(s.$ej,n.$6fc,1),(0,y.$Cr)(f.$5dc,f.$6dc,1),(0,y.$Cr)($.$WM,$.$VM,0),(0,y.$Cr)(A.$nec,A.$lec,0),(0,y.$Cr)(i.$pec,i.$oec,0),(0,y.$Cr)(D.$4ec,D.$8ec,0),(0,y.$Cr)(M.$0ec,M.$9ec,0),(0,y.$Cr)(E.$LM,E.$KM,0),(0,y.$Cr)(p.$Uec,p.$Vec,0),(0,y.$Cr)(r.$2dc,r.$1dc,0),(0,y.$Cr)(T.$Dfc,T.$Cfc,1),(0,y.$Cr)(l.$nfc,l.$ofc,0),(0,y.$Cr)(b.$Iec,b.$Hec,0),(0,y.$Cr)(I.$Qfc,I.$Pfc,0),(0,y.$Cr)(d.$Lec,d.$Oec,0),(0,y.$Cr)(v.$axb,v.$bxb,0),(0,y.$Cr)(t.$4fc,t.$3fc,0),(0,y.$Cr)(P.$kec,P.$jec,0),(0,y.$Cr)(c.$Qec,c.$Pec,0),(0,y.$Cr)(o.$UM,o.$RM,0),(0,y.$Cr)(h.$zec,h.$Aec,0),(0,y.$Cr)(a.$2ec,a.$3ec,0)}),define(Pe[292],Ae([1,0,290,38,2,287,7,14,275]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;class d extends M.$9fc{j(){}getModule(b,v){for(const f of this.b){const t=f(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends T.$Xec{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(E.$cic);const b=this.h.invokeFunction(y.$5fc);this.r=this.h.createInstance(d,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,v,f){v=v.with({path:D(v.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=P.URI.revive(await this.C.$asBrowserUri(v)),r=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),r.status!==200)throw new Error(r.statusText);const c=await r.text(),o=`${v.toString(!0)}#vscode-extension`,h=`${c}
//# sourceURL=${o}`;let n;try{n=new Function("module","exports","require",h)}catch(p){throw console.error(t?`Loading code for extension ${t} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${v.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}b&&await this.w.initializeLocalizedMessages(b);const s={},a={exports:s},g=p=>{const m=this.r.getModule(p,v);if(m===void 0)throw new Error(`Cannot load module '${p}'`);return m};try{return f.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(a,s,g),a.exports!==s?a.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),f.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+b;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,$.$Yg)(10)}}e.$dic=I;function D(l,b){return l.endsWith(b)?l:l+b}}),define(Pe[293],Ae([1,0,69,70,15,38,200,86,292]),function(we,e,y,T,P,M,A,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Cr)(P.$dj,new y.$Sh(A.$8fc,[!0],!0)),(0,T.$Cr)(M.$Yec,E.$dic,0),(0,T.$Cr)($.$qec,$.$rec,0)}),define(Pe[299],Ae([1,0,24,5,79,288,277,20,88,13,2,291,293]),function(we,e,y,T,P,M,A,$,E,d,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const v=fetch.bind(self);function f(n){self.fetch=async function(s,a){return s instanceof Request||b(String(s))&&(s=(await n(I.URI.parse(String(s)))).toString(!0)),v(s,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,a,g,p,m){(async()=>(b(a.toString())&&(a=(await n(I.URI.parse(a.toString()))).toString(!0)),super.open(s,a,g??!0,p,m)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(s,a){if(/^file:/i.test(s.toString()))s=d.$gg.uriToBrowserUri(I.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const p=`(${function(u){function w(V){return typeof V=="string"||V instanceof URL?String(V).replace(/^file:\/\//i,"vscode-file://vscode-app"):V}const S=fetch.bind(self);self.fetch=function(V,J){return V instanceof Request?S(V,J):S(w(V),J)},self.XMLHttpRequest=class extends XMLHttpRequest{open(V,J,N,R,L){return super.open(V,w(J),N??!0,R,L)}};const F=importScripts.bind(self);self.importScripts=(...V)=>{F(...V.map(w))},F(u)}.toString()}('${s}'))`;a=a||{},a.name=a.name||$.$mc(s.toString());const m=new Blob([p],{type:"application/javascript"}),k=URL.createObjectURL(m);return new n(k,a)}}else self.Worker=class extends A.$eic{constructor(n,s){super(l,n,{name:$.$mc(n.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(n){D()}};class i{constructor(){const s=new MessageChannel,a=new T.$Rd;let g=!1;l(s.port2,[s.port2]),s.port1.onmessage=p=>{const{data:m}=p;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const k=y.$fe.wrap(new Uint8Array(m,0,m.byteLength));if((0,P.$im)(k,2)){g=!0,c("received terminate message from renderer");return}a.fire(k)},this.protocol={onMessage:a.event,send:p=>{if(!g){const m=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);s.port1.postMessage(m,[m])}}}}}function r(n){return new Promise(s=>{const a=n.onMessage(g=>{a.dispose();const p=JSON.parse(g.toString());n.send((0,P.$hm)(0)),s({protocol:n,initData:p})});n.send((0,P.$hm)(1))})}let c=n=>D();function o(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function h(){E.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(s){o(s)&&r(n.protocol).then(a=>{E.mark("code/extHost/didWaitForInitData");const g=new M.$$fc(a.protocol,a.initData,t,null,s.data);f(p=>g.asBrowserUri(p)),c=p=>g.terminate(p)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/54b8f6a80aaad7489b75e9293b8d7a1700bed815/core/vs/workbench/api/worker/extensionHostWorker.js.map
